/*  Module Name: @(#)abort.c	7.2
    Version: 12/2/96
    Author: 
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        
 
 
*/

#include "abort.h"

/* This is shared by origin and target */

int DbvAbortRequest(       DbvAssocId lAssocId, DbvError **ppsError )
{
        DBVAssociateDetails *psAssociateDetails;
	DbvProtocolStack eProtocolStack;
        int return_value = SI_OK;

#ifndef NO_OSI
	/* Structure for ISODE */
	struct AcSAPindication *psAssocControlIndication = NULL;
	struct AcSAPabort *psAssocControlAbort = NULL;
#endif /* NO_OSI */

	DBVEnterFuncTrace("DbvAbortRequest",lAssocId);

        DBVTrace(lAssocId, Trace_High, "\nInput Function Arguments\n");
        Trace_writeDbvAssocId(lAssocId);

        DBVCheckError(ppsError);

#ifndef NO_OSI
	/* Malloc the isode structure */
	if(DBVAllocCheck((psAssocControlIndication = (struct AcSAPindication *)
		DBVAlloc(sizeof(struct AcSAPindication),ppsError)))==SI_NOTOK)
		{ return SI_NOTOK; }

	psAssocControlAbort = &psAssocControlIndication->aci_abort;
#endif /* NO_OSI */

        if((SIWhichStack(lAssocId, &eProtocolStack, ppsError) == SI_OK) &&
          (return_value = DBVChangeState(lAssocId, DBV_TE_IABORTREQ, ppsError))==SI_OK)
	{
		psAssociateDetails = SL_Current(DBVAssociateList);
		if(eProtocolStack == TCP_Stack)
		{
        		if((close(psAssociateDetails->ulTcpSocket)) != 0)
        		{
                		/* Complete error structure */
                		/* AbortRequest: close failed */
				if (errno > 0 && errno < sys_nerr)
                                	sprintf(DBVErrorBuffer, DBV_TCP_CLOSEFAILED_S, lAssocId, sys_errlist[errno]);
				else
                                	sprintf(DBVErrorBuffer, DBV_TCP_CLOSEFAILED_S, lAssocId, "");

                                DBVfill_error_structure(lAssocId, SI_Communication_Error, 0, DBV_TCP_CLOSEFAILED, DBVErrorBuffer, 0, Association_Unknown_State, ppsError);

                		return_value = SI_NOTOK;
        		}
		}
		if(eProtocolStack == OSI_Stack)
		{	
#ifndef NO_OSI
			if(AcUAbortRequest(psAssociateDetails->lOSIAssocId,
				NULLPEP, 0, psAssocControlIndication)== NOTOK)
			{
				/* Abort Failed ! */
				DBVTrace(lAssocId, Trace_Low,
					"A-ABORT.REQUEST error");
				DBVACSEOSICheckISODEError(lAssocId,
					psAssociateDetails->lOSIAssocId,
					psAssocControlIndication, 
					ppsError);
				return_value = SI_NOTOK;
			}
#else
			printf("OSI not supported\n");
#endif /* NO_OSI */
                }
        }
        else
                return_value = SI_NOTOK;

        if((return_value == SI_OK) || (return_value == SI_NOTOK &&
		(*ppsError)->eErrorClass == SI_Abort))
        {
                /* Free up space */
                psAssociateDetails = SL_RemoveCurrent(DBVAssociateList);
                free(psAssociateDetails);
        }

#ifndef NO_OSI
        /* Free the ISODE functions */
        ACAFREE(psAssocControlAbort);
        free(psAssocControlIndication);
#endif

        DBVLeaveFuncTrace("DbvAbortRequest",lAssocId, return_value);
        return return_value;
}

