#include "api_ill.h"




/****************************************************************/
/* Item Order external */

int fill_DbvItemOrderExtendedService(DbvASN1External *external, DbvItemOrderReqOrRsp eItemOrderReqRsp)
{

	char *oid = ANSI_ITEMORDER_EXTENDED_SERVICE;

	external->pcObjectIdentifier = (char *) DbvAlloc (strlen(oid) + 1);
        memcpy(external->pcObjectIdentifier, oid, strlen(oid));
 
        external->eValueType = EVT_SingleASN1Type;
        external->uExternalValue.psSingleASN1Type = (DbvSingleASN1Type * ) DbvAlloc (sizeof (DbvSingleASN1Type));
        external->uExternalValue.psSingleASN1Type->eASN1Type = AT_ItemOrderExtendedService;
        external->uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService = (struct DbvItemOrderExtendedService *) DbvAlloc (sizeof (struct DbvItemOrderExtendedService));

	fill_dbv_itemorder_main(external->uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService, eItemOrderReqRsp);

}



int fill_dbv_itemorder_main(DbvItemOrderExtendedService *psItemOrderExtendedService, DbvItemOrderReqOrRsp eItemOrderReqRsp)
{
	switch (eItemOrderReqRsp) {
	case IOROR_Request:
		psItemOrderExtendedService->eItemOrderReqRsp = IOROR_Request;
		psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderRequest = (DbvEsIoRequest *) DbvAlloc (sizeof (DbvEsIoRequest));
		fill_dbv_itemorderrequest(psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderRequest);
		break;
	case IOROR_Response:
		psItemOrderExtendedService->eItemOrderReqRsp = IOROR_Response;
		psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderResponse = (DbvEsIoTaskPackage *) DbvAlloc (sizeof (DbvEsIoTaskPackage));
		fill_dbv_itemorderresponse(psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderResponse);
		break;
	}
}



int fill_dbv_itemorderrequest(DbvEsIoRequest *psItemOrderRequest)
{
	/* optional */
	psItemOrderRequest->psToKeep = (DbvEsIoOriginPartToKeep *) DbvAlloc (sizeof(DbvEsIoOriginPartToKeep));
	fill_dbv_io_originparttokeep(psItemOrderRequest->psToKeep);

	/* compulsory */
	fill_dbv_io_originpartnottokeep(&psItemOrderRequest->sNotToKeep);
}



int fill_dbv_io_originparttokeep(DbvEsIoOriginPartToKeep *psToKeep)
{

	char *sutrs_string = "an item order sutrs string";


	/* All fields optional */
	
	/* Set up a sutrs */
	psToKeep->psSupplementalDescription = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_dbv_isosutrs_external(psToKeep->psSupplementalDescription, sutrs_string);

	psToKeep->psContact = (DbvEsIoContact *) DbvAlloc (sizeof(DbvEsIoContact));
	fill_dbv_io_contact(psToKeep->psContact);


	psToKeep->psAdditionalBilling = (DbvEsIoAdditionalBilling *) DbvAlloc (sizeof(DbvEsIoAdditionalBilling));
	fill_dbv_io_addbilling(psToKeep->psAdditionalBilling);

}


	
int fill_dbv_io_contact(DbvEsIoContact *psContact)
{
	char *name_str = "J. Major";
	char *phone_str = "(+44) 01810 34687";
	char *email_str = "pm@parl.gov.org";


	/* All optional */
	
	psContact->psName = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
	fill_dbv_inter_string(psContact->psName, name_str);
	
	psContact->psPhone = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
	fill_dbv_inter_string(psContact->psPhone, phone_str);
	
	psContact->psEmail = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
	fill_dbv_inter_string(psContact->psEmail, email_str);
	
}



int fill_dbv_io_addbilling(DbvEsIoAdditionalBilling *psAdditionalBilling)
{
	char reference[100];
	char ponum[100];

	/* Use arrays and strcpy for a change (same effect as using char*) */
	strcpy(reference, "ref 01765");
	strcpy(ponum, "ponum 12876");

	/* First compulsory */
	fill_dbv_io_paymethod(&psAdditionalBilling->sPaymentMethod);

	/* Remaining optional */

	psAdditionalBilling->psCustomerReference = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
	fill_dbv_inter_string(psAdditionalBilling->psCustomerReference, reference);
	
	psAdditionalBilling->psCustomerPONumber = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
	fill_dbv_inter_string(psAdditionalBilling->psCustomerPONumber, ponum);

}



int fill_dbv_io_paymethod(DbvEsIoPaymentMethod *psPaymentMethod)
{
	
	char *sutrs_string = "test payment method sutrs string";

	int choice = 0;
	char choice_string[100];


	choice = 0;
	while (choice < 1 || choice > 7) {
		printf("Enter ePaymentMethodType type: IOPM_BillInvoice (1), IOPM_Prepay (2), IOPM_DepositAccount (3), IOPM_CreditCard (4), IOPM_CardInfoPrevSupplied (5), IOPM_PrivateKnown (6), IOPM_PrivateNotKnown (7): ");
		choice = (atol(gets(choice_string)));
	}

	switch (choice) {
	case 1:
		psPaymentMethod->ePaymentMethodType = IOPM_BillInvoice;
		break;
	case 2:
		psPaymentMethod->ePaymentMethodType = IOPM_Prepay;
		break;
	case 3:
		psPaymentMethod->ePaymentMethodType = IOPM_DepositAccount;
		break;
	case 4:
		psPaymentMethod->ePaymentMethodType = IOPM_CreditCard;
		psPaymentMethod->puPaymentMethod = (union uPaymentMethod *) DbvAlloc (sizeof (union uPaymentMethod));
		psPaymentMethod->puPaymentMethod->psCreditCardInfo = (DbvEsIoCreditCardInfo *) DbvAlloc (sizeof(DbvEsIoCreditCardInfo));
		fill_dbv_io_ccinfo(psPaymentMethod->puPaymentMethod->psCreditCardInfo);
		break;
	case 5:
		psPaymentMethod->ePaymentMethodType = IOPM_CardInfoPrevSupplied;
		break;
	case 6:
		psPaymentMethod->ePaymentMethodType = IOPM_PrivateKnown;
		break;
	case 7:
		psPaymentMethod->ePaymentMethodType = IOPM_PrivateNotKnown;
		psPaymentMethod->puPaymentMethod = (union uPaymentMethod *) DbvAlloc (sizeof (union uPaymentMethod));
		psPaymentMethod->puPaymentMethod->psPrivateNotKnown = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
		fill_dbv_sutrs_external(psPaymentMethod->puPaymentMethod->psPrivateNotKnown, sutrs_string);
		break;
	}

}

	

int fill_dbv_io_ccinfo(DbvEsIoCreditCardInfo *psCreditCardInfo)
{
	char *name = "John Major";
	char *expir_date="10 Jan 1999";
	char *cardnumber="0984587265";

	/* All compulsory */
        fill_dbv_inter_string(&psCreditCardInfo->sNameOnCard, name);
        fill_dbv_inter_string(&psCreditCardInfo->sExpirationDate, expir_date);
        fill_dbv_inter_string(&psCreditCardInfo->sCardNumber, cardnumber);
}



int fill_dbv_io_originpartnottokeep(DbvEsIoOriginPartNotToKeep *psNotToKeep)
{
	char *sutrs_record = "result set item";

	/* o */
	psNotToKeep->psResultSetItem = (DbvEsIoResultSetItem *) DbvAlloc (sizeof (DbvEsIoResultSetItem));
	fill_dbv_ressetitem(psNotToKeep->psResultSetItem);

	/* o */
	/* the ILL here forming the request */
/*
	psNotToKeep->psItemRequest = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
	fill_DbvIllPdu(psNotToKeep->psItemRequest);
*/
	
}



int fill_dbv_ressetitem(DbvEsIoResultSetItem *psResultSetItem)
{
	char *ressetid = "item order result set id";


	/* c */
        fill_dbv_inter_string(&psResultSetItem->sResultSetId, ressetid);
	
	/* c */
	/* now ulItem */
        psResultSetItem->ulItem = 678;

}



int fill_dbv_itemorderresponse(DbvEsIoTaskPackage *psItemOrderResponse)
{
	/* o */
	psItemOrderResponse->psOriginPart = (DbvEsIoOriginPartToKeep *) DbvAlloc (sizeof (DbvEsIoOriginPartToKeep));
	fill_dbv_io_originparttokeep(psItemOrderResponse->psOriginPart);

	/* c */
	fill_dbv_io_originpartnotkeep(&psItemOrderResponse->sTargetPart);
}



int fill_dbv_io_originpartnotkeep(DbvEsIoTargetPart *psTargetPart)
{
	char *sutrs = "status or error report sutrs test";

	/* o */

	/* And now for the ILL external..... (it could however also be anything
	   else !!) - both the ILL_IllRequest and ILL_StatusOrErrorReport 
	   structures are filled by the following function (as 
	   appropriate, depending upon menu options selected) */
/*
	psTargetPart->psItemRequest = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
	fill_DbvIllPdu(psTargetPart->psItemRequest);
*/


	/* c */
	psTargetPart->psStatusOrErrorReport = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
	fill_dbv_sutrs_external(psTargetPart->psStatusOrErrorReport, sutrs);
	

	/* o */
	psTargetPart->peAuxiliaryStatus = (DbvEsIoAuxiliaryStatus *) DbvAlloc (sizeof(DbvEsIoAuxiliaryStatus));
	fill_dbv_io_auxstat(psTargetPart->peAuxiliaryStatus);
}



int fill_dbv_io_auxstat(DbvEsIoAuxiliaryStatus *peAuxiliaryStatus)
{
	*peAuxiliaryStatus = IOAS_UnfilledCopyright;
}




/****************************************************************/
/* ILL external */


int fill_DbvIllPdu(DbvASN1External *external)
{

        char    *oid = ISO_ILL_PDU;

        /* ALWAYS SUPPLY AN OID WITH SINGLE ASN1 TYPE */

        /* +1 to copy the \0 */
        external->pcObjectIdentifier = (char *) DbvAlloc (strlen(oid) + 1);
        memcpy(external->pcObjectIdentifier, oid, strlen(oid));

        external->eValueType = EVT_SingleASN1Type;
        external->uExternalValue.psSingleASN1Type = (DbvSingleASN1Type * ) DbvAlloc (sizeof (DbvSingleASN1Type));
        external->uExternalValue.psSingleASN1Type->eASN1Type = AT_IllPdu;

        external->uExternalValue.psSingleASN1Type->uASN1.psIllPdu = (struct DbvIllPdu *) DbvAlloc (sizeof (struct DbvIllPdu));

        fill_dbv_ill_main(external->uExternalValue.psSingleASN1Type->uASN1.psIllPdu);

}



int fill_dbv_ill_main(struct DbvIllPdu *psIllPdu)
{
	int choice = 0;
	char choice_string[100];


	choice = 0;
	while (choice < 1 || choice > 2) {
		printf("Enter eIllPduType type: ILL_IllRequest (1), ILL_StatusOrErrorReport (2): ");
		choice = (atol(gets(choice_string)));
	}

	switch (choice) {
	case 1:
		psIllPdu->eIllPduType = ILL_IllRequest;
		psIllPdu->uIllPdu.psIllRequest = (struct DbvIllRequest *) DbvAlloc (sizeof (struct DbvIllRequest));
		fill_dbv_ill_illrequest(psIllPdu->uIllPdu.psIllRequest);
		break;
	case 2:
		psIllPdu->eIllPduType = ILL_StatusOrErrorReport;
		psIllPdu->uIllPdu.psStatusOrErrorReport = (struct DbvStatusOrErrorReport *) DbvAlloc (sizeof (struct DbvStatusOrErrorReport));
		fill_dbv_ill_statorerr(psIllPdu->uIllPdu.psStatusOrErrorReport);
		break;
	}
}



int fill_dbv_ill_illrequest(struct DbvIllRequest *psIllRequest)
{
	char *sutrs_str="test sutrs string";

	/* c */
	fill_dbv_ill_protocolver(&psIllRequest->eProtocolVersion);

	/* c */
	fill_dbv_ill_transid(&psIllRequest->sTransactionId);

	/* c */
	fill_dbv_ill_servdatetime(&psIllRequest->sServiceDateTime);

	/* o */
	psIllRequest->psRequesterId = (DbvSystemId *) DbvAlloc (sizeof (DbvSystemId));
	fill_dbv_ill_systemid(psIllRequest->psRequesterId);


	/* o */
	psIllRequest->psResponderId = (DbvSystemId *) DbvAlloc (sizeof (DbvSystemId));
	fill_dbv_ill_systemid(psIllRequest->psResponderId);


	/* default */
	psIllRequest->peTransactionType = (DbvTransactionType *) DbvAlloc (sizeof (DbvTransactionType));
	fill_dbv_ill_transtype(psIllRequest->peTransactionType);

	/* o */
	psIllRequest->psDeliveryAddress = (DbvDeliveryAddress *) DbvAlloc (sizeof (DbvDeliveryAddress));
	fill_dbv_ill_delivaddr(psIllRequest->psDeliveryAddress);

	
	/* o */
	psIllRequest->psDeliveryService = (DbvDeliveryService *) DbvAlloc (sizeof (DbvDeliveryService));
	fill_dbv_ill_delivserv(psIllRequest->psDeliveryService);

	/* o */
	psIllRequest->psBillingAddress = (DbvDeliveryAddress *) DbvAlloc (sizeof (DbvDeliveryAddress));
	fill_dbv_ill_delivaddr(psIllRequest->psBillingAddress);
	

	/* c */

	/* ok. lets have a 2 element list (3 nodes: 0, 1, /0 ) */

	/* malloc space for the list */
	psIllRequest->ppeServiceType = (DbvServiceType **) DbvAlloc (sizeof(DbvServiceType *) * 3);


	/* malloc the individual list elements */
        psIllRequest->ppeServiceType[0] = (DbvServiceType *) DbvAlloc(sizeof(DbvServiceType));
        psIllRequest->ppeServiceType[1] = (DbvServiceType *) DbvAlloc(sizeof(DbvServiceType));


	/* and fill em in .. */

	/* fog */
	fill_dbv_ill_servtype(psIllRequest->ppeServiceType[0]);

	/* sog */
	fill_dbv_ill_servtype(psIllRequest->ppeServiceType[1]);


	/* o */
	psIllRequest->psResponderSpecificService = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
	fill_dbv_sutrs_external(psIllRequest->psResponderSpecificService, sutrs_str);

	/* c */
	fill_dbv_ill_reqoptmsg(&psIllRequest->sRequesterOptionalMessages);

	/* o */
	psIllRequest->psSearchType = (DbvSearchType *) DbvAlloc(sizeof (DbvSearchType));
	fill_dbv_ill_srchtype(psIllRequest->psSearchType);

	
	/* o */

	/* 3 elements (4 nodes) */
	psIllRequest->ppsSupplyMediumInfo = (DbvSupplyMediumInfo **) DbvAlloc (sizeof(DbvSupplyMediumInfo *) * 4);
        psIllRequest->ppsSupplyMediumInfo[0] = (DbvSupplyMediumInfo *) DbvAlloc(sizeof(DbvSupplyMediumInfo));
        psIllRequest->ppsSupplyMediumInfo[1] = (DbvSupplyMediumInfo *) DbvAlloc(sizeof(DbvSupplyMediumInfo));
        psIllRequest->ppsSupplyMediumInfo[2] = (DbvSupplyMediumInfo *) DbvAlloc(sizeof(DbvSupplyMediumInfo));

	/* fill, fill, fill */
	fill_dbv_ill_suppmedinfo(psIllRequest->ppsSupplyMediumInfo[0]);
	fill_dbv_ill_suppmedinfo(psIllRequest->ppsSupplyMediumInfo[1]);
	fill_dbv_ill_suppmedinfo(psIllRequest->ppsSupplyMediumInfo[2]);
	
	/* default */
	psIllRequest->pePlaceOnHold = (DbvPlaceOnHold *) DbvAlloc (sizeof (DbvPlaceOnHold));
	fill_dbv_ill_placehold(psIllRequest->pePlaceOnHold);


	/* o */
	psIllRequest->psClientId = (DbvClientId *) DbvAlloc (sizeof (DbvClientId));
	fill_dbv_ill_clientid(psIllRequest->psClientId);


	/* c */
	fill_dbv_itemid(&psIllRequest->sItemId);
	
	
	/* o */
	/* or err, a list of externals - lets have 2 sutrs */
	psIllRequest->ppsSupplementalItemDescription = (DbvASN1External **) DbvAlloc (sizeof(DbvASN1External *) * 3);
        psIllRequest->ppsSupplementalItemDescription[0] = (DbvASN1External *) DbvAlloc(sizeof(DbvASN1External));
        psIllRequest->ppsSupplementalItemDescription[1] = (DbvASN1External *) DbvAlloc(sizeof(DbvASN1External));
	fill_dbv_sutrs_external(psIllRequest->ppsSupplementalItemDescription[0], sutrs_str);
	fill_dbv_sutrs_external(psIllRequest->ppsSupplementalItemDescription[1], sutrs_str);


	/* o */
	psIllRequest->psCostInfo = (DbvCostInfo *) DbvAlloc (sizeof (DbvCostInfo ));
	fill_dbv_ill_costinfo(psIllRequest->psCostInfo);
	
	/* o */
	psIllRequest->psCopyrightCompliance = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psIllRequest->psCopyrightCompliance, ST_GeneralString, "copyright compliance");


	/* o */
	psIllRequest->psThirdPartyInfo = (DbvThirdPartyInfo *) DbvAlloc (sizeof (DbvThirdPartyInfo));
	fill_dbv_ill_thirdparty(psIllRequest->psThirdPartyInfo);

	
	/* default */
	psIllRequest->pfRetry = (DbvBool *) DbvAlloc (sizeof (DbvBool));
	*psIllRequest->pfRetry = DBV_TRUE;

	/* default */
	psIllRequest->pfForward = (DbvBool *) DbvAlloc (sizeof (DbvBool));
	*psIllRequest->pfForward = DBV_FALSE;

	/* o */
	psIllRequest->psRequesterNote = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psIllRequest->psRequesterNote, ST_GeneralString, "requester note");

	
	/* o */
	psIllRequest->psForwardNote = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psIllRequest->psForwardNote, ST_GeneralString, "forward note");

	
	/* o */
	/* A list of extensions - wow */

	
	/* Extension uses its ulIdentifier field as an external specifier 
	   (as opposed to an oid). 

	   Only one type of identifier referenced (as opposed to
	   oid referenced) type
	   can be used at the moment - SUBITO_ADDITIONAL_INFO, 
	   a special type defined by DBV 
 	   (see sitypes.h, itemordr.h, iord_ext.h) */

	psIllRequest->ppsRequestExtension = (DbvExtension **) DbvAlloc (sizeof(DbvExtension *) * 3);
        psIllRequest->ppsRequestExtension[0] = (DbvExtension *) DbvAlloc(sizeof(DbvExtension));
        psIllRequest->ppsRequestExtension[1] = (DbvExtension *) DbvAlloc(sizeof(DbvExtension));
	fill_dbv_ill_extension(psIllRequest->ppsRequestExtension[0]);
	fill_dbv_ill_extension(psIllRequest->ppsRequestExtension[1]);


}


int fill_dbv_ill_protocolver(DbvIllProtocolVersion *peProtocolVersion)
{
	*peProtocolVersion = PV_Version2;
}



int fill_dbv_ill_transid(DbvTransactionId *psTransactionId)
{
	/* o */
	psTransactionId->psInitialRequesterId = (DbvSystemId *) DbvAlloc (sizeof (DbvSystemId));
	fill_dbv_ill_systemid(psTransactionId->psInitialRequesterId);

	/* c */ 
        fill_dbv_ill_illstring(&psTransactionId->sTransactionGroupQualifier, ST_GeneralString, "transaction group qualifier");

	/* c */
        fill_dbv_ill_illstring(&psTransactionId->sTransactionQualifier, ST_GeneralString, "transaction qualifier");


	/* o */
	psTransactionId->psSubTransactionQualifier = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
        fill_dbv_ill_illstring(psTransactionId->psSubTransactionQualifier, ST_EdifactString, "sub transaction qualifier");

}



int fill_dbv_ill_systemid(DbvSystemId *psRequesterId)
{
	/* o */
	psRequesterId->psSymbol = (DbvPersonOrInstitutionSymbol *) DbvAlloc (sizeof (DbvPersonOrInstitutionSymbol));
	fill_dbv_ill_perorinsym(psRequesterId->psSymbol);

	 /* o */
	psRequesterId->psName = (DbvNameOfPersonOrInstitution *) DbvAlloc (sizeof (DbvNameOfPersonOrInstitution));
	fill_dbv_ill_nameofperorin(psRequesterId->psName);
}


int fill_dbv_ill_perorinsym(DbvPersonOrInstitutionSymbol *psSymbol)
{
	/* c */
	fill_dbv_ill_perorsymtype(&psSymbol->eSymbolType);

	/* c */
	fill_dbv_ill_illstring(&psSymbol->sSymbol, ST_EdifactString, "this is a symbol");
}



int fill_dbv_ill_perorsymtype(DbvPersOrInstSymbolType *peSymbolType)
{
	*peSymbolType = SPI_PersonSymbol;
}



int fill_dbv_ill_illstring(DbvIllString *psCopyrightCompliance, DbvIllStringType str_type, char *fill_str)
{

	switch (str_type) {
	case ST_GeneralString:
		psCopyrightCompliance->eStringType = ST_GeneralString;
		psCopyrightCompliance->uString.psGeneralString = (DbvGeneralString *) DbvAlloc (sizeof (DbvGeneralString));
		fill_DbvGeneralString(psCopyrightCompliance->uString.psGeneralString, fill_str);
		break;
	case ST_EdifactString:
		psCopyrightCompliance->eStringType = ST_EdifactString;
		psCopyrightCompliance->uString.pcVisibleString = (DbvVisibleString) DbvAlloc (strlen(fill_str) + 1);
		memcpy(psCopyrightCompliance->uString.pcVisibleString, fill_str, strlen(fill_str));
		break;
	}
}




int fill_dbv_ill_nameofperorin(DbvNameOfPersonOrInstitution *psName)
{
	/* c */
	fill_dbv_ill_namofperint(&psName->eNameType);

	/* c */
	fill_dbv_ill_illstring(&psName->sName, ST_EdifactString, "this is a name");
}


int fill_dbv_ill_namofperint(DbvNameOfPersOrInstType *peNameType)
{
	*peNameType = NPI_NameOfPerson;
}



int fill_dbv_ill_servdatetime(DbvServiceDateTime *psServiceDateTime)
{
	/* c */
	fill_dbv_ill_datetime(&psServiceDateTime->sThisService);

	/* o */
	psServiceDateTime->psOriginalService = (DbvDateTime *) DbvAlloc (sizeof (DbvDateTime));
	fill_dbv_ill_datetime(psServiceDateTime->psOriginalService);
}



int fill_dbv_ill_datetime(DbvDateTime *psThisService)
{
	char *date = "19820124";
	char *time = "063321";

	

	/* NOTE: DbvVisibleString is a typedefed char * */

	/* c */
	psThisService->pcDate = (DbvVisibleString) DbvAlloc (strlen(date) + 1);
	memcpy(psThisService->pcDate, date, strlen(date));


	/* o */
	psThisService->pcTime = (DbvVisibleString) DbvAlloc (strlen(time) + 1);
	memcpy(psThisService->pcTime, time, strlen(time));
}



int fill_dbv_ill_transtype(DbvTransactionType *peTransactionType)
{
	*peTransactionType = TT_Partitioned;
}


int fill_dbv_ill_delivaddr(DbvDeliveryAddress *psDeliveryAddress)
{
	/* o */
	psDeliveryAddress->psPostalAddress = (DbvPostalAddress *) DbvAlloc (sizeof (DbvPostalAddress));
	fill_dbv_ill_postaddr(psDeliveryAddress->psPostalAddress);
	

	/* o */
	psDeliveryAddress->psElectronicAddress = (DbvSystemAddress *) DbvAlloc (sizeof (DbvSystemAddress));
	fill_dbv_ill_sysaddr(psDeliveryAddress->psElectronicAddress);
}



int fill_dbv_ill_postaddr(DbvPostalAddress *psPostalAddress)
{
	/* o */
	psPostalAddress->psNameOfPersonOrInstitution = (DbvNameOfPersonOrInstitution *) DbvAlloc (sizeof (DbvNameOfPersonOrInstitution));
	fill_dbv_ill_nameofperorin(psPostalAddress->psNameOfPersonOrInstitution);
	
	/* o */
	psPostalAddress->psExtendedPostalDeliveryAddress = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psPostalAddress->psExtendedPostalDeliveryAddress, ST_EdifactString, "extended postal delivery address");

	/* o */
	psPostalAddress->psStreetAndNumber = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psPostalAddress->psStreetAndNumber, ST_EdifactString, "1 The Mall");

	/* o */
	psPostalAddress->psPostOfficeBox = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psPostalAddress->psPostOfficeBox, ST_EdifactString, "PO Box 999");


	/* o */
	psPostalAddress->psCity = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psPostalAddress->psCity, ST_EdifactString, "London");


	/* o */
	psPostalAddress->psRegion = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psPostalAddress->psRegion, ST_GeneralString, "Greater London");


	/* o */
	psPostalAddress->psCountry = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psPostalAddress->psCountry, ST_GeneralString, "Jamaica");


	/* o */
	psPostalAddress->psPostalCode = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psPostalAddress->psPostalCode, ST_EdifactString, "GF45 5TY");
}



int fill_dbv_ill_sysaddr(DbvSystemAddress *psElectronicAddress)
{
	/* o */
	psElectronicAddress->psTelecomServiceIdentifier = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psElectronicAddress->psTelecomServiceIdentifier, ST_GeneralString, "British Talacom");

	/* o */
	psElectronicAddress->psTelecomServiceAddress = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psElectronicAddress->psTelecomServiceAddress, ST_EdifactString, "12 Saville Row");
}



int fill_dbv_ill_delivserv(DbvDeliveryService *psDeliveryService)
{
	int choice = 0;
	char choice_string[100];

	choice = 0;
	while (choice < 1 || choice > 2) {
		printf("Enter eDeliveryServiceType type: DST_PhysicalDelivery (1), DST_ElectronicDelivery (2): ");
		choice = (atol(gets(choice_string)));
	}


	/* c */
	switch (choice) {
	case 1:
		psDeliveryService->eDeliveryServiceType = DST_PhysicalDelivery;
		psDeliveryService->uDeliveryService.psPhysicalDelivery = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		fill_dbv_ill_illstring(psDeliveryService->uDeliveryService.psPhysicalDelivery, ST_GeneralString, "physical delivery");
		break;
	case 2:

		psDeliveryService->eDeliveryServiceType = DST_ElectronicDelivery;


		/* 2 nodes - 0 1 /0 */
		psDeliveryService->uDeliveryService.ppsElectronicDelivery = (DbvElectronicDeliveryService **) DbvAlloc (sizeof (DbvElectronicDeliveryService *) * 3);

		psDeliveryService->uDeliveryService.ppsElectronicDelivery[0] = (DbvElectronicDeliveryService *) DbvAlloc (sizeof (DbvElectronicDeliveryService));
		psDeliveryService->uDeliveryService.ppsElectronicDelivery[1] = (DbvElectronicDeliveryService *) DbvAlloc (sizeof (DbvElectronicDeliveryService));

		/* fill em */
		fill_dbv_ill_elecdelivser(psDeliveryService->uDeliveryService.ppsElectronicDelivery[0]);
		fill_dbv_ill_elecdelivser(psDeliveryService->uDeliveryService.ppsElectronicDelivery[1]);

		break;
	}

}



int fill_dbv_ill_elecdelivser(DbvElectronicDeliveryService *psElectronicDelivery)
{
	char *delivtime = "electronic delivery time";

	/* o */

	psElectronicDelivery->psDeliveryParameter = (DbvElDeliveryParameter *) DbvAlloc (sizeof (DbvElDeliveryParameter));
	fill_dbv_ill_eldeliv(psElectronicDelivery->psDeliveryParameter);

	
	/* o */
	psElectronicDelivery->psDocumentTypeParameter = (DbvDocumentTypeParameter *) DbvAlloc (sizeof (DbvDocumentTypeParameter));
	fill_dbv_ill_doctypeparam(psElectronicDelivery->psDocumentTypeParameter);


	/* o */
	psElectronicDelivery->psDeliveryDescription = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psElectronicDelivery->psDeliveryDescription, ST_EdifactString, "delivery description");

	/* c */
	fill_dbv_ill_delivdetails(&psElectronicDelivery->sDeliveryDetails);


	/* o */
	psElectronicDelivery->psNameOrCode = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psElectronicDelivery->psNameOrCode, ST_EdifactString, "electronic delivery name or code");

	/* o */
	psElectronicDelivery->pcDeliveryTime = (DbvVisibleString) DbvAlloc (strlen(delivtime) + 1);
	memcpy(psElectronicDelivery->pcDeliveryTime, delivtime, strlen(delivtime));

}



int fill_dbv_ill_eldeliv(DbvElDeliveryParameter *psDeliveryParameter)
{
	char *oid = ANSI_UNSTRUCTURED_TEXT_RECORD;
	char *sutrs_str = "sutrs eldelivery test";
	
	/* As psDeliveryParameter->pcDeliveryMode specifies 
	   the external being encoded (see the ILL ASN.1) it will 
	   appear as both 
	   psDeliveryParameter->pcDeliveryMode 
	   and
	   DbvASN1External->pcObjectIdentifier 
	   after decoding.
	   Any oid specified in DbvASN1External->pcObjectIdentifier
	   before enconding is ignored. 

	   Recommended: set psDeliveryParameter->pcDeliveryMode and
	   DbvASN1External->pcObjectIdentifier to the same oid. 
	*/


	/* o */
	psDeliveryParameter->pcDeliveryMode = (DbvObjectIdentifier) DbvAlloc (strlen(oid) + 1);
	memcpy(psDeliveryParameter->pcDeliveryMode, oid, strlen(oid));


	/* o */
	psDeliveryParameter->puDeliveryParameter = (union uDeliveryParameter *) DbvAlloc (sizeof(union uDeliveryParameter));
	psDeliveryParameter->puDeliveryParameter->psDummy = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));

	fill_dbv_sutrs_external(psDeliveryParameter->puDeliveryParameter->psDummy, sutrs_str);



}



int fill_dbv_ill_doctypeparam(DbvDocumentTypeParameter *psDocumentTypeParameter)
{
	char *oid = ANSI_UNSTRUCTURED_TEXT_RECORD;
	char *sutrs_str = "sutrs doctype test";
	
	/* As psDocumentTypeParameter->pcDocumentTypeId specifies 
	   the external being encoded (see the ILL ASN.1) it will 
	   appear as both 
	   psDocumentTypeParameter->pcDocumentTypeId 
	   and
	   DbvASN1External->pcObjectIdentifier 
	   after decoding.
	   Any oid specified in DbvASN1External->pcObjectIdentifier
	   before enconding is ignored. 

	   Recommended: set psDocumentTypeParameter->pcDocumentTypeId and
	   DbvASN1External->pcObjectIdentifier to the same oid. 
	*/

	/* o */
	psDocumentTypeParameter->pcDocumentTypeId = (DbvObjectIdentifier) DbvAlloc (strlen(oid) + 1);
	memcpy(psDocumentTypeParameter->pcDocumentTypeId, oid, strlen(oid));

	/* o */
	psDocumentTypeParameter->puDocumentTypeParameter = (union uDocumentTypeParameter *) DbvAlloc (sizeof(union uDocumentTypeParameter));
	psDocumentTypeParameter->puDocumentTypeParameter->psDummy = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));

	fill_dbv_sutrs_external(psDocumentTypeParameter->puDocumentTypeParameter->psDummy, sutrs_str);

}



int fill_dbv_ill_delivdetails(DbvElDeliveryDetails *psDeliveryDetails)
{
	int choice = 0;
	char choice_string[100];

	choice = 0;
	while (choice < 1 || choice > 2) {
		printf("Enter eDeliveryDetailsType type: DDT_SystemAddress (1), DDT_SystemId (2): ");
		choice = (atol(gets(choice_string)));
	}


	switch (choice) {
	case 1:
		psDeliveryDetails->eDeliveryDetailsType = DDT_SystemAddress;
		psDeliveryDetails->uDeliveryDetails.psSystemAddress = (DbvSystemAddress *) DbvAlloc (sizeof (DbvSystemAddress));
		fill_dbv_ill_sysaddr(psDeliveryDetails->uDeliveryDetails.psSystemAddress);
		break;
	case 2:
		psDeliveryDetails->eDeliveryDetailsType = DDT_SystemId;
		psDeliveryDetails->uDeliveryDetails.psSystemId = (DbvSystemId *) DbvAlloc (sizeof (DbvSystemId));
		fill_dbv_ill_systemid(psDeliveryDetails->uDeliveryDetails.psSystemId);
		break;
	}

	
}



int fill_dbv_ill_servtype(DbvServiceType *peServiceType)
{
	*peServiceType = ST_Locations;
}



int fill_dbv_ill_reqoptmsg(DbvRequesterOptionalMessages *psRequesterOptionalMessages)
{
	/* c */
	psRequesterOptionalMessages->fCanSendReceived = DBV_TRUE;

	/* c */
	psRequesterOptionalMessages->fCanSendReturned = DBV_FALSE;
	
	/* c */
	psRequesterOptionalMessages->eRequesterShipped = OMR_Neither;


	/* c */
	psRequesterOptionalMessages->eRequesterCheckedIn = OMR_Requires;
}



int fill_dbv_ill_srchtype(DbvSearchType *psSearchType)
{
	char *need_before = "need before date";
	char *exp_date = "expire date";

	/* o */
	psSearchType->psLevelOfService = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psSearchType->psLevelOfService, ST_GeneralString, "Full service");

	/* o */
	psSearchType->pcNeedBeforeDate = (DbvVisibleString) DbvAlloc (strlen(need_before) + 1);
	memcpy(psSearchType->pcNeedBeforeDate, need_before, strlen(need_before));


	/* default (optional) */
	psSearchType->peExpiryFlag = (DbvExpiry *) DbvAlloc (sizeof (DbvExpiry));
	*psSearchType->peExpiryFlag = EXP_OtherDate;
	
	
	/* o */
	psSearchType->pcExpiryDate = (DbvVisibleString) DbvAlloc (strlen(exp_date) + 1);
	memcpy(psSearchType->pcExpiryDate, exp_date, strlen(exp_date));
}



int fill_dbv_ill_suppmedinfo(DbvSupplyMediumInfo *psSupplyMediumInfo)
{

	/* c */
	psSupplyMediumInfo->eSupplyMediumType = SMT_FilmOrVideoRecording;

	/* o */
	psSupplyMediumInfo->psMediumCharacteristics = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psSupplyMediumInfo->psMediumCharacteristics, ST_EdifactString, "medium characteristics");
}



int fill_dbv_ill_placehold(DbvPlaceOnHold *pePlaceOnHold)
{
	*pePlaceOnHold = POH_ResponderPolicy;

}


int fill_dbv_ill_clientid(DbvClientId *psClientId)
{
	/* o */
	psClientId->psClientName = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psClientId->psClientName, ST_GeneralString, "Ladi Dye Spancer");


	/* o */
	psClientId->psClientStatus = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psClientId->psClientStatus, ST_EdifactString, "Full");


	/* o */
	psClientId->psClientIdentifier = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psClientId->psClientIdentifier, ST_EdifactString, "client identifier");

}


int fill_dbv_itemid(DbvItemId *psItemId)
{

	char *bib_no = "bibliographic number";
	char *system_no = "system number";

	/* o */
	psItemId->peItemType = (DbvItemType *) DbvAlloc (sizeof (DbvItemType));
	*psItemId->peItemType = IT_Serial;

	
	/* o */
	psItemId->peMediumType = (DbvMediumType *) DbvAlloc (sizeof (DbvMediumType));
	*psItemId->peMediumType = MT_FilmOrVideoRecording;


	/* o */
	psItemId->psCallNumber = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psCallNumber, ST_EdifactString, "call number");

	/* o */
	psItemId->psAuthor = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psAuthor, ST_GeneralString, "Dave Lookum");

	/* o */
	psItemId->psTitle = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psTitle, ST_EdifactString, "Mastering The Abyss");

	/* o */
	psItemId->psSubTitle = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psSubTitle, ST_GeneralString, "Caving For Beginners");

	/* o */
	psItemId->psSponsoringBody = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psSponsoringBody, ST_GeneralString, "sponsers");

	/* o */
	psItemId->psPlaceOfPublication = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psPlaceOfPublication, ST_EdifactString, "Dallas, Texas");

	/* o */
	psItemId->psPublisher = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psPublisher, ST_GeneralString, "Rundum House");

	/* o */
	psItemId->psSeriesTitleNumber = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psSeriesTitleNumber, ST_GeneralString, "First title");

	/* o */
	psItemId->psVolumeIssue = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psVolumeIssue, ST_GeneralString, "first volume");

	/* o */
	psItemId->psEdition = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psEdition, ST_EdifactString, "first edition");

	/* o */
	psItemId->psPublicationDate = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psPublicationDate, ST_GeneralString, "sometime");

	
	/* o */
	psItemId->psPublicationDateOfComponent = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psPublicationDateOfComponent, ST_GeneralString, "publication date of component");

	
	/* o */
	psItemId->psAuthorOfArticle = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psAuthorOfArticle, ST_EdifactString, "Mike Smith");

	/* o */
	psItemId->psTitleOfArticle = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psTitleOfArticle, ST_GeneralString, "Touring Car Driving Skills" );

	/* o */
	psItemId->psPagination = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psPagination, ST_EdifactString, "pagination");


	/* o */
	/* sutrs please */
	psItemId->psNationalBibliographyNo = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
	fill_dbv_sutrs_external(psItemId->psNationalBibliographyNo, bib_no);

	/* o */
	psItemId->psIsbn = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psIsbn, ST_EdifactString, "This is my Isbn number");


	/* o */
	psItemId->psIssn = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psIssn, ST_EdifactString, "This is my Issn number");

	
	/* o */
	/* another sutrs please */
	psItemId->psSystemNo = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
	fill_dbv_sutrs_external(psItemId->psSystemNo, system_no);

	/* o */
	psItemId->psAdditionalNoLetters = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psAdditionalNoLetters, ST_GeneralString, "additional no letters");

	/* o */
	psItemId->psVerificationReferenceSource = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psItemId->psVerificationReferenceSource, ST_GeneralString, "reference source");

}



int fill_dbv_ill_costinfo(DbvCostInfo *psCostInfo)
{

	/* o */
	psCostInfo->psAccountNumber = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psCostInfo->psAccountNumber, ST_GeneralString, "Account number");

	/* o */
	psCostInfo->psMaximumCost = (DbvAmount *) DbvAlloc (sizeof (DbvAmount));
	fill_dbv_amount(psCostInfo->psMaximumCost);
	

	/* default */
	psCostInfo->pfReciprocalAgreement = (DbvBool *) DbvAlloc (sizeof (DbvBool));
	*psCostInfo->pfReciprocalAgreement = DBV_TRUE;	


	
	/* default */
	psCostInfo->pfWillPayFee = (DbvBool *) DbvAlloc (sizeof(DbvBool));
	*psCostInfo->pfWillPayFee = DBV_FALSE;	


	/* default */
	psCostInfo->pfPaymentProvided = (DbvBool *) DbvAlloc (sizeof(DbvBool));
	*psCostInfo->pfPaymentProvided = DBV_TRUE;	

}



int fill_dbv_amount(DbvAmount *psMaximumCost)
{
	char *curr_code = "currency code";
	char *monetary_value = "monetary value";
	
	/* o */
	/* DbvPrintableString is a typedefed char* */
	psMaximumCost->pcCurrencyCode = (DbvPrintableString) DbvAlloc (strlen(curr_code) + 1);
	memcpy(psMaximumCost->pcCurrencyCode, curr_code, strlen(curr_code));


	/* c */
	psMaximumCost->pcMonetaryValue = (DbvPrintableString) DbvAlloc (strlen(monetary_value) + 1);
	memcpy(psMaximumCost->pcMonetaryValue, monetary_value, strlen(monetary_value));

}



int fill_dbv_ill_thirdparty(DbvThirdPartyInfo *psThirdPartyInfo)
{

	/* default so optional */
	psThirdPartyInfo->pfPermissionToForward = (DbvBool *) DbvAlloc (sizeof (DbvBool));
	*psThirdPartyInfo->pfPermissionToForward = DBV_TRUE;


	/* default so optional */
	psThirdPartyInfo->pfPermissionToChain = (DbvBool *) DbvAlloc (sizeof (DbvBool));
	*psThirdPartyInfo->pfPermissionToChain = DBV_FALSE;


	/* default so optional */
	psThirdPartyInfo->pfPermissionToPartition = (DbvBool *) DbvAlloc (sizeof (DbvBool));
	*psThirdPartyInfo->pfPermissionToPartition = DBV_TRUE;


	/* default so optional */
	psThirdPartyInfo->pfPermissionToChangeSendToList = (DbvBool *) DbvAlloc (sizeof (DbvBool));
	*psThirdPartyInfo->pfPermissionToChangeSendToList = DBV_FALSE;


	/* o */
	psThirdPartyInfo->psInitialRequesterAddress = (DbvSystemAddress *) DbvAlloc (sizeof(DbvSystemAddress));
	fill_dbv_ill_sysaddr(psThirdPartyInfo->psInitialRequesterAddress);


	/* default so optional */
	psThirdPartyInfo->pePreference = (DbvPreference *) DbvAlloc (sizeof (DbvPreference));
	fill_dbv_ill_preference(psThirdPartyInfo->pePreference);
	

	/* opt */

	/* 3 nodes, 2 items - 0, 1, \0 */
	psThirdPartyInfo->ppsSendToList = (DbvSendToList **) DbvAlloc (sizeof (DbvSendToList *) * 3);
        psThirdPartyInfo->ppsSendToList[0] = (DbvSendToList *) DbvAlloc(sizeof(DbvSendToList));
        psThirdPartyInfo->ppsSendToList[1] = (DbvSendToList *) DbvAlloc(sizeof(DbvSendToList));
	fill_dbv_ill_sendtolist(psThirdPartyInfo->ppsSendToList[0]);
	fill_dbv_ill_sendtolist(psThirdPartyInfo->ppsSendToList[1]);

	/* opt */
	/* 3 nodes, 2 items - 0, 1, \0 */
	psThirdPartyInfo->ppsAlreadyTriedList = (DbvSystemId **) DbvAlloc (sizeof (DbvSystemId *) * 3);
        psThirdPartyInfo->ppsAlreadyTriedList[0] = (DbvSystemId *) DbvAlloc(sizeof(DbvSystemId));
        psThirdPartyInfo->ppsAlreadyTriedList[1] = (DbvSystemId *) DbvAlloc(sizeof(DbvSystemId));
	fill_dbv_ill_systemid(psThirdPartyInfo->ppsAlreadyTriedList[0]);
	fill_dbv_ill_systemid(psThirdPartyInfo->ppsAlreadyTriedList[1]);

}


int fill_dbv_ill_preference(DbvPreference *pePreference)
{
	*pePreference = PRE_Unordered;

}



int fill_dbv_ill_sendtolist(DbvSendToList *psSendToList)
{

	/* c */
	fill_dbv_ill_systemid(&psSendToList->sSystemId);
	

	/* o */
	psSendToList->psAccountNumber = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psSendToList->psAccountNumber, ST_GeneralString, "a send to list account string");

	/* o */
	psSendToList->psSystemAddress = (DbvSystemAddress *) DbvAlloc (sizeof (DbvSystemAddress));
	fill_dbv_ill_sysaddr(psSendToList->psSystemAddress);
}



int fill_dbv_ill_extension(DbvExtension *psRequestExtension)
{
	/* c */

	/* SUBITO_ADDITIONAL_INFO is defined in sitypes.h */
	psRequestExtension->ulIdentifier = SUBITO_ADDITIONAL_INFO;
	

	/* default */
	psRequestExtension->pfCritical = (DbvBool *) DbvAlloc (sizeof (DbvBool));
	*psRequestExtension->pfCritical = DBV_TRUE;

	
	/* c */

	psRequestExtension->uItem.psAddIllReqInfo = (DbvSubitoAdditionalInfo *) DbvAlloc (sizeof (DbvSubitoAdditionalInfo));
	fill_dbv_illext_subito(psRequestExtension->uItem.psAddIllReqInfo);

}



int fill_dbv_illext_subito(DbvSubitoAdditionalInfo *psAddIllReqInfo)
{
	/* default */
	psAddIllReqInfo->pfCustomerInfoToKeep = (DbvBool *) DbvAlloc (sizeof (DbvBool));
	*psAddIllReqInfo->pfCustomerInfoToKeep = DBV_TRUE;


	/* o */
	psAddIllReqInfo->psAddRequesterInfo = (DbvAddRequesterInfo *) DbvAlloc (sizeof (DbvAddRequesterInfo));
	fill_dbv_requesterinfo(psAddIllReqInfo->psAddRequesterInfo);
	

	/* o */
	psAddIllReqInfo->psAddDeliveryInfo = (DbvAddDeliveryInfo *) DbvAlloc (sizeof (DbvAddDeliveryInfo));
	fill_dbv_deliveryinfo(psAddIllReqInfo->psAddDeliveryInfo);

	/* o */
	psAddIllReqInfo->psAddBillingInfo = (DbvAddBillingInfo *) DbvAlloc (sizeof (DbvAddBillingInfo));
	fill_dbv_billinginfo(psAddIllReqInfo->psAddBillingInfo);
}



int fill_dbv_requesterinfo(DbvAddRequesterInfo *psAddRequesterInfo)
{
	char *email_addr = "president@whitehouse.gov";

	/* default */
	psAddRequesterInfo->peRequesterGroup = (DbvRequesterGroup *) DbvAlloc (sizeof (DbvRequesterGroup));
	*psAddRequesterInfo->peRequesterGroup = RG_UserGroup1;


	/* o */
	psAddRequesterInfo->pcRequesterEmailAddress = (DbvVisibleString) DbvAlloc (strlen(email_addr) + 1);
	memcpy(psAddRequesterInfo->pcRequesterEmailAddress, email_addr, strlen(email_addr));
	
}


int fill_dbv_deliveryinfo(DbvAddDeliveryInfo *psAddDeliveryInfo)
{
	char *deliv_notes = "delivery notes";
	char *country_deliv_notes = "country delivery notes";

	/* default */
	psAddDeliveryInfo->peStatusLevelUser = (DbvStatusLevelUser *) DbvAlloc (sizeof (DbvStatusLevelUser));
	*psAddDeliveryInfo->peStatusLevelUser = SLU_Negative;

	/* default */
	psAddDeliveryInfo->peStatusLevelOrigin = (DbvStatusLevelRequester *) DbvAlloc (sizeof (DbvStatusLevelRequester));
	*psAddDeliveryInfo->peStatusLevelOrigin = SLO_Negative;


	/* o */
	psAddDeliveryInfo->pcDeliveryNotes = (DbvVisibleString) DbvAlloc (strlen(deliv_notes) + 1);
	memcpy(psAddDeliveryInfo->pcDeliveryNotes, deliv_notes, strlen(deliv_notes));

	/* o */
	psAddDeliveryInfo->pcCountryDeliveryTarget = (DbvVisibleString) DbvAlloc (strlen(country_deliv_notes) + 1);
	memcpy(psAddDeliveryInfo->pcCountryDeliveryTarget, country_deliv_notes, strlen(country_deliv_notes));


	/* default */
	psAddDeliveryInfo->pfAlternativePostalDelivery = (DbvBool *) DbvAlloc (sizeof (DbvBool));
	*psAddDeliveryInfo->pfAlternativePostalDelivery = DBV_TRUE;


}



int fill_dbv_billinginfo(DbvAddBillingInfo *psAddBillingInfo)
{
	char *prepaidid = "prepaid identification";
	char *depositid = "deposit identification";

	int choice = 0;
	char choice_string[100];

	choice = 0;
	while (choice < 1 || choice > 5) {
		printf("Enter eAddBillingType type: ABT_BankInfo (1), ABT_CreditCardInfo (2), ABT_InvoiceType (3), ABT_PrepaidType (4), ABT_DepositType (5): ");
		choice = (atol(gets(choice_string)));
	}


	switch (choice) {
	case 1:
		psAddBillingInfo->eAddBillingType = ABT_BankInfo;
		psAddBillingInfo->uAddBillingInfo.psBillingBankInfo = (DbvBillingBankInfo *) DbvAlloc (sizeof (DbvBillingBankInfo));
		fill_dbv_billingbankinfo(psAddBillingInfo->uAddBillingInfo.psBillingBankInfo);
		break;

	case 2:
		psAddBillingInfo->eAddBillingType = ABT_CreditCardInfo;
		psAddBillingInfo->uAddBillingInfo.psBillingCreditCardInfo = (DbvBillingCreditCardInfo *) DbvAlloc (sizeof (DbvBillingCreditCardInfo));
		fill_dbv_billingcreditcardinfo(psAddBillingInfo->uAddBillingInfo.psBillingCreditCardInfo);
		break;

	case 3:
		psAddBillingInfo->eAddBillingType = ABT_InvoiceType;
		psAddBillingInfo->uAddBillingInfo.eBillingInvoiceType = BIT_Collective;
		break;

	case 4:
		psAddBillingInfo->eAddBillingType = ABT_PrepaidType;
		psAddBillingInfo->uAddBillingInfo.pcPrepaidId = (DbvVisibleString) DbvAlloc (strlen(prepaidid) + 1);
		memcpy(psAddBillingInfo->uAddBillingInfo.pcPrepaidId, prepaidid, strlen(prepaidid));
		break;

	case 5:
		psAddBillingInfo->eAddBillingType = ABT_DepositType;
		psAddBillingInfo->uAddBillingInfo.pcDepositId = (DbvVisibleString) DbvAlloc (strlen(depositid) + 1);
		memcpy(psAddBillingInfo->uAddBillingInfo.pcDepositId, depositid, strlen(depositid));
		break;

	}
}



int fill_dbv_billingbankinfo(DbvBillingBankInfo *psBillingBankInfo)
{
	char *bank_account_house = "bank account house";
	char *bank_account_routing_symbol = "bank account routing symbol";
	char *bank_account_number = "bank account number ccfcfcf";

	/* c */
	psBillingBankInfo->pcBankAccountHouse = (DbvVisibleString) DbvAlloc (strlen(bank_account_house) + 1);
	memcpy(psBillingBankInfo->pcBankAccountHouse, bank_account_house, strlen(bank_account_house));
	
	/* c */
	psBillingBankInfo->pcBankAccountRoutingSymbol = (DbvVisibleString) DbvAlloc (strlen(bank_account_routing_symbol) + 1);
	memcpy(psBillingBankInfo->pcBankAccountRoutingSymbol, bank_account_routing_symbol, strlen(bank_account_routing_symbol));
	
	/* c */
	psBillingBankInfo->pcBankAccountNo = (DbvVisibleString) DbvAlloc (strlen(bank_account_number) + 1);
	memcpy(psBillingBankInfo->pcBankAccountNo, bank_account_number, strlen(bank_account_number));
	
	/* c */
	psBillingBankInfo->fBankAuthority = DBV_TRUE;
}



int fill_dbv_billingcreditcardinfo(DbvBillingCreditCardInfo *psBillingCreditCardInfo)
{
	char *card_company = "visa";
	char *card_number = "4565656hdfgdft";
	char *card_valid_from = "42424233245";
	char *card_valid_thru = "56565656565";

	/* c */
	psBillingCreditCardInfo->pcCardCompany = (DbvVisibleString) DbvAlloc (strlen(card_company) + 1);
	memcpy(psBillingCreditCardInfo->pcCardCompany, card_company, strlen(card_company));

	/* c */
	psBillingCreditCardInfo->pcCardNo = (DbvVisibleString) DbvAlloc (strlen(card_number) + 1);
	memcpy(psBillingCreditCardInfo->pcCardNo, card_number, strlen(card_number));

	/* ISO_Date is VisibleString */

	/* o */
	psBillingCreditCardInfo->pcCardValidFrom = (DbvVisibleString) DbvAlloc (strlen(card_valid_from) + 1);
	memcpy(psBillingCreditCardInfo->pcCardValidFrom, card_valid_from, strlen(card_valid_from));

	/* c */
	psBillingCreditCardInfo->pcCardValidThru = (DbvVisibleString) DbvAlloc (strlen(card_valid_thru) + 1);
	memcpy(psBillingCreditCardInfo->pcCardValidThru, card_valid_thru, strlen(card_valid_thru));

}


/***********************************************************/



int fill_dbv_ill_statorerr(struct DbvStatusOrErrorReport *psStatusOrErrorReport)
{
	/* c */
	fill_dbv_ill_protocolver(&psStatusOrErrorReport->eProtocolVersion);


	/* c */
	fill_dbv_ill_transid(&psStatusOrErrorReport->sTransactionId);


	/* c */
	fill_dbv_ill_servdatetime(&psStatusOrErrorReport->sServiceDateTime);

	/* o */
	psStatusOrErrorReport->psRequesterId = (DbvSystemId *) DbvAlloc (sizeof (DbvSystemId));
	fill_dbv_ill_systemid(psStatusOrErrorReport->psRequesterId);
	
	/* o */
	psStatusOrErrorReport->psResponderId = (DbvSystemId *) DbvAlloc (sizeof (DbvSystemId));
	fill_dbv_ill_systemid(psStatusOrErrorReport->psResponderId);

	/* o */
	psStatusOrErrorReport->peReasonNoReport = (DbvReasonNoReport *) DbvAlloc (sizeof (DbvReasonNoReport));
	fill_dbv_ill_raesonno(psStatusOrErrorReport->peReasonNoReport);
	
	/* o */
	psStatusOrErrorReport->psStatusReport = (DbvStatusReport *) DbvAlloc (sizeof(DbvStatusReport));
	fill_dbv_ill_statusrep(psStatusOrErrorReport->psStatusReport);
	
	/* o */
	psStatusOrErrorReport->psErrorReport = (DbvErrorReport *) DbvAlloc (sizeof (DbvErrorReport));
	fill_dbv_ill_errrep(psStatusOrErrorReport->psErrorReport);
	

	/* o */
	psStatusOrErrorReport->psNote = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psStatusOrErrorReport->psNote, ST_GeneralString, "a status or error report note");
	

	/* o */


	/* Extension uses its ulIdentifier field as an external specifier 
	   (as opposed to an oid). 

	   Only one type of identifier referenced (as opposed to
	   oid referenced) type
	   can be used at the moment - SUBITO_ADDITIONAL_INFO, 
	   a special type defined 
	   by DBV (see sitypes.h, itemordr.h and iord_ext.h) */

	/* gimee 2 (3 nodes, last = \0) */
	psStatusOrErrorReport->ppsStOrErReportExtension = (DbvExtension **) DbvAlloc (sizeof (DbvIllString *) * 3);
	psStatusOrErrorReport->ppsStOrErReportExtension[0] = (DbvExtension *) DbvAlloc (sizeof (DbvExtension));
	psStatusOrErrorReport->ppsStOrErReportExtension[1] = (DbvExtension *) DbvAlloc (sizeof (DbvExtension));

	fill_dbv_ill_extension(psStatusOrErrorReport->ppsStOrErReportExtension[0]);
	fill_dbv_ill_extension(psStatusOrErrorReport->ppsStOrErReportExtension[1]);


}



int fill_dbv_ill_raesonno(DbvReasonNoReport *peReasonNoReport)
{
	*peReasonNoReport = RNR_Permanent;
}



int fill_dbv_ill_statusrep(DbvStatusReport *psStatusReport)
{

	/* c */
	fill_dbv_ill_histrep(&psStatusReport->sUserStatusReport);

	/* c */
	fill_dbv_ill_currstat(&psStatusReport->eProviderStatusReport);
}



int fill_dbv_ill_histrep(DbvHistoryReport *psUserStatusReport)
{
	char *date_req = "date requested";
	char *date_last = "date of last transition";
	char *date_most = "date of most recent service";

	/* o */

	psUserStatusReport->pcDateRequested = (DbvVisibleString) DbvAlloc (strlen(date_req) + 1);
	memcpy(psUserStatusReport->pcDateRequested, date_req, strlen(date_req));

	/* o */
	psUserStatusReport->psAuthor = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psUserStatusReport->psAuthor, ST_GeneralString, "Fred Bloggs-Smyth");


	/* o */
	psUserStatusReport->psTitle = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psUserStatusReport->psTitle, ST_GeneralString, "'Cor blimey gavna, that's ganna cost ya' - Recollections Of Famous East End Car Dealers");


	/* o */
	psUserStatusReport->psAuthorOfArticle = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psUserStatusReport->psAuthorOfArticle, ST_EdifactString, "some author");

	/* o */
	psUserStatusReport->psTitleOfArticle = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psUserStatusReport->psTitleOfArticle, ST_GeneralString, "some title");

	/* c */

	psUserStatusReport->pcDateOfLastTransition = (DbvVisibleString) DbvAlloc (strlen(date_last) + 1);
	memcpy(psUserStatusReport->pcDateOfLastTransition, date_last, strlen(date_last));


	/* c */
	fill_dbv_ill_mostrecserv(&psUserStatusReport->eMostRecentService);


	/* c */
	psUserStatusReport->pcDateOfMostRecentService = (DbvVisibleString) DbvAlloc (strlen(date_most) + 1);
	memcpy(psUserStatusReport->pcDateOfMostRecentService, date_most, strlen(date_most));

	/* c */
	fill_dbv_ill_systemid(&psUserStatusReport->sSystemId);

	/* o */
	psUserStatusReport->peShippedServiceType = (DbvShippedServiceType *) DbvAlloc (sizeof (DbvShippedServiceType));
	fill_dbv_shipped_serv(psUserStatusReport->peShippedServiceType);

	/* o */
	psUserStatusReport->peTransactionResults = (DbvTransactionResults *) DbvAlloc (sizeof(DbvTransactionResults));
	fill_dbv_ill_transres(psUserStatusReport->peTransactionResults);

	/* o */
	psUserStatusReport->psMostRecentServiceNote = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
	fill_dbv_ill_illstring(psUserStatusReport->psMostRecentServiceNote, ST_EdifactString, "most recent service note");

}



int fill_dbv_ill_mostrecserv(DbvMostRecentService *peMostRecentService)
{
	*peMostRecentService = MRS_CheckedIn;
}


int fill_dbv_shipped_serv(DbvShippedServiceType *peShippedServiceType)
{
	*peShippedServiceType = SST_CopyNonReturnable;
}



int fill_dbv_ill_transres(DbvTransactionResults *peTransactionResults)
{
	*peTransactionResults = TR_HoldPlaced;
}



int fill_dbv_ill_currstat(DbvCurrentState *peProviderStatusReport)
{
	*peProviderStatusReport = CS_Cancelled;
}




int fill_dbv_ill_errrep(DbvErrorReport *psErrorReport)
{
	/* c */
	fill_dbv_ill_illstring(&psErrorReport->sCorrelationInfo, ST_EdifactString, "correlation info");

	/* c */
	fill_dbv_ill_userorproverrrep(&psErrorReport->sReport);
}



int fill_dbv_ill_userorproverrrep(DbvUserOrProviderErrorReport *psReport)
{
	int choice = 0;
	char choice_string[100];

	choice = 0;
	while (choice < 1 || choice > 2) {
		printf("Enter eReportSource type: RS_User (1), RS_Provider (2): ");
		choice = (atol(gets(choice_string)));
	}


	switch (choice) {
	case 1:
		psReport->eReportSource = RS_User;
		psReport->uReport.psUserErrorReport = (DbvUserErrorReport *) DbvAlloc (sizeof (DbvUserErrorReport));
		fill_dbv_ill_usererrrep(psReport->uReport.psUserErrorReport);
		break;
	case 2:
		psReport->eReportSource = RS_Provider;
		psReport->uReport.psProviderErrorReport = (DbvProviderErrorReport *) DbvAlloc (sizeof (DbvProviderErrorReport));
		fill_dbv_ill_proverrrep(psReport->uReport.psProviderErrorReport);
		break;
	}
}






int fill_dbv_ill_usererrrep(DbvUserErrorReport *psUserErrorReport)
{
	int choice = 0;
	char choice_string[100];

	choice = 0;
	while (choice < 1 || choice > 4) {
		printf("Enter eReportType type: UER_AlreadyForwarded (1), UER_IntermediaryProblem (2), UER_SecurityProblem (3), UER_UnableToPerform (4): ");
		choice = (atol(gets(choice_string)));
	}


	switch (choice) {
	case 1:
		psUserErrorReport->eReportType = UER_AlreadyForwarded;
		psUserErrorReport->uUserErrorReport.psAlreadyForwarded = (DbvAlreadyForwarded *) DbvAlloc (sizeof (DbvAlreadyForwarded));
		fill_dbv_ill_alreadyforw(psUserErrorReport->uUserErrorReport.psAlreadyForwarded);
		break;
	case 2:
		psUserErrorReport->eReportType = UER_IntermediaryProblem;
		fill_dbv_ill_interprob(&psUserErrorReport->uUserErrorReport.eIntermediaryProblem);
		break;
	case 3:
		psUserErrorReport->eReportType = UER_SecurityProblem;
		psUserErrorReport->uUserErrorReport.psSecurityProblem = (DbvIllString *) DbvAlloc (sizeof (DbvIllString));
		fill_dbv_ill_illstring(psUserErrorReport->uUserErrorReport.psSecurityProblem, ST_EdifactString, "security problem");
		break;
	case 4:
		psUserErrorReport->eReportType = UER_UnableToPerform;
		fill_dbv_ill_unabletoperf(&psUserErrorReport->uUserErrorReport.eUnableToPerform);
		break;
	}
}



int fill_dbv_ill_alreadyforw(DbvAlreadyForwarded *psAlreadyForwarded)
{
	/* c */
	fill_dbv_ill_systemid(&psAlreadyForwarded->sResponderId);

	/* o */
	psAlreadyForwarded->psResponderAddress = (DbvSystemAddress *) DbvAlloc (sizeof (DbvSystemAddress));
	fill_dbv_ill_sysaddr(psAlreadyForwarded->psResponderAddress);
}



int fill_dbv_ill_interprob(DbvIntermediaryProblem *peIntermediaryProblem)
{
	*peIntermediaryProblem = IP_CannotSendOnward;
}



int fill_dbv_ill_unabletoperf(DbvUnableToPerform *peUnableToPerform)
{
	*peUnableToPerform = UTP_ResourceLimitation;
	
}



int fill_dbv_ill_proverrrep(DbvProviderErrorReport *psProviderErrorReport)
{
	int choice = 0;
	char choice_string[100];

	/* c */
	choice = 0;
	while (choice < 1 || choice > 3) {
		printf("Enter eReportType type: PER_GeneralProblem (1), PER_TransactionIdProblem (2), PER_StateTransitionProhibited (3): ");
		choice = (atol(gets(choice_string)));
	}


	switch (choice) {
	case 1:
		psProviderErrorReport->eReportType = PER_GeneralProblem;
		fill_dbv_ill_generalprob(&psProviderErrorReport->uProviderErrorReport.eGeneralProblem);
		break;
	case 2:
		psProviderErrorReport->eReportType = PER_TransactionIdProblem;
		fill_dbv_ill_transidprob(&psProviderErrorReport->uProviderErrorReport.eTransactionIdProblem);
		break;

	case 3:
		psProviderErrorReport->eReportType = PER_StateTransitionProhibited;
		psProviderErrorReport->uProviderErrorReport.psStateTransitionProblem = (DbvStateTransitionProhibited *) DbvAlloc (sizeof (DbvStateTransitionProhibited));
		fill_dbv_ill_statetranspro(psProviderErrorReport->uProviderErrorReport.psStateTransitionProblem);
		break;
	}
	
}



int fill_dbv_ill_generalprob(DbvGeneralProblem *peGeneralProblem)
{
	*peGeneralProblem = GP_ProtocolVersionNotSupported;

}



int fill_dbv_ill_transidprob(DbvTransactionIdProblem *peTransactionIdProblem) 
{
	*peTransactionIdProblem = TIP_InvalidTransactionId;
}




int fill_dbv_ill_statetranspro(DbvStateTransitionProhibited *psStateTransitionProblem)
{

	/* c */
	psStateTransitionProblem->eAPDUType = IAT_Received;

	/* c */
	psStateTransitionProblem->eCurrentState = CS_RenewOverdue;
}








/****************************************************************/
/* DbvCOrder external */

int fill_DbvCOrder(DbvASN1External *external)
{

	char *oid = ESRIN_ORDER;

	external->pcObjectIdentifier = (char *) DbvAlloc (strlen(oid) + 1);
        memcpy(external->pcObjectIdentifier, oid, strlen(oid));
 
        external->eValueType = EVT_SingleASN1Type;
        external->uExternalValue.psSingleASN1Type = (DbvSingleASN1Type * ) DbvAlloc (sizeof (DbvSingleASN1Type));
        external->uExternalValue.psSingleASN1Type->eASN1Type = AT_Corder;
        external->uExternalValue.psSingleASN1Type->uASN1.psCOrder = (struct DbvCOrder *) DbvAlloc (sizeof (struct DbvCOrder));

	fill_DbvCOrder_main(external->uExternalValue.psSingleASN1Type->uASN1.psCOrder);
}



int fill_DbvCOrder_main(DbvCOrder *psCOrder)
{
	int choice = 0;
	char choice_string[100];


	choice = 0;
	while (choice < 1 || choice > 2) {
		printf("Enter eCOrderType type: COT_OrderRequest (1), COT_OrderResponse (2): ");
		choice = (atol(gets(choice_string)));
	}

	switch (choice) {
	case 1:
		psCOrder->eCOrderType = COT_OrderRequest;
		psCOrder->uCOrder.psOrderRequest = (DbvOrderRequest *) DbvAlloc (sizeof (DbvOrderRequest));
		fill_DbvOrderRequest(psCOrder->uCOrder.psOrderRequest);
		break;
	case 2:
		psCOrder->eCOrderType = COT_OrderResponse;
	
		/* Lets have a list of 3 order response nodes 
		   (malloc 4 pointers, one for the terminating NULL
		   (0, 1, 2, \0) ) */
		psCOrder->uCOrder.ppsOrderResponse = (DbvInternationalString **) DbvAlloc (sizeof (DbvInternationalString *) * 4 );
		psCOrder->uCOrder.ppsOrderResponse[0] = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		psCOrder->uCOrder.ppsOrderResponse[1] = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		psCOrder->uCOrder.ppsOrderResponse[2] = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));

		/* now fill the 3 nodes */
		fill_dbv_inter_string(psCOrder->uCOrder.ppsOrderResponse[0], "first corder request");
		fill_dbv_inter_string(psCOrder->uCOrder.ppsOrderResponse[1], "second corder request");
		fill_dbv_inter_string(psCOrder->uCOrder.ppsOrderResponse[2], "third corder request");
		break;
	}
}



int fill_DbvOrderRequest(DbvOrderRequest *psOrderRequest)
{
	int choice = 0;
	char choice_string[100];


	choice = 0;
	while (choice < 1 || choice > 2) {
		printf("Enter eOrderRequestType type: ORT_NormalOrder (1), ORT_OrderRefs (2): ");
		choice = (atol(gets(choice_string)));
	}

	switch (choice) {
	case 1:
		psOrderRequest->eOrderRequestType = ORT_NormalOrder;
		psOrderRequest->uOrderRequest.psNormalOrder = (DbvNormalOrder *) DbvAlloc (sizeof (DbvNormalOrder));
		fill_DbvNormalOrder(psOrderRequest->uOrderRequest.psNormalOrder);
		break;
	case 2:
		psOrderRequest->eOrderRequestType = ORT_OrderRefs;
	
		/* Lets have a list of 3 order ref nodes 
		   (malloc 4 pointers, one for the terminating NULL
		   (0, 1, 2, \0) ) */
		psOrderRequest->uOrderRequest.ppsOrderRefs = (DbvInternationalString **) DbvAlloc (sizeof (DbvInternationalString *) * 4 );
		psOrderRequest->uOrderRequest.ppsOrderRefs[0] = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		psOrderRequest->uOrderRequest.ppsOrderRefs[1] = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		psOrderRequest->uOrderRequest.ppsOrderRefs[2] = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));

		/* now fill the 3 nodes */
		fill_dbv_inter_string(psOrderRequest->uOrderRequest.ppsOrderRefs[0], "first corder reference");
		fill_dbv_inter_string(psOrderRequest->uOrderRequest.ppsOrderRefs[1], "second corder reference");
		fill_dbv_inter_string(psOrderRequest->uOrderRequest.ppsOrderRefs[2], "third corder reference");
		break;
	}
}



int fill_DbvNormalOrder(DbvNormalOrder *psNormalOrder)
{
	/* c */
	psNormalOrder->ppsOrderRanges = (DbvRange **) DbvAlloc(sizeof(DbvRange * ) * 3);
	psNormalOrder->ppsOrderRanges[0] = (DbvRange *) DbvAlloc(sizeof(DbvRange));        
	psNormalOrder->ppsOrderRanges[1] = (DbvRange *) DbvAlloc(sizeof(DbvRange));
	fill_DbvRange(psNormalOrder->ppsOrderRanges[0]);
	fill_DbvRange(psNormalOrder->ppsOrderRanges[1]);


	/* c */
	psNormalOrder->ulQuantity = 666;
	
}





