#include "api_origin_close.h"


int send_closereq_to_target(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error)
{
        DbvCloseReq   *psCloseReq = NULL;

	int choice = 0;
        char choice_string[100];

 
        /* Allocate memory for psCloseReq and fill it in */
        psCloseReq = (DbvCloseReq *) DbvAlloc (sizeof(DbvCloseReq));
        fill_close_request(psCloseReq);
 

        printf("Print 'CloseRequest' (Close PDU) to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_closereq_fields(stdout, psCloseReq);
                printf("-----------------------------------------\n");
        }
 
 

        /* Send the CloseRequest just filled in to the target */
        if (DbvCloseRequest(*assoc_id, psCloseReq, error) == SI_OK) {

                /* Sent PDU to target ok so free up space it used */

                SIFreeDbvCloseReq(&psCloseReq);

                return SI_OK;
        } else {
 
                /* The attempt to send the PDU to the target failed */
                PrivateErrorHandling(error);

                SIFreeDbvCloseReq(&psCloseReq);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(error);
                return SI_NOTOK;
        }
}
 


/* There is no closeRequest/closeResponse pair in Z39.50, only a 
   Close PDU. A 'closeResponse' is sent as a 'closeRequest' */
int send_closersp_to_target(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error)
{
        DbvCloseReq   *psCloseRsp = NULL;

        int choice = 0;
        char choice_string[100];

 
        /* Allocate memory for psCloseRsp and fill it in */
        psCloseRsp = (DbvCloseReq *) DbvAlloc (sizeof(DbvCloseReq));
        fill_close_request(psCloseRsp);
 
        printf("Print 'CloseResponse' (Close PDU) to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_closereq_fields(stdout, psCloseRsp);
                printf("-----------------------------------------\n");
        }
 

        /* Send the CloseResponse just filled in to the target */
        if (DbvCloseResponse(*assoc_id, psCloseRsp, error) == SI_OK) {

                /* Sent PDU to target ok so free up space it used */

                SIFreeDbvCloseReq(&psCloseRsp);

                return SI_OK;
        } else {
 
                /* The attempt to send the PDU to the target failed */
                PrivateErrorHandling(error);

                SIFreeDbvCloseReq(&psCloseRsp);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(error);
                return SI_NOTOK;
        }
}

