#include "api_origin_extend.h"


/* In PDU and external set up code prior to ItemOrder and ILL,
   compulsory fields were set up before optional fields for convenience. 
   Because of the size of ILL, this strategy has been dropped.
*/

int send_DbvExtendedServicesReq_DbvUpdateExtendedService(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error)
{
        DbvExtendedServicesReq   *psExtendedServicesReq = NULL;
	
 
        /* Allocate memory for psExtendedServicesReq and fill it in */
        psExtendedServicesReq = (DbvExtendedServicesReq *) DbvAlloc (sizeof(DbvExtendedServicesReq));

        fill_DbvExtendedServiceReq_common(psExtendedServicesReq);


	/* psOriginSpecificParameter */
	psExtendedServicesReq->psOriginSpecificParameter = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));

	/* Fill the field with an update external */
        fill_DbvUpdateExtendedService(psExtendedServicesReq->psOriginSpecificParameter);

	send_extendreq(assoc_id, psExtendedServicesReq, error);

	return SI_OK;
}



int fill_DbvExtendedServiceReq_common(DbvExtendedServicesReq *psExtendedServicesReq)
{
/*
        char *test_oid = ANSI_UKMARC;
*/
        char *test_oid = "1.2.840.10003.5.1";

        char *test_reference_id = "extend services request reference id";
        int choice = 0;
        char choice_string[100];
	int number_of_nodes = 0;
 
        /* Compulsory fields */
 
        /* eFunction */
	psExtendedServicesReq->eFunction = ESF_Delete;

	/* packageType - DbvObjectIdentifier is a typdefed char*  */
	psExtendedServicesReq->pcPackageType = (DbvObjectIdentifier ) DbvAlloc (strlen(test_oid) + 1);
	memcpy(psExtendedServicesReq->pcPackageType, test_oid, strlen(test_oid));


	/* eWaitAction */
	psExtendedServicesReq->eWaitAction = ESWA_DontReturnPackage;
	

        /* Optional fields */
 
        /* Reference id */
        psExtendedServicesReq->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
        fill_dbv_octet_string(psExtendedServicesReq->psReferenceId, test_reference_id);
 

	/* psPackageName */
	psExtendedServicesReq->psPackageName = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
        fill_dbv_inter_string(psExtendedServicesReq->psPackageName, "extended services request package name");


	/* psUserId */
	psExtendedServicesReq->psUserId = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
        fill_dbv_inter_string(psExtendedServicesReq->psUserId, "extended services request test user id");


	/* psRetentionTime */
	psExtendedServicesReq->psRetentionTime = (DbvIntUnit *) DbvAlloc (sizeof(DbvIntUnit));
	fill_intunit(psExtendedServicesReq->psRetentionTime);
	

	/* ppsPermissions */
	psExtendedServicesReq->ppsPermissions = (DbvPermissions **) DbvAlloc (sizeof(DbvPermissions *) * 3);

	/* Total number of nodes, including terminator */
	number_of_nodes = 3;
	fill_permissions_list(psExtendedServicesReq->ppsPermissions, number_of_nodes);
	
	/* psDescription */
	psExtendedServicesReq->psDescription = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
        fill_dbv_inter_string(psExtendedServicesReq->psDescription, "extended services request description");


	/* psElements */
	psExtendedServicesReq->psElements = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
        fill_dbv_inter_string(psExtendedServicesReq->psElements, "extended service request psElements");


        /* psOtherInformation */
        psExtendedServicesReq->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);
        psExtendedServicesReq->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
        psExtendedServicesReq->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
 
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), other (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
                fill_extend_req_othinfo_char(psExtendedServicesReq->ppsOtherInformation[0]);
                fill_extend_req_othinfo_char(psExtendedServicesReq->ppsOtherInformation[1]);
                break;
        case 2:
                fill_extend_req_othinfo_bin(psExtendedServicesReq->ppsOtherInformation[0]);
                fill_extend_req_othinfo_bin(psExtendedServicesReq->ppsOtherInformation[1]);
                break;
        case 3:
                fill_extend_req_othinfo_ext(psExtendedServicesReq->ppsOtherInformation[0]);
                fill_extend_req_othinfo_ext(psExtendedServicesReq->ppsOtherInformation[1]);
                break;
       case 4:
                fill_extend_req_othinfo_obj(psExtendedServicesReq->ppsOtherInformation[0]);
                fill_extend_req_othinfo_obj(psExtendedServicesReq->ppsOtherInformation[1]);
                break;
        }
}
 


/****************************************************************/
/* Update external */

int fill_DbvUpdateExtendedService(DbvASN1External *external)
{

	char *oid = ANSI_UPDATE_EXTENDED_SERVICE;

	external->pcObjectIdentifier = (char *) DbvAlloc (strlen(oid) + 1);
        memcpy(external->pcObjectIdentifier, oid, strlen(oid));
 

        external->eValueType = EVT_SingleASN1Type;
        external->uExternalValue.psSingleASN1Type = (DbvSingleASN1Type * ) DbvAlloc (sizeof (DbvSingleASN1Type));
        external->uExternalValue.psSingleASN1Type->eASN1Type = AT_UpdateExtendedService;
        external->uExternalValue.psSingleASN1Type->uASN1.psUpdateExtendedService= (struct DbvUpdateExtendedService *) DbvAlloc (sizeof (struct DbvUpdateExtendedService));

	fill_DbvUpdateExtendedService_main(external->uExternalValue.psSingleASN1Type->uASN1.psUpdateExtendedService);

}



int fill_DbvUpdateExtendedService_main(DbvUpdateExtendedService *psUpdateExtendedService)
{
	int choice = 0;
	char choice_string[100];


	choice = 0;
	while (choice < 1 || choice > 2) {
		printf("Enter eUpdateReqRsp type: UROR_Request (1), UROR_Response (2): ");
		choice = (atol(gets(choice_string)));
	}

	switch (choice) {
	case 1:
		psUpdateExtendedService->eUpdateReqRsp = UROR_Request;
		psUpdateExtendedService->uUpdateReqOrRsp.psUpdateRequest = (DbvUpdateRequestPackage *) DbvAlloc (sizeof (DbvUpdateRequestPackage));
		fill_DbvUpdateRequestPackage(psUpdateExtendedService->uUpdateReqOrRsp.psUpdateRequest);
		break;
	case 2:
		psUpdateExtendedService->eUpdateReqRsp = UROR_Response;
		psUpdateExtendedService->uUpdateReqOrRsp.psUpdateResponse = (DbvUpdateTaskPackage *) DbvAlloc (sizeof (DbvUpdateTaskPackage));
		fill_DbvUpdateTaskPackage(psUpdateExtendedService->uUpdateReqOrRsp.psUpdateResponse);
		break;
	}
}



int fill_DbvUpdateRequestPackage(DbvUpdateRequestPackage *psUpdateRequest)
{
	/* Both these compulsory */
	fill_dbv_originparttokeep(&psUpdateRequest->sOriginPartToKeep);

	/* 3 nodes - 0, 1, \0 */
	psUpdateRequest->ppsSuppliedRecord = (DbvSuppliedRecord **) DbvAlloc (sizeof(DbvSuppliedRecord *) * 3);

	printf("Node 0:\n");
	psUpdateRequest->ppsSuppliedRecord[0] = (DbvSuppliedRecord *) DbvAlloc (sizeof(DbvSuppliedRecord));
	fill_dbv_supplied_rec(psUpdateRequest->ppsSuppliedRecord[0]);

	printf("Node 1:\n");
	psUpdateRequest->ppsSuppliedRecord[1] = (DbvSuppliedRecord *) DbvAlloc (sizeof(DbvSuppliedRecord));
	fill_dbv_supplied_rec(psUpdateRequest->ppsSuppliedRecord[1]);

	/* Terminate the list */
	psUpdateRequest->ppsSuppliedRecord[2] = NULL;

}



int fill_dbv_originparttokeep(DbvOriginPartToKeep *psOriginPartToKeep)
{
	char *test_inter_string = "test database name";
	char *test_oid = ANSI_CANMARC;
	char *test_elsetname = "test element set name";

	psOriginPartToKeep->eAction = UA_RecordReplace;

	fill_dbv_inter_string(&psOriginPartToKeep->sDatabaseName, test_inter_string);

	/* DbvObjectIdentifier is a typdefed char * */
	psOriginPartToKeep->pcSchema = (DbvObjectIdentifier) DbvAlloc (strlen(test_oid) + 1 );
	memcpy(psOriginPartToKeep->pcSchema, test_oid, strlen(test_oid));



	psOriginPartToKeep->psElementSetName = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psOriginPartToKeep->psElementSetName, test_elsetname);

	
}



int fill_dbv_supplied_rec(DbvSuppliedRecord *psSuppliedRecord)
{
        char *sutrs = "this is an update supplied record sutrs string";

	psSuppliedRecord->psUpdtRecordId = (DbvUpdtRecordId *) DbvAlloc (sizeof (DbvUpdtRecordId));
	fill_dbv_record_id(psSuppliedRecord->psUpdtRecordId);

	psSuppliedRecord->psUpdtSupplementalId = (DbvUpdtSupplementalId *) DbvAlloc (sizeof (DbvUpdtSupplementalId));
	fill_dbv_supp_id(psSuppliedRecord->psUpdtSupplementalId);

	psSuppliedRecord->psCorrelationInfo = (DbvCorrelationInfo *) DbvAlloc (sizeof (DbvCorrelationInfo));
	fill_dbv_corr_info(psSuppliedRecord->psCorrelationInfo);


	/* This external is compulsory */
        fill_dbv_sutrs_external(&psSuppliedRecord->sRecord, sutrs);
}



int fill_dbv_record_id(DbvUpdtRecordId *psUpdtRecordId)
{
	int choice = 0;
	char choice_string[100];


	choice = 0;
	while (choice < 1 || choice > 3) {
		printf("Enter eRecordIdType type: URIT_Number (1), URIT_String (2), URIT_Opaque (3): ");
		choice = (atol(gets(choice_string)));
	}

	switch (choice) {
	case URIT_Number:
		psUpdtRecordId->eRecordIdType = URIT_Number;
		psUpdtRecordId->uUpdtRecordId.ulNumber = 444;
		break;
	case URIT_String:
		psUpdtRecordId->eRecordIdType = URIT_String;
		psUpdtRecordId->uUpdtRecordId.psString = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		fill_dbv_inter_string(psUpdtRecordId->uUpdtRecordId.psString, "record id psstring test");
		break;
	case URIT_Opaque:
		psUpdtRecordId->eRecordIdType = URIT_Opaque;
		psUpdtRecordId->uUpdtRecordId.psOpaque = (DbvOctetString *) DbvAlloc (sizeof (DbvOctetString));
		fill_dbv_octet_string(psUpdtRecordId->uUpdtRecordId.psOpaque, "record id psopaque test");
		break;
	}
}



int fill_dbv_supp_id(DbvUpdtSupplementalId *psUpdtSupplementalId)
{
	int choice = 0;
	char choice_string[100];
	char *test_gen_time = "19950216210627.3";

	choice = 0;
	while (choice < 1 || choice > 3) {
		printf("Enter eSupplementalIdType type: USIT_Time (1), USIT_Version (2), USIT_PreviousVersion (3): ");
		choice = (atol(gets(choice_string)));
	}


	switch (choice) {
	case USIT_Time:
		psUpdtSupplementalId->eSupplementalIdType = USIT_Time;
		/* DbvGeneralizedTime is a char * */
		psUpdtSupplementalId->uUpdtSupplementalId.pcTime = (DbvGeneralizedTime) DbvAlloc (strlen(test_gen_time) + 1);
		memcpy(psUpdtSupplementalId->uUpdtSupplementalId.pcTime, test_gen_time, strlen(test_gen_time)); 
		break;
	case USIT_Version:
		psUpdtSupplementalId->eSupplementalIdType = USIT_Version;
		psUpdtSupplementalId->uUpdtSupplementalId.psVersion = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		fill_dbv_inter_string(psUpdtSupplementalId->uUpdtSupplementalId.psVersion, "test supp id version");
		break;
	case USIT_PreviousVersion:
		psUpdtSupplementalId->eSupplementalIdType = USIT_PreviousVersion;
		psUpdtSupplementalId->uUpdtSupplementalId.psPreviousVersion = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
        	fill_dbv_sutrs_external(psUpdtSupplementalId->uUpdtSupplementalId.psPreviousVersion, "this is a supp id previous version sutrs test string");
		break;
	}
}



int fill_dbv_corr_info(DbvCorrelationInfo *psCorrelationInfo)
{
	char *test_note = "correlation info test note";


	psCorrelationInfo->psNote = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psCorrelationInfo->psNote, test_note);


	psCorrelationInfo->pulId = (Ulong *) DbvAlloc (sizeof(Ulong));
	*psCorrelationInfo->pulId = 555;


}



int fill_DbvUpdateTaskPackage(DbvUpdateTaskPackage *psUpdateResponse)
{
	/* Both these compulsory */
	fill_dbv_originparttokeep(&psUpdateResponse->sOriginPartToKeep);
	fill_dbv_targetpart(&psUpdateResponse->sTargetPart);
}



int fill_dbv_targetpart(DbvUpdateTargetPart *psTargetPart)
{
	psTargetPart->eTaskStatus = UTS_Partial;
	fill_dbv_globaldiags(psTargetPart);
	fill_dbv_taskpackrecs(psTargetPart);
}



int fill_dbv_globaldiags(DbvUpdateTargetPart *psTargetPart)
{
	/* 3 nodes - 0, 1, \0 */
	psTargetPart->ppsGlobalDiagnostics = (DbvDiagRec **) DbvAlloc (sizeof(DbvDiagRec *) * 3);


	psTargetPart->ppsGlobalDiagnostics[0] = (DbvDiagRec *) DbvAlloc (sizeof(DbvDiagRec));

	/* DbvDiagRec, DbvDefaultDiagFormat V2 */
        fill_default_diag_rec(psTargetPart->ppsGlobalDiagnostics[0], ANSI_LIBRISMARC, 33, "another diag text for v2", PVIF_Version2, DT_DefaultFormat, NULL);


	psTargetPart->ppsGlobalDiagnostics[1] = (DbvDiagRec *) DbvAlloc (sizeof(DbvDiagRec));

        /* DbvDiagRec, DbvDefaultDiagFormat V3 */
        fill_default_diag_rec(psTargetPart->ppsGlobalDiagnostics[1], ANSI_DANMARC, 44, "another diag text for v3", PVIF_Version3, DT_DefaultFormat, NULL);


	/* Terminate the list */
	psTargetPart->ppsGlobalDiagnostics[2] = NULL;
}



int fill_dbv_taskpackrecs(DbvUpdateTargetPart *psTargetPart)
{
	/* 3 nodes - 0, 1, \0 */
	psTargetPart->ppsTaskPackageRecord = (DbvTaskPackageRecord **) DbvAlloc (sizeof(DbvTaskPackageRecord *) * 3);

	printf("Node 0\n");
	psTargetPart->ppsTaskPackageRecord[0] = (DbvTaskPackageRecord *) DbvAlloc (sizeof(DbvTaskPackageRecord));
	fill_dbv_taskpackrec(psTargetPart->ppsTaskPackageRecord[0]);

	printf("Node 1\n");
	psTargetPart->ppsTaskPackageRecord[1] = (DbvTaskPackageRecord *) DbvAlloc (sizeof(DbvTaskPackageRecord));
	fill_dbv_taskpackrec(psTargetPart->ppsTaskPackageRecord[1]);

	/* Terminate the list */
	psTargetPart->ppsTaskPackageRecord[2] = NULL;
}



int fill_dbv_taskpackrec(DbvTaskPackageRecord *psTaskPackageRecord)
{
	
	psTaskPackageRecord->psUpdtRecordOrDiag = (DbvUpdtRecordOrDiag *) DbvAlloc (sizeof (DbvUpdtRecordOrDiag));
	fill_dbv_recordiag(psTaskPackageRecord->psUpdtRecordOrDiag);
	
	psTaskPackageRecord->psCorrelationInfo = (DbvCorrelationInfo *) DbvAlloc (sizeof (DbvCorrelationInfo));
	fill_dbv_corr_info(psTaskPackageRecord->psCorrelationInfo);


	psTaskPackageRecord->eUpdtRecordStatus = URST_InProcess;
	
}



int fill_dbv_recordiag(DbvUpdtRecordOrDiag *psUpdtRecordOrDiag)
{
	int choice = 0;
	char choice_string[100];

	choice = 0;
	while (choice < 1 || choice > 2) {
		printf("Enter eUpdtRecordOrDiag type: URDT_Record (1), URDT_Diagnostic (2): ");
		choice = (atol(gets(choice_string)));
	}


	switch (choice) {
	case URDT_Record:
		psUpdtRecordOrDiag->eUpdtRecordOrDiag = URDT_Record;
		psUpdtRecordOrDiag->uUpdtRecordOrDiag.psRecord = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
        	fill_dbv_sutrs_external(psUpdtRecordOrDiag->uUpdtRecordOrDiag.psRecord, "this is an update record or diag sutrs test string");
		break;
	case URDT_Diagnostic:
		psUpdtRecordOrDiag->eUpdtRecordOrDiag = URDT_Diagnostic;
		psUpdtRecordOrDiag->uUpdtRecordOrDiag.psDiagnostic = (DbvDiagRec *) DbvAlloc (sizeof(DbvDiagRec));
        	fill_default_diag_rec(psUpdtRecordOrDiag->uUpdtRecordOrDiag.psDiagnostic, ANSI_LIBRISMARC, 33, "another diag text for v2", PVIF_Version2, DT_DefaultFormat, NULL);
		break;
	}
}


/* rest of extended service  */

int fill_extend_req_othinfo_char(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 27;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my extended services request otherinfo char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}
 
 
int fill_extend_req_othinfo_bin(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char bininfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 33;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my extended services request otherinfo bin field");
 
        fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}
 
 
 
int fill_extend_req_othinfo_ext(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char bininfo[100];
        char sutrs_string[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
        DbvASN1External *external = NULL;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my extend  request otherinfo bin field");
        strcpy(sutrs_string, "this is my sutrs string - ExtendedServices Request");
 
 
        fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);
 
        /* Set up a sutrs external */
        external = psOtherInformation->uInformation.psExternallyDefinedInfo;
        fill_dbv_sutrs_external(external, sutrs_string);
 
}
 
 
 
int fill_extend_req_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
        fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
}
 
 


int send_extendreq(DbvAssocId *assoc_id, DbvExtendedServicesReq *psExtendedServicesReq, DbvError **error)
{
        int choice = 0;
        char choice_string[100];

        printf("Print ExtendedServicesRequest PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_extendreq_fields(stdout, psExtendedServicesReq);
                printf("-----------------------------------------\n");
        }

        /* Send the ExtendedServicesRequest just filled in to the target */
        if (DbvExtendedServicesRequest(*assoc_id, psExtendedServicesReq, error) == SI_OK) {
 
                /* Sent PDU to target ok so free up space it used */

                SIFreeDbvExtendedServicesReq(&psExtendedServicesReq);

                return SI_OK;
        } else {
 
                /* The attempt to send the PDU to the target failed */
                PrivateErrorHandling(error);

                SIFreeDbvExtendedServicesReq(&psExtendedServicesReq);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(error);
 
                return SI_NOTOK;
        }

}



/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/



/* Item Order with ILL */
int send_DbvExtendedServicesReq_DbvItemOrderExtendedService_DbvIllPdu(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error)
{   
        DbvExtendedServicesReq *psExtendedServicesReq = NULL;
    
        /* Allocate memory for psExtendedServicesReq and fill it in */
        psExtendedServicesReq = (DbvExtendedServicesReq *) DbvAlloc (sizeof(DbvExtendedServicesReq));

        fill_DbvExtendedServiceReq_common(psExtendedServicesReq);

	/* psOriginSpecificParameter */
	psExtendedServicesReq->psOriginSpecificParameter = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));

        /* Fill the field with an Item Order external (following function in api_ill.c) */
        fill_DbvItemOrderExtendedService(psExtendedServicesReq->psOriginSpecificParameter, IOROR_Request);


	/* Add an ILL external to be carried in the Item Order (following funbction in api_ill.c) */
	/* o */
	psExtendedServicesReq->psOriginSpecificParameter->uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderRequest->sNotToKeep.psItemRequest = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
        fill_DbvIllPdu(psExtendedServicesReq->psOriginSpecificParameter->uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderRequest->sNotToKeep.psItemRequest);



	send_extendreq(assoc_id, psExtendedServicesReq, error);
        return SI_OK;
}





/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/


/* DbvPrintExtendedService */
int send_DbvExtendedServicesReq_DbvPrintExtendedService(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error)
{   
        DbvExtendedServicesReq *psExtendedServicesReq = NULL;
    
        /* Allocate memory for psExtendedServicesReq and fill it in */
        psExtendedServicesReq = (DbvExtendedServicesReq *) DbvAlloc (sizeof(DbvExtendedServicesReq));

        fill_DbvExtendedServiceReq_common(psExtendedServicesReq);

	/* psOriginSpecificParameter */
	psExtendedServicesReq->psOriginSpecificParameter = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));

	/* Fill with DbvPrintExtendedService */
        fill_DbvPrintExtendedService(psExtendedServicesReq->psOriginSpecificParameter);  

	send_extendreq(assoc_id, psExtendedServicesReq, error);
        return SI_OK;
}




/****************************************************************/
/* DbvPrintExtendedService external */

int fill_DbvPrintExtendedService(DbvASN1External *external)
{

	char *oid = ESRIN_PRINT;

	external->pcObjectIdentifier = (char *) DbvAlloc (strlen(oid) + 1);
        memcpy(external->pcObjectIdentifier, oid, strlen(oid));
 
        external->eValueType = EVT_SingleASN1Type;
        external->uExternalValue.psSingleASN1Type = (DbvSingleASN1Type * ) DbvAlloc (sizeof (DbvSingleASN1Type));
        external->uExternalValue.psSingleASN1Type->eASN1Type = AT_Print;
        external->uExternalValue.psSingleASN1Type->uASN1.psPrintExtendedService = (struct DbvPrintExtendedService *) DbvAlloc (sizeof (struct DbvPrintExtendedService));

	fill_DbvPrintExtendedService_main(external->uExternalValue.psSingleASN1Type->uASN1.psPrintExtendedService);

}



int fill_DbvPrintExtendedService_main(DbvPrintExtendedService *psPrintExtendedService)
{
	int choice = 0;
	char choice_string[100];


	choice = 0;
	while (choice < 1 || choice > 2) {
		printf("Enter ePrintReqRsp type: PROR_Request (1), PROR_Response (2): ");
		choice = (atol(gets(choice_string)));
	}

	switch (choice) {
	case 1:
		psPrintExtendedService->ePrintReqRsp = PROR_Request;
		psPrintExtendedService->uPrintReqOrRsp.psPrintRequest = (DbvPrintRequestPackage *) DbvAlloc (sizeof (DbvPrintRequestPackage));
		fill_DbvPrintRequestPackage(psPrintExtendedService->uPrintReqOrRsp.psPrintRequest);
		break;
	case 2:
		psPrintExtendedService->ePrintReqRsp = PROR_Response;
		psPrintExtendedService->uPrintReqOrRsp.psPrintResponse = (DbvPrintTaskPackage *) DbvAlloc (sizeof (DbvPrintTaskPackage));
		fill_DbvPrintTaskPackage(psPrintExtendedService->uPrintReqOrRsp.psPrintResponse);
		break;
	}
}



int fill_DbvPrintRequestPackage(DbvPrintRequestPackage *psPrintRequestPackage)
{
	/* o */
	psPrintRequestPackage->psOriginPartToKeep = (DbvPrintOriginPartToKeep *) DbvAlloc (sizeof (DbvPrintOriginPartToKeep));
	fill_DbvPrintOriginPartToKeep(psPrintRequestPackage->psOriginPartToKeep);
}



int fill_DbvPrintOriginPartToKeep(DbvPrintOriginPartToKeep *psOriginPartToKeep)
{
	int choice = 0;
	char choice_string[100];


	choice = 0;
	while (choice < 1 || choice > 2) {
		printf("Enter ePrintOriginPartToKeepType type: POPKT_Create (1), POPKT_Delete (2): ");
		choice = (atol(gets(choice_string)));
	}

	switch (choice) {
	case 1:
		psOriginPartToKeep->ePrintOriginPartToKeepType = POPKT_Create;
		psOriginPartToKeep->uPrintOriginPartToKeep.psCreateOption = (DbvCreateOption *) DbvAlloc (sizeof (DbvCreateOption));
		fill_DbvCreateOption(psOriginPartToKeep->uPrintOriginPartToKeep.psCreateOption);
		break;
	case 2:
		psOriginPartToKeep->ePrintOriginPartToKeepType = PROR_Response;
		psOriginPartToKeep->uPrintOriginPartToKeep.psDeleteOption = (DbvDeleteOption *) DbvAlloc (sizeof (DbvDeleteOption));
		fill_DbvDeleteOption(psOriginPartToKeep->uPrintOriginPartToKeep.psDeleteOption);
		break;
	}
}



int fill_DbvCreateOption(DbvCreateOption *psCreateOption)
{

	int choice = 0;
	char choice_string[100];


	choice = 0;
	while (choice < 1 || choice > 2) {
		printf("Enter eCreateOptionType type: COPT_ResultSetReference (1), COPT_AccessionReference (2): ");
		choice = (atol(gets(choice_string)));
	}

	switch (choice) {
	case 1:
		psCreateOption->eCreateOptionType = COPT_ResultSetReference;
		psCreateOption->uCreateOption.psResultSetReference = (DbvResultSetReference *) DbvAlloc (sizeof (DbvResultSetReference));
		fill_DbvResultSetReference(psCreateOption->uCreateOption.psResultSetReference);
		break;
	case 2:
		psCreateOption->eCreateOptionType = COPT_AccessionReference;
		psCreateOption->uCreateOption.psAccessionReference = (DbvAccessionReference *) DbvAlloc (sizeof (DbvAccessionReference));
		fill_DbvAccessionReference(psCreateOption->uCreateOption.psAccessionReference);
		break;
	}
}



void fill_DbvResultSetReference(DbvResultSetReference *psResultSetReference)
{
	char    *test_ressetid = "default result set";

	/* c */
	fill_dbv_inter_string(&psResultSetReference->sResultSetId, test_ressetid);

	/* c */
	psResultSetReference->ulResultSetStartPoint = 34;

	/* c */
	psResultSetReference->ulNumberOfRecordsRequested = 35;

	/* o */	
	psResultSetReference->ppsAdditionalRanges = (DbvRange **) DbvAlloc(sizeof(DbvRange * ) * 3);
	psResultSetReference->ppsAdditionalRanges[0] = (DbvRange *) DbvAlloc(sizeof(DbvRange));
	psResultSetReference->ppsAdditionalRanges[1] = (DbvRange *) DbvAlloc(sizeof(DbvRange));
	fill_DbvRange(psResultSetReference->ppsAdditionalRanges[0]);
	fill_DbvRange(psResultSetReference->ppsAdditionalRanges[1]);


	/* o */
	psResultSetReference->psRecordComposition = (DbvRecordComposition * ) DbvAlloc (sizeof(struct DbvRecordComposition));
	fill_DbvRecordComposition(psResultSetReference->psRecordComposition);

	/* c */
	fill_DbvAddress(&psResultSetReference->sAddress);
}



void fill_DbvAddress(DbvAddress *psAddress)
{
	/* c */
	fill_dbv_inter_string(&psAddress->sPostalAddress, "Kensington Palace");

	/* o */
	psAddress->psEmailAddress = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
        fill_dbv_inter_string(psAddress->psEmailAddress, "James.Hewitt@kenpalace.org");

}



void fill_DbvAccessionReference(DbvAccessionReference *psAccessionReference)
{
	/* c */
	fill_dbv_inter_string(&psAccessionReference->sReferenceId, "This is an accession id");

	/* o */
	psAccessionReference->psRecordComposition = (DbvRecordComposition * ) DbvAlloc (sizeof(struct DbvRecordComposition));
	fill_DbvRecordComposition(psAccessionReference->psRecordComposition);

	/* c */
	fill_DbvAddress(&psAccessionReference->sAddress);
}



int fill_DbvDeleteOption(DbvDeleteOption *psDeleteOption)
{
	char *test_jobref = "delete option test job reference";

	/* c */
	fill_dbv_inter_string(&psDeleteOption->sJobReference, test_jobref);

}



int fill_DbvPrintTaskPackage(DbvPrintTaskPackage *psPrintResponse)
{
	
	/* o */
	psPrintResponse->psOriginPartToKeep = (DbvPrintOriginPartToKeep *) DbvAlloc (sizeof (DbvPrintTaskPackage));
	fill_DbvPrintOriginPartToKeep(psPrintResponse->psOriginPartToKeep);


	/* c */
	fill_DbvPrintTargetPartToKeep(&psPrintResponse->sTargetPart);
}



int fill_DbvPrintTargetPartToKeep(DbvPrintTargetPartToKeep *psTargetPart)
{
	
	char *test_jobref = "task package test job reference";

	/* c */
	fill_dbv_inter_string(&psTargetPart->sJobReference, test_jobref);
}







/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/
/******************************************************************/


/* DbvAlertExtendedService */
int send_DbvExtendedServicesReq_DbvAlertExtendedService(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error)
{   
        DbvExtendedServicesReq *psExtendedServicesReq = NULL;
    
        /* Allocate memory for psExtendedServicesReq and fill it in */
        psExtendedServicesReq = (DbvExtendedServicesReq *) DbvAlloc (sizeof(DbvExtendedServicesReq));

        fill_DbvExtendedServiceReq_common(psExtendedServicesReq);

	/* psOriginSpecificParameter */
	psExtendedServicesReq->psOriginSpecificParameter = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));

	/* Fill with DbvAlertExtendedService */
        fill_DbvAlertExtendedService(psExtendedServicesReq->psOriginSpecificParameter);  

	send_extendreq(assoc_id, psExtendedServicesReq, error);
        return SI_OK;
}




/****************************************************************/
/* DbvAlertExtendedService external */

int fill_DbvAlertExtendedService(DbvASN1External *external)
{

	char *oid = ESRIN_ALERT;

	external->pcObjectIdentifier = (char *) DbvAlloc (strlen(oid) + 1);
        memcpy(external->pcObjectIdentifier, oid, strlen(oid));
 
        external->eValueType = EVT_SingleASN1Type;
        external->uExternalValue.psSingleASN1Type = (DbvSingleASN1Type * ) DbvAlloc (sizeof (DbvSingleASN1Type));
        external->uExternalValue.psSingleASN1Type->eASN1Type = AT_Alert;
        external->uExternalValue.psSingleASN1Type->uASN1.psAlertExtendedService = (struct DbvAlertExtendedService *) DbvAlloc (sizeof (struct DbvAlertExtendedService));

	fill_DbvAlertExtendedService_main(external->uExternalValue.psSingleASN1Type->uASN1.psAlertExtendedService);

}



int fill_DbvAlertExtendedService_main(DbvAlertExtendedService *psAlertExtendedService)
{
	int choice = 0;
	char choice_string[100];


	choice = 0;
	while (choice < 1 || choice > 2) {
		printf("Enter eAlertReqRsp type: AROR_Request (1), AROR_Response (2): ");
		choice = (atol(gets(choice_string)));
	}

	switch (choice) {
	case 1:
		psAlertExtendedService->eAlertReqRsp = AROR_Request;
		psAlertExtendedService->uAlertReqOrRsp.psAlertRequest = (DbvAlertRequestPackage *) DbvAlloc (sizeof (DbvAlertRequestPackage));
		fill_DbvAlertRequestPackage(psAlertExtendedService->uAlertReqOrRsp.psAlertRequest);
		break;
	case 2:
		psAlertExtendedService->eAlertReqRsp = AROR_Response;
		psAlertExtendedService->uAlertReqOrRsp.psAlertResponse = (DbvAlertTaskPackage *) DbvAlloc (sizeof (DbvAlertTaskPackage));
		fill_DbvAlertTaskPackage(psAlertExtendedService->uAlertReqOrRsp.psAlertResponse);
		break;
	}
}



int fill_DbvAlertRequestPackage(DbvAlertRequestPackage *psAlertRequest)
{
	/* o */
	psAlertRequest->psOriginPartToKeep = (DbvAlertOriginPartToKeep *) DbvAlloc (sizeof (DbvAlertOriginPartToKeep));
	fill_DbvAlertOriginPartToKeep(psAlertRequest->psOriginPartToKeep);
}



void fill_DbvAlertOriginPartToKeep(DbvAlertOriginPartToKeep *psOriginPartToKeep)
{
	char *test_interstring = "alert name";

	/* c */
	fill_DbvInternationalString(&psOriginPartToKeep->sAlertName, test_interstring);

	/* o */
	psOriginPartToKeep->psAddress = (DbvAddress *) DbvAlloc (sizeof (DbvAddress));
	fill_DbvAddress(psOriginPartToKeep->psAddress);

}



int fill_DbvAlertTaskPackage(DbvAlertTaskPackage *psAlertResponse)
{
	/* o */
	psAlertResponse->psOriginPartToKeep = (DbvAlertOriginPartToKeep *) DbvAlloc (sizeof (DbvAlertOriginPartToKeep));
	fill_DbvAlertOriginPartToKeep(psAlertResponse->psOriginPartToKeep);
}



/* Item Order with Corder (Crossnet order format) */
int send_DbvExtendedServicesReq_DbvItemOrderExtendedService_DbvCOrder(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error)
{   
        DbvExtendedServicesReq *psExtendedServicesReq = NULL;
    
        /* Allocate memory for psExtendedServicesReq and fill it in */
        psExtendedServicesReq = (DbvExtendedServicesReq *) DbvAlloc (sizeof(DbvExtendedServicesReq));

        fill_DbvExtendedServiceReq_common(psExtendedServicesReq);

	/* psOriginSpecificParameter */
	psExtendedServicesReq->psOriginSpecificParameter = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));

        /* Fill the field with an Item Order external (following function in api_ill.c) */
        fill_DbvItemOrderExtendedService(psExtendedServicesReq->psOriginSpecificParameter, IOROR_Request);

	/* Add a Corder external to be carried in the Item Order */
	/* o */
	psExtendedServicesReq->psOriginSpecificParameter->uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderRequest->sNotToKeep.psItemRequest = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));

	/* following function in api_ill.c */
        fill_DbvCOrder(psExtendedServicesReq->psOriginSpecificParameter->uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderRequest->sNotToKeep.psItemRequest);

	send_extendreq(assoc_id, psExtendedServicesReq, error);

        return SI_OK;
}






