#include "api_origin_pres.h"



/* Set up a PresentRequest PDU and sent it to a target */
int send_presreq_to_target(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *dbname)
{

	DbvPresentReq   * psPresentReq = NULL;

	int choice = 0;
        char choice_string[100];

	/* Allocate memory for psPresentReq and fill it in */
	psPresentReq = (DbvPresentReq * ) DbvAlloc (sizeof(DbvPresentReq));

	fill_pres_request(psPresentReq, dbname);

	printf("Print PresentRequest PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_presreq_fields(stdout, psPresentReq);
                printf("-----------------------------------------\n");
        }
 

        /* Send the PresentRequest we have just filled in to the target */
	if (DbvPresentRequest(*assoc_id, psPresentReq, error) == SI_OK) {


		SIFreeDbvPresentReq(&psPresentReq);

		return SI_OK;
	} else {

		PrivateErrorHandling(error);

		SIFreeDbvPresentReq(&psPresentReq);


		/* Release buffer, assign NULL pointer */
		FreeSIErrorCode(error);
		return SI_NOTOK;
	}
}


int fill_pres_request(DbvPresentReq *psPresentReq, char *dbname)
{
        int choice = 0;
        char choice_string[100];
	char	*pref_rec_syntax;


        choice = 0;
        while (choice < 1 || choice > 18) {
        	printf("\n\n");
                printf("Choose a Preferred Record Syntax:\n");
                printf(" 1) ANSI_USMARC syntax (1.2.840.10003.5.10)\n");
                printf(" 2) ANSI_UKMARC syntax (1.2.840.10003.5.11)\n");
                printf(" 3) ANSI_UNIMARC syntax (1.2.840.10003.5.1)\n");
		printf(" 4) ANSI_NORMARC syntax (1.2.840.10003.5.12)\n");
		printf(" 5) ANSI_DANMARC syntax (1.2.840.10003.5.14)\n");
		printf(" 6) ANSI_FINMARC syntax (1.2.840.10003.5.15)\n");
		printf(" 7) ANSI_CANMARC syntax (1.2.840.10003.5.17)\n");
		printf(" 8) ANSI_INTERMARC syntax (1.2.840.10003.5.2)\n");
		printf(" 9) ANSI_CCF syntax (1.2.840.10003.5.3)\n");
		printf("10) ANSI_LIBRISMARC syntax (1.2.840.10003.5.13)\n");
		printf("11) ANSI_MAB syntax (1.2.840.10003.5.16)\n");
		printf("12) ANSI_SBN syntax (1.2.840.10003.5.18)\n");
		printf("13) ANSI_PICAMARC syntax (1.2.840.10003.5.19)\n");
		printf("14) ANSI_AUSMARC syntax (1.2.840.10003.5.20)\n");
		printf("\n");
		printf("15) ANSI SUTRS RECORD syntax (1.2.840.10003.5.101)\n");
		printf("16) ANSI OPAC RECORD syntax (1.2.840.10003.5.102)\n");
		printf("17) ANSI_SUMMARY_RECORD syntax (1.2.840.10003.5.103)\n");
		printf("\n");
		printf("18) ISO record formats\n");
		printf("select a choice, (1 - 18): ");
                choice = (atol(gets(choice_string)));
	}
	
	/* Set the Preferred Record Syntax */
	/* +1 to allocate space for the \0 */
	switch(choice) {
	case 1:
		pref_rec_syntax = ANSI_USMARC;
		break;
	case 2:
		pref_rec_syntax = ANSI_UKMARC;	
		break;
	case 3:
		pref_rec_syntax = ANSI_UNIMARC;	
		break;
	case 4:
		pref_rec_syntax = ANSI_NORMARC;	
		break;
	case 5:
		pref_rec_syntax = ANSI_DANMARC;	
		break;
	case 6:
		pref_rec_syntax = ANSI_FINMARC;	
		break;
	case 7:
		pref_rec_syntax = ANSI_CANMARC;	
		break;
	case 8:
		pref_rec_syntax = ANSI_INTERMARC;	
		break;
	case 9:
		pref_rec_syntax = ANSI_CCF;	
		break;
	case 10:
		pref_rec_syntax = ANSI_LIBRISMARC;	
		break;
	case 11:
		pref_rec_syntax = ANSI_MAB;	
		break;
	case 12:
		pref_rec_syntax = ANSI_SBN;	
		break;
	case 13:
		pref_rec_syntax = ANSI_PICAMARC;	
		break;
	case 14:
		pref_rec_syntax = ANSI_AUSMARC;	
		break;
	case 15:
		pref_rec_syntax = ANSI_UNSTRUCTURED_TEXT_RECORD;	
		break;
	case 16:
		pref_rec_syntax = ANSI_OPAC_RECORD;	
		break;
	case 17:
		pref_rec_syntax = ANSI_SUMMARY_RECORD;
		break;
	case 18:
            	choice = 0;
            	while (choice < 1 || choice > 18) {
        		printf("\n\n");
                	printf("Choose an ISO Record Syntax:\n");
                	printf(" 1) ISO_USMARC syntax (1.0.10163.5.10)\n");
                	printf(" 2) ISO_UKMARC syntax (1.0.10163.5.11)\n");
                	printf(" 3) ISO_UNIMARC syntax (1.0.10163.5.1)\n");
			printf(" 4) ISO_NORMARC syntax (1.0.10163.5.12)\n");
			printf(" 5) ISO_DANMARC syntax (1.0.10163.5.14)\n");
			printf(" 6) ISO_FINMARC syntax (1.0.10163.5.15)\n");
			printf(" 7) ISO_CANMARC syntax (1.0.10163.5.17)\n");
			printf(" 8) ISO_INTERMARC syntax (1.0.10163.5.2)\n");
			printf(" 9) ISO_CCF syntax (1.0.10163.5.3)\n");
			printf("10) ISO_LIBRISMARC syntax (1.0.10163.5.13)\n");
			printf("11) ISO_MAB syntax (1.0.10163.5.16)\n");
			printf("12) ISO_SBN syntax (1.0.10163.5.18)\n");
			printf("13) ISO_PICAMARC syntax (1.0.10163.5.19)\n");
			printf("14) ISO_AUSMARC syntax (1.0.10163.5.20)\n");
			printf("\n");
			printf("15) ISO SUTRS RECORD syntax (1.0.10163.5.101)\n");
			printf("16) ISO OPAC RECORD syntax (1.0.10163.5.102)\n");
			printf("17) ISO_SUMMARY_RECORD syntax (1.0.10163.5.103)\n");
			printf("select a choice, (1 - 18): ");
                	choice = (atol(gets(choice_string)));
		}
		switch(choice) {
		case 1:
			pref_rec_syntax = ISO_USMARC;
			break;
		case 2:
			pref_rec_syntax = ISO_UKMARC;	
			break;
		case 3:
			pref_rec_syntax = ISO_UNIMARC;	
			break;
		case 4:
			pref_rec_syntax = ISO_NORMARC;	
			break;
		case 5:
			pref_rec_syntax = ISO_DANMARC;	
			break;
		case 6:
			pref_rec_syntax = ISO_FINMARC;	
			break;
		case 7:
			pref_rec_syntax = ISO_CANMARC;	
			break;
		case 8:
			pref_rec_syntax = ISO_INTERMARC;	
			break;
		case 9:
			pref_rec_syntax = ISO_CCF;	
			break;
		case 10:
			pref_rec_syntax = ISO_LIBRISMARC;	
			break;
		case 11:
			pref_rec_syntax = ISO_MAB;	
			break;
		case 12:
			pref_rec_syntax = ISO_SBN;	
			break;
		case 13:
			pref_rec_syntax = ISO_PICAMARC;	
			break;
		case 14:
			pref_rec_syntax = ISO_AUSMARC;	
			break;
		case 15:
			pref_rec_syntax = ISO_UNSTRUCTURED_TEXT_RECORD;	
			break;
		case 16:
			pref_rec_syntax = ISO_OPAC_RECORD;	
			break;
		case 17:
			pref_rec_syntax = ISO_SUMMARY_RECORD;
			break;
		}
		break;
	}

	psPresentReq->pcPreferredRecordSyntax = (DbvProtocolVersion) DbvAlloc (strlen(pref_rec_syntax) + 1);
	memcpy(psPresentReq->pcPreferredRecordSyntax, pref_rec_syntax, strlen(pref_rec_syntax));

	/* now the rest of the fields... */
        fill_pres_request_default(psPresentReq);

}




int	fill_pres_request_default(DbvPresentReq *psPresentReq)
{
	char	*test_ressetid = "default";
	char	*test_reference_id = "present request reference id";

	char	num_recs[1000];
	char	res_start[1000];
        int choice = 0;
        char choice_string[100];


	/* Compulsory fields... */


	/* ResultSetId */
	fill_dbv_inter_string(&(psPresentReq->sResultSetId), test_ressetid);

	/* Result set start point  */
	printf("\n");
	printf("Enter result set start point (e.g. 1): ");
	psPresentReq->ulResultSetStartPoint = atol(gets(res_start));
	
	/* Number of records requested */
	printf("Enter number of records to retrieve (e.g. 3): ");
	psPresentReq->ulNumberOfRecordsRequested = atol(gets(num_recs));



	/* Optional fields for version 3 stuff... */
	/* remove the following  to test. Note, this may have unpredictable
	 * results on various servers... */

/* LOOK !!!!!!! */
#ifdef WANTV3INFO

	/* ReferenceId */


	psPresentReq->psReferenceId = (DbvOctetString * ) DbvAlloc(sizeof(DbvOctetString));
	fill_dbv_octet_string(psPresentReq->psReferenceId, test_reference_id);


	/* Additional ranges  - create space for ten ranges (0 - 9) */

	psPresentReq->ppsAdditionalRanges = (DbvRange **) DbvAlloc(sizeof(DbvRange * ) * 10);

	fill_dbv_present_addranges(psPresentReq->ppsAdditionalRanges);


	/* Record composititon */

	psPresentReq->psRecordComposition = (DbvRecordComposition * ) DbvAlloc (sizeof(struct DbvRecordComposition));
	fill_DbvRecordComposition(psPresentReq->psRecordComposition);


	/* Max segment count */
	psPresentReq->pulMaxSegmentCount = (Ulong * ) DbvAlloc (sizeof(Ulong));
	*psPresentReq->pulMaxSegmentCount = 16;

	/* Max record size */
	psPresentReq->pulMaxRecordSize = (Ulong * ) DbvAlloc (sizeof(Ulong));
	*psPresentReq->pulMaxRecordSize = 32;

	/* Max segment size */
	psPresentReq->pulMaxSegmentSize = (Ulong * ) DbvAlloc (sizeof(Ulong));
	*psPresentReq->pulMaxSegmentSize = 48;

	/* OtherInformation */
	psPresentReq->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);
	psPresentReq->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
	psPresentReq->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));

        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), obj (4): ");
                choice = (atol(gets(choice_string)));
        }


	switch (choice) {
	case 1:
		fill_pres_request_othinfo_char(psPresentReq->ppsOtherInformation[0]);
		fill_pres_request_othinfo_char(psPresentReq->ppsOtherInformation[1]);
		break;
	case 2:
		fill_pres_request_othinfo_bin(psPresentReq->ppsOtherInformation[0]);
		fill_pres_request_othinfo_bin(psPresentReq->ppsOtherInformation[1]);
		break;
	case 3:
		fill_pres_request_othinfo_ext(psPresentReq->ppsOtherInformation[0]);
		fill_pres_request_othinfo_ext(psPresentReq->ppsOtherInformation[1]);
		break;
	case 4:
		fill_pres_request_othinfo_obj(psPresentReq->ppsOtherInformation[0]);
		fill_pres_request_othinfo_obj(psPresentReq->ppsOtherInformation[1]);
		break;
	}
#endif
/* LOOK !!!!!!! */
}



int fill_dbv_present_addranges(DbvRange **ppsAdditionalRanges)
{
	/* First range */
	ppsAdditionalRanges[0] = (DbvRange * ) DbvAlloc (sizeof(DbvRange));
	fill_DbvRange(ppsAdditionalRanges[0]);

	/* Second range */
	ppsAdditionalRanges[1] = (DbvRange * ) DbvAlloc (sizeof(DbvRange));
	fill_DbvRange(ppsAdditionalRanges[1]);

	/* Terminate the list of additionalRanges with a NULL */
	ppsAdditionalRanges[2] = NULL;
}






int	fill_pres_request_othinfo_char(DbvOtherInformation *psOtherInformation)
{

	char	oid[100];
	char	charinfo[100];

	DbvBool want_infocat = DBV_TRUE;
	unsigned long	catvalue = 27;

	strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
	strcpy(charinfo, "this is my otherinfo char field");

	fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}







int	fill_pres_request_othinfo_bin(DbvOtherInformation *psOtherInformation)
{
	char	oid[100];
	char	bininfo[100];

	DbvBool want_infocat = DBV_TRUE;
	unsigned long	catvalue = 33;

	strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
	strcpy(bininfo, "this is my otherinfo bin field");

	fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}





int	fill_pres_request_othinfo_ext(DbvOtherInformation *psOtherInformation)
{
	char	oid[100];
	char	bininfo[100];
	char	sutrs_string[100];

	DbvBool want_infocat = DBV_TRUE;
	unsigned long	catvalue = 47;
	DbvASN1External * external = NULL;

	strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
	strcpy(bininfo, "this is my otherinfo bin field");
	strcpy(sutrs_string, "this is my sutrs string");

	fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);

	/* Set up a sutrs external */
	external = psOtherInformation->uInformation.psExternallyDefinedInfo;
	fill_dbv_sutrs_external(external, sutrs_string);
}





int	fill_pres_request_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
	char	infooid[100];
	char	otheroid[100];

	DbvBool want_infocat = DBV_TRUE;
	unsigned long	catvalue = 47;

	strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
	strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);

	fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
}



