#include "api_origin_rescntrl.h"



/* Set up an ResourceControlResponse PDU and sent it to a target */
int send_rescntrlrsp_to_target(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error)
{
	DbvResourceControlRsp   *psResourceControlRsp = NULL;
	
	int choice = 0;
	char choice_string[100];

	/* Allocate memory for psResourceControlRsp and fill it in */
        psResourceControlRsp = (DbvResourceControlRsp *) DbvAlloc (sizeof(DbvResourceControlRsp));
        fill_rescntrl_response(psResourceControlRsp);
 
	printf("Print ResourceControlResponse PDU to screen before sending ? yes (1), no (2): ");
	choice = atoi(gets(choice_string));
	if (choice == 1) {
		printf("-----------------------------------------\n");
		print_rescntrlrsp_fields(stdout, psResourceControlRsp);
		printf("-----------------------------------------\n");
	}

 
        /* Send the ResourceControlResponse just filled in to the target */
        if (DbvResourceControlResponse(*assoc_id, psResourceControlRsp, error) == SI_OK) {
		/* Sent PDU to target ok so free up space it used */ 

		SIFreeDbvResourceControlRsp(&psResourceControlRsp);

		return SI_OK;
	} else {
		
		/* The attempt to send the PDU to the target failed */
                PrivateErrorHandling(error);

                SIFreeDbvResourceControlRsp(&psResourceControlRsp);


                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(error);
		return SI_NOTOK;
	}
}



int fill_rescntrl_response(DbvResourceControlRsp *psResourceControlRsp)
{


	char *test_refid = "resource control response reference id";
	char *test_otherinfo1 = "first other information test";
	char *test_otherinfo2 = "second other information test";


        /* Compulsory fields... */

        psResourceControlRsp->fContinueFlag = DBV_TRUE; 


       	/* Optional fields... */
 
	/* +1 to allocate space for the \0 */
        psResourceControlRsp->psReferenceId = (DbvOctetString *) DbvAlloc (sizeof(DbvOctetString));
	fill_dbv_octet_string(psResourceControlRsp->psReferenceId, test_refid);


        psResourceControlRsp->pfResultSetWanted = (DbvBool *) DbvAlloc (sizeof (DbvBool));
        *psResourceControlRsp->pfResultSetWanted = DBV_TRUE; 


	/* 2 nodes */
	psResourceControlRsp->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);

	psResourceControlRsp->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));

	psResourceControlRsp->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
	psResourceControlRsp->ppsOtherInformation[2] = NULL;


	fill_dbv_otherinfo_char(psResourceControlRsp->ppsOtherInformation[0], DBV_TRUE, ANSI_UNSTRUCTURED_TEXT_RECORD, 989, test_otherinfo1);
	fill_dbv_otherinfo_char(psResourceControlRsp->ppsOtherInformation[1], DBV_TRUE, ANSI_UNSTRUCTURED_TEXT_RECORD, 999, test_otherinfo2);



}
  



