#include "api_origin_scan.h"


int	send_scanreq_to_target(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error)
{
        DbvScanReq   *psScanReq = NULL;

        int choice = 0;
        char choice_string[100];

 
        /* Allocate memory for psScanReq and fill it in */
        psScanReq = (DbvScanReq *) DbvAlloc (sizeof(DbvScanReq));
        fill_scan_request(psScanReq);
 
 
        printf("Print ScanRequest PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_scanreq_fields(stdout, psScanReq);
                printf("-----------------------------------------\n");
        }
 

        /* Send the ScanRequest just filled in to the target */
        if (DbvScanRequest(*assoc_id, psScanReq, error) == SI_OK) {

                /* Sent PDU to target ok so free up space it used */

                SIFreeDbvScanReq(&psScanReq);

                return SI_OK;
        } else {
 
                /* The attempt to send the PDU to the target failed */
                PrivateErrorHandling(error);

                SIFreeDbvScanReq(&psScanReq);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(error);
 
                return SI_NOTOK;
        }
}
 
 
 
int fill_scan_request(DbvScanReq *psScanReq)
{
        char 	*test_reference_id = "scan request reference id";
        char 	*test_attset = ANSI_ATTRIBUTE_SET_BIB_1;
        char 	dbname[100];
        int 	choice = 0;
        char 	choice_string[100];
 
        /* Compulsory fields */

	/* ppsDatabaseNames */
	printf("Enter database name: ");
	gets(dbname);

	psScanReq->ppsDatabaseNames = (DbvInternationalString **) DbvAlloc(sizeof (DbvInternationalString *) * 2);
	psScanReq->ppsDatabaseNames[0] = (DbvInternationalString *) DbvAlloc(sizeof(DbvInternationalString));
	fill_dbv_inter_string(psScanReq->ppsDatabaseNames[0], dbname);
	psScanReq->ppsDatabaseNames[1] = NULL;

	/* sAttributesPlusTerm */	
        choice = 0;
        while (choice < 1 || choice > 3) {
                printf("Term Attribute Type: subject (1), title (2), author (3): ");
                choice = (atol(gets(choice_string)));
        }
        printf("Enter Term: ");
        gets(choice_string);
 
 	/* fill in the attribute and term info */

        switch (choice) {
	/* fill with subject attributes of bib-1 */
        case 1:
		psScanReq->sAttributesPlusTerm.ppsAttributeElement = (DbvAttributeElement **) DbvAlloc (sizeof(DbvAttributeElement *) * 5);
	
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[0] = (DbvAttributeElement *) DbvAlloc (sizeof(DbvAttributeElement));
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[0]->ulAttributeType = 1;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[0]->sAttributeValue.eAttributeValueType = AVT_Numeric;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[0]->sAttributeValue.uAttributeValue.ulNumeric = 21;

		psScanReq->sAttributesPlusTerm.ppsAttributeElement[1] = (DbvAttributeElement *) DbvAlloc (sizeof(DbvAttributeElement));
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[1]->ulAttributeType = 3;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[1]->sAttributeValue.eAttributeValueType = AVT_Numeric;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[1]->sAttributeValue.uAttributeValue.ulNumeric = 3;

		psScanReq->sAttributesPlusTerm.ppsAttributeElement[2] = (DbvAttributeElement *) DbvAlloc (sizeof(DbvAttributeElement));
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[2]->ulAttributeType = 4;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[2]->sAttributeValue.eAttributeValueType = AVT_Numeric;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[2]->sAttributeValue.uAttributeValue.ulNumeric = 6;

		psScanReq->sAttributesPlusTerm.ppsAttributeElement[3] = (DbvAttributeElement *) DbvAlloc (sizeof(DbvAttributeElement));
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[3]->ulAttributeType = 6;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[3]->sAttributeValue.eAttributeValueType = AVT_Numeric;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[3]->sAttributeValue.uAttributeValue.ulNumeric = 1;
        break;

	/* fill with title attributes of bib-1 */
        case 2:
		psScanReq->sAttributesPlusTerm.ppsAttributeElement = (DbvAttributeElement **) DbvAlloc (sizeof(DbvAttributeElement *) * 5);
	
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[0] = (DbvAttributeElement *) DbvAlloc (sizeof(DbvAttributeElement));
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[0]->ulAttributeType = 1;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[0]->sAttributeValue.eAttributeValueType = AVT_Numeric;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[0]->sAttributeValue.uAttributeValue.ulNumeric = 4;

		psScanReq->sAttributesPlusTerm.ppsAttributeElement[1] = (DbvAttributeElement *) DbvAlloc (sizeof(DbvAttributeElement));
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[1]->ulAttributeType = 3;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[1]->sAttributeValue.eAttributeValueType = AVT_Numeric;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[1]->sAttributeValue.uAttributeValue.ulNumeric = 4;

		psScanReq->sAttributesPlusTerm.ppsAttributeElement[2] = (DbvAttributeElement *) DbvAlloc (sizeof(DbvAttributeElement));
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[2]->ulAttributeType = 4;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[2]->sAttributeValue.eAttributeValueType = AVT_Numeric;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[2]->sAttributeValue.uAttributeValue.ulNumeric = 6;

		psScanReq->sAttributesPlusTerm.ppsAttributeElement[3] = (DbvAttributeElement *) DbvAlloc (sizeof(DbvAttributeElement));
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[3]->ulAttributeType = 6;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[3]->sAttributeValue.eAttributeValueType = AVT_Numeric;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[3]->sAttributeValue.uAttributeValue.ulNumeric = 1;
        break;

	/* fill with author attributes of bib-1 */
        case 3:
		psScanReq->sAttributesPlusTerm.ppsAttributeElement = (DbvAttributeElement **) DbvAlloc (sizeof(DbvAttributeElement *) * 5);
	
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[0] = (DbvAttributeElement *) DbvAlloc (sizeof(DbvAttributeElement));
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[0]->ulAttributeType = 1;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[0]->sAttributeValue.eAttributeValueType = AVT_Numeric;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[0]->sAttributeValue.uAttributeValue.ulNumeric = 1003;

		psScanReq->sAttributesPlusTerm.ppsAttributeElement[1] = (DbvAttributeElement *) DbvAlloc (sizeof(DbvAttributeElement));
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[1]->ulAttributeType = 3;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[1]->sAttributeValue.eAttributeValueType = AVT_Numeric;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[1]->sAttributeValue.uAttributeValue.ulNumeric = 3;

		psScanReq->sAttributesPlusTerm.ppsAttributeElement[2] = (DbvAttributeElement *) DbvAlloc (sizeof(DbvAttributeElement));
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[2]->ulAttributeType = 4;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[2]->sAttributeValue.eAttributeValueType = AVT_Numeric;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[2]->sAttributeValue.uAttributeValue.ulNumeric = 6;

		psScanReq->sAttributesPlusTerm.ppsAttributeElement[3] = (DbvAttributeElement *) DbvAlloc (sizeof(DbvAttributeElement));
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[3]->ulAttributeType = 6;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[3]->sAttributeValue.eAttributeValueType = AVT_Numeric;
		psScanReq->sAttributesPlusTerm.ppsAttributeElement[3]->sAttributeValue.uAttributeValue.ulNumeric = 1;

        break;
        }

	/* fill in the term itself */
	psScanReq->sAttributesPlusTerm.sTerm.eTermType = TT_General;
	psScanReq->sAttributesPlusTerm.sTerm.uTerm.psGeneral = (DbvOctetString *) DbvAlloc (sizeof(DbvOctetString));
	fill_dbv_octet_string(psScanReq->sAttributesPlusTerm.sTerm.uTerm.psGeneral, choice_string);
	


	/* how many terms */
	printf("How many terms: ");
	gets(choice_string);
	choice = atoi(choice_string);
	psScanReq->ulNumberOfTermsRequested = choice;


	/* Optional fields */

	/* Reference id - uncomment and fill in sommething useful if you want to use
	 * ref Id
	 */
/*
        psScanReq->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
        fill_dbv_octet_string(psScanReq->psReferenceId, test_reference_id);
*/


	/* pcAttributeSetId */
        psScanReq->pcAttributeSetId = (DbvObjectIdentifier) DbvAlloc (strlen(test_attset) + 1);
	memcpy(psScanReq->pcAttributeSetId, test_attset, strlen(test_attset));


	/* pulStepSize */
	printf("Step Size: ");
	gets(choice_string);
	choice = atoi(choice_string);
        psScanReq->pulStepSize = (Ulong *) DbvAlloc (sizeof(Ulong));
        *psScanReq->pulStepSize = choice;


	/* pulPreferredPositionInResponse */
	/* uncomment to ask the user */
/*
	printf("Preferred Position in Response: ");
	gets(choice_string);
	choice = atoi(choice_string);
*/

        psScanReq->pulPreferredPositionInResponse = (Ulong *) DbvAlloc (sizeof(Ulong));
        *psScanReq->pulPreferredPositionInResponse = 1;

/*
        *psScanReq->pulPreferredPositionInResponse = choice;
*/
	

        /* OtherInformation */
        /* uncomment to demonstrate OtherInformation */
/*
        psScanReq->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);
        psScanReq->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
        psScanReq->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));

 
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), other (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
                fill_scanreq_othinfo_char(psScanReq->ppsOtherInformation[0]);
                fill_scanreq_othinfo_char(psScanReq->ppsOtherInformation[1]);
                break;
        case 2:
                fill_scanreq_othinfo_bin(psScanReq->ppsOtherInformation[0]);
                fill_scanreq_othinfo_bin(psScanReq->ppsOtherInformation[1]);
                break;
        case 3:
                fill_scanreq_othinfo_ext(psScanReq->ppsOtherInformation[0]);
                fill_scanreq_othinfo_ext(psScanReq->ppsOtherInformation[1]);
                break;
        case 4:
                fill_scanreq_othinfo_obj(psScanReq->ppsOtherInformation[0]);
                fill_scanreq_othinfo_obj(psScanReq->ppsOtherInformation[1]);
                break;
        }
*/

}



int fill_scanreq_othinfo_char(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 27;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my scan request otherinfo char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}
 
 

int fill_scanreq_othinfo_bin(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char bininfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 33;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my scan request otherinfo bin field");
 
        fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}
 
 
 
int fill_scanreq_othinfo_ext(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char bininfo[100];
        char sutrs_string[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
        DbvASN1External *external = NULL;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my scan request otherinfo bin field");
        strcpy(sutrs_string, "this is my sutrs string - Scan Request");
 
        fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);
 
        /* Set up a sutrs external */
        external = psOtherInformation->uInformation.psExternallyDefinedInfo;
        fill_dbv_sutrs_external(external, sutrs_string);
}
 
 
 
int fill_scanreq_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
        fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
}
 
 



