#include "api_origin_sort.h"


int	send_sortreq_to_target(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error)
{
        DbvSortReq   *psSortReq = NULL;

        int choice = 0;
        char choice_string[100];

 
        /* Allocate memory for psSortReq and fill it in */
        psSortReq = (DbvSortReq *) DbvAlloc (sizeof(DbvSortReq));
        fill_sort_request(psSortReq);
 
 
        printf("Print SortRequest PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_sortreq_fields(stdout, psSortReq);
                printf("-----------------------------------------\n");
        }

        /* Send the SortRequest just filled in to the target */
        if (DbvSortRequest(*assoc_id, psSortReq, error) == SI_OK) {
 
                /* Sent PDU to target ok so free up space it used */

                SIFreeDbvSortReq(&psSortReq);

                return SI_OK;
        } else {
 
                /* The attempt to send the PDU to the target failed */
                PrivateErrorHandling(error);

                SIFreeDbvSortReq(&psSortReq);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(error);
 
                return SI_NOTOK;
	}
}



int fill_sort_request(DbvSortReq *psSortReq)
{
        char *test_reference_id = "sort request reference id";
        char *test_attset = ANSI_UKMARC;
        int choice = 0;
        char choice_string[100];
 
        /* Compulsory fields */
 
 
	/* ppsInputResultSetName */
        /* Create 3 nodes - 0, 1 \0 */
        psSortReq->ppsInputResultSetName = (DbvInternationalString **) DbvAlloc(sizeof (DbvInternationalString *) * 3);
	fill_inressetnames_list(psSortReq->ppsInputResultSetName);


	/* sSortedResultSetName */
	fill_dbv_inter_string(&psSortReq->sSortedResultSetName, "sort request test result set name");


	/* ppsSortSequence */
        /* Create 3 nodes - 0, 1 \0 */
        psSortReq->ppsSortSequence = (DbvSortKeySpec **) DbvAlloc(sizeof (DbvSortKeySpec *) * 3);
	fill_sortsequence_list(psSortReq->ppsSortSequence);


        /* Optional fields */

        /* Reference id */
        psSortReq->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
        fill_dbv_octet_string(psSortReq->psReferenceId, test_reference_id);

	/* psOtherInformation */
        psSortReq->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);
        psSortReq->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
        psSortReq->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
 
 
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), other (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
                fill_sortreq_othinfo_char(psSortReq->ppsOtherInformation[0]);
                fill_sortreq_othinfo_char(psSortReq->ppsOtherInformation[1]);
                break;
        case 2:
                fill_sortreq_othinfo_bin(psSortReq->ppsOtherInformation[0]);
                fill_sortreq_othinfo_bin(psSortReq->ppsOtherInformation[1]);
                break;
        case 3:
                fill_sortreq_othinfo_ext(psSortReq->ppsOtherInformation[0]);
                fill_sortreq_othinfo_ext(psSortReq->ppsOtherInformation[1]);
                break;
       case 4:
                fill_sortreq_othinfo_obj(psSortReq->ppsOtherInformation[0]);
                fill_sortreq_othinfo_obj(psSortReq->ppsOtherInformation[1]);
                break;
        }
}
 
 

int fill_inressetnames_list(DbvInternationalString **ppsInputResultSetName)
{
        ppsInputResultSetName[0] = (DbvInternationalString *) DbvAlloc(sizeof(DbvInternationalString));
        fill_dbv_inter_string(ppsInputResultSetName[0], "sort result set name 0");
 
        ppsInputResultSetName[1] = (DbvInternationalString *) DbvAlloc(sizeof(DbvInternationalString));
        fill_dbv_inter_string(ppsInputResultSetName[1], "sort result set name 1");
        ppsInputResultSetName[2] = NULL;
}



int fill_sortsequence_list(DbvSortKeySpec **ppsSortSequence)
{
        ppsSortSequence[0] = (DbvSortKeySpec *) DbvAlloc(sizeof(DbvSortKeySpec));
        fill_sortkeyspec(ppsSortSequence[0]);
 
        ppsSortSequence[1] = (DbvSortKeySpec *) DbvAlloc(sizeof(DbvSortKeySpec));
        fill_sortkeyspec(ppsSortSequence[1]);
        ppsSortSequence[2] = NULL;
}

 

int fill_sortkeyspec(DbvSortKeySpec *psSortSequence)
{
	fill_sortelement(&psSortSequence->sSortElement);
	psSortSequence->eSortRelationType = SRT_FrequencyAsc;
	psSortSequence->eSortCaseType = SCT_CaseInsensitive;

	psSortSequence->psMVActionType = (DbvSortMVAction *) DbvAlloc (sizeof (DbvSortMVAction));
	fill_sortmvaction(psSortSequence->psMVActionType);

}



int fill_sortelement(DbvSortElement *psSortElement)
{
        int choice = 0;
        char choice_string[100];
 
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter eSortElementType: SET_Generic (1), SET_DbSpecific (2): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
		psSortElement->eSortElementType = SET_Generic;
		psSortElement->uSortElement.psGeneric = (DbvSortKey *) DbvAlloc (sizeof (DbvSortKey));
                fill_sortkey(psSortElement->uSortElement.psGeneric);
		break;
	case 2:
		psSortElement->eSortElementType = SET_DbSpecific;

		/* 3 nodes - 0, 1, \0,*/

		psSortElement->uSortElement.ppsDatabaseSpecific = (DbvDbSpecificSortKey **) DbvAlloc (sizeof(DbvDbSpecificSortKey *) * 3);
                fill_specsortkey_list(psSortElement->uSortElement.ppsDatabaseSpecific);
		break;
	}
}



int fill_sortkey(DbvSortKey *psGeneric)
{
	
        int choice = 0;
        char choice_string[100];
 
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter eSortKeyType: SKT_SortField (1), SKT_ElementSpec (2), SKT_SortAttributes (3): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
		psGeneric->eSortKeyType = SKT_SortField;
		psGeneric->uSortElement.psSortField = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		fill_dbv_inter_string(psGeneric->uSortElement.psSortField, "sort key sort field test");
		break;
	case 2:
		psGeneric->eSortKeyType = SKT_ElementSpec;
		psGeneric->uSortElement.psElementSpec = (DbvSpecification *) DbvAlloc (sizeof (DbvSpecification));
		fill_specification(psGeneric->uSortElement.psElementSpec);
                break;
	case 3:
		psGeneric->eSortKeyType = SKT_SortAttributes;
		psGeneric->uSortElement.psSortAttributes = (DbvSortAttributes *) DbvAlloc (sizeof (DbvSortAttributes));
		fill_sortatts(psGeneric->uSortElement.psSortAttributes);
                break;
	}
}



int fill_sortatts(DbvSortAttributes *psSortAttributes)
{
	char *test_oid = ANSI_ATTRIBUTE_SET_BIB_1;

	/* DbvObjectIdentifier is a typdefed char* */
	psSortAttributes->pcAttributeSetId = (DbvObjectIdentifier ) DbvAlloc (strlen(test_oid) + 1);
	memcpy(psSortAttributes->pcAttributeSetId, test_oid, strlen(test_oid));
	

	/* Create 3 list nodes - 0, 1, \0 */
	psSortAttributes->ppsAttributeElement = (DbvAttributeElement **) DbvAlloc (sizeof(DbvAttributeElement *) * 3);
	fill_attelmnts(psSortAttributes->ppsAttributeElement);
}



int fill_specsortkey_list(DbvDbSpecificSortKey **ppsDatabaseSpecific)
{
	ppsDatabaseSpecific[0] = (DbvDbSpecificSortKey *) DbvAlloc (sizeof(DbvDbSpecificSortKey));
	fill_specsortkey(ppsDatabaseSpecific[0]);

	ppsDatabaseSpecific[1] = (DbvDbSpecificSortKey *) DbvAlloc (sizeof(DbvDbSpecificSortKey));
	fill_specsortkey(ppsDatabaseSpecific[1]);

	ppsDatabaseSpecific[2] = NULL;
}



int fill_specsortkey(DbvDbSpecificSortKey *psDatabaseSpecific)
{
	fill_dbv_inter_string(&psDatabaseSpecific->sDatabaseName, "specific sort key database name test");
	fill_sortkey(&psDatabaseSpecific->sDbSort);
}



int fill_sortmvaction(DbvSortMVAction *psMVActionType)
{
	psMVActionType->eSortMVActionType = SMT_Constant;
	psMVActionType->psOctetString = (DbvOctetString *) DbvAlloc (sizeof (DbvOctetString));
	fill_dbv_octet_string(psMVActionType->psOctetString, "mv action octet string");

}



int fill_sortreq_othinfo_char(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 27;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my sort request otherinfo char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}
 
 

int fill_sortreq_othinfo_bin(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char bininfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 33;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my sort request otherinfo bin field");
 
        fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}
 
 
 
int fill_sortreq_othinfo_ext(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char bininfo[100];
        char sutrs_string[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
        DbvASN1External *external = NULL;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my sort request otherinfo bin field");
        strcpy(sutrs_string, "this is my sutrs string - Sort Request");
 
 
        fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);
 
        /* Set up a sutrs external */
        external = psOtherInformation->uInformation.psExternallyDefinedInfo;
        fill_dbv_sutrs_external(external, sutrs_string);
}
 
 
 
int fill_sortreq_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
	fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
}
 
 



