#include "api_origin_trigger.h"



/* Set up an TriggerResourceControlRequest PDU and sent it to a target */
int send_trigrescntrlreq_to_target(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error)
{
	DbvTriggerResourceControlReq   *psTriggerResourceControlReq = NULL;
	
	int choice = 0;
	char choice_string[100];

	/* Allocate memory for psTriggerResourceControlReq and fill it in */
        psTriggerResourceControlReq = (DbvTriggerResourceControlReq *) DbvAlloc (sizeof(DbvTriggerResourceControlReq));
        fill_trigrescntrl_response(psTriggerResourceControlReq);
 
	printf("Print TriggerResourceControlRequest PDU to screen before sending ? yes (1), no (2): ");
	choice = atoi(gets(choice_string));
	if (choice == 1) {
		printf("-----------------------------------------\n");
		print_trigrescntrlreq_fields(stdout, psTriggerResourceControlReq);
		printf("-----------------------------------------\n");
	}

 
        /* Send the TriggerResourceControlRequest just filled in to the target */
        if (DbvTriggerResourceControlRequest(*assoc_id, psTriggerResourceControlReq, error) == SI_OK) {
		/* Sent PDU to target ok so free up space it used */ 

		SIFreeDbvTriggerResourceControlReq(&psTriggerResourceControlReq);

		return SI_OK;
	} else {
		
		/* The attempt to send the PDU to the target failed */
                PrivateErrorHandling(error);

                SIFreeDbvTriggerResourceControlReq(&psTriggerResourceControlReq);


                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(error);
		return SI_NOTOK;
	}
}



int fill_trigrescntrl_response(DbvTriggerResourceControlReq *psTriggerResourceControlReq)
{
	char *test_refid = "trigger resource control request reference id";
	char *test_oid = ANSI_NORMARC; 
	char *test_otherinfo1 = "first other information test";
	char *test_otherinfo2 = "second other information test";


        /* Compulsory fields... */

        psTriggerResourceControlReq->eRequestedAction = RA_Cancel;

       	/* Optional fields... */
 
	/* +1 to allocate space for the \0 */
        psTriggerResourceControlReq->psReferenceId = (DbvOctetString *) DbvAlloc (sizeof(DbvOctetString));
	fill_dbv_octet_string(psTriggerResourceControlReq->psReferenceId, test_refid);


        psTriggerResourceControlReq->pcPreferredResourceReportFormat = (DbvObjectIdentifier) DbvAlloc (strlen(test_oid) + 1);
	memcpy(psTriggerResourceControlReq->pcPreferredResourceReportFormat, test_oid, strlen(test_oid));



        psTriggerResourceControlReq->pfResultSetWanted = (DbvBool *) DbvAlloc (sizeof (DbvBool));
        *psTriggerResourceControlReq->pfResultSetWanted = DBV_FALSE;


	/* 2 nodes */
	psTriggerResourceControlReq->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);

	psTriggerResourceControlReq->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));

	psTriggerResourceControlReq->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
	psTriggerResourceControlReq->ppsOtherInformation[2] = NULL;


	fill_dbv_otherinfo_char(psTriggerResourceControlReq->ppsOtherInformation[0], DBV_TRUE, ANSI_UNSTRUCTURED_TEXT_RECORD, 989, test_otherinfo1);
	fill_dbv_otherinfo_char(psTriggerResourceControlReq->ppsOtherInformation[1], DBV_TRUE, ANSI_UNSTRUCTURED_TEXT_RECORD, 999, test_otherinfo2);



}
  


