#include "api_pdu_print1.h"

/***************************************************************/ 
/* InitResponse */

int print_initrsp_fields(FILE *f, DbvInitializeRsp *psInitializeRsp)
{
	fprintf(f,"InitResponse PDU\n");

	print_init_response_refid(f, psInitializeRsp);
	print_init_response_prover(f, psInitializeRsp);
	print_init_response_options(f, psInitializeRsp);
	print_init_response_prefmess(f, psInitializeRsp);
	print_init_response_maxmess(f, psInitializeRsp);
	print_init_response_result(f, psInitializeRsp);
	print_init_response_impid(f, psInitializeRsp);
	print_init_response_impname(f, psInitializeRsp);
	print_init_response_impver(f, psInitializeRsp);
	print_init_response_userinfo(f, psInitializeRsp);
	print_init_response_otherinfo(f, psInitializeRsp);
}



int print_init_response_refid(FILE *f, DbvInitializeRsp *psInitializeRsp)
{
       	fprintf(f,"psReferenceId: ");
	print_octet_string(f, psInitializeRsp->psReferenceId);
}


int print_init_response_prover(FILE *f, DbvInitializeRsp *psInitializeRsp)
{
        fprintf(f,"pcProtocolVersion: %s\n", psInitializeRsp->pcProtocolVersion);
}


int print_init_response_options(FILE *f, DbvInitializeRsp *psInitializeRsp)
{
        fprintf(f,"pcOptions: %s\n", psInitializeRsp->pcOptions);
}



int print_init_response_prefmess(FILE *f, DbvInitializeRsp *psInitializeRsp)
{

        fprintf(f,"ulPreferredMessageSize: %ld\n", psInitializeRsp->ulPreferredMessageSize);
}



int print_init_response_maxmess(FILE *f, DbvInitializeRsp *psInitializeRsp)
{
        fprintf(f,"ulMaxmiumMessageSize: %ld\n", psInitializeRsp->ulMaximumMessageSize);
}




int print_init_response_result(FILE *f, DbvInitializeRsp *psInitializeRsp)
{

	/* result */
	if (psInitializeRsp->fResult == DBV_TRUE)
		fprintf(f,"fResult: TRUE\n");
	else
	if (psInitializeRsp->fResult == DBV_FALSE)
		fprintf(f,"fResult: FALSE\n");
	else
		fprintf(f,"fResult: %d - invalid\n", psInitializeRsp->fResult);
}



int print_init_response_impid(FILE *f, DbvInitializeRsp *psInitializeRsp)
{
       	fprintf(f,"psImplementationId: ");
	print_inter_string(f, psInitializeRsp->psImplementationId);
}



int print_init_response_impname(FILE *f, DbvInitializeRsp *psInitializeRsp)
{
        fprintf(f,"psImplementationName: ");
	print_inter_string(f, psInitializeRsp->psImplementationName);
}


int print_init_response_impver(FILE *f, DbvInitializeRsp *psInitializeRsp)
{
        fprintf(f,"psImplementationVersion: ");
	print_inter_string(f, psInitializeRsp->psImplementationVersion);
}
 
 
int print_init_response_userinfo(FILE *f, DbvInitializeRsp *psInitializeRsp)
{
       	fprintf(f,"psUserInformationField: ");
	print_external(f, psInitializeRsp->psUserInformationField);
}



int print_init_response_otherinfo(FILE *f, DbvInitializeRsp *psInitializeRsp)
{
	fprintf(f,"ppsOtherInformation: ");
	print_otherinfo(f, psInitializeRsp->ppsOtherInformation);
}



/***************************************************************/ 
/* SearchResponse */


int print_searchrsp_fields(FILE *f, DbvSearchRsp *psSearchRsp)
{
        fprintf(f,"SearchResponse PDU\n");

	fprintf(f,"psReferenceId: ");
        print_octet_string(f, psSearchRsp->psReferenceId);

	fprintf(f,"ulResultCount: %d\n", psSearchRsp->ulResultCount);
	fprintf(f,"ulNumberOfRecordsReturned: %d\n", psSearchRsp->ulNumberOfRecordsReturned);
	fprintf(f,"ulNextResultSetPosition: %d\n", psSearchRsp->ulNextResultSetPosition);

	fprintf(f,"fSearchStatus: ");
        print_bool(f, &psSearchRsp->fSearchStatus);

	print_DbvResultSetStatus(f, psSearchRsp->peResultSetStatus);

	fprintf(f,"pePresentStatus: ");
	if (psSearchRsp->pePresentStatus != NULL)
		print_DbvPresentStatus(f, psSearchRsp->pePresentStatus);
	else
		fprintf(f,"NULL\n");

	fprintf(f,"psRecords: \n");
	print_records(f, psSearchRsp->psRecords);
	
        fprintf(f,"ppsAdditionalSearchInfo: ");
        print_otherinfo(f, psSearchRsp->ppsAdditionalSearchInfo);
 
        fprintf(f,"ppsOtherInformation: ");
        print_otherinfo(f, psSearchRsp->ppsOtherInformation);

}



int print_DbvResultSetStatus(FILE *f, DbvResultSetStatus *peResultSetStatus)
{
	fprintf(f,"peResultSetStatus: ");
	if(peResultSetStatus != NULL)
	{
		switch(*peResultSetStatus)
		{
		case RSS_Subset:
			fprintf(f,"RSS_Subset\n");
			break;
		case RSS_Interim:
			fprintf(f,"RSS_Interim\n");
			break;
		case RSS_None:
			fprintf(f,"RSS_None\n");
			break;
		case RSS_Invalid:
			fprintf(f,"RSS_Invalid\n");
			break;
		}
	}
	else
		fprintf(f,"NULL\n");
}



/***************************************************************/ 
/* PresentResponse */


int print_presrsp_fields(FILE *f, DbvPresentRsp *psPresentRsp)
{
        fprintf(f,"PresentResponse PDU\n");
 
        print_presrsp_refid(f, psPresentRsp);
        print_presrsp_numrecs(f, psPresentRsp);
        print_presrsp_nxtresset(f, psPresentRsp);
        print_presrsp_presstat(f, psPresentRsp);
        print_presrsp_records(f, psPresentRsp);
	print_presrsp_otherinfo(f, psPresentRsp);
}



int print_presrsp_refid(FILE *f, DbvPresentRsp *psPresentRsp)
{
 
        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psPresentRsp->psReferenceId);
}




int print_presrsp_numrecs(FILE *f, DbvPresentRsp *psPresentRsp)
{
	fprintf(f,"ulNumberOfRecordsReturned: %d\n", psPresentRsp->ulNumberOfRecordsReturned);

}



int print_presrsp_nxtresset(FILE *f, DbvPresentRsp *psPresentRsp)
{
	fprintf(f,"ulNextResultSetPosition: %d\n", psPresentRsp->ulNextResultSetPosition);
}



int print_presrsp_presstat(FILE *f, DbvPresentRsp *psPresentRsp)
{
        fprintf(f,"ePresentStatus: ");
			
	print_DbvPresentStatus(f, &psPresentRsp->ePresentStatus);
}



int print_presrsp_records(FILE *f, DbvPresentRsp *psPresentRsp)
{
	fprintf(f,"psRecords: ");
	print_records(f, psPresentRsp->psRecords);
}




int print_presrsp_otherinfo(FILE *f, DbvPresentRsp *psPresentRsp)
{
 
	fprintf(f,"ppsOtherInformation: ");
	print_otherinfo(f, psPresentRsp->ppsOtherInformation);
}
 
 

/***************************************************************/ 
/* DeleteResultSetResponse */


int print_delrsp_fields(FILE *f, DbvDeleteResultSetRsp *psDeleteResultSetRsp)
{
        fprintf(f,"DeleteResultSetResponse PDU\n");

        print_delete_resp_refid(f, psDeleteResultSetRsp);
        print_delete_resp_opstat(f, psDeleteResultSetRsp);
        print_delete_resp_dellistat(f, psDeleteResultSetRsp);
        print_delete_resp_numnotdel(f, psDeleteResultSetRsp);
        print_delete_resp_bulkstat(f, psDeleteResultSetRsp);
        print_delete_resp_delmess(f, psDeleteResultSetRsp);
        print_delete_resp_otherinfo(f, psDeleteResultSetRsp);
 
}


int print_delete_resp_refid(FILE *f, DbvDeleteResultSetRsp *psDeleteResultSetRsp)
{
        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psDeleteResultSetRsp->psReferenceId);

}



int print_delete_resp_opstat(FILE *f, DbvDeleteResultSetRsp *psDeleteResultSetRsp)
{
	fprintf(f,"eDeleteOperationStatus: ");
	print_opstat(f, psDeleteResultSetRsp->eDeleteOperationStatus);
}



int print_opstat(FILE *f, DbvDeleteSetStatus eDeleteOperationStatus)
{
        switch(eDeleteOperationStatus) {
	case DSS_Success:
		fprintf(f,"DSS_Success\n");
		break;
	case DSS_ResultSetDidNotExist:
		fprintf(f,"DSS_ResultSetDidNotExist\n");
		break;
	case DSS_PreviouslyDeletedByTarget:
		fprintf(f,"DSS_PreviouslyDeletedByTarget\n");
		break;
	case DSS_SystemProblemAtTarget:
		fprintf(f,"DSS_SystemProblemAtTarget\n");
		break;
	case DSS_AccessNotAllowed:
		fprintf(f,"DSS_AccessNotAllowed\n");
		break;
	case DSS_ResourceControlAtOrigin:
		fprintf(f,"DSS_ResourceControlAtOrigin\n");
		break;
	case DSS_ResourceControlAtTarget:
		fprintf(f,"DSS_ResourceControlAtTarget\n");
		break;
	case DSS_BulkDeleteNotSupported:
		fprintf(f,"DSS_BulkDeleteNotSupported\n");
		break;
	case DSS_NotAllSetsDeletedOnBulkDlt:
		fprintf(f,"DSS_NotAllSetsDeletedOnBulkDlt\n");
		break;
	case DSS_NotAllRequestedSetsDeleted:
		fprintf(f,"DSS_NotAllRequestedSetsDeleted\n");
		break;
	case DSS_ResultSetInUse:
		fprintf(f,"DSS_ResultSetInUse\n");
		break;
	case DSS_Invalid:
		fprintf(f,"DSS_Invalid\n");
		break;
	default:
		fprintf(f,"Unknown\n");
		break;
	}
}



int print_delete_resp_dellistat(FILE *f, DbvDeleteResultSetRsp *psDeleteResultSetRsp)
{
	int index = 0;

	fprintf(f,"ppsDeleteListStatuses: ");
	if (psDeleteResultSetRsp->ppsDeleteListStatuses != NULL) {
		fprintf(f,"\n");

		while( psDeleteResultSetRsp->ppsDeleteListStatuses[index] != NULL) {
			print_liststat(f, psDeleteResultSetRsp->ppsDeleteListStatuses[index]);
			index++;
		}
		fprintf(f,"\n");
		
	} else
		fprintf(f,"NULL\n");
				
}



int print_liststat(FILE *f, DbvListStatus *psDeleteListStatuses)
{
	/* Both the following are compulsory */
	fprintf(f,"sResultSetId: ");
	print_inter_string(f, &psDeleteListStatuses->sResultSetId);

	fprintf(f,"eDeleteSetStatus: ");
	print_opstat(f, psDeleteListStatuses->eDeleteSetStatus);
}



int print_delete_resp_numnotdel(FILE *f, DbvDeleteResultSetRsp *psDeleteResultSetRsp)
{
	fprintf(f,"pulNumberNotDeleted: ");
	if (psDeleteResultSetRsp->pulNumberNotDeleted != NULL) 
		fprintf(f,"%lu\n", *psDeleteResultSetRsp->pulNumberNotDeleted); 
	else
		fprintf(f,"NULL\n");
}



int print_delete_resp_bulkstat(FILE *f, DbvDeleteResultSetRsp *psDeleteResultSetRsp)
{
	int index = 0;

	fprintf(f,"ppsBulkStatuses: ");
	if (psDeleteResultSetRsp->ppsBulkStatuses != NULL) {
		fprintf(f,"\n");

		while( psDeleteResultSetRsp->ppsBulkStatuses[index] != NULL) {
			print_liststat(f, psDeleteResultSetRsp->ppsBulkStatuses[index]);
			index++;
		}
		fprintf(f,"\n");
		
	} else
		fprintf(f,"NULL\n");
}



int print_delete_resp_delmess(FILE *f, DbvDeleteResultSetRsp *psDeleteResultSetRsp)
{
	fprintf(f,"psDeleteMessage: ");
	print_inter_string(f, psDeleteResultSetRsp->psDeleteMessage);
}



int print_delete_resp_otherinfo(FILE *f, DbvDeleteResultSetRsp *psDeleteResultSetRsp)
{
        fprintf(f,"ppsOtherInformation: ");
        print_otherinfo(f, psDeleteResultSetRsp->ppsOtherInformation);

}



/***************************************************************/ 
/* ResourceReportResponse */


int print_resreprsp_fields(FILE *f, DbvResourceReportRsp *psResourceReportRsp)
{
        fprintf(f,"ResourceReportResponse PDU\n");
 
        print_resrep_resp_refid(f, psResourceReportRsp);
        print_resrep_resp_repstat(f, psResourceReportRsp);
        print_resrep_resp_resrep(f, psResourceReportRsp);
        print_resrep_resp_otherinfo(f, psResourceReportRsp);
}



int print_resrep_resp_refid(FILE *f, DbvResourceReportRsp *psResourceReportRsp)
{
        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psResourceReportRsp->psReferenceId);
}



int print_resrep_resp_repstat(FILE *f, DbvResourceReportRsp *psResourceReportRsp)
{
	fprintf(f,"eResourceReportStatus: ");
	switch( psResourceReportRsp->eResourceReportStatus) {
	case RRS_Success:
		fprintf(f,"RRS_Success\n");
		break;
	case RRS_Partial:
		fprintf(f,"RRS_Partial\n");
		break;
	
		fprintf(f,"RRS_Failure_1\n");
		break;
	case RRS_Failure_2:
		fprintf(f,"RRS_Failure_2\n");
		break;
	case RRS_Failure_3:
		fprintf(f,"RRS_Failure_3\n");
		break;
	case RRS_Failure_4:
		fprintf(f,"RRS_Failure_4\n");
		break;
	case RRS_Failure_5:
		fprintf(f,"RRS_Failure_5\n");
		break;
	case RRS_Failure_6:
		fprintf(f,"RRS_Failure_6\n");
		break;
	case RRS_Invalid:
		fprintf(f,"RRS_Invalid\n");
		break;
	}
}



int print_resrep_resp_resrep(FILE *f, DbvResourceReportRsp *psResourceReportRsp)
{
	fprintf(f,"psResourceReport: ");
	print_external(f, psResourceReportRsp->psResourceReport);
}



int print_resrep_resp_otherinfo(FILE *f, DbvResourceReportRsp *psResourceReportRsp)
{
        fprintf(f,"ppsOtherInformation: ");
        print_otherinfo(f, psResourceReportRsp->ppsOtherInformation);

}



/***************************************************************/ 
/* ScanResponse */


int print_scanrsp_fields(FILE *f, DbvScanRsp *psScanRsp)
{
        fprintf(f,"ScanResponse PDU\n");
 
        print_scan_resp_refid(f, psScanRsp);
        print_scan_resp_stepsz(f, psScanRsp);
        print_scan_resp_scanstat(f, psScanRsp);
        print_scan_resp_nument(f, psScanRsp);
        print_scan_resp_posterm(f, psScanRsp);
        print_scan_resp_entries(f, psScanRsp);
        print_scan_resp_attsetid(f, psScanRsp);
        print_scan_resp_otherinfo(f, psScanRsp);
}



int print_scan_resp_refid(FILE *f, DbvScanRsp *psScanRsp)
{
        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psScanRsp->psReferenceId);
}
 
 
int print_scan_resp_stepsz(FILE *f, DbvScanRsp *psScanRsp)
{
	fprintf(f,"pulStepSize: ");
	if (psScanRsp->pulStepSize != NULL)
		fprintf(f,"%lu\n", *psScanRsp->pulStepSize);
	else
		fprintf(f,"NULL\n");
}



int print_scan_resp_scanstat(FILE *f, DbvScanRsp *psScanRsp)
{
	/* Compulsory */
	fprintf(f,"eScanStatus: ");
	switch( psScanRsp->eScanStatus) {
	case SCS_Success:
		fprintf(f,"SCS_Success\n");
		break;
	case SCS_Partial_1:
		fprintf(f,"SCS_Partial_1\n");
		break;
	case SCS_Partial_2:
		fprintf(f,"SCS_Partial_2\n");
		break;
	case SCS_Partial_3:
		fprintf(f,"SCS_Partial_3\n");
		break;
	case SCS_Partial_4:
		fprintf(f,"SCS_Partial_4\n");
		break;
	case SCS_Partial_5:
		fprintf(f,"SCS_Partial_5\n");
		break;
	case SCS_Failure:
		fprintf(f,"SCS_Failure\n");
		break;
	case SCS_Invalid:
		fprintf(f,"SCS_Invalid\n");
		break;
	}
}



int print_scan_resp_nument(FILE *f, DbvScanRsp *psScanRsp)
{
	fprintf(f,"ulNumberOfEntriesReturned: ");
	fprintf(f,"%lu\n", psScanRsp->ulNumberOfEntriesReturned);
}



int print_scan_resp_posterm(FILE *f, DbvScanRsp *psScanRsp)
{
	fprintf(f,"pulPositionOfTerm: ");
	if (psScanRsp->pulPositionOfTerm != NULL)
		fprintf(f,"%lu\n", *psScanRsp->pulPositionOfTerm);
	else
		fprintf(f,"NULL\n");
}



int print_scan_resp_entries(FILE *f, DbvScanRsp *psScanRsp)
{
	fprintf(f,"psEntries: ");
	if (psScanRsp->psEntries != NULL) 
		print_listentries(f, psScanRsp->psEntries);
	else
		fprintf(f,"NULL\n");
}



int print_listentries(FILE *f, DbvListEntries *psEntries)
{
	fprintf(f,"\n");

	fprintf(f,"ppsEntry: ");
	if (psEntries->ppsEntry != NULL) 
		print_entry_list(f, psEntries->ppsEntry);
	else
		fprintf(f,"NULL\n");


	fprintf(f,"ppsNonSurrogateDiagnostics: ");
	if (psEntries->ppsNonSurrogateDiagnostics != NULL) 
		print_diagrec_list(f, psEntries->ppsNonSurrogateDiagnostics);
	else
		fprintf(f,"NULL\n");
}



int print_entry_list(FILE *f, DbvEntry **ppsEntry)
{
	int index = 0;

	if (ppsEntry != NULL) {
		while( ppsEntry[index] != NULL) {
			switch( ppsEntry[index]->eEntryType) {
			case ET_TermInfo:
				fprintf(f,"ET_TermInfo:\n");
				print_terminfo(f, ppsEntry[index]->uEntry.psTermInfo);
				break;
			case ET_SurrogateDiagnostic:
				fprintf(f,"ET_SurrogateDiagnostic:\n");
				print_diag_rec(f, ppsEntry[index]->uEntry.psSurrogateDiagnostic);
				break;
			}
			index++;
		}
	}
	fprintf(f,"\n");
}



int print_terminfo(FILE *f, DbvTermInfo *psTermInfo)
{
	/* Term is compulsory */
	fprintf(f,"sTerm: ");
	print_att_term(f, psTermInfo->sTerm);

	fprintf(f,"psDisplayTerm: ");
	if (psTermInfo->psDisplayTerm != NULL)
		print_inter_string(f, psTermInfo->psDisplayTerm);
	else
		fprintf(f,"NULL\n");

	fprintf(f,"ppsSuggestedAttribute: ");
	if (psTermInfo->ppsSuggestedAttribute != NULL)
		print_attelmnt_list(f, psTermInfo->ppsSuggestedAttribute);
	else 
		fprintf(f,"NULL\n");
	

	fprintf(f,"\nppsAlternativeTerm: ");
	if (psTermInfo->ppsAlternativeTerm != NULL)
		print_attsplusterm_list(f, psTermInfo->ppsAlternativeTerm);
	else
		fprintf(f,"NULL\n");

	fprintf(f,"pulGlobalOccurrences: ");
	if (psTermInfo->pulGlobalOccurrences != NULL)
		fprintf(f,"%lu\n", *psTermInfo->pulGlobalOccurrences);
	else
		fprintf(f,"NULL\n");


	fprintf(f,"ppsByAttributes: ");
	if (psTermInfo->ppsByAttributes != NULL)
		print_occurrbyatt_list(f, psTermInfo->ppsByAttributes);
	else
		fprintf(f,"NULL\n");


	fprintf(f,"ppsOtherInformation: ");
	if (psTermInfo->ppsOtherInformation != NULL)
		print_otherinfo(f, psTermInfo->ppsOtherInformation);
	else
		fprintf(f,"NULL\n");

}



int print_attsplusterm_list(FILE *f, DbvAttributesPlusTerm **ppsAlternativeTerm)
{
	int index = 0;

	if (ppsAlternativeTerm != NULL) {
		while( ppsAlternativeTerm[index] != NULL) {
			print_attsplusterm(f, ppsAlternativeTerm[index]);
			index++;
		}
	}
	fprintf(f,"\n");
}



int print_occurrbyatt_list(FILE *f, DbvOccurrenceByAttributes **ppsByAttributes)
{
	int index = 0;

	if (ppsByAttributes != NULL) {
		while( ppsByAttributes[index] != NULL) {
			print_occurrbyatt(f, ppsByAttributes[index]);
			index++;
		}
	}
	fprintf(f,"\n");
}




int print_occurrbyatt(FILE *f, DbvOccurrenceByAttributes *psByAttributes)
{
	/* ppsAttributeElement is compulsory */
	fprintf(f,"\nppsAttributeElement: ");
	print_attelmnt_list(f, psByAttributes->ppsAttributeElement);

	fprintf(f,"\npsOccurrence: ");
	if (psByAttributes->psOccurrence != NULL)
		print_occurrence(f, psByAttributes->psOccurrence);
	else
		fprintf(f,"NULL\n");


	fprintf(f,"ppsOtherInformation: ");
	if (psByAttributes->ppsOtherInformation != NULL)
		print_otherinfo(f, psByAttributes->ppsOtherInformation);
	else
		fprintf(f,"NULL\n");
}



int print_occurrence(FILE *f, DbvOccurrence *psOccurrence)
{
	switch( psOccurrence->eOccurrenceType) {
	case OT_Global:
		fprintf(f,"OT_Global: ");
		fprintf(f,"%lu\n", psOccurrence->uOccurence.ulGlobal);
		break;
	case OT_ByDatabase:
		fprintf(f,"OT_ByDatabase:\n");
		print_occurbydb_list(f, psOccurrence->uOccurence.ppsOccurrenceByDb);
		break;
	}
}



int print_occurbydb_list(FILE *f, DbvOccurrenceByDb **ppsOccurrenceByDb)
{
	int index = 0;

	if (ppsOccurrenceByDb != NULL) {
		while( ppsOccurrenceByDb[index] != NULL) {
			print_occurbydb(f, ppsOccurrenceByDb[index]);
			index++;
		}
	}
	fprintf(f,"\n");
}


int print_occurbydb(FILE *f, DbvOccurrenceByDb *psOccurrenceByDb)
{
	/* sDatabaseName is compulsory */
	fprintf(f,"sDatabaseName:");
	print_inter_string(f, &psOccurrenceByDb->sDatabaseName);

	fprintf(f,"pulNumber: ");
	if (psOccurrenceByDb->pulNumber != NULL)
		fprintf(f,"%lu\n", *psOccurrenceByDb->pulNumber);
	else
		fprintf(f,"NULL\n");


	fprintf(f,"ppsOtherInformation: ");
	if (psOccurrenceByDb->ppsOtherInformation != NULL)
		print_otherinfo(f, psOccurrenceByDb->ppsOtherInformation);
	else
		fprintf(f,"NULL\n");
}



int print_scan_resp_attsetid(FILE *f, DbvScanRsp *psScanRsp)
{
	fprintf(f,"pcAttributeSetId: ");
	if (psScanRsp->pcAttributeSetId != NULL)
		fprintf(f,"%s\n", psScanRsp->pcAttributeSetId);
	else
		fprintf(f,"NULL\n");
}




int print_scan_resp_otherinfo(FILE *f, DbvScanRsp *psScanRsp)
{
        fprintf(f,"ppsOtherInformation: ");
        print_otherinfo(f, psScanRsp->ppsOtherInformation);
 
}



/***************************************************************/ 
/* SortResponse */


int print_sortrsp_fields(FILE *f, DbvSortRsp *psSortRsp)
{
        fprintf(f,"SortResponse PDU\n");
 
        print_sort_resp_refid(f, psSortRsp);
        print_sort_resp_status(f, psSortRsp);
        print_sort_resp_ressetstat(f, psSortRsp);
        print_sort_resp_diags(f, psSortRsp);
        print_sort_resp_otherinfo(f, psSortRsp);
}



int print_sort_resp_refid(FILE *f, DbvSortRsp *psSortRsp)
{
        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psSortRsp->psReferenceId);
}
 

 
int print_sort_resp_status(FILE *f, DbvSortRsp *psSortRsp)
{
	fprintf(f,"eSortStatus: ");
	switch( psSortRsp->eSortStatus) {
	case SOS_Success:
		fprintf(f,"SOS_Success\n");
		break;
	case SOS_Partial_1:
		fprintf(f,"SOS_Success\n");
		break;
	case SOS_Failure:
		fprintf(f,"SOS_Success\n");
		break;
	case SOS_Invalid:
		fprintf(f,"SOS_Invalid\n");
		break;
	}
	
}



int print_sort_resp_ressetstat(FILE *f, DbvSortRsp *psSortRsp)
{
	fprintf(f,"peResultSetStatus: ");
	if (psSortRsp->peResultSetStatus != NULL) {
		switch (*psSortRsp->peResultSetStatus) {
		case SRSS_Empty:
			fprintf(f,"SRSS_Empty\n");
			break;
		case SRSS_Interim:
			fprintf(f,"SRSS_Interim\n");
			break;
		case SRSS_Unchanged:
			fprintf(f,"SRSS_Unchanged\n");
			break;
		case SRSS_None:
			fprintf(f,"SRSS_None\n");
			break;
		case SRSS_Invalid:
			fprintf(f,"SRSS_Invalid\n");
			break;
		}
	} else
		fprintf(f,"NULL\n");
}



int print_sort_resp_diags(FILE *f, DbvSortRsp *psSortRsp)
{
	fprintf(f,"ppsDiagnostics: ");

	if (psSortRsp->ppsDiagnostics != NULL) 
		print_diagrec_list(f, psSortRsp->ppsDiagnostics);
	else
		fprintf(f,"NULL\n");
}



int print_sort_resp_otherinfo(FILE *f, DbvSortRsp *psSortRsp)
{
        fprintf(f,"ppsOtherInformation: ");
        print_otherinfo(f, psSortRsp->ppsOtherInformation);
 
}
 


/***************************************************************/ 
/* ExtendedServicesResponse */

 
int print_extendrsp_fields(FILE *f, DbvExtendedServicesRsp *psExtendedServicesRsp)
{
        fprintf(f,"ExtendServicesResponse PDU\n");

        print_extend_resp_refid(f, psExtendedServicesRsp);
        print_extend_resp_opstat(f, psExtendedServicesRsp);
        print_extend_resp_diags(f, psExtendedServicesRsp);
        print_extend_resp_taskpack(f, psExtendedServicesRsp);
        print_extend_resp_otherinfo(f, psExtendedServicesRsp);
}



int print_extend_resp_refid(FILE *f, DbvExtendedServicesRsp *psExtendedServicesRsp)
{
        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psExtendedServicesRsp->psReferenceId);
}
 
 
int print_extend_resp_opstat(FILE *f, DbvExtendedServicesRsp *psExtendedServicesRsp)
{
	fprintf(f,"eOperationStatus: ");
	switch( psExtendedServicesRsp->eOperationStatus) {
	case ESOS_Done:
		fprintf(f,"ESOS_Done\n");
		break;
	case ESOS_Queued:
		fprintf(f,"ESOS_Queued\n");
		break;
	case ESOS_Failure:
		fprintf(f,"ESOS_Failure\n");
		break;
	case ESOS_Invalid:
		fprintf(f,"ESOS_Invalid\n");
		break;
	}
}



int print_extend_resp_diags(FILE *f, DbvExtendedServicesRsp *psExtendedServicesRsp)
{
	fprintf(f,"ppsDiagnostics: ");
	if (psExtendedServicesRsp->ppsDiagnostics != NULL)
		print_diagrec_list(f, psExtendedServicesRsp->ppsDiagnostics);
	else
		fprintf(f,"NULL\n");
}



int print_extend_resp_taskpack(FILE *f, DbvExtendedServicesRsp *psExtendedServicesRsp)
{
	fprintf(f,"psTaskPackage: ");
	print_external(f, psExtendedServicesRsp->psTaskPackage);
}


 
int print_extend_resp_otherinfo(FILE *f, DbvExtendedServicesRsp *psExtendedServicesRsp)
{
        fprintf(f,"ppsOtherInformation: ");
        print_otherinfo(f, psExtendedServicesRsp->ppsOtherInformation)
;
 
}
 



/***************************************************************/ 
/* Close (CloseRequest/CloseResponse) */


int print_closereq_fields(FILE *f, DbvCloseReq  *psCloseReq)
{
        fprintf(f,"Close PDU\n");
 
        print_close_request_refid(f, psCloseReq);
        print_close_request_reason(f, psCloseReq);
        print_close_request_diaginfo(f, psCloseReq);
        print_close_request_resrepfmt(f, psCloseReq);
        print_close_request_resrep(f, psCloseReq);
        print_close_request_otherinfo(f, psCloseReq);
 
}



int print_close_request_refid(FILE *f, DbvCloseReq *psCloseReq)
{
        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psCloseReq->psReferenceId);
}
 


int print_close_request_reason(FILE *f, DbvCloseReq *psCloseReq)
{
	fprintf(f,"eCloseReason: ");
	switch( psCloseReq->eCloseReason) {
	case CR_Finished:
		fprintf(f,"CR_Finished\n");
		break;
	case CR_ShutDown:
		fprintf(f,"CR_ShutDown\n");
		break;
	case CR_SystemProblem:
		fprintf(f,"CR_SystemProblem\n");
		break;
	case CR_CostLimit:
		fprintf(f,"CR_CostLimit\n");
		break;
	case CR_Resources:
		fprintf(f,"CR_Resources\n");
		break;
	case CR_SecurityViolation:
		fprintf(f,"CR_SecurityViolation\n");
		break;
	case CR_ProtocolError:
		fprintf(f,"CR_ProtocolError\n");
		break;
	case CR_LackOfActivity:
		fprintf(f,"CR_LackOfActivity\n");
		break;
	case CR_PeerAbort:
		fprintf(f,"CR_PeerAbort\n");
		break;
	case CR_Unspecified:
		fprintf(f,"CR_Unspecified\n");
		break;
	case CR_Invalid:
		fprintf(f,"CR_Invalid\n");
		break;
	}
}



int print_close_request_diaginfo(FILE *f, DbvCloseReq *psCloseReq)
{
	fprintf(f,"psDiagnosticInformation: ");
	print_inter_string(f, psCloseReq->psDiagnosticInformation);
}



int print_close_request_resrepfmt(FILE *f, DbvCloseReq *psCloseReq)
{
	fprintf(f,"pcResourceReportFormat: ");

	if (psCloseReq->pcResourceReportFormat != NULL) 
		fprintf(f,"%s\n", psCloseReq->pcResourceReportFormat);
	else
		fprintf(f,"NULL\n");
}



int print_close_request_resrep(FILE *f, DbvCloseReq *psCloseReq)
{
	fprintf(f,"psResourceReport: ");
	print_external(f, psCloseReq->psResourceReport);
}



int print_close_request_otherinfo(FILE *f, DbvCloseReq *psCloseReq)
{
        fprintf(f,"ppsOtherInformation: ");
        print_otherinfo(f, psCloseReq->ppsOtherInformation);
 
}
 
 

/***************************************************************/ 
/* InitializeRequest */
 

int print_initreq_fields(FILE *f, DbvInitializeReq *psInitializeReq)
{
        fprintf(f,"InitRequest PDU\n");
 
	print_init_request_refid(f, psInitializeReq);
	print_init_request_prover(f, psInitializeReq);
	print_init_request_options(f, psInitializeReq);
	print_init_request_prefmess(f, psInitializeReq);
	print_init_request_maxmess(f, psInitializeReq);
	print_init_request_idauth(f, psInitializeReq);
	print_init_request_impid(f, psInitializeReq);
	print_init_request_impname(f, psInitializeReq);
	print_init_request_impver(f, psInitializeReq);
	print_init_request_userinfo(f, psInitializeReq);
	print_init_request_otherinfo(f, psInitializeReq);
}



int print_init_request_refid(FILE *f, DbvInitializeReq *psInitializeReq)
{

        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psInitializeReq->psReferenceId); 
}



int print_init_request_prover(FILE *f, DbvInitializeReq *psInitializeReq)
{
 
        fprintf(f,"pcProtocolVersion: %s\n", psInitializeReq->pcProtocolVersion);
}



int print_init_request_options(FILE *f, DbvInitializeReq *psInitializeReq)
{
        fprintf(f,"pcOptions: %s\n", psInitializeReq->pcOptions);
}



int print_init_request_prefmess(FILE *f, DbvInitializeReq *psInitializeReq)
{
        fprintf(f,"ulPreferredMessageSize: %ld\n", psInitializeReq->ulPreferredMessageSize);
}


int print_init_request_maxmess(FILE *f, DbvInitializeReq *psInitializeReq)
{
        fprintf(f,"ulMaxmiumMessageSize: %ld\n", psInitializeReq->ulMaximumMessageSize);
}


int print_init_request_idauth(FILE *f, DbvInitializeReq *psInitializeReq)
{

	/* Id Authentication */
	fprintf(f,"psAuthentication: ");
	if (psInitializeReq->psAuthentication != NULL) {
		switch( psInitializeReq->psAuthentication->eAuthenticationType)
		{
		case AT_Open:
			print_initreq_idauth_open(f, psInitializeReq);
			break;
		case AT_Anonymous:
			fprintf(f,"Anonymous\n");
			break;
		case AT_IdPassword:
			print_initreq_idauth_pass(f, psInitializeReq);
			break;
		case AT_Other:
			print_initreq_idauth_other(f, psInitializeReq);
			break;
		default:
			fprintf(f,"Unknown id auth\n");
			break;
		}
	} else {
		fprintf(f,"NULL\n");
	}
}



int print_initreq_idauth_open(FILE *f, DbvInitializeReq *psInitializeReq)
{
	fprintf(f,"Open\n");
	fprintf(f,"\tpsOpen: %s\n", psInitializeReq->psAuthentication->uAuthentication.psOpen);
}



int print_initreq_idauth_pass(FILE *f, DbvInitializeReq *psInitializeReq)
{

	fprintf(f,"IdPassword\n");

	/* Group id */
	fprintf(f,"\tpsGroupId: ");
	if (psInitializeReq->psAuthentication->uAuthentication.psIdPassword->psGroupId != NULL)
		print_inter_string(f, psInitializeReq->psAuthentication->uAuthentication.psIdPassword->psGroupId);
	else
		fprintf(f,"NULL\n");
	

	/* user id  */
	fprintf(f,"\tpsUserId: ");
	if (psInitializeReq->psAuthentication->uAuthentication.psIdPassword->psUserId != NULL)
		print_inter_string(f, psInitializeReq->psAuthentication->uAuthentication.psIdPassword->psUserId);
	else
		fprintf(f,"NULL\n");


	/* password */
	fprintf(f,"\tpsPassword: ");
	if (psInitializeReq->psAuthentication->uAuthentication.psIdPassword->psPassword != NULL)
		print_inter_string(f, psInitializeReq->psAuthentication->uAuthentication.psIdPassword->psPassword);
	else
		fprintf(f,"NULL\n");
}





int print_initreq_idauth_other(FILE *f, DbvInitializeReq *psInitializeReq)
{
	/* Dont need a \n at the end of the folllowing because a \n
	   is output by print_external */
	fprintf(f,"psOther");
	print_external(f, psInitializeReq->psAuthentication->uAuthentication.psOther);
}



int print_init_request_impid(FILE *f, DbvInitializeReq *psInitializeReq)
{
	fprintf(f,"psImplementationId: ");
        print_inter_string(f, psInitializeReq->psImplementationId);
}



int print_init_request_impname(FILE *f, DbvInitializeReq *psInitializeReq)
{
	fprintf(f,"psImplementationName: ");
        print_inter_string(f, psInitializeReq->psImplementationName);
}



int print_init_request_impver(FILE *f, DbvInitializeReq *psInitializeReq)
{
	fprintf(f,"psImplementationVersion: ");
        print_inter_string(f, psInitializeReq->psImplementationVersion);

}
 
 

int print_init_request_userinfo(FILE *f, DbvInitializeReq *psInitializeReq)
{
	fprintf(f,"psUserInformationField: ");
	print_external(f, psInitializeReq->psUserInformationField);

}
 


int print_init_request_otherinfo(FILE *f, DbvInitializeReq *psInitializeReq)
{

	fprintf(f,"ppsOtherInformation: ");
	print_otherinfo(f, psInitializeReq->ppsOtherInformation);
}



/***************************************************************/ 
/* SearchRequest */


int print_searchreq_fields(FILE *f, DbvSearchReq *psSearchReq)
{
	int index = 0;

        fprintf(f,"SearchRequest PDU\n");

	fprintf(f,"psReferenceId: ");
	print_octet_string(f, psSearchReq->psReferenceId);
	fprintf(f,"ulSmallSetUpperBound: %d\n",psSearchReq->ulSmallSetUpperBound);

	fprintf(f,"ulLargeSetLowerBound: %d\n",psSearchReq->ulLargeSetLowerBound);

	fprintf(f,"ulMediumSetPresentNumber: %d\n",psSearchReq->ulMediumSetPresentNumber);

	fprintf(f,"fReplaceIndicator: ");
	print_bool(f, &psSearchReq->fReplaceIndicator);

	fprintf(f,"sResultSetName: ");
	print_inter_string(f, &psSearchReq->sResultSetName);

	fprintf(f,"ppsDatabaseNames:\n");

	if (psSearchReq->ppsDatabaseNames != NULL) {
		while( psSearchReq->ppsDatabaseNames[index] != NULL) {
			fprintf(f,"\t");
			print_inter_string(f, psSearchReq->ppsDatabaseNames[index]);
			index++;
		}
	}

	fprintf(f,"\n");

	fprintf(f,"psSmallSetElementNames:");
	print_DbvElementSetNames(f, psSearchReq->psSmallSetElementNames);

	fprintf(f,"psMediumSetElementNames:");
	print_DbvElementSetNames(f, psSearchReq->psMediumSetElementNames);

	fprintf(f,"pcPreferredRecordSyntax: ");
	if (psSearchReq->pcPreferredRecordSyntax == NULL)
		fprintf(f,"NULL\n");
	else
		fprintf(f,"%s\n",psSearchReq->pcPreferredRecordSyntax);

	fprintf(f,"psQuery: ");
	print_DbvQuery(f, psSearchReq->psQuery);

	fprintf(f,"ppsAdditionalSearchInfo: ");
	print_otherinfo(f, psSearchReq->ppsAdditionalSearchInfo);

	fprintf(f,"ppsOtherInformation: ");
	print_otherinfo(f, psSearchReq->ppsOtherInformation);

}



int	print_DbvQuery(FILE *f, DbvQuery *psQuery)
{
	if (psQuery != NULL)
	{
		fprintf(f,"\n\teQueryType: ");
		switch( psQuery->eQueryType)
		{
		case QT_Private:
			fprintf(f,"QT_Private\n");
			fprintf(f,"\tpsPrivateQuery: ");
			print_octet_string(f, psQuery->uQuery.psPrivateQuery);
			break;
		case QT_Rpn:
			fprintf(f,"QT_Rpn\n");
			print_rpnquery(f, psQuery->uQuery.psRpnQuery);
			break;
		case QT_Iso8777:
			fprintf(f,"QT_Iso8777\n");
			fprintf(f,"\tpsIso8777Query: ");
			print_octet_string(f, psQuery->uQuery.psIso8777Query);
			break;
		case QT_Z3958:
			fprintf(f,"QT_Z3958\n");
			fprintf(f,"\tpsZ3958Query: ");
			print_octet_string(f, psQuery->uQuery.psZ3958Query);
			break;
		case QT_Erpn:
			fprintf(f,"QT_Erpn\n");
			print_rpnquery(f, psQuery->uQuery.psErpnQuery);
			break;
		case QT_NaturalLanguage:
			fprintf(f,"QT_NaturalLanguage\n");
			fprintf(f,"\tpsNaturalLanguageQuery: ");
			print_octet_string(f, psQuery->uQuery.psNaturalLanguageQuery);
			break;
		}
		fprintf(f,"\n");
	}
	else
		fprintf(f,"NULL\n");
}



int print_rpnquery(FILE *f, DbvRPNQuery *psRpnQuery)
{
	fprintf(f,"DbvRPNQuery pcAttributeSetId: %s\n", psRpnQuery->pcAttributeSetId);
	print_rpn_structure(f, &psRpnQuery->sRpnStructure);
}



int print_rpn_structure(FILE *f, DbvRPNStructure *psDbvRPNStructure)
{
	
	switch( psDbvRPNStructure->eRpnStructureType) {
	case RST_RpnLopRopOperator:
		fprintf(f,"\nRST_RpnLopRopOperator:\n");
		print_rpnlopropoperator(f, psDbvRPNStructure->uRPNStructure.psRpnLopRopOperator);
		break;
	case RST_RpnOperand:
		fprintf(f,"\nRST_RpnOperand:\n");
		print_rpnoperand(f, psDbvRPNStructure->uRPNStructure.psRpnOperand);
		break;
	}
}




int print_rpnlopropoperator(FILE *f, DbvRPNLopRopOperator *psDbvRPNLopRopOperator)
{

	if (psDbvRPNLopRopOperator->psLeftOperand != NULL) 
		print_rpn_structure(f, psDbvRPNLopRopOperator->psLeftOperand);

	if (psDbvRPNLopRopOperator->psRightOperand != NULL) 
		print_rpn_structure(f, psDbvRPNLopRopOperator->psRightOperand);

	print_operator(f, psDbvRPNLopRopOperator->sOperator);
}



int print_operator(FILE *f, DbvOperator sOperator)
{
	fprintf(f,"sOperator: ");
	switch (sOperator.eOperatorType) {
	case OT_Or:
		fprintf(f,"OR\n");
		break;
	case OT_And:
		fprintf(f,"AND\n");
		break;
	case OT_AndNot:
		fprintf(f,"ANDNOT\n");
		break;
	case OT_Proximity:
		fprintf(f,"PROX\n");
		print_proxoperator(f, sOperator.psProximityOperator);
		break;
	default:
		fprintf(f,"Unknown\n");
		break;
	}
}



int print_proxoperator(FILE *f, DbvProximityOperator *psProximityOperator)
{
	
	fprintf(f,"pfExclusion: ");
	if (psProximityOperator->pfExclusion != NULL)
		print_bool(f, psProximityOperator->pfExclusion);
	else
		fprintf(f,"NULL\n");
		

	/* The rest of these are compulsory */
	fprintf(f,"ulDistance: %ld\n", psProximityOperator->ulDistance);

	fprintf(f,"fOrdered: ");
	print_bool(f, &psProximityOperator->fOrdered);


	fprintf(f,"eProximityRelationType: ");
	switch( psProximityOperator->eProximityRelationType) {
	case PRT_LessThan:
		fprintf(f,"PRT_LessThan\n");
		break;
	case PRT_LessThanOrEqual:
		fprintf(f,"PRT_LessThanOrEqual\n");
		break;
	case PRT_Equal:
		fprintf(f,"PRT_Equal\n");
		break;
	case PRT_GreaterThanOrEqual:
		fprintf(f,"PRT_GreaterThanOrEqual\n");
		break;
	case PRT_GreaterThan:
		fprintf(f,"PRT_GreaterThan\n");
		break;
	case PRT_NotEqual:
		fprintf(f,"PRT_NotEqual\n");
		break;
	case PRT_Invalid:
		fprintf(f,"PRT_Invalid\n");
		break;
	}

	print_proxunitcode(f, psProximityOperator->sProximityUnitCode);
	
}



int print_proxunitcode(FILE *f, DbvProximityUnitCode sProximityUnitCode)
{

	fprintf(f,"sProximityUnitCode:\n");

	switch (sProximityUnitCode.eProximityUnitType) {
	case PUT_Known:
		fprintf(f,"eProximityUnitType: PUT_Known\n");		
		
		switch (sProximityUnitCode.uProximityUnit.eKnownProximityUnit) {
		case KPU_Character:
			fprintf(f,"eKnownProximityUnit: KPU_Character\n");
			break;
		case KPU_Word:
			fprintf(f,"eKnownProximityUnit: KPU_Word\n");
			break;
		case KPU_Sentence:
			fprintf(f,"eKnownProximityUnit: KPU_Sentence\n");
			break;
		case KPU_Paragraph:
			fprintf(f,"eKnownProximityUnit: KPU_Paragraph\n");
			break;
		case KPU_Section:
			fprintf(f,"eKnownProximityUnit: KPU_Section\n");
			break;
		case KPU_Chapter:
			fprintf(f,"eKnownProximityUnit: KPU_Chapter\n");
			break;
		case KPU_Document:
			fprintf(f,"eKnownProximityUnit: KPU_Document\n");
			break;
		case KPU_Element:
			fprintf(f,"eKnownProximityUnit: KPU_Element\n");
			break;
		case KPU_SubElement:
			fprintf(f,"eKnownProximityUnit: KPU_SubElement\n");
			break;
		case KPU_ElementType:
			fprintf(f,"eKnownProximityUnit: KPU_ElementType\n");
			break;
		case KPU_Byte:
			fprintf(f,"eKnownProximityUnit: KPU_Byte\n");
			break;
		case KPU_Invalid:
			fprintf(f,"eKnownProximityUnit: KPU_Invalid\n");
			break;
		}

		break;
	case PUT_Private:
		fprintf(f,"eProximityUnitType: PUT_Private\n");		
		fprintf(f,"ulPrivate: %ld\n", sProximityUnitCode.uProximityUnit.ulPrivate);
		break;
	}
}



int print_rpnoperand(FILE *f, DbvOperand *psRpnOperand)
{

	switch( psRpnOperand->eOperandType) {
	case OT_AttributePlusTerm:
		print_attsplusterm(f, psRpnOperand->uOperand.psAttributesPlusTerm);
		break;
	case OT_ResultSetId:
		fprintf(f,"psResultSetId: ");
		print_inter_string(f, psRpnOperand->uOperand.psResultSetId);
		break;
	case OT_ResultSetPlusAttributes:
		print_resplusatts(f, psRpnOperand->uOperand.psResultSetPlusAttributes);
		break;
	}	

}






int print_resplusatts(FILE *f, DbvResultSetPlusAttributes *psResultSetPlusAttributes)
{
	int index = 0;

	/* Both compulsory */
	fprintf(f,"sResultSetId: \n");
	print_inter_string(f, &psResultSetPlusAttributes->sResultSetId);
	
	/* Print all attributes */

	if (psResultSetPlusAttributes->ppsAttributeElement != NULL) {
		while( psResultSetPlusAttributes->ppsAttributeElement[index] != NULL) {

			/* print the attribute element */
			print_att_element(f, psResultSetPlusAttributes->ppsAttributeElement[index]);
			index++;
		}
	}

	fprintf(f,"\n");

}



/***************************************************************/ 
/* PresentRequest */


int print_presreq_fields(FILE *f, DbvPresentReq *psPresentReq)
{
        fprintf(f,"PresentRequest PDU\n");
 
	print_pres_request_refid(f, psPresentReq);
	print_pres_request_ressetid(f, psPresentReq);
	print_pres_request_ressetstart(f, psPresentReq);
	print_pres_request_numrecsreq(f, psPresentReq);
	print_pres_request_addranges(f, psPresentReq);
	print_pres_request_reccomp(f, psPresentReq);
	print_pres_request_prefrecsyn(f, psPresentReq);
	print_pres_request_maxsegcnt(f, psPresentReq);
	print_pres_request_maxrecsze(f, psPresentReq);
	print_pres_request_maxsegsze(f, psPresentReq);
	print_pres_request_otherinfo(f, psPresentReq);
}



int print_pres_request_refid(FILE *f, DbvPresentReq *psPresentReq)
{

        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psPresentReq->psReferenceId); 
	
}


int print_pres_request_ressetid(FILE *f, DbvPresentReq *psPresentReq)
{
        fprintf(f,"sResultSetId: ");
        print_inter_string(f, &psPresentReq->sResultSetId); 
}



int print_pres_request_ressetstart(FILE *f, DbvPresentReq *psPresentReq)
{
       fprintf(f,"ulResultSetStartPoint: %d\n",psPresentReq->ulResultSetStartPoint);
}



int print_pres_request_numrecsreq(FILE *f, DbvPresentReq *psPresentReq)
{
       fprintf(f,"ulNumberOfRecordsRequested: %d\n",psPresentReq->ulNumberOfRecordsRequested);

}



int print_pres_request_addranges(FILE *f, DbvPresentReq *psPresentReq)
{
	/* o */
	printN_DbvRange(f, "ppsAdditionalRanges", psPresentReq->ppsAdditionalRanges);
}



/* Print out the record composition */
int print_pres_request_reccomp(FILE *f, DbvPresentReq *psPresentReq)
{
	/* o */
	print_DbvRecordComposition(f, psPresentReq->psRecordComposition);
}



int print_pres_request_prefrecsyn(FILE *f, DbvPresentReq *psPresentReq)
{
	fprintf(f,"pcPreferredRecordSyntax: ");
	if (psPresentReq->pcPreferredRecordSyntax != NULL)
		fprintf(f,"%s\n",psPresentReq->pcPreferredRecordSyntax);
	else
		fprintf(f,"NULL\n");

}



int print_pres_request_maxsegcnt(FILE *f, DbvPresentReq *psPresentReq)
{
	fprintf(f,"pulMaxSegmentCount: ");
	if (psPresentReq->pulMaxSegmentCount != NULL)
		fprintf(f,"%d\n", *psPresentReq->pulMaxSegmentCount);
	else
		fprintf(f,"NULL\n");

}



int print_pres_request_maxrecsze(FILE *f, DbvPresentReq *psPresentReq)
{
	fprintf(f,"pulMaxRecordSize: ");
	if (psPresentReq->pulMaxRecordSize != NULL)
		fprintf(f,"%d\n", *psPresentReq->pulMaxRecordSize);
	else
		fprintf(f,"NULL\n");

}



int print_pres_request_maxsegsze(FILE *f, DbvPresentReq *psPresentReq)
{

	fprintf(f,"pulMaxSegmentSize: ");
	if (psPresentReq->pulMaxSegmentSize != NULL)
		fprintf(f,"%d\n", *psPresentReq->pulMaxSegmentSize);
	else
		fprintf(f,"NULL\n");

}


int print_pres_request_otherinfo(FILE *f, DbvPresentReq *psPresentReq)
{

	fprintf(f,"ppsOtherInformation: ");
	print_otherinfo(f, psPresentReq->ppsOtherInformation);
}



/***************************************************************/ 
/* DeleteResultSetRequest */
	
	
int print_delreq_fields(FILE *f, DbvDeleteResultSetReq *psDeleteResultSetReq)
{
        fprintf(f,"DeleteResultSetRequest PDU\n");
 
        print_delete_request_refid(f, psDeleteResultSetReq);
        print_delete_request_delfunc(f, psDeleteResultSetReq);
        print_delete_request_ressetid(f, psDeleteResultSetReq);
        print_delete_request_otherinfo(f, psDeleteResultSetReq);
 
}



int print_delete_request_refid(FILE *f, DbvDeleteResultSetReq *psDeleteResultSetReq)
{
	fprintf(f,"psReferenceId: ");
	print_octet_string(f, psDeleteResultSetReq->psReferenceId);
}



int print_delete_request_delfunc(FILE *f, DbvDeleteResultSetReq *psDeleteResultSetReq)
{
	fprintf(f,"eDeleteFunction: ");
	switch( psDeleteResultSetReq->eDeleteFunction) {
	case DF_List:
		fprintf(f,"DF_List\n");
		break;
	case DF_All:
		fprintf(f,"DF_All\n");
		break;
	case DF_Invalid:
		fprintf(f,"DF_Invalid\n");
		break;
	}
		
}



int print_delete_request_ressetid(FILE *f, DbvDeleteResultSetReq *psDeleteResultSetReq)
{
	int index = 0;

	fprintf(f,"ppsResultSetId: ");

	if (psDeleteResultSetReq->ppsResultSetId != NULL) {
		fprintf(f,"\n");

		while( psDeleteResultSetReq->ppsResultSetId[index] != NULL) {
			print_inter_string(f, psDeleteResultSetReq->ppsResultSetId[index]);
			index++;
		}
		fprintf(f,"\n");
	} else
		fprintf(f,"NULL\n");

}



int print_delete_request_otherinfo(FILE *f, DbvDeleteResultSetReq *psDeleteResultSetReq)
{
	fprintf(f,"ppsOtherInformation: ");
	print_otherinfo(f, psDeleteResultSetReq->ppsOtherInformation);

}


	
/***************************************************************/ 
/* ResourceReportRequest */
	
int print_resrepreq_fields(FILE *f, DbvResourceReportReq *psResourceReportReq)
{
        fprintf(f,"ResourceReportRequest PDU\n");
 
        print_resrep_request_refid(f, psResourceReportReq);
        print_resrep_request_opid(f, psResourceReportReq);
        print_resrep_request_prefrepfmt(f, psResourceReportReq);
        print_resrep_request_otherinfo(f, psResourceReportReq);
}
	
	
int print_resrep_request_refid(FILE *f, DbvResourceReportReq *psResourceReportReq)
{
        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psResourceReportReq->psReferenceId);
 
}



int print_resrep_request_opid(FILE *f, DbvResourceReportReq *psResourceReportReq)
{
        fprintf(f,"psOperationId: ");
        print_octet_string(f, psResourceReportReq->psOperationId);
 
}



int print_resrep_request_prefrepfmt(FILE *f, DbvResourceReportReq *psResourceReportReq)
{
	fprintf(f,"pcPrefResourceReportFormat: ");
	if (psResourceReportReq->pcPrefResourceReportFormat != NULL)
		fprintf(f,"%s\n", psResourceReportReq->pcPrefResourceReportFormat);
	else
		fprintf(f,"NULL\n");	
}



int print_resrep_request_otherinfo(FILE *f, DbvResourceReportReq *psResourceReportReq)
{
        fprintf(f,"ppsOtherInformation: ");
        print_otherinfo(f, psResourceReportReq->ppsOtherInformation);

}

 
/***************************************************************/ 
/* ScanRequest */

int print_scanreq_fields(FILE *f, DbvScanReq *psScanReq)
{
        fprintf(f,"ScanRequest PDU\n");
 
        print_scan_request_refid(f, psScanReq);
        print_scan_request_dbnames(f, psScanReq);
        print_scan_request_attsetid(f, psScanReq);
        print_scan_request_attplustrm(f, psScanReq);
        print_scan_request_stepsize(f, psScanReq);
        print_scan_request_numterms(f, psScanReq);
        print_scan_request_prefpos(f, psScanReq);
        print_scan_request_otherinfo(f, psScanReq);
 
}
	


int print_scan_request_refid(FILE *f, DbvScanReq *psScanReq)
{
        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psScanReq->psReferenceId);
}


int print_scan_request_dbnames(FILE *f, DbvScanReq *psScanReq)
{
	int index = 0;

	/* Compulsory */
	fprintf(f,"ppsDatabaseNames:\n");

	if (psScanReq->ppsDatabaseNames != NULL) {
        	while( psScanReq->ppsDatabaseNames[index] != NULL) {
                	print_inter_string(f, psScanReq->ppsDatabaseNames[index]);
                	index++;
        	}
	}
	fprintf(f,"\n");

}



int print_scan_request_attsetid(FILE *f, DbvScanReq *psScanReq)
{
	fprintf(f,"pcAttributeSetId: ");
	if (psScanReq->pcAttributeSetId != NULL) 
		fprintf(f,"%s\n", psScanReq->pcAttributeSetId);
	else
		fprintf(f,"NULL\n");
}



int print_scan_request_attplustrm(FILE *f, DbvScanReq *psScanReq)
{
	/* Compulsory */
	fprintf(f,"sAttributesPlusTerm:\n");
	print_attsplusterm(f, &psScanReq->sAttributesPlusTerm);
	
}



int print_scan_request_stepsize(FILE *f, DbvScanReq *psScanReq)
{
	fprintf(f,"pulStepSize: ");
	if (psScanReq->pulStepSize != NULL)
		fprintf(f,"%lu\n", *psScanReq->pulStepSize);
	else 
		fprintf(f,"NULL\n");
}



int print_scan_request_numterms(FILE *f, DbvScanReq *psScanReq)
{
	/* Compulsory */
	fprintf(f,"ulNumberOfTermsRequested: ");
	fprintf(f,"%lu\n", psScanReq->ulNumberOfTermsRequested);
}



int print_scan_request_prefpos(FILE *f, DbvScanReq *psScanReq)
{
	fprintf(f,"pulPreferredPositionInResponse: ");
	if (psScanReq->pulPreferredPositionInResponse != NULL)
		fprintf(f,"%lu\n", *psScanReq->pulPreferredPositionInResponse);
	else 
		fprintf(f,"NULL\n");
}



int print_scan_request_otherinfo(FILE *f, DbvScanReq *psScanReq)
{
        fprintf(f,"ppsOtherInformation: ");
        print_otherinfo(f, psScanReq->ppsOtherInformation);
 
}
 

	
/***************************************************************/ 
/* SortRequest */

 

int print_sortreq_fields(FILE *f, DbvSortReq *psSortReq)
{
        fprintf(f,"SortRequest PDU\n");
 
        print_sort_request_refid(f, psSortReq);
        print_sort_request_inresset(f, psSortReq);
        print_sort_request_sortedres(f, psSortReq);
        print_sort_request_sortseq(f, psSortReq);
        print_sort_request_otherinfo(f, psSortReq);
 
}


 
int print_sort_request_refid(FILE *f, DbvSortReq *psSortReq)
{
        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psSortReq->psReferenceId);
}
 
 

int print_sort_request_inresset(FILE *f, DbvSortReq *psSortReq)
{
	int index = 0;

	/* Compulsory */
	fprintf(f,"ppsInputResultSetName:\n");

	if (psSortReq->ppsInputResultSetName != NULL) {
        	while( psSortReq->ppsInputResultSetName[index] != NULL) {
			print_inter_string(f, psSortReq->ppsInputResultSetName[index]);
			index++;
		}
	}
	fprintf(f,"\n");
}



int print_sort_request_sortedres(FILE *f, DbvSortReq *psSortReq)
{
	/* Compulsory */
	fprintf(f,"sSortedResultSetName: ");
	print_inter_string(f, &psSortReq->sSortedResultSetName);
}



int print_sort_request_sortseq(FILE *f, DbvSortReq *psSortReq)
{
	int index = 0;

	/* Compulsory */
	fprintf(f,"ppsSortSequence:\n");

	if (psSortReq->ppsSortSequence != NULL) {
		while( psSortReq->ppsSortSequence[index] != NULL) {
			print_sortkeyspec(f, psSortReq->ppsSortSequence[index]);
			index++;
		}
	}
	fprintf(f,"\n");
}



int print_sortkeyspec(FILE *f, DbvSortKeySpec *psSortSequence)
{
	fprintf(f,"sSortElement: ");
	print_sortelement(f, &psSortSequence->sSortElement);
	
	fprintf(f,"\neSortRelationType: ");
	print_sortrelation(f, psSortSequence->eSortRelationType);

	fprintf(f,"eSortCaseType: ");
	print_sortcase(f, psSortSequence->eSortCaseType);

	fprintf(f,"psMVActionType: ");
	if (psSortSequence->psMVActionType != NULL)
		print_mvaction(f, psSortSequence->psMVActionType);
	else
		fprintf(f,"NULL\n");
	
}



int print_sortelement(FILE *f, DbvSortElement *psSortElement)
{
	switch( psSortElement->eSortElementType) {
	case SET_Generic:
		fprintf(f,"SET_Generic\n");
		print_sortkey(f, psSortElement->uSortElement.psGeneric);
		break;
	case SET_DbSpecific:
		fprintf(f,"SET_DbSpecific\n");
		print_dbspecific(f, psSortElement->uSortElement.ppsDatabaseSpecific);
		break;
	}
}



int print_sortkey(FILE *f, DbvSortKey *psGeneric)
{
	fprintf(f,"eSortKeyType: ");
	switch( psGeneric->eSortKeyType) {
	case SKT_SortField:
		fprintf(f,"SKT_SortField: ");
		print_inter_string(f, psGeneric->uSortElement.psSortField);
		break;
	case SKT_ElementSpec:
		fprintf(f,"SKT_ElementSpec:\n");
		print_DbvSpecification(f, "psElementSpec", psGeneric->uSortElement.psElementSpec);
		break;
	case SKT_SortAttributes:
		fprintf(f,"SKT_SortAttributes:\n");
		print_sortatts(f, psGeneric->uSortElement.psSortAttributes);
		break;
	}
}



int print_sortatts(FILE *f, DbvSortAttributes *psSortAttributes)
{
	fprintf(f,"pcAttributeSetId: %s\n", psSortAttributes->pcAttributeSetId);

	fprintf(f,"ppsAttributeElement:\n");
	print_attelmnt_list(f, psSortAttributes->ppsAttributeElement);
}



int print_dbspecific(FILE *f, DbvDbSpecificSortKey **ppsDatabaseSpecific)
{
	int index = 0;

	if (ppsDatabaseSpecific != NULL) {
		while( ppsDatabaseSpecific[index] != NULL) {
			print_specsortkey(f, ppsDatabaseSpecific[index]);
			index++;
		}
	}
	fprintf(f,"\n");
}



int print_specsortkey(FILE *f, DbvDbSpecificSortKey *psDatabaseSpecific)
{
	fprintf(f,"sDatabaseName: ");
	print_inter_string(f, &psDatabaseSpecific->sDatabaseName);

	fprintf(f,"sDbSort: ");
	print_sortkey(f, &psDatabaseSpecific->sDbSort);
}



int print_sortrelation(FILE *f, DbvSortRelationType eSortRelationType)
{
	switch (eSortRelationType) {
	case SRT_Ascending:
		fprintf(f,"SRT_Ascending\n");
		break;
	case SRT_Descending:
		fprintf(f,"SRT_Descending\n");
		break;
	case SRT_FrequencyAsc:
		fprintf(f,"SRT_FrequencyAsc\n");
		break;
	case SRT_FrequencyDesc:
		fprintf(f,"SRT_FrequencyDesc\n");
		break;
	case SRT_Invalid:
		fprintf(f,"SRT_Invalid\n");
		break;
	}
}



int print_sortcase(FILE *f, DbvSortCaseType eSortCaseType)
{
	switch (eSortCaseType) {
	case SCT_CaseSensitive:
		fprintf(f,"SCT_CaseSensitive\n");
		break;
	case SCT_CaseInsensitive:
		fprintf(f,"SCT_CaseInsensitive\n");
		break;
	case SCT_Invalid:
		fprintf(f,"SCT_Invalid\n");
		break;
	}
}



int print_mvaction(FILE *f, DbvSortMVAction *psMVActionType)
{
	switch( psMVActionType->eSortMVActionType) {
	case SMT_Abort:
		fprintf(f,"SMT_Abort\n");
		break;
	case SMT_Null:
		fprintf(f,"SMT_Null\n");
		break;
	case SMT_Constant:
		fprintf(f,"SMT_Constant: ");
		print_octet_string(f, psMVActionType->psOctetString);
		break;
	}
	
}



int print_sort_request_otherinfo(FILE *f, DbvSortReq *psSortReq)
{
        fprintf(f,"ppsOtherInformation: ");
        print_otherinfo(f, psSortReq->ppsOtherInformation);
 
}
 

/***************************************************************/ 
/* SegmentRequest  - sent from target to origin */
 

int print_segreq_fields(FILE *f, DbvSegmentReq *psSegmentReq)
{
        fprintf(f,"SegmentRequest PDU\n");
 
        print_segreq_refid(f, psSegmentReq);
        print_segreq_numrecs(f, psSegmentReq);
        print_segreq_segrecs(f, psSegmentReq);
        print_segreq_otherinfo(f, psSegmentReq);
}



int print_segreq_refid(FILE *f, DbvSegmentReq *psSegmentReq)
{
        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psSegmentReq->psReferenceId);
}
 
 

int print_segreq_numrecs(FILE *f, DbvSegmentReq *psSegmentReq)
{
	fprintf(f,"ulNumberOfRecordsReturned: %lu\n", psSegmentReq->ulNumberOfRecordsReturned);
}



int print_segreq_segrecs(FILE *f, DbvSegmentReq *psSegmentReq)
{
	fprintf(f,"ppsSegmentRecords:\n");
	print_nameplusrec(f, psSegmentReq->ppsSegmentRecords);
}



int print_segreq_otherinfo(FILE *f, DbvSegmentReq *psSegmentReq)
{
        fprintf(f,"ppsOtherInformation: ");
        print_otherinfo(f, psSegmentReq->ppsOtherInformation);
}
 


/***************************************************************/ 
/* ExtendedServicesRequest */


int print_extendreq_fields(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
        fprintf(f,"ExtendedServicesRequest PDU\n");
 
        print_extend_request_refid(f, psExtendedServicesReq);
        print_extend_request_function(f, psExtendedServicesReq);
        print_extend_request_packtype(f, psExtendedServicesReq);
        print_extend_request_packname(f, psExtendedServicesReq);
        print_extend_request_userid(f, psExtendedServicesReq);
        print_extend_request_rettime(f, psExtendedServicesReq);
        print_extend_request_permiss(f, psExtendedServicesReq);
        print_extend_request_descrp(f, psExtendedServicesReq);
        print_extend_request_orspec(f, psExtendedServicesReq);
        print_extend_request_waction(f, psExtendedServicesReq);
        print_extend_request_elements(f, psExtendedServicesReq);
        print_extend_request_otherinfo(f, psExtendedServicesReq);
 
}



int print_extend_request_refid(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
        fprintf(f,"psReferenceId: ");
        print_octet_string(f, psExtendedServicesReq->psReferenceId);
}
 
 

int print_extend_request_function(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
        fprintf(f,"eFunction: ");
	switch( psExtendedServicesReq->eFunction) {
	case ESF_Create:
		fprintf(f,"ESF_Create\n");
		break;
	case ESF_Delete:
		fprintf(f,"ESF_Delete\n");
		break;
	case ESF_Modify:
		fprintf(f,"ESF_Modify\n");
		break;
	case ESF_Invalid:
		fprintf(f,"ESF_Invalid\n");
		break;
	}
}



int print_extend_request_packtype(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
	fprintf(f,"pcPackageType: ");
	fprintf(f,"%s\n", psExtendedServicesReq->pcPackageType);
}



int print_extend_request_packname(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
	fprintf(f,"psPackageName: ");
	print_inter_string(f, psExtendedServicesReq->psPackageName);
}



int print_extend_request_userid(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
	fprintf(f,"psUserId: ");
	print_inter_string(f, psExtendedServicesReq->psUserId);
}



int print_extend_request_rettime(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
	fprintf(f,"psRetentionTime: ");
	if (psExtendedServicesReq->psRetentionTime != NULL) {
		fprintf(f,"\n");

		print_intunit(f, psExtendedServicesReq->psRetentionTime);
	} else
		fprintf(f,"NULL\n");
}



int print_extend_request_permiss(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
	fprintf(f,"ppsPermissions: ");
	if (psExtendedServicesReq->ppsPermissions != NULL)
		print_permissions(f, psExtendedServicesReq->ppsPermissions);
	else
		fprintf(f,"NULL\n");
}



int print_extend_request_descrp(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
	fprintf(f,"psDescription: ");
	print_inter_string(f, psExtendedServicesReq->psDescription);
}



int print_extend_request_orspec(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
	fprintf(f,"psOriginSpecificParameter: ");
	print_external(f, psExtendedServicesReq->psOriginSpecificParameter);
}



int print_extend_request_waction(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
	fprintf(f,"eWaitAction: ");
	switch( psExtendedServicesReq->eWaitAction) {
	case ESWA_Wait:
		fprintf(f,"ESWA_Wait\n");
		break;
	case ESWA_WaitIfPossible:
		fprintf(f,"ESWA_WaitIfPossible\n");
		break;
	case ESWA_DontWait:
		fprintf(f,"ESWA_DontWait\n");
		break;
	case ESWA_DontReturnPackage:
		fprintf(f,"ESWA_DontReturnPackage\n");
		break;
	case ESWA_Invalid:
		fprintf(f,"ESWA_Invalid\n");
		break;
	}
}



int print_extend_request_elements(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
	fprintf(f,"psElements: ");
	print_inter_string(f, psExtendedServicesReq->psElements);
}



int print_extend_request_otherinfo(FILE *f, DbvExtendedServicesReq *psExtendedServicesReq)
{
        fprintf(f,"ppsOtherInformation: ");
        print_otherinfo(f, psExtendedServicesReq->ppsOtherInformation);
 
}



 


/***********************************************/
/* shared printing routines */

void print_DbvASN1External(FILE *f, DbvASN1External *psASN1External)
{
	print_external(f, psASN1External);
}



int	print_external(FILE *f, DbvASN1External *external_ptr)
{
	char	*oid = NULL;
	char	temp[500];
	char	*string = NULL;
	unsigned long	length = 0;

	memset(temp, 0, sizeof(temp));


	if (external_ptr != NULL) {

		fprintf(f,"\n");

		oid = external_ptr->pcObjectIdentifier;

		/* Print the oid of the external (a char* in dbv) */
	
		if (oid != NULL)
			fprintf(f,"\tObjectIdentifier: %s\n", oid);
		else
			fprintf(f,"\tObjectIdentifier: NULL\n");

		/* Print the type of the external (eValueType) */
		print_external_evaluetype(f, external_ptr->eValueType);
	
		switch (external_ptr->eValueType) {
		case EVT_SingleASN1Type:

			if (external_ptr->uExternalValue.psSingleASN1Type != NULL) {
				print_singleasn1type_easn1type(f, external_ptr->uExternalValue.psSingleASN1Type->eASN1Type);

				print_singleasn1type_external(f, oid, external_ptr);
			}
			break;
		case EVT_OctetAligned:
			print_aligned_external(f, external_ptr);
			break;
		case EVT_Arbitrary:
			print_arbitrary_external(f, external_ptr);
		default:
			break;
		}
	} else
		fprintf(f,"NULL\n");

}


int	print_external_evaluetype(FILE *f, DbvExternalValueType eValueType)
{
	switch (eValueType) {
	case EVT_SingleASN1Type:
		fprintf(f,"\teValueType: EVT_SingleASN1Type\n");
		break;
	case EVT_OctetAligned:
		fprintf(f,"\teValueType: EVT_OctetAligned\n");
		break;
	case EVT_Arbitrary:
		fprintf(f,"\teValueType: EVT_Arbitrary\n");
		break;
	default:
		fprintf(f,"\teValueType: Unknown\n");
		break;
	}
}



int	print_singleasn1type_easn1type(FILE *f, DbvExternalValueType eASN1Type)
{
	switch (eASN1Type) {
	case AT_UnstructuredText:
		fprintf(f,"\teASN1Type: AT_UnstructuredText\n");
		break;
	case AT_OpacRecord:
		fprintf(f,"\teASN1Type: AT_OpacRecord\n");
		break;
	case AT_SummaryRecord:
		fprintf(f,"\teASN1Type: AT_SummaryRecord\n");
		break;
	case AT_ResourceReport1:
		fprintf(f,"\teASN1Type: AT_ResourceReport1\n");
		break;
	case AT_ResourceReport2:
		fprintf(f,"\teASN1Type: AT_ResourceReport2\n");
		break;
	case AT_EsTaskPackage:
		fprintf(f,"\teASN1Type: AT_EsTaskPackage\n");
		break;
	case AT_UpdateExtendedService:
		fprintf(f,"\teASN1Type: AT_UpdateExtendedService\n");
		break;

	case AT_ItemOrderExtendedService:
		fprintf(f,"\teASN1Type: AT_ItemOrderExtendedService\n");
		break;
	case AT_IllPdu:
		fprintf(f,"\teASN1Type: AT_IllPdu\n");
		break;


        case AT_ExplainRecord:
                fprintf(f,"\teASN1Type: AT_ExplainRecord\n");
                break;

        case AT_GenericRecord:
                fprintf(f,"\teASN1Type: AT_GenericRecord\n");
                break;

        case AT_PromptObject:
                fprintf(f,"\teASN1Type: AT_PromptObject\n");
                break;
	


        case AT_Print:
                fprintf(f,"\teASN1Type: AT_Print\n");
                break;
        case AT_Alert:
                fprintf(f,"\teASN1Type: AT_Alert\n");
                break;
        case AT_Corder:
                fprintf(f,"\teASN1Type: AT_Corder\n");
                break;
        case AT_CharSetAndLanguage:
                fprintf(f,"\teASN1Type: AT_CharSetAndLanguage\n");
                break;




/*****************
 No longer used

	case AT_IntMapTest:
		fprintf(f,"\teASN1Type: AT_IntMapTest\n");
		break;

*****************/


	default:
		fprintf(f,"\teASN1Type: Unknown\n");
		break;
	}
}



int print_singleasn1type_external(FILE *f, char *oid, DbvASN1External *external_ptr)
{
	/* If oid is not null (it will be null for
	   ILL intmappers after decoding) */

	if (oid != NULL) 
		print_external_with_oid(f, oid, external_ptr);

	else
		print_external_with_int(f, external_ptr);
}



void print_external_with_oid(FILE *f, char *oid, DbvASN1External *external_ptr)
{
	if ( (strcmp(oid, ANSI_UNSTRUCTURED_TEXT_RECORD) == 0)
	|| (strcmp(oid, ISO_UNSTRUCTURED_TEXT_RECORD) == 0) ) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_UnstructuredText) {
			print_sutrs_external(f, external_ptr);
			return;
		}


	}

	if ( (strcmp(oid, ANSI_OPAC_RECORD) == 0) 
       	|| (strcmp(oid, ISO_OPAC_RECORD) == 0) ) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_OpacRecord) {
		 	print_opac_external(f, external_ptr);
			return;
		}


	} 

	if ( (strcmp(oid, ANSI_SUMMARY_RECORD) == 0) 
	|| (strcmp(oid, ISO_SUMMARY_RECORD) == 0) ) {	
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_SummaryRecord) { 
			print_summary_external(f, external_ptr);
			return;
		}


	} 

	if ( (strcmp(oid, ANSI_RESOURCE_REPORT_1) == 0) 
	|| (strcmp(oid, ISO_RESOURCE_REPORT_1) == 0) )  {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_ResourceReport1) {
			print_resrep1_external(f, external_ptr);
			return;
		}

	}

	if ( (strcmp(oid, ANSI_RESOURCE_REPORT_2) == 0) 
		|| (strcmp(oid, ISO_RESOURCE_REPORT_2) == 0) ) {	
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_ResourceReport2) {
			print_resrep2_external(f, external_ptr);
			return;
		}

	}

	if ( (strcmp(oid, ANSI_ES_TASK_PACKAGE_RECORD) == 0) 
	|| (strcmp(oid, ISO_ES_TASK_PACKAGE_RECORD) == 0)) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_EsTaskPackage) {
			print_estask_external(f, external_ptr);
			return;
		}

	}

	if ( (strcmp(oid, ANSI_UPDATE_EXTENDED_SERVICE) == 0) 
	|| (strcmp(oid, ISO_UPDATE_EXTENDED_SERVICE) == 0) ) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_UpdateExtendedService) {
			print_update_external(f, external_ptr);
			return;
		}
	} 


	if ( (strcmp(oid, ANSI_ITEMORDER_EXTENDED_SERVICE) == 0) 
	|| (strcmp(oid, ISO_ITEMORDER_EXTENDED_SERVICE) == 0) ) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_ItemOrderExtendedService) {
			print_itemorder_external(f, external_ptr);
			return;
		}

	} 


	if ( (strcmp(oid, ISO_ILL_PDU) == 0) ) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_IllPdu) {
			print_ill_external(f, external_ptr);
			return;
		}
	} 



	if ( (strcmp(oid, ANSI_EXPLAIN_RECORD) == 0)
	|| (strcmp(oid, ISO_EXPLAIN_RECORD) == 0) ) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_ExplainRecord) {
			print_explain_external(f, external_ptr);
			return;
		}
	}



	if ( (strcmp(oid, ANSI_GENERIC_RECORD) == 0)
	|| (strcmp(oid, ISO_GENERIC_RECORD) == 0) ) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_GenericRecord) {
			print_generic_external(f, external_ptr);
			return;
		}
	}



	
	if ( (strcmp(oid, ANSI_ACCESS_PROMPT_1) == 0) 
	|| (strcmp(oid, ISO_ACCESS_PROMPT_1) == 0) ) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_PromptObject) {
			print_DbvPromptObject_external(f, external_ptr);
			return;
		}
	} 





	if (strcmp(oid, ESRIN_PRINT) == 0) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_Print) {
			print_DbvPrintExtendedService_external(f, external_ptr);
			return;
		}
	} 



	if (strcmp(oid, ESRIN_ALERT) == 0) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_Alert) {
			print_DbvAlertExtendedService_external(f, external_ptr);
			return;
		}
	} 



	if (strcmp(oid, ESRIN_ORDER) == 0) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_Corder) {
			print_DbvCOrder_external(f, external_ptr);
			return;
		}
	} 



	if ( (strcmp(oid, ANSI_CHARSET_AND_LANGUAGE_NEGOTIATION) == 0) 
	|| (strcmp(oid, ISO_CHARSET_AND_LANGUAGE_NEGOTIATION) == 0) ) {
		if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_CharSetAndLanguage) {
			print_DbvCharSetAndLanguage_external(f, external_ptr);
			return;
		}
	} 








	/* Any other combination */
	print_unknown_external(f, external_ptr);	
}



int print_external_with_int(FILE *f, DbvASN1External *external_ptr)
{

/********************
 No longer used

	if (external_ptr->uExternalValue.psSingleASN1Type->eASN1Type == AT_IntMapTest) {
		print_intmaptest_external(f, external_ptr);
		return;
	}

********************/


	/* Any other combination */
	print_unknown_external(f, external_ptr);	
}



int	print_sutrs_external(FILE *f, DbvASN1External *external_ptr)
{
	struct DbvInternationalString *sutrs_ptr = NULL;

	sutrs_ptr = external_ptr->uExternalValue.psSingleASN1Type->uASN1.psUnstructuredText;
	
	/* Will always be non NULL after decoding but check just in
	   case function has been called before PDU sending */
	if (sutrs_ptr != NULL) {
        	fprintf(f,"\tpsUnstructuredText: ");
		print_inter_string(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psUnstructuredText);
	}

}



int	print_opac_external(FILE *f, DbvASN1External *external_ptr)
{
	int index = 0;
	struct DbvOpacRecord *local_ptr = NULL;

	local_ptr = external_ptr->uExternalValue.psSingleASN1Type->uASN1.psOpacRecord;

	if (local_ptr != NULL) {
		fprintf(f,"psOpacRecord:\n");	

		/* If psBibliographicRecord is given */
		fprintf(f,"psBibliographicRecord: ");
		if (local_ptr->psBibliographicRecord != NULL) {

			/* It an external so print it as one */
			print_external(f, local_ptr->psBibliographicRecord);
		} else {
			fprintf(f,"NULL\n");
		}

		/* If ppsHoldingsData is given */
		fprintf(f,"ppsHoldingsData: ");
		if (local_ptr->ppsHoldingsData != NULL) {
			while (local_ptr->ppsHoldingsData[index] != NULL) {
				print_holdings_data(f, local_ptr->ppsHoldingsData[index]);
				index++;
			}
			fprintf(f,"\n");
		} else {
			fprintf(f,"NULL\n");
		}
	}

}



int print_holdings_data(FILE *f, DbvHoldingsRecord *psHoldingsData)
{
	/* HoldingsData is a choice according to V3 ballot 2 */
	switch( psHoldingsData->eHoldingsRecType) {
	case HRT_MarcHoldingsRecord:
		fprintf(f,"\nHRT_MarcHoldingsRecord\n");
		print_external(f, &psHoldingsData->uMarcOrHoldAndCirc.sMarcHoldingsRecord);
		break;
	case HRT_HoldingsAndCirc:
		fprintf(f,"\nHRT_HoldingsAndCirc\n");
		print_holdings_bulk(f, psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc);
		print_hold_volume(f, psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc);
		print_hold_circ(f, psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc);
		break;
	}

}



int print_holdings_bulk(FILE *f, DbvHoldingsAndCircData sHoldingsAndCirc)
{
	/* psTypeOfRecord */
	fprintf(f,"psTypeOfRecord: ");
	if (sHoldingsAndCirc.psTypeOfRecord != NULL)
		print_inter_string(f, sHoldingsAndCirc.psTypeOfRecord);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psEncodingLevel: ");
	if (sHoldingsAndCirc.psEncodingLevel != NULL)
		print_inter_string(f, sHoldingsAndCirc.psEncodingLevel);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psFormat: ");
	if (sHoldingsAndCirc.psFormat != NULL)
		print_inter_string(f, sHoldingsAndCirc.psFormat);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psReceiptAcqStatus: ");
	if (sHoldingsAndCirc.psReceiptAcqStatus != NULL)
		print_inter_string(f, sHoldingsAndCirc.psReceiptAcqStatus);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psGeneralRetention: ");
	if (sHoldingsAndCirc.psGeneralRetention != NULL)
		print_inter_string(f, sHoldingsAndCirc.psGeneralRetention);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psCompleteness: ");
	if (sHoldingsAndCirc.psCompleteness != NULL)
		print_inter_string(f, sHoldingsAndCirc.psCompleteness);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psDateOfReport: ");
	if (sHoldingsAndCirc.psDateOfReport != NULL)
		print_inter_string(f, sHoldingsAndCirc.psDateOfReport);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psNucCode: ");
	if (sHoldingsAndCirc.psNucCode != NULL)
		print_inter_string(f, sHoldingsAndCirc.psNucCode);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psLocalLocation: ");
	if (sHoldingsAndCirc.psLocalLocation != NULL)
		print_inter_string(f, sHoldingsAndCirc.psLocalLocation);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psShelvingLocation: ");
	if (sHoldingsAndCirc.psShelvingLocation != NULL)
		print_inter_string(f, sHoldingsAndCirc.psShelvingLocation);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psCallNumber: ");
	if (sHoldingsAndCirc.psCallNumber != NULL)
		print_inter_string(f, sHoldingsAndCirc.psCallNumber);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psShelvingData: ");
	if (sHoldingsAndCirc.psShelvingData != NULL)
		print_inter_string(f, sHoldingsAndCirc.psShelvingData);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psCopyNumber: ");
	if (sHoldingsAndCirc.psCopyNumber != NULL)
		print_inter_string(f, sHoldingsAndCirc.psCopyNumber);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psPublicNote: ");
	if (sHoldingsAndCirc.psPublicNote != NULL)
		print_inter_string(f, sHoldingsAndCirc.psPublicNote);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psReproductionNote: ");
	if (sHoldingsAndCirc.psReproductionNote != NULL)
		print_inter_string(f, sHoldingsAndCirc.psReproductionNote);
	else
		fprintf(f,"NULL\n");
		

	fprintf(f,"psTermsUseRepro: ");
	if (sHoldingsAndCirc.psTermsUseRepro != NULL)
		print_inter_string(f, sHoldingsAndCirc.psTermsUseRepro);
	else
		fprintf(f,"NULL\n");
		


}



int print_hold_volume(FILE *f, DbvHoldingsAndCircData sHoldingsAndCirc)
{
	int index = 0;

	fprintf(f,"ppsVolume: ");
	if (sHoldingsAndCirc.ppsVolume != NULL) {
		while (sHoldingsAndCirc.ppsVolume[index] != NULL) {	

			fprintf(f,"\npsEnumeration: ");
			if (sHoldingsAndCirc.ppsVolume[index]->psEnumeration != NULL) 
				print_inter_string(f, sHoldingsAndCirc.ppsVolume[index]->psEnumeration);
			else
				fprintf(f,"NULL\n");

			fprintf(f,"psChronology: ");
			if (sHoldingsAndCirc.ppsVolume[index]->psChronology != NULL) 
				print_inter_string(f, sHoldingsAndCirc.ppsVolume[index]->psChronology);
			else
				fprintf(f,"NULL\n");

			fprintf(f,"psEnumAndChron: ");
			if (sHoldingsAndCirc.ppsVolume[index]->psEnumAndChron != NULL) 
				print_inter_string(f, sHoldingsAndCirc.ppsVolume[index]->psEnumAndChron);
			else
				fprintf(f,"NULL\n");

			index++;
		}
		fprintf(f,"\n");
	} else
		fprintf(f,"NULL\n");
}



int print_hold_circ(FILE *f, DbvHoldingsAndCircData sHoldingsAndCirc)
{
	int index = 0;

	fprintf(f,"ppsCircRecord: ");
	if (sHoldingsAndCirc.ppsCircRecord != NULL) {
		while (sHoldingsAndCirc.ppsCircRecord[index] != NULL) {	

			fprintf(f,"\nfAvailableNow: ");
			print_bool(f, &sHoldingsAndCirc.ppsCircRecord[index]->fAvailableNow);
			fprintf(f,"psAvailabilityDate: ");
			if (sHoldingsAndCirc.ppsCircRecord[index]->psAvailabilityDate != NULL) 
				print_inter_string(f, sHoldingsAndCirc.ppsCircRecord[index]->psAvailabilityDate);
			else
				fprintf(f,"NULL\n");

			fprintf(f,"psAvailableThru: ");
			if (sHoldingsAndCirc.ppsCircRecord[index]->psAvailableThru != NULL) 
				print_inter_string(f, sHoldingsAndCirc.ppsCircRecord[index]->psAvailableThru);
			else
				fprintf(f,"NULL\n");

			fprintf(f,"psRestrictions: ");
			if (sHoldingsAndCirc.ppsCircRecord[index]->psRestrictions != NULL) 
				print_inter_string(f, sHoldingsAndCirc.ppsCircRecord[index]->psRestrictions);
			else
				fprintf(f,"NULL\n");


			fprintf(f,"psItemId: ");
			if (sHoldingsAndCirc.ppsCircRecord[index]->psItemId != NULL) 
				print_inter_string(f, sHoldingsAndCirc.ppsCircRecord[index]->psItemId);
			else
				fprintf(f,"NULL\n");


			fprintf(f,"fRenewable: ");
			print_bool(f, &sHoldingsAndCirc.ppsCircRecord[index]->fRenewable);

			fprintf(f,"fOnHold: ");
			print_bool(f, &sHoldingsAndCirc.ppsCircRecord[index]->fOnHold);

			fprintf(f,"psEnumAndChron: ");
			if (sHoldingsAndCirc.ppsCircRecord[index]->psEnumAndChron != NULL) 
				print_inter_string(f, sHoldingsAndCirc.ppsCircRecord[index]->psEnumAndChron);
			else
				fprintf(f,"NULL\n");

			fprintf(f,"psMidspine: ");
			if (sHoldingsAndCirc.ppsCircRecord[index]->psMidspine != NULL) 
				print_inter_string(f, sHoldingsAndCirc.ppsCircRecord[index]->psMidspine);
			else
				fprintf(f,"NULL\n");

			fprintf(f,"psTemporaryLocation: ");
			if (sHoldingsAndCirc.ppsCircRecord[index]->psTemporaryLocation != NULL) 
				print_inter_string(f, sHoldingsAndCirc.ppsCircRecord[index]->psTemporaryLocation);
			else
				fprintf(f,"NULL\n");


			index++;
		}
		fprintf(f,"\n");
	} else
		fprintf(f,"NULL\n");
}



int	print_summary_external(FILE *f, DbvASN1External *external_ptr)
{
	
	DbvSummaryRecord *summary_ptr;
	int index = 0;

	summary_ptr = external_ptr->uExternalValue.psSingleASN1Type->uASN1.psSummaryRecord;

	if (summary_ptr != NULL) {

		fprintf(f,"psSummaryRecord: \n");

		/* sTitle is compulsory */
		fprintf(f,"sTitle: ");
		print_inter_string(f, &summary_ptr->sTitle);

		/* psAuthor is optional */
		fprintf(f,"psAuthor: ");
		if (summary_ptr->psAuthor != NULL) 
			print_inter_string(f, summary_ptr->psAuthor);
		else
			fprintf(f,"NULL\n");
	

		/* psCallNumber is optional */
		fprintf(f,"psCallNumber: ");
		if (summary_ptr->psCallNumber != NULL) 
			print_inter_string(f, summary_ptr->psCallNumber);
		else
			fprintf(f,"NULL\n");
	

		/* psRecordType is optional */
		fprintf(f,"psRecordType: ");
		if (summary_ptr->psRecordType != NULL) 
			print_inter_string(f, summary_ptr->psRecordType);
		else
			fprintf(f,"NULL\n");
	

		/* psBibliographicLevel is optional */
		fprintf(f,"psBibliographicLevel: ");
		if (summary_ptr->psBibliographicLevel != NULL) 
			print_inter_string(f, summary_ptr->psBibliographicLevel);
		else
			fprintf(f,"NULL\n");

	
		/* ppsFormat is optional */
		fprintf(f,"ppsFormat: ");
		if (summary_ptr->ppsFormat != NULL) {
			while (summary_ptr->ppsFormat[index] != NULL) {	

				fprintf(f,"\nsType: ");
				print_inter_string(f, &(summary_ptr->ppsFormat[index]->sType));
				fprintf(f,"pulSize: ");
				if (summary_ptr->ppsFormat[index]->pulSize != NULL) 
					fprintf(f,"%ld\n", *(summary_ptr->ppsFormat[index]->pulSize));
				else
					fprintf(f,"NULL\n");

				fprintf(f,"pulBestPosn: ");
				if (summary_ptr->ppsFormat[index]->pulBestPosn != NULL) 
					fprintf(f,"%ld\n", *(summary_ptr->ppsFormat[index]->pulBestPosn));
				else
					fprintf(f,"NULL\n");
	
				index++;
			}
			fprintf(f,"\n");
		} else
			fprintf(f,"NULL\n");

		/* psPublicationPlace is optional */
		fprintf(f,"psPublicationPlace: ");
		if (summary_ptr->psPublicationPlace != NULL) 
			print_inter_string(f, summary_ptr->psPublicationPlace);
		else
			fprintf(f,"NULL\n");
	

		/* psPublicationDate is optional */
		fprintf(f,"psPublicationDate: ");
		if (summary_ptr->psPublicationDate != NULL) 
			print_inter_string(f, summary_ptr->psPublicationDate);
		else
			fprintf(f,"NULL\n");
	

		/* psTargetSystemKey is optional */
		fprintf(f,"psTargetSystemKey: ");
		if (summary_ptr->psTargetSystemKey != NULL) 
			print_inter_string(f, summary_ptr->psTargetSystemKey);
		else
			fprintf(f,"NULL\n");
	

		/* psSatisfyingElement is optional */
		fprintf(f,"psSatisfyingElement: ");
		if (summary_ptr->psSatisfyingElement != NULL) 
			print_inter_string(f, summary_ptr->psSatisfyingElement);
		else
			fprintf(f,"NULL\n");
	
		/* pulRank is optional */
		fprintf(f,"pulRank: ");
		if (summary_ptr->pulRank != NULL) 
			fprintf(f,"%ld\n", *summary_ptr->pulRank);
		else
			fprintf(f,"NULL\n");
	

		/* psDocumentId is optional */
		fprintf(f,"psDocumentId: ");
		if (summary_ptr->psDocumentId != NULL) 
			print_inter_string(f, summary_ptr->psDocumentId);
		else
			fprintf(f,"NULL\n");
	

		/* psAbstract is optional */
		fprintf(f,"psAbstract: ");
		if (summary_ptr->psAbstract != NULL) 
			print_inter_string(f, summary_ptr->psAbstract);
		else
			fprintf(f,"NULL\n");
	
		/* psOtherInformation is optional */
		fprintf(f,"ppsOtherInformation: ");
		print_otherinfo(f, summary_ptr->ppsOtherInformation);
	}
}



int print_resrep1_external(FILE *f, DbvASN1External *external_ptr)
{
	int index = 0;
	struct DbvResourceReport1 *local_ptr = NULL;

	local_ptr = external_ptr->uExternalValue.psSingleASN1Type->uASN1.psResourceReport1;

	if (local_ptr != NULL) {
		fprintf(f,"psResourceReport1:\n");	

		/* Print out the ppsEstimate list */

		if (local_ptr->ppsEstimate != NULL) {
			while (local_ptr->ppsEstimate[index] != NULL) {
		
				fprintf(f,"ppsEstimate[%d]->eEstimateType: ", index);
				print_estimate_type(f, local_ptr->ppsEstimate[index]->eEstimateType);

				fprintf(f,"ppsEstimate[%d]->ulValue: %lu\n", index, local_ptr->ppsEstimate[index]->ulValue);

				fprintf(f,"*ppsEstimate[%d]->pulCurrencyCode: ", index);
				if (local_ptr->ppsEstimate[index]->pulCurrencyCode != NULL) 
					fprintf(f,"%lu\n", *local_ptr->ppsEstimate[index]->pulCurrencyCode);
				else
					fprintf(f,"NULL\n");
	
				index++;
			}
		}

		fprintf(f,"\n");


		/* Print out the sMessage string */
		fprintf(f,"sMessage: ");	
		print_inter_string(f, &local_ptr->sMessage);
	}

}



int print_estimate_type(FILE *f, DbvEstimateType eEstimateType)
{
	switch (eEstimateType) {
	case ET_CurrentSearchRecords:
		fprintf(f,"ET_CurrentSearchRecords\n");
		break;
	case ET_FinalSearchRecords:
		fprintf(f,"ET_FinalSearchRecords\n");
		break;
	case ET_CurrentPresentRecords:
		fprintf(f,"ET_CurrentPresentRecords\n");
		break;
	case ET_FinalPresentRecords:
		fprintf(f,"ET_FinalPresentRecords\n");
		break;
	case ET_CurrentOpTimeProcessing:
		fprintf(f,"ET_CurrentOpTimeProcessing\n");
		break;
	case ET_FinalOpTimeProcessing:
		fprintf(f,"ET_FinalOpTimeProcessing\n");
		break;
	case ET_CurrentAssocTime:
		fprintf(f,"ET_CurrentAssocTime\n");
		break;
	case ET_CurrentOperationCost:
		fprintf(f,"ET_CurrentOperationCost\n");
		break;
	case ET_FinalOperationCost:
		fprintf(f,"ET_FinalOperationCost\n");
		break;
	case ET_CurrentAssocCost:
		fprintf(f,"ET_CurrentAssocCost\n");
		break;
	case ET_FinalOpTimeElapsed:
		fprintf(f,"ET_FinalOpTimeElapsed\n");
		break;
	case ET_PercentComplete:
		fprintf(f,"ET_PercentComplete\n");
		break;
	case ET_CurrentSearchAssocCost:
		fprintf(f,"ET_CurrentSearchAssocCost\n");
		break;
	case ET_CurrentPresentAssocCost:
		fprintf(f,"ET_CurrentPresentAssocCost\n");
		break;
	case ET_CurrentConnectAssocCost:
		fprintf(f,"ET_CurrentConnectAssocCost\n");
		break;
	case ET_CurrentOtherAssocCost:
		fprintf(f,"ET_CurrentOtherAssocCost\n");
		break;
	case ET_Invalid:
		fprintf(f,"ET_Invalid\n");
		break;
	}
}



int print_resrep2_external(FILE *f, DbvASN1External *external_ptr)
{
	int index = 0;
	struct DbvResourceReport2 *local_ptr = NULL;

	local_ptr = external_ptr->uExternalValue.psSingleASN1Type->uASN1.psResourceReport2;

	if (local_ptr != NULL) {
		fprintf(f,"psResourceReport2:\n");	


		/* Both the following are optional */

		/* Print out the ppsEstimate list */
		fprintf(f,"ppsEstimate: ");
		if (local_ptr->ppsEstimate != NULL) {

			fprintf(f,"\n");

			while (local_ptr->ppsEstimate[index] != NULL) {
		
				fprintf(f,"ppsEstimate[%d]->sType:\n", index);
				print_strornum(f, &(local_ptr->ppsEstimate[index]->sType));
				print_intunit(f, &(local_ptr->ppsEstimate[index]->sValue));
	
				index++;
			}
			fprintf(f,"\n");
		} else
			fprintf(f,"NULL\n");
	


		/* Print out the psMessage string */
		fprintf(f,"psMessage: ");	
		if (local_ptr->psMessage != NULL)
			print_inter_string(f, local_ptr->psMessage);
		else
			fprintf(f,"NULL\n");
	}
}



int print_estask_external(FILE *f, DbvASN1External *external_ptr)
{
	int index = 0;
	struct DbvEsTaskPackage *local_ptr = NULL;

	local_ptr = external_ptr->uExternalValue.psSingleASN1Type->uASN1.psEsTaskPackage;

	if (local_ptr != NULL) {
		fprintf(f,"psEsTaskPackage:\n");	
		fprintf(f,"pcPackageType: %s\n", local_ptr->pcPackageType);

		fprintf(f,"psPackageName: ");
		if (local_ptr->psPackageName != NULL)
			print_inter_string(f, local_ptr->psPackageName);
		else
			fprintf(f,"NULL\n");


		fprintf(f,"psUserId: ");
		if (local_ptr->psUserId != NULL)
			print_inter_string(f, local_ptr->psUserId);
		else
			fprintf(f,"NULL\n");


		fprintf(f,"psRetentionTime:\n");
		if (local_ptr->psRetentionTime != NULL)
			print_intunit(f, local_ptr->psRetentionTime);
		else
			fprintf(f,"NULL\n");


		fprintf(f,"ppsPermissions: ");
		if (local_ptr->ppsPermissions != NULL)
			print_permissions(f, local_ptr->ppsPermissions);
		else
			fprintf(f,"NULL\n");


		fprintf(f,"psDescription: ");
		if (local_ptr->psDescription != NULL)
			print_inter_string(f, local_ptr->psDescription);
		else
			fprintf(f,"NULL\n");


		fprintf(f,"psTargetReference: ");
		if (local_ptr->psTargetReference != NULL)
			print_octet_string(f, local_ptr->psTargetReference);
		else
			fprintf(f,"NULL\n");

		fprintf(f,"pcCreationDateTime: ");
		if (local_ptr->pcCreationDateTime != NULL)
			fprintf(f,"%s\n", local_ptr->pcCreationDateTime);
		else
			fprintf(f,"NULL\n");


		fprintf(f,"eExtServicesTaskStatus: ");
		switch (local_ptr->eExtServicesTaskStatus) {
		case ESTS_Pending:
			fprintf(f,"ESTS_Pending\n");
			break;
		case ESTS_Active:
			fprintf(f,"ESTS_Active\n");
			break;
		case ESTS_Complete:
			fprintf(f,"ESTS_Complete\n");
			break;
		case ESTS_Aborted:
			fprintf(f,"ESTS_Aborted\n");
			break;
		case ESTS_Invalid:
			fprintf(f,"ESTS_Invalid\n");
			break;
		}
	

		fprintf(f,"ppsPackageDiagnostics:\n");
		if (local_ptr->ppsPackageDiagnostics != NULL)
			print_diagrec_list(f, local_ptr->ppsPackageDiagnostics);
		else
			fprintf(f,"NULL\n");

		fprintf(f,"sTaskSpecificParameters:\n");	
		print_external(f, &local_ptr->sTaskSpecificParameters);
	}
}



int print_permissions(FILE *f, DbvPermissions **ppsPermissions)
{
	int index = 0;

	if (ppsPermissions != NULL) {
		while( ppsPermissions[index] != NULL) {
			fprintf(f,"\nuserId: ");
			print_inter_string(f, &ppsPermissions[index]->sUserId);
			print_allowfuncts(f, ppsPermissions[index]->ppeAllowableFunctions);
			index++;
		}
	}
	fprintf(f,"\n");
}



int print_allowfuncts(FILE *f, DbvPermAllowableFunctions **ppeAllowableFunctions)
{
	int index = 0;

	fprintf(f,"ppeAllowableFunctions:\n");

	if (ppeAllowableFunctions != NULL) {
		while (ppeAllowableFunctions[index] != NULL) {
			switch (*ppeAllowableFunctions[index]) {
			case PAF_Delete:
				fprintf(f,"PAF_Delete\n");
				break;
			case PAF_ModifyContents:
				fprintf(f,"PAF_ModifyContents\n");
				break;
			case PAF_ModifyPermissions:
				fprintf(f,"PAF_ModifyPermissions\n");
				break;
			case PAF_Present:
				fprintf(f,"PAF_Present\n");
				break;
			case PAF_Invoke:
				fprintf(f,"PAF_Invoke\n");
				break;
			case PAF_Invalid:
				fprintf(f,"PAF_Invalid\n");
				break;
			}
			index++;
		}
	}
	fprintf(f,"\n");

}



int print_update_external(FILE *f, DbvASN1External *external_ptr)
{
	DbvUpdateExtendedService *update_ptr;

	update_ptr = external_ptr->uExternalValue.psSingleASN1Type->uASN1.psUpdateExtendedService;

	if (update_ptr != NULL) {

		fprintf(f,"psUpdateExtendedService: \n");
		fprintf(f,"eUpdateReqRsp:\n");
		switch (update_ptr->eUpdateReqRsp) {
		case UROR_Request:
			fprintf(f,"UROR_Request\n");
			print_update_request(f, update_ptr->uUpdateReqOrRsp.psUpdateRequest);
			break;
		case UROR_Response:
			fprintf(f,"UROR_Response\n");
			print_update_response(f, update_ptr->uUpdateReqOrRsp.psUpdateResponse);
			break;
		default:
			fprintf(f,"Unknown\n");
			break;
		}
	}
}



int print_update_request(FILE *f, DbvUpdateRequestPackage *psUpdateRequest)
{
	/* Both compulsory */
	print_originparttokeep(f, &psUpdateRequest->sOriginPartToKeep);
	print_suppliedrecs(f, psUpdateRequest->ppsSuppliedRecord);
	
}



int print_originparttokeep(FILE *f, DbvOriginPartToKeep *psOriginPartToKeep)
{
	fprintf(f,"psOriginPartToKeep:\n");
	print_action(f, psOriginPartToKeep->eAction);
	
	fprintf(f,"sDatabaseName: ");
	print_inter_string(f, &psOriginPartToKeep->sDatabaseName);

	fprintf(f,"pcSchema: ");
	if (psOriginPartToKeep->pcSchema != NULL)
		fprintf(f,"%s\n", psOriginPartToKeep->pcSchema);
	else
		fprintf(f,"NULL\n");

	fprintf(f,"psElementSetName: ");
	if (psOriginPartToKeep->psElementSetName != NULL)
		print_inter_string(f, psOriginPartToKeep->psElementSetName);
	else
		fprintf(f,"NULL\n");
}



int print_action(FILE *f, DbvUpdtAction eAction)
{
	fprintf(f,"eAction: ");
	switch (eAction) {
	case UA_RecordInsert:
		fprintf(f,"UA_RecordInsert\n");
		break;
	case UA_RecordReplace:
		fprintf(f,"UA_RecordReplace\n");
		break;
	case UA_RecordDelete:
		fprintf(f,"UA_RecordDelete\n");
		break;
	case UA_ElementUpdate:
		fprintf(f,"UA_ElementUpdate\n");
		break;
	case UA_Invalid:
		fprintf(f,"UA_Invalid\n");
		break;
	default:
		fprintf(f,"unknown\n");
		break;
	}
}



int print_suppliedrecs(FILE *f, DbvSuppliedRecord **ppsSuppliedRecord)
{
	int index = 0;

	fprintf(f,"ppsSuppliedRecord:\n");

	if (ppsSuppliedRecord != NULL) {
		while( ppsSuppliedRecord[index] != NULL) {
			print_suppliedrec(f, ppsSuppliedRecord[index]);
			index++;
		}
	}
	fprintf(f,"\n");
}



int print_suppliedrec(FILE *f, DbvSuppliedRecord *psSuppliedRecord)
{
	fprintf(f,"\n\npsSuppliedRecord:\n");

	fprintf(f,"psUpdtRecordId: ");
	if (psSuppliedRecord->psUpdtRecordId != NULL)
		print_recordid(f, psSuppliedRecord->psUpdtRecordId);
	else
		fprintf(f,"NULL\n");


	fprintf(f,"psUpdtSupplementalId: ");
	if (psSuppliedRecord->psUpdtSupplementalId != NULL)
		print_suppid(f, psSuppliedRecord->psUpdtSupplementalId);
	else
		fprintf(f,"NULL\n");
	

	fprintf(f,"psCorrelationInfo: ");
	if (psSuppliedRecord->psCorrelationInfo != NULL)
		print_correl_info(f, psSuppliedRecord->psCorrelationInfo);
	else
		fprintf(f,"NULL\n");
	

	/* The following external is compulsory */
	fprintf(f,"sRecord:\n");
	print_external(f, &psSuppliedRecord->sRecord);
}



int print_recordid(FILE *f, DbvUpdtRecordId *psUpdtRecordId)
{
	fprintf(f,"\neRecordIdType: ");
	switch( psUpdtRecordId->eRecordIdType) {
	case URIT_Number:
		fprintf(f,"URIT_Number\n");
		fprintf(f,"ulNumber: %lu\n", psUpdtRecordId->uUpdtRecordId.ulNumber);
		break;
	case URIT_String:
		fprintf(f,"URIT_String\n");
		fprintf(f,"psString: ");
		print_inter_string(f, psUpdtRecordId->uUpdtRecordId.psString);
		break;
	case URIT_Opaque:
		fprintf(f,"URIT_Opaque\n");
		fprintf(f,"psOpaque: ");
		print_octet_string(f, psUpdtRecordId->uUpdtRecordId.psOpaque);
		break;
	default:
		fprintf(f,"Unknown\n");
		break;
	}
}



int print_suppid(FILE *f, DbvUpdtSupplementalId *psUpdtSupplementalId)
{
	fprintf(f,"\neSupplementalIdType: ");
	switch( psUpdtSupplementalId->eSupplementalIdType) {
	case USIT_Time:
		fprintf(f,"USIT_Time\n");
		fprintf(f,"pcTime: %s\n", psUpdtSupplementalId->uUpdtSupplementalId.pcTime);
		break;
	case USIT_Version:
		fprintf(f,"USIT_Version\n");
		fprintf(f,"psVersion: ");
		print_inter_string(f, psUpdtSupplementalId->uUpdtSupplementalId.psVersion);
		break;
	case USIT_PreviousVersion:
		fprintf(f,"USIT_PreviousVersion\n");
		print_external(f, psUpdtSupplementalId->uUpdtSupplementalId.psPreviousVersion);
		break;
	default:
		fprintf(f,"Unknown\n");
		break;
	}
}



int print_correl_info(FILE *f, DbvCorrelationInfo *psCorrelationInfo)
{
	/* Both optional */
	fprintf(f,"\npsNote: ");
	if (psCorrelationInfo->psNote != NULL)
		print_inter_string(f, psCorrelationInfo->psNote);
	else
		fprintf(f,"NULL\n");
		
	fprintf(f,"pulId: ");
	if (psCorrelationInfo->pulId != NULL)
		fprintf(f,"%lu\n", *psCorrelationInfo->pulId);
	else
		fprintf(f,"NULL\n");
}



int print_update_response(FILE *f, DbvUpdateTaskPackage *psUpdateResponse)
{
	/* Both compulsory */
	print_originparttokeep(f, &psUpdateResponse->sOriginPartToKeep);
	print_targetpart(f, &psUpdateResponse->sTargetPart);
}



int print_targetpart(FILE *f, DbvUpdateTargetPart *psTargetPart)
{
	fprintf(f,"psTargetPart:\n");
	print_taskstatus(f, psTargetPart->eTaskStatus);

	/* Following two optional */

	fprintf(f,"ppsGlobalDiagnostics: ");
	if (psTargetPart->ppsGlobalDiagnostics != NULL)
		print_diagrec_list(f, psTargetPart->ppsGlobalDiagnostics);
	else
		fprintf(f,"NULL\n");

	fprintf(f,"ppsTaskPackageRecord: ");
	if (psTargetPart->ppsTaskPackageRecord != NULL)
		print_taskpack_recs(f, psTargetPart->ppsTaskPackageRecord);
	else
		fprintf(f,"NULL\n");
}



int print_taskstatus(FILE *f, DbvUpdtTaskStatus eTaskStatus)
{
	fprintf(f,"eTaskStatus: ");
	switch (eTaskStatus) {
	case UTS_Success:
		fprintf(f,"UTS_Success\n");
		break;
	case UTS_Partial:
		fprintf(f,"UTS_Partial\n");
		break;
	case UTS_Failure:
		fprintf(f,"UTS_Failure\n");
		break;
	case UTS_Invalid:
		fprintf(f,"UTS_Invalid\n");
		break;
	default:
		fprintf(f,"Unknown\n");
		break;
	}
}



int print_taskpack_recs(FILE *f, DbvTaskPackageRecord **ppsTaskPackageRecord)
{
	int index = 0;

	if (ppsTaskPackageRecord != NULL) {
		while( ppsTaskPackageRecord[index] != NULL) {
			fprintf(f,"\n");
			print_taskpack_rec(f, ppsTaskPackageRecord[index]);
			index++;
		}
	}
	fprintf(f,"\n");
}



int print_taskpack_rec(FILE *f, DbvTaskPackageRecord *psTaskPackageRecord)
{
	fprintf(f,"psUpdtRecordOrDiag: ");
	if (psTaskPackageRecord->psUpdtRecordOrDiag != NULL)
		print_recordiag(f, psTaskPackageRecord->psUpdtRecordOrDiag);
	else
		fprintf(f,"NULL\n");

	
	fprintf(f,"psCorrelationInfo: ");
	if (psTaskPackageRecord->psCorrelationInfo != NULL)
		print_correl_info(f, psTaskPackageRecord->psCorrelationInfo);
	else
		fprintf(f,"NULL\n");

	
	print_recstatus(f, psTaskPackageRecord->eUpdtRecordStatus);
	
}



int print_recordiag(FILE *f, DbvUpdtRecordOrDiag *psUpdtRecordOrDiag)
{
	fprintf(f,"\neUpdtRecordOrDiag: ");
	switch( psUpdtRecordOrDiag->eUpdtRecordOrDiag) {
	case URDT_Record:
		fprintf(f,"URDT_Record\n");
		print_external(f, psUpdtRecordOrDiag->uUpdtRecordOrDiag.psRecord);
		break;
	case URDT_Diagnostic:
		fprintf(f,"URDT_Diagnostic\n");
		print_diag_rec(f, psUpdtRecordOrDiag->uUpdtRecordOrDiag.psDiagnostic);
		break;
	default:
		fprintf(f,"Unknown\n");
		break;
	}

}



int print_recstatus(FILE *f, DbvUpdtRecordStatus eUpdtRecordStatus)
{
	fprintf(f,"eUpdtRecordStatus: ");
	switch (eUpdtRecordStatus) {
	case URST_Success:
		fprintf(f,"URST_Success\n");
		break;
	case URST_Queued:
		fprintf(f,"URST_Queued\n");
		break;
	case URST_InProcess:
		fprintf(f,"URST_InProcess\n");
		break;
	case URST_Failure:
		fprintf(f,"URST_Failure\n");
		break;
	case URST_Invalid:
		fprintf(f,"URST_Invalid\n");
		break;
	default:
		fprintf(f,"Unknown\n");
		break;
	}
}



int print_unknown_external(FILE *f, DbvASN1External *external_ptr)
{
	char *ber_data = NULL;
	struct DbvOctetString *pdu_ptr = NULL;
	unsigned long length = 0;

	pdu_ptr = external_ptr->uExternalValue.psSingleASN1Type->uASN1.psUnknownType;

	if (pdu_ptr != NULL) {
		ber_data = pdu_ptr->pcValue;
		length = pdu_ptr->ulLength;
		fprintf(f,"\tpsUnknownType:");

		print_as_hex(f, ber_data, length);
	}
}



int	print_arbitrary_external(FILE *f, DbvASN1External *external_ptr)
{
        fprintf(f,"\tpsArbitrary:");
	print_octet_string(f, external_ptr->uExternalValue.psArbitrary);

}


/* Routines to print out psOtherInformation Fields */
int	print_otherinfo(FILE *f, DbvOtherInformation **ppsOtherInformation)
{
	int index = 0;

	if (ppsOtherInformation != NULL) {
		while( ppsOtherInformation[index] != NULL) {
			print_otherinfo_node(f, ppsOtherInformation[index]);
			index++;
		}
		fprintf(f,"\n");
	} else
		fprintf(f,"NULL\n");

	fprintf(f,"\n");
}



int print_otherinfo_node(FILE *f, DbvOtherInformation *psOtherInformation)
{

	char	*oid = NULL;


	if (psOtherInformation != NULL) {

		fprintf(f,"\n");

		fprintf(f,"\tpsInfoCategory: ");

		/* If the psInfoCategory is given (it is an optional field) */
		if (psOtherInformation->psInfoCategory != NULL) {
	
			fprintf(f,"\n\tpcCategoryTypeId: ");
			/* If pcCategoryTypeId is given (it is an optional field) */
			if (psOtherInformation->psInfoCategory->pcCategoryTypeId != NULL) {
				oid = psOtherInformation->psInfoCategory->pcCategoryTypeId;
	
				/* Print the oid (a char* in dbv) */
				fprintf(f,"%s\n", oid);
			} else
				fprintf(f,"NULL\n");
	
			/* ulCategoryValue must be given in a psInfoCategory */
			fprintf(f,"\tulCategoryValue: %ld\n", psOtherInformation->psInfoCategory->ulCategoryValue);
		} else
			fprintf(f,"NULL\n");
	

		/* Print out the type of otherinformation */
		print_otherinfo_infotype(f, psOtherInformation->eInformationType);
	
	
		/* Now print out the actual otherinfo data */
		switch( psOtherInformation->eInformationType) {
		case IT_CharacterInfo:
			print_otherinfo_char(f, psOtherInformation->uInformation.psCharacterInfo);
			break;
		case IT_BinaryInfo:
			print_otherinfo_bin(f, psOtherInformation->uInformation.psBinaryInfo);
			break;
		case IT_ExternalInfo:
			print_otherinfo_ext(f, psOtherInformation->uInformation.psExternallyDefinedInfo);
			break;
		case IT_ObjectIdentifier:
			print_otherinfo_obj(f, psOtherInformation->uInformation.pcObjectIdentifier);
			break;
		}
	} else
		fprintf(f,"NULL\n");
}
	




int print_otherinfo_char(FILE *f, DbvInternationalString *psCharacterInfo)
{
	fprintf(f,"\tpsCharacterInfo: ");
        print_inter_string(f, psCharacterInfo);
}



int print_otherinfo_bin(FILE *f, DbvOctetString *psBinaryInfo)
{
	fprintf(f,"\tpsBinaryInfo: ");
        print_octet_string(f, psBinaryInfo);
}



int print_otherinfo_ext(FILE *f, DbvASN1External *psExternallyDefinedInfo)
{
	fprintf(f,"\tpsExternallyDefinedInfo:\n");
	print_external(f, psExternallyDefinedInfo);
}



int	print_otherinfo_obj(FILE *f, DbvObjectIdentifier pcObjectIdentifier)
{
	/* Print the oid of the external (a char* in dbv) */
	fprintf(f,"\tpcObjectIdentifier:%s\n", pcObjectIdentifier);

}


int	print_otherinfo_infotype(FILE *f, DbvInformationType eInformationType)
{
	switch (eInformationType) {
	case IT_CharacterInfo:
		fprintf(f,"\teInformationType: IT_CharacterInfo\n");
		break;
	case IT_BinaryInfo:
		fprintf(f,"\teInformationType: IT_BinaryInfo\n");
		break;
	case IT_ExternalInfo:
		fprintf(f,"\teInformationType: IT_ExternalInfo\n");
		break;
	case IT_ObjectIdentifier:
		fprintf(f,"\teInformationType: IT_ObjectIdentifier\n");
		break;
	default:
		fprintf(f,"\teInformationType: Unknown\n");
		break;
	}
}



int print_octet_string(FILE *f, DbvOctetString *octet_string)
{
        char *temp = NULL;
        char *string = NULL;
        unsigned long length = 0;
 
 
        if (octet_string != NULL) {
                if (octet_string->pcValue != NULL) {
 
                        string = octet_string->pcValue;
                        length = octet_string->ulLength;
 
                        temp = (char *) DbvAlloc (length + 1);
                        if (temp != NULL) {
                                memcpy(temp, string, length);
                                fprintf(f,"%s\n", temp);
                                DbvFree(temp);
                        } else
				fprintf(f,"NOT ENOUGH MEMORY FOR PRINT OPERATION!\n");
                } else
                        fprintf(f,"\n");
 
        } else
                fprintf(f,"NULL\n");
}



void print_DbvInternationalString(FILE *f, char *name, DbvInternationalString *psInternationalString)
{
   /* Write the title out */ 
   if (psInternationalString == NULL)
      {
      fprintf(f, "%s: NULL\n", name);
      return;
      } /* End if */

   fprintf(f, "%s: ", name);


	print_inter_string(f, psInternationalString);
}



int print_inter_string(FILE *f, DbvInternationalString *inter_string)
{
        char *temp = NULL;
        char *string = NULL;
        unsigned long length = 0;
 
        if (inter_string != NULL) {
                if (inter_string->pcValue != NULL) {
 
                        string = inter_string->pcValue;
                        length = inter_string->ulLength;
 
                        temp = (char *) DbvAlloc (length + 1);
                        if (temp != NULL) {
                                memcpy(temp, string, length);
                                fprintf(f,"%s\n", temp);
                                DbvFree(temp);

				print_as_hex(f, string, length);
                        } else
				fprintf(f,"NOT ENOUGH MEMORY FOR PRINT OPERATION!\n");
                } else
                        fprintf(f,"\n");
 
        } else
                fprintf(f,"NULL\n");

}



int 	print_bool(FILE *f, DbvBool *bool)
{
	if(bool != NULL)
	{
		if(*bool == DBV_FALSE)
			fprintf(f,"DBV_FALSE\n");
		else
			fprintf(f,"DBV_TRUE\n");
	}
	else
		fprintf(f,"NULL\n");
		
}



int print_DbvPresentStatus(FILE *f, DbvPresentStatus *pePresentStatus)
{
	switch (*pePresentStatus) {
		case PS_Success:
			fprintf(f,"PS_Success\n");
			break;
		case PS_Partial_1:
			fprintf(f,"PS_Partial_1\n");
			break;
		case PS_Partial_2:
			fprintf(f,"PS_Partial_2\n");
			break;
		case PS_Partial_3:
			fprintf(f,"PS_Partial_3\n");
			break;
		case PS_Partial_4:
			fprintf(f,"PS_Partial_4\n");
			break;
		case PS_Failure:
			fprintf(f,"PS_Failure\n");
			break;
		case PS_Invalid:
			fprintf(f,"PS_Invalid\n");
			break;
	}

}


int print_DbvElementSetNames(FILE *f, DbvElementSetNames *psElementSetNames)
{

	fprintf(f,"\npsElementSetNames: ");
	if (psElementSetNames != NULL)
		print_el_set_names(f, psElementSetNames);
	else
		fprintf(f,"NULL\n");

}




int print_el_set_names(FILE *f, DbvElementSetNames *psElementSetNames)
{

	switch( psElementSetNames->eElementSetType) {
	case EST_Generic:
		fprintf(f,"EST_Generic:\n");
        	print_inter_string(f, psElementSetNames->uElementSet.psGeneric); 
		break;
	case EST_DatabaseSpecific:
		fprintf(f,"EST_DatabaseSpecific:\n");
		print_el_set_specific(f, psElementSetNames->uElementSet.ppsElementSetsDbSpecific);
		break;
	}
}



int print_el_set_specific(FILE *f, DbvElementSetsDbSpecific **ppsElementSetsDbSpecific)
{
	int index = 0;

	if (ppsElementSetsDbSpecific != NULL){
		while(ppsElementSetsDbSpecific[index] != NULL) {
       			fprintf(f,"\tpsDatabaseName: ");
			print_inter_string(f, ppsElementSetsDbSpecific[index]->psDatabaseName);
       			fprintf(f,"\tpspsElementSetName: ");
			print_inter_string(f, ppsElementSetsDbSpecific[index]->psElementSetName);
			index++;
			fprintf(f,"\n");
		}
		fprintf(f,"\n");
	} else
		fprintf(f,"NULL\n");
}




int	print_records(FILE *f, DbvRecords *psRecords)
{
	if (psRecords != NULL) {
		fprintf(f,"\n\n");
		switch( psRecords->eRecordType) {
		case RT_Response:
			fprintf(f,"RT_Response:\n");
			print_nameplusrec(f, psRecords->uRecord.ppsResponseRecord);
			break;
		case RT_NonSurrDiagnostics:
			fprintf(f,"RT_NonSurrDiagnostics:\n");
			if (psRecords->uRecord.psNonSurrogateDiag != NULL)
				print_default_diag(f, psRecords->uRecord.psNonSurrogateDiag);
			break;
		case RT_MultipleNonSurrDiagnostics:
			fprintf(f,"RT_MultipleNonSurrDiagnostics:\n");
			if (psRecords->uRecord.ppsMultipleNonSurrogateDiag != NULL) 
				print_diagrec_list(f, psRecords->uRecord.ppsMultipleNonSurrogateDiag);
			break;
		}
		fprintf(f,"\n\n");
	
		
	} else
		fprintf(f,"NULL\n");

}



int print_nameplusrec(FILE *f, DbvNamePlusRecord **ppsResponseRecord)
{
	int index = 0;

	if (ppsResponseRecord != NULL) {
		while( ppsResponseRecord[index] != NULL) {
			fprintf(f,"\npsDatabaseName: ");
			if (ppsResponseRecord[index]->psDatabaseName != NULL)
				print_inter_string(f, ppsResponseRecord[index]->psDatabaseName);
			else
				fprintf(f,"NULL\n");
	
			switch( ppsResponseRecord[index]->eDbRecordType) {
			case DRT_Retrieval:
				fprintf(f,"DRT_Retrieval:\n");
				print_external(f, ppsResponseRecord[index]->uDbRecord.psRetrievalRecord);
				break;
			case DRT_SurrogateDiagnostics:
				fprintf(f,"DRT_SurrogateDiagnostics:\n");
				print_diag_rec(f, ppsResponseRecord[index]->uDbRecord.psSurrogateDiagnostic);
				break;
			case DRT_StartingFragment:
				fprintf(f,"DRT_StartingFragment:\n");
				print_fragment(f, ppsResponseRecord[index]->uDbRecord.psStartingFragment);
				break;
			case DRT_IntermediateFragment:
				fprintf(f,"DRT_IntermediateFragment:\n");
				print_fragment(f, ppsResponseRecord[index]->uDbRecord.psIntermediateFragment);
				break;
			case DRT_FinalFragment:
				fprintf(f,"DRT_FinalFragment:\n");
				print_fragment(f, ppsResponseRecord[index]->uDbRecord.psFinalFragment);
				break;
			}
	
		index++;
		}
	}
	fprintf(f,"\n");
}



int print_diag_rec(FILE *f, DbvDiagRec *psSurrogateDiagnostic)
{
	if (psSurrogateDiagnostic == NULL) {
		fprintf(f, "NULL\n");
		return 1;
	}

	switch( psSurrogateDiagnostic->eDiagnosticsType) {
	case DT_DefaultFormat:
		fprintf(f,"DT_DefaultFormat:\n");
		print_default_diag(f, psSurrogateDiagnostic->uDiagnostics.psDefault);
		break;
	case DT_ExternallyDefined:
		fprintf(f,"DT_ExternallyDefined:\n");
		print_external(f, psSurrogateDiagnostic->uDiagnostics.psExternallyDefined);
		break;
	}

	return 1;
}



int print_default_diag(FILE *f, DbvDefaultDiagFormat *psDefault)
{
	/* All compulsory fields */
	fprintf(f,"pcDiagnosticSetId: %s\n", psDefault->pcDiagnosticSetId);
	fprintf(f,"ulCondition: %ld\n", psDefault->ulCondition);

	print_additional_info(f, psDefault->sAdditionalInfo);
}



int print_fragment(FILE *f, DbvFragmentSyntax *psStartingFragment)
{
	fprintf(f,"eFragmentSyntaxType: ");
	switch( psStartingFragment->eFragmentSyntaxType) {
	case FST_ExternallyTagged:
		fprintf(f,"FST_ExternallyTagged\n");
		print_external(f, psStartingFragment->uFragmentSyntax.psExternallyTagged);
		break;
	case FST_NotExternallyTagged:
		fprintf(f,"FST_NotExternallyTagged\n");
		print_octet_string(f, psStartingFragment->uFragmentSyntax.psNotExternallyTagged);
		break;
	}
}



int print_additional_info(FILE *f, DbvAdditionalInfo sAdditionalInfo)
{

	switch(sAdditionalInfo.eProtocolVersionInForce) {
	case PVIF_Version2:
		fprintf(f,"PVIF_Version2: %s\n", sAdditionalInfo.uAdditionalInfo.pcV2);	
		break;
	case PVIF_Version3:
		fprintf(f,"PVIF_Version3: ");	
		print_inter_string(f, sAdditionalInfo.uAdditionalInfo.psV3);	
		break;
	}

}



int print_diagrec_list(FILE *f, DbvDiagRec **diagrec_list)
{
	int index = 0;

	if (diagrec_list != NULL) {
		while (diagrec_list[index] != NULL) {
			fprintf(f,"\n");
			print_diag_rec(f, diagrec_list[index]);
			index++;
		}
	}

	fprintf(f,"\n");
		
}


 
 

int print_strornum(FILE *f, DbvStringOrNumeric *psList)
{
	if (psList == NULL) {
		fprintf(f, "NULL\n");
		return 1; 
	} 
   
        switch( psList->eStringOrNumeric) {
        case SNT_String:
                fprintf(f,"psString: ");
                print_inter_string(f, psList->uStringOrNumeric.psString);
                break;
        case SNT_Numeric:
                fprintf(f,"ulNumeric: %ld\n", psList->uStringOrNumeric.ulNumeric);
                break;
        }

	return 1;
}



int print_intunit(FILE *f, DbvIntUnit *psIntegerAndUnit)
{
	if (psIntegerAndUnit == NULL) {
		fprintf(f, "NULL\n");
		return 1;
	}

        /* Both compulsory */
        fprintf(f,"value: %ld\n", psIntegerAndUnit->ulValue);
 
        print_unitused(f, psIntegerAndUnit->sUnitUsed);

	return 1;
}
 
 
 
int print_unitused(FILE *f, DbvUnit sUnitUsed)
{
 
        /* All optional */
 
        fprintf(f,"psUnitSystem: ");
        if (sUnitUsed.psUnitSystem != NULL)
                print_inter_string(f, sUnitUsed.psUnitSystem);
        else
                fprintf(f,"NULL\n");
 
 
        fprintf(f,"psUnitType: ");
        if (sUnitUsed.psUnitType != NULL)
                print_strornum(f, sUnitUsed.psUnitType);
        else
                fprintf(f,"NULL\n");
 
 
        fprintf(f,"psUnit: ");
        if (sUnitUsed.psUnit != NULL)
                print_strornum(f, sUnitUsed.psUnit);
        else
                fprintf(f,"NULL\n");
 
 
        fprintf(f,"pulScaleFactor: ");
        if (sUnitUsed.pulScaleFactor != NULL)
                fprintf(f,"%ld\n", *sUnitUsed.pulScaleFactor);
        else
                fprintf(f,"NULL\n");
}






int print_attsplusterm(FILE *f, DbvAttributesPlusTerm *psAttributesPlusTerm)
{
	int index = 0;


	/* Print all attributes */
	
	if (psAttributesPlusTerm->ppsAttributeElement != NULL) {
		while( psAttributesPlusTerm->ppsAttributeElement[index] != NULL) {
			print_att_element(f, psAttributesPlusTerm->ppsAttributeElement[index]);
			index++;
		}
	}

	fprintf(f,"\n");

	/* then the term */
	print_att_term(f, psAttributesPlusTerm->sTerm);

	fprintf(f,"\n\n");
}




int print_att_element(FILE *f, DbvAttributeElement *psAttributeElement)
{
	fprintf(f,"\npcAttributeSetId: ");
	if (psAttributeElement->pcAttributeSetId != NULL)
		fprintf(f,"%s ", psAttributeElement->pcAttributeSetId);
	else
		fprintf(f,"NULL ");


	fprintf(f,"attype: %ld ", psAttributeElement->ulAttributeType);
	print_att_value(f, psAttributeElement->sAttributeValue);
}



int print_att_value(FILE *f, DbvAttributeValue sAttributeValue)
{
	switch (sAttributeValue.eAttributeValueType) {
	case AVT_Numeric:
		fprintf(f,"attval: %ld   ", sAttributeValue.uAttributeValue.ulNumeric);
		break;
	case AVT_Complex:
		fprintf(f,"\nComplex attval: ");
		print_complexval(f, sAttributeValue.uAttributeValue.psComplexValue);
		break;
	}
}



int print_complexval(FILE *f, DbvComplexValue *psComplexValue)
{
	/* First compulsory */
	int index = 0;

	
	fprintf(f,"\n#####################\n");
	fprintf(f,"Start of complexval: \n");

	/* Print all attributes */

	if (psComplexValue->ppsList != NULL) {
		while( psComplexValue->ppsList[index] != NULL) {
			fprintf(f,"\npsStringOrNumeric: \n");
			print_strornum(f, psComplexValue->ppsList[index]);
			index++;
		}
	}
	fprintf(f,"\n");
	


	/* Second optional */
	index = 0;

	/* Print all attributes */

	fprintf(f,"\nppulSemanticAction list: ");
	if (psComplexValue->ppulSemanticAction != NULL) {
		while( psComplexValue->ppulSemanticAction[index] != NULL) {
			fprintf(f,"\npulSemanticAction: %ld", *psComplexValue->ppulSemanticAction[index]);
			index++;

		}
		fprintf(f,"\n\n");
	} else
		fprintf(f,"NULL\n\n");


	fprintf(f,"End of complexval: \n");
	fprintf(f,"#####################\n");
}



int print_att_term(FILE *f, DbvTerm sTerm)
{
	switch (sTerm.eTermType) {
	case TT_General:
		fprintf(f,"\npsGeneral: ");
		print_octet_string(f, sTerm.uTerm.psGeneral);
		break;
	case TT_Numeric:
		fprintf(f,"\nulInteger: %ld\n", sTerm.uTerm.ulInteger);
		break;
	case TT_SimpleCharacter:
		fprintf(f,"\npsSimpleCharacter: ");
		print_inter_string(f, sTerm.uTerm.psSimpleCharacter);
		break;
	case TT_ObjectIdentifier:
		fprintf(f,"\npcObjectIdentifier: %s\n", sTerm.uTerm.pcObjectIdentifier );
		break;
	case TT_DateTime:

		/* DateTime is just a char* */
		fprintf(f,"\npcDateTime: %s\n", sTerm.uTerm.pcObjectIdentifier);
		break;
	case TT_External:
		fprintf(f,"\npsExternal: ");
		print_external(f, sTerm.uTerm.psExternal);
		break;
	case TT_IntegerAndUnit:
		fprintf(f,"\nTT_IntegerAndUnit:\n");
		print_intunit(f, sTerm.uTerm.psIntegerAndUnit);
		break;
	case TT_Null:
		fprintf(f,"\nTT_Null: ");
		break;
	}

}



int print_DbvSpecification(FILE *f, char *name, DbvSpecification *psSpecification)
{
	if (psSpecification == NULL) {
           fprintf(f, "%s: NULL\n", name);
           return 1;
	}
   
	fprintf(f, "%s:\n", name);

	print_DbvObjectIdentifier(f, "pcSchema", psSpecification->pcSchema);
	print_DbvElementSpec(f, "psElementSpec", psSpecification->psElementSpec);

	return 1;
}



int print_DbvElementSpec(FILE *f, char *name, DbvElementSpec *psElementSpec)
{
	if (psElementSpec == NULL) {
		fprintf(f, "%s: NULL\n", name);
		return 1;
	} 
   
	fprintf(f, "%s:\n", name);

        switch( psElementSpec->eElementSpecType) {
        case EST_Primitive:
                fprintf(f,"EST_Primitive: ");
                print_inter_string(f, psElementSpec->uElementSpec.psPrimitive);
                break;
        case EST_External:
                fprintf(f,"EST_External:\n");
                print_external(f, psElementSpec->uElementSpec.psExternal);
                break;
        }

	return 1;
}
 


int print_attelmnt_list(FILE *f, DbvAttributeElement **ppsAttributeElement)
{
        int index = 0;
 
	if (ppsAttributeElement != NULL) {
        	while( ppsAttributeElement[index] != NULL) {
                	print_att_element(f, ppsAttributeElement[index]);
                	index++;
        	}
	}
	fprintf(f,"\n");
}
 
 
 
 


int print_invalidapdu(FILE *f, DbvOctetString *psInvalidAPDU)
{
	char	*ber_data = NULL;
	long	length = 0;

	fprintf(f,"Invalid PDU:\n");

	ber_data = psInvalidAPDU->pcValue;
	length = psInvalidAPDU->ulLength;

	print_as_hex(f, ber_data, length);
}

