#include "api_target_close.h"



int	send_closereq_to_origin(int assoc_id) 
{
	DbvAssocId      lAssocId = assoc_id;
        DbvCloseReq	*psCloseReq = NULL;
        DbvError        *psError = NULL;
 
	int choice = 0;
        char choice_string[100];

        /* Allocate memory for psCloseReq and fill it in */
        psCloseReq = (DbvCloseReq *) DbvAlloc (sizeof(DbvCloseReq));
        fill_close_request(psCloseReq);
 

	printf("Print 'CloseRequest' (Close PDU) to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_closereq_fields(stdout, psCloseReq);
                printf("-----------------------------------------\n");
        }

        /* Send CloseRequest to client */
        if (DbvCloseRequest(lAssocId, psCloseReq, &psError) == SI_OK)
        {

                SIFreeDbvCloseReq(&psCloseReq);

                return SI_OK;
        }  else {
                PrivateErrorHandling(&psError);

                SIFreeDbvCloseReq(&psCloseReq);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
                return SI_NOTOK;
        }
}


int	send_closersp_to_origin(int assoc_id) 
{
	DbvAssocId      lAssocId = assoc_id;

	/* Note that in the following psCloseRsp is a pointer to DbvCloseReq */
        DbvCloseReq	*psCloseRsp = NULL;
        DbvError        *psError = NULL;
 
	int choice = 0;
        char choice_string[100];

        /* Allocate memory for psCloseRsp and fill it in */
        psCloseRsp = (DbvCloseReq *) DbvAlloc (sizeof(DbvCloseReq));
        fill_close_request(psCloseRsp);
 

	printf("Print 'CloseResponse' (Close PDU) to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_closereq_fields(stdout, psCloseRsp);
                printf("-----------------------------------------\n");
        }
 

        /* Send CloseResponse to client */
        if (DbvCloseResponse(lAssocId, psCloseRsp, &psError) == SI_OK)
        {

                SIFreeDbvCloseReq(&psCloseRsp);

                return SI_OK;
        }  else {
                PrivateErrorHandling(&psError);

                SIFreeDbvCloseReq(&psCloseRsp);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
                return SI_NOTOK;
        }
}



