#include "api_target_delete.h"




int send_delrsp_to_origin(int assoc_id)
{
        DbvAssocId      lAssocId = assoc_id;
        DbvDeleteResultSetRsp   *psDeleteResultSetRsp = NULL;
        DbvError        *psError = NULL;
 
        int choice = 0;
        char choice_string[100];

        /* Allocate memory for psDeleteResultSetRsp and fill it in */
        psDeleteResultSetRsp = (DbvDeleteResultSetRsp *) DbvAlloc (sizeof(DbvDeleteResultSetRsp));
        fill_delete_response(psDeleteResultSetRsp);
 

        printf("Print DeleteResultSetResponse PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_delrsp_fields(stdout, psDeleteResultSetRsp);
                printf("-----------------------------------------\n");
        }
 

        /* Send DeleteResultSetResponse to client */
        if (DbvDeleteResultSetResponse(lAssocId, psDeleteResultSetRsp, &psError) == SI_OK)
        {

                SIFreeDbvDeleteResultSetRsp(&psDeleteResultSetRsp);

                return SI_OK;
        }  else {
                PrivateErrorHandling(&psError);

                SIFreeDbvDeleteResultSetRsp(&psDeleteResultSetRsp);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
                return SI_NOTOK;
        }
}



int fill_delete_response(DbvDeleteResultSetRsp *psDeleteResultSetRsp)
{

	char *test_reference_id = "delete response reference id";
	char *test_deletemessage = "delete response delete message";
        int choice = 0;
        char choice_string[100];
 
 
        /* Compulsory fields */
 
        /* ulNumberOfRecordsReturned */
        psDeleteResultSetRsp->eDeleteOperationStatus = DSS_ResourceControlAtOrigin;
 
        /* Optional fields */
        /* Reference id */
        psDeleteResultSetRsp->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
        fill_dbv_octet_string(psDeleteResultSetRsp->psReferenceId, test_reference_id);

 
	/* ppsDeleteListStatuses */

	/* 3 nodes - 0, 1, \0 */
        psDeleteResultSetRsp->ppsDeleteListStatuses = (DbvListStatus **) DbvAlloc(sizeof(DbvListStatus *) * 3);

        psDeleteResultSetRsp->ppsDeleteListStatuses[0] = (DbvListStatus *) DbvAlloc (sizeof(DbvListStatus));
	fill_dbv_liststat(psDeleteResultSetRsp->ppsDeleteListStatuses[0]);

        psDeleteResultSetRsp->ppsDeleteListStatuses[1] = (DbvListStatus *) DbvAlloc (sizeof(DbvListStatus));
	fill_dbv_liststat(psDeleteResultSetRsp->ppsDeleteListStatuses[1]);

        psDeleteResultSetRsp->ppsDeleteListStatuses[2] = NULL;
 
 
	/* pulNumberNotDeleted */
        psDeleteResultSetRsp->pulNumberNotDeleted = (Ulong *) DbvAlloc (sizeof (Ulong));
        *psDeleteResultSetRsp->pulNumberNotDeleted = 1234321;


	/* ppsBulkStatuses */
        psDeleteResultSetRsp->ppsBulkStatuses = (DbvListStatus **) DbvAlloc(sizeof(DbvListStatus *) * 3);


        psDeleteResultSetRsp->ppsBulkStatuses[0] = (DbvListStatus *) DbvAlloc (sizeof(DbvListStatus));
	fill_dbv_liststat(psDeleteResultSetRsp->ppsBulkStatuses[0]);

        psDeleteResultSetRsp->ppsBulkStatuses[1] = (DbvListStatus *) DbvAlloc (sizeof(DbvListStatus));
	fill_dbv_liststat(psDeleteResultSetRsp->ppsBulkStatuses[1]);

        psDeleteResultSetRsp->ppsBulkStatuses[2] = NULL;


	/* psDeleteMessage */
        psDeleteResultSetRsp->psDeleteMessage = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psDeleteResultSetRsp->psDeleteMessage, test_deletemessage);


        /* psOtherInformation */
        psDeleteResultSetRsp->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);
        psDeleteResultSetRsp->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
        psDeleteResultSetRsp->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
 
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), obj (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
                fill_del_response_othinfo_char(psDeleteResultSetRsp->ppsOtherInformation[0]);
                fill_del_response_othinfo_char(psDeleteResultSetRsp->ppsOtherInformation[1]);
                break;
        case 2:
                fill_del_response_othinfo_bin(psDeleteResultSetRsp->ppsOtherInformation[0]);
                fill_del_response_othinfo_bin(psDeleteResultSetRsp->ppsOtherInformation[1]);
                break;
        case 3:
                fill_del_response_othinfo_ext(psDeleteResultSetRsp->ppsOtherInformation[0]);
                fill_del_response_othinfo_ext(psDeleteResultSetRsp->ppsOtherInformation[1]);
                break;
        case 4:
                fill_del_response_othinfo_obj(psDeleteResultSetRsp->ppsOtherInformation[0]);
                fill_del_response_othinfo_obj(psDeleteResultSetRsp->ppsOtherInformation[1]);
                break;
        }

}
 



int fill_dbv_liststat(DbvListStatus *psDeleteListStatuses)
{
	char *test_resetid = "delete response test result set id";
	DbvDeleteSetStatus test_delsetstat = DSS_NotAllRequestedSetsDeleted;

	/* Both the following are compulsory */

	fill_dbv_inter_string(&psDeleteListStatuses->sResultSetId, test_resetid);
	psDeleteListStatuses->eDeleteSetStatus = test_delsetstat;

}



int fill_del_response_othinfo_char(DbvOtherInformation *psOtherInformation)
{
 
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 9;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my otherinfo delete response char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue,
 charinfo);
}



int fill_del_response_othinfo_bin(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char bininfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 18;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my otherinfo delete response bin field");
 
        fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue,
bininfo);
}
 


int fill_del_response_othinfo_ext(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char bininfo[100];
        char sutrs_string[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 656;
        DbvASN1External *external = NULL;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my otherinfo bin field");
        strcpy(sutrs_string, "this is a delete response test otherinfo sutrs string");
 
        fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);
 
        /* Set up a sutrs external */
        external = psOtherInformation->uInformation.psExternallyDefinedInfo;
        fill_dbv_sutrs_external(external, sutrs_string);
}



int fill_del_response_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
 
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 74;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
        fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
 
}

 


