#include "api_target_extend.h"


int send_DbvExtendedServicesRsp_DbvEsTaskPackage_DbvInternationalString(int assoc_id)
{
        DbvAssocId      	lAssocId = assoc_id;
        DbvExtendedServicesRsp  *psExtendedServicesRsp = NULL;
        DbvError        	*psError = NULL;

        char *sutrs = "this is an extended service task package sutrs string";
        int choice = 0;
        char choice_string[100];

        /* Allocate memory for psExtendedServicesRsp and fill it in */
        psExtendedServicesRsp = (DbvExtendedServicesRsp *) DbvAlloc (sizeof(DbvExtendedServicesRsp));
        fill_DbvExtendedServicesRsp_common(psExtendedServicesRsp);
 
	/* Now fill in the external to be sent back in the DbvEsTaskPackage
	   field in the DbvExtendedServicesRsp */		  
        fill_dbv_sutrs_external(&psExtendedServicesRsp->psTaskPackage->uExternalValue.psSingleASN1Type->uASN1.psEsTaskPackage->sTaskSpecificParameters, sutrs);


        printf("Print ExtendedServicesResponse PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_extendrsp_fields(stdout, psExtendedServicesRsp);
                printf("-----------------------------------------\n");
        }
 

        /* Send ExtendedServicesResponse to client */
        if (DbvExtendedServicesResponse(lAssocId, psExtendedServicesRsp, &psError) == SI_OK)
        {

                SIFreeDbvExtendedServicesRsp(&psExtendedServicesRsp);

                return SI_OK;
        }  else {
                PrivateErrorHandling(&psError);

                SIFreeDbvExtendedServicesRsp(&psExtendedServicesRsp);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
                return SI_NOTOK;
        }
 
}
 
 

int fill_DbvExtendedServicesRsp_common(DbvExtendedServicesRsp *psExtendedServicesRsp)
{
 
        char *test_reference_id = "extend response reference id";
        int choice = 0;
        char choice_string[100];
 
        /* Compulsory fields */
 
        /* eOperationStatus */
        psExtendedServicesRsp->eOperationStatus = ESOS_Failure;
 
 
        /* Optional fields */
 

        /* Reference id */
        psExtendedServicesRsp->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
        fill_dbv_octet_string(psExtendedServicesRsp->psReferenceId, test_reference_id);
 
	/* ppsDiagnostics */
	psExtendedServicesRsp->ppsDiagnostics = (DbvDiagRec **) DbvAlloc (sizeof (DbvDiagRec *) * 4);
	fill_records_multidiag(psExtendedServicesRsp->ppsDiagnostics);

	/* psTaskPackage */
	psExtendedServicesRsp->psTaskPackage = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_DbvEsTaskPackage_DbvASN1External(psExtendedServicesRsp->psTaskPackage);

        /* psOtherInformation */

	/* Only have a single node in the list - 0, \0 */
        psExtendedServicesRsp->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 2);
        psExtendedServicesRsp->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
 
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 1 list node): char (1), bin (2), ext (3), obj (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
                fill_extend_response_othinfo_char(psExtendedServicesRsp->ppsOtherInformation[0]);
                break;
        case 2:
                fill_extend_response_othinfo_bin(psExtendedServicesRsp->ppsOtherInformation[0]);
                break;
        case 3:
                fill_extend_response_othinfo_ext(psExtendedServicesRsp->ppsOtherInformation[0]);
                break;
        case 4:
                fill_extend_response_othinfo_obj(psExtendedServicesRsp->ppsOtherInformation[0]);
                break;
        }

}
 



int fill_DbvEsTaskPackage_DbvASN1External(DbvASN1External *external)
{

/*
        char *oid = ANSI_ES_TASK_PACKAGE_RECORD;
*/

        char *oid = ISO_ES_TASK_PACKAGE_RECORD;

 
        external->pcObjectIdentifier = (char *) DbvAlloc (strlen(oid) + 1);
        memcpy(external->pcObjectIdentifier, oid, strlen(oid));
 
        external->eValueType = EVT_SingleASN1Type;
        external->uExternalValue.psSingleASN1Type = (DbvSingleASN1Type * ) DbvAlloc (sizeof (DbvSingleASN1Type));
        external->uExternalValue.psSingleASN1Type->eASN1Type = AT_EsTaskPackage;
        external->uExternalValue.psSingleASN1Type->uASN1.psEsTaskPackage= (struct DbvEsTaskPackage *) DbvAlloc (sizeof (struct DbvEsTaskPackage));
 
        fill_DbvEsTaskPackage(external->uExternalValue.psSingleASN1Type->uASN1.psEsTaskPackage);
}



int fill_DbvEsTaskPackage(DbvEsTaskPackage *psEsTaskPackage)
{
 
        char *test_oid = ANSI_AUSMARC;
/*
        char *sutrs = "this is an extended service task package sutrs string";
*/
        char *test_pack_name = "estaskpack test package name";
        char *test_userid = "estaskpack test user id";
        char *test_description = "estaskpack test description";
        char *test_target_ref = "estaskpack test target reference";
        char *test_gen_time = "19950216210627.3";
        int number_of_nodes = 0;
 
 
        /* Compulsory fields */
 
        /* DbvObjectIdentifier is a typeded char* */
        psEsTaskPackage->pcPackageType = (DbvObjectIdentifier) DbvAlloc (strlen(test_oid) +1);
        memcpy(psEsTaskPackage->pcPackageType, test_oid, strlen(test_oid));
 
 
        psEsTaskPackage->eExtServicesTaskStatus = ESTS_Pending;
 
/*
        fill_dbv_sutrs_external(&psEsTaskPackage->sTaskSpecificParameters, sutrs);
*/
 
 
        /* Optionals */
        psEsTaskPackage->psPackageName = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
        fill_dbv_inter_string(psEsTaskPackage->psPackageName, test_pack_name);
 
 
        psEsTaskPackage->psUserId = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
        fill_dbv_inter_string(psEsTaskPackage->psUserId, test_userid);
 
 
        psEsTaskPackage->psRetentionTime = (DbvIntUnit *) DbvAlloc (sizeof (DbvIntUnit));
        fill_intunit(psEsTaskPackage->psRetentionTime);
 
 
 
        /* Have a permissions list with 3 nodes - 0, 1, \0 */
        psEsTaskPackage->ppsPermissions = (DbvPermissions **) DbvAlloc (sizeof (DbvPermissions *) * 3);

        number_of_nodes = 3;
        fill_permissions_list(psEsTaskPackage->ppsPermissions, number_of_nodes);
 
 
        psEsTaskPackage->psDescription = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
        fill_dbv_inter_string(psEsTaskPackage->psDescription, test_description);
 
 
        psEsTaskPackage->psTargetReference = (DbvOctetString *) DbvAlloc (sizeof(DbvOctetString));
        fill_dbv_octet_string(psEsTaskPackage->psTargetReference, test_target_ref);
       
        /* DbvGeneralizedTime is a char * */
        psEsTaskPackage->pcCreationDateTime = (DbvGeneralizedTime) DbvAlloc (strlen(test_gen_time) + 1);
        strcpy(psEsTaskPackage->pcCreationDateTime, test_gen_time);
 
 
        /* Have a package diagnostics list with 4 nodes - 0, 1, 2 \0 */
        psEsTaskPackage->ppsPackageDiagnostics = (DbvDiagRec **) DbvAlloc (sizeof (DbvDiagRec *) * 4);
	fill_records_multidiag(psEsTaskPackage->ppsPackageDiagnostics);
 
}
 



int fill_extend_response_othinfo_char(DbvOtherInformation *psOtherInformation)
{
 
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 9;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my otherinfo extend response char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue,charinfo);
}
 
 

int fill_extend_response_othinfo_bin(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char bininfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 18;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my otherinfo extend response bin field");
 
        fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}
 
 

int fill_extend_response_othinfo_ext(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char bininfo[100];
        char sutrs_string[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 656;
        DbvASN1External *external = NULL;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my otherinfo bin field");
        strcpy(sutrs_string, "this is a extend response test otherinfo sutrs string");
 
        fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);
 
        /* Set up a sutrs external */
        external = psOtherInformation->uInformation.psExternallyDefinedInfo;
 
        fill_dbv_sutrs_external(external, sutrs_string);
}
 


int fill_extend_response_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
 
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 74;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
        fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
 
}
 




int send_DbvExtendedServicesRsp_DbvEsTaskPackage_DbvItemOrderExtendedService_DbvIllPdu(int assoc_id)
{
        DbvAssocId      	lAssocId = assoc_id;
        DbvExtendedServicesRsp  *psExtendedServicesRsp = NULL;
        DbvError        	*psError = NULL;
 
        int choice = 0;
        char choice_string[100];

        /* Allocate memory for psExtendedServicesRsp and fill it in */
        psExtendedServicesRsp = (DbvExtendedServicesRsp *) DbvAlloc (sizeof(DbvExtendedServicesRsp));
        fill_DbvExtendedServicesRsp_common(psExtendedServicesRsp);


	/* Now fill in the external to be sent back in the DbvEsTaskPackage
	   field in the DbvExtendedServicesRsp */		  

	/* set up Item Order (api_ill.c) */
        fill_DbvItemOrderExtendedService(&psExtendedServicesRsp->psTaskPackage->uExternalValue.psSingleASN1Type->uASN1.psEsTaskPackage->sTaskSpecificParameters, IOROR_Response);

	/* Add an ILL to be carried in the Item Order (api_ill.c) */
	psExtendedServicesRsp->psTaskPackage->uExternalValue.psSingleASN1Type->uASN1.psEsTaskPackage->sTaskSpecificParameters.uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderResponse->sTargetPart.psItemRequest = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
	fill_DbvIllPdu(psExtendedServicesRsp->psTaskPackage->uExternalValue.psSingleASN1Type->uASN1.psEsTaskPackage->sTaskSpecificParameters.uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderResponse->sTargetPart.psItemRequest);



        printf("Print ExtendedServicesResponse PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_extendrsp_fields(stdout, psExtendedServicesRsp);
                printf("-----------------------------------------\n");
        }
 

        /* Send ExtendedServicesResponse to client */
        if (DbvExtendedServicesResponse(lAssocId, psExtendedServicesRsp, &psError) == SI_OK)
        {

                SIFreeDbvExtendedServicesRsp(&psExtendedServicesRsp);

                return SI_OK;
        }  else {
                PrivateErrorHandling(&psError);

                SIFreeDbvExtendedServicesRsp(&psExtendedServicesRsp);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
                return SI_NOTOK;
        }
 
}




	
int send_DbvExtendedServicesRsp_DbvEsTaskPackage_DbvItemOrderExtendedService_DbvCOrder(int assoc_id)
{
        DbvAssocId      	lAssocId = assoc_id;
        DbvExtendedServicesRsp  *psExtendedServicesRsp = NULL;
        DbvError        	*psError = NULL;
 
        int choice = 0;
        char choice_string[100];

        /* Allocate memory for psExtendedServicesRsp and fill it in */
        psExtendedServicesRsp = (DbvExtendedServicesRsp *) DbvAlloc (sizeof(DbvExtendedServicesRsp));
        fill_DbvExtendedServicesRsp_common(psExtendedServicesRsp);


	/* Now fill in the external to be sent back in the DbvEsTaskPackage
	   field in the DbvExtendedServicesRsp */		  

	/* set up Item Order (api_ill.c) */
        fill_DbvItemOrderExtendedService(&psExtendedServicesRsp->psTaskPackage->uExternalValue.psSingleASN1Type->uASN1.psEsTaskPackage->sTaskSpecificParameters, IOROR_Response);

	/* Add a COrder to be carried in the Item Order (api_ill.c) */
	psExtendedServicesRsp->psTaskPackage->uExternalValue.psSingleASN1Type->uASN1.psEsTaskPackage->sTaskSpecificParameters.uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderResponse->sTargetPart.psItemRequest = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));

	/* in api_ill.c */
	fill_DbvCOrder(psExtendedServicesRsp->psTaskPackage->uExternalValue.psSingleASN1Type->uASN1.psEsTaskPackage->sTaskSpecificParameters.uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService->uItemOrderReqOrRsp.psItemOrderResponse->sTargetPart.psItemRequest);



        printf("Print ExtendedServicesResponse PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_extendrsp_fields(stdout, psExtendedServicesRsp);
                printf("-----------------------------------------\n");
        }
 

        /* Send ExtendedServicesResponse to client */
        if (DbvExtendedServicesResponse(lAssocId, psExtendedServicesRsp, &psError) == SI_OK)
        {

                SIFreeDbvExtendedServicesRsp(&psExtendedServicesRsp);

                return SI_OK;
        }  else {
                PrivateErrorHandling(&psError);

                SIFreeDbvExtendedServicesRsp(&psExtendedServicesRsp);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
                return SI_NOTOK;
        }
 
}








