#include "api_target_init.h"


int send_initrsp_to_origin(int assoc_id, DbvBool result)
{
        DbvAssocId         lAssocId = assoc_id;
        DbvInitializeRsp   *psInitializeRsp = NULL;
        DbvError           *psError = NULL;
 
	int choice = 0;
	char choice_string[100];

        /* Allocate memory for psInitializeRsp and fill it in */
        psInitializeRsp = (DbvInitializeRsp *) DbvAlloc (sizeof(DbvInitializeRsp));
        fill_init_response(psInitializeRsp,result);
 

        printf("Print InitializeResponse PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_initrsp_fields(stdout, psInitializeRsp);
                printf("-----------------------------------------\n");
        }
 

        /* Send InitializeResponse just filled in to origin */
        if (DbvInitializeResponse(lAssocId, psInitializeRsp, &psError) == SI_OK)
{

		/* Sent PDU to origin ok so free up space it used */

                SIFreeDbvInitializeRsp(&psInitializeRsp);

		return SI_OK;
        } else {


		/* The attempt to send the PDU to the origin failed */  
                PrivateErrorHandling(&psError);

                SIFreeDbvInitializeRsp(&psInitializeRsp);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
		return SI_NOTOK;
        }
}
 
 
 
 

int fill_init_response(DbvInitializeRsp *psInitializeRsp, DbvBool result)
{

	/* Just to prove that we can have any length bit string ... */
        char *test_protocol_version = "111";
        char *test_options = ALLOWED_OPTIONS;
        char *test_reference_id = "init response reference id";

        int choice = 0;
        char choice_string[100];

	char test_impid[100], test_impname[100],  test_impver[100];

	strcpy(test_impid, "DBV-OSI II UNIX API");
	strcpy(test_impname, "ImplementationName result");
	strcpy(test_impver, "ImplementationVersion result");

 

        /* Compulsory fields ... */
 
        /* Protocol Version */

	/* +1 to allocate space for the \0 */

        psInitializeRsp->pcProtocolVersion = (DbvProtocolVersion) DbvAlloc (strlen(test_protocol_version) + 1);
	memcpy(psInitializeRsp->pcProtocolVersion, test_protocol_version, strlen(test_protocol_version));

        /* Options */



	/* +1 to allocate space for the \0 */

        psInitializeRsp->pcOptions = (DbvOptions) DbvAlloc (strlen(test_options) + 1);
        memcpy(psInitializeRsp->pcOptions, test_options, strlen(test_options));
 

        /* Prefered message size */
        psInitializeRsp->ulPreferredMessageSize = 7500;
 
        /* Maximum message size */
        psInitializeRsp->ulMaximumMessageSize = 8000;
 

	/* Result (true or false) */
	psInitializeRsp->fResult = result;



        /* Optional fields */
 
	/* un-comment the following to setup reference id */

/*
        psInitializeRsp->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
	fill_dbv_octet_string(psInitializeRsp->psReferenceId, test_reference_id) ;
*/

 
	/* Implementation Id */
        psInitializeRsp->psImplementationId = (DbvInternationalString *) DbvAlloc(sizeof(DbvInternationalString));
	fill_dbv_inter_string(psInitializeRsp->psImplementationId, test_impid);



	/* Implementation Name */

        psInitializeRsp->psImplementationName = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
	fill_dbv_inter_string(psInitializeRsp->psImplementationName, test_impname);


	/* Implementation Version */

        psInitializeRsp->psImplementationVersion = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
	fill_dbv_inter_string(psInitializeRsp->psImplementationVersion, test_impver);


	/* Un-comment the following C functions to demonstrate filling
	   in userInformationField */
/*
        psInitializeRsp->psUserInformationField = (DbvASN1External *) DbvAlloc(sizeof(DbvASN1External));
        fill_init_response_userinfo(psInitializeRsp->psUserInformationField);
*/
 

	/* Un-comment the following C functions to demonstrate filling
	   in OtherInformation */
/*
        psInitializeRsp->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation) * 3);
        psInitializeRsp->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
        psInitializeRsp->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));

        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), obj (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
        	fill_init_response_othinfo_char(psInitializeRsp->ppsOtherInformation[0]);
        	fill_init_response_othinfo_char(psInitializeRsp->ppsOtherInformation[1]);
		break;
	case 2:
        	fill_init_response_othinfo_bin(psInitializeRsp->ppsOtherInformation[0]);
        	fill_init_response_othinfo_bin(psInitializeRsp->ppsOtherInformation[1]);
		break;
	case 3:
        	fill_init_response_othinfo_ext(psInitializeRsp->ppsOtherInformation[0]);
        	fill_init_response_othinfo_ext(psInitializeRsp->ppsOtherInformation[1]);
		break;
	case 4:
        	fill_init_response_othinfo_obj(psInitializeRsp->ppsOtherInformation[0]);
        	fill_init_response_othinfo_obj(psInitializeRsp->ppsOtherInformation[1]);
		break;
	}

*/
 

}
 
 
int fill_init_response_userinfo(DbvASN1External *external)
{
 
	char sutrs[1000];
	char alignedstr[1000];
	char oid[100];
	char oid2[100];
	char arbstr[1000];
	int choice = 0;
        char choice_string[100];

        strcpy(sutrs, "this is my init response userinfo sutrs string");
        strcpy(alignedstr, "this is my aligned string");
        strcpy(oid, ANSI_USMARC);
        strcpy(oid2, ANSI_NORMARC);
        strcpy(arbstr, "0101010101010101111111111100000000001111111111");

        choice = 0;
        while (choice < 1 || choice > 3) {
                printf("Enter userinfo external type: sutrs (1), aligned (2), arbitrary (3): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
	case 1: 
		fill_dbv_sutrs_external(external, sutrs);
		break;
	case 2:
		/* Third parameter is the optional oid, pass in NULL if dont want one */
		fill_dbv_aligned_external(external, alignedstr, NULL);
		break;
/*
		fill_dbv_aligned_external(external, alignedstr, oid);
*/
		break;
	case 3:

		/* Third parameter is the optional oid, pass in NULL if dont want one */

		fill_dbv_arbitrary_external(external, arbstr, NULL);
/*
		fill_dbv_arbitrary_external(external, arbstr, oid2);
*/
		break;
	}

}


 

int fill_init_response_othinfo_char(DbvOtherInformation *psOtherInformation)
{
	char oid[100]; 
	char charinfo[100];

	DbvBool want_infocat = DBV_TRUE;
	unsigned long catvalue = 9; 

	strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
	strcpy(charinfo, "this is my otherinfo init response char field");

	fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}




int fill_init_response_othinfo_bin(DbvOtherInformation *psOtherInformation)
{

	char oid[100];
	char bininfo[100];

	DbvBool want_infocat = DBV_TRUE;
	unsigned long catvalue = 18; 

	strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
	strcpy(bininfo, "this is my otherinfo init response bin field");

	fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}



int fill_init_response_othinfo_ext(DbvOtherInformation *psOtherInformation)
{

	char oid[100];
	char bininfo[100];
	char sutrs_string[100];

	DbvBool want_infocat = DBV_TRUE;
	unsigned long catvalue = 656; 
	DbvASN1External *external = NULL;

	strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
	strcpy(bininfo, "this is my otherinfo bin field");
	strcpy(sutrs_string, "this is a test otherinfo sutrs string");

	fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);

	/* Set up a sutrs external */
	external = psOtherInformation->uInformation.psExternallyDefinedInfo;
	fill_dbv_sutrs_external(external, sutrs_string);
}




int fill_init_response_othinfo_obj(DbvOtherInformation *psOtherInformation)
{

	char infooid[100];
	char otheroid[100];

	DbvBool want_infocat = DBV_TRUE;
	unsigned long catvalue = 74; 

	strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
	strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);

	fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);

}


 


int send_initrsp_charset_to_origin(int assoc_id, DbvBool result)
{
        DbvAssocId         lAssocId = assoc_id;
        DbvInitializeRsp   *psInitializeRsp = NULL;
        DbvError           *psError = NULL;
 
	int choice = 0;
	char choice_string[100];

        /* Allocate memory for psInitializeRsp and fill it in */
        psInitializeRsp = (DbvInitializeRsp *) DbvAlloc (sizeof(DbvInitializeRsp));
        fill_init_response(psInitializeRsp,result);
 

	/* Now add the CharSetAndLanguage external */
	psInitializeRsp->psUserInformationField = (DbvASN1External *) DbvAlloc ( sizeof (DbvASN1External));
        fill_DbvCharSetAndLanguage_external(psInitializeRsp->psUserInformationField);
	

        printf("Print InitializeResponse PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_initrsp_fields(stdout, psInitializeRsp);
                printf("-----------------------------------------\n");
        }
 

        /* Send InitializeResponse just filled in to origin */
        if (DbvInitializeResponse(lAssocId, psInitializeRsp, &psError) == SI_OK)
{

		/* Sent PDU to origin ok so free up space it used */
                SIFreeDbvInitializeRsp(&psInitializeRsp);
		return SI_OK;
        } else {


		/* The attempt to send the PDU to the origin failed */  
                PrivateErrorHandling(&psError);
                SIFreeDbvInitializeRsp(&psInitializeRsp);
 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
		return SI_NOTOK;
        }
}




