#include "api_target_pres.h"


int send_presrsp_to_origin(int assoc_id)
{

	DbvAssocId	lAssocId = assoc_id;
	DbvPresentRsp	*psPresentRsp = NULL;
	DbvError	*psError = NULL;
 

        int choice = 0;
        char choice_string[100];
 
	/* Allocate memory for psPresentRsp and fill it in */
	psPresentRsp = (DbvPresentRsp *) DbvAlloc (sizeof(DbvPresentRsp));
	fill_pres_response(psPresentRsp);
	 
	printf("Print PresentResponse PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_presrsp_fields(stdout, psPresentRsp);
                printf("-----------------------------------------\n");
        }
 

	/* Send PresentResponse to client */
	if (DbvPresentResponse(lAssocId, psPresentRsp, &psError) == SI_OK)
	{

		SIFreeDbvPresentRsp(&psPresentRsp);

		return SI_OK;
	}  else {
		PrivateErrorHandling(&psError);

		SIFreeDbvPresentRsp(&psPresentRsp);


		/* Release buffer, assign NULL pointer */
		FreeSIErrorCode(&psError);
		return SI_NOTOK;
	}
}




int fill_pres_response(DbvPresentRsp *psPresentRsp)
{

	char *test_reference_id = "present response reference id";
        int choice = 0;
        char choice_string[100];


	/* Compulsory fields */

	/* ulNumberOfRecordsReturned */
	psPresentRsp->ulNumberOfRecordsReturned = 1;

	/* ulNextResultSetPosition */
	psPresentRsp->ulNextResultSetPosition = 2;

	/* ePresentStatus */
	psPresentRsp->ePresentStatus = PS_Success;



	/* Optional fields */
	
	/* Reference id */

/*
	psPresentRsp->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
	fill_dbv_octet_string(psPresentRsp->psReferenceId, test_reference_id);
*/


	/* Records */
	psPresentRsp->psRecords = (DbvRecords *) DbvAlloc (sizeof(DbvRecords));
	fill_present_records(psPresentRsp->psRecords);


	/* psOtherInformation */

	/* uncomment following to use ... */
/*
        psPresentRsp->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);
        psPresentRsp->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
        psPresentRsp->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));

	choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), obj (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
        	fill_pres_response_othinfo_char(psPresentRsp->ppsOtherInformation[0]);
        	fill_pres_response_othinfo_char(psPresentRsp->ppsOtherInformation[1]);
		break;
	case 2:
        	fill_pres_response_othinfo_bin(psPresentRsp->ppsOtherInformation[0]);
        	fill_pres_response_othinfo_bin(psPresentRsp->ppsOtherInformation[1]);
		break;
	case 3:
        	fill_pres_response_othinfo_ext(psPresentRsp->ppsOtherInformation[0]);
        	fill_pres_response_othinfo_ext(psPresentRsp->ppsOtherInformation[1]);
		break;
	case 4:
        	fill_pres_response_othinfo_obj(psPresentRsp->ppsOtherInformation[0]);
        	fill_pres_response_othinfo_obj(psPresentRsp->ppsOtherInformation[1]);
		break;
	}
*/

 
}
 


int fill_present_records(DbvRecords *psRecords)
{

	char *oid1 = ANSI_LIBRISMARC;
	unsigned long condition1 = 2;
	char *ver2diag = "version 2 diagnostic";

	char *oid2= ANSI_PICAMARC;
	unsigned long condition2= 4;
	char *ver3diag = "version 3 diagnostic";

        int choice = 0, choice_low = 0, choice_high = 0;
	char *choice_menu = NULL;
        char choice_string[100];

        choice = 0;

        choice_low  = 1;
	choice_high = 10;
	choice_menu = "Enter psRecords type: sutrs (1), opac (2), summary (3), surrdiag (4), nonsurrdiag-pcV2 (5), nonsurrdiag-pcV3 (6), multnonsurrdiag (7), octetaligned (8), arbitrary (9), example explain (10): ";


        while (choice < choice_low || choice > choice_high) {
                printf("%s", choice_menu);
                choice = (atol(gets(choice_string)));
        }
	
        switch (choice) {
        case 1:

		/* 3 Response Records - NamePlusRecord:3 Sutrs Retrieval Records   */
		psRecords->eRecordType = RT_Response;

		/* Create 3 records, 0, 1, 2, \0 */
		psRecords->uRecord.ppsResponseRecord = (DbvNamePlusRecord **) DbvAlloc (sizeof(DbvNamePlusRecord *) * 4);
		fill_records_sutrs(psRecords->uRecord.ppsResponseRecord);
		break;

	case 2:

		/* 3 Response Records - NamePlusRecord:3 Opac Retrieval Records   */
		psRecords->eRecordType = RT_Response;

		/* Create 3 records, 0, 1, 2, \0 */

		psRecords->uRecord.ppsResponseRecord = (DbvNamePlusRecord **) DbvAlloc (sizeof(DbvNamePlusRecord *) * 4);
	
		fill_records_opac(psRecords->uRecord.ppsResponseRecord);
		break;

	case 3:

		/* 3 Response Records - NamePlusRecord:3 Summary Retrieval Records   */
		psRecords->eRecordType = RT_Response;

		/* Create 3 records, 0, 1, 2, \0 */
		psRecords->uRecord.ppsResponseRecord = (DbvNamePlusRecord **) DbvAlloc (sizeof(DbvNamePlusRecord *) * 4);
	
		fill_records_summary(psRecords->uRecord.ppsResponseRecord);
		break;
	case 4:
	
		/* 3 Response Records - NamePlusRecord:3 SurrogateDiagnostics, mixture of DbvDefaultDiagFormat and DbvASN1External  */
		psRecords->eRecordType = RT_Response;

		/* Create 3 records, 0, 1, 2, \0 */
		psRecords->uRecord.ppsResponseRecord = (DbvNamePlusRecord **) DbvAlloc (sizeof(DbvNamePlusRecord *) * 4);

		fill_records_surrdiag(psRecords->uRecord.ppsResponseRecord);
		break;

	case 5:

		/* A psNonSurrogateDiag - with pcV2 */

		psRecords->eRecordType = RT_NonSurrDiagnostics;
		psRecords->uRecord.psNonSurrogateDiag = (DbvDefaultDiagFormat *) DbvAlloc (sizeof(struct DbvDefaultDiagFormat));
		fill_default_diag_format_v2(psRecords->uRecord.psNonSurrogateDiag, oid1, condition1, ver2diag);

		break;

	case 6:
		/* A psNonSurrogateDiag - with psV3 */
		psRecords->eRecordType = RT_NonSurrDiagnostics;
		psRecords->uRecord.psNonSurrogateDiag = (DbvDefaultDiagFormat *) DbvAlloc (sizeof(struct DbvDefaultDiagFormat));
		fill_default_diag_format_v3(psRecords->uRecord.psNonSurrogateDiag, oid2, condition2, ver3diag);

		break;
	case 7:

		/* 3 multiple non surrogate diagnostics - a psDefault (additional info V2)  
   		an psExternallyDefined and another psDefault (additional info V3)  */
		psRecords->eRecordType = RT_MultipleNonSurrDiagnostics;

		/* Create 3 records, 0, 1, 2, \0 */
		psRecords->uRecord.ppsMultipleNonSurrogateDiag = (DbvDiagRec **) DbvAlloc (sizeof(DbvDiagRec *) * 4);
		fill_records_multidiag(psRecords->uRecord.ppsMultipleNonSurrogateDiag);
		break;
	case 8:

		/* 3 octetaligned externals - octetaligned is returned by all 
   		V2 MARC based targets (e.g. Cansearch). 
   		Although MARC responses from V2 targets are just
   		octetaligned strings [effectively char*], when they are 
   		appropriatly formatted they can generate a lot of information
   		(author, date, references etc.) */
   	 
		psRecords->eRecordType = RT_Response;
	
		/* Create 3 records, 0, 1, 2, \0 */
		psRecords->uRecord.ppsResponseRecord = (DbvNamePlusRecord **) DbvAlloc (sizeof(DbvNamePlusRecord *) * 4);
	
		fill_records_octetaligned(psRecords->uRecord.ppsResponseRecord);
		break;

	case 9:

		/* 3 arbitrary externals - I know of no targets anywhere in the world 
   		which return as search/present response 
   		records a list of arbitrarys (bit strings) - its in
   		the spec though so its possible....
		*/
		psRecords->eRecordType = RT_Response;

		/* Create 3 records, 0, 1, 2, \0 */
		psRecords->uRecord.ppsResponseRecord = (DbvNamePlusRecord **) DbvAlloc (sizeof(DbvNamePlusRecord *) * 4);
	
		fill_records_arbitrary(psRecords->uRecord.ppsResponseRecord);
		break;

	case 10:

		/* pseudo explain database - 1 explain record */
		psRecords->eRecordType = RT_Response;

		/* Create 1 records [2 nodes]: 0, \0 */
		psRecords->uRecord.ppsResponseRecord = (DbvNamePlusRecord **) DbvAlloc (sizeof(DbvNamePlusRecord *) * 2);
	
		fill_records_explain(psRecords->uRecord.ppsResponseRecord);
		break;

	}
 



}

 

int fill_records_sutrs(DbvNamePlusRecord **ppsResponseRecord)
{
	char *dbname0 = "database 0";
	char *dbname1 = NULL;
	char *dbname2 = "database 2";

	DbvASN1External *external0 = NULL;
	DbvASN1External *external1 = NULL;
	DbvASN1External *external2 = NULL;

	ppsResponseRecord[0] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external0 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_dbv_sutrs_external(external0, "this is my first sutrs external");
	fill_dbv_nameplus_rec(ppsResponseRecord[0], dbname0, external0);
	
	ppsResponseRecord[1] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external1 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_dbv_sutrs_external(external1, "this is my second sutrs external");
	fill_dbv_nameplus_rec(ppsResponseRecord[1], dbname1, external1);
	
	ppsResponseRecord[2] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external2 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_dbv_sutrs_external(external2, "this is my third sutrs external");
	fill_dbv_nameplus_rec(ppsResponseRecord[2], dbname2, external2);
	
	ppsResponseRecord[3] = NULL;
}


int fill_records_opac(DbvNamePlusRecord **ppsResponseRecord)
{
	char *dbname0 = "database 0";
	char *dbname1 = NULL;
	char *dbname2 = "database 2";

	DbvASN1External *external0 = NULL;
	DbvASN1External *external1 = NULL;
	DbvASN1External *external2 = NULL;

	ppsResponseRecord[0] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external0 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_response_opac(external0);
	fill_dbv_nameplus_rec(ppsResponseRecord[0], dbname0, external0);
	
	ppsResponseRecord[1] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external1 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_response_opac(external1);
	fill_dbv_nameplus_rec(ppsResponseRecord[1], dbname1, external1);
	
	
	ppsResponseRecord[2] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external2 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_response_opac(external2);
	fill_dbv_nameplus_rec(ppsResponseRecord[2], dbname2, external2);
	
	
	ppsResponseRecord[3] = NULL;
}



int fill_records_summary(DbvNamePlusRecord **ppsResponseRecord)
{

	char *dbname0 = "database 0";
	char *dbname1 = NULL;
	char *dbname2 = "database 2";

	DbvASN1External *external0 = NULL;
	DbvASN1External *external1 = NULL;
	DbvASN1External *external2 = NULL;

	
	ppsResponseRecord[0] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external0 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_response_summary(external0);
	fill_dbv_nameplus_rec(ppsResponseRecord[0], dbname0, external0);
	
	ppsResponseRecord[1] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external1 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_response_summary(external1);
	fill_dbv_nameplus_rec(ppsResponseRecord[1], dbname1, external1);
	
	ppsResponseRecord[2] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external2 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_response_summary(external2);
	fill_dbv_nameplus_rec(ppsResponseRecord[2], dbname2, external2);
	
	ppsResponseRecord[3] = NULL;
}


int fill_records_surrdiag(DbvNamePlusRecord **ppsResponseRecord)
{
	char *diag_dbname0 = "diag database 0";
	char *diag_dbname1 = NULL;
	char *diag_dbname2 = "diag database 2";

	DbvASN1External *external = NULL;
	DbvASN1External *external0 = NULL;
	DbvASN1External *external1 = NULL;
	DbvASN1External *external2 = NULL;

	ppsResponseRecord[0] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	
	/* DbvDiagRec, DbvDefaultDiagFormat V3 */
	fill_dbv_nrec_diagn_default(ppsResponseRecord[0], diag_dbname0, ANSI_LIBRISMARC, 33, "diag text for v3", PVIF_Version3, DT_DefaultFormat, NULL);
	
	ppsResponseRecord[1] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	
	/* DbvDiagRec, DbvASN1External */
	/* Create an external to pass down */
	external = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
	fill_dbv_sutrs_external(external, "this is a diagnostic sutrs external");
	fill_dbv_nrec_diagn_default(ppsResponseRecord[1], diag_dbname1,  NULL, 0, NULL, 0, DT_ExternallyDefined, external);
	
	ppsResponseRecord[2] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
		
	
	/* DbvDiagRec, DbvDefaultDiagFormat V2 */
	fill_dbv_nrec_diagn_default(ppsResponseRecord[2], diag_dbname2, ANSI_DANMARC, 44, "diag text for v2", PVIF_Version2, DT_DefaultFormat, NULL);
	
	ppsResponseRecord[3] = NULL;
}



int fill_records_octetaligned(DbvNamePlusRecord **ppsResponseRecord)
{
	
	char *dbname0 = "database 0";
	char *dbname1 = NULL;
	char *dbname2 = "database 2";

	DbvASN1External *external0 = NULL;
	DbvASN1External *external1 = NULL;
	DbvASN1External *external2 = NULL;

	ppsResponseRecord[0] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external0 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_dbv_aligned_external(external0, "aligned data 0", ANSI_UNSTRUCTURED_TEXT_RECORD);
	fill_dbv_nameplus_rec(ppsResponseRecord[0], dbname0, external0);

	ppsResponseRecord[1] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external1 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_dbv_aligned_external(external1, "aligned data 1", ANSI_UNSTRUCTURED_TEXT_RECORD);
	fill_dbv_nameplus_rec(ppsResponseRecord[1], dbname1, external1);

	ppsResponseRecord[2] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external2 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_dbv_aligned_external(external2, "aligned data 2", ANSI_UNSTRUCTURED_TEXT_RECORD);
	fill_dbv_nameplus_rec(ppsResponseRecord[2], dbname2, external2);
	
	ppsResponseRecord[3] = NULL;
}


int fill_records_arbitrary(DbvNamePlusRecord **ppsResponseRecord)
{
	char *dbname0 = "database 0";
	char *dbname1 = NULL;
	char *dbname2 = "database 2";

	DbvASN1External *external0 = NULL;
	DbvASN1External *external1 = NULL;
	DbvASN1External *external2 = NULL;

	ppsResponseRecord[0] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external0 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_dbv_arbitrary_external(external0, "0101010101010101", NULL);
	fill_dbv_nameplus_rec(ppsResponseRecord[0], dbname0, external0);
	
		
	ppsResponseRecord[1] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external1 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_dbv_arbitrary_external(external1, "1111000011110000", NULL);
	fill_dbv_nameplus_rec(ppsResponseRecord[1], dbname1, external1);
	
	ppsResponseRecord[2] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external2 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_dbv_arbitrary_external(external2, "11111", ANSI_PICAMARC);
	fill_dbv_nameplus_rec(ppsResponseRecord[2], dbname2, external2);

	ppsResponseRecord[3] = NULL;
}



int fill_response_opac(DbvASN1External *external)
{

	char *oid = ANSI_OPAC_RECORD;

	/* ALWAYS SUPPLY AN OID WITH SINGLE ASN1 TYPE */
	/* +1 to copy the \0 */
	external->pcObjectIdentifier = (char *) DbvAlloc (strlen(oid) + 1);

	memcpy(external->pcObjectIdentifier, oid, strlen(oid));

	external->eValueType = EVT_SingleASN1Type;
	external->uExternalValue.psSingleASN1Type = (DbvSingleASN1Type * ) DbvAlloc (sizeof (DbvSingleASN1Type));
	external->uExternalValue.psSingleASN1Type->eASN1Type = AT_OpacRecord;
	external->uExternalValue.psSingleASN1Type->uASN1.psOpacRecord = (struct DbvOpacRecord *) DbvAlloc (sizeof (struct DbvOpacRecord));

	fill_the_opac(external->uExternalValue.psSingleASN1Type->uASN1.psOpacRecord);

}



int fill_the_opac(struct DbvOpacRecord *psOpacRecord)
{
	
	char *sutrs = "this is a sutrs string";

	
	/* psBibliographicRecord */
	psOpacRecord->psBibliographicRecord = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_dbv_sutrs_external(psOpacRecord->psBibliographicRecord, sutrs);


	/* ppsHoldingsData - have 2 list nodes */
	psOpacRecord->ppsHoldingsData = (DbvHoldingsRecord **) DbvAlloc (sizeof (DbvHoldingsRecord *) * 3) ;

	/* First node */
	psOpacRecord->ppsHoldingsData[0] = (DbvHoldingsRecord *) DbvAlloc(sizeof (DbvHoldingsRecord));
	fill_holdings_record1(psOpacRecord->ppsHoldingsData[0]);

	/* Second node */
	psOpacRecord->ppsHoldingsData[1] = (DbvHoldingsRecord *) DbvAlloc(sizeof (DbvHoldingsRecord));
	fill_holdings_record2(psOpacRecord->ppsHoldingsData[1]);


	/* Terminater */
	psOpacRecord->ppsHoldingsData[2] = NULL;

}



/* The nature of OPAC records means it is quite involved to write a
 generic set up function (although it could be done) 
 - hence the following .... */
int fill_holdings_record1(DbvHoldingsRecord *psHoldingsData)
{
	char *sutrs = "this is a sutrs string";

	/* Have a MarcHoldingsRecord here */
	psHoldingsData->eHoldingsRecType = HRT_MarcHoldingsRecord;
	fill_dbv_sutrs_external(&psHoldingsData->uMarcOrHoldAndCirc.sMarcHoldingsRecord, sutrs);
}


/* The nature of the following means it is really too complex to be passing
parameters down */
int fill_holdings_record2(DbvHoldingsRecord *psHoldingsData)
{
	char *sutrs = "this is a sutrs string";
	char *rec_type = "test record type";
	char *enc_level = "test encoding level";
	char *format = "test format";
	char *rec_acq_stat = "test rec_acq_stat";
	char *gen_ret = "test gen_ret";
	char *completness = "test completness";
	char *date_report = "test date_report";
	char *nuc_code = "test nuc_code";
	char *local_loc = "test local_loc";
	char *shelv_loc = "test shelv_loc";
	char *call_num = "test call_num";
	char *shelv_data = "test shelv_data";
	char *copy_num = "test copy_num";
	char *pub_note = "test pub_note";
	char *repo_note = "test repo_note";
	char *terms_use_repo = "test terms_use_repo";
	char *enum_and_chron = "test enum_and_chron";

	DbvBool myfAvailableNow = DBV_TRUE;
	char *mypsAvailabilityDate = "test psAvailabilityDate";
	char *mypsAvailableThru = "test psAvailableThru"; 
	char *mypsRestrictions = "test psRestrictions";
	char *mypsItemId = "psItemId";
	DbvBool myfRenewable = DBV_FALSE;
	DbvBool myfOnHold = DBV_TRUE;
	char *mypsEnumAndChron = "test psEnumAndChron";
	char *mypsMidspine = "test psMidspine";
	char *mypsTemporaryLocation = "test psTemporaryLocation";

	/* Have a HoldingsAndCirc here */
	psHoldingsData->eHoldingsRecType = HRT_HoldingsAndCirc;

	fill_holdings_bulk(& (psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc),
		rec_type,
		enc_level,
		NULL,
		rec_acq_stat,
		gen_ret,
		completness,
		date_report,
		nuc_code,
		local_loc,
		shelv_loc,
		call_num,
		shelv_data,
		copy_num,
		pub_note,
		repo_note,
		terms_use_repo,
		enum_and_chron
	);


	/* Right, now an optional list of volume - create a list with
	   two nodes */



	psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc.ppsVolume = (DbvVolume **) DbvAlloc (sizeof(DbvVolume *) * 3);

	/* First node */
	psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc.ppsVolume[0] = (DbvVolume *) DbvAlloc (sizeof (DbvVolume));
	fill_volume(psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc.ppsVolume[0], "enum1", "chron1", "enum and chron 1");

	/* Second node - dont have a chron */
	psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc.ppsVolume[1] = (DbvVolume *) DbvAlloc (sizeof (DbvVolume));
	
	fill_volume(psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc.ppsVolume[1], "enum2", NULL, "enum and chron 2");

	/* Terminating node */
	psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc.ppsVolume[2] = NULL;
	

	/* DbvCircRecord  - create a list with two nodes 0, 1 \0 */
	psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc.ppsCircRecord = (DbvCircRecord **) DbvAlloc (sizeof(DbvCircRecord *) * 3);

	/* First node */
	psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc.ppsCircRecord[0] = (DbvCircRecord *) DbvAlloc (sizeof (DbvCircRecord));
	fill_circrec(psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc.ppsCircRecord[0], 
		myfAvailableNow,
		NULL,
		mypsAvailableThru,
		mypsRestrictions,
		mypsItemId,
		myfRenewable,
		myfOnHold,
		mypsEnumAndChron,
		NULL,
		mypsTemporaryLocation
	);


	/* Second node */
	psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc.ppsCircRecord[1] = (DbvCircRecord *) DbvAlloc (sizeof (DbvCircRecord));
	fill_circrec(psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc.ppsCircRecord[1], 
		myfAvailableNow,
		NULL,
		mypsAvailableThru,
		mypsRestrictions,
		mypsItemId,
		myfRenewable,
		myfOnHold,
		mypsEnumAndChron,
		NULL,
		mypsTemporaryLocation
	);


	/* Terminator */
	psHoldingsData->uMarcOrHoldAndCirc.sHoldingsAndCirc.ppsCircRecord[2] = NULL;

	
}



int fill_holdings_bulk(DbvHoldingsAndCircData *psHoldingsAndCirc,
		char *rec_type,
		char *enc_level,
		char *format,
		char *rec_acq_stat,
		char *gen_ret,
		char *completness,
		char *date_report,
		char *nuc_code,
		char *local_loc,
		char *shelv_loc,
		char *call_num,
		char *shelv_data,
		char *copy_num,
		char *pub_note,
		char *repo_note,
		char *terms_use_repo,
		char *enum_and_chron
	)
{


	/* Now for the gallons of holdings record ..... */

	/* psTypeOfRecord */ 

	psHoldingsAndCirc->psTypeOfRecord = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psTypeOfRecord, rec_type);


	/* psEncodingLevel */ 
	psHoldingsAndCirc->psEncodingLevel = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psEncodingLevel, enc_level);



	/* psFormat - check for NULL just as an aditional check of the API */ 
	if (psHoldingsAndCirc->psFormat != NULL) {
		psHoldingsAndCirc->psFormat = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(psHoldingsAndCirc->psFormat, format);
	}

	/* psReceiptAcqStatus */ 
	psHoldingsAndCirc->psReceiptAcqStatus = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psReceiptAcqStatus, rec_acq_stat);

	/* psGeneralRetention */ 
	psHoldingsAndCirc->psGeneralRetention = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psGeneralRetention, gen_ret);


	/* psCompleteness */ 
	psHoldingsAndCirc->psCompleteness = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psCompleteness, completness);

	/* psDateOfReport */ 
	psHoldingsAndCirc->psDateOfReport = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psDateOfReport, date_report);

	/* psNucCode */ 
	psHoldingsAndCirc->psNucCode = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psNucCode, nuc_code);

	/* psLocalLocation */ 
	psHoldingsAndCirc->psLocalLocation = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psLocalLocation, local_loc);

	/* psShelvingLocation */ 
	psHoldingsAndCirc->psShelvingLocation = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psShelvingLocation, shelv_loc);

	/* psCallNumber */ 
	psHoldingsAndCirc->psCallNumber = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psCallNumber, call_num);

	/* psShelvingDate */ 
	psHoldingsAndCirc->psShelvingData = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psShelvingData, shelv_data);

	/* psCopyNumber */ 
	psHoldingsAndCirc->psCopyNumber = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psCopyNumber, copy_num);

	/* psPublicNote */ 
	psHoldingsAndCirc->psPublicNote = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psPublicNote, pub_note);

	/* psReproductionNote */ 
	psHoldingsAndCirc->psReproductionNote = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psReproductionNote, repo_note);

	/* psTermsUseRepro */ 
	psHoldingsAndCirc->psTermsUseRepro = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psTermsUseRepro, terms_use_repo);

	/* psEnumAndChron */ 
	psHoldingsAndCirc->psEnumAndChron = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
	fill_dbv_inter_string(psHoldingsAndCirc->psEnumAndChron, enum_and_chron);
}
 


int fill_volume(DbvVolume *psVolume, char *enum_var, char *chron, char *enumandchron)
{

	if (enum_var != NULL) { 
		psVolume->psEnumeration = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(psVolume->psEnumeration, enum_var);
	}
	
	if (chron != NULL) {
		psVolume->psChronology = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(psVolume->psChronology, chron);
	}

	
	if (enumandchron != NULL) {
		psVolume->psEnumAndChron = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(psVolume->psEnumAndChron, enumandchron);
	}

}
	


int fill_circrec(DbvCircRecord *ppsCircRecord,
	DbvBool myfAvailableNow,
	char *mypsAvailabilityDate,
	char *mypsAvailableThru,
	char *mypsRestrictions,
	char *mypsItemId,
	DbvBool myfRenewable,
	DbvBool myfOnHold,
	char *mypsEnumAndChron,
	char *mypsMidspine,
	char *mypsTemporaryLocation
)
{
	/* First node */

	ppsCircRecord->fAvailableNow = myfAvailableNow;

	if (mypsAvailabilityDate != NULL) {
		ppsCircRecord->psAvailabilityDate = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(ppsCircRecord->psAvailabilityDate, mypsAvailabilityDate);
	}
	
	if (mypsAvailableThru != NULL) {
		ppsCircRecord->psAvailableThru = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(ppsCircRecord->psAvailableThru, mypsAvailableThru);
	}
	
	if (mypsRestrictions != NULL) {
		ppsCircRecord->psRestrictions = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(ppsCircRecord->psRestrictions, mypsRestrictions);
	}
	
	if (mypsItemId != NULL) {
		ppsCircRecord->psItemId = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(ppsCircRecord->psItemId, mypsItemId);
	}
	
	ppsCircRecord->fRenewable = myfRenewable;
	ppsCircRecord->fOnHold = myfOnHold;

	if (mypsEnumAndChron != NULL) {
		ppsCircRecord->psEnumAndChron = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(ppsCircRecord->psEnumAndChron, mypsEnumAndChron);
	}
	
	if (mypsMidspine != NULL) {
		ppsCircRecord->psMidspine = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(ppsCircRecord->psMidspine, mypsMidspine);
	}
	
	if (mypsTemporaryLocation != NULL) {
		ppsCircRecord->psTemporaryLocation = (DbvInternationalString *) DbvAlloc (sizeof(DbvInternationalString));
		fill_dbv_inter_string(ppsCircRecord->psTemporaryLocation, mypsTemporaryLocation);
	}

}



int fill_response_summary(DbvASN1External *external)
{
	char *title = "title";
	char *author = NULL;
	char *callnum = "call number";
	char *rectype = "record type";
	char *biblevel = "bib level";

	DbvFormatSpec **myformat = NULL;
	char *pubplace = "pub place";
	char *pubdate = "pub date";
	char *targetkey = "target key";
	char *satelmnt = "satisfy";
	unsigned long rank = 123456;
	char *docid = NULL;
	char *abstract = "abstract";

	DbvOtherInformation *myother = NULL;


	/* Create a ppsFormat list with two nodes */
	myformat = (DbvFormatSpec **) DbvAlloc (sizeof (DbvFormatSpec *) * 3);
	fill_summary_format(myformat);


	/* Create a psOtherinformation field  - an oid */
	myother = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
	fill_pres_resp_othinfo_obj(myother);


	/* Setup a summary record using a general function */
	fill_dbv_summary_external(external, title, author, callnum, rectype, biblevel, myformat, pubplace, pubdate, targetkey, satelmnt, &rank, docid, abstract, myother);

}



int fill_pres_resp_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
        fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
}


int fill_summary_format(DbvFormatSpec **ppsFormat)
{
	/* FormatSpec setting */
	char type_val[100] = "type 1";
	unsigned long size_val = 177; 
	unsigned long bestpos_val = 188;


	/* Create and fill first node */
	ppsFormat[0] = (DbvFormatSpec *) DbvAlloc (sizeof (DbvFormatSpec));
	fill_format_spec(ppsFormat[0], type_val, &size_val, &bestpos_val);

	/* Create and fill second node */
	ppsFormat[1] = (DbvFormatSpec *) DbvAlloc (sizeof (DbvFormatSpec));

	/* Overwrite format values */
	strcpy(type_val, "type 2");
	size_val = 277;
	bestpos_val = 288;

	fill_format_spec(ppsFormat[1], type_val, &size_val, &bestpos_val);

	/* Terminate the list */
	ppsFormat[2] = NULL;


}



int fill_format_spec(DbvFormatSpec *psFormat, char *type_val, unsigned long *size_val, unsigned long *bestpos_val)
{
	
	/* sType is compulsory */
	fill_dbv_inter_string(& (psFormat->sType), type_val);

	if (size_val != NULL) {
		psFormat->pulSize = (Ulong *) DbvAlloc (sizeof(Ulong));
		*psFormat->pulSize = *size_val;
	}

	if (bestpos_val != NULL) {
		psFormat->pulBestPosn = (Ulong *) DbvAlloc (sizeof(Ulong));
		*psFormat->pulBestPosn = *bestpos_val;
	}

}



int fill_records_explain(DbvNamePlusRecord **ppsResponseRecord)
{

	char *dbname0 = "database 0";

	DbvASN1External *external0 = NULL;

	
	ppsResponseRecord[0] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	external0 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
	fill_response_explain(external0);
	fill_dbv_nameplus_rec(ppsResponseRecord[0], dbname0, external0);

}



int fill_response_explain(DbvASN1External *external)
{


	DbvExplainRecord *psExplainRecord;

	char *oid = ANSI_EXPLAIN_RECORD;

	/* ALWAYS SUPPLY AN OID WITH SINGLE ASN1 TYPE */
	/* +1 to copy the \0 */
	external->pcObjectIdentifier = (char *) DbvAlloc (strlen(oid) + 1);

	memcpy(external->pcObjectIdentifier, oid, strlen(oid));

	external->eValueType = EVT_SingleASN1Type;
	external->uExternalValue.psSingleASN1Type = (DbvSingleASN1Type * ) DbvAlloc (sizeof (DbvSingleASN1Type));
	external->uExternalValue.psSingleASN1Type->eASN1Type = AT_ExplainRecord;
	external->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord = (struct DbvExplainRecord *) DbvAlloc (sizeof (struct DbvExplainRecord));

	/* use choice menus to set up explain - could use a 
	   pseudo explain databse here with load_example_explain_database() */
	zraw_fill_DbvExplainRecord(external->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord);


	psExplainRecord = external->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord;




}



int fill_pres_response_userinfo(DbvASN1External *external)
{
 
	char sutrs[1000];
	char alignedstr[1000];
	char oid[100];
	char oid2[100];
	char arbstr[1000];
	int choice = 0;
        char choice_string[100];

        strcpy(sutrs, "this is my present response userinfo sutrs string");
        strcpy(alignedstr, "this is my aligned string");
        strcpy(oid, ANSI_USMARC);
        strcpy(oid2, ANSI_NORMARC);
        strcpy(arbstr, "0101010101010101");


	choice = 0;
        while (choice < 1 || choice > 3) {
                printf("Enter userinfo external type: sutrs (1), aligned (2), arbitrary (3): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
		fill_dbv_sutrs_external(external, sutrs);
		break;
	case 2:

		/* Third parameter is the optional oid, pass in NULL if dont want one */

		fill_dbv_aligned_external(external, alignedstr, NULL);

/*
		fill_dbv_aligned_external(external, alignedstr, oid);
*/
		break;
	case 3:

		/* Third parameter is the optional oid, pass in NULL if dont want one */

		fill_dbv_arbitrary_external(external, arbstr, NULL);

/*
		fill_dbv_arbitrary_external(external, arbstr, oid2);
*/
		break;
	}

}


 

int fill_pres_response_othinfo_char(DbvOtherInformation *psOtherInformation)
{


	char oid[100]; 
	char charinfo[100];

	DbvBool want_infocat = DBV_TRUE;
	unsigned long catvalue = 9; 

	strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
	strcpy(charinfo, "this is my otherinfo present response char field");

	fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}




int fill_pres_response_othinfo_bin(DbvOtherInformation *psOtherInformation)
{

	char oid[100];
	char bininfo[100];

	DbvBool want_infocat = DBV_TRUE;
	unsigned long catvalue = 18; 

	strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
	strcpy(bininfo, "this is my otherinfo present response bin field");

	fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}



int fill_pres_response_othinfo_ext(DbvOtherInformation *psOtherInformation)
{

	char oid[100];
	char bininfo[100];
	char sutrs_string[100];

	DbvBool want_infocat = DBV_TRUE;
	unsigned long catvalue = 656; 
	DbvASN1External *external = NULL;

	strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
	strcpy(bininfo, "this is my otherinfo bin field");
	strcpy(sutrs_string, "this is a present response test otherinfo sutrs string");

	fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);

	/* Set up a sutrs external */
	external = psOtherInformation->uInformation.psExternallyDefinedInfo;
	fill_dbv_sutrs_external(external, sutrs_string);
}




int fill_pres_response_othinfo_obj(DbvOtherInformation *psOtherInformation)
{

	char infooid[100];
	char otheroid[100];

	DbvBool want_infocat = DBV_TRUE;
	unsigned long catvalue = 74; 

	strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
	strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);

	fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);

}		




