#include "api_target_rescntrl.h"



/* Set up a ResourceControlRequest PDU and sent it to an origin */
int send_rescntrlreq_to_origin(DbvAssocId assoc_id, DbvBool fResponseRequired)
{
	DbvError		*psError = NULL;
	DbvResourceControlReq	*psResourceControlReq = NULL;
	
	int choice = 0;
	char choice_string[100];

	/* Allocate memory for psAccessControlReq and fill it in */
        psResourceControlReq = (DbvResourceControlReq *) DbvAlloc (sizeof(DbvResourceControlReq));
        fill_rescntrl_request(psResourceControlReq, fResponseRequired);
 
	printf("Print ResourceControlRequest PDU to screen before sending ? yes (1), no (2): ");
	choice = atoi(gets(choice_string));
	if (choice == 1) {
		printf("-----------------------------------------\n");
		print_rescntrlreq_fields(stdout, psResourceControlReq);
		printf("-----------------------------------------\n");
	}

 
        /* Send the ResourceControlRequest just filled in to the origin */
        if (DbvResourceControlRequest(assoc_id, psResourceControlReq, &psError) == SI_OK) {

		/* Sent PDU to target ok so free up space it used */ 

		SIFreeDbvResourceControlReq(&psResourceControlReq);

		return SI_OK;
	} else {
		
		/* The attempt to send the PDU to the target failed */
                PrivateErrorHandling(&psError);

                SIFreeDbvResourceControlReq(&psResourceControlReq);


                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
		return SI_NOTOK;
	}
}



int fill_rescntrl_request(DbvResourceControlReq *psResourceControlReq, DbvBool fResponseRequired)
{

	char *test_refid = "resource control request reference id";
	char *test_sutrs = "test sutrs external";
	char *test_otherinfo1 = "first other information test";
	char *test_otherinfo2 = "second other information test";


        /* Compulsory fields... */

       	psResourceControlReq->fResponseRequired = fResponseRequired;


       	/* Optional fields... */
 
	/* +1 to allocate space for the \0 */
        psResourceControlReq->psReferenceId = (DbvOctetString *) DbvAlloc (sizeof(DbvOctetString));
	fill_dbv_octet_string(psResourceControlReq->psReferenceId, test_refid);


        psResourceControlReq->pfSuspendedFlag = (DbvBool *) DbvAlloc (sizeof(DbvBool));
        *psResourceControlReq->pfSuspendedFlag = DBV_TRUE;


       	psResourceControlReq->psResourceReport = (DbvASN1External *) DbvAlloc (sizeof (DbvASN1External));
	fill_dbv_isosutrs_external(psResourceControlReq->psResourceReport, test_sutrs);


       	psResourceControlReq->pePartialResultsAvailable = (DbvPartialResultsAvailable *) DbvAlloc (sizeof (DbvPartialResultsAvailable));
       	*psResourceControlReq->pePartialResultsAvailable = PRA_Interim2;



        psResourceControlReq->pfTriggeredRequestFlag = (DbvBool *) DbvAlloc (sizeof(DbvBool));
        *psResourceControlReq->pfTriggeredRequestFlag = DBV_FALSE;


	/* 2 nodes */
	psResourceControlReq->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);

	psResourceControlReq->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));

	psResourceControlReq->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
	psResourceControlReq->ppsOtherInformation[2] = NULL;


	fill_dbv_otherinfo_char(psResourceControlReq->ppsOtherInformation[0], DBV_TRUE, ANSI_UNSTRUCTURED_TEXT_RECORD, 989, test_otherinfo1);
	fill_dbv_otherinfo_char(psResourceControlReq->ppsOtherInformation[1], DBV_TRUE, ANSI_UNSTRUCTURED_TEXT_RECORD, 999, test_otherinfo2);


}
  



