#include "api_target_resrep.h"





int send_resreprsp_to_origin(int assoc_id)
{
        DbvAssocId      lAssocId = assoc_id;
        DbvResourceReportRsp   *psResourceReportRsp = NULL;
        DbvError        *psError = NULL;
 
        int choice = 0;
        char choice_string[100];
 
        /* Allocate memory for psResourceReportRsp and fill it in */
        psResourceReportRsp = (DbvResourceReportRsp *) DbvAlloc (sizeof(DbvDeleteResultSetRsp));
        fill_resrep_response(psResourceReportRsp);
 
	printf("Print ResourceReportResponse PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_resreprsp_fields(stdout, psResourceReportRsp);
                printf("-----------------------------------------\n");
        }


        /* Send ResourceReportResponse to client */
        if (DbvResourceReportResponse(lAssocId, psResourceReportRsp, &psError) == SI_OK)
        {

                SIFreeDbvResourceReportRsp(&psResourceReportRsp);

                return SI_OK;
        }  else {
                PrivateErrorHandling(&psError);

                SIFreeDbvResourceReportRsp(&psResourceReportRsp);


                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
                return SI_NOTOK;
        }
}



int fill_resrep_response(DbvResourceReportRsp *psResourceReportRsp)
{
 
        char *test_reference_id = "resrep response reference id";
        char *test_resrepmessage = "resrep response resrep message";
        int choice = 0;
        char choice_string[100];

	/* compulsory fields */
	/* eResourceReportStatus */
	psResourceReportRsp->eResourceReportStatus = RRS_Failure_3;
	

	/* Optional fields */

	/* Reference id */
 
        psResourceReportRsp->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
        fill_dbv_octet_string(psResourceReportRsp->psReferenceId, test_reference_id);
 
 
	/* psResourceReport */
        psResourceReportRsp->psResourceReport = (DbvASN1External *) DbvAlloc(sizeof(DbvASN1External));

        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter psResourceReport choice: DbvResourceReport1 (1), DbvResourceReport2 (2): ");
                choice = (atol(gets(choice_string)));
        }
	
	switch (choice) {
	case 1:
		fill_dbv_resrep1_external(psResourceReportRsp->psResourceReport);
		break;
	case 2:
		fill_dbv_resrep2_external(psResourceReportRsp->psResourceReport);
		break;
	}
	

	/* psOtherInformation */
        psResourceReportRsp->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);
        psResourceReportRsp->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
        psResourceReportRsp->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));

        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), obj (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
                fill_resrep_response_othinfo_char(psResourceReportRsp->ppsOtherInformation[0]);
                fill_resrep_response_othinfo_char(psResourceReportRsp->ppsOtherInformation[1]);
                break;
        case 2:
                fill_resrep_response_othinfo_bin(psResourceReportRsp->ppsOtherInformation[0]);
                fill_resrep_response_othinfo_bin(psResourceReportRsp->ppsOtherInformation[1]);
                break;
        case 3:
                fill_resrep_response_othinfo_ext(psResourceReportRsp->ppsOtherInformation[0]);
                fill_resrep_response_othinfo_ext(psResourceReportRsp->ppsOtherInformation[1]);
                break;
        case 4:
                fill_resrep_response_othinfo_obj(psResourceReportRsp->ppsOtherInformation[0]);
                fill_resrep_response_othinfo_obj(psResourceReportRsp->ppsOtherInformation[1]);
                break;
        }
}



int fill_resrep_response_othinfo_char(DbvOtherInformation *psOtherInformation)
{
 
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 9;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my otherinfo resource report response char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}
 


int fill_resrep_response_othinfo_bin(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char bininfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 18;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my otherinfo resource report response bin field");
 
        fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}
 


int fill_resrep_response_othinfo_ext(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char bininfo[100];
        char sutrs_string[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 656;
        DbvASN1External *external = NULL;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my otherinfo bin field");
        strcpy(sutrs_string, "this is a resource report response test otherinfo sutrs string");
 
        fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);
 
        /* Set up a sutrs external */
        external = psOtherInformation->uInformation.psExternallyDefinedInfo;
        fill_dbv_sutrs_external(external, sutrs_string);
}
 
 
 
int fill_resrep_response_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
 
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 74;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
        fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
 
}





