#include "api_target_scan.h"




int send_scanrsp_to_origin(int assoc_id)
{
        DbvAssocId      lAssocId = assoc_id;
        DbvScanRsp   *psScanRsp = NULL;
        DbvError        *psError = NULL;
 
	int choice = 0;
        char choice_string[100];

        /* Allocate memory for psScanRsp and fill it in */
        psScanRsp = (DbvScanRsp *) DbvAlloc (sizeof(DbvScanRsp));
        fill_scan_response(psScanRsp);
 
        printf("Print ScanResponse PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_scanrsp_fields(stdout, psScanRsp);
                printf("-----------------------------------------\n");
        }

        /* Send ScanResponse to client */
        if (DbvScanResponse(lAssocId, psScanRsp, &psError) == SI_OK)
        {

                SIFreeDbvScanRsp(&psScanRsp);

                return SI_OK;
        }  else {
                PrivateErrorHandling(&psError);

                SIFreeDbvScanRsp(&psScanRsp);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
                return SI_NOTOK;
        }

}



int fill_scan_response(DbvScanRsp *psScanRsp)
{
 
        char *test_reference_id = "scan response reference id";
        int choice = 0;
        char choice_string[100];

	/* Compulsory fields */
	
	/* eScanStatus */
	psScanRsp->eScanStatus = SCS_Partial_2;

	/* ulNumberOfEntriesReturned */
	psScanRsp->ulNumberOfEntriesReturned = 959;


	/* Optional fields */
	 

	/* Reference id */
        psScanRsp->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
        fill_dbv_octet_string(psScanRsp->psReferenceId, test_reference_id);
 

	/* pulStepSize */
        psScanRsp->pulStepSize = (Ulong *) DbvAlloc(sizeof(Ulong));
        *psScanRsp->pulStepSize = 12345678;
	
	/* pulPositionOfTerm */
        psScanRsp->pulPositionOfTerm = (Ulong *) DbvAlloc(sizeof(Ulong));
        *psScanRsp->pulPositionOfTerm = 87654321;


	/* psEntries */
        psScanRsp->psEntries = (DbvListEntries *) DbvAlloc (sizeof (DbvListEntries));
	fill_listent(psScanRsp->psEntries);

	/* pcAttributeSetId */
        psScanRsp->pcAttributeSetId = ANSI_ATTRIBUTE_SET_BIB_1;

	/* psOtherInformation */
        psScanRsp->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);
        psScanRsp->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
        psScanRsp->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
 
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), obj (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
                fill_scan_response_othinfo_char(psScanRsp->ppsOtherInformation[0]);
                fill_scan_response_othinfo_char(psScanRsp->ppsOtherInformation[1]);
                break;
        case 2:
                fill_scan_response_othinfo_bin(psScanRsp->ppsOtherInformation[0]);
                fill_scan_response_othinfo_bin(psScanRsp->ppsOtherInformation[1]);
                break;
        case 3:
                fill_scan_response_othinfo_ext(psScanRsp->ppsOtherInformation[0]);
                fill_scan_response_othinfo_ext(psScanRsp->ppsOtherInformation[1]);
                break;
        case 4:
                fill_scan_response_othinfo_obj(psScanRsp->ppsOtherInformation[0]);
                fill_scan_response_othinfo_obj(psScanRsp->ppsOtherInformation[1]);
                break;
        }

}



int fill_listent(DbvListEntries *psEntries)
{

	/* Both following optional */

	/* create 3 nodes - 0, 1, \0) */
	psEntries->ppsEntry = (DbvEntry **) DbvAlloc (sizeof(DbvEntry *) * 3);
	fill_entries(psEntries->ppsEntry);

	/* create 3 records (4 nodes - 0, 1, 2, \0) */
	psEntries->ppsNonSurrogateDiagnostics = (DbvDiagRec **) DbvAlloc (sizeof(DbvDiagRec *) * 4);
	fill_records_multidiag(psEntries->ppsNonSurrogateDiagnostics);
}



int fill_entries(DbvEntry **ppsEntry)
{
	printf("ppsEntry[0]: ");
	ppsEntry[0] = (DbvEntry *) DbvAlloc (sizeof(DbvEntry));
	fill_entry(ppsEntry[0]);

	printf("ppsEntry[1]: ");
	ppsEntry[1] = (DbvEntry *) DbvAlloc (sizeof(DbvEntry));
	fill_entry(ppsEntry[1]);

	ppsEntry[2] = NULL;
}



int fill_entry(DbvEntry *psEntry)
{
	
        int choice = 0;
        char choice_string[100];
	
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter eEntryType: ET_TermInfo (1), ET_SurrogateDiagnostic (2): ");
                choice = (atol(gets(choice_string)));
        }


	switch (choice) {
	case ET_TermInfo:
		psEntry->eEntryType = ET_TermInfo;
		psEntry->uEntry.psTermInfo = (DbvTermInfo *) DbvAlloc (sizeof(DbvTermInfo));
		fill_terminfo(psEntry->uEntry.psTermInfo);
		break;
	case ET_SurrogateDiagnostic:
		psEntry->eEntryType = ET_SurrogateDiagnostic;

		psEntry->uEntry.psSurrogateDiagnostic = (DbvDiagRec *) DbvAlloc (sizeof(DbvDiagRec));
		fill_default_diag_rec(psEntry->uEntry.psSurrogateDiagnostic, ANSI_DANMARC, 44, "another diag text for v3", PVIF_Version3, DT_DefaultFormat, NULL);
		break;
	}

}



int fill_terminfo(DbvTermInfo *psTermInfo)
{
	/* Term is compulsory */
	fill_term(&psTermInfo->sTerm);

	/* psDisplayTerm */
	psTermInfo->psDisplayTerm = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
	fill_dbv_inter_string(psTermInfo->psDisplayTerm, "test terminfo inter string");

	/* ppsSuggestedAttribute */
	/* 3 nodes - 0, 1, \0 */
	psTermInfo->ppsSuggestedAttribute = (DbvAttributeElement **) DbvAlloc (sizeof (DbvAttributeElement *) * 3);
	fill_attelmnts(psTermInfo->ppsSuggestedAttribute);
	

	/* ppsAlternativeTerm */
	/* 3 nodes - 0, 1, \0 */
	psTermInfo->ppsAlternativeTerm = (DbvAttributesPlusTerm **) DbvAlloc (sizeof (DbvAttributesPlusTerm *) * 3);
	fill_attsplusterm_list(psTermInfo->ppsAlternativeTerm);
	

	/* pulGlobalOccurrences */
	psTermInfo->pulGlobalOccurrences = (Ulong *) DbvAlloc (sizeof(Ulong));
	*psTermInfo->pulGlobalOccurrences = 657;


	/* ppsByAttributes */
	/* 3 nodes - 0, 1, \0 */
	psTermInfo->ppsByAttributes = (DbvOccurrenceByAttributes **) DbvAlloc (sizeof (DbvOccurrenceByAttributes *) * 3);
	psTermInfo->ppsByAttributes[0] = (DbvOccurrenceByAttributes *) DbvAlloc (sizeof (DbvOccurrenceByAttributes));
	psTermInfo->ppsByAttributes[1] = (DbvOccurrenceByAttributes *) DbvAlloc (sizeof (DbvOccurrenceByAttributes));
	fill_occurbyatt(psTermInfo->ppsByAttributes[0]);
	fill_occurbyatt(psTermInfo->ppsByAttributes[1]);

	/* psOtherInformation */

	/* 3 nodes - 0 1 \0 */
	psTermInfo->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc (sizeof (DbvOtherInformation * ) * 3);
	psTermInfo->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc (sizeof (DbvOtherInformation));
	fill_terminfo_othinfo_char(psTermInfo->ppsOtherInformation[0]);

	psTermInfo->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc (sizeof (DbvOtherInformation));
	fill_terminfo_othinfo_char(psTermInfo->ppsOtherInformation[1]);

}



int fill_attsplusterm_list(DbvAttributesPlusTerm **ppsAlternativeTerm)
{
        /* First node */
        ppsAlternativeTerm[0] = (DbvAttributesPlusTerm *) DbvAlloc (sizeof(DbvAttributesPlusTerm));
        printf("Aplustlist Node 0: ");
	fill_attsplusterm(ppsAlternativeTerm[0]);
 
 
	/* Second node */
        ppsAlternativeTerm[1] = (DbvAttributesPlusTerm *) DbvAlloc (sizeof(DbvAttributesPlusTerm));
        printf("Aplustlist Node 1: ");
	fill_attsplusterm(ppsAlternativeTerm[1]);
 
        /* NULL list terminator */
        ppsAlternativeTerm[2] = NULL;
}



int fill_occurbyatt(DbvOccurrenceByAttributes *psByAttributes)
{
	/* ppsAttributeElement */
	/* 3 nodes - 0, 1, \0 */
	psByAttributes->ppsAttributeElement = (DbvAttributeElement **) DbvAlloc (sizeof (DbvAttributeElement *) * 3);
	fill_attelmnts(psByAttributes->ppsAttributeElement);
	

	/* psOccurrence */
	psByAttributes->psOccurrence = (DbvOccurrence *) DbvAlloc (sizeof (DbvOccurrence));
	fill_occurrence(psByAttributes->psOccurrence);


	/* optional psOtherInformation */ 

	/* 3 nodes - 0, 1 \0 */
	psByAttributes->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc (sizeof (DbvOtherInformation *) * 3);
	psByAttributes->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc (sizeof (DbvOtherInformation));
	psByAttributes->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc (sizeof (DbvOtherInformation));
	fill_byatts_othinfo_char(psByAttributes->ppsOtherInformation[0]);
	fill_byatts_othinfo_char(psByAttributes->ppsOtherInformation[1]);

}



int fill_occurrence(DbvOccurrence *psOccurrence)
{
        int choice = 0;
        char choice_string[100];
	
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter eOccurrenceType: OT_Global (1), OT_ByDatabase (2): ");
                choice = (atol(gets(choice_string)));
        }


	switch (choice) {
	case OT_Global:
		psOccurrence->eOccurrenceType = OT_Global;
		psOccurrence->uOccurence.ulGlobal = 55555;
		break;
	case OT_ByDatabase:
		psOccurrence->eOccurrenceType = OT_ByDatabase;

		/* 3 list nodes - 0, 1 \0 */
		psOccurrence->uOccurence.ppsOccurrenceByDb = (DbvOccurrenceByDb **) DbvAlloc (sizeof(DbvOccurrenceByDb *) * 3); 
		fill_occurrencebydb_list(psOccurrence->uOccurence.ppsOccurrenceByDb);
		break;
	}
}



int fill_occurrencebydb_list(DbvOccurrenceByDb **ppsOccurrenceByDb)
{
	ppsOccurrenceByDb[0] = (DbvOccurrenceByDb *) DbvAlloc (sizeof (DbvOccurrenceByDb));
	fill_occurrencebydb(ppsOccurrenceByDb[0]);

	ppsOccurrenceByDb[1] = (DbvOccurrenceByDb *) DbvAlloc (sizeof (DbvOccurrenceByDb));
	fill_occurrencebydb(ppsOccurrenceByDb[1]);
	ppsOccurrenceByDb[2] =  NULL;
}



int fill_occurrencebydb(DbvOccurrenceByDb *psOccurrenceByDb)
{
	/* sDatabaseName compulsory */
	fill_dbv_inter_string(&psOccurrenceByDb->sDatabaseName, "occurrence by database database name");

	psOccurrenceByDb->pulNumber = (Ulong *) DbvAlloc (sizeof(Ulong));
	*psOccurrenceByDb->pulNumber = 4321;

	
	/* psOtherInformation */

	/* 3 nodes - 0, 1, \0 */
	psOccurrenceByDb->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc (sizeof (DbvOtherInformation *) * 3);
	psOccurrenceByDb->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc (sizeof (DbvOtherInformation));
	psOccurrenceByDb->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc (sizeof (DbvOtherInformation));
	fill_occurrence_othinfo_char(psOccurrenceByDb->ppsOtherInformation[0]);
	fill_occurrence_othinfo_char(psOccurrenceByDb->ppsOtherInformation[1]);
}



int fill_occurrence_othinfo_char(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 9;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my otherinfo occurrence scan response char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}
 


int fill_byatts_othinfo_char(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 9;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my otherinfo byattributes scan response char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}
 


int fill_terminfo_othinfo_char(DbvOtherInformation *psOtherInformation)
{
 
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 9;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my otherinfo terminfo scan response char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}
 


int fill_scan_response_othinfo_char(DbvOtherInformation *psOtherInformation)
{
 
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 9;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my otherinfo scan response char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}
 
 
 
int fill_scan_response_othinfo_bin(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char bininfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 18;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my otherinfo scan response bin field");
 
        fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}
 
 
 
int fill_scan_response_othinfo_ext(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char bininfo[100];
        char sutrs_string[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 656;
        DbvASN1External *external = NULL;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my otherinfo bin field");
        strcpy(sutrs_string, "this is a scan response test otherinfo sutrs string");
 
        fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue)
;
 
        /* Set up a sutrs external */
        external = psOtherInformation->uInformation.psExternallyDefinedInfo;
        fill_dbv_sutrs_external(external, sutrs_string);
}



int fill_scan_response_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
 
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 74;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
        fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
 
}
 




