#include "api_target_search.h"


int send_srchrsp_to_origin(DbvAssocId lAssocId)
{

	DbvError *psSIError;

	DbvSearchRsp	*psSearchRsp;
	char    *test_psReferenceId = "SearchResponse reference id";
	Ulong	test_ulResultCount = 5;
	Ulong	test_ulNumberOfRecordsReturned = 0;
	Ulong	test_ulNextResultSetPosition = 1;
	DbvBool	test_fSearchStatus = DBV_TRUE;
	DbvResultSetStatus test_peResultSetStatus = RSS_Subset;
	DbvPresentStatus test_pePresentStatus = PS_Success;

	int choice = 0;
        char choice_string[100];

	psSearchRsp = (DbvSearchRsp *)DbvAlloc(sizeof(DbvSearchRsp));


	/* Reference id */
        psSearchRsp->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
        fill_dbv_octet_string(psSearchRsp->psReferenceId, test_psReferenceId);
 


	/* Result Count */
	psSearchRsp->ulResultCount = test_ulResultCount;
	
	/* Number of Records Returned */
	psSearchRsp->ulNumberOfRecordsReturned = test_ulNumberOfRecordsReturned;

	/* Next Result Set Position */
	psSearchRsp->ulNextResultSetPosition = test_ulNextResultSetPosition;

	/* Search Status */


	psSearchRsp->fSearchStatus = test_fSearchStatus;

	
	psSearchRsp->peResultSetStatus=(DbvResultSetStatus *)DbvAlloc(sizeof (DbvResultSetStatus));
	*psSearchRsp->peResultSetStatus = test_peResultSetStatus;



	/* PresentStatus Optional */
	psSearchRsp->pePresentStatus=(DbvPresentStatus *)DbvAlloc(sizeof (DbvPresentStatus));
	*psSearchRsp->pePresentStatus = test_pePresentStatus;

	
	/* Records optional */

	/* un-comment the following to send back records in SrchRsp */
/*
	psSearchRsp->psRecords = (DbvRecords *) DbvAlloc (sizeof(DbvRecords));
        fill_search_records(psSearchRsp->psRecords);
*/
	
	
	/* uncomment following to use */

/*
        psSearchRsp->ppsAdditionalSearchInfo = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);
        psSearchRsp->ppsAdditionalSearchInfo[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
        psSearchRsp->ppsAdditionalSearchInfo[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
 
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsAdditionalSearchInfo type (for 2 list nodes): char (1), bin (2), ext (3), other (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
        	fill_searchrsp_othinfo_char(psSearchRsp->ppsAdditionalSearchInfo[0]);
        	fill_searchrsp_othinfo_char(psSearchRsp->ppsAdditionalSearchInfo[1]);
		break;
	case 2:
        	fill_searchrsp_othinfo_bin(psSearchRsp->ppsAdditionalSearchInfo[0]);
        	fill_searchrsp_othinfo_bin(psSearchRsp->ppsAdditionalSearchInfo[1]);
		break;
	case 3:
        	fill_searchrsp_othinfo_ext(psSearchRsp->ppsAdditionalSearchInfo[0]);
        	fill_searchrsp_othinfo_ext(psSearchRsp->ppsAdditionalSearchInfo[1]);
		break;
	case 4:
        	fill_searchrsp_othinfo_obj(psSearchRsp->ppsAdditionalSearchInfo[0]);
        	fill_searchrsp_othinfo_obj(psSearchRsp->ppsAdditionalSearchInfo[1]);
		break;
	}
 

        psSearchRsp->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);
        psSearchRsp->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
        psSearchRsp->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
 

        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), obj (4): ");
                choice = (atol(gets(choice_string)));
        }
 

	switch (choice) {
	case 1:
        	fill_searchrsp_othinfo_char(psSearchRsp->ppsOtherInformation[0]);
        	fill_searchrsp_othinfo_char(psSearchRsp->ppsOtherInformation[1]);
		break;
	case 2:
        	fill_searchrsp_othinfo_bin(psSearchRsp->ppsOtherInformation[0]);
        	fill_searchrsp_othinfo_bin(psSearchRsp->ppsOtherInformation[1]);
		break;
	case 3:
        	fill_searchrsp_othinfo_ext(psSearchRsp->ppsOtherInformation[0]);
        	fill_searchrsp_othinfo_ext(psSearchRsp->ppsOtherInformation[1]);
		break;
	case 4:
        	fill_searchrsp_othinfo_obj(psSearchRsp->ppsOtherInformation[0]);
        	fill_searchrsp_othinfo_obj(psSearchRsp->ppsOtherInformation[1]);
		break;
	}

*/
 
 
        printf("Print SearchResponse PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_searchrsp_fields(stdout, psSearchRsp);
                printf("-----------------------------------------\n");
        }


	if (DbvSearchResponse(lAssocId, psSearchRsp, &psSIError) == SI_OK) {

        	SIFreeDbvSearchRsp(&psSearchRsp);

		return SI_OK;
	} else {

                PrivateErrorHandling(&psSIError);

        	SIFreeDbvSearchRsp(&psSearchRsp);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psSIError);
		return SI_NOTOK;
        }
}



/* Here, five sutrs records are returned - look in the present response code
   for a range of record (sutrs, opac, summary) and diagnostic 
   return tests */
int fill_search_records(DbvRecords *psRecords)
{

	char *dbname0 = "database name 0 ";
	char *dbname1 = "database name 1 ";
	char *dbname2 = "database name 2 ";
	char *dbname3 = "database name 3 ";
	char *dbname4 = "database name 4 ";

        DbvASN1External *external0 = NULL;
        DbvASN1External *external1 = NULL;
        DbvASN1External *external2 = NULL;
        DbvASN1External *external3 = NULL;
        DbvASN1External *external4 = NULL;


        psRecords->eRecordType = RT_Response;
 

        /* Create 6 records, 0, 1, 2, 3, 4 \0 */
        psRecords->uRecord.ppsResponseRecord = (DbvNamePlusRecord **) DbvAlloc (
sizeof(DbvNamePlusRecord *) * 6);
 
 
        psRecords->uRecord.ppsResponseRecord[0] = (DbvNamePlusRecord *) DbvAlloc
 (sizeof (DbvNamePlusRecord));
        external0 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
        fill_dbv_sutrs_external(external0, "search response  - sutrs zero");
        fill_dbv_nameplus_rec(psRecords->uRecord.ppsResponseRecord[0], dbname0,
external0);
 
        psRecords->uRecord.ppsResponseRecord[1] = (DbvNamePlusRecord *) DbvAlloc
 (sizeof (DbvNamePlusRecord));
        external1 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
        fill_dbv_sutrs_external(external1, "search response  - sutrs one");
        fill_dbv_nameplus_rec(psRecords->uRecord.ppsResponseRecord[1], dbname1,
external1);
 
        psRecords->uRecord.ppsResponseRecord[2] = (DbvNamePlusRecord *) DbvAlloc
 (sizeof (DbvNamePlusRecord));
        external2 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
        fill_dbv_sutrs_external(external2, "search response  - sutrs two");
        fill_dbv_nameplus_rec(psRecords->uRecord.ppsResponseRecord[2], dbname2,
external2);
 
 
        psRecords->uRecord.ppsResponseRecord[3] = (DbvNamePlusRecord *) DbvAlloc
 (sizeof (DbvNamePlusRecord));
        external3 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
        fill_dbv_sutrs_external(external3, "search response  - sutrs three");
        fill_dbv_nameplus_rec(psRecords->uRecord.ppsResponseRecord[3], dbname3, external3);
 
 
        psRecords->uRecord.ppsResponseRecord[4] = (DbvNamePlusRecord *) DbvAlloc
 (sizeof (DbvNamePlusRecord));
        external4 = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
        fill_dbv_sutrs_external(external4, "search response  - sutrs four");
        fill_dbv_nameplus_rec(psRecords->uRecord.ppsResponseRecord[4], dbname4, external4);
 
 
        psRecords->uRecord.ppsResponseRecord[5] = NULL;


}
 


void fill_searchrsp_othinfo_char(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 27;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is a search response otherinformation char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue,
 charinfo);
}

void fill_searchrsp_othinfo_bin(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char bininfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 33;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my search response otherinfo bin field");
 
        fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue,
bininfo);
}

void fill_searchrsp_othinfo_ext(DbvOtherInformation *psOtherInformation)
{
        char oid[100];
        char bininfo[100];
        char sutrs_string[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
        DbvASN1External *external = NULL;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my search response otherinfo bin field");
        strcpy(sutrs_string, "this is yet another sutrs string");
 
        fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);
 
        /* Set up a sutrs external */
        external = psOtherInformation->uInformation.psExternallyDefinedInfo;
        fill_dbv_sutrs_external(external, sutrs_string);
}



void fill_searchrsp_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 47;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
        fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
}




