#include "api_target_segment.h"


int send_segreq_to_origin(int assoc_id)
{
        DbvAssocId      lAssocId = assoc_id;
        DbvSegmentReq   *psSegmentReq = NULL;
        DbvError        *psError = NULL;
	 
        int choice = 0;
        char choice_string[100];
 
        /* Allocate memory for psSegmentReq and fill it in */
        psSegmentReq = (DbvSegmentReq *) DbvAlloc (sizeof(DbvSegmentReq));
        fill_seg_request(psSegmentReq);
 

	printf("Print SegmentRequest PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_segreq_fields(stdout, psSegmentReq);
                printf("-----------------------------------------\n");
        }

        /* Send SegmentReq to client */
        if (DbvSegmentRequest(lAssocId, psSegmentReq, &psError) == SI_OK)
        {

                SIFreeDbvSegmentReq(&psSegmentReq);

                return SI_OK;
        }  else {
                PrivateErrorHandling(&psError);

                SIFreeDbvSegmentReq(&psSegmentReq);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
                return SI_NOTOK;
	}
}



int fill_seg_request(DbvSegmentReq *psSegmentReq)
{
        char *test_reference_id = "seg request reference id";
        int choice = 0;
        char choice_string[100];
 
        /* Compulsory fields */
        psSegmentReq->ulNumberOfRecordsReturned = 12345;
 
	/* Create 4 nodes - 0, 1, 2, \0 */


	psSegmentReq->ppsSegmentRecords = (DbvNamePlusRecord **) DbvAlloc (sizeof(DbvNamePlusRecord *) * 4);

	/* Now fill them */
	fill_segment_records(psSegmentReq->ppsSegmentRecords);

 
        /* Optional fields */
        /* Reference id */

        psSegmentReq->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
        fill_dbv_octet_string(psSegmentReq->psReferenceId, test_reference_id);
 
	
	/* psOtherInformation */
	psSegmentReq->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation *) * 3);
	psSegmentReq->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
	psSegmentReq->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
 
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), obj (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
                fill_seg_request_othinfo_char(psSegmentReq->ppsOtherInformation[0]);
                fill_seg_request_othinfo_char(psSegmentReq->ppsOtherInformation[1]);
                break;
        case 2:
                fill_seg_request_othinfo_bin(psSegmentReq->ppsOtherInformation[0]);
                fill_seg_request_othinfo_bin(psSegmentReq->ppsOtherInformation[1]);
                break;
 
        case 3:
                fill_seg_request_othinfo_ext(psSegmentReq->ppsOtherInformation[0]);
                fill_seg_request_othinfo_ext(psSegmentReq->ppsOtherInformation[1]);
                break;
        case 4:
                fill_seg_request_othinfo_obj(psSegmentReq->ppsOtherInformation[0]);
                fill_seg_request_othinfo_obj(psSegmentReq->ppsOtherInformation[1]);
                break;
        }
}
 
 

int fill_segment_records(DbvNamePlusRecord **ppsSegmentRecords)
{
	ppsSegmentRecords[0] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	fill_fragment_nameplusrec(ppsSegmentRecords[0]);

	ppsSegmentRecords[1] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	fill_fragment_nameplusrec(ppsSegmentRecords[1]);


	ppsSegmentRecords[2] = (DbvNamePlusRecord *) DbvAlloc (sizeof (DbvNamePlusRecord));
	fill_fragment_nameplusrec(ppsSegmentRecords[2]);

	ppsSegmentRecords[3] = NULL;
}



int fill_fragment_nameplusrec(DbvNamePlusRecord *psSegmentRecords)
{
	
        int choice = 0;
        char choice_string[100];

        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Setup database name: yes (1), no (2): ");
                choice = (atol(gets(choice_string)));
        }
	

	if (choice == 1) {
		psSegmentRecords->psDatabaseName = (DbvInternationalString *) DbvAlloc (sizeof (DbvInternationalString));
		fill_dbv_inter_string(psSegmentRecords->psDatabaseName, "fragment database name test");
	}
		

        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter fragment type: starting (1), intermediate (2), final (3): ");
                choice = (atol(gets(choice_string)));
        }


	switch (choice) {
	case 1:
		psSegmentRecords->eDbRecordType = DRT_StartingFragment;
        	psSegmentRecords->uDbRecord.psStartingFragment = (DbvFragmentSyntax *) DbvAlloc (sizeof (DbvFragmentSyntax));
		fill_fragment(psSegmentRecords->uDbRecord.psStartingFragment);
		break;
	case 2:
		psSegmentRecords->eDbRecordType = DRT_IntermediateFragment;
        	psSegmentRecords->uDbRecord.psIntermediateFragment = (DbvFragmentSyntax *) DbvAlloc (sizeof (DbvFragmentSyntax));
		fill_fragment(psSegmentRecords->uDbRecord.psIntermediateFragment);
		break;
	case 3:
		psSegmentRecords->eDbRecordType = DRT_FinalFragment;
        	psSegmentRecords->uDbRecord.psFinalFragment = (DbvFragmentSyntax *) DbvAlloc (sizeof (DbvFragmentSyntax));
		fill_fragment(psSegmentRecords->uDbRecord.psFinalFragment);
		break;
	}
}



int fill_fragment(DbvFragmentSyntax *psFinalFragment)
{
        int choice = 0;
        char choice_string[100];
	DbvASN1External *external = NULL;

		
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter eFragmentSyntaxType: FST_ExternallyTagged (1), FST_NotExternallyTagged (2): ");
                choice = (atol(gets(choice_string)));
        }


	switch (choice) {
	case FST_ExternallyTagged:
		psFinalFragment->eFragmentSyntaxType = FST_ExternallyTagged;
		external = (DbvASN1External *) DbvAlloc (sizeof(DbvASN1External));
		fill_dbv_sutrs_external(external, "this is a name plus record fragment sutrs external");
		psFinalFragment->uFragmentSyntax.psExternallyTagged = external;
		break;
	case FST_NotExternallyTagged:
		psFinalFragment->eFragmentSyntaxType = FST_NotExternallyTagged;
		psFinalFragment->uFragmentSyntax.psNotExternallyTagged = (DbvOctetString *) DbvAlloc (sizeof(DbvOctetString));
		fill_dbv_octet_string(psFinalFragment->uFragmentSyntax.psNotExternallyTagged, "this is a fragment octet string");
		break;
	}

}



int fill_seg_request_othinfo_char(DbvOtherInformation *psOtherInformation)
{
 
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 9;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my otherinfo seg request char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}
 
 
int fill_seg_request_othinfo_bin(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char bininfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 18;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my otherinfo seg request bin field");
 
        fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}
 
 
 
int fill_seg_request_othinfo_ext(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char bininfo[100];
        char sutrs_string[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 656;
        DbvASN1External *external = NULL;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my otherinfo bin field");
        strcpy(sutrs_string, "this is a seg request test otherinfo sutrs string");
 
        fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue);
 
        /* Set up a sutrs external */
        external = psOtherInformation->uInformation.psExternallyDefinedInfo;
        fill_dbv_sutrs_external(external, sutrs_string);
}
 
 
 
int fill_seg_request_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
 
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 74;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
        fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
 
}





	
	

 
