#include "api_target_sort.h"


int send_sortrsp_to_origin(int assoc_id)
{
        DbvAssocId      lAssocId = assoc_id;
        DbvSortRsp   *psSortRsp = NULL;
        DbvError        *psError = NULL;
 
        int choice = 0;
        char choice_string[100];

        /* Allocate memory for psSortRsp and fill it in */
        psSortRsp = (DbvSortRsp *) DbvAlloc (sizeof(DbvSortRsp));
        fill_sort_response(psSortRsp);
 
        printf("Print SortResponse PDU to screen before sending ? yes (1), no (2): ");
        choice = atoi(gets(choice_string));
        if (choice == 1) {
                printf("-----------------------------------------\n");
                print_sortrsp_fields(stdout, psSortRsp);
                printf("-----------------------------------------\n");
        }

        /* Send SortResponse to client */
        if (DbvSortResponse(lAssocId, psSortRsp, &psError) == SI_OK)
        {

                SIFreeDbvSortRsp(&psSortRsp);

                return SI_OK;
        }  else {
                PrivateErrorHandling(&psError);

                SIFreeDbvSortRsp(&psSortRsp);

 
                /* Release buffer, assign NULL pointer */
                FreeSIErrorCode(&psError);
                return SI_NOTOK;
 
       }
}



int fill_sort_response(DbvSortRsp *psSortRsp)
{
 
        char *test_reference_id = "sort response reference id";
        int choice = 0;
        char choice_string[100];
 
        /* Compulsory fields */
 
        /* eSortStatus */
        psSortRsp->eSortStatus = SOS_Partial_1;
 

        /* Optional fields */
        /* Reference id */
        psSortRsp->psReferenceId = (DbvOctetString *) DbvAlloc(sizeof(DbvOctetString));
        fill_dbv_octet_string(psSortRsp->psReferenceId, test_reference_id);
 
	psSortRsp->peResultSetStatus = (DbvSortResultSetStatus *) DbvAlloc (sizeof (DbvSortResultSetStatus));
	*psSortRsp->peResultSetStatus = SRSS_Unchanged;

	
	psSortRsp->ppsDiagnostics = (DbvDiagRec **) DbvAlloc (sizeof(DbvDiagRec *) * 4);
	fill_records_multidiag(psSortRsp->ppsDiagnostics);
	
 
       psSortRsp->ppsOtherInformation = (DbvOtherInformation **) DbvAlloc(sizeof(DbvOtherInformation * ) * 3);
       psSortRsp->ppsOtherInformation[0] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
       psSortRsp->ppsOtherInformation[1] = (DbvOtherInformation *) DbvAlloc(sizeof(DbvOtherInformation));
 
        choice = 0;
        while (choice < 1 || choice > 4) {
                printf("Enter ppsOtherInformation type (for 2 list nodes): char (1), bin (2), ext (3), obj (4): ");
                choice = (atol(gets(choice_string)));
        }
 
        switch (choice) {
        case 1:
                fill_sort_response_othinfo_char(psSortRsp->ppsOtherInformation[0]);
                fill_sort_response_othinfo_char(psSortRsp->ppsOtherInformation[1]);
                break;
        case 2:
                fill_sort_response_othinfo_bin(psSortRsp->ppsOtherInformation[0]);
                fill_sort_response_othinfo_bin(psSortRsp->ppsOtherInformation[1]);
                break;
        case 3:
                fill_sort_response_othinfo_ext(psSortRsp->ppsOtherInformation[0]);
                fill_sort_response_othinfo_ext(psSortRsp->ppsOtherInformation[1]);
                break;
        case 4:
                fill_sort_response_othinfo_obj(psSortRsp->ppsOtherInformation[0]);
                fill_sort_response_othinfo_obj(psSortRsp->ppsOtherInformation[1]);
 
                break;
        }
}
 


int fill_sort_response_othinfo_char(DbvOtherInformation *psOtherInformation)
{
 
 
        char oid[100];
        char charinfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 9;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(charinfo, "this is my otherinfo sort response char field");
 
        fill_dbv_otherinfo_char(psOtherInformation, want_infocat, oid, catvalue, charinfo);
}
 
 
 
int fill_sort_response_othinfo_bin(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char bininfo[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 18;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my otherinfo sort response bin field");
 
        fill_dbv_otherinfo_bin(psOtherInformation, want_infocat, oid, catvalue, bininfo);
}
 
 
 
int fill_sort_response_othinfo_ext(DbvOtherInformation *psOtherInformation)
{
 
        char oid[100];
        char bininfo[100];
        char sutrs_string[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 656;
        DbvASN1External *external = NULL;
 
        strcpy(oid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(bininfo, "this is my otherinfo bin field");
        strcpy(sutrs_string, "this is a sort response test otherinfo sutrs string");
 
        fill_dbv_otherinfo_ext(psOtherInformation, want_infocat, oid, catvalue) ;
 
        /* Set up a sutrs external */
        external = psOtherInformation->uInformation.psExternallyDefinedInfo;
        fill_dbv_sutrs_external(external, sutrs_string);
 
}
 
 
 
int fill_sort_response_othinfo_obj(DbvOtherInformation *psOtherInformation)
{
 
        char infooid[100];
        char otheroid[100];
 
        DbvBool want_infocat = DBV_TRUE;
        unsigned long catvalue = 74;
 
        strcpy(infooid, ANSI_UNSTRUCTURED_TEXT_RECORD);
        strcpy(otheroid, ANSI_UNSTRUCTURED_TEXT_RECORD);
 
        fill_dbv_otherinfo_obj(psOtherInformation, want_infocat, infooid, catvalue, otheroid);
 
}
 
 


