#ifndef apishared_h
#define apishared_h


#include "api_common_includes.h"

int getline(char *line, int max);
void convert_n_to_0(char *line);
int post_scanf_check(int result);
int post_gets_check(char *result);
int PrintApplicationProtocol(DbvApplicationProtocol *peApplicationProtocol);
int PrintAbstractSyntax(DbvAbstractSyntax *peAbstractSyntax);
int PrintppcCommonSyntaxes(char **ppcCommonSyntaxes);
int	fill_dbv_sutrs_external(DbvASN1External *external, char *sutrs);
int     fill_dbv_isosutrs_external(DbvASN1External *external, char *sutrs);
int fill_dbv_summary_external(DbvASN1External *external, char *title, char *author, char *callnum, char *rectype, char *biblevel, DbvFormatSpec **myformat, char *pubplace, char *pubdate, char *targetkey, char *satelmnt, unsigned long *rank, char *docid, char *abstract, DbvOtherInformation *myother);
int fill_summary_bulk(DbvSummaryRecord *psSummaryRecord, char *title, char *author, char *callnum, char *rectype, char *biblevel, char *pubplace, char *pubdate, char *targetkey, char *satelmnt, unsigned long *rank, char *docid, char *abstract);
int	fill_dbv_aligned_external(DbvASN1External *external, char *aligned, char *oid);
int	fill_dbv_arbitrary_external(DbvASN1External *external, char *arbitrary, char *oid);
int	fill_dbv_otherinfo_char(DbvOtherInformation *psOtherInformation, DbvBool want_infocat, char *oid, unsigned long catvalue, char *charinfo);
int	fill_dbv_otherinfo_bin(DbvOtherInformation *psOtherInformation, DbvBool want_infocat, char *oid, unsigned long catvalue, char *bininfo);
int	fill_dbv_otherinfo_ext(DbvOtherInformation *psOtherInformation, DbvBool want_infocat, char *oid, unsigned long catvalue);
int	fill_dbv_otherinfo_obj(DbvOtherInformation *psOtherInformation, DbvBool want_infocat, char *infooid, unsigned long catvalue, char *otheroid);
int fill_dbv_octet_string(DbvOctetString *octet_string, char *setup_string);
int fill_dbv_inter_string(DbvInternationalString *inter_string, char *setup_string);
int fill_DbvGeneralString(DbvGeneralString *inter_string, char *setup_string);
int fill_dbv_nameplus_rec(DbvNamePlusRecord *psResponseRecord, char *dbname, DbvASN1External* external);
int fill_dbv_nrec_diagn_default(DbvNamePlusRecord *psResponseRecord, char *diag_dbname, char *oid, unsigned long condition, char *diag, int choice, DbvDiagnosticsType diagtype, DbvASN1External *external);
int fill_default_diag_rec(DbvDiagRec *psSurrogateDiagnostic, char *oid, unsigned long condition, char *diag, int choice, DbvDiagnosticsType diagtype, DbvASN1External *external);
int fill_default_diag_format_v2(DbvDefaultDiagFormat *psDefault, char *oid, unsigned long condition, char *ver2diag);
int fill_default_diag_format_v3(DbvDefaultDiagFormat *psDefault, char *oid, unsigned long condition, char *ver3diag);
int fill_strornum(DbvStringOrNumeric *psUnitType);
int fill_intunit(DbvIntUnit *psIntegerAndUnit);
int fill_unit(DbvUnit *psUnitUsed);
int fill_attsplusterm(DbvAttributesPlusTerm *psAttributesPlusTerm);
int fill_attelement(DbvAttributeElement *psAttributeElement);
int fill_attvalue(DbvAttributeValue *psAttributeValue);
int fill_complex(DbvComplexValue *psComplexValue);
int fill_term(DbvTerm *psTerm);
int fill_records_multidiag(DbvDiagRec **ppsMultipleNonSurrogateDiag);
int fill_specification(DbvSpecification *psGeneric);
int fill_DbvElementSpec(DbvElementSpec *psElementSpec);
int fill_attelmnts(DbvAttributeElement **ppsAttributeElement);
int fill_permissions_list(DbvPermissions **ppsPermissions, int number_of_nodes);
int fill_dbv_permissions(DbvPermissions *psPermissions);
int fill_dbv_resrep1_external(DbvASN1External *external);
int fill_dbv_resrep1_main(DbvResourceReport1 *psResourceReport1);
int fill_dbv_estimate1(DbvEstimate1 *psEstimate);
int fill_dbv_resrep2_external(DbvASN1External *external);
int fill_dbv_resrep2_main(DbvResourceReport2 *psResourceReport2);
int fill_dbv_estimate2(DbvEstimate2 *psEstimate);
void fill_DbvRange(DbvRange *psRange);
void fill_DbvRecordComposition(DbvRecordComposition *psRecordComposition);
void fill_DbvElementSetsDbSpecific_list(DbvElementSetsDbSpecific **ppsElementSetsDbSpecific);
void fill_DbvInternationalString(DbvLanguageCode *psProposedLangauages, char *pcString); 



void fill_DbvCharSetAndLanguage_external(DbvASN1External *external);
void fill_DbvCharSetAndLanguage(DbvCharSetAndLanguage *psCharSetAndLanguage);
void fill_DbvOriginProposal(DbvOriginProposal *psProposal);
void fill_DbvProposedCharSet(DbvProposedCharSet *psProposedCharSets, DbvProposedCharSetType eProposedCharSetType);
void fill_DbvIso2022(DbvIso2022 *psIso2022, DbvIso2022Type eIso2022Type);
void fill_DbvIso2022Proposal(DbvIso2022Proposal *psOriginProposal);
void fill_DbvEnvironment(DbvEnvironment *psProposedEnvironment);
void fill_DbvInitialSet(DbvInitialSet *psProposedInitialSets);
void fill_DbvLeftAndRight(DbvLeftAndRight *psProposedLeftAndRight);
void fill_DbvIso2022Response(DbvIso2022Response *psTargetResponse);
void fill_DbvIso10646(DbvIso10646 *psIso10646);
void fill_DbvPrivateCharacterSet(DbvPrivateCharacterSet *psPrivate);
void fill_DbvLanguageCode(DbvLanguageCode *psProposedLangauages);
void fill_DbvTargetResponse(DbvTargetResponse *psResponse);
void fill_DbvSelectedCharSet(DbvSelectedCharSet *psSelectedCharSets);
  




#endif

