#ifndef apitestorigin_h
#define apitestorigin_h

/* Include function prototypes */
#include "api_origin_includes.h"


/* An array of associations to check for */
#define         MAX_ASSOCS 10


/* Structure holding details about each api association */
typedef struct Dbnamestruct {
        char *dbname;
} Dbnamestruct;

typedef enum AddressType {
	AT_tcpip 	= 1,
	AT_osi 		= 2,
	AT_byname 	= 3
} AddressType;

#define ACSE_CONFIG_FILE "./ACSE_configuration_file_origin.tbl"



int main();
int menu_choice();
int process_choice(int choice, char *host_address, int *port, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, Dbnamestruct *assoc_dbnames, char *dbname, AddressType *address_type_chosen, char *psel, char *ssel, char *tsel, char *nsap);
int output_about_message(void);
int specify_tcpip_target(char *host_address, int *port, char *dbname); 
int specify_osi_target(char *host_address, char *psel, char *ssel, char *tsel, char *nsap); 
int specify_byname_target(char *host_address); 
int connect_to_target(char *host_address, int *port, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, AddressType address_type_chosen, char *psel, char *ssel, char *tsel, char *nsap);
int setup_tcpip_byaddr_target_info(DbvTarget *targetid, char *host_address, int port);
int setup_osi_byaddr_target_info(DbvTarget *targetid, char *psel, char *ssel, char *tsel, char *nsap);
int setup_osi_target_info(DbvOsiAddress *psOsiAddress, char *psel, char *ssel, char *tsel, char *nsap);
int setup_byname_target_info(DbvTarget *targetid, char *host_address);
void print_the_assocreq_result(DbvAssociateState eAssociateState, 
	DbvAssociateResult *puAssociateResult);
int PrintDbvAssociateRejectSource(DbvAssociateRejectSource 
	*peAssociateRejectSource);
int PrintDbvAssociateRejectResult(DbvAssociateRejectResult 
	*peAssociateRejectResult);
int PrintDbvAssociateRejectReason(DbvAssociateRejectReason 
	*peAssociateRejectReason);
void PrivateErrorHandling(DbvError **ppsError);
int do_initreq(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int handle_response(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError ** error);
int do_srchreq(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_presreq(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_delreq(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_accessrsp(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_rescntrlrsp(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_trigrescntrlreq(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_resrepreq(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_scanreq(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_sortreq(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_DbvExtendedServicesReq_DbvUpdateExtendedService(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_DbvExtendedServicesReq_DbvItemOrderExtendedService_DbvIllPdu(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);



int do_DbvExtendedServicesReq_DbvPrintExtendedService(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);



int do_DbvExtendedServicesReq_DbvAlertExtendedService(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_DbvExtendedServicesReq_DbvItemOrderExtendedService_DbvCOrder(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_closereq(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_closersp(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int wait_for_any_responses(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error);
int FreeSIErrorCode(DbvError **ppsError);
int wait_for_and_display_response(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error);
int print_origin_fields(FILE *f, DbvOriginData *psOriginData);
int close_connection_to_target(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error);
int process_release_state(DbvAssocId *assoc_id, DbvReleaseState *rel_state, DbvError **error);
int abort_connection_to_target(DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error);
DbvAssocId select_current_assoc(void);
int get_new_assoc_place(void);
void remove_assoc(DbvAssocId lAssocId);
int do_srchreq_explain(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_srchreq_explain_cip(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);
int do_exppresreq(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);



int do_initreq_charset(DbvBool done_initial_association, DbvAssocId *assoc_id, DbvAssociateState *assoc_state, DbvAssociateResult **assoc_res, DbvReleaseState *rel_state, DbvError **error, char *assoc_dbname);




#endif
