#include "dans_write.h"

/* From zraw_writeDbvFuncs.c */



void zraw_writeDbvObjectIdentifier(char *name, DbvObjectIdentifier psObjectIdentifier)
   {

   char temp[ 128 ];

   if ( psObjectIdentifier != NULL )
      {
      sprintf(temp, "%s: %s", name, psObjectIdentifier );
      } /* End if */
   else
      sprintf(temp, "%s : NULL", name);

   zraw_writechar_field(temp);
   

   } /* End zraw_writeDbvObjectIdentifier() */

void zraw_writeDbvVisibleString(char *name, DbvVisibleString psVisibleString)
   {

   char temp[ 128 ];

   if ( psVisibleString != NULL )
      {
      sprintf(temp, "%s: %s", name, psVisibleString );
      } /* End if */
   else
      sprintf(temp, "%s : NULL", name);

   zraw_writechar_field(temp);
   

   } /* End zraw_writeDbvVisibleString() */






void zraw_writeDbvStringOrNumeric( DbvStringOrNumeric *psStringOrNumeric)
   {
   char temp[ STRING_LEN ];
   char *pc_string = NULL;

   /* StringOrNumeric type */
   if(psStringOrNumeric == NULL)
   {
           zraw_writetitle_char("NULL","DbvStringOrNumeric");
           
           return;
   }

   convert_DbvStringOrNumericType( &pc_string, 
				   &psStringOrNumeric->eStringOrNumeric );
   sprintf( temp, "eStringOrNumericType : %s", pc_string );
   zraw_writechar_field( temp);
   DbvFree( pc_string );
   

   /* DbvStringOrNumeric */

   switch( psStringOrNumeric->eStringOrNumeric )
      {
      case SNT_String:
	 zraw_writeDbvInternationalString( "psString:" , 
				psStringOrNumeric->uStringOrNumeric.psString);
         
	 break;

      case SNT_Numeric:
         sprintf( temp, "pcNumeric: %ld", 
			psStringOrNumeric->uStringOrNumeric.ulNumeric );
         zraw_writechar_field( temp);
         
	 break;

      default:
	 break;
      } /* End switch */

   } /* End zraw_writeDbvStringOrNumeric() */


void zraw_writeinteger_string( char *name, int *pul)
   {
   char temp[ STRING_LEN ];
   if ( pul )
      sprintf(temp, "%s : %ld", name, *pul);
   else
      sprintf(temp, "%s : NULL", name );

   zraw_writechar_field( temp);

   } /* End zraw_writeinteger_string() */




void zraw_writeDbvTerm( DbvTerm *psTerm)
   {
	   char temp[ STRING_LEN ];
   char *pc_string = NULL;

   /* Write the title out */

   if(psTerm == NULL)
   {
           zraw_writetitle_char("NULL","DbvTerm");
           
           return;
   }

   zraw_writetitle_char("psTerm", "Structure");
   

   /* Term type */
   convert_DbvTermType( &pc_string, &psTerm->eTermType );
   sprintf( temp, "eTermType : %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* DbvTerm */

   switch( psTerm->eTermType )
      {
      case TT_General:
         zraw_writeDbvOctetString( "psGeneral :" , psTerm->uTerm.psGeneral);
         break;

      case TT_Numeric:
         sprintf( temp, "ulInteger : %ld", psTerm->uTerm.ulInteger );
         zraw_writechar_field(temp);
         
         break;

      case TT_SimpleCharacter:
         zraw_writeDbvInternationalString( "psSimpleCharacter :" ,
                                psTerm->uTerm.psSimpleCharacter);
         
         break;

      case TT_ObjectIdentifier:
         zraw_writeDbvObjectIdentifier( "pcObjectIdentifier :",
                                psTerm->uTerm.pcObjectIdentifier);
         break;

      case TT_DateTime:
         zraw_writeDbvGeneralizedTime( "pcDateTime",
                                   psTerm->uTerm.pcDateTime);
         break;

      case TT_External:
         print_external( psTerm->uTerm.psExternal);
         break;

      case TT_IntegerAndUnit:
         zraw_writeDbvIntUnit( psTerm->uTerm.psIntegerAndUnit);
         break;

      case TT_Null:
         break;

      default:
         break;
      } /* End switch */

   } /* End zraw_writeDbvTerm() */




void zraw_writeDbvGeneralizedTime(char *name, DbvGeneralizedTime psGeneralizedTime)
   {

   char temp[ STRING_LEN ];

   if ( psGeneralizedTime != NULL )
      {
      sprintf(temp, "%s: %s", name, psGeneralizedTime );
      } /* End if */
   else
      sprintf(temp, "%s : NULL", name);

   zraw_writechar_field(temp);
   

   } /* End zraw_writeDbvGeneralizedTime() */

void zraw_writeDbvIntUnit( DbvIntUnit *psIntUnit)
   {

   char temp[ STRING_LEN ];

   /* Write the title out */

   if(psIntUnit == NULL)
   {
           zraw_writetitle_char("NULL","DbvIntUnit");
           
           return;
   }

   zraw_writetitle_char("psIntUnit :", "Structure");
   

   /* Value */

   sprintf( temp, "ulValue: %ld", psIntUnit->ulValue );
   zraw_writechar_field( temp);
   

   /* Unit */

   zraw_writeDbvUnit( &psIntUnit->sUnitUsed);

   } /* End zraw_writeDbvIntUnit() */

void zraw_writeDbvUnit( DbvUnit *psUnit)
   {

   char temp[ STRING_LEN ];

   /* Write the title out */

   if(psUnit == NULL)
   {
           zraw_writetitle_char("NULL","DbvUnit");
           
           return;
   }

   zraw_writetitle_char("psUnit :", "Structure");
   

   /* Unit System */

   zraw_writeDbvInternationalString( "psUnitSystem", psUnit->psUnitSystem );

   

   /* Unit Type */

   if ( !psUnit->psUnitType )
      {
      sprintf( temp, "psUnitType : NULL" );
      zraw_writechar_field( temp);
      
      } /* End if */
   else
      zraw_writeDbvStringOrNumeric( psUnit->psUnitType);

   /* Unit */

   if ( !psUnit->psUnit )
      {
      sprintf( temp, "psUnit : NULL" );
      zraw_writechar_field( temp);
      
      } /* End if */
   else
      zraw_writeDbvStringOrNumeric( psUnit->psUnit);

   /* Scale Factor */

   zraw_writeinteger_string( "pulScaleFactor", (int *)psUnit->pulScaleFactor);
   

   } /* End zraw_writeDbvUnit() */




void zraw_writeDbvSpecification( DbvSpecification *psSpecification)
   {
   char temp[ STRING_LEN ];
   char *pc_string = NULL;

   /* Write the title out */

   if(psSpecification == NULL)
   {
           zraw_writetitle_char("NULL","DbvSpecification");
           
           return;
   }

   zraw_writetitle_char("psSpecification", "Structure");
   

   /* Schema */
   zraw_writeDbvObjectIdentifier( "pcSchema:", psSpecification->pcSchema);

   /* Specification type */

   convert_DbvElementSpecType( &pc_string, &psSpecification->eElementSpecType );
   sprintf( temp, "eElementSpecType : %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* DbvSpecification */

   switch( psSpecification->eElementSpecType )
      {
      case EST_Primitive:
         zraw_writeDbvInternationalString( "psPrimitive",
                                        psSpecification->
                                        uElementSpec.psPrimitive);
         
         break;

      case EST_External:
         print_external( psSpecification->uElementSpec.psExternal);
         break;

      default:
         break;
      } /* End switch */
   } /* End zraw_writeDbvSpecification() */

/* Functions beyond this point where added by Dan Maskell 8-2-96 */


void zraw_writeDbvGeneralString(char *name, DbvGeneralString
        *psGeneralString)
   {
   zraw_writeDbvOctetString(name, (DbvOctetString *)psGeneralString);
   } /* End zraw_writeDbvGeneralString() */





/********************************************************************/
/* From zraw_writeDbvFuncs2.c */

#undef DEBUG

void zraw_writeDbvCommonInfo( char *name, DbvCommonInfo *psCommonInfo)
   {
   char temp[ STRING_LEN  ];
#ifdef DEBUG
   printf( "D - zraw_writeDbvCommonInfo()\n" );
#endif

   /* Write the title out */ 
   if(psCommonInfo == NULL)
      {
      zraw_writetitle_char("NULL", name);
      
      return;
      } /* End if */

   zraw_writetitle_char(name, "Structure");
   


   /* pcDateAdded */
   zraw_writeDbvGeneralizedTime( "pcDateAdded", psCommonInfo->pcDateAdded);

   /* pcDateChanged */
   zraw_writeDbvGeneralizedTime( "pcDateChanged", psCommonInfo->pcDateChanged);

   /* pcExpiry */
   zraw_writeDbvGeneralizedTime( "pcExpiry", psCommonInfo->pcExpiry);

   /* psHumanStringLanguage */
   zraw_writeDbvLanguageCode( "psHumanStringLanguage", 
			   psCommonInfo->psHumanStringLanguage);

   /* ppsOtherInformation */
   
   if( psCommonInfo->ppsOtherInformation == NULL )
      {
      zraw_writechar_field("psOccurrenceByDb->ppsOtherInformation: NULL");
      
      }
   else
      writeN_DbvOtherInformation( psCommonInfo->ppsOtherInformation );

   } /* End zraw_writeDbvCommonInfo() */

void zraw_writeDbvHumanString( DbvHumanString *psHumanString)
   {
#ifdef DEBUG
   printf( "D - zraw_writeDbvHumanString()\n" );
#endif

   /* Write the title out */ 
   if(psHumanString == NULL)
      {
      zraw_writetitle_char("NULL","DbvHumanString");
      
      return;
      } /* End if */

   zraw_writetitle_char("psHumanString", "Structure");
   


   /* psLanguage */
   zraw_writeDbvLanguageCode( "psLanguage", psHumanString->psLanguage);

   /* psText */
   zraw_writeDbvInternationalString( "sText", &psHumanString->sText);

   } /* End zraw_writeDbvHumanString() */

void zraw_writeDbvBodyType( DbvBodyType *psBodyType)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;
#ifdef DEBUG
   printf( "D - zraw_writeDbvBodyType()\n" );
#endif


   /* Write the title out */ 
   if(psBodyType == NULL)
      {
      zraw_writetitle_char("NULL","DbvBodyType");
      
      return;
      } /* End if */

   zraw_writetitle_char("psBodyType", "Structure");
   


   /* eBodyTypeType */
   convert_DbvBodyTypeType( &pc_string, &psBodyType->eBodyTypeType);
   sprintf( temp, "eBodyType: %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* uBodyType */
   switch( psBodyType->eBodyTypeType )
      {
      case BTT_IanaType:
	 zraw_writeDbvInternationalString( "psIanaType",
				       psBodyType->uBodyType.psIanaType);
				 
	 break;

      case BTT_Z3950Type:
	 zraw_writeDbvInternationalString( "psIanaType",
				       psBodyType->uBodyType.psZ3950Type);
	 break;

      case BTT_OtherType:
	 zraw_writeDbvInternationalString( "psOtherType",
				       psBodyType->uBodyType.psOtherType);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End zraw_writeDbvBodyType() */

void zraw_writeDbvIconObject( DbvIconObject *psIconObject)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvIconObject()\n" );
#endif

   /* Write the title out */ 
   if(psIconObject == NULL)
      {
      zraw_writetitle_char("NULL","DbvIconObject");
      
      return;
      } /* End if */

   zraw_writetitle_char("psIconObject", "Structure");
   


   /* psBodyType */
   zraw_writeDbvBodyType( &psIconObject->sBodyType);
				
   /* sContent */
   zraw_writeDbvOctetString( "sContent", &psIconObject->sContent);

   } /* End zraw_writeDbvIconObject() */

void zraw_writeDbvContactInfo( DbvContactInfo *psContactInfo)
   {
#ifdef DEBUG
   printf( "D - zraw_writeDbvContactInfo()\n" );
#endif

   /* Write the title out */ 
   if(psContactInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvContactInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psContactInfo", "Structure");
   


   /* psName */
   zraw_writeDbvInternationalString( "psName", psContactInfo->psName);
				
   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription",
			  psContactInfo->ppsDescription);

   /* ppsAddress */
   writeN_DbvHumanString( "ppsAddress",
			  psContactInfo->ppsAddress);

   /* psEmail */
   zraw_writeDbvInternationalString( "psEmail", psContactInfo->psEmail);

   /* psPhone */
   zraw_writeDbvInternationalString( "psPhone", psContactInfo->psPhone);

   } /* End zraw_writeDbvContactInfo() */

void zraw_writeDbvInterAddress( DbvInterAddress *psInterAddress)
   {
   char temp[ SML_BUFFER ];
#ifdef DEBUG
   printf( "D - zraw_writeDbvInterAddress()\n" );
#endif


   /* Write the title out */ 
   if(psInterAddress == NULL)
      {
      zraw_writetitle_char("NULL","DbvInterAddress");
      
      return;
      } /* End if */

   zraw_writetitle_char("psInterAddress", "Structure");
   


   /* sHostAddress */
   zraw_writeDbvInternationalString( "sHostAddress", 
				 &psInterAddress->sHostAddress);
   /* ulPort */

   sprintf( temp, "ulPort: %ld", psInterAddress->ulPort  );
   zraw_writechar_field(temp);
   

   } /* End zraw_writeDbvInterAddress() */

void zraw_writeDbvOsiPresentationAddress(DbvOsiPresentationAddress *psOsiPresentationAddress)
   {
#ifdef DEBUG
   printf( "D - zraw_writeDbvOsiPresentationAddress()\n" );
#endif

   /* Write the title out */ 
   if(psOsiPresentationAddress == NULL)
      {
      zraw_writetitle_char("NULL","DbvOsiPresentationAddress");
      
      return;
      } /* End if */

   zraw_writetitle_char("psOsiPresentationAddress", "Structure");
   


   /* sPsel */
   zraw_writeDbvInternationalString( "sPsel", &psOsiPresentationAddress->sPsel);
   /* psSSel */
   zraw_writeDbvInternationalString( "psSSel", psOsiPresentationAddress->psSSel);
   /* psTSel */
   zraw_writeDbvInternationalString( "psTSel", psOsiPresentationAddress->psTSel);
   /* sNSap */
   zraw_writeDbvInternationalString( "sNSap", &psOsiPresentationAddress->sNSap);

   } /* End zraw_writeDbvOsiPresentationAddress() */

void zraw_writeDbvOtherAddress( DbvOtherAddress *psOtherAddress)
   {
#ifdef DEBUG
   printf( "D - zraw_writeDbvOtherAddress()\n" );
#endif

   /* Write the title out */ 
   if(psOtherAddress == NULL)
      {
      zraw_writetitle_char("NULL","DbvOtherAddress");
      
      return;
      } /* End if */

   zraw_writetitle_char("psOtherAddress", "Structure");
   


   /* sType */
   zraw_writeDbvInternationalString( "sType", &psOtherAddress->sType);

   /* sAddress */
   zraw_writeDbvInternationalString( "sAddress", &psOtherAddress->sAddress);

   } /* End zraw_writeDbvOtherAddress() */

void zraw_writeDbvNetworkAddress( DbvNetworkAddress *psNetworkAddress)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;
#ifdef DEBUG
   printf( "D - zraw_writeDbvNetworkAddress()\n" );
#endif


   /* Write the title out */ 
   if(psNetworkAddress == NULL)
      {
      zraw_writetitle_char("NULL","DbvNetworkAddress");
      
      return;
      } /* End if */

   zraw_writetitle_char("psNetworkAddress", "Structure");
   


   /* eNetworkAddressType */
   convert_DbvNetworkAddressType( &pc_string, 
				  &psNetworkAddress->eNetworkAddressType);
   sprintf( temp, "eNetworkAddress: %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* uNetworkAddress */

   switch( psNetworkAddress->eNetworkAddressType )
      {
      case NAT_InternetAddress:
	 zraw_writeDbvInterAddress( psNetworkAddress->
				uNetworkAddress.psInternetAddress);
	 break;

      case NAT_OsiPresentationAddress:
	 zraw_writeDbvOsiPresentationAddress( psNetworkAddress->
				uNetworkAddress.psOsiPresentationAddress);
	 break;

      case NAT_OtherAddress:
	 zraw_writeDbvOtherAddress( psNetworkAddress->
				uNetworkAddress.psOtherAddress);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End zraw_writeDbvNetworkAddress() */

void zraw_writeDbvOperators( DbvOperators *psOperators)
   {
#ifdef DEBUG
   printf( "D - zraw_writeDbvOperators()\n" );
#endif

   /* Write the title out */ 
   if(psOperators == NULL)
      {
      zraw_writetitle_char("NULL","DbvOperators");
      
      return;
      } /* End if */

   zraw_writetitle_char("psOperators", "Structure");
   


   /* sOperator */
   zraw_writeDbvInternationalString( "sOperator", &psOperators->sOperator);
   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psOperators->ppsDescription);

   } /* End zraw_writeDbvOperators() */

void zraw_writeDbvSearchKey( DbvSearchKey *psSearchKey)
   {
#ifdef DEBUG
   printf( "D - zraw_writeDbvSearchKey()\n" );
#endif

   /* Write the title out */ 
   if(psSearchKey == NULL)
      {
      zraw_writetitle_char("NULL","DbvSearchKey");
      
      return;
      } /* End if */

   zraw_writetitle_char("psSearchKey", "Structure");
   


   /* sSearchKey */
   zraw_writeDbvInternationalString( "sSearchKey", &psSearchKey->sSearchKey);
   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psSearchKey->ppsDescription);

   } /* End zraw_writeDbvSearchKey() */



void writeN_DbvHumanStringSeq( char *name, DbvHumanStringSeq **ppsDescription)
   {

   if( ppsDescription != NULL)
      {
      zraw_writechar_field( name);
      

      while( ppsDescription && *ppsDescription )
         {
         zraw_writeDbvHumanStringSeq( *ppsDescription);
         ppsDescription++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvHumanStringSeq");
      
      } /* End else */

     
   } /* End writeN_DbvHumanStringSeq() */


void zraw_writeDbvPrivateCapabilities( 
		DbvPrivateCapabilities *psPrivateCapabilities)
   {
#ifdef DEBUG
   printf( "D -zraw_writeDbvPrivateCapabilities()\n" );
#endif

   /* Write the title out */ 
   if(psPrivateCapabilities == NULL)
      {
      zraw_writetitle_char("NULL","DbvPrivateCapabilities");
      
      return;
      } /* End if */

   zraw_writetitle_char("psPrivateCapabilities", "Structure");
   


   /* ppsOperators */
   writeN_DbvOperators( psPrivateCapabilities->ppsOperators);

   /* ppsSearchKey */
   writeN_DbvSearchKey( psPrivateCapabilities->ppsSearchKeys);

   /* ppsDescription */
   writeN_DbvHumanStringSeq( "ppsDescription", 
			  psPrivateCapabilities->ppsDescription);

   } /* End zraw_writeDbvPrivateCapabilities() */

void zraw_writeDbvPrivate( DbvPrivate *psPrivate)
   {
   char temp[ STRING_LEN  ];
#ifdef DEBUG
   printf( "D - zraw_writeDbvPrivate()\n" );
#endif

   /* Write the title out */ 
   if(psPrivate == NULL)
      {
      zraw_writetitle_char("NULL","DbvPrivate");
      
      return;
      } /* End if */

   zraw_writetitle_char("psPrivate", "Structure");
   


   /* ulUnit */
   sprintf( temp, "ulUnit: %ld", psPrivate->ulUnit );
   zraw_writechar_field(temp);
   

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psPrivate->ppsDescription);


   } /* End zraw_writeDbvPrivate() */

void zraw_writeDbvUnitsSupported( DbvUnitsSupported *psUnitsSupported)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;
#ifdef DEBUG
   printf( "D - zraw_writeDbvUnitsSupported()\n" );
#endif


   /* Write the title out */ 
   if(psUnitsSupported == NULL)
      {
      zraw_writetitle_char("NULL","DbvUnitsSupported");
      
      return;
      } /* End if */

   zraw_writetitle_char("psUnitsSupported", "Structure");
   


   /* eUnitsSupportedType */
   convert_DbvUnitsSupportedType( &pc_string,
				  &psUnitsSupported->eUnitsSupportedType);
   sprintf( temp, "eUnitsSupported: %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* uUnitsSupported */

   switch( psUnitsSupported->eUnitsSupportedType )
      {
      case UST_Known:
         sprintf( temp, "ulKnown: %ld", 
		  psUnitsSupported->uUnitsSupported.ulKnown );
         zraw_writechar_field(temp);
         
	 break;

      case UST_Private:
	 zraw_writeDbvPrivate( psUnitsSupported->uUnitsSupported.psPrivate);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End zraw_writeDbvUnitsSupported() */

void zraw_writeDbvProximitySupport( DbvProximitySupport *psProximitySupport)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvProximitySupport()\n" );
#endif

   /* Write the title out */ 
   if(psProximitySupport == NULL)
      {
      zraw_writetitle_char("NULL","DbvProximitySupport");
      
      return;
      } /* End if */

   zraw_writetitle_char("psProximitySupport", "Structure");
   


   /* fAnySupport */
   zraw_writeDbvBool("fAnySupport", psProximitySupport->fAnySupport);
   

   /* ppsUnitsSupported */
   writeN_DbvUnitsSupported( psProximitySupport->ppsUnitsSupported);

   } /* End zraw_writeDbvProximitySupport() */

void zraw_writeDbvRpnCapabilities( DbvRpnCapabilities *psRpnCapabilities)
   {
#ifdef DEBUG
   printf( "D - zraw_writeDbvRpnCapabilities()\n" );
#endif

   /* Write the title out */ 
   if(psRpnCapabilities == NULL)
      {
      zraw_writetitle_char("NULL","DbvRpnCapabilities");
      
      return;
      } /* End if */

   zraw_writetitle_char("psRpnCapabilities", "Structure");
   


   /* ppulOperators */
   writeN_Ulong( "ppulOperators", psRpnCapabilities->ppulOperators);

   /* fResultSetAsOperandSupported */
   zraw_writeDbvBool("fResultSetAsOperandSupported",
		 psRpnCapabilities->fResultSetAsOperandSupported);
   

   /* fRestrictionOperandSupported */
   zraw_writeDbvBool("fRestrictionOperandSupported", 
		 psRpnCapabilities->fRestrictionOperandSupported);
   

   /* psProximity */
   zraw_writeDbvProximitySupport( psRpnCapabilities->psProximity);

   } /* End zraw_writeDbvRpnCapabilities() */

void zraw_writeDbvIso8777Capabilities(DbvIso8777Capabilities *psIso8777Capabilities)
   {
#ifdef DEBUG
   printf( "D - zraw_writeDbvIso8777Capabilities()\n" );
#endif

   /* Write the title out */ 
   if(psIso8777Capabilities == NULL)
      {
      zraw_writetitle_char("NULL","DbvIso8777Capabilities");
      
      return;
      } /* End if */

   zraw_writetitle_char("psIso8777Capabilities", "Structure");
   


   /* ppsSearchKeys */
   writeN_DbvSearchKey( psIso8777Capabilities->ppsSearchKeys);

   /* ppsRestrictions */
   writeN_DbvHumanString( "ppsRestrictions", 
			  psIso8777Capabilities->ppsRestrictions);

   } /* End zraw_writeDbvIso8777Capabilities() */

void zraw_writeDbvQueryTypeDetails( 
		DbvQueryTypeDetails *psQueryTypeDetails)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvQueryTypeDetails()\n" );
#endif

   /* Write the title out */ 
   if(psQueryTypeDetails == NULL)
      {
      zraw_writetitle_char("NULL","DbvQueryTypeDetails");
      
      return;
      } /* End if */

   zraw_writetitle_char("psQueryTypeDetails", "Structure");
   


   /* eQueryTypeDetailsType */
   convert_DbvQueryTypeDetailsType( &pc_string, 
				    &psQueryTypeDetails->eQueryTypeDetailsType);
   sprintf( temp, "eQueryTypeDetails: %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* uQueryTypeDetails */

   switch( psQueryTypeDetails->eQueryTypeDetailsType )
      {
      case QTDT_Private:
	 zraw_writeDbvPrivateCapabilities( psQueryTypeDetails->
				       uQueryTypeDetails.psPrivate );
	 break;

      case QTDT_Rpn:
	 zraw_writeDbvRpnCapabilities( psQueryTypeDetails->
				   uQueryTypeDetails.psRpn);
	 break;

      case QTDT_Iso8777:
	 zraw_writeDbvIso8777Capabilities( psQueryTypeDetails->
				       uQueryTypeDetails.psIso8777);
	 break;

      case QTDT_Z39_58:
	 writeN_DbvHumanString( "ppsZ39_58",
				psQueryTypeDetails->uQueryTypeDetails.ppsZ39_58);
	 break;

      case QTDT_Erpn:
	 zraw_writeDbvRpnCapabilities( psQueryTypeDetails->
				   uQueryTypeDetails.psErpn);
	 break;

      case QTDT_RankedList:
	 writeN_DbvHumanString( "ppsRankedList",
			       psQueryTypeDetails->
			       uQueryTypeDetails.ppsRankedList);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End zraw_writeDbvQueryTypeDetails() */

void zraw_writeDbvAccessRestrictions( DbvAccessRestrictions *psAccessRestrictions)
   {
   char temp[ STRING_LEN ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvAccessRestrictions()\n" );
#endif

   /* Write the title out */ 
   if(psAccessRestrictions == NULL)
      {
      zraw_writetitle_char("NULL","DbvAccessRestrictions");
      
      return;
      } /* End if */

   zraw_writetitle_char("psAccessRestrictions", "Structure");
   


   /* eAccessType */
   convert_DbvAccessType( &pc_string, &psAccessRestrictions->eAccessType);
   sprintf( temp, "eAccessType: %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* ppsAccessText */
   writeN_DbvHumanString( "ppsAccessText", psAccessRestrictions->ppsAccessText);

   /* ppcAccessChallenges */
   writeN_DbvObjectIdentifier( "ppcAccessChallenges", 
				psAccessRestrictions->ppcAccessChallenges);

   } /* End zraw_writeDbvAccessRestrictions() */

void zraw_writeDbvCharge( DbvCharge *psCharge)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvCharge()\n" );
#endif

   /* Write the title out */ 
   if(psCharge == NULL)
      {
      zraw_writetitle_char("NULL","DbvCharge");
      
      return;
      } /* End if */

   zraw_writetitle_char("psCharge", "Structure");
   


   /* sCost */
   zraw_writeDbvIntUnit( &psCharge->sCost);

   /* psPerWhat */
   zraw_writeDbvUnit( psCharge->psPerWhat);

   /* ppsText */
   writeN_DbvHumanString( "ppsText", psCharge->ppsText);

   } /* End zraw_writeDbvCharge() */

void zraw_writeDbvOtherCharge( DbvOtherCharge *psOtherCharge)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvOtherCharge()\n" );
#endif

   /* Write the title out */ 
   if(psOtherCharge == NULL)
      {
      zraw_writetitle_char("NULL","DbvOtherCharge");
      
      return;
      } /* End if */

   zraw_writetitle_char("psOtherCharge", "Structure");
   


   /* ppsForWhat */
   writeN_DbvHumanString( "ppsForWhat", psOtherCharge->ppsForWhat);

   /* sCharge */
   zraw_writeDbvCharge( &psOtherCharge->sCharge);

   } /* End zraw_writeDbvOtherCharge() */

void zraw_writeDbvCosts( DbvCosts *psCosts)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvCosts()\n" );
#endif

   /* Write the title out */ 
   if(psCosts == NULL)
      {
      zraw_writetitle_char("NULL","DbvCosts");
      
      return;
      } /* End if */

   zraw_writetitle_char("psCosts", "Structure");
   


   /* psConnectCharge */
   zraw_writeDbvCharge( psCosts->psConnectCharge);

   /* psConnectTime */
   zraw_writeDbvCharge( psCosts->psConnectTime);

   /* psDisplayCharge */
   zraw_writeDbvCharge( psCosts->psDisplayCharge);

   /* psSearchCharge */
   zraw_writeDbvCharge( psCosts->psSearchCharge);

   /* psSubscriptCharge */
   zraw_writeDbvCharge( psCosts->psSubscriptCharge);

   /* ppsOtherCharge */
   writeN_DbvOtherCharge( psCosts->ppsOtherCharge);

   } /* End zraw_writeDbvCosts() */

void zraw_writeDbvAccessInfo( DbvAccessInfo *psAccessInfo)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvAccessInfo()\n" );
#endif

   /* Write the title out */ 
   if(psAccessInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvAccessInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psAccessInfo", "Structure");
   


   /* ppsQueryTypesSupported */
   writeN_DbvQueryTypeDetails( psAccessInfo->ppsQueryTypesSupported);

   /* ppcDiagnosticsSets */
   writeN_DbvObjectIdentifier( "ppcDiagnosticsSets", 
				psAccessInfo->ppcDiagnosticsSets);

   /* ppcAttributeSetIds */
   writeN_DbvObjectIdentifier( "ppcAttributeSetIds",
				psAccessInfo->ppcAttributeSetIds);

   /* ppcSchemas */
   writeN_DbvObjectIdentifier( "ppcSchemas", psAccessInfo->ppcSchemas);

   /* ppcRecordSyntaxes */
   writeN_DbvObjectIdentifier( "ppcRecordSyntaxes", 
				psAccessInfo->ppcRecordSyntaxes);

   /* ppcResourceChallenges */
   writeN_DbvObjectIdentifier( "ppcResourceChallenges",
				psAccessInfo->ppcResourceChallenges);

   /* ppsRestrictedAccess */
   writeN_DbvAccessRestrictions( psAccessInfo->ppsRestrictedAccess);

   /* psCostInfo */
   zraw_writeDbvCosts( psAccessInfo->psCostInfo);

   /* ppcVariantSets */
   writeN_DbvObjectIdentifier( "ppcVariantSets", 
				psAccessInfo->ppcVariantSets);

   /* ppsElementSetNames */
   writeN_DbvInternationalString( "ppsElementSetNames",
				 psAccessInfo->ppsElementSetNames);
   /* ppsUnitSystems */
   writeN_DbvInternationalString( "ppsUnitSystems", 
				  psAccessInfo->ppsUnitSystems);

   } /* End zraw_writeDbvAccessInfo() */

void zraw_writeDbvTargetInfo( DbvTargetInfo *psTargetInfo)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvTargetInfo()\n" );
#endif

   /* Write the title out */ 
   if(psTargetInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvTargetInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psTargetInfo", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psTargetInfo->psCommonInfo);

   /* sName */
   zraw_writeDbvInternationalString( "sName", &psTargetInfo->sName);
   /* ppsRecentNews */
   writeN_DbvHumanString( "ppsRecentNews", psTargetInfo->ppsRecentNews);

   /* ppsIcon */
   writeN_DbvIconObject( psTargetInfo->ppsIcon);

   /* fNamedResultSets */
   zraw_writeDbvBool("fNamedResultSets", psTargetInfo->fNamedResultSets);
   

   /* fMultipleDBSearch */
   zraw_writeDbvBool("fMultipleDBSearch", psTargetInfo->fMultipleDBSearch);
   

   /* pulMaxResultSets */
   zraw_writeinteger_string("pulMaxResultSets", 
			(int *)psTargetInfo->pulMaxResultSets);
   

   /* pulMaxResultSize */
   zraw_writeinteger_string("pulMaxResultSize", 
			(int *)psTargetInfo->pulMaxResultSize);
   

   /* pulMaxTerms */
   zraw_writeinteger_string("pulMaxTerms", (int *)psTargetInfo->pulMaxTerms);
   

   /* psTimeoutInterval */
   zraw_writeDbvIntUnit( psTargetInfo->psTimeoutInterval);

   /* ppsWelcomeMessage */
   writeN_DbvHumanString( "ppsWelcomeMessage", 
			  psTargetInfo->ppsWelcomeMessage);

   /* psContactInfo */
   zraw_writeDbvContactInfo( psTargetInfo->psContactInfo);

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psTargetInfo->ppsDescription);

   /* ppsNicknames */
   writeN_DbvInternationalString( "ppsNicknames",
			  psTargetInfo->ppsNicknames);
   /* ppsUsageRest */
   writeN_DbvHumanString( "ppsUsageRest", psTargetInfo->ppsUsageRest);

   /* ppsPaymentAddr */
   writeN_DbvHumanString( "ppsPaymentAddr", psTargetInfo->ppsPaymentAddr);

   /* ppsHours */
   writeN_DbvHumanString( "ppsHours", psTargetInfo->ppsHours);

   /* ppsDbCombinations */
   writeN_DbvDatabaseList( "ppsDbCombinations",
			  psTargetInfo->ppsDbCombinations);
   /* ppsAddresses */
   writeN_DbvNetworkAddress( psTargetInfo->ppsAddresses);

   /* psCommonAccessInfo */
   zraw_writeDbvAccessInfo( psTargetInfo->psCommonAccessInfo);

   } /* End zraw_writeDbvTargetInfo() */

void zraw_writeDbvRecordCount( DbvRecordCount *psRecordCount)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvRecordCount()\n" );
#endif

   /* Write the title out */ 
   if(psRecordCount == NULL)
      {
      zraw_writetitle_char("NULL","DbvRecordCount");
      
      return;
      } /* End if */

   zraw_writetitle_char("psRecordCount", "Structure");
   


   /* eRecordCountType */
   convert_DbvRecordCountType( &pc_string, &psRecordCount->eRecordCountType);
   sprintf( temp, "eRecordCount: %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* uRecordCount */

   switch( psRecordCount->eRecordCountType )
      {
      case RCT_ActualNumber:
         sprintf( temp, "ulActualNumber: %ld",
			psRecordCount->uRecordCount.ulActualNumber  );
         zraw_writechar_field(temp);
         
	 break;

      case RCT_ApproxNumber:
         sprintf( temp, "ulApproxNumber: %ld",
			psRecordCount->uRecordCount.ulApproxNumber  );
         zraw_writechar_field(temp);
         
	 break;

      default:
	 break;
      } /* End switch */

   } /* End zraw_writeDbvRecordCount() */

void zraw_writeDbvDatabaseInfo( DbvDatabaseInfo *psDatabaseInfo)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvDatabaseInfo()\n" );
#endif

   /* Write the title out */ 
   if(psDatabaseInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvDatabaseInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psDatabaseInfo", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psDatabaseInfo->psCommonInfo);

   /* sName */
   zraw_writeDbvInternationalString( "sName", &psDatabaseInfo->sName);

   /* pvExplainDatabase */
   zraw_writeDbvNull( "pvExplainDatabase",
		  psDatabaseInfo->pvExplainDatabase);

   /* ppsNicknames */
   writeN_DbvInternationalString( "ppsNicknames",
				psDatabaseInfo->ppsNicknames);

   /* ppsIcon */
   writeN_DbvIconObject( psDatabaseInfo->ppsIcon);

   /* fUserFee */
   zraw_writeDbvBool("fUserFee", psDatabaseInfo->fUserFee);
   

   /* fAvailable */
   zraw_writeDbvBool("fAvailable", psDatabaseInfo->fAvailable);
   

   /* ppsTitleString */
   writeN_DbvHumanString( "ppsTitleString", psDatabaseInfo->ppsTitleString);
   /* ppsKeywords */
   writeN_DbvDataBaseInfoSeq( "ppsKeywords", psDatabaseInfo->ppsKeywords);

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psDatabaseInfo->ppsDescription);

   /* ppsAssociatedDbs */
   writeN_DbvInternationalString( "ppsAssociatedDbs",
				psDatabaseInfo->ppsAssociatedDbs);
   /* ppsSubDbs */
   writeN_DbvInternationalString( "ppsSubDbs",
				psDatabaseInfo->ppsSubDbs);
   /* ppsDisclaimers */
   writeN_DbvHumanString( "ppsDisclaimers", psDatabaseInfo->ppsDisclaimers);

   /* ppsNews */
   writeN_DbvHumanString( "ppsNews", psDatabaseInfo->ppsNews);

   /* psRecordCount */
   zraw_writeDbvRecordCount( psDatabaseInfo->psRecordCount);

   /* ppsDefaultOrder */
   writeN_DbvHumanString( "ppsDefaultOrder", psDatabaseInfo->ppsDefaultOrder);

   /* pulAvRecordSize */
   zraw_writeinteger_string("pulAvRecordSize", 
			(int *)psDatabaseInfo->pulAvRecordSize);
   

   /* pulMaxRecordSize */
   zraw_writeinteger_string("pulMaxRecordSize", 
			(int *)psDatabaseInfo->pulMaxRecordSize);
   

   /* ppsHours */
   writeN_DbvHumanString( "ppsHours", psDatabaseInfo->ppsHours);

   /* ppsBestTime */
   writeN_DbvHumanString( "ppsBestTime",psDatabaseInfo->ppsBestTime);

   /* pcLastUpdate */
   zraw_writeDbvGeneralizedTime( "pcLastUpdate", psDatabaseInfo->pcLastUpdate);

   /* psUpdateInterval */
   zraw_writeDbvIntUnit( psDatabaseInfo->psUpdateInterval);

   /* ppsCoverage */
   writeN_DbvHumanString( "ppsCoverage",psDatabaseInfo->ppsCoverage);

   /* pfProprietary */
   if ( psDatabaseInfo->pfProprietary )
      zraw_writeDbvBool("pfProprietary", *psDatabaseInfo->pfProprietary);
   else
      zraw_writetitle_char("NULL","pfProprietary");
   

   /* ppsCopyrightText */
   writeN_DbvHumanString( "ppsCopyrightText", psDatabaseInfo->ppsCopyrightText);
   /* ppsCopyrightNotice */
   writeN_DbvHumanString( "ppsCopyrightNotice",
				psDatabaseInfo->ppsCopyrightNotice);
   /* psProducerContactInfo */
   zraw_writeDbvContactInfo( psDatabaseInfo->psProducerContactInfo);

   /* psSupplierContactInfo */
   zraw_writeDbvContactInfo( psDatabaseInfo->psSupplierContactInfo);

   /* psSubmissionContactInfo */
   zraw_writeDbvContactInfo( psDatabaseInfo->psSubmissionContactInfo);

   /* psAccessInfo */
   zraw_writeDbvAccessInfo( psDatabaseInfo->psAccessInfo);

   } /* End zraw_writeDbvDatabaseInfo() */

void zraw_writeDbvTagTypeMapping( DbvTagTypeMapping *psTagTypeMapping)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvTagTypeMapping()\n" );
#endif

   /* Write the title out */ 
   if(psTagTypeMapping == NULL)
      {
      zraw_writetitle_char("NULL","DbvTagTypeMapping");
      
      return;
      } /* End if */

   zraw_writetitle_char("psTagTypeMapping", "Structure");
   


   /* ulTagType */
   zraw_writeinteger_string("ulTagType", (int *)&psTagTypeMapping->ulTagType);
   

   /* pcTagSet */
   zraw_writeDbvObjectIdentifier( "pcTagSet", psTagTypeMapping->pcTagSet);

   /* pvDefaultTagType */
   zraw_writeDbvNull( "pvDefaultTagType",
		  psTagTypeMapping->pvDefaultTagType);

   } /* End zraw_writeDbvTagTypeMapping() */

void zraw_writeDbvPath( DbvPath *psPath)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvPath()\n" );
#endif

   /* Write the title out */ 
   if(psPath == NULL)
      {
      zraw_writetitle_char("NULL","DbvPath");
      
      return;
      } /* End if */

   zraw_writetitle_char("psPath", "Structure");
   


   /* ulTagType */
   zraw_writeinteger_string("ulTagType", (int *)&psPath->ulTagType);
   

   /* sTagValue */
   zraw_writeDbvStringOrNumeric( &psPath->sTagValue);

   } /* End zraw_writeDbvPath() */

void zraw_writeDbvElementInfo( DbvElementInfo *psElementInfo)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvElementInfo()\n" );
#endif

   /* Write the title out */ 
   if(psElementInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvElementInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psElementInfo", "Structure");
   


   /* sElementName */
   zraw_writeDbvInternationalString( "sElementName", &psElementInfo->sElementName);

   /* ppsElementTagPath */
   writeN_DbvPath( psElementInfo->ppsElementTagPath);

   /* psDataType */
   zraw_writeDbvElementDataType( psElementInfo->psDataType);

   /* fRequired */
   zraw_writeDbvBool("fRequired", psElementInfo->fRequired);
   

   /* fRepeatable */
   zraw_writeDbvBool("fRepeatable", psElementInfo->fRepeatable);
   

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psElementInfo->ppsDescription);

   } /* End zraw_writeDbvElementInfo() */

void zraw_writeDbvElementDataType( DbvElementDataType *psElementDataType)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvElementDataType()\n" );
#endif

   /* Write the title out */ 
   if(psElementDataType == NULL)
      {
      zraw_writetitle_char("NULL","DbvElementDataType");
      
      return;
      } /* End if */

   zraw_writetitle_char("psElementDataType", "Structure");
   


   /* eElementDataTypeType */
   convert_DbvElementDataTypeType( &pc_string, 
				   &psElementDataType->eElementDataTypeType);
   sprintf( temp, "eElementDataType: %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* uElementDataType */

   switch( psElementDataType->eElementDataTypeType )
      {
      case EDTT_Primitive:
	 zraw_writeDbvPrimitiveDataType( "ePrimitive", 
				     &psElementDataType->
				     uElementDataType.ePrimitive);
	 break;

      case EDTT_Structured:
	 writeN_DbvElementInfo( psElementDataType->
				uElementDataType.ppsStructured);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End zraw_writeDbvElementDataType() */

void zraw_writeDbvSchemaInfo( DbvSchemaInfo *psSchemaInfo)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvSchemaInfo()\n" );
#endif

   /* Write the title out */ 
   if(psSchemaInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvSchemaInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psSchemaInfo", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psSchemaInfo->psCommonInfo);

   /* pcSchema */
   zraw_writeDbvObjectIdentifier( "pcSchema", psSchemaInfo->pcSchema);

   /* sName */
   zraw_writeDbvInternationalString( "sName", &psSchemaInfo->sName);

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psSchemaInfo->ppsDescription);

   /* ppsTagTypeMapping */
   writeN_DbvTagTypeMapping( psSchemaInfo->ppsTagTypeMapping);

   /* ppsRecordStructure */
   writeN_DbvElementInfo( psSchemaInfo->ppsRecordStructure);

   } /* End zraw_writeDbvSchemaInfo() */

void zraw_writeDbvElements( DbvElements *psElements)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvElements()\n" );
#endif

   /* Write the title out */ 
   if(psElements == NULL)
      {
      zraw_writetitle_char("NULL","DbvElements");
      
      return;
      } /* End if */

   zraw_writetitle_char("psElements", "Structure");
   


   /* sElementName */
   zraw_writeDbvInternationalString( "sElementName", 
				 &psElements->sElementName);
   /* ppsNicknames */
   writeN_DbvInternationalString( "ppsNicknames", 
				  psElements->ppsNicknames);
   /* sElementTag */
   zraw_writeDbvStringOrNumeric( &psElements->sElementTag);
   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psElements->ppsDescription);

   /* peDataType */
   zraw_writeDbvPrimitiveDataType( "peDataType",psElements->peDataType);

   /* ppsOtherInformation */
   writeN_DbvOtherInformation( psElements->ppsOtherInformation);

   } /* End zraw_writeDbvElements() */

void zraw_writeDbvPrimitiveDataType( char *name, DbvPrimitiveDataType *pePrimitiveDataType)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvPrimitiveDataType()\n" );
#endif

   /* Write the title out */ 
   if(pePrimitiveDataType == NULL)
      {
      zraw_writetitle_char("NULL","DbvPrimitiveDataType");
      
      return;
      } /* End if */

   /* ePrimitiveDataType */
   convert_DbvPrimitiveDataType( &pc_string, pePrimitiveDataType );
   sprintf( temp, "%s : %s", name, pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   } /* End zraw_writeDbvPrimitiveDataType() */

void zraw_writeDbvTagSetInfo( DbvTagSetInfo *psTagSetInfo)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvTagSetInfo()\n" );
#endif

   /* Write the title out */ 
   if(psTagSetInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvTagSetInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psTagSetInfo", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psTagSetInfo->psCommonInfo);

   /* pcTagSet */
   zraw_writeDbvObjectIdentifier( "pcTagSet", psTagSetInfo->pcTagSet);

   /* sName */
   zraw_writeDbvInternationalString( "sName", &psTagSetInfo->sName);

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psTagSetInfo->ppsDescription);

   /* ppsElements */
   writeN_DbvElements( psTagSetInfo->ppsElements);

   } /* End zraw_writeDbvTagSetInfo() */

void zraw_writeDbvRecordSyntaxInfo( DbvRecordSyntaxInfo *psRecordSyntaxInfo)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvRecordSyntaxInfo()\n" );
#endif

   /* Write the title out */ 
   if(psRecordSyntaxInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvRecordSyntaxInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psRecordSyntaxInfo", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psRecordSyntaxInfo->psCommonInfo);

   /* pcRecordSyntax */
   zraw_writeDbvObjectIdentifier( "pcRecordSyntax",
			      psRecordSyntaxInfo->pcRecordSyntax);

   /* sName */
   zraw_writeDbvInternationalString( "sName", &psRecordSyntaxInfo->sName);

   /* ppcTransferSyntaxes */
   writeN_DbvObjectIdentifier( "ppcTransferSyntaxes", 
			       psRecordSyntaxInfo->ppcTransferSyntaxes);

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psRecordSyntaxInfo->ppsDescription);

   /* psAsn1Module */
   zraw_writeDbvInternationalString( "psAsn1Module", 
				  psRecordSyntaxInfo->psAsn1Module);
   /* ppsAbstractStructure */

   writeN_DbvElementInfo( psRecordSyntaxInfo->ppsAbstractStructure);

   } /* End zraw_writeDbvRecordSyntaxInfo() */

void zraw_writeDbvAttributeDescription(DbvAttributeDescription *psAttributeDescription)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvAttributeDescription()\n" );
#endif

   /* Write the title out */ 
   if(psAttributeDescription == NULL)
      {
      zraw_writetitle_char("NULL","DbvAttributeDescription");
      
      return;
      } /* End if */

   zraw_writetitle_char("psAttributeDescription", "Structure");
   


   /* psName */
   zraw_writeDbvInternationalString( "psName", 
				psAttributeDescription->psName);

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", 
			  psAttributeDescription->ppsDescription);

   /* psAttributeValue */
   zraw_writeDbvStringOrNumeric( &psAttributeDescription->sAttributeValue);
   /* ppsEquivalentAttributes */
   writeN_DbvStringOrNumeric( psAttributeDescription->ppsEquivalentAttributes);

   } /* End zraw_writeDbvAttributeDescription() */

void zraw_writeDbvAttributeType( DbvAttributeType *psAttributeType)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvAttributeType()\n" );
#endif

   /* Write the title out */ 
   if(psAttributeType == NULL)
      {
      zraw_writetitle_char("NULL","DbvAttributeType");
      
      return;
      } /* End if */

   zraw_writetitle_char("psAttributeType", "Structure");
   


   /* psName */
   zraw_writeDbvInternationalString( "psName", psAttributeType->psName);

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psAttributeType->ppsDescription);
   /* UlAttributeType */

   zraw_writeinteger_string( "ulAttributeType", 
			(int*)&psAttributeType->ulAttributeType);
   

   /* ppsAttributeValues */
   writeN_DbvAttributeDescription( psAttributeType->ppsAttributeValues);

   } /* End zraw_writeDbvAttributeType() */

void zraw_writeDbvAttributeSetInfo( DbvAttributeSetInfo *psAttributeSetInfo )
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvAttributeSetInfo()\n" );
#endif

   /* Write the title out */ 
   if(psAttributeSetInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvAttributeSetInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psAttributeSetInfo", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psAttributeSetInfo->psCommonInfo);

   /* pcAttributeSetId */
   zraw_writeDbvObjectIdentifier( "pcAttributeSetId", 
				psAttributeSetInfo->pcAttributeSetId);
   /* sName */
   zraw_writeDbvInternationalString( "sName", &psAttributeSetInfo->sName );
   /* ppsAttributes */
   writeN_DbvAttributeType( psAttributeSetInfo->ppsAttributes);

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psAttributeSetInfo->ppsDescription );

   } /* End zraw_writeDbvAttributeSetInfo() */

void zraw_writeDbvTermList( DbvTermList *psTermList)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvTermList()\n" );
#endif

   /* Write the title out */ 
   if(psTermList == NULL)
      {
      zraw_writetitle_char("NULL","DbvTermList");
      
      return;
      } /* End if */

   zraw_writetitle_char("psTermList", "Structure");
   


   /* sName */
   zraw_writeDbvInternationalString( "sName", &psTermList->sName);

   /* ppsTitle */
   writeN_DbvHumanString( "ppsTitle", psTermList->ppsTitle);

   /* peSearchCost */
   zraw_writeDbvSearchCost( "peSearchCost", psTermList->peSearchCost);

   /* fScanable */
   zraw_writeDbvBool("fScanable", psTermList->fScanable);
   

   /* ppsBroader */
   writeN_DbvInternationalString( "ppsBroader", psTermList->ppsBroader );
   /* ppsNarrower */
   writeN_DbvInternationalString( "ppsNarrower", psTermList->ppsNarrower);

   } /* End zraw_writeDbvTermList() */

void zraw_writeDbvTermListInfo( DbvTermListInfo *psTermListInfo)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvTermListInfo()\n" );
#endif

   /* Write the title out */ 
   if(psTermListInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvTermListInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psTermListInfo", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psTermListInfo->psCommonInfo);

   /* psDatabaseName */
   zraw_writeDbvInternationalString( "psDatabaseName", 
				 &psTermListInfo->sDatabaseName );
   /* ppsTermLists */
   writeN_DbvTermList( psTermListInfo->ppsTermLists);

   } /* End zraw_writeDbvTermListInfo() */

void zraw_writeDbvExtendedServicesInfo(DbvExtendedServicesInfo *psExtendedServicesInfo )
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvExtendedServicesInfo()\n" );
#endif

   /* Write the title out */ 
   if(psExtendedServicesInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvExtendedServicesInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psExtendedServicesInfo", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psExtendedServicesInfo->psCommonInfo);

   /* pcType */
    zraw_writeDbvObjectIdentifier( "pcType", psExtendedServicesInfo->pcType );

   /* psName */
   zraw_writeDbvInternationalString( "psName", psExtendedServicesInfo->psName );

   /* fPrivateType */
   zraw_writeDbvBool("fPrivateType", psExtendedServicesInfo->fPrivateType );
   

   /* fRestrictionsApply */
   zraw_writeDbvBool("fRestrictionsApply", 
			psExtendedServicesInfo->fRestrictionsApply );
   

   /* fFeeApply */
   zraw_writeDbvBool("fFeeApply", psExtendedServicesInfo->fFeeApply);
   

   /* fAvailable */
   zraw_writeDbvBool("fAvailable", psExtendedServicesInfo->fAvailable);
   

   /* fRetentionSupported */
   zraw_writeDbvBool("fRetentionSupported",
			psExtendedServicesInfo->fRetentionSupported);
   

   /* ewaitAction */
   zraw_writeDbvExtendedServicesInfoInt( &psExtendedServicesInfo->eWaitAction );

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", 
			  psExtendedServicesInfo->ppsDescription );

   /* psSpecificExplain */
   print_external( psExtendedServicesInfo->psSpecificExplain);

   /* psEsASN */
   zraw_writeDbvInternationalString( "psEsASN", psExtendedServicesInfo->psEsASN );

   } /* End zraw_writeDbvExtendedServicesInfo() */

void zraw_writeDbvExtendedServicesInfoInt( 
	DbvExtendedServicesInfoInt *peExtendedServicesInfoInt)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvExtendedServicesInfoInt()\n" );
#endif

   /* Write the title out */ 
   if(peExtendedServicesInfoInt == NULL)
      {
      zraw_writetitle_char("NULL","DbvExtendedServicesInfoInt");
      
      return;
      } /* End if */

   /* eExtendedServicesInfoInt */
   convert_DbvExtendedServicesInfoInt( &pc_string, peExtendedServicesInfoInt );
   sprintf( temp, "eExtendedServicesInfoInt : %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   } /* End zraw_writeDbvExtendedServicesInfoInt() */
void zraw_writeDbvOmittedAttributeInterpretation( DbvOmittedAttributeInterpretation *psOmittedAttributeInterpretation )
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvOmittedAttributeInterpretation()\n" );
#endif

   /* Write the title out */ 
   if(psOmittedAttributeInterpretation == NULL)
      {
      zraw_writetitle_char("NULL","DbvOmittedAttributeInterpretation");
      
      return;
      } /* End if */

   zraw_writetitle_char("psOmittedAttributeInterpretation", "Structure");
   


   /* psDefaultValue */
   zraw_writeDbvStringOrNumeric( psOmittedAttributeInterpretation->psDefaultValue );
   /* ppsDefaultDescription */
   writeN_DbvHumanString( "ppsDefaultDescription", psOmittedAttributeInterpretation->ppsDefaultDescription );

   } /* End zraw_writeDbvOmittedAttributeInterpretation() */

void zraw_writeDbvSearchCost( char* name, DbvSearchCost *peSearchCost)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvSearchCost()\n" );
#endif

   /* Write the title out */ 
   if(peSearchCost == NULL)
      {
      zraw_writetitle_char("NULL","DbvSearchCost");
      
      return;
      } /* End if */

   /* eSearchCost */
   convert_DbvSearchCost( &pc_string, peSearchCost );
   sprintf( temp, "%s : %s", name, pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   } /* End zraw_writeDbvSearchCost() */

void zraw_writeDbvAttributeValues( DbvAttributeValues *psAttributeValues )
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvAttributeValues()\n" );
#endif

   /* Write the title out */ 
   if(psAttributeValues == NULL)
      {
      zraw_writetitle_char("NULL","DbvAttributeValues");
      
      return;
      } /* End if */

   zraw_writetitle_char("psAttributeValues", "Structure");
   


   /* sValue */
   zraw_writeDbvStringOrNumeric( &psAttributeValues->sValue);

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psAttributeValues->ppsDescription );

   /* ppsSubAttributes */
   writeN_DbvStringOrNumeric( psAttributeValues->ppsSubAttributes);

   /* ppsSuperAttributes */
   writeN_DbvStringOrNumeric( psAttributeValues->ppsSuperAttributes);

   /* pvPartialSupport */
   zraw_writeDbvNull( "pvPartialSupport",
		  psAttributeValues->pvPartialSupport);

   } /* End zraw_writeDbvAttributeValues() */

void zraw_writeDbvAttributesByType( DbvAttributesByType *psAttributesByType )
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvAttributesByType()\n" );
#endif

   /* Write the title out */ 
   if(psAttributesByType == NULL)
      {
      zraw_writetitle_char("NULL","DbvAttributesByType");
      
      return;
      } /* End if */

   zraw_writetitle_char("psAttributesByType", "Structure");
   


   /* ulAttributeType */
   zraw_writeinteger_string("ulAttributeType", 
			(int *)&psAttributesByType->ulAttributeType );
   

   /* psOptionalType */
   zraw_writeDbvOmittedAttributeInterpretation( psAttributesByType->psOptionalType );

   /* ppsAttributeValues */
   writeN_DbvAttributeValues( psAttributesByType->ppsAttributeValues);

   } /* End zraw_writeDbvAttributesByType() */

void zraw_writeDbvAttributesBySet( DbvAttributesBySet *psAttributesBySet )
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvAttributesBySet()\n" );
#endif

   /* Write the title out */ 
   if(psAttributesBySet == NULL)
      {
      zraw_writetitle_char("NULL","DbvAttributesBySet");
      
      return;
      } /* End if */

   zraw_writetitle_char("psAttributesBySet", "Structure");
   


   /* pcAttributeSet */
   zraw_writeDbvObjectIdentifier( "pcAttributeSet", 
			      psAttributesBySet->pcAttributeSet );
   /* ppsAttributesByType */
   writeN_DbvAttributesByType( psAttributesBySet->ppsAttributesByType );

   } /* End zraw_writeDbvAttributesBySet() */

void zraw_writeDbvAttributeCombinations( 
			DbvAttributeCombinations *psAttributeCombinations )
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvAttributeCombinations()\n" );
#endif

   /* Write the title out */ 
   if(psAttributeCombinations == NULL)
      {
      zraw_writetitle_char("NULL","DbvAttributeCombinations");
      
      return;
      } /* End if */

   zraw_writetitle_char("psAttributeCombinations", "Structure");
   


   /* pcDefaultAttributeSet */
   zraw_writeDbvObjectIdentifier( "pcDefaultAttributeSet", 
				psAttributeCombinations->pcDefaultAttributeSet );


   /* ppsLegalCombinations */
   writeN_DbvAttributeCombination( psAttributeCombinations->
				ppsLegalCombinations );

   } /* End zraw_writeDbvAttributeCombinations() */

void zraw_writeDbvAttributeDetails( DbvAttributeDetails *psAttributeDetails )
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvAttributeDetails()\n" );
#endif

   /* Write the title out */ 
   if(psAttributeDetails == NULL)
      {
      zraw_writetitle_char("NULL","DbvAttributeDetails");
      
      return;
      } /* End if */

   zraw_writetitle_char("psAttributeDetails", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psAttributeDetails->psCommonInfo);


   /* sDatabaseName */
   zraw_writeDbvInternationalString( "sDatabaseName", 
				  &psAttributeDetails->sDatabaseName );
   /* ppsAttributesBySet */

   writeN_DbvAttributesBySet( psAttributeDetails->ppsAttributesBySet );

   /* psAttributeCombinations */
   zraw_writeDbvAttributeCombinations( psAttributeDetails->psAttributeCombinations );

   } /* End zraw_writeDbvAttributeDetails() */

void zraw_writeDbvScanInfo( DbvScanInfo *psScanInfo)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvScanInfo()\n" );
#endif

   /* Write the title out */ 
   if(psScanInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvScanInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psScanInfo", "Structure");
   


   /* pulMaxStepSize */
   zraw_writeinteger_string("pulMaxStepSize", (int *)psScanInfo->pulMaxStepSize );
   

   /* ppsCollatingSequence */
   writeN_DbvHumanString( "ppsCollatingSequence",
			  psScanInfo->ppsCollatingSequence );
   /* pfIncreasing */
   if ( psScanInfo->pfIncreasing )
      zraw_writeDbvBool("pfIncreasing", *psScanInfo->pfIncreasing);
   else
      zraw_writetitle_char("NULL","pfIncreasing");
   

   } /* End zraw_writeDbvScanInfo() */

void zraw_writeDbvTermListDetails( DbvTermListDetails *psTermListDetails )
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvTermListDetails()\n" );
#endif

   /* Write the title out */ 
   if(psTermListDetails == NULL)
      {
      zraw_writetitle_char("NULL","DbvTermListDetails");
      
      return;
      } /* End if */

   zraw_writetitle_char("psTermListDetails", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psTermListDetails->psCommonInfo);

   /* sTermListName */
   zraw_writeDbvInternationalString( "sTermListName",
				  &psTermListDetails->sTermListName );
   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psTermListDetails->ppsDescription );

   /* psAttributes */
   zraw_writeDbvAttributeCombinations( psTermListDetails->psAttributes);

   /* psScanInfo */
   zraw_writeDbvScanInfo( psTermListDetails->psScanInfo);

   /* pulEstNumberTerms */
   zraw_writeinteger_string("pulEstNumberTerms", 
			(int *)psTermListDetails->pulEstNumberTerms );
   

   /* ppsSampleTerms */
   writeN_DbvTerm( psTermListDetails->ppsSampleTerms);

   } /* End zraw_writeDbvTermListDetails() */

void zraw_writeDbvRecordTag( DbvRecordTag *psRecordTag)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvRecordTag()\n" );
#endif

   /* Write the title out */ 
   if(psRecordTag == NULL)
      {
      zraw_writetitle_char("NULL","DbvRecordTag");
      
      return;
      } /* End if */

   zraw_writetitle_char("psRecordTag", "Structure");
   


   /* psQualifier */
   zraw_writeDbvStringOrNumeric( psRecordTag->psQualifier);

   /* sTagValue */
   zraw_writeDbvStringOrNumeric( &psRecordTag->sTagValue);

   } /* End zraw_writeDbvRecordTag() */

void zraw_writeDbvDetailsPerElement( DbvDetailsPerElement *psDetailsPerElement )
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvDetailsPerElement()\n" );
#endif

   /* Write the title out */ 
   if(psDetailsPerElement == NULL)
      {
      zraw_writetitle_char("NULL","DbvDetailsPerElement");
      
      return;
      } /* End if */

   zraw_writetitle_char("psDetailsPerElement", "Structure");
   


   /* psName */
   zraw_writeDbvInternationalString( "psName", psDetailsPerElement->psName );
   /* psRecordTag */
   zraw_writeDbvRecordTag( psDetailsPerElement->psRecordTag);

   /* ppsSchemaTags */
   writeN_DbvPathA( psDetailsPerElement->ppsSchemaTags);

   /* pulMaxSize */
   zraw_writeinteger_string("pulMaxSize", (int *)psDetailsPerElement->pulMaxSize );
   

   /* pulMinSize */
   zraw_writeinteger_string("pulMinSize", (int *)psDetailsPerElement->pulMinSize );
   

   /* pulAvgSize */
   zraw_writeinteger_string("pulAvgSize", (int *)psDetailsPerElement->pulAvgSize );
   

   /* pulFixedSize */
   zraw_writeinteger_string("pulFixedSize", 
			(int *)psDetailsPerElement->pulFixedSize );
   

   /* fRepeatable */
   zraw_writeDbvBool("fRepeatable", psDetailsPerElement->fRepeatable);
   

   /* fRequired */
   zraw_writeDbvBool("fRequired", psDetailsPerElement->fRequired);
   

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psDetailsPerElement->ppsDescription );
   /* ppsContents */
   writeN_DbvHumanString( "ppsContents", psDetailsPerElement->ppsContents );

   /* ppsBillingInfo */
   writeN_DbvHumanString( "ppsBillingInfo", psDetailsPerElement->ppsBillingInfo );
   /* ppsRestrictions */
   writeN_DbvHumanString( "ppsRestrictions",
			  psDetailsPerElement->ppsRestrictions );

   /* ppsAlternateNames */
   writeN_DbvInternationalString( "ppsAlternateNames",
			  psDetailsPerElement->ppsAlternateNames );
   /* ppsGenericNames */
   writeN_DbvInternationalString( "ppsGenericNames",
			  psDetailsPerElement->ppsGenericNames );
   /* psSearchAccess */
   zraw_writeDbvAttributeCombinations( psDetailsPerElement->psSearchAccess );

   } /* End zraw_writeDbvDetailsPerElement() */

void zraw_writeDbvElementSetDetails( DbvElementSetDetails *psElementSetDetails )
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvElementSetDetails()\n" );
#endif

   /* Write the title out */ 
   if(psElementSetDetails == NULL)
      {
      zraw_writetitle_char("NULL","DbvElementSetDetails");
      
      return;
      } /* End if */

   zraw_writetitle_char("psElementSetDetails", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psElementSetDetails->psCommonInfo);

   /* sDatabaseName */
   zraw_writeDbvInternationalString( "sDatabaseName", 
				  &psElementSetDetails->sDatabaseName );

   /* sElementSetName */
   zraw_writeDbvInternationalString( "sElementSetName", 
				  &psElementSetDetails->sElementSetName );

   /* pcRecordSyntax */
   zraw_writeDbvObjectIdentifier( "pcRecordSyntax", 
				psElementSetDetails->pcRecordSyntax );
   /* pcSchema */
   zraw_writeDbvObjectIdentifier( "pcSchema", psElementSetDetails->pcSchema );
   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psElementSetDetails->ppsDescription );
   /* ppsDetailsPerElement */

   writeN_DbvDetailsPerElement(psElementSetDetails->ppsDetailsPerElement);

   } /* End zraw_writeDbvElementSetDetails() */



void zraw_writeDbvRetrievalRecordDetails( 
			DbvRetrievalRecordDetails *psRetrievalRecordDetails )
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvRetrievalRecordDetails()\n" );
#endif

   /* Write the title out */ 
   if(psRetrievalRecordDetails == NULL)
      {
      zraw_writetitle_char("NULL","DbvRetrievalRecordDetails");
      
      return;
      } /* End if */

   zraw_writetitle_char("psRetrievalRecordDetails", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psRetrievalRecordDetails->psCommonInfo);

   /* sDatabaseName */
   zraw_writeDbvInternationalString( "sDatabaseName", 
				  &psRetrievalRecordDetails->sDatabaseName );

   /* pcSchema */
   zraw_writeDbvObjectIdentifier( "pcSchema",
			      psRetrievalRecordDetails->pcSchema );
   /* pcRecordSyntax */
   zraw_writeDbvObjectIdentifier( "pcRecordSyntax",
			      psRetrievalRecordDetails->pcRecordSyntax);

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", 
			  psRetrievalRecordDetails->ppsDescription );

   /* ppsDetailsPerElement */
   writeN_DbvDetailsPerElement( psRetrievalRecordDetails->ppsDetailsPerElement );

   } /* End zraw_writeDbvRetrievalRecordDetails() */

void zraw_writeDbvSortType( DbvSortType *psSortType)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvSortType()\n" );
#endif

   /* Write the title out */ 
   if(psSortType == NULL)
      {
      zraw_writetitle_char("NULL","DbvSortType");
      
      return;
      } /* End if */

   zraw_writetitle_char("psSortType", "Structure");
   


   /* eSortTypeType */
   convert_DbvSortTypeType( &pc_string, &psSortType->eSortTypeType);
   sprintf( temp, "eSortType: %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* uSortType */

   switch( psSortType->eSortTypeType )
      {
      case STT_Structured:
	 writeN_DbvHumanString( "ppsStructured", 
				psSortType->uSortType.ppsStructured );
	 break;

      default:
	 break;
      } /* End switch */

   } /* End zraw_writeDbvSortType() */

void zraw_writeDbvSortKeys( DbvSortKeys *psSortKeys)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvSortKeys()\n" );
#endif

   /* Write the title out */ 
   if(psSortKeys == NULL)
      {
      zraw_writetitle_char("NULL","DbvSortKeys");
      
      return;
      } /* End if */

   zraw_writetitle_char("psSortKeys", "Structure");
   


   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psSortKeys->ppsDescription );

   /* ppsElementSpecifications */
   writeN_DbvSpecification( psSortKeys->ppsElementSpecifications);

   /* psAttributeSpecifications */
   zraw_writeDbvAttributeCombinations( psSortKeys->psAttributeSpecifications );

   /* psSortType */
   zraw_writeDbvSortType( psSortKeys->psSortType);

   /* peCaseSensitivity */
   if ( psSortKeys->peCaseSensitivity )
      {
      convert_DbvCaseSensitivity( &pc_string, psSortKeys->peCaseSensitivity );
      sprintf( temp, "peCaseSensitivity: %s", pc_string );
      }
   else
      sprintf( temp, "peCaseSensitivity: NULL" );

   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   } /* End zraw_writeDbvSortKeys() */

void zraw_writeDbvSortDetails( DbvSortDetails *psSortDetails)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvSortDetails()\n" );
#endif

   /* Write the title out */ 
   if(psSortDetails == NULL)
      {
      zraw_writetitle_char("NULL","DbvSortDetails");
      
      return;
      } /* End if */

   zraw_writetitle_char("psSortDetails", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psSortDetails->psCommonInfo);

   /* sDatabaseName */
   zraw_writeDbvInternationalString( "sDatabaseName", &psSortDetails->sDatabaseName );
   /* ppsSortKeys */
   writeN_DbvSortKeys( psSortDetails->ppsSortKeys);

   } /* End zraw_writeDbvSortDetails() */

void zraw_writeDbvProcessingInformation( 
			DbvProcessingInformation *psProcessingInformation )
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvProcessingInformation()\n" );
#endif

   /* Write the title out */ 
   if(psProcessingInformation == NULL)
      {
      zraw_writetitle_char("NULL","DbvProcessingInformation");
      
      return;
      } /* End if */

   zraw_writetitle_char("psProcessingInformation", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psProcessingInformation->psCommonInfo);

   /* sDatabaseName */
   zraw_writeDbvInternationalString( "sDatabaseName", 
				 &psProcessingInformation->sDatabaseName );
   /* eProcessingContext */

   convert_DbvProcessingContext( &pc_string, 
				    &psProcessingInformation->eProcessingContext);
   sprintf( temp, "eDbvProcessingContext: %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );


   /* psName */
   zraw_writeDbvInternationalString( "psName", &psProcessingInformation->sName );
   /* pcOid */
   zraw_writeDbvObjectIdentifier( "pcOid", psProcessingInformation->pcOid );
   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", 
			  psProcessingInformation->ppsDescription );
   /* psInstructions */

   print_external( psProcessingInformation->psInstructions);

   } /* End zraw_writeDbvProcessingInformation() */

void zraw_writeDbvValueDescription( DbvValueDescription *psValueDescription )
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvValueDescription()\n" );
#endif

   /* Write the title out */ 
   if(psValueDescription == NULL)
      {
      zraw_writetitle_char("NULL","DbvValueDescription");
      
      return;
      } /* End if */

   zraw_writetitle_char("psValueDescription", "Structure");
   


   /* eValueDescriptionType */
   convert_DbvValueDescriptionType( &pc_string, 
				    &psValueDescription->eValueDescriptionType);
   sprintf( temp, "eValueDescription: %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* uValueDescription */

   switch( psValueDescription->eValueDescriptionType )
      {
      case VDT_Integer:
	 zraw_writeinteger_string( "ulInteger", (int*)&psValueDescription->
				uValueDescription.ulInteger);
         
	 break;

      case VDT_String:
	 zraw_writeDbvInternationalString( "psString", psValueDescription->
				uValueDescription.psString);
	 break;

      case VDT_Octets:
	 zraw_writeDbvOctetString( "psOctets", psValueDescription->
				uValueDescription.psOctets);
	 break;

      case VDT_Oid:
	 zraw_writeDbvObjectIdentifier( "pcOid", psValueDescription->
				uValueDescription.pcOid);
	 break;

      case VDT_Unit:
	 zraw_writeDbvUnit( psValueDescription->uValueDescription.psUnit );
	 break;

      case VDT_ValueAndUnit:
	 zraw_writeDbvIntUnit( psValueDescription->uValueDescription.psValueAndUnit );
	 break;

      default:
	 break;
      } /* End switch */

   } /* End zraw_writeDbvValueDescription() */

void zraw_writeDbvValueRange( DbvValueRange *psValueRange)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvValueRange()\n" );
#endif

   /* Write the title out */ 
   if(psValueRange == NULL)
      {
      zraw_writetitle_char("NULL","DbvValueRange");
      
      return;
      } /* End if */

   zraw_writetitle_char("psValueRange", "Structure");
   


   /* psLower */
   zraw_writeDbvValueDescription( psValueRange->psLower);

   /* psUpper */
   zraw_writeDbvValueDescription( psValueRange->psUpper);

   } /* End zraw_writeDbvValueRange() */




void zraw_writeDbvValueSet( DbvValueSet *psValues)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

#ifdef DEBUG
   printf( "D - zraw_writeDbvValueSet()\n" );
#endif

   /* Write the title out */ 
   if(psValues == NULL)
      {
      zraw_writetitle_char("NULL","DbvValueSet");
      
      return;
      } /* End if */

   zraw_writetitle_char("psValues", "Structure");
   


   /* eValuesType */
   convert_DbvValueSetType( &pc_string, &psValues->eValueSetType );
   sprintf( temp, "eValuesTypes: %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* uValues */

   switch( psValues->eValueSetType )
      {
      case VT_Range:
	 zraw_writeDbvValueRange( psValues->uValueSet.psRange);
	 break;

      case VT_Enumerated:
	writeN_DbvValueDescription(psValues->uValueSet.ppsEnumerated);

	 break;

      default:
	 break;
      } /* End switch */

   } /* End zraw_writeDbvValueSet() */



void writeN_DbvValueDescription(DbvValueDescription **ppsEnumerated)
{
   if( ppsEnumerated != NULL)
      {
      while( ppsEnumerated && *ppsEnumerated )
         {
         zraw_writeDbvValueDescription( *ppsEnumerated);
         ppsEnumerated++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "ValueDescription");
      
      } /* End else */


   } /* End writeN_DbvDetailsPerElement() */




void zraw_writeDbvVariantValue( DbvVariantValue *psVariantValue)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvVariantValue()\n" );
#endif

   /* Write the title out */ 
   if(psVariantValue == NULL)
      {
      zraw_writetitle_char("NULL","DbvVariantValue");
      
      return;
      } /* End if */

   zraw_writetitle_char("psVariantValue", "Structure");
   


   /* eDataType */
   zraw_writeDbvPrimitiveDataType( "eDataType", 
				&psVariantValue->eDataType);
   /* psValues */

   zraw_writeDbvValueSet( psVariantValue->psValues);

   } /* End zraw_writeDbvVariantValue() */

void zraw_writeDbvVariantTypes( DbvVariantTypes *psVariantTypes)
   {

#ifdef DEBUG
   printf( "D - zraw_writeDbvVariantTypes()\n" );
#endif

   /* Write the title out */ 
   if(psVariantTypes == NULL)
      {
      zraw_writetitle_char("NULL","DbvVariantTypes");
      
      return;
      } /* End if */

   zraw_writetitle_char("psVariantTypes", "Structure");
   


   /* psName */
   zraw_writeDbvInternationalString( "psName", psVariantTypes->psName );
   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psVariantTypes->ppsDescription );

   /* ulVariantType */
   zraw_writeinteger_string("ulVariantType", (int *)&psVariantTypes->ulVariantType );
   
   /* psVariantValue */
   zraw_writeDbvVariantValue( psVariantTypes->psVariantValue);

   } /* End zraw_writeDbvVariantTypes() */

void zraw_writeDbvVariantClass( DbvVariantClass *psVariants)
   {

   /* Write the title out */ 
   if(psVariants == NULL)
      {
      zraw_writetitle_char("NULL","DbvVariants");
      
      return;
      } /* End if */

   zraw_writetitle_char("psVariants", "Structure");
   


   /* psName */
   zraw_writeDbvInternationalString( "psName", psVariants->psName);

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psVariants->ppsDescription );

   /* ulVariantClass */
   zraw_writeinteger_string("ulVariantClass", (int *)&psVariants->ulVariantClass );
   

   /* ppsVariantTypes */
   writeN_DbvVariantTypes( psVariants->ppsVariantTypes);

   } /* End zraw_writeDbvVariants() */

void zraw_writeDbvVariantSetInfo( DbvVariantSetInfo *psVariantSetInfo)
   {

   /* Write the title out */ 
   if(psVariantSetInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvVariantSetInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psVariantSetInfo", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psVariantSetInfo->psCommonInfo);

   /* pcVariantSet */
   zraw_writeDbvObjectIdentifier( "pcVariantSet", psVariantSetInfo->pcVariantSet );

   /* sName */
   zraw_writeDbvInternationalString( "sName", &psVariantSetInfo->sName);

   /* ppsVariants */
   writeN_DbvVariantClass( psVariantSetInfo->ppsVariants);

   } /* End zraw_writeDbvVariantSetInfo() */

void zraw_writeDbvUnits( DbvUnits *psUnits)
   {

   /* Write the title out */ 
   if(psUnits == NULL)
      {
      zraw_writetitle_char("NULL","DbvUnits");
      
      return;
      } /* End if */

   zraw_writetitle_char("psUnits", "Structure");
   


   /* psName */
   zraw_writeDbvInternationalString( "psName", psUnits->psName);

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psUnits->ppsDescription);

   /* sUnitType */
   zraw_writeDbvStringOrNumeric( &psUnits->sUnit);

   } /* End zraw_writeDbvUnits() */

void zraw_writeDbvUnitInfo( DbvUnitInfo *psUnitInfo)
   {

   /* Write the title out */ 
   if(psUnitInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvUnitInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psUnitInfo", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psUnitInfo->psCommonInfo);

   /* sUnitSystem */
   zraw_writeDbvInternationalString( "sUnitSystem", &psUnitInfo->sUnitSystem );
   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psUnitInfo->ppsDescription );

   } /* End zraw_writeDbvUnitInfo() */

void zraw_writeDbvCategoryInfo( DbvCategoryInfo *psCategoryInfo)
   {

   /* Write the title out */ 
   if(psCategoryInfo == NULL)
      {
      zraw_writetitle_char("NULL","DbvCategoryInfo");
      
      return;
      } /* End if */

   zraw_writetitle_char("psCategoryInfo", "Structure");
   


   /* sCategory */
   zraw_writeDbvInternationalString( "sCategory", &psCategoryInfo->sCategory );

   /* psOriginalCategory */
   zraw_writeDbvInternationalString( "psOriginalCategory", 
				  psCategoryInfo->psOriginalCategory );

   /* ppsDescription */
   writeN_DbvHumanString( "ppsDescription", psCategoryInfo->ppsDescription );
			
   /* psAsn1Module */
   zraw_writeDbvInternationalString( "psAsn1Module", psCategoryInfo->psAsn1Module );
   } /* End zraw_writeDbvCategoryInfo() */

void zraw_writeDbvCategoryList( DbvCategoryList *psCategoryList)
   {

   /* Write the title out */ 
   if(psCategoryList == NULL)
      {
      zraw_writetitle_char("NULL","DbvCategoryList");
      
      return;
      } /* End if */

   zraw_writetitle_char("psCategoryList", "Structure");
   


   /* psCommonInfo */
   zraw_writeDbvCommonInfo( "psCommonInfo", psCategoryList->psCommonInfo);

   /* ppsCategories */
   writeN_DbvCategoryInfo( psCategoryList->ppsCategories);

   } /* End zraw_writeDbvCategoryList() */

void zraw_writeDbvExplainRecord( DbvExplainRecord *psExplainRecord)
   {
   char temp[ STRING_LEN  ];
   char *pc_string = NULL;

   /* Write the title out */ 
   if(psExplainRecord == NULL)
      {
      zraw_writetitle_char("NULL","DbvExplainRecord");
      
      return;
      } /* End if */

   zraw_writetitle_char("psExplainRecord", "Structure");
   


   /* eExplainRecordType */
   convert_DbvExplainRecordType( &pc_string, 
				&psExplainRecord->eExplainRecordType);
   sprintf( temp, "eExplainRecord: %s", pc_string );
   zraw_writechar_field(temp);
   
   DbvFree( pc_string );

   /* uExplainRecord */

   switch( psExplainRecord->eExplainRecordType )
      {
      case ERT_TargetInfo:
	 zraw_writeDbvTargetInfo( psExplainRecord->
				uExplainRecord.psTargetInfo);
	 break;

      case ERT_DatabaseInfo:
	 zraw_writeDbvDatabaseInfo( psExplainRecord->
				uExplainRecord.psDatabaseInfo);
	 break;

      case ERT_SchemaInfo:
	 zraw_writeDbvSchemaInfo( psExplainRecord->
				uExplainRecord.psSchemaInfo);
	 break;

      case ERT_TagSetInfo:
	 zraw_writeDbvTagSetInfo( psExplainRecord->
				uExplainRecord.psTagSetInfo);
	 break;

      case ERT_RecordSyntaxInfo:
	 zraw_writeDbvRecordSyntaxInfo( psExplainRecord->
				uExplainRecord.psRecordSyntaxInfo);
	 break;

      case ERT_AttributeSetInfo:
	 zraw_writeDbvAttributeSetInfo( psExplainRecord->
				uExplainRecord.psAttributeSetInfo);
	 break;

      case ERT_TermListInfo:
	 zraw_writeDbvTermListInfo( psExplainRecord->
				uExplainRecord.psTermListInfo);
	 break;

      case ERT_ExtendedServicesInfo:
	 zraw_writeDbvExtendedServicesInfo( psExplainRecord->
				uExplainRecord.psExtendedServicesInfo );
	 break;

      case ERT_AttributeDetails:
	 zraw_writeDbvAttributeDetails( psExplainRecord->
				uExplainRecord.psAttributeDetails);
	 break;

      case ERT_TermListDetails:
	 zraw_writeDbvTermListDetails( psExplainRecord->
				uExplainRecord.psTermListDetails);
	 break;

      case ERT_ElementSetDetails:
	 zraw_writeDbvElementSetDetails( psExplainRecord->
				uExplainRecord.psElementSetDetails);
	 break;

      case ERT_RetrievalRecordDetails:
	 zraw_writeDbvRetrievalRecordDetails( psExplainRecord->
				uExplainRecord.psRetrievalRecordDetails );
	 break;

      case ERT_SortDetails:
	 zraw_writeDbvSortDetails( psExplainRecord->
				uExplainRecord.psSortDetails);
	 break;

      case ERT_Processing:
	 zraw_writeDbvProcessingInformation( psExplainRecord->
				uExplainRecord.psProcessing);
	 break;

      case ERT_Variants:
	 zraw_writeDbvVariantSetInfo( psExplainRecord->
				uExplainRecord.psVariants);
	 break;

      case ERT_Units:
	 zraw_writeDbvUnitInfo( psExplainRecord->
				uExplainRecord.psUnits);
	 break;

      case ERT_CategoryList:
	 zraw_writeDbvCategoryList( psExplainRecord->
				uExplainRecord.psCategoryList);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End zraw_writeDbvExplainRecord() */

void zraw_writeDbvLanguageCode( char *name,DbvLanguageCode *psLanguageCode )
   {

   zraw_writeDbvOctetString( name, (DbvOctetString *)psLanguageCode);

   } /* End zraw_writeDbvLanguageCode() */

void zraw_writeDbvNull( char *name, DbvNull *pvNull)
   {
#ifdef DEBUG
   printf( "D - zraw_writeDbvNull()\n" );
#endif
                                
   if(pvNull == NULL)
      zraw_writetitle_char("NULL","DbvNull");
   else 
      zraw_writetitle_char("Value Defined","DbvNull");

   
   return;
   } /* End zraw_writeDbvNull() */




/* Top down style as opposed to bottom up... */
void zraw_writeDbvAttributeCombination(DbvAttributeCombination *psLegalCombinations)
{
	/* Write the title out */ 
	if (psLegalCombinations == NULL) {
		zraw_writetitle_char("NULL","DbvAttributeCombination");
		
		return;
	} /* End if */

	zraw_writetitle_char("psLegalCombinations", "Structure");
	

	
	writeN_DbvDbvAttributeOccurrence(psLegalCombinations->ppsAttributeOccurrence);
	

}



void writeN_DbvDbvAttributeOccurrence(DbvAttributeOccurrence **ppsAttributeOccurrence)
{
   if( ppsAttributeOccurrence != NULL)
      {
      while( ppsAttributeOccurrence && *ppsAttributeOccurrence )
         {
         zraw_writeDbvDbvAttributeOccurrence( *ppsAttributeOccurrence);
         ppsAttributeOccurrence++;
         } 
      } 
   else
      {
      zraw_writetitle_char("NULL", "DbvAttributeOccurrence");
      
      } 

   } 



void zraw_writeDbvDbvAttributeOccurrence( DbvAttributeOccurrence *psAttributeOccurrence)
{

	/* Write the title out */ 
	if(psAttributeOccurrence == NULL) {
		zraw_writetitle_char("NULL","DbvAttributeOccurrence");
		
		return;
	} /* End if */

	zraw_writetitle_char("psAttributeOccurrence", "Structure");
	

	zraw_writeDbvObjectIdentifier( "pcAttributeSet", psAttributeOccurrence->pcAttributeSet);

         zraw_writeinteger_string( "ulAttributeType", (int*)&psAttributeOccurrence->ulAttributeType);

	zraw_writeDbvNull( "pvMustBeSupplied",
		  psAttributeOccurrence->pvMustBeSupplied);

	zraw_writeDbvAttributeOccurrenceChoice(&psAttributeOccurrence->sAttributeValues);
	
}



void zraw_writeDbvAttributeOccurrenceChoice(DbvAttributeOccurrenceChoice *psAttributeValues)
{

	/* Write the title out */ 
	if (psAttributeValues == NULL) {
		zraw_writetitle_char("NULL","DbvAttributeOccurrenceChoice");
		
		return;
	} /* End if */
	
	zraw_writetitle_char("psAttributeValues", "Structure");
	

	switch (psAttributeValues->eAttributeOccurrenceChoiceType) {
	case AOT_AnyOrNone:
		zraw_writeDbvNull( "pvAnyOrNone",
		  psAttributeValues->uAttributeOccurrenceChoiceType.pvAnyOrNone);
		break;
	case AOT_Specific:
   		writeN_DbvStringOrNumeric( psAttributeValues->uAttributeOccurrenceChoiceType.ppsSpecific);
		break;
	}

}



void zraw_writeDbvDatabaseList( char *name, DbvDatabaseList *psDbCombinations)
   {

   writeN_DbvInternationalString( name, psDbCombinations->ppsInnerDatabases);

   } /* End zraw_writeDbvDatabaseList() */


void zraw_writeDbvHumanStringSeq( DbvHumanStringSeq *psHumanStringSeq)
   {
#ifdef DEBUG
   printf( "D - zraw_writeDbvHumanStringSeq()\n" );
#endif

   /* Write the title out */ 
   if(psHumanStringSeq == NULL)
      {
      zraw_writetitle_char("NULL","DbvHumanStringSeq");
      
      return;
      } /* End if */

   zraw_writetitle_char("psHumanStringSeq", "Structure");
   

   writeN_DbvHumanString("ppsHumanString", psHumanStringSeq->ppsHumanString);

   } /* End zraw_writeDbvHumanStringSeq() */


/********************************************************************/
/* From writeN_DbvFuncs.c */



void writeN_DbvIntUnit(DbvIntUnit **ppsIntUnit)
   {

   if( ppsIntUnit != NULL)
      {
      while( ppsIntUnit && *ppsIntUnit )
         {
         zraw_writeDbvIntUnit( *ppsIntUnit);
         ppsIntUnit++;
         } 
      } 
   else
      {
      zraw_writetitle_char("NULL", "IntUnit");
      
      } 

     
   } 


void writeN_DbvOtherInformation(DbvOtherInformation **ppsOtherInformation )
   {
 
   if( ppsOtherInformation != NULL)
      {
      while( ppsOtherInformation && *ppsOtherInformation )
         {
         print_otherinfo( *ppsOtherInformation);
         ppsOtherInformation++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "OtherInformation");
      }
      
 
 
   } /* End writeN_DbvOtherInformation() */



/* Functions beyond this point were added by Dan Maskell on 8-2-96 */



void writeN_DbvASN1External(DbvASN1External **ppsASN1External)
   {

   if( ppsASN1External != NULL)
      {
      while( ppsASN1External && *ppsASN1External )
         {
         print_external( *ppsASN1External);
         ppsASN1External++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "ASN1External");
      
      } /* End else */

     
   } /* End writeN_DbvASN1External() */

/* Explain Record Support */

void writeN_DbvHumanString( char *name, 
			    DbvHumanString **ppsHumanString )
   {

   if( ppsHumanString != NULL)
      {
      zraw_writechar_field( name);
      

      while( ppsHumanString && *ppsHumanString )
         {
         zraw_writeDbvHumanString( *ppsHumanString);
         ppsHumanString++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvHumanString");
      
      } /* End else */

     
   } /* End writeN_DbvHumanString() */

void writeN_DbvIconObject( DbvIconObject **ppsIconObject)
   {

   if( ppsIconObject != NULL)
      {
      while( ppsIconObject && *ppsIconObject )
         {
         zraw_writeDbvIconObject( *ppsIconObject);
         ppsIconObject++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvIconObject");
      
      } /* End else */

     
   } /* End writeN_DbvIconObject() */

void writeN_DbvOperators(DbvOperators **ppsOperators)
   {

   if( ppsOperators != NULL)
      {
      while( ppsOperators && *ppsOperators )
         {
         zraw_writeDbvOperators( *ppsOperators);
         ppsOperators++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvOperators");
      
      } /* End else */

     
   } /* End writeN_DbvOperators() */

void writeN_DbvSearchKey(DbvSearchKey **ppsSearchKey)
   {

   if( ppsSearchKey != NULL)
      {
      while( ppsSearchKey && *ppsSearchKey )
         {
         zraw_writeDbvSearchKey( *ppsSearchKey);
         ppsSearchKey++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvSearchKey");
      
      } /* End else */

     
   } /* End writeN_DbvSearchKey() */

void writeN_DbvUnitsSupported(DbvUnitsSupported **ppsUnitsSupported )
   {

   if( ppsUnitsSupported != NULL)
      {
      while( ppsUnitsSupported && *ppsUnitsSupported )
         {
         zraw_writeDbvUnitsSupported( *ppsUnitsSupported);
         ppsUnitsSupported++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvUnitsSupported");
      
      } /* End else */

     
   } /* End writeN_DbvUnitsSupported() */

void writeN_Ulong( char *name, Ulong **ppsUlong)
   {

   if( ppsUlong != NULL)
      {
      zraw_writechar_field( name);
      

      while( ppsUlong && *ppsUlong )
         {
         zraw_writeinteger_string( "Integer", (int*)*ppsUlong);
	 
         ppsUlong++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "integer");
      
      } /* End else */

     
   } /* End writeN_Ulong() */

void writeN_DbvQueryTypeDetails(DbvQueryTypeDetails **ppsQueryTypeDetails )
   {

   if( ppsQueryTypeDetails != NULL)
      {
      while( ppsQueryTypeDetails && *ppsQueryTypeDetails )
         {
         zraw_writeDbvQueryTypeDetails( *ppsQueryTypeDetails);
         ppsQueryTypeDetails++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvQueryTypeDetails");
      
      } /* End else */

     
   } /* End writeN_DbvQueryTypeDetails() */

void writeN_DbvObjectIdentifier( char *name, DbvObjectIdentifier *ppcObjectIdentifier )
   {

   if( ppcObjectIdentifier != NULL)
      {
      while( ppcObjectIdentifier && *ppcObjectIdentifier )
         {
         zraw_writeDbvObjectIdentifier( name, *ppcObjectIdentifier);
         ppcObjectIdentifier++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvObjectIdentifier");
      
      } /* End else */

     
   } /* End writeN_DbvObjectIdentifier() */

void writeN_DbvOtherCharge(DbvOtherCharge **ppsOtherCharge)
   {

   if( ppsOtherCharge != NULL)
      {
      while( ppsOtherCharge && *ppsOtherCharge )
         {
         zraw_writeDbvOtherCharge( *ppsOtherCharge);
         ppsOtherCharge++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvOtherCharge");
      
      } /* End else */

     
   } /* End writeN_DbvOtherCharge() */


void writeN_DbvAccessInfo( DbvAccessInfo **ppsAccessInfo)
   {

   if( ppsAccessInfo != NULL)
      {
      while( ppsAccessInfo && *ppsAccessInfo )
         {
         zraw_writeDbvAccessInfo( *ppsAccessInfo);
         ppsAccessInfo++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvAccessInfo");
      
      } /* End else */

     
   } /* End writeN_DbvAccessInfo() */

void writeN_DbvTagTypeMapping(DbvTagTypeMapping **ppsTagTypeMapping )
   {

   if( ppsTagTypeMapping != NULL)
      {
      while( ppsTagTypeMapping && *ppsTagTypeMapping )
         {
         zraw_writeDbvTagTypeMapping( *ppsTagTypeMapping);
         ppsTagTypeMapping++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvTagTypeMapping");
      
      } /* End else */

     
   } /* End writeN_DbvTagTypeMapping() */


void writeN_DbvPathA(DbvPathA **ppsPath)
   {

   if( ppsPath != NULL)
      {
      while( ppsPath && *ppsPath )
         {
         writeN_DbvPath( (*ppsPath)->ppsSchemaTags);
         ppsPath++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvPathA");
      
      } /* End else */

     
   } /* End writeN_DbvPathA() */


void writeN_DbvPath(DbvPath **ppsPath)
   {

   if( ppsPath != NULL)
      {
      while( ppsPath && *ppsPath )
         {
         zraw_writeDbvPath( *ppsPath);
         ppsPath++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvPath");
      
      } /* End else */

     
   } /* End writeN_DbvPath() */

void writeN_DbvElementInfo(DbvElementInfo **ppsElementInfo)
   {

   if( ppsElementInfo != NULL)
      {
      while( ppsElementInfo && *ppsElementInfo )
         {
         zraw_writeDbvElementInfo( *ppsElementInfo);
         ppsElementInfo++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvElementInfo");
      
      } /* End else */

     
   } /* End writeN_DbvElementInfo() */

void writeN_DbvElements(DbvElements **ppsElements)
   {

   if( ppsElements != NULL)
      {
      while( ppsElements && *ppsElements )
         {
         zraw_writeDbvElements( *ppsElements);
         ppsElements++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvElements");
      
      } /* End else */

     
   } /* End writeN_DbvElements() */

void writeN_DbvAttributeDescription(
		DbvAttributeDescription **ppsAttributeDescription )
   {

   if( ppsAttributeDescription != NULL)
      {
      while( ppsAttributeDescription && *ppsAttributeDescription )
         {
         zraw_writeDbvAttributeDescription( *ppsAttributeDescription);
         ppsAttributeDescription++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvAttributeDescription");
      
      } /* End else */

     
   } /* End writeN_DbvAttributeDescription() */

void writeN_DbvAttributeType( DbvAttributeType **ppsAttributeType )
   {

   if( ppsAttributeType != NULL)
      {
      while( ppsAttributeType && *ppsAttributeType )
         {
         zraw_writeDbvAttributeType( *ppsAttributeType);
         ppsAttributeType++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvAttributeType");
      
      } /* End else */

     
   } /* End writeN_DbvAttributeType() */

void writeN_DbvTermList(DbvTermList **ppsTermList)
   {

   if( ppsTermList != NULL)
      {
      while( ppsTermList && *ppsTermList )
         {
         zraw_writeDbvTermList( *ppsTermList);
         ppsTermList++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvTermList");
      
      } /* End else */

     
   } /* End writeN_DbvTermList() */

void writeN_DbvAttributeValues(DbvAttributeValues **ppsAttributeValues )
   {

   if( ppsAttributeValues != NULL)
      {
      while( ppsAttributeValues && *ppsAttributeValues )
         {
         zraw_writeDbvAttributeValues( *ppsAttributeValues);
         ppsAttributeValues++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvAttributeValues");
      
      } /* End else */

     
   } /* End writeN_DbvAttributeValues() */

void writeN_DbvAttributesByType(DbvAttributesByType **ppsAttributesByType )
   {

   if( ppsAttributesByType != NULL)
      {
      while( ppsAttributesByType && *ppsAttributesByType )
         {
         zraw_writeDbvAttributesByType( *ppsAttributesByType);
         ppsAttributesByType++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvAttributesByType");
      
      } /* End else */

     
   } /* End writeN_DbvAttributesByType() */

void writeN_DbvAttributesBySet( DbvAttributesBySet **ppsAttributesBySet )
   {

   if( ppsAttributesBySet != NULL)
      {
      while( ppsAttributesBySet && *ppsAttributesBySet )
         {
         zraw_writeDbvAttributesBySet( *ppsAttributesBySet);
         ppsAttributesBySet++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvAttributesBySet");
      
      } /* End else */

     
   } /* End writeN_DbvAttributesBySet() */

void writeN_DbvAttributeCombination( DbvAttributeCombination **ppsLegalCombinations)
   {

   if( ppsLegalCombinations != NULL)
      {
      while( ppsLegalCombinations && *ppsLegalCombinations )
         {
         zraw_writeDbvAttributeCombination( *ppsLegalCombinations);
         ppsLegalCombinations++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvAttributeCombination");
      
      } /* End else */

     
   } /* End writeN_DbvAttributeCombination() */

void writeN_DbvTerm( DbvTerm **ppsTerm)
   {

   if( ppsTerm != NULL)
      {
      while( ppsTerm && *ppsTerm )
         {
         zraw_writeDbvTerm( *ppsTerm);
         ppsTerm++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvTerm");
      
      } /* End else */

     
   } /* End writeN_DbvTerm() */

void writeN_DbvDetailsPerElement( 
		DbvDetailsPerElement **ppsDetailsPerElement )
   {

   if( ppsDetailsPerElement != NULL)
      {
      while( ppsDetailsPerElement && *ppsDetailsPerElement )
         {
         zraw_writeDbvDetailsPerElement( *ppsDetailsPerElement);
         ppsDetailsPerElement++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvDetailsPerElement");
      
      } /* End else */

     
   } /* End writeN_DbvDetailsPerElement() */

void writeN_DbvSortKeys( DbvSortKeys **ppsSortKeys)
   {

   if( ppsSortKeys != NULL)
      {
      while( ppsSortKeys && *ppsSortKeys )
         {
         zraw_writeDbvSortKeys( *ppsSortKeys);
         ppsSortKeys++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvSortKeys");
      
      } /* End else */

     
   } /* End writeN_DbvSortKeys() */

void writeN_DbvVariantTypes( DbvVariantTypes **ppsVariantTypes)
   {

   if( ppsVariantTypes != NULL)
      {
      while( ppsVariantTypes && *ppsVariantTypes )
         {
         zraw_writeDbvVariantTypes( *ppsVariantTypes);
         ppsVariantTypes++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvVariantTypes");
      
      } /* End else */

     
   } /* End writeN_DbvVariantTypes() */

void writeN_DbvVariantClass( DbvVariantClass **ppsVariants)
   {

   if( ppsVariants != NULL)
      {
      while( ppsVariants && *ppsVariants )
         {
         zraw_writeDbvVariantClass( *ppsVariants);
         ppsVariants++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvVariantClass");
      
      } /* End else */

     
   } /* End writeN_DbvVariants() */

void writeN_DbvUnits( DbvUnits **ppsUnits)
   {

   if( ppsUnits != NULL)
      {
      while( ppsUnits && *ppsUnits )
         {
         zraw_writeDbvUnits( *ppsUnits);
         ppsUnits++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvUnits");
      
      } /* End else */

     
   } /* End writeN_DbvUnits() */

void writeN_DbvUnit( DbvUnit **ppsUnit)
   {

   if( ppsUnit != NULL)
      {
      while( ppsUnit && *ppsUnit )
         {
         zraw_writeDbvUnit( *ppsUnit);
         ppsUnit++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvUnit");
      
      } /* End else */

     
   } /* End writeN_DbvUnit() */

void writeN_DbvCategoryInfo( DbvCategoryInfo **ppsCategories)
   {

   if( ppsCategories != NULL)
      {
      while( ppsCategories && *ppsCategories )
         {
         zraw_writeDbvCategoryInfo( *ppsCategories);
         ppsCategories++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvCategoryInfo");
      
      } /* End else */

     
   } /* End writeN_DbvCategoryInfo() */

void writeN_DbvStringOrNumeric( DbvStringOrNumeric **ppsStringOrNumeric)
   {

   if( ppsStringOrNumeric != NULL)
      {
      while( ppsStringOrNumeric && *ppsStringOrNumeric )
         {
         zraw_writeDbvStringOrNumeric( *ppsStringOrNumeric);
         ppsStringOrNumeric++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvStringOrNumeric");
      
      } /* End else */

     
   } /* End writeN_DbvStringOrNumeric() */

void writeN_DbvSpecification( DbvSpecification **ppsSpecification)
   {

   if( ppsSpecification != NULL)
      {
      while( ppsSpecification && *ppsSpecification )
         {
         zraw_writeDbvSpecification( *ppsSpecification);
         ppsSpecification++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvSpecification");
      
      } /* End else */

     
   } /* End writeN_DbvSpecification() */

void writeN_DbvAccessRestrictions(
		DbvAccessRestrictions **ppsAccessRestrictions)
   {

   if( ppsAccessRestrictions != NULL)
      {
      while( ppsAccessRestrictions && *ppsAccessRestrictions )
         {
         zraw_writeDbvAccessRestrictions( *ppsAccessRestrictions);
         ppsAccessRestrictions++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvAccessRestrictions");
      
      } /* End else */

     
   } /* End writeN_DbvAccessRestrictions() */

void writeN_DbvNetworkAddress(DbvNetworkAddress **ppsNetworkAddress )
   {

   if( ppsNetworkAddress != NULL)
      {
      while( ppsNetworkAddress && *ppsNetworkAddress )
         {
         zraw_writeDbvNetworkAddress( *ppsNetworkAddress);
         ppsNetworkAddress++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvNetworkAddress");
      
      } /* End else */

     
   } /* End writeN_DbvNetworkAddress() */

void writeN_DbvInternationalString( char *name, DbvInternationalString 
				**ppsInternationalString)
   {

   if( ppsInternationalString != NULL)
      {
      while( ppsInternationalString && *ppsInternationalString )
         {
         zraw_writeDbvInternationalString( name,*ppsInternationalString);
         ppsInternationalString++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvInternationalString");
      
      } /* End else */

     
   } /* End writeN_DbvInternationalString() */



void writeN_DbvDatabaseList( char *name, DbvDatabaseList **ppsDbCombinations)
   {

   if( ppsDbCombinations != NULL)
      {
      while( ppsDbCombinations && *ppsDbCombinations )
         {
         zraw_writeDbvDatabaseList( name,*ppsDbCombinations);
         ppsDbCombinations++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvDatabaseList");
      
      } /* End else */

     
   } /* End writeN_DbvInternationalString() */




void writeN_DbvDataBaseInfoSeq( char *name, DbvDataBaseInfoSeq **ppsKeywords)
   {

   if( ppsKeywords != NULL)
      {
      while( ppsKeywords && *ppsKeywords )
         {
         zraw_writeDbvDataBaseInfoSeq( name,*ppsKeywords);
         ppsKeywords++;
         } /* End while */
      } /* End if */
   else
      {
      zraw_writetitle_char("NULL", "DbvDataBaseInfoSeq");
      
      } /* End else */

     
   } /* End writeN_DbvInternationalString() */



void zraw_writeDbvDataBaseInfoSeq(char *name, DbvDataBaseInfoSeq *psKeywords)
{
	writeN_DbvHumanString(name, psKeywords->ppsDataBaseInfo);
}


/********************************************************************/
/* From convert_DbvFuncs2.c */


void convert_DbvExplainRecordType(char **text, 
			DbvExplainRecordType *peExplainRecordType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("ERT_TargetInfo", *text) == 0)
         *peExplainRecordType = ERT_TargetInfo;
      else
      if(strcmp("ERT_DatabaseInfo", *text) == 0)
         *peExplainRecordType = ERT_DatabaseInfo;
      else
      if(strcmp("ERT_SchemaInfo", *text) == 0)
         *peExplainRecordType = ERT_SchemaInfo;
      else
      if(strcmp("ERT_TagSetInfo", *text) == 0)
         *peExplainRecordType = ERT_TagSetInfo;
      else
      if(strcmp("ERT_RecordSyntaxInfo", *text) == 0)
         *peExplainRecordType = ERT_RecordSyntaxInfo;
      else
      if(strcmp("ERT_AttributeSetInfo", *text) == 0)
         *peExplainRecordType = ERT_AttributeSetInfo;
      else
      if(strcmp("ERT_TermListInfo", *text) == 0)
         *peExplainRecordType = ERT_TermListInfo;
      else
      if(strcmp("ERT_ExtendedServicesInfo", *text) == 0)
         *peExplainRecordType = ERT_ExtendedServicesInfo;
      else
      if(strcmp("ERT_AttributeDetails", *text) == 0)
         *peExplainRecordType = ERT_AttributeDetails;
      else
      if(strcmp("ERT_TermListDetails", *text) == 0)
         *peExplainRecordType = ERT_TermListDetails;
      else
      if(strcmp("ERT_ElementSetDetails", *text) == 0)
         *peExplainRecordType = ERT_ElementSetDetails;
      else
      if(strcmp("ERT_RetrievalRecordDetails", *text) == 0)
         *peExplainRecordType = ERT_RetrievalRecordDetails;
      else
      if(strcmp("ERT_SortDetails", *text) == 0)
         *peExplainRecordType = ERT_SortDetails;
      else
      if(strcmp("ERT_Processing", *text) == 0)
         *peExplainRecordType = ERT_Processing;
      else
      if(strcmp("ERT_Variants", *text) == 0)
         *peExplainRecordType = ERT_Variants;
      else
      if(strcmp("ERT_Units", *text) == 0)
         *peExplainRecordType = ERT_Units;
      else
      if(strcmp("ERT_CategoryList", *text) == 0)
         *peExplainRecordType = ERT_CategoryList;
      else
      if(strcmp("ERT_Invalid", *text) == 0)
         *peExplainRecordType = ERT_Invalid;
      else
         printf("Warning: DbvExplainRecordType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peExplainRecordType == ERT_TargetInfo )
         strcpy(temp, "ERT_TargetInfo");

      if( *peExplainRecordType == ERT_DatabaseInfo)
         strcpy(temp, "ERT_DatabaseInfo");

      if( *peExplainRecordType == ERT_SchemaInfo)
         strcpy(temp, "ERT_SchemaInfo");

      if( *peExplainRecordType == ERT_TagSetInfo)
         strcpy(temp, "ERT_TagSetInfo");

      if( *peExplainRecordType == ERT_RecordSyntaxInfo)
         strcpy(temp, "ERT_RecordSyntaxInfo");

      if( *peExplainRecordType == ERT_AttributeSetInfo)
         strcpy(temp, "ERT_AttributeSetInfo");

      if( *peExplainRecordType == ERT_TermListInfo)
         strcpy(temp, "ERT_TermListInfo");

      if( *peExplainRecordType == ERT_ExtendedServicesInfo)
         strcpy(temp, "ERT_ExtendedServicesInfo");

      if( *peExplainRecordType == ERT_AttributeDetails)
         strcpy(temp, "ERT_AttributeDetails");

      if( *peExplainRecordType == ERT_TermListDetails)
         strcpy(temp, "ERT_TermListDetails");

      if( *peExplainRecordType == ERT_ElementSetDetails)
         strcpy(temp, "ERT_ElementSetDetails");

      if( *peExplainRecordType == ERT_RetrievalRecordDetails)
         strcpy(temp, "ERT_RetrievalRecordDetails");

      if( *peExplainRecordType == ERT_SortDetails)
         strcpy(temp, "ERT_SortDetails");

      if( *peExplainRecordType == ERT_Processing)
         strcpy(temp, "ERT_Processing");

      if( *peExplainRecordType == ERT_Variants)
         strcpy(temp, "ERT_Variants");

      if( *peExplainRecordType == ERT_Units)
         strcpy(temp, "ERT_Units");

      if( *peExplainRecordType == ERT_CategoryList)
         strcpy(temp, "ERT_CategoryList");

      if( *peExplainRecordType == ERT_Invalid)
         strcpy(temp, "ERT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvExplainRecordType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvExplainRecordType() */

void convert_DbvBodyTypeType(char **text, DbvBodyTypeType *peBodyTypeType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("BTT_IanaType", *text) == 0)
         *peBodyTypeType = BTT_IanaType;
      else
      if(strcmp("BTT_Z3950Type", *text) == 0)
         *peBodyTypeType = BTT_Z3950Type;
      else
      if(strcmp("BTT_OtherType", *text) == 0)
         *peBodyTypeType = BTT_OtherType;
      else
      if(strcmp("BTT_Invalid", *text) == 0)
         *peBodyTypeType = BTT_Invalid;
      else
         printf("Warning: DbvBodyTypeType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peBodyTypeType == BTT_IanaType)
         strcpy(temp, "BTT_IanaType");

      if( *peBodyTypeType == BTT_Z3950Type)
         strcpy(temp, "BTT_Z3950Type");

      if( *peBodyTypeType == BTT_OtherType)
         strcpy(temp, "BTT_OtherType");

      if( *peBodyTypeType == BTT_Invalid)
         strcpy(temp, "BTT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvBodyTypeType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvBodyTypeType() */

void convert_DbvNetworkAddressType(char **text, 
				DbvNetworkAddressType *peNetworkAddressType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("NAT_InternetAddress", *text) == 0)
         *peNetworkAddressType = NAT_InternetAddress;
      else
      if(strcmp("NAT_OsiPresentationAddress", *text) == 0)
         *peNetworkAddressType = NAT_OsiPresentationAddress;
      else
      if(strcmp("NAT_OtherAddress", *text) == 0)
         *peNetworkAddressType = NAT_OtherAddress;
      else
      if(strcmp("NAT_Invalid", *text) == 0)
         *peNetworkAddressType = NAT_Invalid;
      else
         printf("Warning: DbvNetworkAddressType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peNetworkAddressType == NAT_InternetAddress)
         strcpy(temp, "NAT_InternetAddress");

      if( *peNetworkAddressType == NAT_OsiPresentationAddress)
         strcpy(temp, "NAT_OsiPresentationAddress");

      if( *peNetworkAddressType == NAT_OtherAddress)
         strcpy(temp, "NAT_OtherAddress");

      if( *peNetworkAddressType == NAT_Invalid)
         strcpy(temp, "NAT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvNetworkAddressType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvNetworkAddressType() */

void convert_DbvQueryTypeDetailsType(char **text, 
			DbvQueryTypeDetailsType *peQueryTypeDetailsType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("QTDT_Private", *text) == 0)
         *peQueryTypeDetailsType = QTDT_Private;
      else
      if(strcmp("QTDT_Rpn", *text) == 0)
         *peQueryTypeDetailsType = QTDT_Rpn;
      else
      if(strcmp("QTDT_Iso8777", *text) == 0)
         *peQueryTypeDetailsType = QTDT_Iso8777;
      else
      if(strcmp("QTDT_Z39_58", *text) == 0)
         *peQueryTypeDetailsType = QTDT_Z39_58;
      else
      if(strcmp("QTDT_Erpn", *text) == 0)
         *peQueryTypeDetailsType = QTDT_Erpn;
      else
      if(strcmp("QTDT_RankedList", *text) == 0)
         *peQueryTypeDetailsType = QTDT_RankedList;
      else
      if(strcmp("QTDT_Invalid", *text) == 0)
         *peQueryTypeDetailsType = QTDT_Invalid;
      else
         printf("Warning: DbvQueryTypeDetailsType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peQueryTypeDetailsType == QTDT_Private)
         strcpy(temp, "QTDT_Private");

      if( *peQueryTypeDetailsType == QTDT_Rpn)
         strcpy(temp, "QTDT_Rpn");

      if( *peQueryTypeDetailsType == QTDT_Iso8777)
         strcpy(temp, "QTDT_Iso8777");

      if( *peQueryTypeDetailsType == QTDT_Z39_58)
         strcpy(temp, "QTDT_Z39_58");

      if( *peQueryTypeDetailsType == QTDT_Erpn)
         strcpy(temp, "QTDT_Erpn");

      if( *peQueryTypeDetailsType == QTDT_RankedList)
         strcpy(temp, "QTDT_RankedList");

      if( *peQueryTypeDetailsType == QTDT_Invalid)
         strcpy(temp, "QTDT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvQueryTypeDetailsType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvQueryTypeDetailsType() */

void convert_DbvUnitsSupportedType(char **text, 
				DbvUnitsSupportedType *peUnitsSupportedType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("UST_Known", *text) == 0)
         *peUnitsSupportedType = UST_Known;
      else
      if(strcmp("UST_Private", *text) == 0)
         *peUnitsSupportedType = UST_Private;
      else
      if(strcmp("UST_Invalid", *text) == 0)
         *peUnitsSupportedType = UST_Invalid;
      else
         printf("Warning: DbvUnitsSupportedType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peUnitsSupportedType == UST_Known)
         strcpy(temp, "UST_Known");

      if( *peUnitsSupportedType == UST_Private)
         strcpy(temp, "UST_Private");

      if( *peUnitsSupportedType == UST_Invalid)
         strcpy(temp, "UST_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvUnitsSupportedType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvUnitsSupportedType() */

void convert_DbvAccessType(char **text, DbvAccessType *peAccessType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("AT_Any", *text) == 0)
         *peAccessType = AT_Any;
      else
      if(strcmp("AT_Search", *text) == 0)
         *peAccessType = AT_Search;
      else
      if(strcmp("AT_Present", *text) == 0)
         *peAccessType = AT_Present;
      else
      if(strcmp("AT_SpecificElements", *text) == 0)
         *peAccessType = AT_SpecificElements;
      else
      if(strcmp("AT_ExtendedServices", *text) == 0)
         *peAccessType = AT_ExtendedServices;
      else
      if(strcmp("AT_ByDatabase", *text) == 0)
         *peAccessType = AT_ByDatabase;
      else
      if(strcmp("AT_Invalid", *text) == 0)
         *peAccessType = AT_Invalid;
      else
         printf("Warning: DbvAccessType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peAccessType == AT_Any)
         strcpy(temp, "AT_Any");

      if( *peAccessType == AT_Search)
         strcpy(temp, "AT_Search");

      if( *peAccessType == AT_Present)
         strcpy(temp, "AT_Present");

      if( *peAccessType == AT_SpecificElements)
         strcpy(temp, "AT_SpecificElements");

      if( *peAccessType == AT_ExtendedServices)
         strcpy(temp, "AT_ExtendedServices");

      if( *peAccessType == AT_ByDatabase)
         strcpy(temp, "AT_ByDatabase");

      if( *peAccessType == AT_Invalid)
         strcpy(temp, "AT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvAccessType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvAccessType() */

void convert_DbvRecordCountType(char **text, 
				DbvRecordCountType *peRecordCountType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("RCT_ActualNumber", *text) == 0)
         *peRecordCountType = RCT_ActualNumber;
      else
      if(strcmp("RCT_ApproxNumber", *text) == 0)
         *peRecordCountType = RCT_ApproxNumber;
      else
      if(strcmp("RCT_Invalid", *text) == 0)
         *peRecordCountType = RCT_Invalid;
      else
         printf("Warning: DbvRecordCountType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peRecordCountType == RCT_ActualNumber)
         strcpy(temp, "RCT_ActualNumber");

      if( *peRecordCountType == RCT_ApproxNumber)
         strcpy(temp, "RCT_ApproxNumber");

      if( *peRecordCountType == RCT_Invalid)
         strcpy(temp, "RCT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvRecordCountType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvRecordCountType() */

void convert_DbvElementDataTypeType(char **text, 
				DbvElementDataTypeType *peElementDataTypeType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("EDTT_Primitive", *text) == 0)
         *peElementDataTypeType = EDTT_Primitive;
      else
      if(strcmp("EDTT_Structured", *text) == 0)
         *peElementDataTypeType = EDTT_Structured;
      else
      if(strcmp("EDTT_Invalid", *text) == 0)
         *peElementDataTypeType = EDTT_Invalid;
      else
         printf("Warning: DbvElementDataTypeType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peElementDataTypeType == EDTT_Primitive)
         strcpy(temp, "EDTT_Primitive");

      if( *peElementDataTypeType == EDTT_Structured)
         strcpy(temp, "EDTT_Structured");

      if( *peElementDataTypeType == EDTT_Invalid)
         strcpy(temp, "EDTT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvElementDataTypeType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvElementDataTypeType() */

void convert_DbvPrimitiveDataType(char **text, 
				DbvPrimitiveDataType *pePrimitiveDataType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("PDT_OctetString", *text) == 0)
         *pePrimitiveDataType = PDT_OctetString;
      else
      if(strcmp("PDT_Numeric", *text) == 0)
         *pePrimitiveDataType = PDT_Numeric;
      else
      if(strcmp("PDT_Date", *text) == 0)
         *pePrimitiveDataType = PDT_Date;
      else
      if(strcmp("PDT_External", *text) == 0)
         *pePrimitiveDataType = PDT_External;
      else
      if(strcmp("PDT_String", *text) == 0)
         *pePrimitiveDataType = PDT_String;
      else
      if(strcmp("PDT_TrueOrFalse", *text) == 0)
         *pePrimitiveDataType = PDT_TrueOrFalse;
      else
      if(strcmp("PDT_Oid", *text) == 0)
         *pePrimitiveDataType = PDT_Oid;
      else
      if(strcmp("PDT_IntUnit", *text) == 0)
         *pePrimitiveDataType = PDT_IntUnit;
      else
      if(strcmp("PDT_Empty", *text) == 0)
         *pePrimitiveDataType = PDT_Empty;
      else
      if(strcmp("PDT_NoneOfTheAbove", *text) == 0)
         *pePrimitiveDataType = PDT_NoneOfTheAbove;
      else
      if(strcmp("PDT_Invalid", *text) == 0)
         *pePrimitiveDataType = PDT_Invalid;
      else
         printf("Warning: DbvPrimitiveDataType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *pePrimitiveDataType == PDT_OctetString)
         strcpy(temp, "PDT_OctetString");

      if( *pePrimitiveDataType == PDT_Numeric)
         strcpy(temp, "PDT_Numeric");

      if( *pePrimitiveDataType == PDT_Date)
         strcpy(temp, "PDT_Date");

      if( *pePrimitiveDataType == PDT_External)
         strcpy(temp, "PDT_External");

      if( *pePrimitiveDataType == PDT_String)
         strcpy(temp, "PDT_String");

      if( *pePrimitiveDataType == PDT_TrueOrFalse)
         strcpy(temp, "PDT_TrueOrFalse");

      if( *pePrimitiveDataType == PDT_Oid)
         strcpy(temp, "PDT_Oid");

      if( *pePrimitiveDataType == PDT_IntUnit)
         strcpy(temp, "PDT_IntUnit");

      if( *pePrimitiveDataType == PDT_Empty)
         strcpy(temp, "PDT_Empty");

      if( *pePrimitiveDataType == PDT_NoneOfTheAbove)
         strcpy(temp, "PDT_NoneOfTheAbove");

      if( *pePrimitiveDataType == PDT_Invalid)
         strcpy(temp, "PDT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvPrimitiveDataType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvPrimitiveDataType() */

void convert_DbvSearchCost(char **text, DbvSearchCost *peSearchCost)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("SC_Optimized", *text) == 0)
         *peSearchCost = SC_Optimized;
      else
      if(strcmp("SC_Normal", *text) == 0)
         *peSearchCost = SC_Normal;
      else
      if(strcmp("SC_Expensive", *text) == 0)
         *peSearchCost = SC_Expensive;
      else
      if(strcmp("SC_Filter", *text) == 0)
         *peSearchCost = SC_Filter;
      else
      if(strcmp("SC_Invalid", *text) == 0)
         *peSearchCost = SC_Invalid;
      else
         printf("Warning: DbvSearchCost string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSearchCost == SC_Optimized)
         strcpy(temp, "SC_Optimized");

      if( *peSearchCost == SC_Normal)
         strcpy(temp, "SC_Normal");

      if( *peSearchCost == SC_Expensive)
         strcpy(temp, "SC_Expensive");

      if( *peSearchCost == SC_Filter)
         strcpy(temp, "SC_Filter");

      if( *peSearchCost == SC_Invalid)
         strcpy(temp, "SC_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvSearchCost enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSearchCost() */

void convert_DbvExtendedServicesInfoInt(char **text, 
			DbvExtendedServicesInfoInt *peExtendedServicesInfoInt)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("ESII_WaitSupported", *text) == 0)
         *peExtendedServicesInfoInt = ESII_WaitSupported;
      else
      if(strcmp("ESII_WaitAlways", *text) == 0)
         *peExtendedServicesInfoInt = ESII_WaitAlways;
      else
      if(strcmp("ESII_WaitNotSupported", *text) == 0)
         *peExtendedServicesInfoInt = ESII_WaitNotSupported;
      else
      if(strcmp("ESII_Depends", *text) == 0)
         *peExtendedServicesInfoInt = ESII_Depends;
      else
      if(strcmp("ESII_NotSaying", *text) == 0)
         *peExtendedServicesInfoInt = ESII_NotSaying;
      else
      if(strcmp("ESII_Invalid", *text) == 0)
         *peExtendedServicesInfoInt = ESII_Invalid;
      else
         printf("Warning: DbvExtendedServicesInfoInt string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peExtendedServicesInfoInt == ESII_WaitSupported)
         strcpy(temp, "ESII_WaitSupported");

      if( *peExtendedServicesInfoInt == ESII_WaitAlways)
         strcpy(temp, "ESII_WaitAlways");

      if( *peExtendedServicesInfoInt == ESII_WaitNotSupported)
         strcpy(temp, "ESII_WaitNotSupported");

      if( *peExtendedServicesInfoInt == ESII_Depends)
         strcpy(temp, "ESII_Depends");

      if( *peExtendedServicesInfoInt == ESII_NotSaying)
         strcpy(temp, "ESII_NotSaying");

      if( *peExtendedServicesInfoInt == ESII_Invalid)
         strcpy(temp, "ESII_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvExtendedServicesInfoInt enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvExtendedServicesInfoInt() */

void convert_DbvSortTypeType(char **text, DbvSortTypeType *peSortTypeType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("STT_Character", *text) == 0)
         *peSortTypeType = STT_Character;
      else
      if(strcmp("STT_Numeric", *text) == 0)
         *peSortTypeType = STT_Numeric;
      else
      if(strcmp("STT_Structured", *text) == 0)
         *peSortTypeType = STT_Structured;
      else
      if(strcmp("STT_Invalid", *text) == 0)
         *peSortTypeType = STT_Invalid;
      else
         printf("Warning: DbvSortTypeType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peSortTypeType == STT_Character)
         strcpy(temp, "STT_Character");

      if( *peSortTypeType == STT_Numeric)
         strcpy(temp, "STT_Numeric");

      if( *peSortTypeType == STT_Structured)
         strcpy(temp, "STT_Structured");

      if( *peSortTypeType == STT_Invalid)
         strcpy(temp, "STT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvSortTypeType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvSortTypeType() */

void convert_DbvCaseSensitivity(char **text, 
			DbvCaseSensitivity *peCaseSensitivity)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("CSE_Always", *text) == 0)
         *peCaseSensitivity = CSE_Always;
      else
      if(strcmp("CSE_Never", *text) == 0)
         *peCaseSensitivity = CSE_Never;
      else
      if(strcmp("CSE_DefaultYes", *text) == 0)
         *peCaseSensitivity = CSE_DefaultYes;
      else
      if(strcmp("CSE_DefaultNo", *text) == 0)
         *peCaseSensitivity = CSE_DefaultNo;
      else
      if(strcmp("CSE_Invalid", *text) == 0)
         *peCaseSensitivity = CSE_Invalid;
      else
         printf("Warning: DbvCaseSensitivity string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peCaseSensitivity == CSE_Always)
         strcpy(temp, "CSE_Always");

      if( *peCaseSensitivity == CSE_Never)
         strcpy(temp, "CSE_Never");

      if( *peCaseSensitivity == CSE_DefaultYes)
         strcpy(temp, "CSE_DefaultYes");

      if( *peCaseSensitivity == CSE_DefaultNo)
         strcpy(temp, "CSE_DefaultNo");

      if( *peCaseSensitivity == CSE_Invalid)
         strcpy(temp, "CSE_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvCaseSensitivity enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvCaseSensitivity() */

void convert_DbvProcessingContext(char **text, 
				DbvProcessingContext *peProcessingContext)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("PC_Access", *text) == 0)
         *peProcessingContext = PC_Access;
      else
      if(strcmp("PC_Search", *text) == 0)
         *peProcessingContext = PC_Search;
      else
      if(strcmp("PC_Retrieval", *text) == 0)
         *peProcessingContext = PC_Retrieval;
      else
      if(strcmp("PC_RecordPresentation", *text) == 0)
         *peProcessingContext = PC_RecordPresentation;
      else
      if(strcmp("PC_RecordHandling", *text) == 0)
         *peProcessingContext = PC_RecordHandling;
      else
      if(strcmp("PC_Invalid", *text) == 0)
         *peProcessingContext = PC_Invalid;
      else
         printf("Warning: DbvProcessingContext string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peProcessingContext == PC_Access)
         strcpy(temp, "PC_Access");

      if( *peProcessingContext == PC_Search)
         strcpy(temp, "PC_Search");

      if( *peProcessingContext == PC_Retrieval)
         strcpy(temp, "PC_Retrieval");

      if( *peProcessingContext == PC_RecordPresentation)
         strcpy(temp, "PC_RecordPresentation");

      if( *peProcessingContext == PC_RecordHandling)
         strcpy(temp, "PC_RecordHandling");

      if( *peProcessingContext == PC_Invalid)
         strcpy(temp, "PC_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvProcessingContext enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvProcessingContext() */

void convert_DbvValueSetType(char **text, DbvValueSetType *peValueSetType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("VT_Range", *text) == 0)
         *peValueSetType = VT_Range;
      else
      if(strcmp("VT_Enumerated", *text) == 0)
         *peValueSetType = VT_Enumerated;
      else
      if(strcmp("VT_Invalid", *text) == 0)
         *peValueSetType = VT_Invalid;
      else
         printf("Warning: DbvValueSetType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peValueSetType == VT_Range)
         strcpy(temp, "VT_Range");

      if( *peValueSetType == VT_Enumerated)
         strcpy(temp, "VT_Enumerated");

      if( *peValueSetType == VT_Invalid)
         strcpy(temp, "VT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
         printf("Warning: DbvValueSetType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvValueSetType() */

void convert_DbvValueDescriptionType(char **text, 
			DbvValueDescriptionType *peValueDescriptionType)
   {
   int length;
   char temp[ SML_BUFFER ];

   if( *text != NULL )
      {
      if(strcmp("VDT_Integer", *text) == 0)
         *peValueDescriptionType = VDT_Integer;
      else
      if(strcmp("VDT_String", *text) == 0)
         *peValueDescriptionType = VDT_String;
      else
      if(strcmp("VDT_Octets", *text) == 0)
         *peValueDescriptionType = VDT_Octets;
      else
      if(strcmp("VDT_Oid", *text) == 0)
         *peValueDescriptionType = VDT_Oid;
      else
      if(strcmp("VDT_Unit", *text) == 0)
         *peValueDescriptionType = VDT_Unit;
      else
      if(strcmp("VDT_ValueAndUnit", *text) == 0)
         *peValueDescriptionType = VDT_ValueAndUnit;
      else
      if(strcmp("VDT_Invalid", *text) == 0)
         *peValueDescriptionType = VDT_Invalid;
      else
         printf("Warning: DbvValueDescriptionType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peValueDescriptionType == VDT_Integer)
         strcpy(temp, "VDT_Integer");

      if( *peValueDescriptionType == VDT_String)
         strcpy(temp, "VDT_String");

      if( *peValueDescriptionType == VDT_Octets)
         strcpy(temp, "VDT_Octets");

      if( *peValueDescriptionType == VDT_Oid)
         strcpy(temp, "VDT_Oid");

      if( *peValueDescriptionType == VDT_Unit)
         strcpy(temp, "VDT_Unit");

      if( *peValueDescriptionType == VDT_ValueAndUnit)
         strcpy(temp, "VDT_ValueAndUnit");

      if( *peValueDescriptionType == VDT_Invalid)
         strcpy(temp, "VDT_Invalid");

      length = strlen( temp );
      if( length )
	 {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
	 } /* End if */
      else
    printf("Warning: DbvValueDescriptionType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvValueDescriptionType() */



void convert_DbvStringOrNumericType(char **text,
                        DbvStringOrNumericType *peStringOrNumericType)
   {
   int length;
   char temp[ STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("SNT_String", *text) == 0)
         *peStringOrNumericType = SNT_String;
      else
      if(strcmp("SNT_Numeric", *text) == 0)
         *peStringOrNumericType = SNT_Numeric;
      else
         printf("Warning: DbvStringOrNumericType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peStringOrNumericType == SNT_String )
         strcpy(temp, "SNT_String" );

      if( *peStringOrNumericType == SNT_Numeric )
         strcpy(temp, "SNT_Numeric" );

      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
         } /* End if */
      else
         printf("Warning: DbvStringOrNumericType enum could not be converted!\n"
);
      } /* End else */
   } /* End convert_DbvStringOrNumericType() */



void convert_DbvElementSpecType(char **text,
                                DbvElementSpecType *peElementSpecType)
   {
   int length;
   char temp[ STRING_LEN ];

   if( *text != NULL )
      {
      if(strcmp("EST_Primitive", *text) == 0)
         *peElementSpecType = EST_Primitive;
      else
      if(strcmp("EST_External", *text) == 0)
         *peElementSpecType = EST_External;
      else
         printf("Warning: DbvElementSpecType string could not be converted: %s\n",*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peElementSpecType == EST_Primitive )
         strcpy(temp, "EST_Primitive");

      if( *peElementSpecType == EST_External)
         strcpy(temp, "EST_External");

      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
         } /* End if */
      else
         printf("Warning: DbvElementSpecType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvElementSpecType() */


/* ********* WRITE FUNCTIONS ********* */


void zraw_writestring_field(char *text)
{
	printf("%s\n", text);
}
 
void zraw_writecomment_field(char *text)
{
	printf("%s\n", text);
}

void zraw_writechar_field(char *item)
{
	printf("%s\n", item);
}
 
void zraw_writeint_field(int item)
{
 
	printf("%d\n", item);
}



/* Write an integer. "NULL" will be written
	if the pointer is NULL */
void zraw_writetitle_int(char *title, int *item)
{
	char *temp;

	if(item == NULL)
		zraw_writetitle_char("NULL", title);
	else
	{
		/* +12 for a 32-bit integer (plus an extra bit )*/
		temp = DbvAlloc(strlen(title)+20);
		sprintf(temp,"%s: %d",title, *item);
		zraw_writechar_field(temp);
		DbvFree(temp);
	}
}

/* Write an unquoted text field with title. Handles NULL correctly. */
void zraw_writetitle_char(char *text, char *title)
{
	char pcNull[]="NULL";
	char *temp;

	if(text==NULL)
		text=pcNull;
	temp=DbvAlloc((strlen(title)+strlen(text)+5));
	sprintf(temp,"%s: %s",title, text);
	zraw_writechar_field(temp);
	DbvFree(temp);
}

void zraw_writeDbvBool(char *title, DbvBool fBool)
{
	if(fBool == DBV_TRUE)
		zraw_writetitle_char("DBV_TRUE", title);
	else
		zraw_writetitle_char("DBV_FALSE", title);
}



void zraw_writeDbvOctetString(char *name, DbvOctetString *psOctetString)
{
        char *temp = NULL;
 
        if (psOctetString != NULL)
        {
		temp = (char *)DbvAlloc(strlen(name)+20+
			psOctetString->ulLength);
                sprintf(temp, "%s: ", name);
		if (psOctetString->pcValue)
                	strncat(temp, psOctetString->pcValue, psOctetString->ulLength);
        }
        else
        {
		temp = (char *)DbvAlloc(10+strlen(name));
                sprintf(temp, "%s : NULL",name);
        }
        zraw_writechar_field(temp);
	DbvFree(temp);
        
}

void zraw_writeDbvInternationalString(char *name, DbvInternationalString
        *psInternationalString)
{
 
        zraw_writeDbvOctetString(name, (DbvOctetString *)psInternationalString );
}


 



/* Conversion routines to convert from string to enumerated type and
        vice versa */
 
 

void convert_DbvExternalValueType(char **text, DbvExternalValueType *peValueType)
{
	char temp[SML_BUFFER];

	if(*text != NULL)
	{
                if(strcmp("EVT_SingleASN1Type", *text) == 0)
                        *peValueType = EVT_SingleASN1Type;
                else
                if(strcmp("EVT_OctetAligned", *text) == 0)
                        *peValueType = EVT_OctetAligned;
                else
                if(strcmp("EVT_Arbitrary", *text) == 0)
                        *peValueType = EVT_Arbitrary;
		else
                        printf("Warning: DbvExternalValueType string could not be converted: %s\n", *text);

        }
	else
	{
		temp[ 0 ] = '\0';
                if(*peValueType == EVT_SingleASN1Type)
                        strcpy(temp, "EVT_SingleASN1Type");
                if(*peValueType == EVT_OctetAligned)
                        strcpy(temp, "EVT_OctetAligned");
                if(*peValueType == EVT_Arbitrary)
                        strcpy(temp, "EVT_Arbitrary");
                if(strlen(temp)==0)
                        printf("Warning: DbvExternalValueType enum could not be converted!\n" );
                *text = (char *)malloc(strlen(temp)+1);
                strcpy(*text, temp);
	}
}



void convert_DbvASN1Type(char **text, DbvASN1Type *peASN1Type)
{
        char temp[SML_BUFFER];
 
        if(*text != NULL)
        {
                if(strcmp("AT_UnstructuredText", *text) == 0)
                        *peASN1Type = AT_UnstructuredText;
		else
                if(strcmp("AT_OpacRecord", *text) == 0)
                        *peASN1Type = AT_OpacRecord;
		else
                if(strcmp("AT_SummaryRecord", *text) == 0)
                        *peASN1Type = AT_SummaryRecord;
		else
                if(strcmp("AT_ResourceReport1", *text) == 0)
                        *peASN1Type = AT_ResourceReport1;
		else
                if(strcmp("AT_ResourceReport2", *text) == 0)
                        *peASN1Type = AT_ResourceReport2;
		else
                if(strcmp("AT_EsTaskPackage", *text) == 0)
                        *peASN1Type = AT_EsTaskPackage;
		else
                if(strcmp("AT_UpdateExtendedService", *text) == 0)
                        *peASN1Type = AT_UpdateExtendedService;
		else
                if(strcmp("AT_UnknownType", *text) == 0)
                        *peASN1Type = AT_UnknownType;
		else

                if(strcmp("AT_ItemOrderExtendedService", *text) == 0)
                        *peASN1Type = AT_ItemOrderExtendedService;
		else
                if(strcmp("AT_IllPdu", *text) == 0)
                        *peASN1Type = AT_IllPdu;
		else

                if(strcmp("AT_ExplainRecord", *text) == 0)
                        *peASN1Type = AT_ExplainRecord;
                else

                if(strcmp("AT_GenericRecord", *text) == 0)
                        *peASN1Type = AT_GenericRecord;
                else

                        printf("Warning: DbvASN1Type string could not be converted: %s\n",*text);
	}
	else
	{
		temp[ 0 ] = '\0';
                if(*peASN1Type == AT_UnstructuredText)
                        strcpy(temp, "AT_UnstructuredText");

                if(*peASN1Type == AT_OpacRecord)
                        strcpy(temp, "AT_OpacRecord");

                if(*peASN1Type == AT_SummaryRecord)
                        strcpy(temp, "AT_SummaryRecord");

                if(*peASN1Type == AT_ResourceReport1)
                        strcpy(temp, "AT_ResourceReport1");

                if(*peASN1Type == AT_ResourceReport2)
                        strcpy(temp, "AT_ResourceReport2");

                if(*peASN1Type == AT_EsTaskPackage)
                        strcpy(temp, "AT_EsTaskPackage");

                if(*peASN1Type == AT_UpdateExtendedService)
                        strcpy(temp, "AT_UpdateExtendedService");

                if(*peASN1Type == AT_UnknownType)
                        strcpy(temp, "AT_UnknownType");

                if(*peASN1Type == AT_ItemOrderExtendedService)
                        strcpy(temp, "AT_ItemOrderExtendedService");

                if(*peASN1Type == AT_IllPdu)
                        strcpy(temp, "AT_IllPdu");

                if(*peASN1Type == AT_ExplainRecord)
                        strcpy(temp, "AT_ExplainRecord");


                if(*peASN1Type == AT_GenericRecord)
                        strcpy(temp, "AT_GenericRecord");



                if(strlen(temp)==0)
                        printf("Warning: DbvASN1Type enum could not be converted!\n");
                *text = (char *)malloc(strlen(temp)+1);
                strcpy(*text, temp);
	}

}

void convert_DbvInformationType(char **text, DbvInformationType *peInformationType)
{
        char temp[SML_BUFFER];

        if(*text != NULL)
        {
                if(strcmp("IT_CharacterInfo", *text) == 0)
                        *peInformationType = IT_CharacterInfo;
                else
                if(strcmp("IT_BinaryInfo", *text) == 0)
                        *peInformationType = IT_BinaryInfo;
                else
                if(strcmp("IT_ExternalInfo", *text) == 0)
                        *peInformationType = IT_ExternalInfo;
                else
                if(strcmp("IT_ObjectIdentifier", *text) == 0)
                       *peInformationType = IT_ObjectIdentifier;
                else
                        printf("Warning: DbvInformationType string could not be converted: %s\n", *text);
        }
        else
        {
                if(*peInformationType == IT_CharacterInfo)
                        strcpy(temp, "IT_CharacterInfo");
                if(*peInformationType == IT_BinaryInfo)
                        strcpy(temp, "IT_BinaryInfo");
                if(*peInformationType == IT_ExternalInfo)
                        strcpy(temp, "IT_ExternalInfo");
                if(*peInformationType == IT_ObjectIdentifier)
                        strcpy(temp, "IT_ObjectIdentifier");

                if(strlen(temp)==0)
                        printf("Warning: DbvInformationType enum could not be converted!\n");
                *text = (char *)malloc(strlen(temp)+1);
                strcpy(*text, temp);
        }
}




void convert_DbvTermType(char **text, DbvTermType *peTermType)
   {
   int length;
   char temp[SML_BUFFER];
   if( *text != NULL )
      {
      if(strcmp("TT_General", *text) == 0)
         *peTermType = TT_General;
      else
      if(strcmp("TT_Numeric", *text) == 0)
         *peTermType = TT_Numeric;
      else
      if(strcmp("TT_SimpleCharacter", *text) == 0)
         *peTermType = TT_SimpleCharacter;
      else
      if(strcmp("TT_ObjectIdentifier", *text) == 0)
         *peTermType = TT_ObjectIdentifier;
      else
      if(strcmp("TT_DateTime", *text) == 0)
         *peTermType = TT_DateTime;
      else
      if(strcmp("TT_External", *text) == 0)
         *peTermType = TT_External;
      else
      if(strcmp("TT_IntegerAndUnit", *text) == 0)
         *peTermType = TT_IntegerAndUnit;
      else
      if(strcmp("TT_Null", *text) == 0)
         *peTermType = TT_Null;
      else
         printf("Warning: DbvTermType string could not be converted: %s\n"
                ,*text);
      }
   else
      {
      temp[ 0 ] = '\0';
      if( *peTermType == TT_General )

         strcpy(temp, "TT_General");
      if( *peTermType == TT_Numeric  )
         strcpy(temp, "TT_Numeric");
      if( *peTermType == TT_SimpleCharacter )
         strcpy(temp, "TT_SimpleCharacter");
      if( *peTermType ==  TT_ObjectIdentifier)
         strcpy(temp, "TT_ObjectIdentifier");
      if( *peTermType == TT_DateTime )
         strcpy(temp, "TT_DateTime");
      if( *peTermType == TT_External )
         strcpy(temp, "TT_External");
      if( *peTermType == TT_IntegerAndUnit )
         strcpy(temp, "TT_IntegerAndUnit");
      if( *peTermType == TT_Null)
         strcpy(temp, "TT_Null");
      length = strlen( temp );
      if( length )
         {
         *text = (char *)malloc( length + 1);
         strcpy(*text, temp);
         } /* End if */
      else
         printf("Warning: DbvTermType enum could not be converted!\n");
      } /* End else */
   } /* End convert_DbvTermType() */


/***************************************/


