/*  Module Name: @(#)dans_write.h	7.1
    Version: 11/15/96
    Author: Dan Maskell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
        Functions to write structure types to the result script files.
        Used by the origin and target.
 
*/
 
#ifndef DANS_WRITE_H
#define DANS_WRITE_H
 

#include <stdio.h>


/*******************************************************************/
/* From testy_calls.h */

typedef enum DBVRpnQueryType {
	RPN_Q1 = 1,
	RPN_Q2 = 2,
	RPN_Q3 = 3
} DBVRpnQueryType;

typedef int TBLfudge;
typedef int TBLfudge_Return;
int T_Return;

#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "sl_list.h"
#include "memcheck.h"
#include "tbl.h"
#include "str_hand.h"

#include "sidefs.h"
#include "sitypes.h"
#include "sitypes2.h"
#include "dbvproto.h"


extern DbvBool bLocalResult;

#define SI_PREV 2
/* I don't want to fill in an optional PDU field */
#define NOTHING "NULL"
#define STRING_LEN 	128
#define SZ_FILENAME STRING_LEN
#define SML_BUFFER	64

#define ORIGIN 1
#define TARGET 2

typedef enum TestType {
        Valid = 0,
        Invalid = 1
} TestType;


/**********************************************************/
/* Full function prototype list */



void zraw_writeDbvObjectIdentifier(char *name, DbvObjectIdentifier psObjectIdentifier);
void zraw_writeDbvVisibleString(char *name, DbvVisibleString psVisibleString);
void zraw_writeDbvStringOrNumeric( DbvStringOrNumeric *psStringOrNumeric);
void zraw_writeinteger_string( char *name, int *pul);
void zraw_writeDbvTerm( DbvTerm *psTerm);
void zraw_writeDbvGeneralizedTime(char *name, DbvGeneralizedTime psGeneralizedTime);
void zraw_writeDbvIntUnit( DbvIntUnit *psIntUnit);
void zraw_writeDbvUnit( DbvUnit *psUnit);
void zraw_writeDbvSpecification( DbvSpecification *psSpecification);
void zraw_writeDbvGeneralString(char *name, DbvGeneralString
*psGeneralString);
void zraw_writeDbvCommonInfo( char *name, DbvCommonInfo *psCommonInfo);
void zraw_writeDbvHumanString( DbvHumanString *psHumanString);
void zraw_writeDbvBodyType( DbvBodyType *psBodyType);
void zraw_writeDbvIconObject( DbvIconObject *psIconObject);
void zraw_writeDbvContactInfo( DbvContactInfo *psContactInfo);
void zraw_writeDbvInterAddress( DbvInterAddress *psInterAddress);
void zraw_writeDbvOsiPresentationAddress(DbvOsiPresentationAddress *psOsiPresentationAddress);
void zraw_writeDbvOtherAddress( DbvOtherAddress *psOtherAddress);
void zraw_writeDbvNetworkAddress( DbvNetworkAddress *psNetworkAddress);
void zraw_writeDbvOperators( DbvOperators *psOperators);
void zraw_writeDbvSearchKey( DbvSearchKey *psSearchKey);
void writeN_DbvHumanStringSeq( char *name, DbvHumanStringSeq **ppsDescription);
void zraw_writeDbvPrivateCapabilities( 
DbvPrivateCapabilities *psPrivateCapabilities);
void zraw_writeDbvPrivate( DbvPrivate *psPrivate);
void zraw_writeDbvUnitsSupported( DbvUnitsSupported *psUnitsSupported);
void zraw_writeDbvProximitySupport( DbvProximitySupport *psProximitySupport);
void zraw_writeDbvRpnCapabilities( DbvRpnCapabilities *psRpnCapabilities);
void zraw_writeDbvIso8777Capabilities(DbvIso8777Capabilities *psIso8777Capabilities);
void zraw_writeDbvQueryTypeDetails( 
DbvQueryTypeDetails *psQueryTypeDetails);
void zraw_writeDbvAccessRestrictions( DbvAccessRestrictions *psAccessRestrictions);
void zraw_writeDbvCharge( DbvCharge *psCharge);
void zraw_writeDbvOtherCharge( DbvOtherCharge *psOtherCharge);
void zraw_writeDbvCosts( DbvCosts *psCosts);
void zraw_writeDbvAccessInfo( DbvAccessInfo *psAccessInfo);
void zraw_writeDbvTargetInfo( DbvTargetInfo *psTargetInfo);
void zraw_writeDbvRecordCount( DbvRecordCount *psRecordCount);
void zraw_writeDbvDatabaseInfo( DbvDatabaseInfo *psDatabaseInfo);
void zraw_writeDbvTagTypeMapping( DbvTagTypeMapping *psTagTypeMapping);
void zraw_writeDbvPath( DbvPath *psPath);
void zraw_writeDbvElementInfo( DbvElementInfo *psElementInfo);
void zraw_writeDbvElementDataType( DbvElementDataType *psElementDataType);
void zraw_writeDbvSchemaInfo( DbvSchemaInfo *psSchemaInfo);
void zraw_writeDbvElements( DbvElements *psElements);
void zraw_writeDbvPrimitiveDataType( char *name, DbvPrimitiveDataType *pePrimitiveDataType);
void zraw_writeDbvTagSetInfo( DbvTagSetInfo *psTagSetInfo);
void zraw_writeDbvRecordSyntaxInfo( DbvRecordSyntaxInfo *psRecordSyntaxInfo);
void zraw_writeDbvAttributeDescription(DbvAttributeDescription *psAttributeDescription);
void zraw_writeDbvAttributeType( DbvAttributeType *psAttributeType);
void zraw_writeDbvAttributeSetInfo( DbvAttributeSetInfo *psAttributeSetInfo );
void zraw_writeDbvTermList( DbvTermList *psTermList);
void zraw_writeDbvTermListInfo( DbvTermListInfo *psTermListInfo);
void zraw_writeDbvExtendedServicesInfo(DbvExtendedServicesInfo *psExtendedServicesInfo );
void zraw_writeDbvExtendedServicesInfoInt( 
DbvExtendedServicesInfoInt *peExtendedServicesInfoInt);
void zraw_writeDbvOmittedAttributeInterpretation( DbvOmittedAttributeInterpretation *psOmittedAttributeInterpretation );
void zraw_writeDbvSearchCost( char* name, DbvSearchCost *peSearchCost);
void zraw_writeDbvAttributeValues( DbvAttributeValues *psAttributeValues );
void zraw_writeDbvAttributesByType( DbvAttributesByType *psAttributesByType );
void zraw_writeDbvAttributesBySet( DbvAttributesBySet *psAttributesBySet );
void zraw_writeDbvAttributeCombinations( 
DbvAttributeCombinations *psAttributeCombinations );
void zraw_writeDbvAttributeDetails( DbvAttributeDetails *psAttributeDetails );
void zraw_writeDbvScanInfo( DbvScanInfo *psScanInfo);
void zraw_writeDbvTermListDetails( DbvTermListDetails *psTermListDetails );
void zraw_writeDbvRecordTag( DbvRecordTag *psRecordTag);
void zraw_writeDbvDetailsPerElement( DbvDetailsPerElement *psDetailsPerElement );
void zraw_writeDbvElementSetDetails( DbvElementSetDetails *psElementSetDetails );
void zraw_writeDbvRetrievalRecordDetails( 
DbvRetrievalRecordDetails *psRetrievalRecordDetails );
void zraw_writeDbvSortType( DbvSortType *psSortType);
void zraw_writeDbvSortKeys( DbvSortKeys *psSortKeys);
void zraw_writeDbvSortDetails( DbvSortDetails *psSortDetails);
void zraw_writeDbvProcessingInformation( 
DbvProcessingInformation *psProcessingInformation );
void zraw_writeDbvValueDescription( DbvValueDescription *psValueDescription );
void zraw_writeDbvValueRange( DbvValueRange *psValueRange);
void zraw_writeDbvValueSet( DbvValueSet *psValues);
void writeN_DbvValueDescription(DbvValueDescription **ppsEnumerated);
void zraw_writeDbvVariantValue( DbvVariantValue *psVariantValue);
void zraw_writeDbvVariantTypes( DbvVariantTypes *psVariantTypes);
void zraw_writeDbvVariantClass( DbvVariantClass *psVariants);
void zraw_writeDbvVariantSetInfo( DbvVariantSetInfo *psVariantSetInfo);
void zraw_writeDbvUnits( DbvUnits *psUnits);
void zraw_writeDbvUnitInfo( DbvUnitInfo *psUnitInfo);
void zraw_writeDbvCategoryInfo( DbvCategoryInfo *psCategoryInfo);
void zraw_writeDbvCategoryList( DbvCategoryList *psCategoryList);
void zraw_writeDbvExplainRecord( DbvExplainRecord *psExplainRecord);
void zraw_writeDbvLanguageCode( char *name,DbvLanguageCode *psLanguageCode );
void zraw_writeDbvNull( char *name, DbvNull *pvNull);
void zraw_writeDbvAttributeCombination(DbvAttributeCombination *psLegalCombinations);
void writeN_DbvDbvAttributeOccurrence(DbvAttributeOccurrence **ppsAttributeOccurrence);
void zraw_writeDbvDbvAttributeOccurrence( DbvAttributeOccurrence *psAttributeOccurrence);
void zraw_writeDbvAttributeOccurrenceChoice(DbvAttributeOccurrenceChoice *psAttributeValues);
void zraw_writeDbvDatabaseList( char *name, DbvDatabaseList *psDbCombinations);
void zraw_writeDbvHumanStringSeq( DbvHumanStringSeq *psHumanStringSeq);
void writeN_DbvIntUnit(DbvIntUnit **ppsIntUnit);
void writeN_DbvOtherInformation(DbvOtherInformation **ppsOtherInformation );
void writeN_DbvASN1External(DbvASN1External **ppsASN1External);
void writeN_DbvHumanString( char *name, 
DbvHumanString **ppsHumanString );
void writeN_DbvIconObject( DbvIconObject **ppsIconObject);
void writeN_DbvOperators(DbvOperators **ppsOperators);
void writeN_DbvSearchKey(DbvSearchKey **ppsSearchKey);
void writeN_DbvUnitsSupported(DbvUnitsSupported **ppsUnitsSupported );
void writeN_Ulong( char *name, Ulong **ppsUlong);
void writeN_DbvQueryTypeDetails(DbvQueryTypeDetails **ppsQueryTypeDetails );
void writeN_DbvObjectIdentifier( char *name, DbvObjectIdentifier *ppcObjectIdentifier );
void writeN_DbvOtherCharge(DbvOtherCharge **ppsOtherCharge);
void writeN_DbvAccessInfo( DbvAccessInfo **ppsAccessInfo);
void writeN_DbvTagTypeMapping(DbvTagTypeMapping **ppsTagTypeMapping );
void writeN_DbvPathA(DbvPathA **ppsPath);
void writeN_DbvPath(DbvPath **ppsPath);
void writeN_DbvElementInfo(DbvElementInfo **ppsElementInfo);
void writeN_DbvElements(DbvElements **ppsElements);
void writeN_DbvAttributeDescription(
DbvAttributeDescription **ppsAttributeDescription );
void writeN_DbvAttributeType( DbvAttributeType **ppsAttributeType );
void writeN_DbvTermList(DbvTermList **ppsTermList);
void writeN_DbvAttributeValues(DbvAttributeValues **ppsAttributeValues );
void writeN_DbvAttributesByType(DbvAttributesByType **ppsAttributesByType );
void writeN_DbvAttributesBySet( DbvAttributesBySet **ppsAttributesBySet );
void writeN_DbvAttributeCombination( DbvAttributeCombination **ppsLegalCombinations);
void writeN_DbvTerm( DbvTerm **ppsTerm);
void writeN_DbvDetailsPerElement( 
DbvDetailsPerElement **ppsDetailsPerElement );
void writeN_DbvSortKeys( DbvSortKeys **ppsSortKeys);
void writeN_DbvVariantTypes( DbvVariantTypes **ppsVariantTypes);
void writeN_DbvVariantClass( DbvVariantClass **ppsVariants);
void writeN_DbvUnits( DbvUnits **ppsUnits);
void writeN_DbvUnit( DbvUnit **ppsUnit);
void writeN_DbvCategoryInfo( DbvCategoryInfo **ppsCategories);
void writeN_DbvStringOrNumeric( DbvStringOrNumeric **ppsStringOrNumeric);
void writeN_DbvSpecification( DbvSpecification **ppsSpecification);
void writeN_DbvAccessRestrictions(
DbvAccessRestrictions **ppsAccessRestrictions);
void writeN_DbvNetworkAddress(DbvNetworkAddress **ppsNetworkAddress );
void writeN_DbvInternationalString( char *name, DbvInternationalString 
**ppsInternationalString);
void writeN_DbvDatabaseList( char *name, DbvDatabaseList **ppsDbCombinations);
void writeN_DbvDataBaseInfoSeq( char *name, DbvDataBaseInfoSeq **ppsKeywords);
void zraw_writeDbvDataBaseInfoSeq(char *name, DbvDataBaseInfoSeq *psKeywords);
void convert_DbvExplainRecordType(char **text, 
DbvExplainRecordType *peExplainRecordType);
void convert_DbvBodyTypeType(char **text, DbvBodyTypeType *peBodyTypeType);
void convert_DbvNetworkAddressType(char **text, 
DbvNetworkAddressType *peNetworkAddressType);
void convert_DbvQueryTypeDetailsType(char **text, 
DbvQueryTypeDetailsType *peQueryTypeDetailsType);
void convert_DbvUnitsSupportedType(char **text, 
DbvUnitsSupportedType *peUnitsSupportedType);
void convert_DbvAccessType(char **text, DbvAccessType *peAccessType);
void convert_DbvRecordCountType(char **text, 
DbvRecordCountType *peRecordCountType);
void convert_DbvElementDataTypeType(char **text, 
DbvElementDataTypeType *peElementDataTypeType);
void convert_DbvPrimitiveDataType(char **text, 
DbvPrimitiveDataType *pePrimitiveDataType);
void convert_DbvSearchCost(char **text, DbvSearchCost *peSearchCost);
void convert_DbvExtendedServicesInfoInt(char **text, 
DbvExtendedServicesInfoInt *peExtendedServicesInfoInt);
void convert_DbvSortTypeType(char **text, DbvSortTypeType *peSortTypeType);
void convert_DbvCaseSensitivity(char **text, 
DbvCaseSensitivity *peCaseSensitivity);
void convert_DbvProcessingContext(char **text, 
DbvProcessingContext *peProcessingContext);
void convert_DbvValueSetType(char **text, DbvValueSetType *peValueSetType);
void convert_DbvValueDescriptionType(char **text, 
DbvValueDescriptionType *peValueDescriptionType);
void convert_DbvStringOrNumericType(char **text,
DbvStringOrNumericType *peStringOrNumericType);
void convert_DbvElementSpecType(char **text,
DbvElementSpecType *peElementSpecType);
void zraw_writestring_field(char *text);
void zraw_writecomment_field(char *text);
void zraw_writechar_field(char *item);
void zraw_writeint_field(int item);
void zraw_writetitle_int(char *title, int *item);
void zraw_writetitle_char(char *text, char *title);
void zraw_writeDbvBool(char *title, DbvBool fBool);
void zraw_writeDbvOctetString(char *name, DbvOctetString *psOctetString);
void zraw_writeDbvInternationalString(char *name, DbvInternationalString
*psInternationalString);
void convert_DbvExternalValueType(char **text, DbvExternalValueType *peValueType);
void convert_DbvASN1Type(char **text, DbvASN1Type *peASN1Type);
void convert_DbvInformationType(char **text, DbvInformationType *peInformationType);
void convert_DbvTermType(char **text, DbvTermType *peTermType);




#endif
