/*  Module Name: @(#)oid_overwrites_iso.c	7.3
    Version: 12/6/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: snacc oid overwrite
 
*/


#include "sidefs.h"
#include "sitypes.h"
#include "sitypes2.h"
#include "dbvproto.h"
#include "iord_ext.h"
#include "itemordr.h"

int val;
jmp_buf env;
 
if ((val = setjmp(env)) == 0) {
 

AsnOid temp;
    
/* in z3950_globals.c */
extern char isosutrsOid_static[],
	isoopacOid_static[],
	isosummaryOid_static[],
	isoestaskOid_static[],
	isoresrep1Oid_static[],
	isoresrep2Oid_static[],
	isoesformupdateOid_static[],
	isoesformitemorderOid_static[],
	isoexplainOid_static[],
	isogenericOid_static[],
	isopromptobjOid_static[],
	isocharsetandlanguagenegotiationOid_static[];
	

/* ISO_UNSTRUCTURED_TEXT_RECORD - 1.0.10163.5.101 */
ASN_MakeOid(ISO_UNSTRUCTURED_TEXT_RECORD, &temp, env);
memcpy(isosutrsOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
isosutrsOid.octs = isosutrsOid_static;
isosutrsOid.octetLen = temp.octetLen;
oid0.octs = isosutrsOid_static;
oid0.octetLen = temp.octetLen;


/* ISO_OPAC_RECORD - 1.0.10163.5.102 */
ASN_MakeOid(ISO_OPAC_RECORD, &temp, env);
memcpy(isoopacOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
isoopacOid.octs = isoopacOid_static;
isoopacOid.octetLen = temp.octetLen;
oid1.octs = isoopacOid_static;
oid1.octetLen = temp.octetLen;


/* ISO_SUMMARY_RECORD - 1.0.10163.5.103 */
ASN_MakeOid(ISO_SUMMARY_RECORD, &temp, env);
memcpy(isosummaryOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
isosummaryOid.octs = isosummaryOid_static;
isosummaryOid.octetLen = temp.octetLen;
oid2.octs = isosummaryOid_static;
oid2.octetLen = temp.octetLen;


/* ISO_ES_TASK_PACKAGE_RECORD (Extended Service Task Package) -  1.0.10163.5.106 */
ASN_MakeOid(ISO_ES_TASK_PACKAGE_RECORD, &temp, env);
memcpy(isoestaskOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
isoestaskOid.octs = isoestaskOid_static;
isoestaskOid.octetLen = temp.octetLen;
oid3.octs = isoestaskOid_static;
oid3.octetLen = temp.octetLen;



/* ISO_RESOURCE_REPORT_1 - 1.0.10163.7.1  */
ASN_MakeOid(ISO_RESOURCE_REPORT_1, &temp, env);
memcpy(isoresrep1Oid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
isoresrep1Oid.octs = isoresrep1Oid_static;
isoresrep1Oid.octetLen = temp.octetLen;
oid4.octs = isoresrep1Oid_static;
oid4.octetLen = temp.octetLen;


/* ISO_RESOURCE_REPORT_2 - 1.0.10163.7.2  */
ASN_MakeOid(ISO_RESOURCE_REPORT_2, &temp, env);
memcpy(isoresrep2Oid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
isoresrep2Oid.octs = isoresrep2Oid_static;
isoresrep2Oid.octetLen = temp.octetLen;
oid5.octs = isoresrep2Oid_static;
oid5.octetLen = temp.octetLen;


/* ISO_ITEMORDER_EXTENDED_SERVICE - 1.0.10163.9.4  */
ASN_MakeOid(ISO_ITEMORDER_EXTENDED_SERVICE, &temp, env);
memcpy(isoesformitemorderOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
isoesformitemorderOid.octs = isoesformitemorderOid_static;
isoesformitemorderOid.octetLen = temp.octetLen;
oid6.octs = isoesformitemorderOid_static;
oid6.octetLen = temp.octetLen;


/* ISO_UPDATE_EXTENDED_SERVICE - 1.0.10163.9.5  */
ASN_MakeOid(ISO_UPDATE_EXTENDED_SERVICE, &temp, env);
memcpy(isoesformupdateOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
isoesformupdateOid.octs = isoesformupdateOid_static;
isoesformupdateOid.octetLen = temp.octetLen;
oid7.octs = isoesformupdateOid_static;
oid7.octetLen = temp.octetLen;


/* ISO_EXPLAIN_RECORD - 1.0.10163.5.100  */
ASN_MakeOid(ISO_EXPLAIN_RECORD, &temp, env);
memcpy(isoexplainOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
isoexplainOid.octs = isoexplainOid_static;
isoexplainOid.octetLen = temp.octetLen;
oid8.octs = isoexplainOid_static;
oid8.octetLen = temp.octetLen;


/* Generic Record */
/* ISO_GENERIC_RECORD - 1.0.10163.5.105  */
ASN_MakeOid(ISO_GENERIC_RECORD, &temp, env);
memcpy(isogenericOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
isogenericOid.octs = isogenericOid_static;
isogenericOid.octetLen = temp.octetLen;
oid9.octs = isogenericOid_static;
oid9.octetLen = temp.octetLen;


/* Access Control Prompt-1 */
/* ISO_ACCESS_PROMPT_1 - 1.0.10163.8.1  */
ASN_MakeOid(ISO_ACCESS_PROMPT_1, &temp, env);
memcpy(isopromptobjOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
isopromptobjOid.octs = isopromptobjOid_static;
isopromptobjOid.octetLen = temp.octetLen;
oid10.octs = isopromptobjOid_static;
oid10.octetLen = temp.octetLen;



/* CharSetandLanguageNegotiation */
/* ISO_CHARSET_AND_LANGUAGE_NEGOTIATION - 1.0.10163.10.2  */
ASN_MakeOid(ISO_CHARSET_AND_LANGUAGE_NEGOTIATION, &temp, env);
memcpy(isocharsetandlanguagenegotiationOid_static, temp.octs, temp.octetLen);
Asn1Free(temp.octs);
isocharsetandlanguagenegotiationOid.octs = isocharsetandlanguagenegotiationOid_static;
isocharsetandlanguagenegotiationOid.octetLen = temp.octetLen;
oid11.octs = isocharsetandlanguagenegotiationOid_static;
oid11.octetLen = temp.octetLen;



} else {
        fprintf(stderr, "Fatal event: ASN_MakeOid failed for oid_overwrites_iso.c\n");
}
 


