/*  Module Name: @(#)originassoc.h	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
	Origin association handling functions Using TCP/OSI Services 

 
*/

#if !defined(ORIGINASSOC_H)
#define ORIGINASSOC_H

#include "z3950_includes.h"

#define DBV_OSI_NAME 3

/* Connect to a target using TCP communications */
int DBVTcpConnectToHost(char *host, ushort port, DbvFds *socketfd,
        DbvAssociateState *peAssociateState, DBVAssociateDetails 
	*psAssociateDetails, DbvError **psSIError);
 
int DBVTcpNonBlockingConnectToHost(DbvSecs lSeconds, char *host, ushort port,
	DbvFds *socketfd, DbvAssociateState *peAssociateState, 
	DBVAssociateDetails *psAssociateDetails, DbvError **psSIError);

#ifndef NO_OSI
/* Connect to a target using OSI communications */
int DBVOsiConnectToHost(DbvSecs lSeconds, DbvTargetInformation
	*psTargetInformation, DbvAssociateState *peAssociateStateLocal,
	DBVAssociateDetails *psAssociateDetails,
	DbvAssociateResult **ppuAssociateResult, DbvError **ppsError);

int DBVOsiCompleteConnectToHost(DbvAssocId lAssocId, DbvSecs lSeconds, 
	struct AcSAPconnect *psAssocControlConnect,
	struct AcSAPindication *psAssocControlIndication, DBVAssociateDetails 
	*psAssociateDetails, DbvError **ppsError);

int DBVConstructOSIAddress(char **ppcTargetName, DbvTargetInformation
        *psTargetInformation, DbvError **ppsError);

/* Fill out the DbvAssociateResult union according to whether the request
	was sucessful (DbvProtocolAndSyntaxes)/rejected (DbvAssociateReject) */
int DBVOsiCompleteDbvAssociateResult(struct AcSAPconnect *psAssocControlConnect,
	struct AcSAPabort *psAssocControlAbort, DbvAssociateResult 
	**ppuAssociateResult, DbvAssociateState *peAssociateState, 
	DbvError **ppsError);

/* Retrieve the desired application context name and presentation context
	list from the ACSE configuration file so we can sucessfully complete 
	and submit a AASSOCIATE-REQUEST service primitive */
int DBVGetACSEDetails(char **ppcContext, OID *ppsContextOID,
	struct PSAPctxlist **ppsPresentationContextList, DbvError **ppsError);

int DBVCompleteCommonSyntaxes(struct AcSAPconnect *psAssocControlConnect,
        DbvAssociateResult *puAssociateResult, int lAccepted, 
	DbvError **ppsError);
#endif /* NO_OSI */

/* Get a complete address from the name file and fill the DbvTarget structure */
int DBVGetAddressByName(DbvTarget *psTargetIdentification,
	DbvTargetInformation **ppsTargetInformation, DbvError **ppsError);

int DBVFillTcpAssociateResult(DbvAssociateResult **ppuAssociateResult,
        DbvError **ppsError);

/* Free the target information if malloc()'ed by the DbvAssociateRequest()
	function */
void DBVFreeTargetInformation(DbvTargetInformation *psTargetInformation);

#endif

