/*  Module Name: @(#)targetassoc.h	7.1
    Version: 11/15/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
	Target association handling functions using TCP/OSI Servicces
 
*/
 
#if !defined(TARGETASSOCTCP_H)
#define TARGETASSOCTCP_H

#include "z3950_includes.h"
#include "list_functions.h"

/* List of Associations */
extern SL DBVAssociateList;
extern char DBVErrorBuffer[];

#ifndef NO_OSI
extern struct AcSAPstart *DBVpsAssocControlStart;
#endif

/* ISODE header files */
#ifdef OID
/* There is a clash with an OID defined in snacc */
#       undef OID
#endif
 
/* API Function headers */

#ifndef NO_OSI
int DBVCheckApplicationContext(DbvApplicationProtocol *peApplicationProtocol, 
	OID sContext, DbvError **ppsError);
int DBVAcceptOrRejectPresentationContexts(DbvProtocolAndSyntaxes 
	*psProtocolAndSyntaxes, DbvApplicationProtocol eApplicationProtocol, 
	struct PSAPctxlist *psPresentationContextList, DbvError **ppsError);
void DBVRejectPresentationContexts(struct PSAPctxlist 
        *psPresentationContextList);

#endif

#endif
