/*  Module Name: @(#)z3950_globals.c	7.5
    Version: 12/6/96
    Author: John Hough/Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
*/

/* File containing the instances of all the global variables. 
   All globals have been seperated into this file so that shared libraries 
   can be created for certain platforms (e.g. Solaris 1) */


#define GLOBALS_INCLUDE
#include "z3950_includes.h"
#undef GLOBALS_INCLUDE


/* Global AsnOid definitions */

/* From z39_50_externals_a_1995.c */
char diag1Oid_static[50];
AsnOid diag1Oid = { 1, "\51" };


/* From z39_50_externals_b_1995.c */
char explainOid_static[50];
AsnOid explainOid = { 1, "\52" };
 

/* From z39_50_externals_d_1995.c */
char sutrsOid_static[50];
AsnOid sutrsOid = { 1, "\53" };

char opacOid_static[50];
AsnOid opacOid = { 1, "\54" };

char summaryOid_static[50];
AsnOid summaryOid = { 1, "\55" };

char genericOid_static[50];
AsnOid genericOid = { 1, "\56" };

char estaskOid_static[50];
AsnOid estaskOid = { 1, "\57" };


/* From z39_50_externals_e_1995.c */
char resrep1Oid_static[50];
AsnOid resrep1Oid = { 1, "\60" };

char resrep2Oid_static[50];
AsnOid resrep2Oid = { 1, "\61" };

char accprompt1Oid_static[50];
AsnOid accprompt1Oid = { 1, "\62" };

char accdes1Oid_static[50];
AsnOid accdes1Oid = { 1, "\63" };

char acckrb1Oid_static[50];
AsnOid acckrb1Oid = { 1, "\64" };


char esperresOid_static[50];
AsnOid esperresOid = { 1, "\65" };

/* From z39_50_externals_extra_1995.c */
AsnInt essilimtid = 799;


/* From z39_50_externals_f_1995.c */
char esperqueryOid_static[50];
AsnOid esperqueryOid = { 1, "\66" };

char esperqueryschedOid_static[50];
AsnOid esperqueryschedOid = { 1, "\67" };

char esformitemOid_static[50];
AsnOid esformitemOid = { 1, "\70" };

char esformupdateOid_static[50];
AsnOid esformupdateOid = { 1, "\71" };

char esformexpspecOid_static[50];
AsnOid esformexpspecOid = { 1, "\72" };

char esformexpinvoOid_static[50];
AsnOid esformexpinvoOid = { 1, "\73" };

char usersrch1Oid_static[50];
AsnOid usersrch1Oid = { 1, "\74" };

char espec1Oid_static[50];
AsnOid espec1Oid = { 1, "\75" };


/* From z39_50_externals_iso_1995.c */
char isosutrsOid_static[50];
AsnOid isosutrsOid = { 2, "\37777777601\26" };

char isoopacOid_static[50];
AsnOid isoopacOid = { 2, "\37777777601\27" };

char isosummaryOid_static[50];
AsnOid isosummaryOid = { 2, "\37777777601\30" };

char isoestaskOid_static[50];
AsnOid isoestaskOid = { 2, "\37777777601\31" };

char isoresrep1Oid_static[50];
AsnOid isoresrep1Oid = { 2, "\37777777601\32" };

char isoresrep2Oid_static[50];
AsnOid isoresrep2Oid = { 2, "\37777777601\33" };

char isoesformitemorderOid_static[50];
AsnOid isoesformitemorderOid = { 2, "\37777777601\34" };

char isoesformupdateOid_static[50];
AsnOid isoesformupdateOid = { 2, "\37777777601\35" };

char isoexplainOid_static[50];
AsnOid isoexplainOid = { 2, "\37777777601\36" };

char isogenericOid_static[50];
AsnOid isogenericOid = { 2, "\37777777601\37" };

char isopromptobjOid_static[50];
AsnOid isopromptobjOid = { 2, "\37777777601\40" };




char isocharsetandlanguagenegotiationOid_static[50];
AsnOid isocharsetandlanguagenegotiationOid = { 2, "\37777777601\41" };





/* From iso_10161_ill_1.c */
char isoillOid_static[50];
AsnOid isoillOid = { 2, "\37777777601\40" };


/* From iordext.c */
AsnInt subitoOid = 800;

/* From z39_50_externals_sil_1995.c */
char esprintOid_static[50];
AsnOid esprintOid = { 2, "\37777777601\15" };

char esalertOid_static[50];
AsnOid esalertOid = { 2, "\37777777601\16" };

char corderOid_static[50];
AsnOid corderOid = { 2, "\37777777601\17" };




/* From z39_50_externals_charset_1995.c */
char charsetandlanguagenegotiationOid_static[50];
AsnOid charsetandlanguagenegotiationOid = { 1, "\76" };








/* List of DBVTraceDetails */
char DBVTraceBuffer[128]; 
SL DBVTraceList = NULL;

SL DBVAssociateList = NULL;

/* Global buffer for holding error messages*/
char DBVErrorBuffer[SA_ARRAY_SIZE];

/* Holds the current ACSE configuration file name */
char DBVACSEFileName[128] = DBV_ACSE_FILE;

/* Used in the target to pass details from DbvTargetInitialise to 
	DbvReceiveAssociateRequest */
struct AcSAPstart *DBVpsAssocControlStart=NULL;

/***************************************************************/

/* singleASN1Type external counters */


/* Ansi */
int current_explain = 0;
int current_sutrs = 0;
int current_opac = 0;
int current_summary = 0;

int current_generic = 0;

int current_taskpack = 0;

int current_resrep1 = 0;
int current_resrep2 = 0;

int current_promptobj = 0;

int current_itemorder = 0;
int current_update = 0;

/* extra */
int current_silintmaptest = 0;


/* sil */
int current_print = 0;
int current_alert = 0;
int current_corder = 0;

int current_charsetandlang = 0;



/*-----------------------------*/
/* Iso */

int current_isosutrs = 0;
int current_isoopac = 0;
int current_isosummary = 0;
int current_isotaskpack = 0;
int current_isoresrep1 = 0;
int current_isoresrep2 = 0;
int current_isoitemorder = 0;
int current_isoupdate = 0;
int current_isoexplain = 0;

int current_isogeneric = 0;



/* iso_10161_ill_1.c */ 
int current_isoill = 0;

/* iordext.h */
int current_subito = 0;

int current_isopromptobj = 0;


int current_isocharsetandlang = 0;



/* ResourceControlResponse required */
DbvBool ResourceControlResponseRequired = DBV_FALSE;
