/*  Module Name: @(#)z3950_includes.h	7.3
    Version: 12/3/96
    Author: John Hough
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
 
*/

#ifndef z3950_includes_h
#define z3950_includes_h

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <sys/errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h>
#include <signal.h>
#include <setjmp.h>
#include <limits.h>
#include <sys/ioctl.h>
 

/* Essential DBV-OSI II includes containing structure definitions */
#include "sidefs.h"
#include "sitypes.h"
#include "sitypes2.h"
#include "dbvproto.h"
#include "iord_ext.h"
#include "itemordr.h"


#include "crxtypes.h"


#include "apiconfig.h"
#include "sil_defs.h"
#include "sl_list.h"
#include "str_hand.h"
#include "tbl.h"


#include "asn_incl.h"

/* typedef to include conflict with OID_SNACC redefinition below */
typedef OID_SNACC OID_SNACC_STRUCT;

#include "z39_50_apdu_1995.h"
#include "z39_50_apdu_1995_b.h"

#include "z39_50_externals_a_1995.h"

/* The following includes a #define of OID_SNACC different from the
typedef in asn_oid.h included by asn_incl.h, so redefining !! */
#include "z39_50_externals_b_1995.h"

#include "z39_50_externals_c_1995.h"
#include "z39_50_externals_d_1995.h"
#include "z39_50_externals_e_1995.h"
#include "z39_50_externals_f_1995.h"
#include "z39_50_externals_iso_1995.h"
#include "z39_50_externals_extra_1995.h"
#include "z39_50_externals_sil_1995.h"
#include "z39_50_externals_charset_1995.h"
#include "iso_10161_ill_1.h"
#include "iordext.h"
#include "defines.h"
#include "error.h"
#include "sl_list.h"
#include "list_functions.h"
#include "state_machine.h"
#include "origin-sm.h"
#include "target-sm.h"
#include "z3950_usmarc_formatter.h"

/* If ISODE is being used */
#ifndef NO_OSI
/* ISODE headers */
#include <ul/acsap.h>
#include <ul/psap.h>
#endif


/* System Error structures */
extern int errno, sys_nerr;
extern char *sys_errlist[];
 
#include "z3950_shared.h"
#include "z3950_otherinfo.h"
#include "z3950_externals.h"
#include "z3950_externals2.h"
#include "z3950_externals3.h"
#include "z3950_externals4.h"


/*********************************************/
 
/* If not being included by z3950_globals.c */
#ifndef GLOBALS_INCLUDE

extern char DBVTraceBuffer[];
extern SL DBVTraceList;

extern SL DBVAssociateList;
extern char DBVErrorBuffer[];
extern char DBVACSEFileName[];
 

/* Ansi */
extern int current_explain;
extern int current_sutrs;
extern int current_opac;
extern int current_summary;

extern int current_generic;

extern int current_taskpack;

extern int current_resrep1;
extern int current_resrep2;

extern int current_promptobj;

extern int current_itemorder;
extern int current_update;

extern int current_silintmaptest;


extern int current_print;
extern int current_alert;
extern int current_corder;

extern int current_charsetandlang;

 
/*-----------------------------*/
/* Iso */
extern int current_isosutrs;
extern int current_isoopac;
extern int current_isosummary;
extern int current_isotaskpack;
extern int current_isoresrep1;
extern int current_isoresrep2;
extern int current_isoitemorder;
extern int current_isoupdate;
extern int current_isoexplain;

extern int current_isogeneric;


/* iso_10161_ill_1.c */
extern int current_isoill;

/* iordext.h */
extern int current_subito;

extern int current_isopromptobj;


extern int current_isocharsetandlang;




/* ResourceControlResponse required */
extern DbvBool ResourceControlResponseRequired;

#endif 

#endif
