/*  Module Name: @(#)z3950_shared.h	7.6
    Version: 12/6/96
    Author: John Hough
    
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ

    Date of Issue:  

    QA Acceptance:  
    Date of Acceptance:  

    Description: Some DBV-OSI II Shared Routines 

*/

#ifndef z3950_shared_h
#define z3950_shared_h

#include "z3950_includes.h"


void DBVstring_to_up_case(char *input);
void DBVget_token_from_string(char *token_obtained, char *token_delimiter, char *string);
void DBVdbv_to_snacc_DbvOctetString(AsnOcts *snacc_asnocts, DbvOctetString *dbv_octet_string, jmp_buf env);
void DBVdbv_to_snacc_octet_string(AsnOcts *snacc_asnocts, DbvOctetString *dbv_octet_string, jmp_buf env);
int DBVsnacc_to_dbv_DbvOctetString(DbvOctetString *dbv_octet_string, AsnOcts *snacc_asnocts, jmp_buf env);
int DBVsnacc_to_dbv_octet_string(DbvOctetString *dbv_octet_string, AsnOcts *snacc_asnocts, jmp_buf env);
void DBVdbv_to_snacc_DbvInternationalString(InternationalString *snacc_interstr, DbvInternationalString *dbv_interstr, jmp_buf env);
void DBVdbv_to_snacc_inter_string(InternationalString *snacc_interstr, DbvInternationalString *dbv_interstr, jmp_buf env);
int DBVsnacc_to_dbv_DbvInternationalString(DbvInternationalString *dbv_interstr, InternationalString *snacc_interstr, jmp_buf env);
int DBVsnacc_to_dbv_inter_string(DbvInternationalString *dbv_interstr, InternationalString *snacc_interstr, jmp_buf env);
void DBVdbv_to_snacc_DbvVisibleString(VisibleString *snacc_visiblestr, DbvVisibleString dbv_visiblestr, jmp_buf env);
void DBVdbv_to_snacc_vis_string(VisibleString *snacc_visiblestr, DbvVisibleString dbv_visiblestr, jmp_buf env);
int DBVsnacc_to_dbv_DbvVisibleString(char **dbv_visiblestr, VisibleString *snacc_visiblestr, jmp_buf env);
int DBVsnacc_to_dbv_vis_string(char **dbv_visiblestr, VisibleString *snacc_visiblestr, jmp_buf env);
int DBVcheck_bit_string(char  *bit_string);
int DBVcheck_chosen_options(char  *bit_string);
int DBVdbv_to_snacc_el_set_names(struct ElementSetNames* simple, DbvElementSetNames *psElementSetNames, jmp_buf env);
int DBVdbv_to_snacc_el_generic(struct ElementSetNames* simple, DbvElementSetNames *psElementSetNames, jmp_buf env);
int DBVdbv_to_snacc_el_specific(struct ElementSetNames* simple, DbvElementSetNames *psElementSetNames, jmp_buf env);
int DBVdbv_to_snacc_records(struct Records* records, DbvRecords *psRecords, jmp_buf env);
int DBVdbv_to_snacc_resprec(RecordsSeqOf *responseRecords, DbvNamePlusRecord **ppsResponseRecord, jmp_buf env);
int DBVdbv_to_snacc_nameplusrec(NamePlusRecord *data_ptr, DbvNamePlusRecord *psResponseRecord, jmp_buf env);
int DBVdbv_to_snacc_diag_rec(struct DiagRec *surrogateDiagnostic, DbvDiagRec *psSurrogateDiagnostic, jmp_buf env);
int DBVdbv_to_snacc_defaultformat(struct DefaultDiagFormat* defaultFormat, DbvDefaultDiagFormat *psDefault, jmp_buf env);
int DBVdbv_to_snacc_addinfo(struct DefaultDiagFormatChoice* addinfo, DbvAdditionalInfo sAdditionalInfo, jmp_buf env);
int DBVdbv_to_snacc_fragsyntax(struct FragmentSyntax *snaccfragment, DbvFragmentSyntax *dbvfragment, jmp_buf env);
int DBVdbv_to_snacc_multdiag(RecordsSeqOf1 *multipleNonSurDiagnostics, DbvDiagRec **ppsMultipleNonSurrogateDiag, jmp_buf env);
int DBVsnacc_to_dbv_records(DbvRecords *psRecords, struct Records* records, jmp_buf env);
int DBVsnacc_to_dbv_resprec(DbvNamePlusRecord **ppsResponseRecord, RecordsSeqOf *responseRecords, jmp_buf env);
int DBVsnacc_to_dbv_nameplusrec(DbvNamePlusRecord *psResponseRecord, NamePlusRecord *data_ptr, jmp_buf env);
int DBVsnacc_to_dbv_diag_rec(DbvDiagRec *psSurrogateDiagnostic, struct DiagRec *surrogateDiagnostic, jmp_buf env);
int DBVsnacc_to_dbv_defaultformat(DbvDefaultDiagFormat *psDefault, struct DefaultDiagFormat* defaultFormat, jmp_buf env);
int DBVsnacc_to_dbv_addinfo(DbvAdditionalInfo *psAdditionalInfo, struct DefaultDiagFormatChoice* addinfo, jmp_buf env);
int DBVsnacc_to_dbv_fragsyntax(DbvFragmentSyntax *dbvfragment, struct FragmentSyntax* snaccfragment, jmp_buf env);
int DBVsnacc_to_dbv_multdiag(DbvDiagRec **ppsMultipleNonSurrogateDiag, RecordsSeqOf1 *multipleNonSurDiagnostics, jmp_buf env);
int DBVcheck_dbv_enum(unsigned long field, unsigned long bottom_val, unsigned long top_val);
int DBVdbv_field_missing_error(DbvAssocId lAssocId, char *field_in_error, DbvError **ppsSIError);
int DBVsingle_field_error(DbvAssocId lAssocId, char *field_in_error, DbvError **ppsSIError, int error_code, char *error_diag);
int DBVdbv_bit_string_error(DbvAssocId lAssocId, char *field_in_error, char *value, DbvError **ppsSIError);
int DBVtwo_field_error(DbvAssocId lAssocId, char *field1, char *field2, DbvError **ppsSIError, int error_code, char *error_diag);
int DBVdbv_options_chosen_error(DbvAssocId lAssocId, char *field_in_error, char *value, DbvError **ppsSIError);
int DBVdbv_invalid_enum_error(DbvAssocId lAssocId, char *field_in_error, DbvError **ppsSIError);
int DBVdbv_bool_error(DbvAssocId lAssocId, char *field_in_error, DbvError **ppsSIError);
int DBVdbv_oid_error(DbvAssocId lAssocId, char *field_in_error, DbvError **ppsSIError);
int DBVdbv_external_oid_error(DbvAssocId lAssocId, char *oid, char *field_in_error, DbvError **ppsSIError);
int DBVdbv_general_error(DbvAssocId lAssocId, char *field_in_error, DbvError **ppsSIError);
int DBVcheck_DbvBool_opt(DbvAssocId lAssocId, DbvBool *pfIncreasing, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvBool(DbvAssocId lAssocId, DbvBool *pfIncreasing, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_bool(DbvBool boolval);
int DBVcheck_dbv_recsyn(char *oid);
int DBVcheck_dbv_allowed_external(char *oid);
int DBVcheck_dbv_attsetoid(char *oid);
int DBVcheck_dbv_diagsetoid(char *oid);
int DBVcheck_dbv_resrepoid(char *oid);
int DBVcheck_dbv_updateoid(char *oid);
int DBVcheck_dbv_validoid(char *oid);
int DBVcheck_dbspecific(DbvAssocId lAssocId, DbvElementSetsDbSpecific **ppsElementSetsDbSpecific, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_records(DbvAssocId lAssocId, DbvRecords *psRecords, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_response_rec(DbvAssocId lAssocId, DbvNamePlusRecord **ppsResponseRecord, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_nameplusrec(DbvAssocId lAssocId, DbvNamePlusRecord *psResponseRecord, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_surrdiag(DbvAssocId lAssocId, DbvDiagRec *psSurrogateDiagnostic, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_default(DbvAssocId lAssocId, DbvDefaultDiagFormat *psDefault, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_fragment(DbvAssocId lAssocId, DbvFragmentSyntax *psFragment, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_multdiag(DbvAssocId lAssocId, DbvDiagRec **ppsMultipleNonSurrogateDiag, char *error_buffer, DbvError **ppsSIError);
int DBVdbv_to_snacc_strornum(StringOrNumeric *data_ptr, DbvStringOrNumeric *psAttributeElement, jmp_buf env);
int DBVdbv_to_snacc_intunit(struct IntUnit* integerAndUnit, DbvIntUnit *psIntegerAndUnit, jmp_buf env);
int DBVdbv_to_snacc_unit(struct Unit* unitUsed, DbvUnit *psUnitUsed, jmp_buf env);
int DBVsnacc_to_dbv_strornum(DbvStringOrNumeric *psList, StringOrNumeric *data_ptr, jmp_buf env);
int DBVsnacc_to_dbv_intunit(DbvIntUnit *psIntegerAndUnit, struct IntUnit* integerAndUnit, jmp_buf env);
int DBVsnacc_to_dbv_unit(DbvUnit *psUnitUsed, struct Unit* unitUsed, jmp_buf env);
int DBVdbv_to_snacc_attrterm(struct AttributesPlusTerm* attrTerm, DbvAttributesPlusTerm *psAttributesPlusTerm, jmp_buf env);
int DBVdbv_to_snacc_attribute_list(AttributeList* attributes, DbvAttributeElement **ppsAttributeElement, jmp_buf env);
int DBVdbv_to_snacc_attributes(AttributeElement *data_ptr, DbvAttributeElement *psAttributeElement, jmp_buf env);
int DBVdbv_to_snacc_attval(struct AttributeElementChoice* attributeValue, DbvAttributeValue sAttributeValue, jmp_buf env);
int DBVdbv_to_snacc_attcomplex(struct AttributeElementChoiceSeq* complex, DbvComplexValue *psComplexValue, jmp_buf env);
int DBVdbv_to_snacc_attcomplist(AttributeElementChoiceSeqSeqOf* list, DbvStringOrNumeric **ppsList, jmp_buf env);
int DBVdbv_to_snacc_attcompsem(AttributeElementChoiceSeqSeqOf1* semanticAction, Ulong **ppulSemanticAction, jmp_buf env);
int DBVdbv_to_snacc_term(struct Term* term, DbvTerm *psTerm, jmp_buf env);
int DBVsnacc_to_dbv_attrterm(DbvAttributesPlusTerm *psAttributesPlusTerm, struct AttributesPlusTerm* attrTerm, jmp_buf env);
int DBVsnacc_to_dbv_attributes(DbvAttributeElement *psAttributeElement, AttributeElement *data_ptr, jmp_buf env);
int DBVsnacc_to_dbv_attvalue(DbvAttributeValue *psAttributeValue, struct AttributeElementChoice* attributeValue, jmp_buf env);
int DBVsnacc_to_dbv_complex(DbvComplexValue *psComplexValue, struct AttributeElementChoiceSeq* complex, jmp_buf env);
int DBVsnacc_to_dbv_DbvStringOrNumeric_list(DbvStringOrNumeric **ppsList, AttributeElementChoiceSeqSeqOf* list, jmp_buf env);
int DBVsnacc_to_dbv_semantic(Ulong **ppulSemanticAction, AttributeElementChoiceSeqSeqOf1* semanticAction, jmp_buf env);
int DBVsnacc_to_dbv_term(DbvTerm *psTerm, struct Term* term, jmp_buf env);
int DBVsnacc_to_dbv_attribute_list(DbvAttributeElement **ppsAttributeElement, AttributeList *attributes, jmp_buf env);
int DBVdbv_to_snacc_specification(struct Specification* generic, DbvSpecification *psGeneric, jmp_buf env);
void DBVdbv_to_snacc_DbvElementSpec_opt(struct SpecificationChoice** elementSpec, DbvElementSpec *psElementSpec, jmp_buf env);
void DBVdbv_to_snacc_DbvElementSpec(struct SpecificationChoice* elementSpec, DbvElementSpec *psElementSpec, jmp_buf env);
int DBVsnacc_to_dbv_specification(DbvSpecification *psGeneric, struct Specification* generic, jmp_buf env);
void DBVsnacc_to_dbv_DbvElementSpec_opt(DbvElementSpec **ppsElementSpec, struct SpecificationChoice* elementSpec, jmp_buf env);
void DBVsnacc_to_dbv_DbvElementSpec(DbvElementSpec *psElementSpec, struct SpecificationChoice* elementSpec, jmp_buf env);
char *DBVgobble_up_memory();
int DBVcheck_dbv_attsplusterm(DbvAssocId lAssocId, DbvAttributesPlusTerm *psAttributesPlusTerm, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_attelement(DbvAssocId lAssocId, DbvAttributeElement *psAttributeElement, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_attval(DbvAssocId lAssocId, DbvAttributeValue *psAttributeValue, char *error_buffer, DbvError **ppsSIError);  
int DBVcheck_dbv_complexval(DbvAssocId lAssocId, DbvComplexValue *psComplexValue, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvStringOrNumeric_opt(DbvAssocId lAssocId, DbvStringOrNumeric *psDefaultValue, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvStringOrNumeric(DbvAssocId lAssocId, DbvStringOrNumeric *psList, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_term(DbvAssocId lAssocId, DbvTerm *psTerm, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvIntUnit(DbvAssocId lAssocId, DbvIntUnit *psIntegerAndUnit, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvUnit(DbvAssocId lAssocId, DbvUnit *psUnitUsed, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvSpecification(DbvAssocId lAssocId, DbvSpecification *psGeneric, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvElementSpec_opt(DbvAssocId lAssocId, DbvElementSpec *psElementSpec, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvElementSpec(DbvAssocId lAssocId, DbvElementSpec *psElementSpec, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_dbv_allowfuncs(DbvAssocId lAssocId, DbvPermAllowableFunctions **ppeAllowableFunctions, char *error_buffer, DbvError **ppsSIError);
int DBVsa_clear_array(char *array);
int DBVsa_strcat(char *dest, char *src);
int DBVsa_strcpy(char *dest, char *src);
int DBVcheck_oidformat(char *oid);
int DBVcheck_if_number(char *strtok_ptr);
int DBVsnacc_to_dbv_presstat(DbvPresentStatus *ePresentStatus, PresentStatus presentStatus);
int DBVdbv_to_snacc_presstat(PresentStatus *presentStatus, DbvPresentStatus ePresentStatus);
int DBVdbv_to_snacc_bool(AsnBool *snacc_bool, DbvBool *dbv_bool, jmp_buf env);
int DBVdbv_to_snacc_bool_opt(AsnBool **snacc_bool, DbvBool *dbv_bool, jmp_buf env);
int DBVsnacc_to_dbv_bool(DbvBool *dbv_bool, AsnBool *snacc_bool, jmp_buf env);
int DBVsnacc_to_dbv_bool_opt(DbvBool **dbv_bool, AsnBool *snacc_bool, jmp_buf env);
int DBVdbv_to_snacc_int_opt(AsnInt **maxResultSets, Ulong *pulMaxResultSets, jmp_buf env);
int DBVdbv_to_snacc_intunit_opt(struct IntUnit** timeoutInterval, DbvIntUnit *psTimeoutInterval, jmp_buf env);
int DBVdbv_to_snacc_interstring_list(TargetInfoSeqOf *nicknames, DbvInternationalString **ppsNicknames, jmp_buf env);
int DBVdbv_to_snacc_interstring_list_opt(TargetInfoSeqOf **nicknames, DbvInternationalString **ppsNicknames, jmp_buf env);
int DBVdbv_to_snacc_gentime_opt(GeneralizedTime *dateAdded, DbvGeneralizedTime pcDateAdded, jmp_buf env);
int DBVdbv_to_snacc_gentime(GeneralizedTime *dateAdded, DbvGeneralizedTime pcDateAdded, jmp_buf env);
int DBVdbv_to_snacc_otherinfo_opt(OtherInformation **otherInfo, DbvOtherInformation **ppsOtherInformation, jmp_buf env);
void DBVdbv_to_snacc_DbvInternationalString_comp(InternationalString **ianaType, DbvInternationalString *psIanaType, jmp_buf env);
int DBVdbv_to_snacc_interstring_comp(InternationalString **ianaType, DbvInternationalString *psIanaType, jmp_buf env);
void DBVdbv_to_snacc_DbvObjectIdentifier_opt(AsnOid *tagSet, DbvObjectIdentifier pcTagSet, jmp_buf env);
int DBVdbv_to_snacc_objectident_opt(AsnOid *tagSet, DbvObjectIdentifier pcTagSet, jmp_buf env);
void DBVdbv_to_snacc_DbvObjectIdentifier_comp(AsnOid **tagSet, DbvObjectIdentifier pcTagSet, jmp_buf env);
int DBVdbv_to_snacc_objectident_comp(AsnOid **tagSet, DbvObjectIdentifier pcTagSet, jmp_buf env);
void DBVdbv_to_snacc_DbvObjectIdentifier(AsnOid *tagSet, DbvObjectIdentifier pcTagSet, jmp_buf env);
int DBVdbv_to_snacc_objectident(AsnOid *tagSet, DbvObjectIdentifier pcTagSet, jmp_buf env);
int DBVdbv_to_snacc_strornum_comp(struct StringOrNumeric** tagValue, DbvStringOrNumeric *psTagValue, jmp_buf env);
int DBVdbv_to_snacc_strornum_opt(struct StringOrNumeric** tagValue, DbvStringOrNumeric *psTagValue, jmp_buf env);
int DBVdbv_to_snacc_octetstring_comp(AsnOcts **octets, DbvOctetString *psOctets, jmp_buf env);
int DBVsnacc_to_dbv_int_opt(Ulong **ppulMaxResultSets, AsnInt *maxResultSets, jmp_buf env);
int DBVsnacc_to_dbv_intunit_opt(DbvIntUnit **ppsTimeoutInterval, struct IntUnit *timeoutInterval, jmp_buf env);
int DBVsnacc_to_dbv_gentime_opt(DbvGeneralizedTime *ppcDateAdded, GeneralizedTime dateAdded, jmp_buf env);
int DBVsnacc_to_dbv_otherinfo_opt(DbvOtherInformation ***pppsOtherInformation, OtherInformation *otherInfo, jmp_buf env);
int DBVsnacc_to_dbv_interstring_comp(DbvInternationalString **ppsIanaType, InternationalString *ianaType, jmp_buf env);
int DBVsnacc_to_dbv_interstring_opt(DbvInternationalString **ppsName, InternationalString *name, jmp_buf env);
int DBVsnacc_to_dbv_interstring_list_opt(DbvInternationalString ***ppsNicknames, TargetInfoSeqOf *nicknames, jmp_buf env);
int DBVsnacc_to_dbv_inter_list(DbvInternationalString **ppsNicknames, TargetInfoSeqOf *nicknames, jmp_buf env);
int DBVsnacc_to_dbv_ulong_list_opt(Ulong ***pppulOperators, RpnCapabilitiesSeqOf *operators, jmp_buf env);
int DBVsnacc_to_dbv_exp_ullist(Ulong **ppulOperators, RpnCapabilitiesSeqOf *operators, jmp_buf env);
int DBVsnacc_to_dbv_elset_name(DbvElementSetNames *psElementSetNames, struct ElementSetNames* simple, jmp_buf env);
int DBVsnacc_to_dbv_el_generic(DbvElementSetNames *psElementSetNames, struct ElementSetNames* simple, jmp_buf env);
int DBVsnacc_to_dbv_el_specific(DbvElementSetNames *psElementSetNames, struct ElementSetNames* simple, jmp_buf env);
int DBVsnacc_to_dbv_DbvObjectIdentifier_comp(DbvObjectIdentifier *ppcSchema, AsnOid *schema, jmp_buf env);
int DBVsnacc_to_dbv_objectident_comp(DbvObjectIdentifier *ppcSchema, AsnOid *schema, jmp_buf env);
int DBVsnacc_to_dbv_DbvObjectIdentifier_opt(DbvObjectIdentifier *ppcSchema, AsnOid *schema, jmp_buf env);
int DBVsnacc_to_dbv_objectident_opt(DbvObjectIdentifier *ppcSchema, AsnOid *schema, jmp_buf env);
int DBVsnacc_to_dbv_nullpointer_opt(DbvNull *ppvDefaultTagType, AsnNull *defaultTagType, jmp_buf env);
int DBVsnacc_to_dbv_strornum_opt(DbvStringOrNumeric **ppsDefaultValue, struct StringOrNumeric *defaultValue, jmp_buf env);
int DBVsnacc_to_dbv_octetstring_comp(DbvOctetString **ppsOctets, AsnOcts *octets, jmp_buf env);
int DBVcheck_DbvOtherInformation_opt(DbvAssocId lAssocId, DbvOtherInformation **ppsOtherInformation, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvIntUnit_opt(DbvAssocId lAssocId, DbvIntUnit *psTimeoutInterval, 
char *error_buffer, DbvError **ppsSIError); 
int DBVcheck_DbvUnit_opt(DbvAssocId lAssocId, DbvUnit *psUnitUsed, char *error_buffer, DbvError **ppsSIError);
int DBVsnacc_to_dbv_DbvOctetString_opt(DbvOctetString **ppsReferenceId, AsnOcts 
*referenceId, jmp_buf env);
int DBVdbv_to_snacc_DbvOctetString_opt(AsnOcts *referenceId, DbvOctetString *psReferenceId, jmp_buf env);
int DBVdbv_to_snacc_DbvBool_opt(AsnBool **resultSetWanted, DbvBool *pfResultSetWanted, jmp_buf env);
int DBVsnacc_to_dbv_DbvBool_opt(DbvBool **ppfSuspendedFlag, AsnBool* suspendedFlag, jmp_buf env);
int DBVdbv_to_snacc_DbvDiagRec_opt(DiagRec** diagnostic, DbvDiagRec *psDiagnostic, jmp_buf env);
void DBVdbv_to_snacc_DbvDiagRec_comp(struct DiagRec** diagnostic, DbvDiagRec *psDiagnostic, jmp_buf env);
void DBVsnacc_to_dbv_DbvDiagRec_opt(DbvDiagRec **ppsDiagnostic, DiagRec *diagnostic, jmp_buf env);
void DBVsnacc_to_dbv_DbvDiagRec_comp(DbvDiagRec **ppsDiagnostic, struct DiagRec *diagnostic, jmp_buf env);
int DBVcheck_list_opt(DbvAssocId lAssocId, void **listptr, char *error_buffer, char *list_name, DbvError **ppsSIError, int (*func) (DbvAssocId, void *, char *, DbvError **));
int DBVcheck_list(DbvAssocId lAssocId, void **listptr, char *error_buffer, char *list_name, DbvError **ppsSIError, DbvBool fSubstr, int (*func) (DbvAssocId, void *, char *, DbvError **));
int DBVcheck_list_opt_nosub(DbvAssocId lAssocId, void **listptr, char *error_buffer, char *list_name, DbvError **ppsSIError, int (*func) (DbvAssocId, void *, char *, DbvError **));
int DBVcheck_DbvObjectIdentifier_opt(DbvAssocId lAssocId, DbvObjectIdentifier pcPreferredResourceReportFormat, char *error_buffer, DbvError **ppsSIError);
Bool_	TBL_GetRecordDbv(TBL Table, DbvError **ppsError);
void DBVFree(void *psItemToFree);
void *DBVAlloc(size_t sBytes, DbvError **ppsError);
int DBVAllocCheck(void *pStructure);
void DBVdbv_to_snacc_DbvRecordComposition(struct PresentRequestChoice* recordComposition, DbvRecordComposition *psRecordComposition, jmp_buf env);
int DBVdbv_to_snacc_DbvCompSpec(struct CompSpec* complex, DbvCompSpec *psCompSpec, jmp_buf env);
int DBVdbv_to_snacc_DbvDbSpecificComp_list(CompSpecSeqOf *dbSpecific, DbvDbSpecificComp **ppsDbSpecific, jmp_buf env);
int DBVdbv_to_snacc_DbvObjectIdentifier_list(CompSpecSeqOf1* recordSyntax,  DbvObjectIdentifier *ppcRecordSyntax, jmp_buf env);
void DBVsnacc_to_dbv_DbvRecordComposition(DbvRecordComposition *psRecordComposition, struct PresentRequestChoice* recordComposition, jmp_buf env);
int DBVsnacc_to_dbv_DbvCompSpec(DbvCompSpec *psCompSpec, struct CompSpec* complexy, jmp_buf env);
int DBVsnacc_to_dbv_DbvDbSpecificComp(DbvDbSpecificComp **ppsDbSpecific, CompSpecSeqOf *dbSpecific, jmp_buf env);
void DBVsnacc_to_dbv_DbvObjectIdentifier_list_comp(DbvObjectIdentifier **pppcRecordSyntax, CompSpecSeqOf1* recordSyntax, jmp_buf env);
void DBVsnacc_to_dbv_DbvObjectIdentifier_list_opt(DbvObjectIdentifier **pppcRecordSyntax, CompSpecSeqOf1* recordSyntax, jmp_buf env);
int DBVsnacc_to_dbv_DbvObjectIdentifier_list(DbvObjectIdentifier *ppcRecordSyntax, CompSpecSeqOf1* recordSyntax, jmp_buf env);
int DBVsnacc_to_dbv_objectident_list_opt(DbvObjectIdentifier **pppcDiagnosticsSets, AccessInfoSeqOf1 *diagnosticsSets, jmp_buf env);
int DBVcheck_DbvRecordComposition_opt(DbvAssocId lAssocId, DbvRecordComposition *psRecordComposition, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvRecordComposition(DbvAssocId lAssocId, DbvRecordComposition *psRecordComposition, char *error_buffer, DbvError **ppsSIError); 
int DBVcheck_DbvElementSetNames(DbvAssocId lAssocId, DbvElementSetNames *psElementSetNames, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvCompSpec(DbvAssocId lAssocId, DbvCompSpec *psCompSpec, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvDbSpecificComp(DbvAssocId lAssocId, DbvDbSpecificComp **ppsDbSpecific, char *error_buffer, DbvError **ppsSIError);
int DBVcheck_DbvObjectIdentifier_list(DbvAssocId lAssocId, DbvObjectIdentifier *ppcRecordSyntax, char *error_buffer, DbvError **ppsSIError);
void DBVdbv_to_snacc_Ulong(AsnInt* proposedSets, Ulong *pulProposedSets, jmp_buf env);
void DBVsnacc_to_dbv_Ulong(Ulong *pulProposedSets, AsnInt* proposedSets, jmp_buf env);
void DBVdbv_to_snacc_DbvGeneralString_opt(GeneralString *selectedLanguage, DbvGeneralString *psSelectedLanguage, jmp_buf env);
void DBVsnacc_to_dbv_DbvGeneralString_opt(DbvGeneralString** psSelectedLanguage, GeneralString *selectedLanguage, jmp_buf env);


#endif
