/* -----------  dbvproto.h -------------------------------------------*/

/* When using this file with other DBV-OSI II includes, include as follows

#include "sidefs.h"
#include "sitypes.h"
#include "sitypes2.h"
#include "dbvproto.h"
#include "iord_ext.h"
#include "itemordr.h"
*/

/*
#include "crxtypes.h"
*/






/*  Module Name: @(#)dbvproto.h	7.3
    Version: 1/15/97
    Author: John Hough/Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:
 
    QA Acceptance:
    Date of Acceptance:
 
    Description: DBV-OSI II API Function Prototypes 
		 and useful #defines
                 
*/

#ifndef dbv_proto_h
#define dbv_proto_h

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>



/**********************************************
	Origin Function Prototypes
 ***********************************************/

/* Association Handling Function Prototypes */

/* __cplusplus is a directive automatically defined if using GNU c++ */
#ifdef __cplusplus 
extern "C" {
#endif

int DbvAssociateRequest( DbvAssocId *plAssocId, 
			 DbvSecs lSeconds,
			 DbvTarget *psTargetIdentification,
			 DbvAssociateState *peAssociateState,
			 DbvAssociateResult **ppuAssociateResult,
			 DbvError **ppsDbvError );



int DbvReleaseRequest( DbvAssocId lAssocId, 
		       DbvSecs lSeconds,
		       DbvReleaseState *peAReleaseState,
		       DbvError **ppsDbvError );



int DbvAbortRequest(	DbvAssocId lAssocId, 
		     	DbvError **ppsDbvError );



int DbvConfirmAssociateRequest(	DbvAssocId lAssocId, 
				DbvSecs lSeconds,
				DbvAssociateState *peAssociateState,
				DbvAssociateResult **ppuAssociateResult,
				DbvError **ppsDbvError );



int DbvConfirmReleaseRequest( DbvAssocId lAssocId, 
			      DbvSecs lSeconds,
			      DbvReleaseState *peAReleaseState,
			      DbvError **ppsDbvError );



/* SR-/Z39.50 Function Prototypes */

int DbvInitializeRequest( DbvAssocId lAssocId, 
			  DbvInitializeReq *psInitializeReq, 
			  DbvError **ppsDbvError );



int DbvSearchRequest( DbvAssocId lAssocId, 
		      DbvSearchReq *psSearchReq, 
		      DbvError **ppsDbvError );



int DbvPresentRequest( DbvAssocId lAssocId, 
		       DbvPresentReq *psPresentReq, 
		       DbvError **ppsDbvError );



int DbvDeleteResultSetRequest( DbvAssocId lAssocId, 
			       DbvDeleteResultSetReq *psDeleteResultSetReq, 
			       DbvError **ppsDbvError );



int DbvScanRequest( DbvAssocId lAssocId, 
		    DbvScanReq *psScanReq, 
		    DbvError **ppsDbvError );



int DbvResourceReportRequest( DbvAssocId lAssocId, 
			      DbvResourceReportReq *psResourceReportReq, 
			      DbvError **ppsDbvError );



/* A SegmentRequest PDU is sent from target to origin, there is no
   SegmentResponse PDU */

int DbvSortRequest( DbvAssocId lAssocId, 
		    DbvSortReq *psSortReq, 
		    DbvError **ppsDbvError );



int DbvExtendedServicesRequest( DbvAssocId lAssocId, 
			        DbvExtendedServicesReq *psExtendedServicesReq, 
			        DbvError **ppsDbvError );
 



/* DbvCloseRequest and DbvCloseResponse should be used by both origin and target */

int DbvCloseRequest( DbvAssocId lAssocId, 
		     DbvCloseReq *psCloseReq, 
		     DbvError **ppsDbvError );



int DbvCloseResponse( DbvAssocId lAssocId, 
		     DbvCloseReq *psCloseReq, 
		     DbvError **ppsDbvError );



int DbvReceiveDataOrigin( DbvAssocId lAssocId, 
			  DbvSecs ISeconds,
		 	  DbvOriginData **ppsOriginData, 
			  DbvError **ppsDbvError );




int DbvAccessControlResponse(	DbvAssocId lAssocId, 			
				DbvAccessControlRsp *psAccessControlRsp, 					DbvError **ppsSIError);


int DbvResourceControlResponse(	DbvAssocId lAssocId, 
				DbvResourceControlRsp *psResourceControlRsp, 
				DbvError **ppsSIError);


int DbvTriggerResourceControlRequest(	DbvAssocId lAssocId, 
					DbvTriggerResourceControlReq *psTriggerResourceControlReq, 
					DbvError **ppsSIError);



/**********************************************
	Target Function Prototypes
 ***********************************************/
/* Association Handling Function Prototypes */

int DbvTargetInitialize( int argc, 
			 char **argv, 
			 DbvError **ppsError );



int DbvReceiveAssociateRequest( DbvAssocId *plAssocId, 
				DbvSecs lSeconds,
				char **ppcOriginAddress,
				DbvProtocolAndSyntaxes **ppsProtocolAndSyntaxes,
				DbvError **ppsDbvError );



int DbvAssociateResponse( DbvAssocId lAssocId, 
			  DbvAssociateRsp eAssociateRsp,
                          DbvError **ppsDbvError );



int DbvReleaseResponse( DbvAssocId lAssocId, 
			DbvReleaseRsp *psAReleaseRsp,
                        DbvError **ppsDbvError );



/* The origin and target share the same DbvAbortRequest() function */



/* SR-/Z39.50 Function Prototypes */

int DbvInitializeResponse( DbvAssocId lAssocId, 
		           DbvInitializeRsp *psInitializeRsp, 
		           DbvError **ppsDbvError );



int DbvSearchResponse( DbvAssocId lAssocId, 
		       DbvSearchRsp *psSearchRsp, 
		       DbvError **ppsDbvError );



int DbvPresentResponse( DbvAssocId lAssocId, 
		        DbvPresentRsp *psPresentRsp, 
		        DbvError **ppsDbvError );



int DbvDeleteResultSetResponse( DbvAssocId lAssocId, 
				DbvDeleteResultSetRsp *psDeleteResultSetRsp, 
				DbvError **ppsDbvError );



int DbvScanResponse( DbvAssocId lAssocId, 
		     DbvScanRsp *psScanRsp, 
		     DbvError **ppsDbvError );



int DbvResourceReportResponse( DbvAssocId lAssocId, 
			       DbvResourceReportRsp *psResourceReportRsp, 
			       DbvError **ppsDbvError );



/* A SegmentRequest is sent from target to origin, there is no
   SegmentResponse  */

int DbvSegmentRequest( DbvAssocId lAssocId, 
		       DbvSegmentReq *psSegmentReq, 
		       DbvError **ppsDbvError );



int DbvSortResponse( DbvAssocId lAssocId, 
	             DbvSortRsp *psSortRsp, 
	             DbvError **ppsDbvError );



int DbvExtendedServicesResponse( DbvAssocId lAssocId, 
				 DbvExtendedServicesRsp *psExtendedServicesRsp, 
				 DbvError **ppsDbvError );



/* DbvCloseRequest (declared above) should be shared by origin and target */

int DbvReceiveDataTarget( DbvAssocId lAssocId, 
			  DbvSecs ISeconds, 
			  DbvTargetData **ppsTargetData, 
		          DbvError **ppsDbvError );



int DbvAccessControlRequest(	DbvAssocId lAssocId, 
				DbvAccessControlReq *psAccessControlReq, 
				DbvError **ppsSIError);


int DbvResourceControlRequest(	DbvAssocId lAssocId, 
				DbvResourceControlReq *psResourceControlReq, 
				DbvError **ppsSIError);







/**********************************************
	Shared Origin/Target Function Prototypes
 ***********************************************/

/* Utility Function Prototypes */

 
int SIGetEventLocation( DbvAssocId **pplAssocId, 
			DbvSecs lSeconds,
			DbvFds **ppulFileDescriptor,
			DbvEventLocation **ppsEventLocation, 
			DbvError **ppsDbvError );



int SIWhichStack( DbvAssocId lAssocId, 
		  DbvProtocolStack *peProtocolStack,
		  DbvError **ppsDbvError );



int SISetTraceParameter( DbvAssocId lAssocId, 
			 FILE *psTraceFp,
			 DbvTraceLevel eTraceLevel, 
			 DbvError **ppsDbvError );



int SISetACSEFile( char *pcACSEFile, 
		   DbvError **ppsError );




/* Origin end freeing function for structure returned by 
   DbvReceiveDataOrigin() */
int SIFreeDbvOriginData( DbvOriginData **ppsOriginData );

/* Target end freeing function for structure returned by 
   DbvReceiveDataTarget() */
int SIFreeDbvTargetData( DbvTargetData **ppsTargetData );

/* Origin end freeing functions for PDUs sent to a target */
int SIFreeDbvInitializeReq( DbvInitializeReq **ppsInitializeReq );
int SIFreeDbvSearchReq( DbvSearchReq **ppsSearchReq );
int SIFreeDbvPresentReq( DbvPresentReq **ppsPresentReq );
int SIFreeDbvDeleteResultSetReq( DbvDeleteResultSetReq **ppsDeleteResultSetReq );
int SIFreeDbvScanReq( DbvScanReq **ppsScanReq );
int SIFreeDbvResourceReportReq( DbvResourceReportReq **ppsResourceReportReq );
int SIFreeDbvSortReq( DbvSortReq **ppsSortReq );
int SIFreeDbvExtendedServicesReq( DbvExtendedServicesReq **ppsExtendedServicesReq );
int SIFreeDbvCloseReq( DbvCloseReq **ppsCloseReq );
int SIFreeDbvOctetString( DbvOctetString **ppsOctetString );
int SIFreeDbvAccessControlRsp( DbvAccessControlRsp **ppsAccessControlRsp );
int SIFreeDbvResourceControlRsp( DbvResourceControlRsp **ppsResourceControlRsp );
int SIFreeDbvTriggerResourceControlReq( DbvTriggerResourceControlReq **ppsTriggerResourceControlReq );


/* Target end freeing functions for PDUs sent to an origin */
int SIFreeDbvInitializeRsp( DbvInitializeRsp **ppsInitializeRsp );
int SIFreeDbvSearchRsp( DbvSearchRsp **ppsSearchRsp );
int SIFreeDbvPresentRsp( DbvPresentRsp **ppsPresentRsp );
int SIFreeDbvDeleteResultSetRsp( DbvDeleteResultSetRsp **ppsDeleteResultSetRsp );
int SIFreeDbvScanRsp( DbvScanRsp **ppsScanRsp );
int SIFreeDbvResourceReportRsp( DbvResourceReportRsp **ppsResourceReportRsp );
int SIFreeDbvSegmentReq( DbvSegmentReq **ppsSegmentReq );
int SIFreeDbvSortRsp( DbvSortRsp **ppsSortRsp );
int SIFreeDbvExtendedServicesRsp( DbvExtendedServicesRsp **ppsExtendedServicesRsp );
int SIFreeDbvAccessControlReq( DbvAccessControlReq **ppsAccessControlReq );
int SIFreeDbvResourceControlReq( DbvResourceControlReq **ppsResourceControlReq );







/* Error codes returned in lAbortReason of the SIAbort structure */

/* Association Calls */
#define DBV_ABORT		0 	/* The association was aborted by the
					peer */
#define DBV_ABORT_S		"The Association has been aborted"

#define DBV_INTERRUPT           1       /* An action was interrupted by a
                                        signal from the system (e.g. TCP read/
                                        write/select EINTR signal)*/
#define DBV_INTERRUPT_S         "A function call was interrupted by the system"
 
 
#define DBV_ASSOCDEAD           2       /* An association has been lost during
                                        an operation on it */
#define DBV_ASSOCDEAD_S         "This association has been unexpectedly lost"
 
 
#define DBV_INVALIDASSOC        3       /* An API function has been called with
                                        an invalid association ID */
#define DBV_INVALIDASSOC_S      "The association %d is invalid"
 
#define DBV_INVALIDSTYPE        4       /* The Association has an invalid
                                        stack type (you shouldn't get many of
                                        these!) */
#define DBV_INVALIDSTYPE_S      "Association %d has an invalid stack type"
 
#define DBV_NOASSOC             6       /* There are currently no associations*/
#define DBV_NOASSOC_S           "There are currently no associations"
 
#define DBV_INVALIDPARAMS       7       /* The function has failed because one
                                        or more of the parameters was invalid*/
#define DBV_INVALIDPARAMS_S     "Function called with invalid parameters.\nDiagnostics: %s"
#define DBV_SYSERROR            8       /* A Unix function call returned an
                                        an error */
#define DBV_SYSERROR_S          "A call to the system function %s returned error: %s"
#define DBV_INVALIDCALL		9	/* A call to this API function was
					not appropriate */
#define DBV_INVALIDCALL_S	"A call to this API function is invalid.\nDiagnostics: %s"
 
/* TCP/IP specific errors */
#define DBV_TCP_CLOSEFAILED     30      /* The TCP function close for the given
                                        association failed */
#define DBV_TCP_CLOSEFAILED_S   "TCP: close() failed for Association %d\nDiagnostics: %s"
#define DBV_TCP_CONNECTFAILED   31      /* The TCP/IP function connect()
					failed */
#define DBV_TCP_CONNECTFAILED_S "TCP: connect() failed.\nDiagnostics :%s"

/*
#define DBV_TCP_ERROR		32	** An error has occured for an 
					association using the TCP stack **
#define DBV_TCP_ERROR_S		"TCP: An unexpected error has occured.\nDiagnostics:%s"
*/
 
#define DBV_TCP_INVALIDADDRESS  32      /* The TCP/IP address name given was
                                        invalid */
#define DBV_TCP_INVALIDADDRESS_S "TCP/IP: address %s is invalid"

#define DBV_TCP_SOCKETFAILED    33      /* The TCP/IP function socket() failed.
                                        /A socket could not be created */
#define DBV_TCP_SOCKETFAILED_S  "TCP/IP: could not create socket.\nDiagnostics: %s"

/* OSI Specific errors */
#define DBV_OSI_INVALIDADDRESS	40	/* The OSI address given was invalid */
#define DBV_OSI_INVALIDADDRESS_S "OSI: address %s is invalid"

#define DBV_OSI_ISODE_ERROR	41	/* An error occurred in an ISODE 
				function */
#define DBV_OSI_ISODE_ERROR_S	"An ISODE function unexpectedly failed.\nDiagnostics:%s"

/* Errors associated with snacc PDU encoding/decoding 
   and Dbv->snacc PDU mapping */

#define DBV_PDU_DECODEFAILED    60      /* The snacc code could not decode the
                                        incoming PDU. Structure malloc'ed
                                        correctly? */
#define DBV_PDU_DECODEFAILED_S  "The received PDU could not be decoded"
 
#define DBV_PDU_ENCODEFAILED    61      /* The snacc code could not encode the
                                        outgoing PDU */
#define DBV_PDU_ENCODEFAILED_S  "An error occured while encoding the PDU"

/*
#define DBV_PDU_REPETITION      62      ** An invalid repetition of a PDU
                                        has been attempted **
#define DBV_PDU_REPETITION_S    "This function cannot be repeated at this time: %s"
*/
 
#define DBV_PDU_NULLFIELD       64      /* A compulsory field has not been
                                        given (could be a compulsory
					union member or first node in
				  	a list) */
#define DBV_PDU_NULLFIELD_S     "Missing compulsory field %s"
#define DBV_PDU_INVALIDBITSTRING 65     /* A bit string has been filled
                                        incorrectly */
#define DBV_PDU_INVALIDBITSTRING_S "The bit string %s is invalid\nValue:%s"

#define DBV_PDU_OUTOFRANGE	66	/* An integer (usually an enumerated 
					type) is out of its valid range */
#define DBV_PDU_OUTOFRANGE_S	"%s contains a value which is out of its range"

#define DBV_PDU_INVALIDOPTIONS 67     /* An InitRequest options string
					 contains options settings not 
					 permitted by the API (allowed
					 options are specified by the 
					 #define ALLOWED_OPTIONS below */ 
#define DBV_PDU_INVALIDOPTIONS_S "The options string %s contains options not permitted by the API (see dbvproto.h ALLOWED_OPTIONS for allowed options)\nValue:%s"
#define DBV_PDU_NULLCHOICE	71	/* Chosen choice not given */
#define DBV_PDU_NULLCHOICE_S	"Field %s must be given"
#define DBV_PDU_INVALIDBOOL	72	/* Invalid DbvBool value given */
#define DBV_PDU_INVALIDBOOL_S	"Invalid boolean value %s given"
#define DBV_PDU_INVALIDOID	73	/* Invalid oid (ObjectIdentifier) value given */
#define DBV_PDU_INVALIDOID_S	"Invalid oid value %s given"
#define DBV_PDU_EXTERNALOID	74	/* Invalid oid (ObjectIdentifier) for a particular external */
#define DBV_PDU_EXTERNALOID_S	"Invalid oid value %s for external %s"
#define DBV_PDU_OUTOFMEM 	75	/* Out of memory - internal alloc attempt returns NULL */
#define DBV_PDU_OUTOFMEM_S	"Out of memory"
#define DBV_PDU_GENERAL 	76	/* Error not covered by above */
#define DBV_PDU_GENERAL_S	"%s"
 

/* Errors associated with the service provider state machine checks  */
#define DBV_SM_VIOLATION	80	/* An event triggered by the service
					user or the remote origin/target
					association has violated the internal
					state machine */
#define DBV_SM_VIOLATION_S	"Event %s is invalid for state %s"

#define DBV_SM_ERROR		81	/* An incoming event from the remote
					origin/target has violated the internal
					state machine. The current state is now
					the error state */
#define DBV_SM_ERROR_S		"Incoming event %s is an error for state %s"

/* Specifying address by name errors */
#define DBV_FILE_FORMAT		100	/* The format of the file being read
					is wrong */
#define DBV_FILE_FORMAT_S	"File format error: Expected %s, read %s"

#define DBV_FILE_VALUE		101	/* The file contains an invalid value */
#define DBV_FILE_VALUE_S	"The value %s in the file is not valid"

#define DBV_NAME_ENTRY		102 /* The specified name was not in the 
				file (or, for entries in the isoentities file, 
				the entry is incorrect) */
#define DBV_NAME_ENTRY_S	"The entry %s is not in the name file/The format is not correct"

#define DBV_FILE_ERROR		103	/* An error was detected in the 
						file */
#define DBV_FILE_ERROR_S	"There is an error in the file"

/* Miscellaneous errors */
#define DBV_FILE		110 	/* A file could not be opened or does 
					not exist */
#define DBV_FILE_S		"The file %s could not be opened"

#define DBV_INTERNAL		111	/* An unexpected error has occurred
				somewhere in the API */
#define DBV_INTERNAL_S		"An internal error has occurred.\nDiagnostic:%s"

/* Memory Errors (passed back from DBVAlloc functions) */
#define DBV_MALLOC		120	/* A request for memory failed */
#define DBV_MALLOC_S		"A request for memory failed: %s"

/* ACSE configuration file specific errors */
#define DBV_ACSE_INVALID_ACN_VALUE	130 /* An Application Context name is
				incorrect */
#define DBV_ACSE_INVALID_ACN_VALUE_S	"The Application Context %s is invalid"

#define DBV_ACSE_FORMATERROR		131	/* There is an error in the
					ACSE configuration file */
#define DBV_ACSE_FORMATERROR_S		"The format of the configuration file is incorrect\nDiagnostic:%s"
#define DBV_ACSE_MISSING_FILE		132	/* The ACSE configuration file
					is missing (OSI target only). */
#define DBV_ACSE_MISSING_FILE_S		"The ACSE configuration file is missing"

#define DBV_ACSE_MISSING_PCDL		133	/* The Presentation Context
					Definition list is missing (OSI target
					only). */
#define DBV_ACSE_MISSING_PCDL_S         "The  Presentation Context Definition list is missing"

/* Allowed origin end Options bits (InitRequest PDU Options field) */
#define ALLOWED_OPTIONS "111111111011101"


/* Memory macros */
#define DbvAlloc(size)  calloc(1,size)

#define CheckDbvAlloc(ptr, env) \
  if ((ptr) == NULL) \
	longjmp(env, -1)

#define DbvFree(ptr)	free(ptr)


#ifdef __cplusplus 
}
#endif


#endif
