/* -----------  sitypes.h -------------------------------------------*/


/* When using this file with other DBV-OSI II includes, include as follows

#include "sidefs.h"
#include "sitypes.h"
#include "sitypes2.h"
#include "dbvproto.h"
#include "iord_ext.h"
#include "itemordr.h"
*/

/*
#include "crxtypes.h"
*/




/*  Module Name: @(#)sitypes.h	7.4
    Version: 12/4/96
    Author: Chris Attewell
 
    Crossnet Systems Ltd.
    Unit 3, The Paddock,
    Hambridge Road,
    Newbury,
    Berkshire, RG14 5TQ
 
    Date of Issue:    
 
    QA Acceptance:
    Date of Acceptance:
 
    Description:
    Type definitions for DBV-OSI II
 
*/


#if !defined(SITYPES_H)
#define SITYPES_H

/* Responses for releasing an association */
typedef enum DbvReleaseRspReason {
	Normal = 0,
	Not_Finished = 1
} DbvReleaseRspReason;

typedef enum DbvReleaseRspResult {
	Affirmative = 0,
	Negative = 1
} DbvReleaseRspResult;

typedef struct DbvReleaseRsp {
	DbvReleaseRspReason	 *peReleaseRspReason;
	DbvReleaseRspResult	  eReleaseRspResult;
} DbvReleaseRsp;

/* Enumeration Types */

/* Events requiring a read operation: 
typedef enum EventLocation
		API_No_Event (0),
		API_User_Event (1),
		API_Provider_Event (2)
} EventLocation; 
typedef enum EventLocation {
		API_No_Event =0,
		API_User_Event =1,
		API_Provider_Event =2
} EventLocation;*/

/* New definition of DbvEventLocation */
typedef struct DbvEventLocation {
	DbvFds   	**ppulUserEvent;
	DbvAssocId	**pplProviderEvent;
} DbvEventLocation;


/* Protocols supported: */
typedef enum DbvApplicationProtocol {
		Unknown_Protocol = 0,
		Unidentified_Protocol = 1,
		SR_Protocol = 2,
		Z3950_Protocol = 3 
} DbvApplicationProtocol;

/* Protocol stacks supported: */
typedef enum DbvProtocolStack {
		Unknown_Stack = 0,
		OSI_Stack = 1,
		TCP_Stack = 2 
} DbvProtocolStack;

/* Associate Response: */
typedef enum DbvAssociateRsp {
		Accepted = 0,
		Rejected_Perm = 1,
		Rejected_Tran = 2 
} DbvAssociateRsp;

/* Abstract syntaxes: */
typedef enum DbvAbstractSyntax {
		No_Syntaxes_Provided = 0,
		No_Common_Syntax = 1,
		Common_Syntaxes = 2
} DbvAbstractSyntax;

/* Association states during association/connection establishment phase: */
typedef enum DbvAssociateState {
		Associate_Null  = 0,
		Associate_Accepted  = 1,
		Associate_Rejected  = 2,
		Associate_Pending  = 3 
} DbvAssociateState;

/* Associate rejection: */
typedef enum DbvAssociateRejectSource {
		ACSE_User = 0,
		ACSE_Provider = 1 
} DbvAssociateRejectSource;


typedef enum DbvAssociateRejectResult {
		Rejected_Permanent = 0,
		Rejected_Transient = 1 
} DbvAssociateRejectResult;

typedef enum DbvAssociateRejectReason {
		No_Reason_Given = 0,
		No_Common_ACSE_Version = 1,
		Application_Context_Not_Supported = 2 
} DbvAssociateRejectReason;

/* Association states during association/connection release phase: */
typedef enum DbvReleaseState {
		Release_Null  = 0,
		Release_Accepted  = 1,
		Release_Rejected  = 2,
		Release_Pending  = 3 
} DbvReleaseState;

typedef enum DbvReleaseReq {
		ReleaseReq_Normal = 0,
		ReleaseReq_Urgent = 1,
		ReleaseReq_Undefined = 2 
} DbvReleaseReq;

/* Association state upon return of an API function: */
typedef enum DbvAssociationState {
		Association_Open = 0,
		Association_Closed = 1,
		Association_Unknown_State = 2 
} DbvAssociationState;

/* Error classes: */
typedef enum DbvErrorClass {
		SI_Communication_Error = 0,
		SI_Interface_Error = 1,
		SI_OperatingSystem_Error = 2,
		SI_Abort = 3
} DbvErrorClass;



/* Abort sources: */
typedef enum DbvAbortSource {
		SI_ACSE_User = 0,
		SI_ACSE_Provider = 1,
		SI_Presentation_User = 2,
		SI_Presentation_Provider = 3,
		SI_Transport_Provider = 4 
} DbvAbortSource;

/* Permitted SR-/Z39.50 events at the Origin system */
typedef enum DbvOriginEvent {
		OR_InitializeConf = 0,
		OR_SearchConf = 1,
		OR_PresentConf = 2,
		OR_DeleteResultSetConf = 3,
		OR_ScanConf = 4,
		OR_ResourceReportConf = 5,
		OR_SegmentationInd = 6,
		OR_SortConf = 7,
		OR_ExtendedServicesConf = 8,
		OR_CloseConf = 9,
		OR_CloseInd = 10,
/*		OR_ReleaseInd = 11,  Target is not allowed to close the
                                     association */
		OR_Invalid_APDU = 11,
		OR_AccessCntrlInd = 12, /* AccessControlRequest from target */
		OR_ResourCntrlInd = 13  /* ResourceControlRequest from target */
} DbvOriginEvent;

/* Permitted SR-/Z39.50 events at the Target system */
typedef enum DbvTargetEvent {
		TA_InitializeInd = 0,
		TA_SearchInd = 1,
		TA_PresentInd = 2,
		TA_DeleteResultSetInd = 3,
		TA_ScanInd = 4,
		TA_ResourceReportInd = 5,
		TA_SortInd = 6,
		TA_ExtendedServicesInd = 7,
		TA_CloseInd = 8,
		TA_CloseConf = 9,
		TA_ReleaseInd = 10,
		TA_Invalid_APDU = 11,
		TA_AccessCntrlConf = 12, /* AccessControlResponse from origin */
		TA_ResourCntrlConf = 13,  /* ResourceControlResponse from origin */ 

		TA_TrigResourCntrlInd = 14  /* TriggerResourceControlRequest from origin */


} DbvTargetEvent;

/* Target identification */
typedef enum DbvTargetNameOrAddress {
		Target_Name = 0,
		Target_Address = 1
} DbvTargetNameOrAddress;

/* Address types */
typedef enum DbvOsiOrInternetAddress {
		Osi_Address = 0,
		Internet_Address = 1
} DbvOsiOrInternetAddress;


typedef enum DbvTraceLevel {
	Trace_Off = 0,
	Trace_Low = 1,
	Trace_High = 2
} DbvTraceLevel;

/* Structure/Union Types  */

/* Structures associated with Association Handling functions */

typedef struct DbvAssociateReject {
	DbvAssociateRejectSource	*peAssociateRejectSource;
	DbvAssociateRejectResult	*peAssociateRejectResult;
	DbvAssociateRejectReason	*peAssociateRejectReason;
} DbvAssociateReject;

typedef struct DbvProtocolAndSyntaxes {
	DbvApplicationProtocol		  *peApplicationProtocol;
	DbvAbstractSyntax		  *peAbstractSyntax;
	char				**ppcCommonSyntaxes;
/* valid <--> peAbstractSyntax == Common_Syntaxes */
} DbvProtocolAndSyntaxes;

typedef union DbvAssociateResult {
	DbvProtocolAndSyntaxes		*psProtocolAndSyntaxes;
	DbvAssociateReject		*psAssociateReject;
} DbvAssociateResult;


typedef struct DbvOsiAddress {
	char		*pcPsel;
	char		*pcSsel;
	char		*pcTsel;
	char		*pcNsap;
} DbvOsiAddress;

typedef struct DbvInternetAddress {
	char		*pcHostAddress;
	DbvPortNumber    ulPortNumber;
} DbvInternetAddress;

typedef struct DbvTargetInformation {
	DbvApplicationProtocol			*peTargetSupportedProtocol;
	DbvOsiOrInternetAddress			  eOsiOrInternetAddress;
	union {
		DbvOsiAddress		*psOsiAddress;
		DbvInternetAddress	*psInternetAddress;
	}					  uOsiOrInternetAddress;
} DbvTargetInformation;


typedef struct DbvTarget {
	DbvTargetNameOrAddress			eTargetNameOrAddress;
	union {
		char			*pcTargetName;
		DbvTargetInformation	*psTargetInformation;
	}					uNameOrAddress;
} DbvTarget;



/* Structures common to all functions */

typedef struct DbvAbort {
  DbvAbortSource		  eAbortSource;
  DbvAbortReason		  lAbortReason;
  char				 *pcDiagnostics;
} DbvAbort;

typedef struct DbvError {
  DbvErrorClass		eErrorClass;
  union {
    DbvErrorCode	  lIfOsCoError;
    DbvAbort	         *psAbort;
  }			uErrorCode;
  DbvAssociationState	eAssociationState;
} DbvError;


/* The default "ACSE-configuration-file"
The default "ACSE-configuration-file" provides the values of those ACSE parameters, which shall be present in the AAssociate.Request service primitive when initiating an association establishment.
The structure (syntax) of this file has to be defined by the API-provider. The administration of the file will be in the responsibility of the API-user.
The file shall provide values for at least the following ACSE parameters:



Application Context Name
Permitted values: "Basic_SR_Application_Context" and/or "Basic_Z3950_Application_Context".
The application on top of the API may support both protocols, SR and Z39.50. In this case both of the above values shall be present.
Default value: "Basic_SR_Application_Context".


Presentation Context Definition List
A list of abstract syntaxes supported by the application on top of the API.
The function reading this file has to recognize the values "ACSE", "SR", "Z3950" and the values of the enumeration type AbstactSyntax defined in chapter 4.2.
Default value: Empty list.




Whenever one of the values is missing during runtime, the function reading the file shall use the corresponding default value and print a message to a "log file".




Begriffe und Abkrzungen

ACSE
Association Control Service Element


API
Application Programmers Interface


IP
Internet Protocol


ISODE
ISO Development Environment


TCP
Transmission Control Protocol

*/


/* Anhang: SR-/Z39.50 Data Structures
Global type and structure definitions */


/* ------------------------------------------------------------*/
/*               Types and Sub-Structures                      */
/* ------------------------------------------------------------*/

typedef unsigned long   Ulong;
typedef char*           DbvProtocolVersion;
typedef char*           DbvOptions;


typedef enum DbvBool {
             DBV_FALSE = 0,
             DBV_TRUE  = 1
} DbvBool;


typedef char*           DbvObjectIdentifier;



/* -------------   OctetString   ----------------------------- */

typedef struct DbvOctetString {
Ulong      ulLength;
char      *pcValue;
} DbvOctetString;



/* -------------   DbvVisibleString   ----------------------------- */

typedef char*          DbvVisibleString;


/* -------------   DbvGeneralizedTime   ----------------------------- */

typedef char*          DbvGeneralizedTime;


/* -------------   DbvInternationalString   ----------------------------- */

typedef struct DbvInternationalString {
Ulong      ulLength;
char      *pcValue;
} DbvInternationalString;



/* -------------   DbvGeneralString   ----------------------------- */

typedef struct DbvGeneralString {
Ulong      ulLength;
char      *pcValue;
} DbvGeneralString;



/* --------------  ASN1External  ----------------------- */

typedef enum DbvExternalValueType {
                     EVT_SingleASN1Type = 1,
                     EVT_OctetAligned   = 2,
                     EVT_Arbitrary      = 3
} DbvExternalValueType;

typedef enum DbvASN1Type {
             AT_UnstructuredText         = 1,
             AT_OpacRecord               = 2,
             AT_SummaryRecord            = 3,
             AT_ResourceReport1          = 4,
             AT_ResourceReport2          = 5,
             AT_EsTaskPackage            = 6,      
             AT_UpdateExtendedService    = 7,      
             AT_ItemOrderExtendedService = 9,      
             AT_IllPdu                   = 10,
             AT_ExplainRecord            = 12,      

             AT_GenericRecord            = 13,

             AT_PromptObject             = 14,

             AT_Print            	 = 15,
             AT_Alert            	 = 16,
             AT_Corder            	 = 17,

             AT_CharSetAndLanguage       = 18,
             AT_UnknownType              = 8       
} DbvASN1Type;


typedef struct DbvSingleASN1Type {
DbvASN1Type          eASN1Type;
union {
    struct DbvInternationalString      *psUnstructuredText;    
    struct DbvOpacRecord               *psOpacRecord;
    struct DbvSummaryRecord            *psSummaryRecord;
    struct DbvResourceReport1          *psResourceReport1;
    struct DbvResourceReport2          *psResourceReport2;
    struct DbvEsTaskPackage            *psEsTaskPackage;        
    struct DbvUpdateExtendedService    *psUpdateExtendedService;
    struct DbvItemOrderExtendedService *psItemOrderExtendedService;
    struct DbvIllPdu                   *psIllPdu; /* ILL */
    struct DbvExplainRecord            *psExplainRecord;

    struct DbvGenericRecord            *psGenericRecord;

    struct DbvPromptObject             *psPromptObject;

    struct DbvPrintExtendedService     *psPrintExtendedService;
    struct DbvAlertExtendedService     *psAlertExtendedService;
    struct DbvCOrder                   *psCOrder;

    struct DbvCharSetAndLanguage       *psCharSetAndLanguage;
    struct DbvOctetString              *psUnknownType;          
  }               uASN1;
} DbvSingleASN1Type;


typedef struct DbvASN1External {
DbvObjectIdentifier      pcObjectIdentifier;    
DbvExternalValueType     eValueType;
union {
    DbvSingleASN1Type      *psSingleASN1Type;
    DbvOctetString         *psOctetAligned;
    DbvOctetString         *psArbitrary;
  }                   uExternalValue;
} DbvASN1External;



/* --------------  Other Information  ----------------------- */

typedef enum DbvInformationType {
                   IT_CharacterInfo    = 1,
                   IT_BinaryInfo       = 2,
                   IT_ExternalInfo     = 3,
                   IT_ObjectIdentifier = 4
} DbvInformationType;


typedef struct DbvInfoCategory {
DbvObjectIdentifier    pcCategoryTypeId;    
Ulong                  ulCategoryValue;
} DbvInfoCategory;


typedef struct DbvOtherInformation {
DbvInfoCategory       *psInfoCategory;
DbvInformationType     eInformationType;
union {
    DbvInternationalString      *psCharacterInfo;
    DbvOctetString              *psBinaryInfo;
    DbvASN1External             *psExternallyDefinedInfo;
    DbvObjectIdentifier          pcObjectIdentifier;    
  }                 uInformation;
} DbvOtherInformation;



/* ------------------------------------------------------------------------- */


/* --------------  Authentication ----------------------- */

typedef enum DbvAuthenticationType {
                 AT_Open       = 1,
                 AT_IdPassword = 2,
                 AT_Anonymous  = 3,
                 AT_Other      = 4
} DbvAuthenticationType;


typedef struct DbvIdPassword {
DbvInternationalString      *psGroupId;
DbvInternationalString      *psUserId;
DbvInternationalString      *psPassword;
} DbvIdPassword;


typedef struct DbvAuthentication{
DbvAuthenticationType   eAuthenticationType;
union {
    DbvVisibleString		 psOpen;
    DbvIdPassword               *psIdPassword;
    DbvASN1External             *psOther;
  }                  uAuthentication;
} DbvAuthentication;           



/* --------------  DbvElementSetNames  ----------------------- */

typedef enum DbvElementSetType {
                  EST_Generic          = 1,
                  EST_DatabaseSpecific = 2
} DbvElementSetType;


typedef struct DbvElementSetsDbSpecific {
DbvInternationalString       *psDatabaseName;
DbvInternationalString       *psElementSetName;
} DbvElementSetsDbSpecific;


typedef struct DbvElementSetNames {
DbvElementSetType      eElementSetType;
union {
    DbvInternationalString         *psGeneric;
    DbvElementSetsDbSpecific      **ppsElementSetsDbSpecific;
  }                uElementSet;
} DbvElementSetNames;



/* --------------  DbvQuery  ----------------------- */


typedef enum DbvQueryType {
             QT_Private         = 1,
             QT_Rpn             = 2,
             QT_Iso8777         = 3,
             QT_Z3958           = 4,
             QT_Erpn            = 5,   
             QT_NaturalLanguage = 6
} DbvQueryType;


typedef  enum DbvRPNStructureType {
                   RST_RpnLopRopOperator = 1,
                   RST_RpnOperand        = 2
} DbvRPNStructureType;


typedef enum DbvOperandType {
                  OT_AttributePlusTerm       = 1,
                  OT_ResultSetId             = 2,
                  OT_ResultSetPlusAttributes = 3
} DbvOperandType;


typedef enum DbvTermType {
             TT_General          = 1,    /* the original, Version 2 type */
             TT_Numeric          = 2,
             TT_SimpleCharacter  = 3,
             TT_ObjectIdentifier = 4,
             TT_DateTime         = 5,    
             TT_External         = 6,
             TT_IntegerAndUnit   = 7,    
             TT_Null             = 8  
} DbvTermType;


typedef enum DbvOperatorType {
                  OT_Or        = 1,
                  OT_And       = 2,
                  OT_AndNot    = 3,
                  OT_Proximity = 4
} DbvOperatorType;

typedef enum DbvProximityUnitType {
                     PUT_Known   = 1,
                     PUT_Private = 2
} DbvProximityUnitType;


typedef enum DbvProximityRelationType {
                         PRT_LessThan           = 1,
                         PRT_LessThanOrEqual    = 2,
                         PRT_Equal              = 3,
                         PRT_GreaterThanOrEqual = 4,
                         PRT_GreaterThan        = 5,
                         PRT_NotEqual           = 6, 
                         PRT_Invalid            = -1 
} DbvProximityRelationType;


typedef enum DbvKnownProximityUnit {
                      KPU_Character   = 1,
                      KPU_Word        = 2,
                      KPU_Sentence    = 3,
                      KPU_Paragraph   = 4,
                      KPU_Section     = 5,
                      KPU_Chapter     = 6,
                      KPU_Document    = 7,
                      KPU_Element     = 8,
                      KPU_SubElement  = 9,
                      KPU_ElementType = 10,
                      KPU_Byte        = 11,
                      KPU_Invalid     = -1
} DbvKnownProximityUnit;


typedef struct DbvProximityUnitCode {
DbvProximityUnitType    eProximityUnitType;
union {
    DbvKnownProximityUnit  eKnownProximityUnit;
    Ulong                  ulPrivate;
  }                  uProximityUnit;
} DbvProximityUnitCode;


typedef struct DbvProximityOperator {
DbvBool                   *pfExclusion;
Ulong                      ulDistance;
DbvBool                    fOrdered;
DbvProximityRelationType   eProximityRelationType;
DbvProximityUnitCode       sProximityUnitCode;
} DbvProximityOperator;


typedef struct DbvOperator {
DbvOperatorType       eOperatorType;
DbvProximityOperator *psProximityOperator; /* <--> eOperatorType == OT_Proximity */
} DbvOperator;


    /* ---- DbvAttributeValue ----( not the final definition ) ---- */

typedef enum DbvAttributeValueType {
                 AVT_Numeric  = 1,    /* the original one */
                 AVT_Complex  = 2                              
} DbvAttributeValueType;




          /* -------------   DbvIntUnit   -------------------- */

typedef enum DbvStringOrNumericType {
                  SNT_String  = 1,
                  SNT_Numeric = 2
} DbvStringOrNumericType;


typedef struct DbvStringOrNumeric {
DbvStringOrNumericType     eStringOrNumeric;
union {
    DbvInternationalString    *psString;
    Ulong                      ulNumeric;
  }                     uStringOrNumeric;
} DbvStringOrNumeric;


typedef struct DbvUnit {
DbvInternationalString *psUnitSystem;
DbvStringOrNumeric     *psUnitType;
DbvStringOrNumeric     *psUnit;
Ulong                  *pulScaleFactor;
} DbvUnit;


typedef struct DbvIntUnit {
Ulong          ulValue;
DbvUnit        sUnitUsed;
} DbvIntUnit;


typedef struct DbvComplexValue {                                
DbvStringOrNumeric    **ppsList;
Ulong                 **ppulSemanticAction;
} DbvComplexValue;


typedef struct DbvAttributeValue {
DbvAttributeValueType          eAttributeValueType;
union {
    Ulong                   ulNumeric;                   
    DbvComplexValue        *psComplexValue;              
  }                            uAttributeValue;
} DbvAttributeValue;


typedef struct DbvAttributeElement {
DbvObjectIdentifier      pcAttributeSetId;                  
Ulong                    ulAttributeType;
DbvAttributeValue        sAttributeValue;                   
} DbvAttributeElement;


        /* -------------   DbvTerm   ------------------ */

typedef struct DbvTerm {
DbvTermType        eTermType;
union {
    DbvOctetString              *psGeneral;
    Ulong                        ulInteger;
    DbvInternationalString      *psSimpleCharacter;
    DbvObjectIdentifier          pcObjectIdentifier;  
    DbvGeneralizedTime           pcDateTime;                          
    DbvASN1External             *psExternal;
    DbvIntUnit                  *psIntegerAndUnit;                    
  }                uTerm;
} DbvTerm;


typedef struct DbvAttributesPlusTerm {
DbvAttributeElement    **ppsAttributeElement;
DbvTerm                  sTerm;                                   
} DbvAttributesPlusTerm;


typedef struct DbvResultSetPlusAttributes {
DbvInternationalString       sResultSetId;
DbvAttributeElement        **ppsAttributeElement;
} DbvResultSetPlusAttributes;


typedef struct DbvOperand {
DbvOperandType   eOperandType;
union {
    DbvAttributesPlusTerm      *psAttributesPlusTerm;
    DbvInternationalString     *psResultSetId;
    DbvResultSetPlusAttributes *psResultSetPlusAttributes;
  }            uOperand;
} DbvOperand;


typedef struct DbvRPNLopRopOperator {
struct DbvRPNStructure  *psLeftOperand;    
struct DbvRPNStructure  *psRightOperand;    
DbvOperator              sOperator;          
} DbvRPNLopRopOperator;


typedef struct DbvRPNStructure {
DbvRPNStructureType   eRpnStructureType;
union {
    DbvRPNLopRopOperator       *psRpnLopRopOperator;
    DbvOperand                 *psRpnOperand;
  }                uRPNStructure;
} DbvRPNStructure;



typedef struct DbvRPNQuery {
DbvObjectIdentifier         pcAttributeSetId;                  
DbvRPNStructure             sRpnStructure;
} DbvRPNQuery;


typedef struct DbvQuery {
DbvQueryType        eQueryType;
union {
    DbvOctetString          *psPrivateQuery;
    DbvRPNQuery             *psRpnQuery;
    DbvOctetString          *psIso8777Query;
    DbvOctetString          *psZ3958Query;
    DbvRPNQuery             *psErpnQuery;
    DbvOctetString          *psNaturalLanguageQuery;
  }              uQuery;
} DbvQuery;




/* --------------  DbvRecords  ----------------------- */

typedef enum DbvRecordType {
              RT_Response                   = 1,
              RT_NonSurrDiagnostics         = 2,
              RT_MultipleNonSurrDiagnostics = 3
} DbvRecordType;


typedef enum DbvDbRecordType {
                DRT_Retrieval            = 1,
                DRT_SurrogateDiagnostics = 2,
                DRT_StartingFragment     = 3,
                DRT_IntermediateFragment = 4,
                DRT_FinalFragment        = 5
} DbvDbRecordType;


typedef enum DbvDiagnosticsType {
                   DT_DefaultFormat     = 1,
                   DT_ExternallyDefined = 2
} DbvDiagnosticsType;


typedef enum DbvFragmentSyntaxType {
                      FST_ExternallyTagged    = 1,
                      FST_NotExternallyTagged = 2
} DbvFragmentSyntaxType;


typedef enum DbvProtocolVersionInForce {
                      PVIF_Version2 = 1,
                      PVIF_Version3 = 2
} DbvProtocolVersionInForce;


typedef struct DbvAdditionalInfo {
DbvProtocolVersionInForce   eProtocolVersionInForce;
union {
    DbvVisibleString            pcV2;                      
    DbvInternationalString     *psV3;
  }                         uAdditionalInfo;
} DbvAdditionalInfo;

typedef struct DbvDefaultDiagFormat {
DbvObjectIdentifier        pcDiagnosticSetId;                  
Ulong                      ulCondition;
DbvAdditionalInfo          sAdditionalInfo;
} DbvDefaultDiagFormat;


typedef struct DbvDiagRec {
DbvDiagnosticsType       eDiagnosticsType;
union {
    DbvDefaultDiagFormat      *psDefault;
    DbvASN1External           *psExternallyDefined;
  }                  uDiagnostics;
} DbvDiagRec;


typedef struct DbvFragmentSyntax { 
DbvFragmentSyntaxType      eFragmentSyntaxType;
union {
    DbvASN1External    *psExternallyTagged;
    DbvOctetString     *psNotExternallyTagged;
  }                     uFragmentSyntax;
} DbvFragmentSyntax;


typedef struct DbvNamePlusRecord {
DbvInternationalString  *psDatabaseName;               
DbvDbRecordType          eDbRecordType;
union {
    DbvASN1External   *psRetrievalRecord;
    DbvDiagRec        *psSurrogateDiagnostic;
    DbvFragmentSyntax *psStartingFragment; 
    DbvFragmentSyntax *psIntermediateFragment; 
    DbvFragmentSyntax *psFinalFragment;
  }                   uDbRecord; 
} DbvNamePlusRecord;



typedef struct DbvRecords {
DbvRecordType        eRecordType;
union {
    DbvNamePlusRecord    **ppsResponseRecord;
    DbvDefaultDiagFormat  *psNonSurrogateDiag;
    DbvDiagRec           **ppsMultipleNonSurrogateDiag;
  }               uRecord;
} DbvRecords;



/* --------------  DbvRange  ----------------------- */

typedef struct DbvRange {
Ulong        ulStartingPosition;
Ulong        ulNumberOfRecords; 
} DbvRange;



/* --------------  RecordComposition  ----------------------- */


typedef enum DbvRecordCompositionType {
                          RCT_ElementSetNames = 1,
                          RCT_CompSpec        = 2
} DbvRecordCompositionType; 


typedef enum DbvElementSpecType {
                   EST_Primitive = 1,
                   EST_External  = 2
} DbvElementSpecType; 


typedef struct DbvElementSpec { 
DbvElementSpecType        eElementSpecType;
union {
    DbvInternationalString  *psPrimitive;
    DbvASN1External         *psExternal;
  }                    uElementSpec;
} DbvElementSpec;


typedef struct DbvSpecification {
DbvObjectIdentifier        pcSchema;                  
DbvElementSpec            *psElementSpec;
} DbvSpecification;


typedef struct DbvDbSpecificComp {
DbvInternationalString    sDatabaseName;
DbvSpecification          sSpecification;
} DbvDbSpecificComp;


typedef struct DbvCompSpec {
DbvBool                  fSelectAlternativeSyntax;        
DbvSpecification        *psGeneric;
DbvDbSpecificComp      **ppsDbSpecific;
DbvObjectIdentifier     *ppcRecordSyntax;                  
} DbvCompSpec;


typedef struct DbvRecordComposition {
DbvRecordCompositionType    eRecordCompositionType;
union {
    DbvElementSetNames  *psElementSetNames;
    DbvCompSpec         *psCompSpec;
  }                      uRecordComposition;
} DbvRecordComposition;



/* ----------  ListStatus  (--> DELETE-RESULT-SET response) --------- */

typedef enum DbvDeleteSetStatus {
                   DSS_Success                       = 0,
                   DSS_ResultSetDidNotExist          = 1,
                   DSS_PreviouslyDeletedByTarget     = 2,
                   DSS_SystemProblemAtTarget         = 3,
                   DSS_AccessNotAllowed              = 4,
                   DSS_ResourceControlAtOrigin       = 5,
                   DSS_ResourceControlAtTarget       = 6,
                   DSS_BulkDeleteNotSupported        = 7,
                   DSS_NotAllSetsDeletedOnBulkDlt    = 8,
                   DSS_NotAllRequestedSetsDeleted    = 9,
                   DSS_ResultSetInUse                = 10,
                   DSS_Invalid                       = -1 
} DbvDeleteSetStatus;


typedef struct DbvListStatus {
DbvInternationalString       sResultSetId;
DbvDeleteSetStatus           eDeleteSetStatus;
} DbvListStatus;



/* --------------  DbvListEntries  (--> SCAN ) ---------------- */


typedef enum DbvEntryType {
             ET_TermInfo            = 1,
             ET_SurrogateDiagnostic = 2
} DbvEntryType;


typedef enum DbvOccurrenceType {
                  OT_Global     = 1,
                  OT_ByDatabase = 2
} DbvOccurrenceType;


typedef struct DbvOccurrenceByDb {
DbvInternationalString       sDatabaseName;
Ulong                       *pulNumber;
DbvOtherInformation        **ppsOtherInformation;
} DbvOccurrenceByDb;


typedef struct DbvOccurrence {
DbvOccurrenceType             eOccurrenceType;
union {
    Ulong                ulGlobal;
    DbvOccurrenceByDb  **ppsOccurrenceByDb;
  }                           uOccurence;
} DbvOccurrence;


typedef struct DbvOccurrenceByAttributes {
DbvAttributeElement      **ppsAttributeElement;
DbvOccurrence             *psOccurrence;
DbvOtherInformation      **ppsOtherInformation;
} DbvOccurrenceByAttributes;


typedef struct DbvTermInfo {
DbvTerm                     sTerm;
DbvInternationalString     *psDisplayTerm;
DbvAttributeElement       **ppsSuggestedAttribute;
DbvAttributesPlusTerm     **ppsAlternativeTerm;
Ulong                      *pulGlobalOccurrences;
DbvOccurrenceByAttributes **ppsByAttributes;
DbvOtherInformation       **ppsOtherInformation;
} DbvTermInfo;


typedef struct DbvEntry {
DbvEntryType         eEntryType;
union {
    DbvTermInfo    *psTermInfo;
    DbvDiagRec     *psSurrogateDiagnostic;
  }               uEntry;
} DbvEntry;


typedef struct DbvListEntries {          
DbvEntry    **ppsEntry;
DbvDiagRec  **ppsNonSurrogateDiagnostics;
} DbvListEntries;



/* --------------  SortSequence  ----------------------- */

typedef enum DbvSortElementType {                   
                     SET_Generic    = 1,
                     SET_DbSpecific = 2
} DbvSortElementType;


typedef enum DbvSortRelationType {
                    SRT_Ascending     = 1,
                    SRT_Descending    = 2,
                    SRT_FrequencyAsc  = 3,
                    SRT_FrequencyDesc = 4,
                    SRT_Invalid       = -1 
} DbvSortRelationType;


typedef enum DbvSortCaseType {
                SCT_CaseSensitive   = 1,
                SCT_CaseInsensitive = 2,
                SCT_Invalid         = -1 
} DbvSortCaseType;


typedef enum DbvSortKeyType {                                  
                    SKT_SortField      = 1,
                    SKT_ElementSpec    = 2,
                    SKT_SortAttributes = 3
} DbvSortKeyType;


typedef enum DbvSortMVActionType {
                    SMT_Abort    = 1,
                    SMT_Null     = 2,
                    SMT_Constant = 3
} DbvSortMVActionType;


typedef struct DbvSortAttributes {
DbvObjectIdentifier     pcAttributeSetId;                  
DbvAttributeElement   **ppsAttributeElement;
} DbvSortAttributes;


typedef struct DbvSortKey {                               
DbvSortKeyType              eSortKeyType;                 
union {
    DbvInternationalString     *psSortField;
    DbvSpecification           *psElementSpec;
    DbvSortAttributes          *psSortAttributes;         
  }                      uSortElement;  
} DbvSortKey;


typedef struct DbvSortMVAction {
DbvSortMVActionType    eSortMVActionType;
DbvOctetString        *psOctetString;  /* <--> eSortMVActionType == SMT_Constant */
} DbvSortMVAction;


typedef struct DbvDbSpecificSortKey {
DbvInternationalString      sDatabaseName;
DbvSortKey                  sDbSort;                 
} DbvDbSpecificSortKey;


typedef struct DbvSortElement {                      
DbvSortElementType        eSortElementType;       
union {
    DbvSortKey                *psGeneric;               
    DbvDbSpecificSortKey     **ppsDatabaseSpecific;
  }                       uSortElement;
} DbvSortElement;


typedef struct DbvSortKeySpec {                   
DbvSortElement         sSortElement;
DbvSortRelationType    eSortRelationType;
DbvSortCaseType        eSortCaseType;
DbvSortMVAction       *psMVActionType;
} DbvSortKeySpec;


/* ---  OriginSuppliedCommonParameters  (--> EXTENDED-SERVICES) ----------- */

typedef enum DbvPermAllowableFunctions {
                      PAF_Delete            = 1,
                      PAF_ModifyContents    = 2,
                      PAF_ModifyPermissions = 3,
                      PAF_Present           = 4,
                      PAF_Invoke            = 5,
                      PAF_Invalid           = -1 
} DbvPermAllowableFunctions;


typedef struct DbvPermissions {
DbvInternationalString          sUserId;
DbvPermAllowableFunctions     **ppeAllowableFunctions;
} DbvPermissions;



/* ------------------------------------------------------------------------- */


/* -------------------------------------------------------------------*/
/*                  PDU-Datastructures      (Top-Level structures)    */
/* -------------------------------------------------------------------*/



/* ------------------    INITIALIZE   --------------------------------- */


typedef struct DbvInitializeReq {
DbvOctetString         *psReferenceId;
DbvProtocolVersion      pcProtocolVersion;      
DbvOptions              pcOptions;              
Ulong                   ulPreferredMessageSize;     
Ulong                   ulMaximumMessageSize;      
DbvAuthentication      *psAuthentication;
DbvInternationalString *psImplementationId;
DbvInternationalString *psImplementationName;
DbvInternationalString *psImplementationVersion;
DbvASN1External        *psUserInformationField;
DbvOtherInformation   **ppsOtherInformation;
} DbvInitializeReq;




typedef struct DbvInitializeRsp {
DbvOctetString         *psReferenceId;
DbvProtocolVersion      pcProtocolVersion;      
DbvOptions              pcOptions;              
Ulong                   ulPreferredMessageSize;
Ulong                   ulMaximumMessageSize;
DbvBool                 fResult;
DbvInternationalString *psImplementationId;
DbvInternationalString *psImplementationName;
DbvInternationalString *psImplementationVersion;
DbvASN1External        *psUserInformationField;
DbvOtherInformation   **ppsOtherInformation;
} DbvInitializeRsp;



/* ------------------    SEARCH   --------------------------------- */


typedef enum DbvResultSetStatus {
                   RSS_Subset  = 1,
                   RSS_Interim = 2,
                   RSS_None    = 3,
                   RSS_Invalid = -1 
} DbvResultSetStatus;


typedef enum DbvPresentStatus {
                 PS_Success   = 0,
                 PS_Partial_1 = 1,
                 PS_Partial_2 = 2,
                 PS_Partial_3 = 3,
                 PS_Partial_4 = 4,
                 PS_Failure   = 5,
                 PS_Invalid   = -1 
} DbvPresentStatus;



typedef struct DbvSearchReq {
DbvOctetString           *psReferenceId;
Ulong                     ulSmallSetUpperBound;
Ulong                     ulLargeSetLowerBound;
Ulong                     ulMediumSetPresentNumber;
DbvBool                   fReplaceIndicator;
DbvInternationalString    sResultSetName;
DbvInternationalString  **ppsDatabaseNames; 
DbvElementSetNames       *psSmallSetElementNames;
DbvElementSetNames       *psMediumSetElementNames;
DbvObjectIdentifier       pcPreferredRecordSyntax;      
DbvQuery                 *psQuery;
DbvOtherInformation     **ppsAdditionalSearchInfo;
DbvOtherInformation     **ppsOtherInformation;
} DbvSearchReq;



typedef struct DbvSearchRsp {
DbvOctetString         *psReferenceId;
Ulong                   ulResultCount;
Ulong                   ulNumberOfRecordsReturned;
Ulong                   ulNextResultSetPosition;
DbvBool                 fSearchStatus;
DbvResultSetStatus     *peResultSetStatus;
DbvPresentStatus       *pePresentStatus;
DbvRecords             *psRecords;
DbvOtherInformation   **ppsAdditionalSearchInfo;
DbvOtherInformation   **ppsOtherInformation;
} DbvSearchRsp;





/* ------------------    PRESENT   --------------------------------- */




typedef struct DbvPresentReq{
DbvOctetString             *psReferenceId;
DbvInternationalString      sResultSetId;
Ulong                       ulResultSetStartPoint;
Ulong                       ulNumberOfRecordsRequested;
DbvRange                  **ppsAdditionalRanges;
DbvRecordComposition       *psRecordComposition;
DbvObjectIdentifier         pcPreferredRecordSyntax;      
Ulong                      *pulMaxSegmentCount;
Ulong                      *pulMaxRecordSize;
Ulong                      *pulMaxSegmentSize;
DbvOtherInformation       **ppsOtherInformation;
} DbvPresentReq;


typedef struct DbvPresentRsp {
DbvOctetString         *psReferenceId;
Ulong                   ulNumberOfRecordsReturned;
Ulong                   ulNextResultSetPosition;
DbvPresentStatus        ePresentStatus;
DbvRecords             *psRecords;
DbvOtherInformation   **ppsOtherInformation;
} DbvPresentRsp;



/* ------------------    DELETE-RESULT-SET   ----------------------------- */


typedef enum DbvDeleteFunction {
                  DF_List	= 0,
                  DF_All  	= 1,
                  DF_Invalid	= -1 
} DbvDeleteFunction;



typedef struct DbvDeleteResultSetReq {
DbvOctetString               *psReferenceId;
DbvDeleteFunction             eDeleteFunction;
DbvInternationalString      **ppsResultSetId;
DbvOtherInformation         **ppsOtherInformation;
} DbvDeleteResultSetReq;


typedef struct DbvDeleteResultSetRsp {
DbvOctetString             *psReferenceId;
DbvDeleteSetStatus          eDeleteOperationStatus;
DbvListStatus             **ppsDeleteListStatuses;
Ulong                      *pulNumberNotDeleted;
DbvListStatus             **ppsBulkStatuses;
DbvInternationalString     *psDeleteMessage;
DbvOtherInformation       **ppsOtherInformation;
} DbvDeleteResultSetRsp;



/* ------------------    SEGMENT   ----------------------------- */


typedef struct DbvSegmentReq {
DbvOctetString         *psReferenceId;
Ulong                   ulNumberOfRecordsReturned;
DbvNamePlusRecord     **ppsSegmentRecords;
DbvOtherInformation   **ppsOtherInformation;
} DbvSegmentReq;



/* ------------------    RESOURCE-REPORT   ----------------------------- */


typedef enum DbvResourceReportStatus {
                        RRS_Success   = 0,
                        RRS_Partial   = 1,
                        RRS_Failure_1 = 2,
                        RRS_Failure_2 = 3,
                        RRS_Failure_3 = 4,
                        RRS_Failure_4 = 5,
                        RRS_Failure_5 = 6,
                        RRS_Failure_6 = 7,
                        RRS_Invalid   = -1 
} DbvResourceReportStatus;




typedef struct DbvResourceReportReq {
DbvOctetString            *psReferenceId;
DbvOctetString            *psOperationId;
DbvObjectIdentifier        pcPrefResourceReportFormat;      
DbvOtherInformation      **ppsOtherInformation;
} DbvResourceReportReq;


typedef struct DbvResourceReportRsp {
DbvOctetString             *psReferenceId;
DbvResourceReportStatus     eResourceReportStatus;
DbvASN1External            *psResourceReport;
DbvOtherInformation       **ppsOtherInformation;
} DbvResourceReportRsp;



/* ------------------    SCAN   ----------------------------- */


typedef enum DbvScanStatus {
              SCS_Success   = 0,
              SCS_Partial_1 = 1,
              SCS_Partial_2 = 2,
              SCS_Partial_3 = 3,
              SCS_Partial_4 = 4,
              SCS_Partial_5 = 5,
              SCS_Failure   = 6,
              SCS_Invalid   = -1 
} DbvScanStatus;




typedef struct DbvScanReq {
DbvOctetString              *psReferenceId;
DbvInternationalString     **ppsDatabaseNames;
DbvObjectIdentifier          pcAttributeSetId;      
DbvAttributesPlusTerm        sAttributesPlusTerm;
Ulong                       *pulStepSize;
Ulong                        ulNumberOfTermsRequested;
Ulong                       *pulPreferredPositionInResponse;
DbvOtherInformation        **ppsOtherInformation;
} DbvScanReq;


typedef struct DbvScanRsp {
DbvOctetString         *psReferenceId;
Ulong                  *pulStepSize;
DbvScanStatus           eScanStatus;
Ulong                   ulNumberOfEntriesReturned;
Ulong                  *pulPositionOfTerm;
DbvListEntries         *psEntries;
DbvObjectIdentifier     pcAttributeSetId;      
DbvOtherInformation   **ppsOtherInformation;
} DbvScanRsp;



/* ------------------    SORT   ----------------------------- */


typedef enum DbvSortStatus {
                       SOS_Success   = 0,
                       SOS_Partial_1 = 1,
                       SOS_Failure   = 2,
                       SOS_Invalid   = -1 
} DbvSortStatus;


typedef enum DbvSortResultSetStatus {
                       SRSS_Empty     = 0,
                       SRSS_Interim   = 1,
                       SRSS_Unchanged = 2,
                       SRSS_None      = 3,
                       SRSS_Invalid   = -1 
} DbvSortResultSetStatus;



typedef struct DbvSortReq {
DbvOctetString           *psReferenceId;
DbvInternationalString  **ppsInputResultSetName;
DbvInternationalString    sSortedResultSetName;
DbvSortKeySpec          **ppsSortSequence;        
DbvOtherInformation     **ppsOtherInformation;
} DbvSortReq;


typedef struct DbvSortRsp {
DbvOctetString             *psReferenceId;
DbvSortStatus               eSortStatus;
DbvSortResultSetStatus     *peResultSetStatus;
DbvDiagRec                **ppsDiagnostics;
DbvOtherInformation       **ppsOtherInformation;
} DbvSortRsp;



/* ------------------    CLOSE   ----------------------------- */


typedef enum DbvCloseReason {
               CR_Finished          = 0,
               CR_ShutDown          = 1,
               CR_SystemProblem     = 2,
               CR_CostLimit         = 3,
               CR_Resources         = 4,
               CR_SecurityViolation = 5,
               CR_ProtocolError     = 6,
               CR_LackOfActivity    = 7,
               CR_PeerAbort         = 8,
               CR_Unspecified       = 9,
               CR_Invalid           = -1 
} DbvCloseReason;




typedef struct DbvCloseReq {
DbvOctetString                    *psReferenceId;
DbvCloseReason                     eCloseReason;
DbvInternationalString            *psDiagnosticInformation;
DbvObjectIdentifier                pcResourceReportFormat;      
DbvASN1External                   *psResourceReport;
DbvOtherInformation              **ppsOtherInformation;
} DbvCloseReq;




/* ------------------    EXTENDED-SERVICES   ----------------------------- */

typedef enum DbvExtServicesFunctions {
                   ESF_Create	= 1,
                   ESF_Delete	= 2,
                   ESF_Modify	= 3,
                   ESF_Invalid	= -1 
} DbvExtServicesFunctions;


typedef enum DbvExtServicesWaitAction {
                   ESWA_Wait              = 1,
                   ESWA_WaitIfPossible    = 2,
                   ESWA_DontWait          = 3,
                   ESWA_DontReturnPackage = 4,
                   ESWA_Invalid           = -1
} DbvExtServicesWaitAction;


typedef enum DbvExtServicesOperationStatus {
                   ESOS_Done    = 1,
                   ESOS_Queued  = 2,
                   ESOS_Failure = 3,
                   ESOS_Invalid = -1
} DbvExtServicesOperationStatus;



typedef struct DbvExtendedServicesReq {
DbvOctetString                      *psReferenceId;
DbvExtServicesFunctions              eFunction;
DbvObjectIdentifier                  pcPackageType;      
DbvInternationalString              *psPackageName;
DbvInternationalString              *psUserId;
DbvIntUnit                          *psRetentionTime;    
DbvPermissions                     **ppsPermissions;
DbvInternationalString              *psDescription;
DbvASN1External                     *psOriginSpecificParameter;
DbvExtServicesWaitAction             eWaitAction;
DbvInternationalString              *psElements;
DbvOtherInformation                **ppsOtherInformation;
} DbvExtendedServicesReq;


typedef struct DbvExtendedServicesRsp {
DbvOctetString                     *psReferenceId;
DbvExtServicesOperationStatus       eOperationStatus;
DbvDiagRec                        **ppsDiagnostics;
DbvASN1External                    *psTaskPackage;
DbvOtherInformation               **ppsOtherInformation;
} DbvExtendedServicesRsp;



/* ------------------------------------------------------------------------- */



/* -----------------------------------------------------------*/
/*   Object Identifier, Record Syntaxes, Resource Report      */
/* -----------------------------------------------------------*/


/* --------------------------------------------------------------*/
/* The syntax Object Identifier definitions is

   ObjectIdentifier ::= Header Trailer
   Header ::= "1.0.10163." | "1.2.840.10003."
   Trailer ::= Number"."Number"}"
   Number  ::= positive integer value



 --------------------------------------------------------------*/




/* -------------- Object Identifier (Record Syntaxes) -----------*/  


#define ISO_UNIMARC             	"1.0.10163.5.1"
#define ANSI_UNIMARC            	"1.2.840.10003.5.1"
#define ISO_INTERMARC           	"1.0.10163.5.2"
#define ANSI_INTERMARC          	"1.2.840.10003.5.2"
#define ISO_CCF                	 	"1.0.10163.5.3"
#define ANSI_CCF                	"1.2.840.10003.5.3"
#define ISO_USMARC              	"1.0.10163.5.10"
#define ANSI_USMARC             	"1.2.840.10003.5.10"
#define ISO_UKMARC              	"1.0.10163.5.11"
#define ANSI_UKMARC             	"1.2.840.10003.5.11"
#define ISO_NORMARC             	"1.0.10163.5.12"
#define ANSI_NORMARC            	"1.2.840.10003.5.12"
#define ISO_LIBRISMARC          	"1.0.10163.5.13"
#define ANSI_LIBRISMARC         	"1.2.840.10003.5.13"
#define ISO_DANMARC             	"1.0.10163.5.14"
#define ANSI_DANMARC            	"1.2.840.10003.5.14"
#define ISO_FINMARC             	"1.0.10163.5.15"
#define ANSI_FINMARC            	"1.2.840.10003.5.15"
#define ISO_MAB                 	"1.0.10163.5.16"
#define ANSI_MAB                	"1.2.840.10003.5.16"
#define ISO_CANMARC             	"1.0.10163.5.17"
#define ANSI_CANMARC            	"1.2.840.10003.5.17"
#define ISO_SBN				"1.0.10163.5.18"
#define ANSI_SBN			"1.2.840.10003.5.18"
#define ISO_PICAMARC			"1.0.10163.5.19"
#define ANSI_PICAMARC			"1.2.840.10003.5.19"
#define ISO_AUSMARC			"1.0.10163.5.20"
#define ANSI_AUSMARC			"1.2.840.10003.5.20"

#define ISO_EXPLAIN_RECORD		"1.0.10163.5.100"
#define ANSI_EXPLAIN_RECORD		"1.2.840.10003.5.100"
#define ISO_UNSTRUCTURED_TEXT_RECORD	"1.0.10163.5.101"
#define ANSI_UNSTRUCTURED_TEXT_RECORD	"1.2.840.10003.5.101"
#define ISO_OPAC_RECORD			"1.0.10163.5.102"
#define ANSI_OPAC_RECORD		"1.2.840.10003.5.102"
#define ISO_SUMMARY_RECORD		"1.0.10163.5.103"
#define ANSI_SUMMARY_RECORD		"1.2.840.10003.5.103"
#define ISO_GENERIC_RECORD		"1.0.10163.5.105"
#define ANSI_GENERIC_RECORD		"1.2.840.10003.5.105"
#define ISO_ES_TASK_PACKAGE_RECORD	"1.0.10163.5.106"     
#define ANSI_ES_TASK_PACKAGE_RECORD	"1.2.840.10003.5.106"




/* -------------- Object Identifier (Attribute-Set) -----------*/  

#define ISO_ATTRIBUTE_SET_BIB_1		"1.0.10163.3.1"
#define ANSI_ATTRIBUTE_SET_BIB_1	"1.2.840.10003.3.1"


#define ANSI_ATTRIBUTE_SET_EXP_1	"1.2.840.10003.3.2"
#define ANSI_ATTRIBUTE_SET_CIP_1	"1.2.840.10003.3.2000.99.1"



/* -------------- Object Identifier (Diagnostic-Set) -----------*/  

#define ISO_DIAGNOSTIC_SET_BIB_1      	"1.0.10163.4.1"
#define ANSI_DIAGNOSTIC_SET_BIB_1     	"1.2.840.10003.4.1"





/* -------------- Object Identifier (Resource-Report) -----------*/  

#define ISO_RESOURCE_REPORT_1        	"1.0.10163.7.1"
#define ANSI_RESOURCE_REPORT_1       	"1.2.840.10003.7.1"
#define ISO_RESOURCE_REPORT_2        	"1.0.10163.7.2"
#define ANSI_RESOURCE_REPORT_2       	"1.2.840.10003.7.2"



/* -------------- Object Identifier (PERSISTENT QUERY Extended Service) -----*/  
#define ISO_PERSISTENTQUERY_EXTENDED_SERVICE	"1.0.10163.9.2"
#define ANSI_PERSISTENTQUERY_EXTENDED_SERVICE	"1.2.840.10003.9.2"



/* -------------- Object Identifier (ITEM ORDER Extended Service) -----------*/  
#define ISO_ITEMORDER_EXTENDED_SERVICE	"1.0.10163.9.4"
#define ANSI_ITEMORDER_EXTENDED_SERVICE	"1.2.840.10003.9.4"


/* -------------- Object Identifier (ILL PDU) -----------*/  

#define ISO_ILL_PDU			"1.2.10161.2.1"



/* ILL DbvExtension ulIdentifier int->ANY mappings */

#define SUBITO_ADDITIONAL_INFO				800			



/* -------------- Object Identifier (UPDATE Extended Service) -----------*/  

#define ISO_UPDATE_EXTENDED_SERVICE	"1.0.10163.9.5"
#define ANSI_UPDATE_EXTENDED_SERVICE	"1.2.840.10003.9.5"



/* -------------- Object Identifier (Access Control Formats) -----------*/  

#define ISO_ACCESS_PROMPT_1        	"1.0.10163.8.1"
#define ANSI_ACCESS_PROMPT_1       	"1.2.840.10003.8.1"






/* ---- Object Identifier (Crossnet developed for ESA (Esrin) ) ---- */  

/* 70 = implementor id of ESA (Esrin) */


#define ESRIN_PRINT        	"1.2.840.10003.9.1000.70.1"
#define ESRIN_ALERT        	"1.2.840.10003.9.1000.70.2"
#define ESRIN_ORDER        	"1.2.840.10003.9.4.1000.70.1"


/* -------------- Object Identifier (User Information Formats) -----------*/  

#define ISO_CHARSET_AND_LANGUAGE_NEGOTIATION		"1.0.10163.10.2"
#define ANSI_CHARSET_AND_LANGUAGE_NEGOTIATION        	"1.2.840.10003.10.2"





/* -------------- Record Syntax "UnstructuredText" ----------------*/

typedef DbvInternationalString   DbvUnstructuredText;        




/* -------------- Record Syntax "OpacRecord" ----------------*/

typedef struct DbvCircRecord {
DbvBool                     fAvailableNow;
DbvInternationalString     *psAvailabilityDate;
DbvInternationalString     *psAvailableThru;
DbvInternationalString     *psRestrictions;
DbvInternationalString     *psItemId;
DbvBool                     fRenewable;
DbvBool                     fOnHold;
DbvInternationalString     *psEnumAndChron;
DbvInternationalString     *psMidspine;
DbvInternationalString     *psTemporaryLocation;
} DbvCircRecord;


typedef struct DbvVolume {
DbvInternationalString        *psEnumeration;
DbvInternationalString        *psChronology;
DbvInternationalString        *psEnumAndChron;
} DbvVolume;


typedef struct DbvHoldingsAndCircData {
DbvInternationalString        *psTypeOfRecord;
DbvInternationalString        *psEncodingLevel;
DbvInternationalString        *psFormat;
DbvInternationalString        *psReceiptAcqStatus;
DbvInternationalString        *psGeneralRetention;
DbvInternationalString        *psCompleteness;
DbvInternationalString        *psDateOfReport;
DbvInternationalString        *psNucCode;
DbvInternationalString        *psLocalLocation;
DbvInternationalString        *psShelvingLocation;
DbvInternationalString        *psCallNumber;
DbvInternationalString        *psShelvingData;
DbvInternationalString        *psCopyNumber;
DbvInternationalString        *psPublicNote;
DbvInternationalString        *psReproductionNote;
DbvInternationalString        *psTermsUseRepro;
DbvInternationalString        *psEnumAndChron;
DbvVolume                    **ppsVolume;
DbvCircRecord                **ppsCircRecord;
} DbvHoldingsAndCircData;



typedef enum DbvHoldingsRecType {
	HRT_MarcHoldingsRecord	= 1,	
	HRT_HoldingsAndCirc	= 2
} DbvHoldingsRecType;
	

typedef struct DbvHoldingsRecord {
DbvHoldingsRecType	eHoldingsRecType;
union {
    DbvASN1External         sMarcHoldingsRecord;
    DbvHoldingsAndCircData  sHoldingsAndCirc;
  }                   uMarcOrHoldAndCirc; 
} DbvHoldingsRecord;


typedef struct DbvOpacRecord {
DbvASN1External         *psBibliographicRecord;
DbvHoldingsRecord      **ppsHoldingsData;
} DbvOpacRecord;



/* -------------- Record Syntax "SummaryRecord" ----------------*/

typedef struct DbvFormatSpec {
DbvInternationalString          sType;
Ulong                          *pulSize;
Ulong                          *pulBestPosn;
} DbvFormatSpec;



typedef struct DbvSummaryRecord {
DbvInternationalString           sTitle;
DbvInternationalString          *psAuthor;
DbvInternationalString          *psCallNumber;
DbvInternationalString          *psRecordType;
DbvInternationalString          *psBibliographicLevel;
DbvFormatSpec                  **ppsFormat;
DbvInternationalString          *psPublicationPlace;
DbvInternationalString          *psPublicationDate;
DbvInternationalString          *psTargetSystemKey;
DbvInternationalString          *psSatisfyingElement;
Ulong                           *pulRank;
DbvInternationalString          *psDocumentId;
DbvInternationalString          *psAbstract;
DbvOtherInformation            **ppsOtherInformation;
} DbvSummaryRecord;




/* -------------- Record Syntax "Resource Report" ----------------*/

typedef enum DbvEstimateType {
                 ET_CurrentSearchRecords    = 1,
                 ET_FinalSearchRecords      = 2,
                 ET_CurrentPresentRecords   = 3,
                 ET_FinalPresentRecords     = 4,
                 ET_CurrentOpTimeProcessing = 5,
                 ET_FinalOpTimeProcessing   = 6,
                 ET_CurrentAssocTime        = 7,
                 ET_CurrentOperationCost    = 8,
                 ET_FinalOperationCost      = 9,
                 ET_CurrentAssocCost        = 10,
                 ET_FinalOpTimeElapsed      = 11,
                 ET_PercentComplete         = 12,
                 ET_CurrentSearchAssocCost  = 13,
                 ET_CurrentPresentAssocCost = 14,
                 ET_CurrentConnectAssocCost = 15,
                 ET_CurrentOtherAssocCost   = 16,
                 ET_Invalid                 = -1
} DbvEstimateType;


typedef struct DbvEstimate1 {
DbvEstimateType          eEstimateType;
Ulong                    ulValue;
Ulong                   *pulCurrencyCode;
} DbvEstimate1;


typedef struct DbvResourceReport1 {
DbvEstimate1                **ppsEstimate;
DbvInternationalString       sMessage;
} DbvResourceReport1;


typedef struct DbvEstimate2 {
DbvStringOrNumeric       sType;
DbvIntUnit               sValue;
} DbvEstimate2;

typedef struct DbvResourceReport2 {
DbvEstimate2               **ppsEstimate;
DbvInternationalString      *psMessage;
} DbvResourceReport2;





/* -------------- Record Syntax "Extended Services Task Package" ------------*/


typedef enum DbvExtServicesTaskStatus {
                 ESTS_Pending  = 1,
                 ESTS_Active   = 2,
                 ESTS_Complete = 3,
                 ESTS_Aborted  = 4,
                 ESTS_Invalid  = -1 
} DbvExtServicesTaskStatus;
                 


typedef struct DbvEsTaskPackage {
DbvObjectIdentifier                  pcPackageType;     
DbvInternationalString              *psPackageName;
DbvInternationalString              *psUserId;
DbvIntUnit                          *psRetentionTime;  
DbvPermissions                     **ppsPermissions;
DbvInternationalString              *psDescription;
DbvOctetString                      *psTargetReference;
DbvGeneralizedTime                   pcCreationDateTime;
DbvExtServicesTaskStatus             eExtServicesTaskStatus;
DbvDiagRec                         **ppsPackageDiagnostics;
DbvASN1External                      sTaskSpecificParameters;
} DbvEsTaskPackage;





/* -------------  UPDATE  EXTENDED SERVICE ---------------- */

typedef enum DbvUpdtAction {
                         UA_RecordInsert  = 1,
                         UA_RecordReplace = 2,
                         UA_RecordDelete  = 3,
                         UA_ElementUpdate = 4,
                         UA_Invalid       = -1
} DbvUpdtAction;



typedef enum DbvUpdtTaskStatus {
                 UTS_Success  = 1,
                 UTS_Partial  = 2,
                 UTS_Failure  = 3,
                 UTS_Invalid  = -1 
} DbvUpdtTaskStatus;


typedef enum DbvUpdtRecordStatus {
                 URST_Success   = 1,
                 URST_Queued    = 2,
                 URST_InProcess = 3,
                 URST_Failure   = 4,
                 URST_Invalid   = -1 
} DbvUpdtRecordStatus;


typedef enum DbvUpdtRecordOrDiagType {
                 URDT_Record     = 1,
                 URDT_Diagnostic = 2         
} DbvUpdtRecordOrDiagType; 


typedef enum DbvUpdtSupplementalIdType {
                USIT_Time            = 1,
                USIT_Version         = 2,
                USIT_PreviousVersion = 3
} DbvUpdtSupplementalIdType;


typedef enum DbvUpdtRecordIdType {
                URIT_Number = 1,
                URIT_String = 2,
                URIT_Opaque = 3
} DbvUpdtRecordIdType;


typedef struct DbvUpdtRecordOrDiag {
DbvUpdtRecordOrDiagType      eUpdtRecordOrDiag;
union {
    DbvASN1External      *psRecord;
    DbvDiagRec           *psDiagnostic;
  }                          uUpdtRecordOrDiag;
} DbvUpdtRecordOrDiag;


typedef struct DbvCorrelationInfo {
DbvInternationalString  *psNote;
Ulong                   *pulId;
} DbvCorrelationInfo;


typedef struct DbvTaskPackageRecord {
DbvUpdtRecordOrDiag       *psUpdtRecordOrDiag;
DbvCorrelationInfo        *psCorrelationInfo;
DbvUpdtRecordStatus        eUpdtRecordStatus;
} DbvTaskPackageRecord;


typedef struct DbvUpdateTargetPart {
DbvUpdtTaskStatus           eTaskStatus;
DbvDiagRec                **ppsGlobalDiagnostics;
DbvTaskPackageRecord      **ppsTaskPackageRecord;
} DbvUpdateTargetPart;


typedef struct DbvUpdtSupplementalId {
DbvUpdtSupplementalIdType     eSupplementalIdType;
union {
    DbvGeneralizedTime      pcTime;
    DbvInternationalString *psVersion;
    DbvASN1External        *psPreviousVersion;
  }                           uUpdtSupplementalId;
} DbvUpdtSupplementalId;


typedef struct DbvUpdtRecordId {
DbvUpdtRecordIdType   eRecordIdType;
union {
    Ulong                   ulNumber;
    DbvInternationalString *psString;
    DbvOctetString         *psOpaque;
  }                   uUpdtRecordId;
} DbvUpdtRecordId;


typedef struct DbvSuppliedRecord {
DbvUpdtRecordId            *psUpdtRecordId;
DbvUpdtSupplementalId      *psUpdtSupplementalId;
DbvCorrelationInfo         *psCorrelationInfo;
DbvASN1External             sRecord;
} DbvSuppliedRecord;


typedef struct DbvOriginPartToKeep {
DbvUpdtAction               eAction;
DbvInternationalString      sDatabaseName;
DbvObjectIdentifier         pcSchema;      
DbvInternationalString     *psElementSetName;
} DbvOriginPartToKeep;


typedef struct DbvUpdateTaskPackage {
DbvOriginPartToKeep      sOriginPartToKeep;
DbvUpdateTargetPart      sTargetPart;
} DbvUpdateTaskPackage;


typedef struct DbvUpdateRequestPackage {
DbvOriginPartToKeep    sOriginPartToKeep;
DbvSuppliedRecord    **ppsSuppliedRecord;
} DbvUpdateRequestPackage;


typedef enum DbvUpdateReqOrRsp {
                    UROR_Request  = 1,
                    UROR_Response = 2
} DbvUpdateReqOrRsp;


typedef struct DbvUpdateExtendedService {
DbvUpdateReqOrRsp     eUpdateReqRsp;
union {
    DbvUpdateRequestPackage  *psUpdateRequest;
    DbvUpdateTaskPackage     *psUpdateResponse;
  }                uUpdateReqOrRsp;
} DbvUpdateExtendedService;







/* Structures associated with SR-/Z39.50 functions */

/* For the SR-/Z39.50 service request and response structures.refer to the 
annex. */


typedef struct DbvOriginData {
  DbvOriginEvent		eOriginEvent;
  union {
    DbvInitializeRsp	    *psInitializeRsp;
    DbvSearchRsp	    *psSearchRsp;
    DbvPresentRsp	    *psPresentRsp;
    DbvDeleteResultSetRsp   *psDeleteResultSetRsp;
    DbvScanRsp		    *psScanRsp;
    DbvResourceReportRsp    *psResourceReportRsp;
    DbvSegmentReq	    *psSegmentReq;
    DbvSortRsp		    *psSortRsp;
    DbvCloseReq	            *psCloseReq;
    DbvExtendedServicesRsp  *psExtendedServicesRsp;
/*     DbvReleaseReq	    *peReleaseReq;   Target is not allowed to close the
                                             association */
    DbvOctetString          *psInvalidAPDU;

    struct DbvAccessControlReq			*psAccessControlReq; /* AccessControlRequest from target */
    struct DbvResourceControlReq		*psResourceControlReq; /* ResourceControlRequest from target */


  }	uOriginData;
} DbvOriginData;

typedef struct DbvTargetData {
  DbvTargetEvent	eTargetEvent;
  union {
    DbvInitializeReq		*psInitializeReq;
    DbvSearchReq		*psSearchReq;
    DbvPresentReq		*psPresentReq;
    DbvDeleteResultSetReq	*psDeleteResultSetReq;
    DbvScanReq	        	*psScanReq;
    DbvResourceReportReq	*psResourceReportReq;
    DbvSortReq	        	*psSortReq;
    DbvCloseReq	        	*psCloseReq;
    DbvExtendedServicesReq    	*psExtendedServicesReq;
    DbvReleaseReq		*peReleaseReq;
    DbvOctetString              *psInvalidAPDU;

    struct DbvAccessControlRsp			*psAccessControlRsp; /* AccessControlResponse from origin */
    struct DbvResourceControlRsp		*psResourceControlRsp; /* ResourceControlResponse from origin */
    struct DbvTriggerResourceControlReq	*psTriggerResourceControlReq; /* TriggerResourceControlResponse from origin */

  }			uTargetData;
} DbvTargetData;


#endif


