#include "api_pdu_print2.h"



int print_explain_external(FILE *f, DbvASN1External *external_ptr)
{
        fprintf(f,"\tpsExplainRecord:\n");

	fprintf(f,"eExplainRecordType: ");


	/* If not NULL */
	if (external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord) {

		switch(external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->eExplainRecordType) {
		case ERT_TargetInfo:
			fprintf(f,"ERT_TargetInfo\n");
			print_DbvTargetInfo(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psTargetInfo);
			break;

		case ERT_DatabaseInfo:
			fprintf(f,"ERT_DatabaseInfo\n");
			print_DbvDatabaseInfo(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psDatabaseInfo);

			break;
	
		case ERT_SchemaInfo:
			fprintf(f,"ERT_SchemaInfo\n");
			print_DbvSchemaInfo(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psSchemaInfo);
			break;

		case ERT_TagSetInfo:
			fprintf(f,"ERT_TagSetInfo\n");
			print_DbvTagSetInfo(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psTagSetInfo);
			break;

		case ERT_RecordSyntaxInfo:
			fprintf(f,"ERT_RecordSyntaxInfo\n");
			print_DbvRecordSyntaxInfo(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psRecordSyntaxInfo);
			break;
	
		case ERT_AttributeSetInfo:
			fprintf(f,"ERT_AttributeSetInfo\n");
			print_DbvAttributeSetInfo(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psAttributeSetInfo);
			break;

		case ERT_TermListInfo:
			fprintf(f,"ERT_TermListInfo\n");
			print_DbvTermListInfo(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psTermListInfo);
			break;

		case ERT_ExtendedServicesInfo:
			fprintf(f,"ERT_ExtendedServicesInfo\n");
			print_DbvExtendedServicesInfo(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psExtendedServicesInfo);

			break;

		case ERT_AttributeDetails:
			fprintf(f,"ERT_AttributeDetails\n");
			print_DbvAttributeDetails(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psAttributeDetails);

			break;

		case ERT_TermListDetails:
			fprintf(f,"ERT_TermListDetails\n");
			print_DbvTermListDetails(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psTermListDetails);

			break;

		case ERT_ElementSetDetails:
			fprintf(f,"ERT_ElementSetDetails\n");
			print_DbvElementSetDetails(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psElementSetDetails);

			break;

		case ERT_RetrievalRecordDetails:
			fprintf(f,"ERT_RetrievalRecordDetails\n");
			print_DbvRetrievalRecordDetails(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psRetrievalRecordDetails);

			break;

		case ERT_SortDetails:
			fprintf(f,"ERT_SortDetails\n");
			print_DbvSortDetails(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psSortDetails);

			break;

		case ERT_Processing:
			fprintf(f,"ERT_Processing\n");
			print_DbvProcessingInformation(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psProcessing);

			break;

		case ERT_Variants:
			fprintf(f,"ERT_Variants\n");
			print_DbvVariantSetInfo(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psVariants);

			break;

		case ERT_Units:
			fprintf(f,"ERT_Units\n");
			print_DbvUnitInfo(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psUnits);

			break;
	
		case ERT_CategoryList:
			fprintf(f,"ERT_CategoryList\n");
			print_DbvCategoryList(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord->uExplainRecord.psCategoryList);

			break;
		}
	}
}




/* -------------------- DbvTargetInfo -------------------- */

void print_DbvTargetInfo(FILE *f, DbvTargetInfo *psTargetInfo)
   {


   /* Write the title out */ 
   if (psTargetInfo == NULL)
      {
      fprintf(f, "psTargetInfo: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psTargetInfo:\n");
   

   /* psCommonInfo */
   print_DbvCommonInfo(f,  "psCommonInfo", psTargetInfo->psCommonInfo);

   /* sName */
   fprintf(f,  "sName: ");
   print_inter_string(f,  &psTargetInfo->sName);

   /* ppsRecentNews */
   printN_DbvHumanString(f, "ppsRecentNews", psTargetInfo->ppsRecentNews);

   /* ppsIcon */
   printN_DbvIconObject(f, "ppsIcon", psTargetInfo->ppsIcon);

   /* fNamedResultSets */
   fprintf(f,"fNamedResultSets: ");
   print_bool(f, &psTargetInfo->fNamedResultSets);
   

   /* fMultipleDBSearch */
   fprintf(f,"fMultipleDBSearch:" );
   print_bool(f, &psTargetInfo->fMultipleDBSearch);
   

   /* pulMaxResultSets */
   fprintf(f, "pulMaxResultSets: ");
   print_Ulong(f, psTargetInfo->pulMaxResultSets);



   /* pulMaxResultSize */
   fprintf(f, "pulMaxResultSize: ");
   print_Ulong(f, psTargetInfo->pulMaxResultSize);
 

   /* pulMaxTerms */
   fprintf(f, "pulMaxTerms: ");
   print_Ulong(f, psTargetInfo->pulMaxTerms);
 

   /* psTimeoutInterval */
   fprintf(f, "psTimeoutInterval: ");
   print_intunit(f,  psTargetInfo->psTimeoutInterval);

   /* ppsWelcomeMessage */
   printN_DbvHumanString(f, "ppsWelcomeMessage", 
			  psTargetInfo->ppsWelcomeMessage);

   /* psContactInfo */
   print_DbvContactInfo(f, "psContactInfo", psTargetInfo->psContactInfo);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psTargetInfo->ppsDescription);

   /* ppsNicknames */
   printN_DbvInternationalString(f, "ppsNicknames",
			  psTargetInfo->ppsNicknames);

   /* ppsUsageRest */
   printN_DbvHumanString(f, "ppsUsageRest", psTargetInfo->ppsUsageRest);

   /* ppsPaymentAddr */
   printN_DbvHumanString(f, "ppsPaymentAddr", psTargetInfo->ppsPaymentAddr);

   /* ppsHours */
   printN_DbvHumanString(f, "ppsHours", psTargetInfo->ppsHours);

   /* ppsDbCombinations */
   printN_DbvDatabaseList(f, "ppsDbCombinations",
			  psTargetInfo->ppsDbCombinations);

   /* ppsAddresses */
   printN_DbvNetworkAddress(f, "ppsAddresses", psTargetInfo->ppsAddresses);

   /* ppsLanguages */
   printN_DbvInternationalString(f, "ppsLanguages",
			  psTargetInfo->ppsLanguages);

   /* psCommonAccessInfo */
   print_DbvAccessInfo(f, "psCommonAccessInfo", psTargetInfo->psCommonAccessInfo);

   } /* End print_DbvTargetInfo() */



void 
print_Ulong(FILE *f, Ulong *pulMaxResultSets)
{
	if (pulMaxResultSets == NULL) {
		fprintf(f, "NULL\n");
		return;
	}

	fprintf(f, "%ld\n", *pulMaxResultSets);
}
   


void print_DbvCommonInfo(FILE *f, char *name, DbvCommonInfo *psCommonInfo)
   {

   /* Write the title out */ 
   if (psCommonInfo == NULL)
      {
      fprintf(f, "%s: NULL\n", name);
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", name);
   


   /* pcDateAdded */
   print_DbvGeneralizedTime(f,  "pcDateAdded", psCommonInfo->pcDateAdded);

   /* pcDateChanged */
   print_DbvGeneralizedTime(f,  "pcDateChanged", psCommonInfo->pcDateChanged);

   /* pcExpiry */
   print_DbvGeneralizedTime(f,  "pcExpiry", psCommonInfo->pcExpiry);


   /* psHumanStringLanguage */
   print_DbvLanguageCode(f,  "psHumanStringLanguage", 
			   psCommonInfo->psHumanStringLanguage);


   /* ppsOtherInformation */
   fprintf(f, "ppsOtherInformation: ");
   print_otherinfo(f, psCommonInfo->ppsOtherInformation);
   
   } /* End print_DbvCommonInfo() */



void print_DbvGeneralizedTime(FILE *f, char *name, DbvGeneralizedTime psGeneralizedTime)
   {

   if ( psGeneralizedTime != NULL )
      {
      fprintf(f, "%s: %s\n", name, psGeneralizedTime );
      } /* End if */
   else
      fprintf(f, "%s : NULL\n", name);


   } /* End print_DbvGeneralizedTime() */





void print_DbvLanguageCode(FILE *f, char *name,DbvLanguageCode *psLanguageCode )
   {

   fprintf(f, "%s: ", name);
   print_octet_string(f, (DbvOctetString *)psLanguageCode);

   } /* End print_DbvLanguageCode() */



void printN_DbvHumanString(FILE *f, char *name, 
			    DbvHumanString **ppsHumanString )
   {

   if( ppsHumanString != NULL)
      {
      fprintf(f, "%s: \n", name);
      

      while( ppsHumanString && *ppsHumanString )
         {
         print_DbvHumanString(f, "psHumanString", *ppsHumanString);
         ppsHumanString++;
	 fprintf(f, "\n");
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */
     
   } /* End printN_DbvHumanString() */



void print_DbvHumanString(FILE *f, char *name, DbvHumanString *psHumanString)
   {

   /* Write the title out */ 
   if (psHumanString == NULL)
      {
      fprintf(f, "%s: NULL\n", name);
      return;
      } /* End if */

   fprintf(f, "%s:\n", name);
   

   /* psLanguage */
   print_DbvLanguageCode(f, "psLanguage", psHumanString->psLanguage);

   /* psText */
   fprintf(f, "sText: ");
   print_inter_string(f, &psHumanString->sText);

   } /* End print_DbvHumanString() */



void printN_DbvIconObject(FILE *f, char *name, DbvIconObject **ppsIconObject)
   {

   if( ppsIconObject != NULL)
      {
      fprintf(f, "%s:\n", name);

      while( ppsIconObject && *ppsIconObject )
         {
         print_DbvIconObject(f,  *ppsIconObject);
         ppsIconObject++;
	 fprintf(f, "\n");
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */

     
   } /* End printN_DbvIconObject() */



void print_DbvIconObject(FILE *f, DbvIconObject *psIconObject)
   {


   /* Write the title out */ 
   if (psIconObject == NULL)
      {
      fprintf(f, "psIconObject: NULL\n");
      
      return;
      } /* End if */

   fprintf(f, "psIconObject:\n");

   /* psBodyType */
   print_DbvBodyType(f, &psIconObject->sBodyType);
				
   /* sContent */
   fprintf(f, "sContent: ");
   print_octet_string(f, &psIconObject->sContent);

   } /* End print_DbvIconObject() */



void print_DbvBodyType(FILE *f, DbvBodyType *psBodyType)
   {

   /* Write the title out */ 
   if (psBodyType == NULL)
      {
      fprintf(f, "psBodyType: NULL\n");
      
      return;
      } /* End if */

   fprintf(f, "psBodyType:\n");
   


   /* eBodyTypeType */
   fprintf(f, "eBodyTypeType: ");
   print_DbvBodyTypeType(f, &psBodyType->eBodyTypeType);

   /* uBodyType */
   switch( psBodyType->eBodyTypeType )
      {
      case BTT_IanaType:
	 fprintf( f, "psIanaType: ");
	 print_inter_string(f, psBodyType->uBodyType.psIanaType);
				 
	 break;

      case BTT_Z3950Type:
	 fprintf( f, "psZ3950Type: ");
	 print_inter_string(f, psBodyType->uBodyType.psZ3950Type);
	 break;

      case BTT_OtherType:
	 fprintf( f, "psOtherType: ");
	 print_inter_string(f, psBodyType->uBodyType.psOtherType);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvBodyType() */



void print_DbvBodyTypeType(FILE *f, DbvBodyTypeType *peBodyTypeType)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *peBodyTypeType == BTT_IanaType)
         strcpy(temp, "BTT_IanaType");

      if( *peBodyTypeType == BTT_Z3950Type)
         strcpy(temp, "BTT_Z3950Type");

      if( *peBodyTypeType == BTT_OtherType)
         strcpy(temp, "BTT_OtherType");

      if( *peBodyTypeType == BTT_Invalid)
         strcpy(temp, "BTT_Invalid");

         fprintf(f, "%s\n", temp);

   } /* End print_DbvBodyTypeType() */



void print_DbvContactInfo(FILE *f, char *name, DbvContactInfo *psContactInfo)
   {

   /* Write the title out */ 
   if (psContactInfo == NULL)
      {
      fprintf(f, "psContactInfo: NULL\n");
      
      return;
      } /* End if */

   fprintf(f, "psContactInfo:\n");
   


   /* psName */
   fprintf(f, "psName: ");
   print_inter_string(f, psContactInfo->psName);
				
   /* ppsDescription */
   printN_DbvHumanString(f,  "ppsDescription",
			  psContactInfo->ppsDescription);

   /* ppsAddress */
   printN_DbvHumanString(f,  "ppsAddress",
			  psContactInfo->ppsAddress);

   /* psEmail */
   fprintf(f,  "psEmail: ");
   print_inter_string(f,  psContactInfo->psEmail);

   /* psPhone */
   fprintf(f,  "psPhone: ");
   print_inter_string(f, psContactInfo->psPhone);

   } /* End print_DbvContactInfo() */




void printN_DbvInternationalString(FILE *f, char *name, DbvInternationalString **ppsInternationalString)
   {

   if( ppsInternationalString != NULL)
      {
      fprintf(f, "%s:\n", name);

      while( ppsInternationalString && *ppsInternationalString )
         {
         fprintf(f,  "psInternationalString: ");
         print_inter_string(f,  *ppsInternationalString);
         ppsInternationalString++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */
     
   } /* End printN_DbvInternationalString() */



void printN_DbvDatabaseList(FILE *f, char *name, DbvDatabaseList **ppsDbCombinations)
   {

   if( ppsDbCombinations != NULL)
      {
      fprintf(f, "%s:\n", name);
      while( ppsDbCombinations && *ppsDbCombinations )
         {
         print_DbvDatabaseList(f, "psDbCombinations", *ppsDbCombinations);
         ppsDbCombinations++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */

     
   } /* End printN_DbvDatabaseList() */



void print_DbvDatabaseList(FILE *f, char *name, DbvDatabaseList *psDbCombinations)
   {
   printN_DbvInternationalString(f, name, psDbCombinations->ppsInnerDatabases);

   } /* End print_DbvDatabaseList() */



void printN_DbvNetworkAddress(FILE *f, char *name, DbvNetworkAddress **ppsNetworkAddress )
   {

   if( ppsNetworkAddress != NULL)
      {
      fprintf(f, "%s:\n", name);
      while( ppsNetworkAddress && *ppsNetworkAddress )
         {
         print_DbvNetworkAddress(f, "psNetworkAddress", *ppsNetworkAddress);
         ppsNetworkAddress++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */

     
   } /* End printN_DbvNetworkAddress() */



void print_DbvNetworkAddress(FILE *f, char *name, DbvNetworkAddress *psNetworkAddress)
   {
   char temp[ STRING_LEN  ];

   /* Write the title out */ 
   if (psNetworkAddress == NULL)
      {
      fprintf(f, "%s: NULL\n", name);
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", name);
   

   /* eNetworkAddressType */
   fprintf(f, "eNetworkAddress: ");
   print_DbvNetworkAddressType(f, &psNetworkAddress->eNetworkAddressType);

   /* uNetworkAddress */
   switch( psNetworkAddress->eNetworkAddressType )
      {
      case NAT_InternetAddress:
	 print_DbvInterAddress(f, "psInternetAddress", psNetworkAddress->uNetworkAddress.psInternetAddress);
	 break;

      case NAT_OsiPresentationAddress:
	 print_DbvOsiPresentationAddress(f, "psOsiPresentationAddress", psNetworkAddress->uNetworkAddress.psOsiPresentationAddress);
	 break;

      case NAT_OtherAddress:
	 print_DbvOtherAddress(f, "psOtherAddress", psNetworkAddress->uNetworkAddress.psOtherAddress);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvNetworkAddress() */



void print_DbvNetworkAddressType(FILE *f, DbvNetworkAddressType *peNetworkAddressType)
   {
   char temp[ SML_BUFFER ];

   if (peNetworkAddressType == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */


      temp[ 0 ] = '\0';

      if( *peNetworkAddressType == NAT_InternetAddress)
         strcpy(temp, "NAT_InternetAddress");

      if( *peNetworkAddressType == NAT_OsiPresentationAddress)
         strcpy(temp, "NAT_OsiPresentationAddress");

      if( *peNetworkAddressType == NAT_OtherAddress)
         strcpy(temp, "NAT_OtherAddress");

      if( *peNetworkAddressType == NAT_Invalid)
         strcpy(temp, "NAT_Invalid");

         fprintf(f, "%s\n", temp);
   } /* End print_DbvNetworkAddressType() */



void print_DbvInterAddress(FILE *f, char *name, DbvInterAddress *psInterAddress)
   {
   char temp[ SML_BUFFER ];


   /* Write the title out */ 
   if (psInterAddress == NULL)
      {
      fprintf(f, "%s: NULL\n", name);
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", name);
   

   /* sHostAddress */
   fprintf(f, "sHostAddress: ");
   print_inter_string(f, &psInterAddress->sHostAddress);

   /* ulPort */
   fprintf(f, "ulPort: ");
   print_Ulong(f, &psInterAddress->ulPort);
   

   } /* End print_DbvInterAddress() */



void print_DbvOsiPresentationAddress(FILE *f, char *name, DbvOsiPresentationAddress *psOsiPresentationAddress)
   {

   /* Write the title out */ 
   if (psOsiPresentationAddress == NULL)
      {
      fprintf(f, "%s: NULL\n",name);
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", name);
   


   /* sPsel */
   fprintf(f, "sPsel: ");
   print_inter_string(f, &psOsiPresentationAddress->sPsel);

   /* psSSel */
   fprintf(f, "psSSel: ");
   print_inter_string(f, psOsiPresentationAddress->psSSel);

   /* psTSel */
   fprintf(f, "psTSel: ");
   print_inter_string(f, psOsiPresentationAddress->psTSel);

   /* sNSap */
   fprintf(f, "sNSap: ");
   print_inter_string(f, &psOsiPresentationAddress->sNSap);

   } /* End print_DbvOsiPresentationAddress() */



void print_DbvOtherAddress(FILE *f, char *name, DbvOtherAddress *psOtherAddress)
   {

   /* Write the title out */ 
   if (psOtherAddress == NULL)
      {
      fprintf(f, "%s: NULL\n",name);
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", name);
   


   /* sType */
   fprintf(f, "sType: ");
   print_inter_string(f, &psOtherAddress->sType);

   /* sAddress */
   fprintf(f, "sAddress: ");
   print_inter_string(f, &psOtherAddress->sAddress);

   } /* End print_DbvOtherAddress() */




void print_DbvAccessInfo(FILE *f, char *name, DbvAccessInfo *psAccessInfo)
   {
   char temp[ STRING_LEN  ];


   /* Write the title out */ 
   if (psAccessInfo == NULL)
      {
      fprintf(f, "%s: NULL\n",name);
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", name);
   

   /* ppsQueryTypesSupported */
   printN_DbvQueryTypeDetails(f, "ppsQueryTypesSupported", psAccessInfo->ppsQueryTypesSupported);

   /* ppcDiagnosticsSets */
   printN_DbvObjectIdentifier(f, "ppcDiagnosticsSets", 
				psAccessInfo->ppcDiagnosticsSets);

   /* ppcAttributeSetIds */
   printN_DbvObjectIdentifier(f, "ppcAttributeSetIds",
				psAccessInfo->ppcAttributeSetIds);

   /* ppcSchemas */
   printN_DbvObjectIdentifier(f, "ppcSchemas", psAccessInfo->ppcSchemas);

   /* ppcRecordSyntaxes */
   printN_DbvObjectIdentifier(f, "ppcRecordSyntaxes", 
				psAccessInfo->ppcRecordSyntaxes);

   /* ppcResourceChallenges */
   printN_DbvObjectIdentifier(f, "ppcResourceChallenges",
				psAccessInfo->ppcResourceChallenges);

   /* ppsRestrictedAccess */
   printN_DbvAccessRestrictions(f, psAccessInfo->ppsRestrictedAccess);

   /* psCostInfo */
   print_DbvCosts(f, psAccessInfo->psCostInfo);

   /* ppcVariantSets */
   printN_DbvObjectIdentifier(f, "ppcVariantSets", 
				psAccessInfo->ppcVariantSets);

   /* ppsElementSetNames */
   printN_DbvInternationalString(f, "ppsElementSetNames",
				 psAccessInfo->ppsElementSetNames);
   /* ppsUnitSystems */
   printN_DbvInternationalString(f, "ppsUnitSystems", 
				  psAccessInfo->ppsUnitSystems);

   } /* End print_DbvAccessInfo() */



void printN_DbvQueryTypeDetails(FILE *f, char *name, DbvQueryTypeDetails **ppsQueryTypeDetails )
   {

   if( ppsQueryTypeDetails != NULL)
      {
      fprintf(f, "%s:\n", name);

      while( ppsQueryTypeDetails && *ppsQueryTypeDetails )
         {
         print_DbvQueryTypeDetails(f, "psQueryTypeDetails",  *ppsQueryTypeDetails);
         ppsQueryTypeDetails++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */
     
   } /* End printN_DbvQueryTypeDetails() */



void print_DbvQueryTypeDetails(FILE *f, char *name, 
		DbvQueryTypeDetails *psQueryTypeDetails)
   {

   /* Write the title out */ 
   if (psQueryTypeDetails == NULL)
      {
      fprintf(f, "%s: NULL\n",name);
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", name);
   

   /* eQueryTypeDetailsType */
   fprintf(f, "eQueryTypeDetailsType: "); 
   print_DbvQueryTypeDetailsType(f, &psQueryTypeDetails->eQueryTypeDetailsType);

   /* uQueryTypeDetails */
   switch( psQueryTypeDetails->eQueryTypeDetailsType )
      {
      case QTDT_Private:
	 print_DbvPrivateCapabilities(f, psQueryTypeDetails->
				       uQueryTypeDetails.psPrivate );
	 break;

      case QTDT_Rpn:
	 print_DbvRpnCapabilities( f, psQueryTypeDetails->
				   uQueryTypeDetails.psRpn);
	 break;

      case QTDT_Iso8777:
	 print_DbvIso8777Capabilities(f,  psQueryTypeDetails->
				       uQueryTypeDetails.psIso8777);
	 break;

      case QTDT_Z39_58:
	 printN_DbvHumanString( f, "ppsZ39_58",
				psQueryTypeDetails->uQueryTypeDetails.ppsZ39_58);
	 break;

      case QTDT_Erpn:
	 print_DbvRpnCapabilities(f,  psQueryTypeDetails->
				   uQueryTypeDetails.psErpn);
	 break;

      case QTDT_RankedList:
	 printN_DbvHumanString( f, "ppsRankedList",
			       psQueryTypeDetails->
			       uQueryTypeDetails.ppsRankedList);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvQueryTypeDetails() */



void print_DbvQueryTypeDetailsType(FILE *f, DbvQueryTypeDetailsType *peQueryTypeDetailsType)
   {
   char temp[ SML_BUFFER ];

   if (peQueryTypeDetailsType == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */


      temp[ 0 ] = '\0';
      if( *peQueryTypeDetailsType == QTDT_Private)
         strcpy(temp, "QTDT_Private");

      if( *peQueryTypeDetailsType == QTDT_Rpn)
         strcpy(temp, "QTDT_Rpn");

      if( *peQueryTypeDetailsType == QTDT_Iso8777)
         strcpy(temp, "QTDT_Iso8777");

      if( *peQueryTypeDetailsType == QTDT_Z39_58)
         strcpy(temp, "QTDT_Z39_58");

      if( *peQueryTypeDetailsType == QTDT_Erpn)
         strcpy(temp, "QTDT_Erpn");

      if( *peQueryTypeDetailsType == QTDT_RankedList)
         strcpy(temp, "QTDT_RankedList");

      if( *peQueryTypeDetailsType == QTDT_Invalid)
         strcpy(temp, "QTDT_Invalid");

         fprintf(f, "%s\n", temp);
   } /* End print_DbvQueryTypeDetailsType() */



void print_DbvPrivateCapabilities(FILE *f, DbvPrivateCapabilities *psPrivateCapabilities)
   {

   /* Write the title out */ 
   if (psPrivateCapabilities == NULL)
      {
      fprintf(f, "%s: NULL\n","psPrivateCapabilities");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psPrivateCapabilities");


   /* ppsOperators */
   printN_DbvOperators(f,  psPrivateCapabilities->ppsOperators);

   /* ppsSearchKey */
   printN_DbvSearchKey(f,  psPrivateCapabilities->ppsSearchKeys);

   /* ppsDescription */
   printN_DbvHumanStringSeq(f, "ppsDescription", 
			  psPrivateCapabilities->ppsDescription);

   } /* End print_DbvPrivateCapabilities() */



void printN_DbvOperators(FILE *f, DbvOperators **ppsOperators)
   {

   if( ppsOperators != NULL)
      {
      fprintf(f, "%s:\n", "ppsOperators");

      while( ppsOperators && *ppsOperators )
         {
         print_DbvOperators(f, *ppsOperators);
         ppsOperators++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsOperators");
      
      } /* End else */

     
   } /* End printN_DbvOperators() */



void print_DbvOperators(FILE *f,  DbvOperators *psOperators)
   {

   /* Write the title out */ 
   if (psOperators == NULL)
      {
      fprintf(f, "%s: NULL\n","psOperators");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psOperators");
   


   /* sOperator */
   fprintf(f, "sOperator: ");
   print_inter_string(f, &psOperators->sOperator);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psOperators->ppsDescription);

   } /* End print_DbvOperators() */



void printN_DbvSearchKey(FILE *f, DbvSearchKey **ppsSearchKey)
   {

   if( ppsSearchKey != NULL)
      {
      fprintf(f, "%s:\n", "ppsSearchKey");

      while( ppsSearchKey && *ppsSearchKey )
         {
         print_DbvSearchKey(f, *ppsSearchKey);
         ppsSearchKey++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsSearchKey");
      
      } /* End else */

     
   } /* End printN_DbvSearchKey() */



void print_DbvSearchKey(FILE *f, DbvSearchKey *psSearchKey)
   {

   /* Write the title out */ 
   if (psSearchKey == NULL)
      {
      fprintf(f, "%s: NULL\n","psSearchKey");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psSearchKey");
   


   /* sSearchKey */
   fprintf(f, "sSearchKey: ");
   print_inter_string(f, &psSearchKey->sSearchKey);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psSearchKey->ppsDescription);

   } /* End print_DbvSearchKey() */



void printN_DbvHumanStringSeq(FILE *f, char *name, DbvHumanStringSeq **ppsDescription)
   {

   if( ppsDescription != NULL)
      {
      fprintf(f, "%s:\n", name);
      
      while( ppsDescription && *ppsDescription )
         {
         print_DbvHumanStringSeq(f, *ppsDescription);
         ppsDescription++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */

     
   } /* End printN_DbvHumanStringSeq() */



void print_DbvHumanStringSeq(FILE *f,  DbvHumanStringSeq *psHumanStringSeq)
   {

   /* Write the title out */ 
   if (psHumanStringSeq == NULL)
      {
      fprintf(f, "%s: NULL\n","psHumanStringSeq");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psHumanStringSeq");
   

   printN_DbvHumanString(f, "ppsHumanString", psHumanStringSeq->ppsHumanString);

   } /* End print_DbvHumanStringSeq() */



void print_DbvRpnCapabilities(FILE *f, DbvRpnCapabilities *psRpnCapabilities)
   {

   /* Write the title out */ 
   if (psRpnCapabilities == NULL)
      {
      fprintf(f, "%s: NULL\n","psRpnCapabilities");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psRpnCapabilities");
   


   /* ppulOperators */
   printN_Ulong(f, "ppulOperators", psRpnCapabilities->ppulOperators);

   /* fResultSetAsOperandSupported */
   fprintf(f, "fResultSetAsOperandSupported: ");
   print_bool(f, &psRpnCapabilities->fResultSetAsOperandSupported);
   

   /* fRestrictionOperandSupported */
   fprintf(f, "fRestrictionOperandSupported: ");
   print_bool(f, &psRpnCapabilities->fRestrictionOperandSupported);
   

   /* psProximity */
   print_DbvProximitySupport(f, psRpnCapabilities->psProximity);

   } /* End print_DbvRpnCapabilities() */



void printN_Ulong(FILE *f, char *name, Ulong **ppsUlong)
   {

   if( ppsUlong != NULL)
      {
      fprintf(f, "%s:\n", name);
      

      while( ppsUlong && *ppsUlong )
         {
         fprintf(f, "psUlong: ");
         print_Ulong(f, *ppsUlong);
	 
         ppsUlong++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */

     
   } /* End printN_Ulong() */


void print_DbvProximitySupport(FILE *f, DbvProximitySupport *psProximitySupport)
   {


   /* Write the title out */ 
   if (psProximitySupport == NULL)
      {
      fprintf(f, "%s: NULL\n","psProximitySupport");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psProximitySupport");
   


   /* fAnySupport */
   fprintf(f, "fAnySupport: ");
   print_bool(f, &psProximitySupport->fAnySupport);
   

   /* ppsUnitsSupported */
   printN_DbvUnitsSupported(f, psProximitySupport->ppsUnitsSupported);

   } /* End print_DbvProximitySupport() */



void printN_DbvUnitsSupported(FILE *f, DbvUnitsSupported **ppsUnitsSupported )
   {

   if( ppsUnitsSupported != NULL)
      {
      fprintf(f, "%s:\n", "ppsUnitsSupported");

      while( ppsUnitsSupported && *ppsUnitsSupported )
         {
         print_DbvUnitsSupported(f, *ppsUnitsSupported);
         ppsUnitsSupported++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsUnitsSupported");
      
      } /* End else */

     
   } /* End printN_DbvUnitsSupported() */



void print_DbvUnitsSupported(FILE *f,  DbvUnitsSupported *psUnitsSupported)
   {
   char temp[ STRING_LEN  ];


   /* Write the title out */ 
   if (psUnitsSupported == NULL)
      {
      fprintf(f, "%s: NULL\n","psUnitsSupported");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psUnitsSupported");
   

   /* eUnitsSupportedType */
   fprintf(f, "eUnitsSupportedType: ");
   print_DbvUnitsSupportedType(f, &psUnitsSupported->eUnitsSupportedType);

   /* uUnitsSupported */
   switch( psUnitsSupported->eUnitsSupportedType )
      {
      case UST_Known:
         fprintf(f, "ulKnown: ");
         print_Ulong(f, &psUnitsSupported->uUnitsSupported.ulKnown );
	 break;

      case UST_Private:
	 print_DbvPrivate(f, psUnitsSupported->uUnitsSupported.psPrivate);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvUnitsSupported() */



void print_DbvUnitsSupportedType(FILE *f, DbvUnitsSupportedType *peUnitsSupportedType)
   {
   char temp[ SML_BUFFER ];

   if (peUnitsSupportedType == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peUnitsSupportedType == UST_Known)
         strcpy(temp, "UST_Known");

      if( *peUnitsSupportedType == UST_Private)
         strcpy(temp, "UST_Private");

      if( *peUnitsSupportedType == UST_Invalid)
         strcpy(temp, "UST_Invalid");

         fprintf(f, "%s\n", temp);
   } /* End print_DbvUnitsSupportedType() */



void print_DbvPrivate(FILE *f,  DbvPrivate *psPrivate)
   {
   char temp[ STRING_LEN  ];

   /* Write the title out */ 
   if (psPrivate == NULL)
      {
      fprintf(f, "%s: NULL\n","psPrivate");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psPrivate");
   


   /* ulUnit */
   fprintf(f, "ulUnit: ");
   print_Ulong(f, &psPrivate->ulUnit );
   

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psPrivate->ppsDescription);


   } /* End print_DbvPrivate() */



void print_DbvIso8777Capabilities(FILE *f, DbvIso8777Capabilities *psIso8777Capabilities)
   {

   /* Write the title out */ 
   if (psIso8777Capabilities == NULL)
      {
      fprintf(f, "%s: NULL\n","psIso8777Capabilities");
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psIso8777Capabilities");
   

   /* ppsSearchKeys */
   printN_DbvSearchKey(f, psIso8777Capabilities->ppsSearchKeys);

   /* ppsRestrictions */
   printN_DbvHumanString(f, "ppsRestrictions", 
			  psIso8777Capabilities->ppsRestrictions);

   } /* End print_DbvIso8777Capabilities() */



void printN_DbvObjectIdentifier(FILE *f, char *name, DbvObjectIdentifier *ppcObjectIdentifier )
   {

   if( ppcObjectIdentifier != NULL)
      {
      fprintf(f, "%s:\n", name);
      while( ppcObjectIdentifier && *ppcObjectIdentifier )
         {
         print_DbvObjectIdentifier(f, "pcObjectIdentifier", *ppcObjectIdentifier);
         ppcObjectIdentifier++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */

     
   } /* End printN_DbvObjectIdentifier() */




void printN_DbvAccessRestrictions(FILE *f, DbvAccessRestrictions **ppsAccessRestrictions)
   {

   if( ppsAccessRestrictions != NULL)
      {
      fprintf(f, "%s:\n", "ppsAccessRestrictions");

      while( ppsAccessRestrictions && *ppsAccessRestrictions )
         {
         print_DbvAccessRestrictions(f, *ppsAccessRestrictions);
         ppsAccessRestrictions++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsAccessRestrictions");
      
      } /* End else */

     
   } /* End printN_DbvAccessRestrictions() */



void print_DbvAccessRestrictions(FILE *f,  DbvAccessRestrictions *psAccessRestrictions)
   {
   char temp[ STRING_LEN ];


   /* Write the title out */ 
   if (psAccessRestrictions == NULL)
      {
      fprintf(f, "%s: NULL\n","psAccessRestrictions");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psAccessRestrictions");
   


   /* eAccessType */
   fprintf(f, "eAccessType: ");
   print_DbvAccessType( f, &psAccessRestrictions->eAccessType);

   /* ppsAccessText */
   printN_DbvHumanString(f, "ppsAccessText", psAccessRestrictions->ppsAccessText);

   /* ppcAccessChallenges */
   printN_DbvObjectIdentifier(f, "ppcAccessChallenges", 
				psAccessRestrictions->ppcAccessChallenges);

   } /* End print_DbvAccessRestrictions() */




void print_DbvAccessType(FILE *f, DbvAccessType *peAccessType)
   {
   char temp[ SML_BUFFER ];

   if (peAccessType == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peAccessType == AT_Any)
         strcpy(temp, "AT_Any");

      if( *peAccessType == AT_Search)
         strcpy(temp, "AT_Search");

      if( *peAccessType == AT_Present)
         strcpy(temp, "AT_Present");

      if( *peAccessType == AT_SpecificElements)
         strcpy(temp, "AT_SpecificElements");

      if( *peAccessType == AT_ExtendedServices)
         strcpy(temp, "AT_ExtendedServices");

      if( *peAccessType == AT_ByDatabase)
         strcpy(temp, "AT_ByDatabase");

      if( *peAccessType == AT_Invalid)
         strcpy(temp, "AT_Invalid");

         fprintf(f, "%s\n", temp);
   } /* End print_DbvAccessType() */





void print_DbvCosts(FILE *f, DbvCosts *psCosts)
   {

   /* Write the title out */ 
   if(psCosts == NULL)
      {
      fprintf(f, "%s: NULL\n", "psCosts");
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psCosts");


   /* psConnectCharge */
   print_DbvCharge(f, psCosts->psConnectCharge);

   /* psConnectTime */
   print_DbvCharge(f, psCosts->psConnectTime);

   /* psDisplayCharge */
   print_DbvCharge(f, psCosts->psDisplayCharge);

   /* psSearchCharge */
   print_DbvCharge(f, psCosts->psSearchCharge);

   /* ppsOtherCharge */
   printN_DbvOtherCharge(f, psCosts->ppsOtherCharge);

   } /* End print_DbvCosts() */



void print_DbvCharge( FILE *f, DbvCharge *psCharge)
   {


   /* Write the title out */ 
   if(psCharge == NULL)
      {
      fprintf(f, "%s: NULL\n", "psCharge");
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psCharge");


   /* sCost */
   print_intunit(f, &psCharge->sCost);

   /* psPerWhat */
   print_DbvUnit(f, psCharge->psPerWhat);

   /* ppsText */
   printN_DbvHumanString(f, "ppsText", psCharge->ppsText);

   } /* End print_DbvCharge() */



void print_DbvUnit( FILE *f, DbvUnit *psPerWhat)
   {

   /* Write the title out */ 
   if(psPerWhat == NULL)
      {
      fprintf(f, "%s: NULL\n", "psPerWhat");
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psPerWhat");

   print_unitused(f, *psPerWhat);
} /* End print_DbvUnit() */



void printN_DbvOtherCharge(FILE *f, DbvOtherCharge **ppsOtherCharge)
   {

   if( ppsOtherCharge != NULL)
      {
      fprintf(f, "%s:\n", "psOtherCharge");

      while( ppsOtherCharge && *ppsOtherCharge )
         {
         print_DbvOtherCharge(f, *ppsOtherCharge);
         ppsOtherCharge++;
         } /* End while */
      } /* End if */
   else
      fprintf(f, "%s: NULL\n", "psOtherCharge");

     
   } /* End printN_DbvOtherCharge() */



void print_DbvOtherCharge(FILE *f, DbvOtherCharge *psOtherCharge)
   {

   /* Write the title out */ 
   if(psOtherCharge == NULL)
      {
      fprintf(f, "%s: NULL\n", "psOtherCharge");
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psOtherCharge");


   /* ppsForWhat */
   printN_DbvHumanString(f, "ppsForWhat", psOtherCharge->ppsForWhat);

   /* sCharge */
   print_DbvCharge(f, &psOtherCharge->sCharge);

   } /* End print_DbvOtherCharge() */



/* -------------------- DbvDatabaseInfo -------------------- */

void print_DbvDatabaseInfo(FILE *f, DbvDatabaseInfo *psDatabaseInfo)
   {


   /* Write the title out */ 
   if (psDatabaseInfo == NULL)
      {
      fprintf(f, "%s: NULL\n","psDatabaseInfo");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psDatabaseInfo");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psDatabaseInfo->psCommonInfo);

   /* sName */
   fprintf(f, "sName: ");
   print_inter_string(f, &psDatabaseInfo->sName);

   /* pvExplainDatabase */
   print_DbvNull(f, "pvExplainDatabase",
		  psDatabaseInfo->pvExplainDatabase);

   /* ppsNicknames */
   printN_DbvInternationalString(f, "ppsNicknames",
				psDatabaseInfo->ppsNicknames);

   /* ppsIcon */
   printN_DbvIconObject(f, "ppsIcon", psDatabaseInfo->ppsIcon);

   /* fUserFee */
   fprintf(f,"fUserFee: ");
   print_bool(f, &psDatabaseInfo->fUserFee);
   

   /* fAvailable */
   fprintf(f, "fAvailable: ");
   print_bool(f, &psDatabaseInfo->fAvailable);
   

   /* ppsTitleString */
   printN_DbvHumanString(f, "ppsTitleString", psDatabaseInfo->ppsTitleString);
   /* ppsKeywords */
   printN_DbvDataBaseInfoSeq(f, "ppsKeywords", psDatabaseInfo->ppsKeywords);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psDatabaseInfo->ppsDescription);

   /* ppsAssociatedDbs */
   printN_DbvInternationalString(f, "ppsAssociatedDbs",
				psDatabaseInfo->ppsAssociatedDbs);

   /* ppsSubDbs */
   printN_DbvInternationalString(f, "ppsSubDbs",
				psDatabaseInfo->ppsSubDbs);
   /* ppsDisclaimers */
   printN_DbvHumanString(f, "ppsDisclaimers", psDatabaseInfo->ppsDisclaimers);

   /* ppsNews */
   printN_DbvHumanString(f, "ppsNews", psDatabaseInfo->ppsNews);

   /* psRecordCount */
   print_DbvRecordCount(f, psDatabaseInfo->psRecordCount);

   /* ppsDefaultOrder */
   printN_DbvHumanString(f, "ppsDefaultOrder", psDatabaseInfo->ppsDefaultOrder);

   /* pulAvRecordSize */
   fprintf(f, "pulAvRecordSize: ");
   print_Ulong(f, psDatabaseInfo->pulAvRecordSize);
   

   /* pulMaxRecordSize */
   fprintf(f, "pulMaxRecordSize: ");
   print_Ulong(f, psDatabaseInfo->pulMaxRecordSize);
   

   /* ppsHours */
   printN_DbvHumanString(f, "ppsHours", psDatabaseInfo->ppsHours);

   /* ppsBestTime */
   printN_DbvHumanString(f, "ppsBestTime",psDatabaseInfo->ppsBestTime);

   /* pcLastUpdate */
   print_DbvGeneralizedTime(f, "pcLastUpdate", psDatabaseInfo->pcLastUpdate);

   /* psUpdateInterval */
   fprintf(f, "psUpdateInterval: ");
   print_intunit(f, psDatabaseInfo->psUpdateInterval);

   /* ppsCoverage */
   printN_DbvHumanString(f, "ppsCoverage",psDatabaseInfo->ppsCoverage);

   /* pfProprietary */
      fprintf(f, "pfProprietary: ");
      print_bool(f, psDatabaseInfo->pfProprietary);
   

   /* ppsCopyrightText */
   printN_DbvHumanString(f, "ppsCopyrightText", psDatabaseInfo->ppsCopyrightText);
   /* ppsCopyrightNotice */
   printN_DbvHumanString(f, "ppsCopyrightNotice",
				psDatabaseInfo->ppsCopyrightNotice);
   /* psProducerContactInfo */
   print_DbvContactInfo(f, "psProducerContactInfo", psDatabaseInfo->psProducerContactInfo);

   /* psSupplierContactInfo */
   print_DbvContactInfo(f, "psSupplierContactInfo", psDatabaseInfo->psSupplierContactInfo);

   /* psSubmissionContactInfo */
   print_DbvContactInfo(f, "psSubmissionContactInfo", psDatabaseInfo->psSubmissionContactInfo);

   /* psAccessInfo */
   print_DbvAccessInfo(f, "psAccessInfo", psDatabaseInfo->psAccessInfo);

   } /* End print_DbvDatabaseInfo() */



void print_DbvNull(FILE *f, char *name, DbvNull pvNull)
   {
                                
   if(pvNull == NULL)
      fprintf(f, "%s: NULL\n",name);
   else 
      fprintf(f, "%s: Value Defined\n",name);

   return;

   } /* End print_DbvNull() */



void printN_DbvDataBaseInfoSeq(FILE *f, char *name, DbvDataBaseInfoSeq **ppsKeywords)
   {
   if( ppsKeywords != NULL)
      {

      fprintf(f, "%s: \n", name);
      
      while( ppsKeywords && *ppsKeywords )
         {
	 fprintf(f, "%s:\n", name);

         print_DbvDataBaseInfoSeq(f, "psKeywords", *ppsKeywords);
         ppsKeywords++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */

     
   } /* End printN_DbvDataBaseInfoSeq() */



void print_DbvDataBaseInfoSeq(FILE *f, char *name, DbvDataBaseInfoSeq *psKeywords)
{
	printN_DbvHumanString(f, name, psKeywords->ppsDataBaseInfo);
} /* End print_DbvDataBaseInfoSeq */



void print_DbvRecordCount(FILE *f, DbvRecordCount *psRecordCount)
   {
   char temp[ STRING_LEN  ];


   /* Write the title out */ 
   if (psRecordCount == NULL)
      {
      fprintf(f, "%s: NULL\n","psRecordCount");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psRecordCount");
   

   /* eRecordCountType */
   fprintf(f, "eRecordCountType: ");
   print_DbvRecordCountType(f, &psRecordCount->eRecordCountType);

   /* uRecordCount */

   switch( psRecordCount->eRecordCountType )
      {
      case RCT_ActualNumber:
         fprintf(f, "ulActualNumber: ");
         print_Ulong(f, &psRecordCount->uRecordCount.ulActualNumber  );
         
	 break;

      case RCT_ApproxNumber:
         fprintf(f, "ulApproxNumber: ");
         print_Ulong(f, &psRecordCount->uRecordCount.ulApproxNumber  );
         
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvRecordCount() */



void print_DbvRecordCountType(FILE *f, DbvRecordCountType *peRecordCountType)
   {
   char temp[ SML_BUFFER ];

   if (peRecordCountType == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peRecordCountType == RCT_ActualNumber)
         strcpy(temp, "RCT_ActualNumber");

      if( *peRecordCountType == RCT_ApproxNumber)
         strcpy(temp, "RCT_ApproxNumber");

      if( *peRecordCountType == RCT_Invalid)
         strcpy(temp, "RCT_Invalid");

         fprintf(f, "%s\n", temp);
   } /* End print_DbvRecordCountType() */



/* -------------------- DbvSchemaInfo -------------------- */

void print_DbvSchemaInfo(FILE *f, DbvSchemaInfo *psSchemaInfo)
   {


   /* Write the title out */ 
   if (psSchemaInfo == NULL)
      {
      fprintf(f, "%s: NULL\n","psSchemaInfo");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psSchemaInfo");
   

   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psSchemaInfo->psCommonInfo);

   /* pcSchema */
   print_DbvObjectIdentifier(f, "pcSchema", psSchemaInfo->pcSchema);

   /* sName */
   fprintf(f, "sName: ");
   print_inter_string(f, &psSchemaInfo->sName);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psSchemaInfo->ppsDescription);

   /* ppsTagTypeMapping */
   printN_DbvTagTypeMapping(f, "ppsTagTypeMapping", psSchemaInfo->ppsTagTypeMapping);

   /* ppsRecordStructure */
   printN_DbvElementInfo(f, "ppsRecordStructure", psSchemaInfo->ppsRecordStructure);

   } /* End print_DbvSchemaInfo() */



void print_DbvObjectIdentifier(FILE *f, char *name, DbvObjectIdentifier psObjectIdentifier)
   {

   if ( psObjectIdentifier != NULL )
      {
      fprintf(f, "%s: %s\n", name, psObjectIdentifier );
      } /* End if */
   else
      fprintf(f, "%s: NULL\n", name);

   } /* End print_DbvObjectIdentifier() */



void printN_DbvTagTypeMapping(FILE *f, char *name, DbvTagTypeMapping **ppsTagTypeMapping )
   {
   if( ppsTagTypeMapping != NULL)
      {
      fprintf(f, "%s:\n", name);

      while( ppsTagTypeMapping && *ppsTagTypeMapping )
         {
         print_DbvTagTypeMapping(f, *ppsTagTypeMapping);
         ppsTagTypeMapping++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      } /* End else */
     
   } /* End printN_DbvTagTypeMapping() */



void print_DbvTagTypeMapping(FILE *f, DbvTagTypeMapping *psTagTypeMapping)
   {


   /* Write the title out */ 
   if (psTagTypeMapping == NULL)
      {
      fprintf(f, "%s: NULL\n","psTagTypeMapping");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psTagTypeMapping");
   


   /* ulTagType */
   fprintf(f, "ulTagType: ");
   print_Ulong(f, &psTagTypeMapping->ulTagType);
   

   /* pcTagSet */
   print_DbvObjectIdentifier(f, "pcTagSet", psTagTypeMapping->pcTagSet);

   /* pvDefaultTagType */
   print_DbvNull(f, "pvDefaultTagType",
		  psTagTypeMapping->pvDefaultTagType);

   } /* End print_DbvTagTypeMapping() */



void printN_DbvElementInfo(FILE *f, char *name, DbvElementInfo **ppsElementInfo)
   {

   if( ppsElementInfo != NULL)
      {
      fprintf(f, "%s:\n", name);

      while( ppsElementInfo && *ppsElementInfo )
         {
         print_DbvElementInfo(f, *ppsElementInfo);
         ppsElementInfo++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */
     
   } /* End printN_DbvElementInfo() */



void print_DbvElementInfo(FILE *f, DbvElementInfo *psElementInfo)
   {

   /* Write the title out */ 
   if (psElementInfo == NULL)
      {
      fprintf(f, "%s: NULL\n","psElementInfo");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psElementInfo");
   


   /* sElementName */
   fprintf(f, "sElementName: ");
   print_inter_string(f, &psElementInfo->sElementName);

   /* ppsElementTagPath */
   printN_DbvPath(f, psElementInfo->ppsElementTagPath);

   /* psDataType */
   print_DbvElementDataType(f, psElementInfo->psDataType);

   /* fRequired */
   fprintf(f, "fRequired: ");
   print_bool(f, &psElementInfo->fRequired);
   

   /* fRepeatable */
   fprintf(f, "fRepeatable: ");
   print_bool(f, &psElementInfo->fRepeatable);
   

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psElementInfo->ppsDescription);

   } /* End print_DbvElementInfo() */



void printN_DbvPath(FILE *f, DbvPath **ppsPath)
   {

   if( ppsPath != NULL)
      {
      fprintf(f, "%s:\n", "ppsPath");

      while( ppsPath && *ppsPath )
         {
         print_DbvPath(f, *ppsPath);
         ppsPath++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsPath");
      
      } /* End else */

     
   } /* End printN_DbvPath() */


void print_DbvPath(FILE *f, DbvPath *psPath)
   {

   /* Write the title out */ 
   if (psPath == NULL)
      {
      fprintf(f, "%s: NULL\n","psPath");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psPath");
   


   /* ulTagType */
   fprintf(f, "ulTagType: ");
   print_Ulong(f, &psPath->ulTagType);
   

   /* sTagValue */
   fprintf(f, "sTagValue: ");
   print_strornum(f, &psPath->sTagValue);

   } /* End print_DbvPath() */



void print_DbvElementDataType(FILE *f, DbvElementDataType *psElementDataType)
   {
   char temp[ STRING_LEN  ];

   /* Write the title out */ 
   if (psElementDataType == NULL)
      {
      fprintf(f, "%s: NULL\n","psElementDataType");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psElementDataType");
   


   /* eElementDataTypeType */
   fprintf(f, "eElementDataType: ");
   print_DbvElementDataTypeType(f, &psElementDataType->eElementDataTypeType);

   /* uElementDataType */
   switch( psElementDataType->eElementDataTypeType )
      {
      case EDTT_Primitive:
	 print_DbvPrimitiveDataType(f, "ePrimitive", 
				     &psElementDataType->
				     uElementDataType.ePrimitive);
	 break;

      case EDTT_Structured:
	 printN_DbvElementInfo(f, "ppsStructured", psElementDataType->
				uElementDataType.ppsStructured);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvElementDataType() */



void print_DbvElementDataTypeType(FILE *f, DbvElementDataTypeType *peElementDataTypeType)
   {
   char temp[ SML_BUFFER ];

   if (peElementDataTypeType == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peElementDataTypeType == EDTT_Primitive)
         strcpy(temp, "EDTT_Primitive");

      if( *peElementDataTypeType == EDTT_Structured)
         strcpy(temp, "EDTT_Structured");

      if( *peElementDataTypeType == EDTT_Invalid)
         strcpy(temp, "EDTT_Invalid");

         fprintf(f, "%s\n", temp);
   } /* End print_DbvElementDataTypeType() */



void print_DbvPrimitiveDataType(FILE *f, char *name, DbvPrimitiveDataType *pePrimitiveDataType)
   {
   char temp[ STRING_LEN  ];


   /* Write the title out */ 
   if(pePrimitiveDataType == NULL)
      {
      fprintf(f, "%s: NULL\n", name);
      
      return;
      } /* End if */

   fprintf(f, "%s: ", name);

   /* ePrimitiveDataType */
   print_DbvPrimitiveDataTypeA(f, pePrimitiveDataType );
  
   } /* End print_DbvPrimitiveDataType() */



void print_DbvPrimitiveDataTypeA(FILE *f, DbvPrimitiveDataType *pePrimitiveDataType)
   {
   char temp[ SML_BUFFER ];

   if (pePrimitiveDataType == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';


	switch (*pePrimitiveDataType) {
	case PDT_OctetString:
		fprintf(f, "PDT_OctetString\n");
		break;  
	case PDT_Numeric:
		fprintf(f, "PDT_Numeric\n");
		break;  
	case PDT_Date:
		fprintf(f, "PDT_Date\n");
		break;  
	case PDT_External:
		fprintf(f, "PDT_External\n");
		break;  
	case PDT_String:
		fprintf(f, "PDT_String\n");
		break;  
	case PDT_TrueOrFalse:
		fprintf(f, "PDT_TrueOrFalse\n");
		break;
	case PDT_Oid:
		fprintf(f, "PDT_Oid\n");
		break;
	case PDT_IntUnit:
		fprintf(f, "PDT_IntUnit\n");
		break;
	case PDT_Empty:
		fprintf(f, "PDT_Empty\n");
		break;
	case PDT_NoneOfTheAbove:
		fprintf(f, "PDT_NoneOfTheAbove\n");
		break;
	case PDT_Invalid:
		fprintf(f, "PDT_Invalid\n");
		break;
	}

/*
      if( *pePrimitiveDataType == PDT_OctetString)
         strcpy(temp, "PDT_OctetString");

      if( *pePrimitiveDataType == PDT_Numeric)
         strcpy(temp, "PDT_Numeric");

      if( *pePrimitiveDataType == PDT_Date)
         strcpy(temp, "PDT_Date");

      if( *pePrimitiveDataType == PDT_External)
         strcpy(temp, "PDT_External");

      if( *pePrimitiveDataType == PDT_String)
         strcpy(temp, "PDT_String");

      if( *pePrimitiveDataType == PDT_TrueOrFalse)
         strcpy(temp, "PDT_TrueOrFalse");

      if( *pePrimitiveDataType == PDT_Oid)
         strcpy(temp, "PDT_Oid");

      if( *pePrimitiveDataType == PDT_IntUnit)
         strcpy(temp, "PDT_IntUnit");

      if( *pePrimitiveDataType == PDT_Empty)
         strcpy(temp, "PDT_Empty");

      if( *pePrimitiveDataType == PDT_NoneOfTheAbove)
         strcpy(temp, "PDT_NoneOfTheAbove");

      if( *pePrimitiveDataType == PDT_Invalid)
         strcpy(temp, "PDT_Invalid");

         fprintf(f, temp);
*/

   } /* End print_DbvPrimitiveDataTypeA() */


/* -------------------- DbvTagSetInfo -------------------- */

void print_DbvTagSetInfo(FILE *f,  DbvTagSetInfo *psTagSetInfo)
   {


   /* Write the title out */ 
   if (psTagSetInfo == NULL)
      {
      fprintf(f, "%s: NULL\n","psTagSetInfo");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psTagSetInfo");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psTagSetInfo->psCommonInfo);

   /* pcTagSet */
   print_DbvObjectIdentifier(f, "pcTagSet", psTagSetInfo->pcTagSet);

   /* sName */
   fprintf(f, "sName: ");
   print_inter_string(f, &psTagSetInfo->sName);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psTagSetInfo->ppsDescription);

   /* ppsElements */
   printN_DbvElements(f, psTagSetInfo->ppsElements);

   } /* End print_DbvTagSetInfo() */


void printN_DbvElements(FILE *f, DbvElements **ppsElements)
   {

   if( ppsElements != NULL)
      {
      fprintf(f, "%s:\n", "ppsElements");
      while( ppsElements && *ppsElements )
         {
         print_DbvElements(f, *ppsElements);
         ppsElements++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsElements");
      
      } /* End else */

     
   } /* End printN_DbvElements() */



void print_DbvElements(FILE *f,  DbvElements *psElements)
   {


   /* Write the title out */ 
   if (psElements == NULL)
      {
      fprintf(f, "%s: NULL\n","psElements");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psElements");
   

   /* sElementName */
   fprintf(f, "sElementName: ");
   print_inter_string(f, &psElements->sElementName);

   /* ppsNicknames */
   printN_DbvInternationalString(f, "ppsNicknames", 
				  psElements->ppsNicknames);

   /* sElementTag */
   fprintf(f, "sElementTag: ");
   print_strornum(f, &psElements->sElementTag);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psElements->ppsDescription);

   /* peDataType */
   print_DbvPrimitiveDataType(f, "peDataType",psElements->peDataType);

   /* ppsOtherInformation */
   fprintf(f, "ppsOtherInformation: ");
   print_otherinfo(f, psElements->ppsOtherInformation);

   } /* End print_DbvElements() */




/* -------------------- DbvRecordSyntaxInfo -------------------- */

void print_DbvRecordSyntaxInfo(FILE *f,  DbvRecordSyntaxInfo *psRecordSyntaxInfo)
   {


   /* Write the title out */ 
   if (psRecordSyntaxInfo == NULL)
      {
      fprintf(f, "%s: NULL\n","psRecordSyntaxInfo");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psRecordSyntaxInfo");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psRecordSyntaxInfo->psCommonInfo);

   /* pcRecordSyntax */
   print_DbvObjectIdentifier(f, "pcRecordSyntax",
			      psRecordSyntaxInfo->pcRecordSyntax);

   /* sName */
   fprintf(f, "sName: ");
   print_inter_string(f, &psRecordSyntaxInfo->sName);

   /* ppcTransferSyntaxes */
   printN_DbvObjectIdentifier(f, "ppcTransferSyntaxes", 
			       psRecordSyntaxInfo->ppcTransferSyntaxes);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psRecordSyntaxInfo->ppsDescription);

   /* psAsn1Module */
   fprintf(f, "psAsn1Module: ");
   print_inter_string(f, psRecordSyntaxInfo->psAsn1Module);

   /* ppsAbstractStructure */
   printN_DbvElementInfo(f, "ppsAbstractStructure", psRecordSyntaxInfo->ppsAbstractStructure);

   } /* End print_DbvRecordSyntaxInfo() */






/* -------------------- DbvAttributeSetInfo -------------------- */

void print_DbvAttributeSetInfo(FILE *f,  DbvAttributeSetInfo *psAttributeSetInfo )
   {


   /* Write the title out */ 
   if (psAttributeSetInfo == NULL)
      {
      fprintf(f, "%s: NULL\n","psAttributeSetInfo");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psAttributeSetInfo");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psAttributeSetInfo->psCommonInfo);

   /* pcAttributeSetId */
   print_DbvObjectIdentifier(f, "pcAttributeSetId", 
				psAttributeSetInfo->pcAttributeSetId);
   /* sName */
   fprintf(f, "sName: ");
   print_inter_string(f, &psAttributeSetInfo->sName );

   /* ppsAttributes */
   printN_DbvAttributeType(f, psAttributeSetInfo->ppsAttributes);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psAttributeSetInfo->ppsDescription );

   } /* End print_DbvAttributeSetInfo() */



void printN_DbvAttributeType(FILE *f,  DbvAttributeType **ppsAttributeType )
   {

   if( ppsAttributeType != NULL)
      {
      fprintf(f, "%s:\n", "ppsAttributeType");

      while( ppsAttributeType && *ppsAttributeType )
         {
         print_DbvAttributeType(f, *ppsAttributeType);
         ppsAttributeType++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsAttributeType");
      
      } /* End else */

     
   } /* End printN_DbvAttributeType() */



void print_DbvAttributeType(FILE *f, DbvAttributeType *psAttributeType)
   {


   /* Write the title out */ 
   if (psAttributeType == NULL)
      {
      fprintf(f, "%s: NULL\n","psAttributeType");
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psAttributeType");
   


   /* psName */
   fprintf(f, "psName: ");
   print_inter_string(f,  psAttributeType->psName);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psAttributeType->ppsDescription);
   /* UlAttributeType */

   fprintf(f,  "ulAttributeType: ");
   print_Ulong(f,  &psAttributeType->ulAttributeType);
   

   /* ppsAttributeValues */
   printN_DbvAttributeDescription(f, psAttributeType->ppsAttributeValues);

   } /* End print_DbvAttributeType() */




void printN_DbvAttributeDescription(FILE *f, DbvAttributeDescription **ppsAttributeDescription )
   {

   if( ppsAttributeDescription != NULL)
      {
      fprintf(f, "%s:\n", "ppsAttributeDescription");

      while( ppsAttributeDescription && *ppsAttributeDescription )
         {
         print_DbvAttributeDescription(f,  *ppsAttributeDescription);
         ppsAttributeDescription++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsAttributeDescription");
      
      } /* End else */

     
   } /* End printN_DbvAttributeDescription() */



void print_DbvAttributeDescription(FILE *f, DbvAttributeDescription *psAttributeDescription)
   {


   /* Write the title out */ 
   if (psAttributeDescription == NULL)
      {
      fprintf(f, "%s: NULL\n","psAttributeDescription");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psAttributeDescription");
   


   /* psName */
   fprintf(f,  "psName: ");
   print_inter_string(f,  psAttributeDescription->psName);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", 
			  psAttributeDescription->ppsDescription);

   /* psAttributeValue */
   fprintf(f, "sAttributeValue: ");
   print_strornum(f, &psAttributeDescription->sAttributeValue);

   /* ppsEquivalentAttributes */
   printN_DbvStringOrNumeric(f, "ppsEquivalentAttributes", psAttributeDescription->ppsEquivalentAttributes);

   } /* End print_DbvAttributeDescription() */



void printN_DbvStringOrNumeric(FILE *f, char *name, DbvStringOrNumeric **ppsStringOrNumeric)
   {

   if( ppsStringOrNumeric != NULL)
      {
      fprintf(f, "%s:\n", name);

      while( ppsStringOrNumeric && *ppsStringOrNumeric )
         {
         fprintf(f, "psStringOrNumeric: ");
         print_strornum(f, *ppsStringOrNumeric);
         ppsStringOrNumeric++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */

     
   } /* End printN_DbvStringOrNumeric() */



/* -------------------- DbvTermListInfo -------------------- */

void print_DbvTermListInfo(FILE *f, DbvTermListInfo *psTermListInfo)
   {


   /* Write the title out */ 
   if (psTermListInfo == NULL)
      {
      fprintf(f, "%s: NULL\n","psTermListInfo");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psTermListInfo");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psTermListInfo->psCommonInfo);

   /* psDatabaseName */
   fprintf(f, "psDatabaseName: ");
   print_inter_string(f, &psTermListInfo->sDatabaseName );

   /* ppsTermLists */
   printN_DbvTermList(f, psTermListInfo->ppsTermLists);

   } /* End print_DbvTermListInfo() */



void printN_DbvTermList(FILE *f, DbvTermList **ppsTermList)
   {

   if( ppsTermList != NULL)
      {
      fprintf(f, "%s:\n", "ppsTermList");

      while( ppsTermList && *ppsTermList )
         {
         print_DbvTermList(f, *ppsTermList);
         ppsTermList++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsTermList");
      
      } /* End else */

     
   } /* End printN_DbvTermList() */




void print_DbvTermList(FILE *f,  DbvTermList *psTermList)
   {


   /* Write the title out */ 
   if (psTermList == NULL)
      {
      fprintf(f, "%s: NULL\n","psTermList");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psTermList");
   


   /* sName */
   fprintf(f, "sName: ");
   print_inter_string(f, &psTermList->sName);

   /* ppsTitle */
   printN_DbvHumanString(f, "ppsTitle", psTermList->ppsTitle);

   /* peSearchCost */
   print_DbvSearchCost(f, "peSearchCost", psTermList->peSearchCost);

   /* fScanable */
   fprintf(f, "fScanable: ");
   print_bool(f, &psTermList->fScanable);
   

   /* ppsBroader */
   printN_DbvInternationalString(f, "ppsBroader", psTermList->ppsBroader );

   /* ppsNarrower */
   printN_DbvInternationalString(f, "ppsNarrower", psTermList->ppsNarrower);

   } /* End print_DbvTermList() */


void print_DbvSearchCost(FILE *f,  char* name, DbvSearchCost *peSearchCost)
   {
   char temp[ STRING_LEN  ];


   /* Write the title out */ 
   if(peSearchCost == NULL)
      {
      fprintf(f, "%s: NULL\n", name);
      
      return;
      } /* End if */

   fprintf(f, "%s: ", name);

   /* eSearchCost */
   print_DbvSearchCostA(f, peSearchCost );

   } /* End print_DbvSearchCost() */



void print_DbvSearchCostA(FILE *f, DbvSearchCost *peSearchCost)
   {
   char temp[ SML_BUFFER ];

   if (peSearchCost == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peSearchCost == SC_Optimized)
         strcpy(temp, "SC_Optimized");

      if( *peSearchCost == SC_Normal)
         strcpy(temp, "SC_Normal");

      if( *peSearchCost == SC_Expensive)
         strcpy(temp, "SC_Expensive");

      if( *peSearchCost == SC_Filter)
         strcpy(temp, "SC_Filter");

      if( *peSearchCost == SC_Invalid)
         strcpy(temp, "SC_Invalid");

         fprintf(f, "%s\n", temp);	
   } /* End print_DbvSearchCostA() */



/* -------------------- DbvExtendedServicesInfo -------------------- */

void print_DbvExtendedServicesInfo(FILE *f, DbvExtendedServicesInfo *psExtendedServicesInfo )
   {


   /* Write the title out */ 
   if (psExtendedServicesInfo == NULL)
      {
      fprintf(f, "%s: NULL\n","psExtendedServicesInfo");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psExtendedServicesInfo");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psExtendedServicesInfo->psCommonInfo);

   /* pcType */
    print_DbvObjectIdentifier(f, "pcType", psExtendedServicesInfo->pcType );

   /* psName */
   fprintf(f, "psName: ");
   print_inter_string(f, psExtendedServicesInfo->psName );

   /* fPrivateType */
   fprintf(f,"fPrivateType: ");
   print_bool(f, &psExtendedServicesInfo->fPrivateType );
   

   /* fRestrictionsApply */
   fprintf(f,"fRestrictionsApply: ");
   print_bool(f, &psExtendedServicesInfo->fRestrictionsApply );
   

   /* fFeeApply */
   fprintf(f,"fFeeApply: ");
   print_bool(f, &psExtendedServicesInfo->fFeeApply);
   

   /* fAvailable */
   fprintf(f,"fAvailable: ");
   print_bool(f, &psExtendedServicesInfo->fAvailable);
   

   /* fRetentionSupported */
   fprintf(f,"fRetentionSupported: ");
   print_bool(f, &psExtendedServicesInfo->fRetentionSupported);
   

   /* ewaitAction */
   print_DbvExtendedServicesInfoInt(f, &psExtendedServicesInfo->eWaitAction );

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", 
			  psExtendedServicesInfo->ppsDescription );

   /* psSpecificExplain */
   fprintf(f, "psSpecificExplain: ");
   print_external(f, psExtendedServicesInfo->psSpecificExplain);

   /* psEsASN */
   fprintf(f, "psEsASN: ");
   print_inter_string(f, psExtendedServicesInfo->psEsASN );

   } /* End print_DbvExtendedServicesInfo() */



void print_DbvExtendedServicesInfoInt( FILE *f,
	DbvExtendedServicesInfoInt *peExtendedServicesInfoInt)
   {
   char temp[ STRING_LEN  ];


   /* Write the title out */ 
   if(peExtendedServicesInfoInt == NULL)
      {
      fprintf(f, "%s: NULL\n","peExtendedServicesInfoInt");
      
      return;
      } /* End if */

   fprintf(f, "%s: ","peExtendedServicesInfoInt");

   /* eExtendedServicesInfoInt */
   print_DbvExtendedServicesInfoIntA(f, peExtendedServicesInfoInt );

   } /* End print_DbvExtendedServicesInfoInt() */



void print_DbvExtendedServicesInfoIntA(FILE *f, DbvExtendedServicesInfoInt *peExtendedServicesInfoInt)
   {
   char temp[ SML_BUFFER ];

   if (peExtendedServicesInfoInt == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peExtendedServicesInfoInt == ESII_WaitSupported)
         strcpy(temp, "ESII_WaitSupported");

      if( *peExtendedServicesInfoInt == ESII_WaitAlways)
         strcpy(temp, "ESII_WaitAlways");

      if( *peExtendedServicesInfoInt == ESII_WaitNotSupported)
         strcpy(temp, "ESII_WaitNotSupported");

      if( *peExtendedServicesInfoInt == ESII_Depends)
         strcpy(temp, "ESII_Depends");

      if( *peExtendedServicesInfoInt == ESII_NotSaying)
         strcpy(temp, "ESII_NotSaying");

      if( *peExtendedServicesInfoInt == ESII_Invalid)
         strcpy(temp, "ESII_Invalid");

         fprintf(f, "%s\n", temp);	
   } /* End print_DbvExtendedServicesInfoIntA() */


/* -------------------- DbvAttributeDetails -------------------- */

void print_DbvAttributeDetails(FILE *f, DbvAttributeDetails *psAttributeDetails )
   {


   /* Write the title out */ 
   if (psAttributeDetails == NULL)
      {
      fprintf(f, "%s: NULL\n","psAttributeDetails");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psAttributeDetails");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psAttributeDetails->psCommonInfo);


   /* sDatabaseName */
   fprintf( f, "sDatabaseName: ");
   print_inter_string(f, &psAttributeDetails->sDatabaseName );

   /* ppsAttributesBySet */
   printN_DbvAttributesBySet(f, psAttributeDetails->ppsAttributesBySet );

   /* psAttributeCombinations */
   print_DbvAttributeCombinations(f, psAttributeDetails->psAttributeCombinations );

   } /* End print_DbvAttributeDetails() */



void printN_DbvAttributesBySet(FILE *f, DbvAttributesBySet **ppsAttributesBySet )
   {

   if( ppsAttributesBySet != NULL)
      {
      fprintf(f, "%s:\n", "ppsAttributesBySet");
      while( ppsAttributesBySet && *ppsAttributesBySet )
         {
         print_DbvAttributesBySet(f, *ppsAttributesBySet);
         ppsAttributesBySet++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsAttributesBySet");
      
      } /* End else */

     
   } /* End printN_DbvAttributesBySet() */



void print_DbvAttributesBySet(FILE *f, DbvAttributesBySet *psAttributesBySet )
   {


   /* Write the title out */ 
   if (psAttributesBySet == NULL)
      {
      fprintf(f, "%s: NULL\n","psAttributesBySet");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psAttributesBySet");
   


   /* pcAttributeSet */
   print_DbvObjectIdentifier(f, "pcAttributeSet", 
			      psAttributesBySet->pcAttributeSet );

   /* ppsAttributesByType */
   printN_DbvAttributesByType(f, psAttributesBySet->ppsAttributesByType );

   } /* End print_DbvAttributesBySet() */



void printN_DbvAttributesByType(FILE *f, DbvAttributesByType **ppsAttributesByType )
   {

   if( ppsAttributesByType != NULL)
      {
      fprintf(f, "%s:\n", "ppsAttributesByType");
      while( ppsAttributesByType && *ppsAttributesByType )
         {
         print_DbvAttributesByType(f, *ppsAttributesByType);
         ppsAttributesByType++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsAttributesByType");
      
      } /* End else */

     
   } /* End printN_DbvAttributesByType() */


void print_DbvAttributesByType(FILE *f,  DbvAttributesByType *psAttributesByType )
   {

   /* Write the title out */ 
   if (psAttributesByType == NULL)
      {
      fprintf(f, "%s: NULL\n","psAttributesByType");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psAttributesByType");
   


   /* ulAttributeType */
   fprintf(f, "ulAttributeType: ");
   print_Ulong(f, &psAttributesByType->ulAttributeType );
   

   /* psDefaultIfOmitted */
   print_DbvOmittedAttributeInterpretation(f, psAttributesByType->psDefaultIfOmitted );

   /* ppsAttributeValues */
   printN_DbvAttributeValues(f, psAttributesByType->ppsAttributeValues);

   } /* End print_DbvAttributesByType() */



void print_DbvOmittedAttributeInterpretation(FILE *f, DbvOmittedAttributeInterpretation *psOmittedAttributeInterpretation )
   {


   /* Write the title out */ 
   if (psOmittedAttributeInterpretation == NULL)
      {
      fprintf(f, "%s: NULL\n","psOmittedAttributeInterpretation");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psOmittedAttributeInterpretation");
   

   /* psDefaultValue */
   fprintf(f, "psDefaultValue");
   print_strornum(f, psOmittedAttributeInterpretation->psDefaultValue );

   /* ppsDefaultDescription */
   printN_DbvHumanString(f, "ppsDefaultDescription", psOmittedAttributeInterpretation->ppsDefaultDescription );

   } /* End print_DbvOmittedAttributeInterpretation() */



void printN_DbvAttributeValues(FILE *f, DbvAttributeValues **ppsAttributeValues )
   {

   if( ppsAttributeValues != NULL)
      {
      fprintf(f, "%s:\n", "ppsAttributeValues");
      while( ppsAttributeValues && *ppsAttributeValues )
         {
         print_DbvAttributeValues(f, *ppsAttributeValues);
         ppsAttributeValues++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsAttributeValues");
      
      } /* End else */

     
   } /* End printN_DbvAttributeValues() */



void print_DbvAttributeValues(FILE *f, DbvAttributeValues *psAttributeValues )
   {


   /* Write the title out */ 
   if (psAttributeValues == NULL)
      {
      fprintf(f, "%s: NULL\n","psAttributeValues");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psAttributeValues");
   


   /* sValue */
   fprintf(f, "sValue: ");
   print_strornum(f, &psAttributeValues->sValue);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psAttributeValues->ppsDescription );

   /* ppsSubAttributes */
   printN_DbvStringOrNumeric(f, "ppsSubAttributes", psAttributeValues->ppsSubAttributes);

   /* ppsSuperAttributes */
   printN_DbvStringOrNumeric(f, "ppsSuperAttributes", psAttributeValues->ppsSuperAttributes);

   /* pvPartialSupport */
   print_DbvNull(f, "pvPartialSupport",
		  psAttributeValues->pvPartialSupport);

   } /* End print_DbvAttributeValues() */





/* -------------------- DbvTermListDetails -------------------- */

void print_DbvTermListDetails(FILE *f,  DbvTermListDetails *psTermListDetails )
   {


   /* Write the title out */ 
   if (psTermListDetails == NULL)
      {
      fprintf(f, "%s: NULL\n","psTermListDetails");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psTermListDetails");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psTermListDetails->psCommonInfo);

   /* sTermListName */
   fprintf(f, "sTermListName: ");
   print_inter_string(f, &psTermListDetails->sTermListName );

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psTermListDetails->ppsDescription );

   /* psAttributes */
   print_DbvAttributeCombinations(f, psTermListDetails->psAttributes);

   /* psScanInfo */
   print_DbvScanInfo(f, psTermListDetails->psScanInfo);

   /* pulEstNumberTerms */
   fprintf(f, "pulEstNumberTerms: ");
   print_Ulong(f, psTermListDetails->pulEstNumberTerms );
   

   /* ppsSampleTerms */
   printN_DbvTerm(f, "ppsSampleTerms", psTermListDetails->ppsSampleTerms);

   } /* End print_DbvTermListDetails() */



void print_DbvAttributeCombinations(FILE *f, DbvAttributeCombinations *psAttributeCombinations )
   {


   /* Write the title out */ 
   if (psAttributeCombinations == NULL)
      {
      fprintf(f, "%s: NULL\n", "psAttributeCombinations");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psAttributeCombinations");
   


   /* pcDefaultAttributeSet */
   print_DbvObjectIdentifier(f, "pcDefaultAttributeSet", 
				psAttributeCombinations->pcDefaultAttributeSet );


   /* ppsLegalCombinations */
   printN_DbvAttributeCombination(f, psAttributeCombinations->
				ppsLegalCombinations );

   } /* End print_DbvAttributeCombinations() */



void printN_DbvAttributeCombination(FILE *f,  DbvAttributeCombination **ppsLegalCombinations)
   {

   if( ppsLegalCombinations != NULL)
      {
      fprintf(f, "%s:\n", "ppsLegalCombinations");
      while( ppsLegalCombinations && *ppsLegalCombinations )
         {
         print_DbvAttributeCombination(f, *ppsLegalCombinations);
         ppsLegalCombinations++;
	 fprintf(f, "\n");
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsLegalCombinations");
      
      } /* End else */

     
   } /* End printN_DbvAttributeCombination() */


void print_DbvAttributeCombination(FILE *f, DbvAttributeCombination *psLegalCombinations)
{
	/* Write the title out */ 
	if (psLegalCombinations == NULL) {
		fprintf(f, "%s: NULL\n","psLegalCombinations");
		
		return;
	} /* End if */

	fprintf(f, "%s:\n", "psLegalCombinations");
	

	printN_DbvDbvAttributeOccurrence(f, psLegalCombinations->ppsAttributeOccurrence);
	

} /* End print_DbvAttributeCombination */



void printN_DbvDbvAttributeOccurrence(FILE *f, DbvAttributeOccurrence **ppsAttributeOccurrence)
{
   if( ppsAttributeOccurrence != NULL)
      {
      fprintf(f, "%s:\n", "ppsAttributeCombinations");
      while( ppsAttributeOccurrence && *ppsAttributeOccurrence )
         {
         print_DbvDbvAttributeOccurrence(f, *ppsAttributeOccurrence);
         ppsAttributeOccurrence++;
         } 
      } 
   else
      {
      fprintf(f, "%s: NULL\n", "ppsAttributeCombinations");
      
      } 

} /* End printN_DbvDbvAttributeOccurrence */



void print_DbvDbvAttributeOccurrence(FILE *f, DbvAttributeOccurrence *psAttributeOccurrence)
{

	/* Write the title out */ 
	if (psAttributeOccurrence == NULL) {
		fprintf(f, "%s: NULL\n","psAttributeOccurrence");
		
		return;
	} /* End if */

	fprintf(f, "%s:\n", "psAttributeOccurrence");
	

	print_DbvObjectIdentifier(f, "pcAttributeSet", psAttributeOccurrence->pcAttributeSet);

         fprintf(f, "ulAttributeType: ");
         print_Ulong(f, &psAttributeOccurrence->ulAttributeType);

	print_DbvNull(f, "pvMustBeSupplied",
		  psAttributeOccurrence->pvMustBeSupplied);

	print_DbvAttributeOccurrenceChoice(f, &psAttributeOccurrence->sAttributeValues);
	
} /* End print_DbvDbvAttributeOccurrence */



void print_DbvAttributeOccurrenceChoice(FILE *f, DbvAttributeOccurrenceChoice *psAttributeOccurrenceChoice)
{

	/* Write the title out */ 
	if (psAttributeOccurrenceChoice == NULL) {
		fprintf(f, "%s: NULL\n","psAttributeOccurrenceChoice");
		
		return;
	} /* End if */
	
	fprintf(f, "%s:\n", "psAttributeOccurrenceChoice");
	
	fprintf(f, "eAttributeOccurrenceChoiceType: ");
	print_DbvAttributeOccurrenceChoiceType(f, &psAttributeOccurrenceChoice->eAttributeOccurrenceChoiceType);

	switch (psAttributeOccurrenceChoice->eAttributeOccurrenceChoiceType) {
	case AOT_AnyOrNone:
		print_DbvNull(f, "pvAnyOrNone",
		  psAttributeOccurrenceChoice->uAttributeOccurrenceChoiceType.pvAnyOrNone);
		break;
	case AOT_Specific:
   		printN_DbvStringOrNumeric(f, "ppsSpecific", psAttributeOccurrenceChoice->uAttributeOccurrenceChoiceType.ppsSpecific);
		break;
	}

} /* End print_DbvAttributeOccurrenceChoice */



void print_DbvAttributeOccurrenceChoiceType(FILE *f, DbvAttributeOccurrenceChoiceType *peAttributeOccurrenceChoiceType)
   {
   char temp[SML_BUFFER];

   if (peAttributeOccurrenceChoiceType == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peAttributeOccurrenceChoiceType == AOT_AnyOrNone )
         strcpy(temp, "AOT_AnyOrNone");

      if( *peAttributeOccurrenceChoiceType == AOT_Specific  )
         strcpy(temp, "AOT_Specific");

      if( *peAttributeOccurrenceChoiceType == AOT_Invalid  )
         strcpy(temp, "AOT_Invalid");


	fprintf(f, "%s\n", temp);

   } /* End print_DbvAttributeOccurrenceChoiceType() */



void print_DbvScanInfo(FILE *f,  DbvScanInfo *psScanInfo)
   {


   /* Write the title out */ 
   if (psScanInfo == NULL)
      {
      fprintf(f, "%s: NULL\n","psScanInfo");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psScanInfo");
   


   /* pulMaxStepSize */
   fprintf(f, "pulMaxStepSize: ");
   print_Ulong(f, psScanInfo->pulMaxStepSize );
   

   /* ppsCollatingSequence */
   printN_DbvHumanString(f, "ppsCollatingSequence",
			  psScanInfo->ppsCollatingSequence );

   /* pfIncreasing */
      fprintf(f, "pfIncreasing: ");
      print_bool(f,  psScanInfo->pfIncreasing);
   

   } /* End print_DbvScanInfo() */



void printN_DbvTerm(FILE *f,  char *name, DbvTerm **ppsTerm)
   {

   if( ppsTerm != NULL)
      {
      fprintf(f, "%s:\n", name);
      while( ppsTerm && *ppsTerm )
         {
         print_DbvTerm(f, *ppsTerm);
         ppsTerm++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */

     
   } /* End printN_DbvTerm() */


void print_DbvTerm( FILE *f, DbvTerm *psTerm)
   {
   char *pc_string = NULL;

   /* Write the title out */

   if (psTerm == NULL)
   {
           fprintf(f, "%s: NULL\n","psTerm");
           
           return;
   }

   fprintf(f, "%s:\n", "psTerm");
   

   /* Term type */
   fprintf(f, "eTermType: ");
   print_DbvTermType(f, &psTerm->eTermType );


   /* DbvTerm */

   switch( psTerm->eTermType )
      {
      case TT_General:
         fprintf(f,  "psGeneral: " );
         print_octet_string(f,  psTerm->uTerm.psGeneral);
         break;

      case TT_Numeric:
         fprintf(f, "ulInteger: ");
         print_Ulong(f, &psTerm->uTerm.ulInteger );
         break;

      case TT_SimpleCharacter:
         fprintf(f,  "psSimpleCharacter: " );
         print_inter_string(f,  psTerm->uTerm.psSimpleCharacter);
         break;

      case TT_ObjectIdentifier:
         print_DbvObjectIdentifier(f,  "pcObjectIdentifier",
                                psTerm->uTerm.pcObjectIdentifier);
         break;

      case TT_DateTime:
         print_DbvGeneralizedTime(f,  "pcDateTime",
                                   psTerm->uTerm.pcDateTime);
         break;

      case TT_External:
         fprintf(f,  "psExternal: " );
         print_external(f, psTerm->uTerm.psExternal);
         break;

      case TT_IntegerAndUnit:
         fprintf(f, "psIntegerAndUnit: ");
         print_intunit(f, psTerm->uTerm.psIntegerAndUnit);
         break;

      case TT_Null:
         break;

      default:
         break;
      } /* End switch */

   } /* End print_DbvTerm() */



void print_DbvTermType(FILE *f, DbvTermType *peTermType)
   {
   char temp[SML_BUFFER];

   if (peTermType == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peTermType == TT_General )

         strcpy(temp, "TT_General");
      if( *peTermType == TT_Numeric  )
         strcpy(temp, "TT_Numeric");
      if( *peTermType == TT_SimpleCharacter )
         strcpy(temp, "TT_SimpleCharacter");
      if( *peTermType ==  TT_ObjectIdentifier)
         strcpy(temp, "TT_ObjectIdentifier");
      if( *peTermType == TT_DateTime )
         strcpy(temp, "TT_DateTime");
      if( *peTermType == TT_External )
         strcpy(temp, "TT_External");
      if( *peTermType == TT_IntegerAndUnit )
         strcpy(temp, "TT_IntegerAndUnit");
      if( *peTermType == TT_Null)
         strcpy(temp, "TT_Null");

	fprintf(f, "%s\n", temp);

   } /* End print_DbvTermType() */



/* -------------------- DbvElementSetDetails -------------------- */


void print_DbvElementSetDetails(FILE *f, DbvElementSetDetails *psElementSetDetails )
   {


   /* Write the title out */ 
   if (psElementSetDetails == NULL)
      {
      fprintf(f, "%s: NULL\n","psElementSetDetails");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psElementSetDetails");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psElementSetDetails->psCommonInfo);

   /* sDatabaseName */
   fprintf(f, "sDatabaseName: ");
   print_inter_string(f, &psElementSetDetails->sDatabaseName );

   /* sElementSetName */
   fprintf(f, "sElementSetName: ");
   print_inter_string(f, &psElementSetDetails->sElementSetName );

   /* pcRecordSyntax */
   print_DbvObjectIdentifier(f, "pcRecordSyntax", 
				psElementSetDetails->pcRecordSyntax );
   /* pcSchema */
   print_DbvObjectIdentifier(f, "pcSchema", psElementSetDetails->pcSchema );

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psElementSetDetails->ppsDescription );

   /* ppsDetailsPerElement */
   printN_DbvDetailsPerElement(f, psElementSetDetails->ppsDetailsPerElement);

   } /* End print_DbvElementSetDetails() */


void printN_DbvDetailsPerElement(FILE *f, DbvDetailsPerElement **ppsDetailsPerElement )
   {

   if( ppsDetailsPerElement != NULL)
      {
      fprintf(f, "%s:\n", "ppsDetailsPerElement");
      while( ppsDetailsPerElement && *ppsDetailsPerElement )
         {
         print_DbvDetailsPerElement(f, *ppsDetailsPerElement);
         ppsDetailsPerElement++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsDetailsPerElement");
      
      } /* End else */

     
   } /* End printN_DbvDetailsPerElement() */


void print_DbvDetailsPerElement(FILE *f, DbvDetailsPerElement *psDetailsPerElement )
   {


   /* Write the title out */ 
   if (psDetailsPerElement == NULL)
      {
      fprintf(f, "%s: NULL\n","psDetailsPerElement");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psDetailsPerElement");
   


   /* psName */
   fprintf(f, "psName: ");
   print_inter_string(f, psDetailsPerElement->psName );

   /* psRecordTag */
   print_DbvRecordTag(f, psDetailsPerElement->psRecordTag);

   /* ppsSchemaTags */
   printN_DbvPathA(f, psDetailsPerElement->ppsSchemaTags);

   /* pulMaxSize */
   fprintf(f,"pulMaxSize: ");
   print_Ulong(f, psDetailsPerElement->pulMaxSize );
   

   /* pulMinSize */
   fprintf(f,"pulMinSize: ");
   print_Ulong(f, psDetailsPerElement->pulMinSize );
   

   /* pulAvgSize */
   fprintf(f,"pulAvgSize: ");
   print_Ulong(f, psDetailsPerElement->pulAvgSize );
   

   /* pulFixedSize */
   fprintf(f,"pulFixedSize: ");
   print_Ulong(f, psDetailsPerElement->pulFixedSize );
   

   /* fRepeatable */
   fprintf(f,"fRepeatable: ");
   print_bool(f, &psDetailsPerElement->fRepeatable);
   

   /* fRequired */
   fprintf(f,"fRequired: ");
   print_bool(f, &psDetailsPerElement->fRequired);
   

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psDetailsPerElement->ppsDescription );

   /* ppsContents */
   printN_DbvHumanString(f, "ppsContents", psDetailsPerElement->ppsContents );

   /* ppsBillingInfo */
   printN_DbvHumanString(f, "ppsBillingInfo", psDetailsPerElement->ppsBillingInfo );

   /* ppsRestrictions */
   printN_DbvHumanString(f, "ppsRestrictions",
			  psDetailsPerElement->ppsRestrictions );

   /* ppsAlternateNames */
   printN_DbvInternationalString(f, "ppsAlternateNames",
			  psDetailsPerElement->ppsAlternateNames );

   /* ppsGenericNames */
   printN_DbvInternationalString(f, "ppsGenericNames",
			  psDetailsPerElement->ppsGenericNames );

   /* psSearchAccess */
   print_DbvAttributeCombinations(f, psDetailsPerElement->psSearchAccess );

   } /* End print_DbvDetailsPerElement() */



void print_DbvRecordTag(FILE *f,  DbvRecordTag *psRecordTag)
   {


   /* Write the title out */ 
   if (psRecordTag == NULL)
      {
      fprintf(f, "%s: NULL\n","psRecordTag");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psRecordTag");
   


   /* psQualifier */
   fprintf(f, "psQualifier: ");
   print_strornum(f,  psRecordTag->psQualifier);

   /* sTagValue */
   fprintf(f, "sTagValue: ");
   print_strornum(f,  &psRecordTag->sTagValue);

   } /* End print_DbvRecordTag() */


void printN_DbvPathA(FILE *f, DbvPathA **ppsPathA)
   {

   if( ppsPathA != NULL)
      {
      fprintf(f, "%s:\n", "ppsPathA");
      while( ppsPathA && *ppsPathA )
         {
         printN_DbvPath(f,  (*ppsPathA)->ppsSchemaTags);
         ppsPathA++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsPathA");
      
      } /* End else */

     
   } /* End printN_DbvPathA() */




/* -------------------- DbvRetrievalRecordDetails -------------------- */

void print_DbvRetrievalRecordDetails(FILE *f,  DbvRetrievalRecordDetails *psRetrievalRecordDetails )
   {


   /* Write the title out */ 
   if (psRetrievalRecordDetails == NULL)
      {
      fprintf(f, "%s: NULL\n","psRetrievalRecordDetails");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psRetrievalRecordDetails");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psRetrievalRecordDetails->psCommonInfo);

   /* sDatabaseName */
   fprintf(f, "sDatabaseName: ");
   print_inter_string(f, &psRetrievalRecordDetails->sDatabaseName );

   /* pcSchema */
   print_DbvObjectIdentifier(f, "pcSchema",
			      psRetrievalRecordDetails->pcSchema );

   /* pcRecordSyntax */
   print_DbvObjectIdentifier(f, "pcRecordSyntax",
			      psRetrievalRecordDetails->pcRecordSyntax);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", 
			  psRetrievalRecordDetails->ppsDescription );

   /* ppsDetailsPerElement */
   printN_DbvDetailsPerElement(f, psRetrievalRecordDetails->ppsDetailsPerElement );

   } /* End print_DbvRetrievalRecordDetails() */



/* -------------------- DbvSortDetails -------------------- */

void print_DbvSortDetails( FILE *f, DbvSortDetails *psSortDetails)
   {


   /* Write the title out */ 
   if (psSortDetails == NULL)
      {
      fprintf(f, "%s: NULL\n","psSortDetails");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psSortDetails");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psSortDetails->psCommonInfo);

   /* sDatabaseName */
   fprintf(f, "sDatabaseName: ");
   print_inter_string(f, &psSortDetails->sDatabaseName );

   /* ppsSortKeys */
   printN_DbvSortKeys(f, psSortDetails->ppsSortKeys);

   } /* End print_DbvSortDetails() */



void printN_DbvSortKeys(FILE *f, DbvSortKeys **ppsSortKeys)
   {

   if( ppsSortKeys != NULL)
      {
      fprintf(f, "%s:\n", "ppsSortKeys");
      while( ppsSortKeys && *ppsSortKeys )
         {
         print_DbvSortKeys(f, *ppsSortKeys);
         ppsSortKeys++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsSortKeys");
      
      } /* End else */

     
   } /* End printN_DbvSortKeys() */



void print_DbvSortKeys(FILE *f, DbvSortKeys *psSortKeys)
   {
   char temp[ STRING_LEN  ];


   /* Write the title out */ 
   if (psSortKeys == NULL)
      {
      fprintf(f, "%s: NULL\n","psSortKeys");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psSortKeys");
   


   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psSortKeys->ppsDescription );

   /* ppsElementSpecifications */
   printN_DbvSpecification(f, "ppsElementSpecifications", psSortKeys->ppsElementSpecifications);

   /* psAttributeSpecifications */
   print_DbvAttributeCombinations(f, psSortKeys->psAttributeSpecifications );

   /* psSortType */
   print_DbvSortType(f, psSortKeys->psSortType);

   /* peCaseSensitivity */
   fprintf(f, "peCaseSensitivity: ");
   print_DbvCaseSensitivity( f, psSortKeys->peCaseSensitivity );
  
   } /* End print_DbvSortKeys() */



void printN_DbvSpecification(FILE *f, char *name, DbvSpecification **ppsSpecification)
   {

   if( ppsSpecification != NULL)
      {
      fprintf(f, "%s:\n", name);
      while( ppsSpecification && *ppsSpecification )
         {
         print_DbvSpecification(f, "psSpecification", *ppsSpecification);
         ppsSpecification++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */

     
   } /* End printN_DbvSpecification() */



void print_DbvSortType(FILE *f,  DbvSortType *psSortType)
   {
   char temp[ STRING_LEN  ];

   /* Write the title out */ 
   if (psSortType == NULL)
      {
      fprintf(f, "%s: NULL\n","psSortType");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psSortType");
   

   /* eSortTypeType */
   fprintf(f, "eSortTypeType: ");
   print_DbvSortTypeType(f, &psSortType->eSortTypeType);


   /* uSortType */

   switch( psSortType->eSortTypeType )
      {
      case STT_Structured:
	 printN_DbvHumanString(f, "ppsStructured", 
				psSortType->uSortType.ppsStructured );
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvSortType() */



void print_DbvSortTypeType(FILE *f, DbvSortTypeType *peSortTypeType)
   {
   char temp[ SML_BUFFER ];

   if (peSortTypeType == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peSortTypeType == STT_Character)
         strcpy(temp, "STT_Character");

      if( *peSortTypeType == STT_Numeric)
         strcpy(temp, "STT_Numeric");

      if( *peSortTypeType == STT_Structured)
         strcpy(temp, "STT_Structured");

      if( *peSortTypeType == STT_Invalid)
         strcpy(temp, "STT_Invalid");

         fprintf(f, "%s\n", temp);
   } /* End print_DbvSortTypeType() */




void print_DbvCaseSensitivity(FILE *f, DbvCaseSensitivity *peCaseSensitivity)
   {
   char temp[ SML_BUFFER ];

   if (peCaseSensitivity == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peCaseSensitivity == CSE_Always)
         strcpy(temp, "CSE_Always");

      if( *peCaseSensitivity == CSE_Never)
         strcpy(temp, "CSE_Never");

      if( *peCaseSensitivity == CSE_DefaultYes)
         strcpy(temp, "CSE_DefaultYes");

      if( *peCaseSensitivity == CSE_DefaultNo)
         strcpy(temp, "CSE_DefaultNo");

      if( *peCaseSensitivity == CSE_Invalid)
         strcpy(temp, "CSE_Invalid");

         fprintf(f, "%s\n", temp);
   } /* End print_DbvCaseSensitivity() */



/* -------------------- DbvProcessingInformation -------------------- */

void print_DbvProcessingInformation(FILE *f, DbvProcessingInformation *psProcessingInformation )
   {
   char temp[ STRING_LEN  ];


   /* Write the title out */ 
   if (psProcessingInformation == NULL)
      {
      fprintf(f, "%s: NULL\n","psProcessingInformation");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psProcessingInformation");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psProcessingInformation->psCommonInfo);

   /* sDatabaseName */
   fprintf(f, "sDatabaseName: ");
   print_inter_string(f, &psProcessingInformation->sDatabaseName );


   /* eProcessingContext */
   fprintf(f, "eProcessingContext: ");
   print_DbvProcessingContext(f, &psProcessingInformation->eProcessingContext);

   /* psName */
   fprintf( f, "psName: ");
   print_inter_string(f,  &psProcessingInformation->sName );

   /* pcOid */
   print_DbvObjectIdentifier(f, "pcOid", psProcessingInformation->pcOid );

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", 
			  psProcessingInformation->ppsDescription );

   /* psInstructions */
   fprintf(f, "psInstructions: ");
   print_external(f, psProcessingInformation->psInstructions);

   } /* End print_DbvProcessingInformation() */



void print_DbvProcessingContext(FILE *f, DbvProcessingContext *peProcessingContext)
   {
   char temp[ SML_BUFFER ];

   if (peProcessingContext == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peProcessingContext == PC_Access)
         strcpy(temp, "PC_Access");

      if( *peProcessingContext == PC_Search)
         strcpy(temp, "PC_Search");

      if( *peProcessingContext == PC_Retrieval)
         strcpy(temp, "PC_Retrieval");

      if( *peProcessingContext == PC_RecordPresentation)
         strcpy(temp, "PC_RecordPresentation");

      if( *peProcessingContext == PC_RecordHandling)
         strcpy(temp, "PC_RecordHandling");

      if( *peProcessingContext == PC_Invalid)
         strcpy(temp, "PC_Invalid");

         fprintf(f, "%s\n", temp);	
   } /* End print_DbvProcessingContext() */



/* -------------------- DbvVariantSetInfo -------------------- */


void print_DbvVariantSetInfo(FILE *f,  DbvVariantSetInfo *psVariantSetInfo)
   {

   /* Write the title out */ 
   if (psVariantSetInfo == NULL)
      {
      fprintf(f, "%s: NULL\n","psVariantSetInfo");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psVariantSetInfo");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psVariantSetInfo->psCommonInfo);

   /* pcVariantSet */
   print_DbvObjectIdentifier(f, "pcVariantSet", psVariantSetInfo->pcVariantSet );

   /* sName */
   fprintf(f, "sName: ");
   print_inter_string(f, &psVariantSetInfo->sName);

   /* ppsVariants */
   printN_DbvVariantClass(f, psVariantSetInfo->ppsVariants);

   } /* End print_DbvVariantSetInfo() */



void printN_DbvVariantClass(FILE *f,  DbvVariantClass **ppsVariants)
   {

   if( ppsVariants != NULL)
      {
      fprintf(f, "%s:\n", "ppsVariants");
      while( ppsVariants && *ppsVariants )
         {
         print_DbvVariantClass(f, *ppsVariants);
         ppsVariants++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsVariants");
      
      } /* End else */

     
   } /* End printN_DbvVariantClass() */



void print_DbvVariantClass(FILE *f,  DbvVariantClass *psVariants)
   {

   /* Write the title out */ 
   if (psVariants == NULL)
      {
      fprintf(f, "%s: NULL\n","psVariants");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psVariants");
   

   /* psName */
   fprintf(f, "psName: ");
   print_inter_string(f, psVariants->psName);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psVariants->ppsDescription );

   /* ulVariantClass */
   fprintf(f, "ulVariantClass: ");
   print_Ulong(f, &psVariants->ulVariantClass );
   

   /* ppsVariantTypes */
   printN_DbvVariantTypes(f, psVariants->ppsVariantTypes);

   } /* End print_DbvVariantClass() */



void printN_DbvVariantTypes(FILE *f,  DbvVariantTypes **ppsVariantTypes)
   {

   if( ppsVariantTypes != NULL)
      {
      fprintf(f, "%s:\n", "ppsVariantTypes");
      while( ppsVariantTypes && *ppsVariantTypes )
         {
         print_DbvVariantTypes(f,  *ppsVariantTypes);
         ppsVariantTypes++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsVariantTypes");
      
      } /* End else */

     
   } /* End printN_DbvVariantTypes() */



void print_DbvVariantTypes(FILE *f,  DbvVariantTypes *psVariantTypes)
   {


   /* Write the title out */ 
   if (psVariantTypes == NULL)
      {
      fprintf(f, "%s: NULL\n","psVariantTypes");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psVariantTypes");
   


   /* psName */
   fprintf(f, "psName: ");
   print_inter_string(f, psVariantTypes->psName );

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psVariantTypes->ppsDescription );

   /* ulVariantType */
   fprintf(f, "ulVariantType: ");
   print_Ulong(f, &psVariantTypes->ulVariantType );
   
   /* psVariantValue */
   print_DbvVariantValue(f,  psVariantTypes->psVariantValue);

   } /* End print_DbvVariantTypes() */



void print_DbvVariantValue(FILE *f,  DbvVariantValue *psVariantValue)
   {


   /* Write the title out */ 
   if (psVariantValue == NULL)
      {
      fprintf(f, "%s: NULL\n","psVariantValue");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psVariantValue");
   


   /* eDataType */
   print_DbvPrimitiveDataType(f, "eDataType", 
				&psVariantValue->eDataType);

   /* psValues */
   print_DbvValueSet(f, psVariantValue->psValues);

   } /* End print_DbvVariantValue() */



void print_DbvValueSet(FILE *f,  DbvValueSet *psValues)
   {
   char temp[ STRING_LEN  ];


   /* Write the title out */ 
   if (psValues == NULL)
      {
      fprintf(f, "%s: NULL\n","psValues");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psValues");
   


   /* eValuesType */
   fprintf(f, "eValueSetType: ");
   print_DbvValueSetType(f, &psValues->eValueSetType );

   /* uValues */
   switch( psValues->eValueSetType )
      {
      case VT_Range:
	 print_DbvValueRange(f, psValues->uValueSet.psRange);
	 break;

      case VT_Enumerated:
	printN_DbvValueDescription(f, psValues->uValueSet.ppsEnumerated);

	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvValueSet() */



void print_DbvValueSetType(FILE *f, DbvValueSetType *peValueSetType)
   {
   char temp[ SML_BUFFER ];

   if (peValueSetType == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peValueSetType == VT_Range)
         strcpy(temp, "VT_Range");

      if( *peValueSetType == VT_Enumerated)
         strcpy(temp, "VT_Enumerated");

      if( *peValueSetType == VT_Invalid)
         strcpy(temp, "VT_Invalid");

         fprintf(f, "%s\n", temp);
   } /* End print_DbvValueSetType() */



void print_DbvValueRange(FILE *f, DbvValueRange *psValueRange)
   {


   /* Write the title out */ 
   if (psValueRange == NULL)
      {
      fprintf(f, "%s: NULL\n","psValueRange");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psValueRange");
   


   /* psLower */
   print_DbvValueDescription(f, psValueRange->psLower);

   /* psUpper */
   print_DbvValueDescription(f, psValueRange->psUpper);

   } /* End print_DbvValueRange() */




void print_DbvValueDescription(FILE *f, DbvValueDescription *psValueDescription )
   {
   char temp[ STRING_LEN  ];


   /* Write the title out */ 
   if (psValueDescription == NULL)
      {
      fprintf(f, "%s: NULL\n","psValueDescription");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psValueDescription");
   

   /* eValueDescriptionType */
   fprintf(f, "eValueDescriptiptionType: ");
   print_DbvValueDescriptionType(f, &psValueDescription->eValueDescriptionType);
 
   /* uValueDescription */
   switch( psValueDescription->eValueDescriptionType )
      {
      case VDT_Integer:
	 fprintf(f, "ulInteger: ");
	 print_Ulong(f, &psValueDescription-> uValueDescription.ulInteger);
         
	 break;

      case VDT_String:
	 fprintf(f, "psString: ");
	 print_inter_string(f, psValueDescription->
				uValueDescription.psString);
	 break;

      case VDT_Octets:
	 fprintf(f, "psOctets: ");
	 print_octet_string(f,  psValueDescription->
				uValueDescription.psOctets);
	 break;

      case VDT_Oid:
	 print_DbvObjectIdentifier(f, "pcOid", psValueDescription->
				uValueDescription.pcOid);
	 break;

      case VDT_Unit:
	 fprintf(f, "psUnit: ");
	 print_DbvUnit(f, psValueDescription->uValueDescription.psUnit );
	 break;

      case VDT_ValueAndUnit:
	 fprintf(f, "psValueAndUnit: ");
	 print_intunit(f, psValueDescription->uValueDescription.psValueAndUnit );
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvValueDescription() */



void print_DbvValueDescriptionType(FILE *f, DbvValueDescriptionType *peValueDescriptionType)
   {
   char temp[ SML_BUFFER ];

   if (peValueDescriptionType == NULL)
      {
      fprintf(f, "NULL\n");
      return;
      } /* End if */

      temp[ 0 ] = '\0';
      if( *peValueDescriptionType == VDT_Integer)
         strcpy(temp, "VDT_Integer");

      if( *peValueDescriptionType == VDT_String)
         strcpy(temp, "VDT_String");

      if( *peValueDescriptionType == VDT_Octets)
         strcpy(temp, "VDT_Octets");

      if( *peValueDescriptionType == VDT_Oid)
         strcpy(temp, "VDT_Oid");

      if( *peValueDescriptionType == VDT_Unit)
         strcpy(temp, "VDT_Unit");

      if( *peValueDescriptionType == VDT_ValueAndUnit)
         strcpy(temp, "VDT_ValueAndUnit");

      if( *peValueDescriptionType == VDT_Invalid)
         strcpy(temp, "VDT_Invalid");

    fprintf(f, "%s\n", temp);
   } /* End print_DbvValueDescriptionType() */



void printN_DbvValueDescription(FILE *f, DbvValueDescription **ppsEnumerated)
{
   if( ppsEnumerated != NULL)
      {
      fprintf(f, "%s:\n", "ppsEnumerated");
      while( ppsEnumerated && *ppsEnumerated )
         {
         print_DbvValueDescription(f, *ppsEnumerated);
         ppsEnumerated++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsEnumerated");
      
      } /* End else */


   } /* End printN_DbvValueDescription() */



/* -------------------- DbvUnitInfo -------------------- */


void print_DbvUnitInfo( FILE *f, DbvUnitInfo *psUnitInfo)
   {

   /* Write the title out */ 
   if (psUnitInfo == NULL)
      {
      fprintf(f, "%s: NULL\n","psUnitInfo");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psUnitInfo");
   
   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psUnitInfo->psCommonInfo);

   /* sUnitSystem */
   fprintf(f, "sUnitSystem: ");
   print_inter_string(f, &psUnitInfo->sUnitSystem );

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psUnitInfo->ppsDescription );
   /* ppsUnitTypes */
   printN_DbvUnitType(f, "ppsUnitTypes", psUnitInfo->ppsUnitTypes );

   } /* End print_DbvUnitInfo() */



void printN_DbvUnitType(FILE *f, char *name, DbvUnitType **ppsUnitTypes)
{
   if( ppsUnitTypes != NULL)
      {
      fprintf(f, "%s:\n", name);
      while( ppsUnitTypes && *ppsUnitTypes )
         {
         print_DbvUnitType(f, *ppsUnitTypes);
         ppsUnitTypes++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */


   } /* End printN_DbvUnitType() */



void print_DbvUnitType( FILE *f, DbvUnitType *psUnitTypes)
   {

   /* Write the title out */ 
   if (psUnitTypes == NULL)
      {
      fprintf(f, "%s: NULL\n","psUnitTypes");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psUnitTypes");
   
   /* psName */
   fprintf(f, "psName: ");
   print_inter_string(f, psUnitTypes->psName);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psUnitTypes->ppsDescription );
   /* sUnitType */
   fprintf(f, "sUnitType: ");
   print_strornum(f, &psUnitTypes->sUnitType);

   /* ppsUnitTypes */
   printN_DbvUnits(f, "ppsUnits", psUnitTypes->ppsUnits );

   } /* End print_DbvUnitType() */



void printN_DbvUnits(FILE *f, char *name, DbvUnits **ppsUnits)
{
   if( ppsUnits != NULL)
      {
      fprintf(f, "%s:\n", name);
      while( ppsUnits && *ppsUnits )
         {
         print_DbvUnits(f, *ppsUnits);
         ppsUnits++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */
   } /* End printN_DbvUnits() */



void print_DbvUnits( FILE *f, DbvUnits *psUnits)
   {

   /* Write the title out */ 
   if (psUnits == NULL)
      {
      fprintf(f, "%s: NULL\n","psUnits");
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psUnits");
   
   /* psName */
   fprintf(f, "psName: ");
   print_inter_string(f, psUnits->psName);

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psUnits->ppsDescription );

   /* sUnit */
   fprintf(f, "sUnit: ");
   print_strornum(f, &psUnits->sUnit);

   } /* End print_DbvUnits() */



/* -------------------- DbvCategoryList -------------------- */

void print_DbvCategoryList( FILE *f, DbvCategoryList *psCategoryList)
   {

   /* Write the title out */ 
   if (psCategoryList == NULL)
      {
      fprintf(f, "%s: NULL\n","psCategoryList");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psCategoryList");
   


   /* psCommonInfo */
   print_DbvCommonInfo(f, "psCommonInfo", psCategoryList->psCommonInfo);

   /* ppsCategories */
   printN_DbvCategoryInfo(f, psCategoryList->ppsCategories);

   } /* End print_DbvCategoryList() */



void printN_DbvCategoryInfo(FILE *f,  DbvCategoryInfo **ppsCategories)
   {

   if( ppsCategories != NULL)
      {
      fprintf(f, "%s:\n", "ppsCategories");
      while( ppsCategories && *ppsCategories )
         {
         print_DbvCategoryInfo(f, *ppsCategories);
         ppsCategories++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", "ppsCategories");
      
      } /* End else */

     
   } /* End printN_DbvCategoryInfo() */



void print_DbvCategoryInfo(FILE *f,  DbvCategoryInfo *psCategoryInfo)
   {

   /* Write the title out */ 
   if (psCategoryInfo == NULL)
      {
      fprintf(f, "%s: NULL\n","psCategoryInfo");
      
      return;
      } /* End if */

   fprintf(f, "%s:\n", "psCategoryInfo");
   


   /* sCategory */
   fprintf(f, "sCategory: ");
   print_inter_string(f, &psCategoryInfo->sCategory );

   /* psOriginalCategory */
   fprintf(f, "psOriginalCategory: ");
   print_inter_string(f, psCategoryInfo->psOriginalCategory );

   /* ppsDescription */
   printN_DbvHumanString(f, "ppsDescription", psCategoryInfo->ppsDescription );
			
   /* psAsn1Module */
   fprintf(f, "psAsn1Module: ");
   print_inter_string(f, psCategoryInfo->psAsn1Module );

   } /* End print_DbvCategoryInfo() */


/*************************************/





int print_generic_external(FILE *f, DbvASN1External *external_ptr)
{
        fprintf(f,"\tpsGenericRecord:\n");

	fprintf(f,"Printing of this record type is not yet supported\n");
}








/******************************************************************/
/******************************************************************/
/* Before printing compulsory fields which are pointers, check that they 
   are not NULL to prevent nasty test program crashes */
/*******************************************************/
/* ItemOrder external */ 

int print_itemorder_external(FILE *f, DbvASN1External *external_ptr)
{
	DbvItemOrderExtendedService *io_ptr;

	fprintf(f,"psItemOrderExtendedService:\n");
	io_ptr = external_ptr->uExternalValue.psSingleASN1Type->uASN1.psItemOrderExtendedService;

	if (io_ptr != NULL) {
		fprintf(f,"eItemOrderReqRsp: ");
		switch (io_ptr->eItemOrderReqRsp) {
		case IOROR_Request:
			fprintf(f,"IOROR_Request: ");
			if (io_ptr->uItemOrderReqOrRsp.psItemOrderRequest != NULL)
				print_io_request(f, io_ptr->uItemOrderReqOrRsp.psItemOrderRequest);
			break;
		case IOROR_Response:
			fprintf(f,"IOROR_Response: ");
			if (io_ptr->uItemOrderReqOrRsp.psItemOrderResponse != NULL)
				print_io_response(f, io_ptr->uItemOrderReqOrRsp.psItemOrderResponse);
			break;
		default:
			fprintf(f,"Unknown\n");
			break;
		}
	}
}



int print_io_request(FILE *f, DbvEsIoRequest *psItemOrderRequest)
{
	fprintf(f,"\n");

	/* o */
        fprintf(f,"psToKeep: ");
        if (psItemOrderRequest->psToKeep != NULL)
                print_io_originpartkeep(f, psItemOrderRequest->psToKeep);
        else
                fprintf(f,"NULL\n");


	/* c */
	fprintf(f,"sNotToKeep: ");
	print_io_originpartnotkeep(f, &psItemOrderRequest->sNotToKeep);
	
}



int print_io_originpartkeep(FILE *f, DbvEsIoOriginPartToKeep *psToKeep)
{
	
	/* o */
        fprintf(f,"psSupplementalDescription: ");
        if (psToKeep->psSupplementalDescription != NULL)
		print_external(f, psToKeep->psSupplementalDescription);
        else
                fprintf(f,"NULL\n");


	/* o */
        fprintf(f,"psContact: ");
        if (psToKeep->psContact != NULL)
		print_io_contact(f, psToKeep->psContact);
        else
                fprintf(f,"NULL\n");

	/* o */
        fprintf(f,"psAdditionalBilling:\n");
        if (psToKeep->psAdditionalBilling != NULL)
		print_io_addbilling(f, psToKeep->psAdditionalBilling);
        else
                fprintf(f,"NULL\n");


}


int print_io_contact(FILE *f, DbvEsIoContact *psContact)
{
	/* o */
        fprintf(f,"psName: ");
	if (psContact->psName != NULL)
		print_inter_string(f, psContact->psName);
        else
                fprintf(f,"NULL\n");


	/* o */
        fprintf(f,"psPhone: ");
	if (psContact->psPhone != NULL)
		print_inter_string(f, psContact->psPhone);
        else
                fprintf(f,"NULL\n");



	/* o */
        fprintf(f,"psEmail: ");
	if (psContact->psEmail != NULL)
		print_inter_string(f, psContact->psEmail);
        else
                fprintf(f,"NULL\n");


	
}



int print_io_addbilling(FILE *f, DbvEsIoAdditionalBilling *psAdditionalBilling)
{
	
	/* c */
        fprintf(f,"sPaymentMethod: ");
	print_io_paymethod(f, &psAdditionalBilling->sPaymentMethod);

	/* o */
        fprintf(f,"psCustomerReference: ");
	if (psAdditionalBilling->psCustomerReference != NULL)
		print_inter_string(f, psAdditionalBilling->psCustomerReference);
        else
                fprintf(f,"NULL\n");

	/* o */
        fprintf(f,"psCustomerPONumber: ");
	if (psAdditionalBilling->psCustomerPONumber != NULL)
		print_inter_string(f, psAdditionalBilling->psCustomerPONumber);
        else
                fprintf(f,"NULL\n");
	
}



int print_io_paymethod(FILE *f, DbvEsIoPaymentMethod *psPaymentMethod)
{
	fprintf(f,"\n");

        fprintf(f,"ePaymentMethodType: ");
        switch (psPaymentMethod->ePaymentMethodType) {
        case IOPM_BillInvoice:
                fprintf(f,"IOPM_BillInvoice\n");
                break;
        case IOPM_Prepay:
                fprintf(f,"IOPM_Prepay\n");
                break;
        case IOPM_DepositAccount:
                fprintf(f,"IOPM_DepositAccount\n");
                break;
        case IOPM_CreditCard:
                fprintf(f,"IOPM_CreditCard\n");

		if (psPaymentMethod->puPaymentMethod->psCreditCardInfo != NULL)
			print_io_creditcardinfo(f, psPaymentMethod->puPaymentMethod->psCreditCardInfo);
                break;
        case IOPM_CardInfoPrevSupplied:
                fprintf(f,"IOPM_CardInfoPrevSupplied\n");
                break;
        case IOPM_PrivateKnown:
                fprintf(f,"IOPM_PrivateKnown\n");
                break;
        case IOPM_PrivateNotKnown:
                fprintf(f,"IOPM_PrivateNotKnown\n");

		if (psPaymentMethod->puPaymentMethod->psPrivateNotKnown != NULL)
			print_external(f, psPaymentMethod->puPaymentMethod->psPrivateNotKnown);
                break;
        case IOPM_Invalid:
                fprintf(f,"IOPM_Invalid\n");
                break;
        }
	
}


int print_io_creditcardinfo(FILE *f, DbvEsIoCreditCardInfo *psCreditCardInfo)
{
	/* c */
        fprintf(f,"sNameOnCard: ");
	print_inter_string(f, &psCreditCardInfo->sNameOnCard);

	/* c */
        fprintf(f,"sExpirationDate: ");
	print_inter_string(f, &psCreditCardInfo->sExpirationDate);

	/* c */
        fprintf(f,"sCardNumber: ");
	print_inter_string(f, &psCreditCardInfo->sCardNumber);
	
}



int print_io_originpartnotkeep(FILE *f, DbvEsIoOriginPartNotToKeep *psNotToKeep)
{

	/* o */
	fprintf(f,"psResultSetItem: ");
	if (psNotToKeep->psResultSetItem != NULL)
		print_io_ressetitem(f, psNotToKeep->psResultSetItem);
	else
                fprintf(f,"NULL\n");

	/* o */
	fprintf(f,"psItemRequest: ");
	if (psNotToKeep->psItemRequest != NULL)
		print_external(f, psNotToKeep->psItemRequest);
	else
                fprintf(f,"NULL\n");

		
	
}


int print_io_ressetitem(FILE *f, DbvEsIoResultSetItem *psResultSetItem)
{
	/* c */
	fprintf(f,"sResultSetId: ");
	print_inter_string(f, &psResultSetItem->sResultSetId);

	/* c */
	fprintf(f,"sResultSetId: ");
	fprintf(f,"%lu\n", psResultSetItem->ulItem);
	
}



int print_io_response(FILE *f, DbvEsIoTaskPackage *psItemOrderResponse)
{
	fprintf(f,"\n");

	/* o */
        fprintf(f,"psOriginPart: ");
        if (psItemOrderResponse->psOriginPart != NULL)
		print_io_originpartkeep(f, psItemOrderResponse->psOriginPart);
        else
                fprintf(f,"NULL\n");

	/* c */
        fprintf(f,"sTargetPart: ");
	print_io_targetpart(f, &psItemOrderResponse->sTargetPart);

}




int print_io_targetpart(FILE *f, DbvEsIoTargetPart *psTargetPart)
{

	/* o */

	/* print out ILL - could legally be any other external however ! */
        fprintf(f,"psItemRequest: ");
        if (psTargetPart->psItemRequest != NULL)
		print_external(f, psTargetPart->psItemRequest);
        else
                fprintf(f,"NULL\n");


	/* c */
        fprintf(f,"psStatusOrErrorReport: ");
	if (psTargetPart->psStatusOrErrorReport != NULL)
		print_external(f, psTargetPart->psStatusOrErrorReport);

	/* o */
        fprintf(f,"peAuxiliaryStatus: ");
        if (psTargetPart->peAuxiliaryStatus != NULL)
		print_io_auxstat(f, psTargetPart->peAuxiliaryStatus);
        else
                fprintf(f,"NULL\n");

	
}



int print_io_auxstat(FILE *f, DbvEsIoAuxiliaryStatus *peAuxiliaryStatus)
{
	switch (*peAuxiliaryStatus) {
	case IOAS_NotReceived:
		fprintf(f,"IOAS_NotReceived\n");
		break;
	case IOAS_LoanQueue:
		fprintf(f,"IOAS_LoanQueue\n");
		break;
	case IOAS_Forwarded:
		fprintf(f,"IOAS_Forwarded\n");
		break;
	case IOAS_UnfilledCopyright:
		fprintf(f,"IOAS_UnfilledCopyright\n");
		break;
	case IOAS_FilledCopyright:
		fprintf(f,"IOAS_FilledCopyright\n");
		break;
	case IOAS_Invalid:
		fprintf(f,"IOAS_Invalid\n");
		break;
	}
}



/*******************************************************/
/* Ill external */ 
int print_ill_external(FILE *f, DbvASN1External *external_ptr)
{
	DbvIllPdu *ill_ptr;

	ill_ptr = external_ptr->uExternalValue.psSingleASN1Type->uASN1.psIllPdu;

	if (ill_ptr != NULL) {

		fprintf(f,"eIllPduType: ");
		switch (ill_ptr->eIllPduType) {
		case ILL_IllRequest:
			fprintf(f,"ILL_IllRequest: ");
			if (ill_ptr->uIllPdu.psIllRequest != NULL)
				print_ill_request(f, ill_ptr->uIllPdu.psIllRequest);
			break;
		case ILL_StatusOrErrorReport:
			fprintf(f,"ILL_StatusOrErrorReport: ");
			if (ill_ptr->uIllPdu.psStatusOrErrorReport != NULL)
				print_ill_statorerr(f, ill_ptr->uIllPdu.psStatusOrErrorReport);
			break;
		case ILL_Invalid:
			fprintf(f,"ILL_Invalid\n");
			break;
		}
	}
}


int print_ill_request(FILE *f, struct DbvIllRequest *psIllRequest)
{
	fprintf(f,"\n");

	/* c */
	fprintf(f,"eProtocolVersion: ");
	print_ill_protocolver(f, &psIllRequest->eProtocolVersion);

	/* c */
	fprintf(f,"sTransactionId: ");
	print_ill_transid(f, &psIllRequest->sTransactionId);

	/* c */
	fprintf(f,"sServiceDateTime: ");
	print_ill_servdatetime(f, &psIllRequest->sServiceDateTime);
	
	/* o */
	fprintf(f,"psRequesterId: ");
	if (psIllRequest->psRequesterId != NULL) 
		print_ill_systemid(f, psIllRequest->psRequesterId);
	else
		fprintf(f,"NULL\n");
	

	/* o */
	fprintf(f,"psResponderId: ");
	if (psIllRequest->psResponderId != NULL) 
		print_ill_systemid(f, psIllRequest->psResponderId);
	else
		fprintf(f,"NULL\n");
	

	/* c */
	fprintf(f,"peTransactionType: ");
	if (psIllRequest->peTransactionType != NULL) 
		print_ill_transtype(f, psIllRequest->peTransactionType);
	else
		fprintf(f,"NULL\n");
	

	/* o */
	fprintf(f,"psDeliveryAddress: ");
	if (psIllRequest->psDeliveryAddress != NULL) 
		print_ill_delivaddr(f, psIllRequest->psDeliveryAddress);
	else
		fprintf(f,"NULL\n");
	

	/* o */
	fprintf(f,"psDeliveryService: ");
	if (psIllRequest->psDeliveryService != NULL) 
		print_ill_delivserv(f, psIllRequest->psDeliveryService);
	else
		fprintf(f,"NULL\n");
	

	/* o */
	fprintf(f,"psBillingAddress: ");
	if (psIllRequest->psBillingAddress != NULL) 
		print_ill_delivaddr(f, psIllRequest->psBillingAddress);
	else
		fprintf(f,"NULL\n");
	


	/* iLL_service_type */
	/* c */
	fprintf(f,"ppeServiceType: ");
	if (psIllRequest->ppeServiceType != NULL)
		print_ill_servtypelist(f, psIllRequest->ppeServiceType);


	/* o */
	fprintf(f,"psResponderSpecificService: ");
	if (psIllRequest->psResponderSpecificService != NULL) 
		print_external(f, psIllRequest->psResponderSpecificService);
	else
		fprintf(f,"NULL\n");
	

	
	/* c */
	fprintf(f,"sRequesterOptionalMessages: ");
	print_ill_reqoptmsg(f, &psIllRequest->sRequesterOptionalMessages);


	/* o */
	fprintf(f,"psSearchType: ");
	if (psIllRequest->psSearchType != NULL) 
		print_ill_searchtype(f, psIllRequest->psSearchType);
	else
		fprintf(f,"NULL\n");
	

	/* o */
	fprintf(f,"ppsSupplyMediumInfo: ");
	if (psIllRequest->ppsSupplyMediumInfo != NULL)
		print_ill_suppmedlist(f, psIllRequest->ppsSupplyMediumInfo);
	else
		fprintf(f,"NULL\n");
	
	


	/* place_on_hold */
	/* default */
	fprintf(f,"pePlaceOnHold: ");
	if (psIllRequest->pePlaceOnHold)
		print_ill_placeonhold(f, psIllRequest->pePlaceOnHold);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"psClientId: ");
	if (psIllRequest->psClientId != NULL)
		print_ill_clientid(f, psIllRequest->psClientId);
	else
		fprintf(f,"NULL\n");
	

	/* c */
	fprintf(f,"sItemId: ");
	print_ill_itemid(f, &psIllRequest->sItemId);
	


	/* o */
	fprintf(f,"ppsSupplementalItemDescription: ");
	if (psIllRequest->ppsSupplementalItemDescription != NULL)
		print_ill_suppdesc(f, psIllRequest->ppsSupplementalItemDescription);
	else
		fprintf(f,"NULL\n");
	
		

	/* o */
	fprintf(f,"psCostInfo: ");
	if (psIllRequest->psCostInfo != NULL)
		print_ill_costinfo(f, psIllRequest->psCostInfo);
	else
		fprintf(f,"NULL\n");
	

	/* o */
	fprintf(f,"psCopyrightCompliance: ");
	if (psIllRequest->psCopyrightCompliance != NULL)
		print_ill_illstring(f, psIllRequest->psCopyrightCompliance);
	else
		fprintf(f,"NULL\n");
	


	/* o */
	fprintf(f,"psThirdPartyInfo: ");
	if (psIllRequest->psThirdPartyInfo != NULL)
		print_ill_thirdparty(f, psIllRequest->psThirdPartyInfo);
	else
		fprintf(f,"NULL\n");


	/* retry_flag */
	/* default */
	fprintf(f,"pfRetry: ");
	if (psIllRequest->pfRetry)
		print_bool(f, psIllRequest->pfRetry);
	else
		fprintf(f,"NULL\n");


	/* default */
	fprintf(f,"pfForward: ");
	if (psIllRequest->pfForward)
		print_bool(f, psIllRequest->pfForward);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"psRequesterNote: ");
	if (psIllRequest->psRequesterNote != NULL)
		print_ill_illstring(f, psIllRequest->psRequesterNote);
	else
		fprintf(f,"NULL\n");
	

	/* o */
	fprintf(f,"psForwardNote: ");
	if (psIllRequest->psForwardNote != NULL)
		print_ill_illstring(f, psIllRequest->psForwardNote);
	else
		fprintf(f,"NULL\n");
	

	/* o */
	fprintf(f,"ppsRequestExtension: ");
	if (psIllRequest->ppsRequestExtension != NULL)
		print_ill_extensionlist(f, psIllRequest->ppsRequestExtension);
	else
		fprintf(f,"NULL\n");

}



int print_ill_protocolver(FILE *f, DbvIllProtocolVersion *peProtocolVersion)
{
	switch (*peProtocolVersion) {
	case PV_Version1:
		fprintf(f,"PV_Version1\n");
		break;
	case PV_Version2:
		fprintf(f,"PV_Version2\n");
		break;
	case PV_Invalid:
		fprintf(f,"PV_Invalid\n");
		break;
	}

	
}



int print_ill_transid(FILE *f, DbvTransactionId *psTransactionId)
{
	fprintf(f,"\n");

	/* o */
	fprintf(f,"psInitialRequesterId: ");
	if (psTransactionId->psInitialRequesterId != NULL)
		print_ill_systemid(f, psTransactionId->psInitialRequesterId);
	else
		fprintf(f,"NULL\n");
	

	/* c */
	fprintf(f,"sTransactionGroupQualifier: ");
	print_ill_illstring(f, &psTransactionId->sTransactionGroupQualifier);


	/* c */
	fprintf(f,"sTransactionQualifier: ");
	print_ill_illstring(f, &psTransactionId->sTransactionQualifier);


	/* o */
	fprintf(f,"psSubTransactionQualifier: ");
	if (psTransactionId->psSubTransactionQualifier != NULL)
		print_ill_illstring(f, psTransactionId->psSubTransactionQualifier);
	else
		fprintf(f,"NULL\n");
}



int print_ill_systemid(FILE *f, DbvSystemId *psInitialRequesterId)
{
	fprintf(f,"\n");

	/* o */
	fprintf(f,"psSymbol: ");
	if (psInitialRequesterId->psSymbol != NULL)
		print_ill_symbol(f, psInitialRequesterId->psSymbol);
	else
		fprintf(f,"NULL\n");

	/* o */
	fprintf(f,"psName: ");
	if (psInitialRequesterId->psName != NULL)
		print_ill_name(f, psInitialRequesterId->psName);
	else
		fprintf(f,"NULL\n");
}



int print_ill_symbol(FILE *f, DbvPersonOrInstitutionSymbol *psSymbol)
{
	fprintf(f,"\n");

	/* c */
	fprintf(f,"eSymbolType: ");
	print_ill_perorinstsymtype(f, &psSymbol->eSymbolType);

	/* c */
	fprintf(f,"sSymbol: ");
	print_ill_illstring(f, &psSymbol->sSymbol);

}



int print_ill_perorinstsymtype(FILE *f, DbvPersOrInstSymbolType *peSymbolType)
{
	switch (*peSymbolType) {
	case SPI_PersonSymbol:
		fprintf(f,"SPI_PersonSymbol\n");
		break;
	case SPI_InstitutionSymbol:
		fprintf(f,"SPI_InstitutionSymbol\n");
		break;
	}
	
}


int print_ill_illstring(FILE *f, DbvIllString *psSymbol)
{

	switch (psSymbol->eStringType) {
	case ST_GeneralString:
		fprintf(f,"ST_GeneralString: ");
		if (psSymbol->uString.psGeneralString != NULL)
			print_DbvGeneralString(f, psSymbol->uString.psGeneralString);
		break;
	case ST_EdifactString:
		fprintf(f,"ST_EdifactString: ");
		if (psSymbol->uString.pcVisibleString != NULL)
			fprintf(f,"%s\n", psSymbol->uString.pcVisibleString);
		break;
	}
	
}


/* DbvGeneralString is defined in sitypes.h - it has the same 
structure as DbvInternationalString so print as such */
int print_DbvGeneralString(FILE *f, DbvGeneralString *psGeneralString)
{
	print_inter_string(f, (DbvInternationalString *) psGeneralString);
}



int print_ill_name(FILE *f, DbvNameOfPersonOrInstitution *psName)
{
	/* c */
	fprintf(f,"eNameType: ");
	print_ill_nameofperorinst_type(f, &psName->eNameType);

	/* c */
	fprintf(f,"sName: ");
	print_ill_illstring(f, &psName->sName);
}


int print_ill_nameofperorinst_type(FILE *f, DbvNameOfPersOrInstType *peNameType)
{
	switch (*peNameType) {
	case NPI_NameOfPerson:
		fprintf(f,"NPI_NameOfPerson\n");
		break;
	case NPI_NameOfInstitution:
		fprintf(f,"NPI_NameOfInstitution\n");
		break;
	}
	
}


int print_ill_servdatetime(FILE *f, DbvServiceDateTime *psServiceDateTime)
{
	/* c */
	fprintf(f,"sThisService: ");
	print_ill_datetime(f, &psServiceDateTime->sThisService);

	/* o */
	fprintf(f,"psOriginalService: ");
	if (psServiceDateTime->psOriginalService != NULL)
		print_ill_datetime(f, psServiceDateTime->psOriginalService);
	else
		fprintf(f,"NULL\n");
}


int print_ill_datetime(FILE *f, DbvDateTime *psThisService)
{
	fprintf(f,"\n");

	/* c */
	fprintf(f,"pcDate: %s\n", psThisService->pcDate);

	/* o */
	fprintf(f,"pcTime: ");
	if (psThisService->pcTime != NULL)
		fprintf(f,"%s\n", psThisService->pcTime);
	else
		fprintf(f,"NULL\n");
}


int print_ill_transtype(FILE *f, DbvTransactionType *peTransactionType)
{
	switch (*peTransactionType) {
	case TT_Simple:
		fprintf(f,"TT_Simple\n");
		break;
	case TT_Chained:
		fprintf(f,"TT_Chained\n");
		break;
	case TT_Partitioned:
		fprintf(f,"TT_Partitioned\n");
		break;
	case TT_Invalid:
		fprintf(f,"TT_Invalid\n");
		break;
	}
}



int print_ill_delivaddr(FILE *f, DbvDeliveryAddress *psDeliveryAddress)
{
	fprintf(f,"\n");

	/* o */
	fprintf(f,"psPostalAddress: ");
	if (psDeliveryAddress->psPostalAddress != NULL)
		print_ill_postaladdr(f, psDeliveryAddress->psPostalAddress);
	else
		fprintf(f,"NULL\n");

	/* o */
	fprintf(f,"psElectronicAddress: ");
	if (psDeliveryAddress->psElectronicAddress != NULL)
		print_ill_sysaddr(f, psDeliveryAddress->psElectronicAddress);
	else
		fprintf(f,"NULL\n");
}



int print_ill_postaladdr(FILE *f, DbvPostalAddress *psPostalAddress)
{
	/* o */
	fprintf(f,"psNameOfPersonOrInstitution: ");
	if (psPostalAddress->psNameOfPersonOrInstitution != NULL)
		print_ill_name(f, psPostalAddress->psNameOfPersonOrInstitution);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psExtendedPostalDeliveryAddress: ");
	if (psPostalAddress->psExtendedPostalDeliveryAddress != NULL)
		print_ill_illstring(f, psPostalAddress->psExtendedPostalDeliveryAddress);
	else
		fprintf(f,"NULL\n");
	

	/* o */	
	fprintf(f,"psStreetAndNumber: ");
	if (psPostalAddress->psStreetAndNumber != NULL)
		print_ill_illstring(f, psPostalAddress->psStreetAndNumber);
	else
		fprintf(f,"NULL\n");
	

	/* o */	
	fprintf(f,"psPostOfficeBox: ");
	if (psPostalAddress->psPostOfficeBox != NULL)
		print_ill_illstring(f, psPostalAddress->psPostOfficeBox);
	else
		fprintf(f,"NULL\n");
	

	/* o */	
	fprintf(f,"psCity: ");
	if (psPostalAddress->psCity != NULL)
		print_ill_illstring(f, psPostalAddress->psCity);
	else
		fprintf(f,"NULL\n");
	

	/* o */	
	fprintf(f,"psRegion: ");
	if (psPostalAddress->psRegion != NULL)
		print_ill_illstring(f, psPostalAddress->psRegion);
	else
		fprintf(f,"NULL\n");
	

	/* o */	
	fprintf(f,"psCountry: ");
	if (psPostalAddress->psCountry != NULL)
		print_ill_illstring(f, psPostalAddress->psCountry);
	else
		fprintf(f,"NULL\n");
	

	/* o */	
	fprintf(f,"psPostalCode: ");
	if (psPostalAddress->psPostalCode != NULL)
		print_ill_illstring(f, psPostalAddress->psPostalCode);
	else
		fprintf(f,"NULL\n");
	
	
}



int print_ill_sysaddr(FILE *f, DbvSystemAddress *psElectronicAddress)
{
	fprintf(f,"\n");

	/* o */
	fprintf(f,"psTelecomServiceIdentifier: ");
	if (psElectronicAddress->psTelecomServiceIdentifier != NULL)
		print_ill_illstring(f, psElectronicAddress->psTelecomServiceIdentifier);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"psTelecomServiceAddress: ");
	if (psElectronicAddress->psTelecomServiceAddress != NULL)
		print_ill_illstring(f, psElectronicAddress->psTelecomServiceAddress);
	else
		fprintf(f,"NULL\n");
}



int print_ill_delivserv(FILE *f, DbvDeliveryService *psDeliveryService)
{
	fprintf(f,"\n");

	/* c */
	fprintf(f,"eDeliveryServiceType: ");
	switch (psDeliveryService->eDeliveryServiceType) {
	case DST_PhysicalDelivery:
		fprintf(f,"DST_PhysicalDelivery: ");

		if (psDeliveryService->uDeliveryService.psPhysicalDelivery != NULL) 
			print_ill_illstring(f, psDeliveryService->uDeliveryService.psPhysicalDelivery);
		
		break;

	case DST_ElectronicDelivery:
		fprintf(f,"DST_ElectronicDelivery: ");

		if (psDeliveryService->uDeliveryService.ppsElectronicDelivery != NULL) 
			print_ill_elecdelivservlist(f, psDeliveryService->uDeliveryService.ppsElectronicDelivery);
		break;
	case DST_Invalid:
		fprintf(f,"DST_Invalid\n");
		break;
	}

}


int print_ill_elecdelivservlist(FILE *f, DbvElectronicDeliveryService **ppsElectronicDelivery)
{
	int index = 0;

	fprintf(f,"\n");

	while (ppsElectronicDelivery[index] != NULL) {
       		fprintf(f,"\tpsElectronicDelivery[%d]\n", index);
		print_ill_elecdelivserv(f, ppsElectronicDelivery[index]);
		index++;
		fprintf(f,"\n");
	}
	fprintf(f,"\n");
}



int print_ill_elecdelivserv(FILE *f, DbvElectronicDeliveryService *psElectronicDelivery)
{
	fprintf(f,"\n");

	/* o */
	fprintf(f,"psDeliveryParameter: ");
	if (psElectronicDelivery->psDeliveryParameter != NULL)
		print_ill_eldelivparam(f, psElectronicDelivery->psDeliveryParameter);
	else
		fprintf(f,"NULL\n");

	fprintf(f,"\n");

	/* o */
	fprintf(f,"psDocumentTypeParameter: ");
	if (psElectronicDelivery->psDocumentTypeParameter != NULL)
		print_ill_doctypeparam(f, psElectronicDelivery->psDocumentTypeParameter);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"psDeliveryDescription: ");
	if (psElectronicDelivery->psDeliveryDescription != NULL)
		print_ill_illstring(f, psElectronicDelivery->psDeliveryDescription);
	else
		fprintf(f,"NULL\n");


	/* c */
	fprintf(f,"sDeliveryDetails: ");
	print_ill_eldelivdetails(f, &psElectronicDelivery->sDeliveryDetails);
	
	/* o */
	fprintf(f,"psNameOrCode: ");
	if (psElectronicDelivery->psNameOrCode != NULL)
		print_ill_illstring(f, psElectronicDelivery->psNameOrCode);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"pcDeliveryTime: ");
	if (psElectronicDelivery->pcDeliveryTime != NULL)
		fprintf(f,"%s\n", psElectronicDelivery->pcDeliveryTime);
	else
		fprintf(f,"NULL\n");
}



int print_ill_eldelivparam(FILE *f, DbvElDeliveryParameter *psDeliveryParameter)
{
	fprintf(f,"\n");

	/* o */
	fprintf(f,"pcDeliveryMode: ");
	if (psDeliveryParameter->pcDeliveryMode != NULL) 
		fprintf(f,"%s\n", psDeliveryParameter->pcDeliveryMode);
	else 
		fprintf(f,"NULL\n");

	/* o */
	fprintf(f,"psDummy: ");
	if (psDeliveryParameter->puDeliveryParameter != NULL) 
		if (psDeliveryParameter->puDeliveryParameter->psDummy != NULL)
			   print_external(f, psDeliveryParameter->puDeliveryParameter->psDummy);
		else
			fprintf(f,"NULL\n");
	else
		fprintf(f,"NULL\n");
}



int print_ill_doctypeparam(FILE *f, DbvDocumentTypeParameter *psDocumentTypeParameter)
{
	fprintf(f,"\n");

	/* o */
	fprintf(f,"pcDocumentTypeId: ");
	if (psDocumentTypeParameter->pcDocumentTypeId != NULL) 
		fprintf(f,"%s\n", psDocumentTypeParameter->pcDocumentTypeId);
	else
		fprintf(f,"NULL\n");

	/* o */
	fprintf(f,"psDummy: ");
	if (psDocumentTypeParameter->puDocumentTypeParameter != NULL) 
		if (psDocumentTypeParameter->puDocumentTypeParameter->psDummy != NULL)
			print_external(f, psDocumentTypeParameter->puDocumentTypeParameter->psDummy);
		else
			fprintf(f,"NULL\n");
	else
		fprintf(f,"NULL\n");
}


int print_ill_eldelivdetails(FILE *f, DbvElDeliveryDetails *psDeliveryDetails)
{
	switch (psDeliveryDetails->eDeliveryDetailsType) {
	case DDT_SystemAddress:
		fprintf(f,"DDT_SystemAddress\n");
		if (psDeliveryDetails->uDeliveryDetails.psSystemAddress != NULL)
			print_ill_sysaddr(f, psDeliveryDetails->uDeliveryDetails.psSystemAddress);
		
		break;
	case DDT_SystemId:
		fprintf(f,"DDT_SystemId\n");
		if (psDeliveryDetails->uDeliveryDetails.psSystemId != NULL)
			print_ill_systemid(f, psDeliveryDetails->uDeliveryDetails.psSystemId);
		break;
	}
	
}


int print_ill_servtypelist(FILE *f, DbvServiceType **ppeServiceType)
{
	int index = 0;

	fprintf(f,"\n");

	while (ppeServiceType[index] != NULL) {
       		fprintf(f,"\tpeServiceType[%d]: ", index);
		print_ill_servtype(f, ppeServiceType[index]);
		index++;
		fprintf(f,"\n");
	}
	fprintf(f,"\n");
}



int print_ill_servtype(FILE *f, DbvServiceType *peServiceType)
{
	fprintf(f,"\n");

	switch (*peServiceType) {
	case ST_Loan:
		fprintf(f,"ST_Loan\n");
		break;
	case ST_CopyNonReturnable:
		fprintf(f,"ST_CopyNonReturnable\n");
		break;
	case ST_Locations:
		fprintf(f,"ST_Locations\n");
		break;
	case ST_Estimate:
		fprintf(f,"ST_Estimate\n");
		break;
	case ST_ResponderSpecific:
		fprintf(f,"ST_ResponderSpecific\n");
		break;
	case ST_Invalid:
		fprintf(f,"ST_Invalid\n");
		break;
	}
}



int print_ill_reqoptmsg(FILE *f, DbvRequesterOptionalMessages *psRequesterOptionalMessages)
{
	fprintf(f,"\n");

	/* c */
	fprintf(f,"fCanSendReceived: ");
	print_bool(f, &psRequesterOptionalMessages->fCanSendReceived);

	/* c */
	fprintf(f,"fCanSendReturned: ");
	print_bool(f, &psRequesterOptionalMessages->fCanSendReturned);

	/* c */
	fprintf(f,"eRequesterShipped: ");
	print_ill_optmsgreq(f, &psRequesterOptionalMessages->eRequesterShipped);

	/* c */
	fprintf(f,"eRequesterCheckedIn: ");
	print_ill_optmsgreq(f, &psRequesterOptionalMessages->eRequesterCheckedIn);
}



int print_ill_optmsgreq(FILE *f, DbvOptionalMsgRequirements *peRequesterCheckedIn)
{
	switch (*peRequesterCheckedIn) {
	case OMR_Requires:
		fprintf(f,"OMR_Requires\n");	
		break;
	case OMR_Desires:
		fprintf(f,"OMR_Desires\n");	
		break;
	case OMR_Neither:
		fprintf(f,"OMR_Neither\n");	
		break;
	case OMR_Invalid:
		fprintf(f,"OMR_Invalid\n");	
		break;
	}
}


int print_ill_searchtype(FILE *f, DbvSearchType *psSearchType)
{
	fprintf(f,"\n");

	/* o */
	fprintf(f,"psLevelOfService: ");
	if (psSearchType->psLevelOfService != NULL)
		print_ill_illstring(f, psSearchType->psLevelOfService);
	else
		fprintf(f,"NULL\n");

	/* o */
	fprintf(f,"pcNeedBeforeDate: ");
	if (psSearchType->pcNeedBeforeDate != NULL)
		fprintf(f,"%s\n", psSearchType->pcNeedBeforeDate);
	else
		fprintf(f,"NULL\n");

	/* c */
	fprintf(f,"peExpiryFlag: ");
	if (psSearchType->peExpiryFlag != NULL)
		print_ill_expflag(f, psSearchType->peExpiryFlag);
	else
		fprintf(f,"NULL\n");
		

	/* o */
	fprintf(f,"pcExpiryDate: ");
	if (psSearchType->pcExpiryDate != NULL)
		fprintf(f,"%s\n", psSearchType->pcExpiryDate);
	else
		fprintf(f,"NULL\n");

	
}


int print_ill_expflag(FILE *f, DbvExpiry *peExpiryFlag)
{
	switch (*peExpiryFlag) {
	case EXP_NeedBeforeDate:
		fprintf(f,"EXP_NeedBeforeDate\n");
		break;
	case EXP_OtherDate:
		fprintf(f,"EXP_OtherDate\n");
		break;
	case EXP_NoExpiry:
		fprintf(f,"EXP_NoExpiry\n");
		break;
	case EXP_Invalid:
		fprintf(f,"EXP_Invalid\n");
		break;
	}
	
}


int print_ill_suppmedlist(FILE *f, DbvSupplyMediumInfo **ppsSupplyMediumInfo)
{
	int index = 0;

	fprintf(f,"\n");

	while (ppsSupplyMediumInfo[index] != NULL) {
       		fprintf(f,"\tpsSupplyMediumInfo[%d]: ", index);
		print_ill_suppmed(f, ppsSupplyMediumInfo[index]);
		index++;
		fprintf(f,"\n");
	}
	fprintf(f,"\n");
}



int print_ill_suppmed(FILE *f, DbvSupplyMediumInfo *psSupplyMediumInfo)
{
	fprintf(f,"\n");

	/* c */
	fprintf(f,"eSupplyMediumType: ");
	print_ill_suppmedinfo(f, &psSupplyMediumInfo->eSupplyMediumType);	

	/* o */
	fprintf(f,"psMediumCharacteristics: ");
	if (psSupplyMediumInfo->psMediumCharacteristics != NULL)
		print_ill_illstring(f, psSupplyMediumInfo->psMediumCharacteristics);
	else
		fprintf(f,"NULL\n");
}



int print_ill_suppmedinfo(FILE *f, DbvSupplyMediumType *peSupplyMediumType)
{
	switch (*peSupplyMediumType) {
	case SMT_Printed:
		fprintf(f,"SMT_Printed\n");
		break;
	case SMT_Photocopy:
		fprintf(f,"SMT_Photocopy\n");
		break;
	case SMT_Microform:
		fprintf(f,"SMT_Microform\n");
		break;
	case SMT_FilmOrVideoRecording:
		fprintf(f,"SMT_FilmOrVideoRecording\n");
		break;
	case SMT_AudioRecording:
		fprintf(f,"SMT_AudioRecording\n");
		break;
	case SMT_MachineReadable:
		fprintf(f,"SMT_MachineReadable\n");
		break;
	case SMT_Other:
		fprintf(f,"SMT_Other\n");
		break;
	case SMT_Invalid:
		fprintf(f,"SMT_Invalid\n");
		break;
	}
}



int print_ill_placeonhold(FILE *f, DbvPlaceOnHold *pePlaceOnHold)
{
	switch (*pePlaceOnHold) {
	case POH_Yes:
		fprintf(f,"POH_Yes\n");
		break;
	case POH_No:
		fprintf(f,"POH_Yes\n");
		break;
	case POH_ResponderPolicy:
		fprintf(f,"POH_ResponderPolicy\n");
		break;
	case POH_Invalid:
		fprintf(f,"POH_Invalid\n");
		break;
	}
}


int print_ill_clientid(FILE *f, DbvClientId *psClientId)
{
	fprintf(f,"\n");

	/* o */
	fprintf(f,"psClientName: ");
	if (psClientId->psClientName != NULL)
		print_ill_illstring(f, psClientId->psClientName);
	else
		fprintf(f,"NULL\n");
	

	/* o */
	fprintf(f,"psClientStatus: ");
	if (psClientId->psClientStatus != NULL)
		print_ill_illstring(f, psClientId->psClientStatus);
	else
		fprintf(f,"NULL\n");
	



	/* o */
	fprintf(f,"psClientIdentifier: ");
	if (psClientId->psClientIdentifier != NULL)
		print_ill_illstring(f, psClientId->psClientIdentifier);
	else
		fprintf(f,"NULL\n");
	

	
}



int print_ill_itemid(FILE *f, DbvItemId *psItemId)
{
	fprintf(f,"\n");

	/* o */
	fprintf(f,"peItemType: ");
	if (psItemId->peItemType != NULL)
		print_ill_itemtype(f, psItemId->peItemType);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"peMediumType: ");
	if (psItemId->peMediumType != NULL)
		print_ill_mediumtype(f, psItemId->peMediumType);
	else
		fprintf(f,"NULL\n");

	
	/* o */
	fprintf(f,"psCallNumber: ");
	if (psItemId->psCallNumber != NULL)
		print_ill_illstring(f, psItemId->psCallNumber);
	else
		fprintf(f,"NULL\n");

	
	/* o */
	fprintf(f,"psAuthor: ");
	if (psItemId->psAuthor != NULL)
		print_ill_illstring(f, psItemId->psAuthor);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psTitle: ");
	if (psItemId->psTitle != NULL)
		print_ill_illstring(f, psItemId->psTitle);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psSubTitle: ");
	if (psItemId->psSubTitle != NULL)
		print_ill_illstring(f, psItemId->psSubTitle);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psSponsoringBody: ");
	if (psItemId->psSponsoringBody != NULL)
		print_ill_illstring(f, psItemId->psSponsoringBody);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psPlaceOfPublication: ");
	if (psItemId->psPlaceOfPublication != NULL)
		print_ill_illstring(f, psItemId->psPlaceOfPublication);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psPublisher: ");
	if (psItemId->psPublisher != NULL)
		print_ill_illstring(f, psItemId->psPublisher);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psSeriesTitleNumber: ");
	if (psItemId->psSeriesTitleNumber != NULL)
		print_ill_illstring(f, psItemId->psSeriesTitleNumber);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psVolumeIssue: ");
	if (psItemId->psVolumeIssue != NULL)
		print_ill_illstring(f, psItemId->psVolumeIssue);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psEdition: ");
	if (psItemId->psEdition != NULL)
		print_ill_illstring(f, psItemId->psEdition);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psPublicationDate: ");
	if (psItemId->psPublicationDate != NULL)
		print_ill_illstring(f, psItemId->psPublicationDate);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psPublicationDateOfComponent: ");
	if (psItemId->psPublicationDateOfComponent != NULL)
		print_ill_illstring(f, psItemId->psPublicationDateOfComponent);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psAuthorOfArticle: ");
	if (psItemId->psAuthorOfArticle != NULL)
		print_ill_illstring(f, psItemId->psAuthorOfArticle);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psTitleOfArticle: ");
	if (psItemId->psTitleOfArticle != NULL)
		print_ill_illstring(f, psItemId->psTitleOfArticle);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psPagination: ");
	if (psItemId->psPagination != NULL)
		print_ill_illstring(f, psItemId->psPagination);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psNationalBibliographyNo: ");
	if (psItemId->psNationalBibliographyNo != NULL)
		print_external(f, psItemId->psNationalBibliographyNo);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psIsbn: ");
	if (psItemId->psIsbn != NULL)
		print_ill_illstring(f, psItemId->psIsbn);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psIssn: ");
	if (psItemId->psIssn != NULL)
		print_ill_illstring(f, psItemId->psIssn);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psSystemNo: ");
	if (psItemId->psSystemNo != NULL)
		print_external(f, psItemId->psSystemNo);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psAdditionalNoLetters: ");
	if (psItemId->psAdditionalNoLetters != NULL)
		print_ill_illstring(f, psItemId->psAdditionalNoLetters);
	else
		fprintf(f,"NULL\n");
	
	/* o */
	fprintf(f,"psVerificationReferenceSource: ");
	if (psItemId->psVerificationReferenceSource != NULL)
		print_ill_illstring(f, psItemId->psVerificationReferenceSource);
	else
		fprintf(f,"NULL\n");
	
}



int print_ill_itemtype(FILE *f, DbvItemType *peItemType)
{
	switch (*peItemType) {
	case IT_Monograph:
		fprintf(f,"IT_Monograph\n");
		break;
	case IT_Serial:
		fprintf(f,"IT_Serial\n");
		break;
	case IT_Other:
		fprintf(f,"IT_Other\n");
		break;
	case IT_Invalid:
		fprintf(f,"IT_Invalid\n");
		break;
	}
}



int print_ill_mediumtype(FILE *f, DbvMediumType *peMediumType)
{
	switch (*peMediumType) {
	case MT_Printed:
		fprintf(f,"MT_Printed\n");
		break;
	case MT_Microform:
		fprintf(f,"MT_Microform\n");
		break;
	case MT_FilmOrVideoRecording:
		fprintf(f,"MT_FilmOrVideoRecording\n");
		break;
	case MT_AudioRecording:
		fprintf(f,"MT_AudioRecording\n");
		break;
	case MT_MachineReadable:
		fprintf(f,"MT_MachineReadable\n");
		break;
	case MT_Other:
		fprintf(f,"MT_Other\n");
		break;
	case MT_Invalid:
		fprintf(f,"MT_Invalid\n");
		break;
	}
	
}



int print_ill_suppdesc(FILE *f, DbvASN1External **ppsSupplementalItemDescription)
{

	int index = 0;

	fprintf(f,"\n");

	while (ppsSupplementalItemDescription[index] != NULL) {
       		fprintf(f,"\tpsSupplementalItemDescription[%d]: ", index);
		print_external(f, ppsSupplementalItemDescription[index]);
		index++;
		fprintf(f,"\n");
	}
	fprintf(f,"\n");
}



int print_ill_costinfo(FILE *f, DbvCostInfo *psCostInfo)
{
	
	fprintf(f,"\n");

	/* o */
	fprintf(f,"psAccountNumber: ");
	if (psCostInfo->psAccountNumber != NULL)
		print_ill_illstring(f, psCostInfo->psAccountNumber);
	else
		fprintf(f,"NULL\n");
	
	
	/* o */
	fprintf(f,"psMaximumCost: ");
	if (psCostInfo->psMaximumCost != NULL)
		print_ill_amount(f, psCostInfo->psMaximumCost);
	else
		fprintf(f,"NULL\n");
	

	/* default */
	fprintf(f,"pfReciprocalAgreement: ");
	if (psCostInfo->pfReciprocalAgreement)
		print_bool(f, psCostInfo->pfReciprocalAgreement);
	else
		fprintf(f,"NULL\n");
	

	/* default */
	fprintf(f,"pfWillPayFee: ");
	if (psCostInfo->pfWillPayFee)
		print_bool(f, psCostInfo->pfWillPayFee);
	else
		fprintf(f,"NULL\n");

	/* default */
	fprintf(f,"pfPaymentProvided: ");
	if (psCostInfo->pfWillPayFee)
		print_bool(f, psCostInfo->pfPaymentProvided);
	else
		fprintf(f,"NULL\n");
	
}



int print_ill_amount(FILE *f, DbvAmount *psMaximumCost)
{
	fprintf(f,"\n");

	/* o */
	fprintf(f,"pcCurrencyCode: ");
	if (psMaximumCost->pcCurrencyCode != NULL)
		fprintf(f,"%s\n", psMaximumCost->pcCurrencyCode);
	else
		fprintf(f,"NULL\n");
	

	/* c */
	fprintf(f,"pcMonetaryValue: ");
	if (psMaximumCost->pcMonetaryValue != NULL)
		fprintf(f,"%s\n", psMaximumCost->pcMonetaryValue);
	
}



int print_ill_thirdparty(FILE *f, DbvThirdPartyInfo *psThirdPartyInfo)
{
	fprintf(f,"\n");

	/* default so optional */ 
	fprintf(f,"pfPermissionToForward: ");
	if (psThirdPartyInfo->pfPermissionToForward)
		print_bool(f, psThirdPartyInfo->pfPermissionToForward);
	else
		fprintf(f,"NULL\n");


	/* default so optional */
	fprintf(f,"pfPermissionToChain: ");
	if (psThirdPartyInfo->pfPermissionToChain)
		print_bool(f, psThirdPartyInfo->pfPermissionToChain);
	else
		fprintf(f,"NULL\n");


	/* default so optional */
	fprintf(f,"pfPermissionToPartition: ");
	if (psThirdPartyInfo->pfPermissionToPartition)
		print_bool(f, psThirdPartyInfo->pfPermissionToPartition);
	else
		fprintf(f,"NULL\n");


	/* default so optional */
	fprintf(f,"pfPermissionToChangeSendToList: ");
	if (psThirdPartyInfo->pfPermissionToChangeSendToList)
		print_bool(f, psThirdPartyInfo->pfPermissionToChangeSendToList);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"psInitialRequesterAddress: ");
	if (psThirdPartyInfo->psInitialRequesterAddress != NULL)
		print_ill_sysaddr(f, psThirdPartyInfo->psInitialRequesterAddress);
	else
		fprintf(f,"NULL\n");
	

	/* default so optional */
	fprintf(f,"pePreference: ");
	if (psThirdPartyInfo->pePreference)
		print_ill_preference(f, psThirdPartyInfo->pePreference);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"ppsSendToList: ");
	if (psThirdPartyInfo->ppsSendToList != NULL)
		print_ill_sendtolistlist(f, psThirdPartyInfo->ppsSendToList);
	else
		fprintf(f,"NULL\n");

	

	/* o */
	fprintf(f,"ppsAlreadyTriedList: ");
	if (psThirdPartyInfo->ppsAlreadyTriedList != NULL)
		print_ill_systemidlist(f, psThirdPartyInfo->ppsAlreadyTriedList);
	else
		fprintf(f,"NULL\n");

	
	
}



int print_ill_preference(FILE *f, DbvPreference *pePreference)
{
	switch (*pePreference) {
	case PRE_Ordered:
		fprintf(f,"PRE_Ordered\n");
		break;
	case PRE_Unordered:
		fprintf(f,"PRE_Unordered\n");
		break;
	case PRE_Invalid:
		fprintf(f,"PRE_Invalid\n");
		break;
	}
}



int print_ill_sendtolistlist(FILE *f, DbvSendToList **ppsSendToList)
{

	int index = 0;

	fprintf(f,"\n");

	while (ppsSendToList[index] != NULL) {
       		fprintf(f,"\tpsSendToList[%d]: ", index);
		print_ill_sendtolist(f, ppsSendToList[index]);
		index++;
		fprintf(f,"\n");
	}
	fprintf(f,"\n");
}



int print_ill_sendtolist(FILE *f, DbvSendToList *psSendToList)
{
	/* c */
	fprintf(f,"sSystemId: ");
	print_ill_systemid(f, &psSendToList->sSystemId);

	/* o */
	fprintf(f,"psAccountNumber: ");
	if (psSendToList->psAccountNumber != NULL) 
		print_ill_illstring(f, psSendToList->psAccountNumber);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"psSystemAddress: ");
	if (psSendToList->psSystemAddress != NULL) 
		print_ill_sysaddr(f, psSendToList->psSystemAddress);
	else
		fprintf(f,"NULL\n");
}


int print_ill_systemidlist(FILE *f, DbvSystemId **ppsAlreadyTriedList)
{
	int index = 0;

	fprintf(f,"\n");

	while (ppsAlreadyTriedList[index] != NULL) {
       		fprintf(f,"\tpsAlreadyTriedList[%d]: ", index);
		print_ill_systemid(f, ppsAlreadyTriedList[index]);
		index++;
		fprintf(f,"\n");
	}
	fprintf(f,"\n");
}



int print_ill_extensionlist(FILE *f, DbvExtension **ppsRequestExtension)
{
	int index = 0;

	fprintf(f,"\n");

	while (ppsRequestExtension[index] != NULL) {
       		fprintf(f,"\tpsRequestExtension[%d]\n", index);
		print_ill_extension(f, ppsRequestExtension[index]);
		index++;
		fprintf(f,"\n");
	}
	fprintf(f,"\n");
}



int print_ill_extension(FILE *f, DbvExtension *psRequestExtension)
{
	/* c */
	fprintf(f,"ulIdentifier: %lu\n", psRequestExtension->ulIdentifier);

	/* default */
	fprintf(f,"pfCritical: ");
	if (psRequestExtension->pfCritical)
		print_bool(f, psRequestExtension->pfCritical);	
	else
		fprintf(f,"NULL\n");


	/* c */
	switch (psRequestExtension->ulIdentifier) {

	case SUBITO_ADDITIONAL_INFO:
                print_illext_subito(f, psRequestExtension->uItem.psAddIllReqInfo);
                break;
        }


}



int print_illext_subito(FILE *f, DbvSubitoAdditionalInfo *psAddIllReqInfo)
{
        fprintf(f,"psAddIllReqInfo:\n");
        if (psAddIllReqInfo) {

                /* c */
                fprintf(f,"pfCustomerInfoToKeep: ");
               	print_bool(f, psAddIllReqInfo->pfCustomerInfoToKeep);

                /* o */
                print_illext_subito_request(f, psAddIllReqInfo->psAddRequesterInfo);

                /* o */
                print_illext_subito_deliver(f, psAddIllReqInfo->psAddDeliveryInfo);

                /* o */
                print_illext_subito_billing(f, psAddIllReqInfo->psAddBillingInfo);

        } else
                fprintf(f,"NULL\n");

}



int print_illext_subito_request(FILE *f, DbvAddRequesterInfo *psAddRequesterInfo)
{
        fprintf(f,"psAddRequesterInfo: ");
        if (psAddRequesterInfo) {

		fprintf(f,"\n");
	
		/* c */
		print_illext_subito_requestergroup(f, psAddRequesterInfo->peRequesterGroup);

		/* o */
		/* DbVisibleString is a typedefed char* */
		fprintf(f,"pcRequesterEmailAddress: ");
		print_visible_string(f, psAddRequesterInfo->pcRequesterEmailAddress);
		
        } else
                fprintf(f,"NULL\n");

}


int print_visible_string(FILE *f, DbvVisibleString pcRequesterEmailAddress)
{
	if (pcRequesterEmailAddress)
		fprintf(f,"%s\n", pcRequesterEmailAddress);
	else
		fprintf(f,"NULL\n");
}


int print_illext_subito_requestergroup(FILE *f, DbvRequesterGroup *peRequesterGroup)
{
	fprintf(f,"peRequesterGroup: ");
	if (peRequesterGroup) {
		switch (*peRequesterGroup) {
		case RG_UserGroup1:
			fprintf(f,"RG_UserGroup1\n");
			break;
		case RG_UserGroup2:
			fprintf(f,"RG_UserGroup2\n");
			break;
		}
	} else
                fprintf(f,"NULL\n");
}



int print_illext_subito_deliver(FILE *f, DbvAddDeliveryInfo *psAddDeliveryInfo)
{
        fprintf(f,"psAddDeliveryInfo: ");
        if (psAddDeliveryInfo) {

		fprintf(f,"\n");

		/* c */
		print_illext_subito_statusleveluser(f, psAddDeliveryInfo->peStatusLevelUser);
		
		/* c */
		print_illext_subito_statuslevelerequester(f, psAddDeliveryInfo->peStatusLevelOrigin);

		/* o */
		fprintf(f,"pcDeliveryNotes: ");
		print_visible_string(f, psAddDeliveryInfo->pcDeliveryNotes);

		/* c */
		fprintf(f,"pcCountryDeliveryTarget: ");
		print_visible_string(f, psAddDeliveryInfo->pcCountryDeliveryTarget);
		/* c */
                fprintf(f,"pfAlternativePostalDelivery: ");
               	print_bool(f, psAddDeliveryInfo->pfAlternativePostalDelivery);
		

        } else
                fprintf(f,"NULL\n");
}



int print_unsigned_long(FILE *f, Ulong *pulNumberOfCopies) 
{
	if (pulNumberOfCopies) 
		fprintf(f,"%lu\n", *pulNumberOfCopies);
	else
		fprintf(f,"NULL\n");
}




int print_illext_subito_statusleveluser(FILE *f, DbvStatusLevelUser *peStatusLevelUser)
{
	fprintf(f,"peStatusLevelUser: ");
	if (peStatusLevelUser) {
		switch (*peStatusLevelUser) {
		case SLU_All:
			fprintf(f,"SLU_All\n");
			break;
		case SLU_Negative:
			fprintf(f,"SLU_Negative\n");
			break;
		case SLU_None:
			fprintf(f,"SLU_None\n");
			break;	
		}
	} else
                fprintf(f,"NULL\n");
		
}



int print_illext_subito_statuslevelerequester(FILE *f, DbvStatusLevelRequester *peStatusLevelOrigin)
{
	fprintf(f,"peStatusLevelOrigin: ");
	if (peStatusLevelOrigin) {
		switch (*peStatusLevelOrigin) {
		case SLO_All:
			fprintf(f,"SLO_All\n");
			break;
		case SLO_Negative:
			fprintf(f,"SLO_Negative\n");
			break;
		case SLO_None:
			fprintf(f,"SLO_None\n");
			break;
		}
	} else
                fprintf(f,"NULL\n");
}



int print_illext_subito_billing(FILE *f, DbvAddBillingInfo *psAddBillingInfo)
{
        fprintf(f,"psAddBillingInfo: ");

        if (psAddBillingInfo) {

		fprintf(f, "\n");

		fprintf(f,"eAddBillingType: ");

		switch (psAddBillingInfo->eAddBillingType) {
		case ABT_BankInfo:
			fprintf(f,"ABT_BankInfo\n");
			print_illext_subito_billingbankinfo(f, psAddBillingInfo->uAddBillingInfo.psBillingBankInfo);
			break;
		case ABT_CreditCardInfo:
			fprintf(f,"ABT_CreditCardInfo\n");
			print_illext_subito_billingcreditcardinfo(f, psAddBillingInfo->uAddBillingInfo.psBillingCreditCardInfo);
			break;
		case ABT_InvoiceType:
			fprintf(f,"ABT_InvoiceType\n");
			print_illext_subito_billinginvoicetype(f, psAddBillingInfo->uAddBillingInfo.eBillingInvoiceType);
			break;

		case ABT_PrepaidType:
			fprintf(f,"ABT_PrepaidType\n");
			fprintf(f,"pcPrepaidId: ");
			print_visible_string(f, psAddBillingInfo->uAddBillingInfo.pcPrepaidId);
			break;

		case ABT_DepositType:
			fprintf(f,"ABT_DepositType\n");
			fprintf(f,"pcDepositId: ");
			print_visible_string(f, psAddBillingInfo->uAddBillingInfo.pcDepositId);
			break;
		default:
			fprintf(f,"\n");
			break;

		}
        } else
                fprintf(f,"NULL\n");
		
}



int print_illext_subito_billingbankinfo(FILE *f, DbvBillingBankInfo *psBillingBankInfo)
{
	fprintf(f,"psBillingBankInfo: ");
	if (psBillingBankInfo) {

		fprintf(f,"\n");

		/* c */
		fprintf(f,"pcBankAccountHouse: ");
		print_visible_string(f, psBillingBankInfo->pcBankAccountHouse);
		
		/* c */
		fprintf(f,"pcBankAccountRoutingSymbol: ");
		print_visible_string(f, psBillingBankInfo->pcBankAccountRoutingSymbol);
		
		/* c */
		fprintf(f,"pcBankAccountNo: ");
		print_visible_string(f, psBillingBankInfo->pcBankAccountNo);
		
		/* c */
                fprintf(f,"fBankAuthority: ");
               	print_bool(f, &psBillingBankInfo->fBankAuthority);
		

	} else
                fprintf(f,"NULL\n");

}



int print_illext_subito_billingcreditcardinfo(FILE *f, DbvBillingCreditCardInfo *psBillingCreditCardInfo)
{
	fprintf(f,"psBillingCreditCardInfo: ");
	if (psBillingCreditCardInfo) {

		fprintf(f,"\n");

		/* c */
		fprintf(f,"pcCardCompany: ");
		print_visible_string(f, psBillingCreditCardInfo->pcCardCompany);
		
		/* c */
		fprintf(f,"pcCardNo: ");
		print_visible_string(f, psBillingCreditCardInfo->pcCardNo);
		
		/* ISO_Date are VisibleString */

		/* o */
		fprintf(f,"pcCardValidFrom: ");
		print_visible_string(f, psBillingCreditCardInfo->pcCardValidFrom);
		
		/* c */
		fprintf(f,"pcCardValidThru: ");
		print_visible_string(f, psBillingCreditCardInfo->pcCardValidThru);

		
	} else
                fprintf(f,"NULL\n");

}



int print_illext_subito_billinginvoicetype(FILE *f, DbvBillingInvoiceType eBillingInvoiceType)
{
	fprintf(f,"eBillingInvoiceType: ");
	switch (eBillingInvoiceType) {
	case BIT_Single:
		fprintf(f,"BIT_Single\n");
		break;
	case BIT_Collective:
		fprintf(f,"BIT_Collective\n");
		break;
	}
}



int print_ill_statorerr(FILE *f, struct DbvStatusOrErrorReport *psStatusOrErrorReport)
{
	fprintf(f,"\n");

	/* c */
	fprintf(f,"eProtocolVersion: ");
	print_ill_protocolver(f, &psStatusOrErrorReport->eProtocolVersion);

	/* c */
	fprintf(f,"sTransactionId: ");
	print_ill_transid(f, &psStatusOrErrorReport->sTransactionId);
	
	/* c */
	fprintf(f,"sServiceDateTime: ");	
	print_ill_servdatetime(f, &psStatusOrErrorReport->sServiceDateTime);

	/* o */
	fprintf(f,"psRequesterId: ");
	if (psStatusOrErrorReport->psRequesterId != NULL) 
		print_ill_systemid(f, psStatusOrErrorReport->psRequesterId);
	else
		fprintf(f,"NULL\n");

	/* o */
	fprintf(f,"psResponderId: ");
	if (psStatusOrErrorReport->psResponderId != NULL) 
		print_ill_systemid(f, psStatusOrErrorReport->psResponderId);
	else
		fprintf(f,"NULL\n");

	/* o */
	fprintf(f,"peReasonNoReport: ");
	if (psStatusOrErrorReport->peReasonNoReport != NULL) 
		print_ill_reasnorep(f, psStatusOrErrorReport->peReasonNoReport);
	else
		fprintf(f,"NULL\n");

	/* o */
	fprintf(f,"psStatusReport: ");
	if (psStatusOrErrorReport->psStatusReport != NULL) 
		print_ill_statrep(f, psStatusOrErrorReport->psStatusReport);
	else
		fprintf(f,"NULL\n");

	/* o */
	fprintf(f,"psErrorReport: ");
	if (psStatusOrErrorReport->psErrorReport != NULL) 
		print_ill_errrep(f, psStatusOrErrorReport->psErrorReport);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"psNote: ");
	if (psStatusOrErrorReport->psNote != NULL) 
		print_ill_illstring(f, psStatusOrErrorReport->psNote);
	else
		fprintf(f,"NULL\n");


	
	/* o */
	fprintf(f,"ppsStOrErReportExtension: ");
	if (psStatusOrErrorReport->ppsStOrErReportExtension != NULL) 
		print_ill_extensionlist(f, psStatusOrErrorReport->ppsStOrErReportExtension);
	else
		fprintf(f,"NULL\n");

	
}



int print_ill_reasnorep(FILE *f, DbvReasonNoReport *peReasonNoReport)
{
	switch (*peReasonNoReport) {
	case RNR_Temporary:
		fprintf(f,"RNR_Temporary\n");
		break;
	case RNR_Permanent:
		fprintf(f,"RNR_Permanent\n");
		break;
	case RNR_Invalid:
		fprintf(f,"RNR_Invalid\n");
		break;
	}
	
}


int print_ill_statrep(FILE *f, DbvStatusReport *psStatusReport)
{
	fprintf(f,"\n");

	/* c */
	fprintf(f,"sUserStatusReport: ");
	print_ill_histrep(f, &psStatusReport->sUserStatusReport);


	/* c */
	fprintf(f,"eProviderstatusReport: ");
	print_ill_provstat(f, &psStatusReport->eProviderStatusReport);
	
}



int print_ill_histrep(FILE *f, DbvHistoryReport *psUserStatusReport)
{
	fprintf(f,"\n");

	/* o */
	fprintf(f,"pcDateRequested: ");
	if (psUserStatusReport->pcDateRequested != NULL) 
		fprintf(f,"%s\n", psUserStatusReport->pcDateRequested);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"psAuthor: ");
	if (psUserStatusReport->psAuthor != NULL) 
		print_ill_illstring(f, psUserStatusReport->psAuthor);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"psTitle: ");
	if (psUserStatusReport->psTitle != NULL) 
		print_ill_illstring(f, psUserStatusReport->psTitle);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"psAuthorOfArticle: ");
	if (psUserStatusReport->psAuthorOfArticle != NULL) 
		print_ill_illstring(f, psUserStatusReport->psAuthorOfArticle);
	else
		fprintf(f,"NULL\n");

	
	/* o */
	fprintf(f,"psTitleOfArticle: ");
	if (psUserStatusReport->psTitleOfArticle != NULL) 
		print_ill_illstring(f, psUserStatusReport->psTitleOfArticle);
	else
		fprintf(f,"NULL\n");


	/* c */
	fprintf(f,"pcDateOfLastTransition: ");
	if (psUserStatusReport->pcDateOfLastTransition != NULL) 
		fprintf(f,"%s\n", psUserStatusReport->pcDateOfLastTransition);
	else
		fprintf(f,"NULL\n");


	/* c */
	fprintf(f,"eMostRecentService: ");
	print_ill_mostrecserv(f, &psUserStatusReport->eMostRecentService);

	/* c */
	fprintf(f,"pcDateOfMostRecentService: ");
	if (psUserStatusReport->pcDateOfMostRecentService != NULL) 
		fprintf(f,"%s\n", psUserStatusReport->pcDateOfMostRecentService);
	else
		fprintf(f,"NULL\n");


	/* c */
	fprintf(f,"sSystemId: ");
	print_ill_systemid(f, &psUserStatusReport->sSystemId);
	
	/* o */
	fprintf(f,"peShippedServiceType: ");
	if (psUserStatusReport->peShippedServiceType != NULL) 
		print_ill_shippedservtype(f, psUserStatusReport->peShippedServiceType);
	else
		fprintf(f,"NULL\n");

	
	/* o */
	fprintf(f,"peTransactionResults: ");
	if (psUserStatusReport->peTransactionResults != NULL) 
		print_ill_transres(f, psUserStatusReport->peTransactionResults);
	else
		fprintf(f,"NULL\n");


	/* o */
	fprintf(f,"psMostRecentServiceNote: ");
	if (psUserStatusReport->psMostRecentServiceNote != NULL) 
		print_ill_illstring(f, psUserStatusReport->psMostRecentServiceNote);
	else
		fprintf(f,"NULL\n");
}



int print_ill_mostrecserv(FILE *f, DbvMostRecentService *peMostRecentService)
{
	switch (*peMostRecentService) {
	case MRS_IllRequest:
		fprintf(f,"MRS_IllRequest\n");
		break;
	case MRS_Forward:
		fprintf(f,"MRS_Forward\n");
		break;
	case MRS_ForwardNotification:
		fprintf(f,"MRS_ForwardNotification\n");
		break;
	case MRS_Shipped:
		fprintf(f,"MRS_Shipped\n");
		break;
	case MRS_IllAnswer:
		fprintf(f,"MRS_IllAnswer\n");
		break;
	case MRS_ConditionalReply:
		fprintf(f,"MRS_ConditionalReply\n");
		break;
	case MRS_Cancel:
		fprintf(f,"MRS_Cancel\n");
		break;
	case MRS_CancelReply:
		fprintf(f,"MRS_CancelReply\n");
		break;
	case MRS_Received:
		fprintf(f,"MRS_Received\n");
		break;
	case MRS_Recall:
		fprintf(f,"MRS_Recall\n");
		break;
	case MRS_Returned:
		fprintf(f,"MRS_Returned\n");
		break;
	case MRS_CheckedIn:
		fprintf(f,"MRS_CheckedIn\n");
		break;
	case MRS_Overdue:
		fprintf(f,"MRS_Overdue\n");
		break;
	case MRS_Renew:
		fprintf(f,"MRS_Renew\n");
		break;
	case MRS_RenewAnswer:
		fprintf(f,"MRS_RenewAnswer\n");
		break;
	case MRS_Lost:
		fprintf(f,"MRS_Lost\n");
		break;
	case MRS_Damaged:
		fprintf(f,"MRS_Damaged\n");
		break;
	case MRS_Message:
		fprintf(f,"MRS_Message\n");
		break;
	case MRS_StatusQuery:
		fprintf(f,"MRS_StatusQuery\n");
		break;
	case MRS_StatusOrErrorReport:
		fprintf(f,"MRS_StatusOrErrorReport\n");
		break;
	case MRS_Expired:
		fprintf(f,"MRS_Expired\n");
		break;
	case MRS_Invalid:
		fprintf(f,"MRS_Invalid\n");
		break;
	}
}



int print_ill_shippedservtype(FILE *f, DbvShippedServiceType *peShippedServiceType)
{
	switch (*peShippedServiceType) {
	case SST_Loan:
		fprintf(f,"SST_Loan\n");
		break;
	case SST_CopyNonReturnable:
		fprintf(f,"SST_CopyNonReturnable\n");
		break;
	case SST_Invalid:
		fprintf(f,"SST_Invalid\n");
		break;
	}
	
}


int print_ill_transres(FILE *f, DbvTransactionResults *peTransactionResults)
{
	switch (*peTransactionResults) {
	case TR_Conditional:
		fprintf(f,"TR_Conditional\n");
		break;
	case TR_Retry:
		fprintf(f,"TR_Retry\n");
		break;
	case TR_Unfilled:
		fprintf(f,"TR_Unfilled\n");
		break;
	case TR_LocationsProvided:
		fprintf(f,"TR_LocationsProvided\n");
		break;
	case TR_WillSupply:
		fprintf(f,"TR_WillSupply\n");
		break;
	case TR_HoldPlaced:
		fprintf(f,"TR_HoldPlaced\n");
		break;
	case TR_Estimate:
		fprintf(f,"TR_Estimate\n");
		break;
	case TR_Invalid:
		fprintf(f,"TR_Invalid\n");
		break;
	}
}



int print_ill_provstat(FILE *f, DbvCurrentState *peProviderStatusReport)
{
	switch (*peProviderStatusReport) {
	case CS_NotSupplied:
		fprintf(f,"CS_NotSupplied\n");
		break;
	case CS_Pending:
		fprintf(f,"CS_Pending\n");
		break;
	case CS_InProcess:
		fprintf(f,"CS_InProcess\n");
		break;
	case CS_Forward:
		fprintf(f,"CS_Forward\n");
		break;
	case CS_Conditional:
		fprintf(f,"CS_Conditional\n");
		break;
	case CS_CancelPending:
		fprintf(f,"CS_CancelPending\n");
		break;
	case CS_Cancelled:
		fprintf(f,"CS_Cancelled\n");
		break;
	case CS_Shipped:
		fprintf(f,"CS_Shipped\n");
		break;
	case CS_Received:
		fprintf(f,"CS_Received\n");
		break;
	case CS_RenewPending:
		fprintf(f,"CS_RenewPending\n");
		break;
	case CS_NotReceivedOverdue:
		fprintf(f,"CS_NotReceivedOverdue\n");
		break;
	case CS_RenewOverdue:
		fprintf(f,"CS_RenewOverdue\n");
		break;
	case CS_Overdue:
		fprintf(f,"CS_Overdue\n");
		break;
	case CS_Returned:
		fprintf(f,"CS_Returned\n");
		break;
	case CS_CheckedIn:
		fprintf(f,"CS_CheckedIn\n");
		break;
	case CS_Recall:
		fprintf(f,"CS_Recall\n");
		break;
	case CS_Lost:
		fprintf(f,"CS_Lost\n");
		break;
	case CS_Unknown:
		fprintf(f,"CS_Unknown\n");
		break;
	case CS_Invalid:
		fprintf(f,"CS_Invalid\n");
		break;
	}
	
}



int print_ill_errrep(FILE *f, DbvErrorReport *psErrorReport)
{

	/* c */
	fprintf(f,"sCorrelationInfo: ");
	print_ill_illstring(f, &psErrorReport->sCorrelationInfo);
	

	/* c */
	fprintf(f,"sReport: ");
	print_ill_userorprovrrrep(f, &psErrorReport->sReport);
}



int print_ill_userorprovrrrep(FILE *f, DbvUserOrProviderErrorReport *psReport)
{
	fprintf(f,"\n");

	fprintf(f,"eReportSource: ");
	switch (psReport->eReportSource) {
	case RS_User:
		fprintf(f,"RS_User: ");
		if (psReport->uReport.psUserErrorReport != NULL)
			print_ill_usererrrep(f, psReport->uReport.psUserErrorReport);
		break;
	case RS_Provider:
		fprintf(f,"RS_Provider: ");
		if (psReport->uReport.psProviderErrorReport != NULL)
			print_ill_proverrrep(f, psReport->uReport.psProviderErrorReport);

		break;
	}
}



int print_ill_usererrrep(FILE *f, DbvUserErrorReport *psUserErrorReport)
{
	fprintf(f,"\n");

	fprintf(f,"eReportType: ");
	switch (psUserErrorReport->eReportType) {
	case UER_AlreadyForwarded:
		fprintf(f,"UER_AlreadyForwarded: ");
		if (psUserErrorReport->uUserErrorReport.psAlreadyForwarded != NULL) 
			print_ill_alreadyforw(f, psUserErrorReport->uUserErrorReport.psAlreadyForwarded);
		break;
	case UER_IntermediaryProblem:
		fprintf(f,"UER_IntermediaryProblem: ");
		print_ill_intermed(f, &psUserErrorReport->uUserErrorReport.eIntermediaryProblem);
		break;
	case UER_SecurityProblem:
		fprintf(f,"UER_SecurityProblem: ");
		if (psUserErrorReport->uUserErrorReport.psSecurityProblem != NULL)
			print_ill_illstring(f, psUserErrorReport->uUserErrorReport.psSecurityProblem);
		break;
	case UER_UnableToPerform:
		fprintf(f,"UER_UnableToPerform: ");
		print_ill_unabletoper(f, &psUserErrorReport->uUserErrorReport.eUnableToPerform);
		break;
	}
	
}



int print_ill_alreadyforw(FILE *f, DbvAlreadyForwarded *psAlreadyForwarded)
{
	fprintf(f,"\n");

	/* c */
	fprintf(f,"sResponderId: ");
	print_ill_systemid(f, &psAlreadyForwarded->sResponderId);

	/* o */
	fprintf(f,"psResponderAddress: ");
	if (psAlreadyForwarded->psResponderAddress != NULL)
		print_ill_sysaddr(f, psAlreadyForwarded->psResponderAddress);
	else
		fprintf(f,"NULL\n");
	
}


int print_ill_intermed(FILE *f, DbvIntermediaryProblem *peIntermediaryProblem)
{
	switch (*peIntermediaryProblem) {
	case IP_CannotSendOnward:
		fprintf(f,"IP_CannotSendOnward\n");
		break;
	case IP_Invalid:
		fprintf(f,"IP_Invalid\n");
		break;
	}
}



int print_ill_unabletoper(FILE *f, DbvUnableToPerform *peUnableToPerform)
{
	switch (*peUnableToPerform) {
	case UTP_NotAvailable:
		fprintf(f,"UTP_NotAvailable\n");
		break;
	case UTP_ResourceLimitation:
		fprintf(f,"UTP_ResourceLimitation\n");
		break;
	case UTP_Other:
		fprintf(f,"UTP_Other\n");
		break;
	case UTP_Invalid:
		fprintf(f,"UTP_Invalid\n");
		break;
	}
	
}



int print_ill_proverrrep(FILE *f, DbvProviderErrorReport *psProviderErrorReport)
{
	fprintf(f,"\n");

	/* c */
	fprintf(f,"eReportType: ");
	switch (psProviderErrorReport->eReportType) {
	case PER_GeneralProblem:
		fprintf(f,"PER_GeneralProblem: ");
		print_ill_genprob(f, &psProviderErrorReport->uProviderErrorReport.eGeneralProblem);
		break;
	case PER_TransactionIdProblem:
		fprintf(f,"PER_TransactionIdProblem: ");
		print_ill_transidprob(f, &psProviderErrorReport->uProviderErrorReport.eTransactionIdProblem);
		break;
	case PER_StateTransitionProhibited:
		fprintf(f,"PER_StateTransitionProhibited: ");
		if (psProviderErrorReport->uProviderErrorReport.psStateTransitionProblem != NULL)
			print_ill_statetransprohib(f, psProviderErrorReport->uProviderErrorReport.psStateTransitionProblem);
		break;
	}
}



int print_ill_genprob(FILE *f, DbvGeneralProblem *peGeneralProblem)
{
	switch (*peGeneralProblem) {
	case GP_UnrecognizedAPDU:
		fprintf(f,"GP_UnrecognizedAPDU\n");
		break;
	case GP_MistypedAPDU:
		fprintf(f,"GP_MistypedAPDU\n");
		break;
	case GP_BadlyStructuredAPDU:
		fprintf(f,"GP_BadlyStructuredAPDU\n");
		break;
	case GP_ProtocolVersionNotSupported:
		fprintf(f,"GP_ProtocolVersionNotSupported\n");
		break;
	case GP_Other:
		fprintf(f,"GP_Other\n");
		break;
	case GP_Invalid:
		fprintf(f,"GP_Invalid\n");
		break;
	}
	
}



int print_ill_transidprob(FILE *f, DbvTransactionIdProblem *peTransactionIdProblem)
{
	switch (*peTransactionIdProblem) {
	case TIP_DuplicateTransactionId:
		fprintf(f,"TIP_DuplicateTransactionId\n");
		break;
	case TIP_InvalidTransactionId:
		fprintf(f,"TIP_InvalidTransactionId\n");
		break;
	case TIP_UnknownTransactionId:
		fprintf(f,"TIP_UnknownTransactionId\n");
		break;
	case TIP_Invalid:
		fprintf(f,"TIP_Invalid\n");
		break;
	}

}

int print_ill_statetransprohib(FILE *f, DbvStateTransitionProhibited *psStateTransitionProblem)
{
	fprintf(f,"\n");

	/* c */
	fprintf(f,"eAPDUType: ");
	print_ill_apdutype(f, &psStateTransitionProblem->eAPDUType);
	
	/* c */
	fprintf(f,"eCurrentState: ");
	print_ill_provstat(f, &psStateTransitionProblem->eCurrentState);
	
}


int print_ill_apdutype(FILE *f, DbvIllAPDUType *peAPDUType)
{
	switch (*peAPDUType) {
	case IAT_IllRequest:
		fprintf(f,"IAT_IllRequest\n");
		break;
	case IAT_ForwardNotification:
		fprintf(f,"IAT_ForwardNotification\n");
		break;
	case IAT_Shipped:
		fprintf(f,"IAT_Shipped\n");
		break;
	case IAT_IllAnswer:
		fprintf(f,"IAT_IllAnswer\n");
		break;
	case IAT_ConditionalReply:
		fprintf(f,"IAT_ConditionalReply\n");
		break;
	case IAT_Cancel:
		fprintf(f,"IAT_Cancel\n");
		break;
	case IAT_CancelReply:
		fprintf(f,"IAT_CancelReply\n");
		break;
	case IAT_Received:
		fprintf(f,"IAT_Received\n");
		break;
	case IAT_Recall:
		fprintf(f,"IAT_Recall\n");
		break;
	case IAT_Returned:
		fprintf(f,"IAT_Returned\n");
		break;
	case IAT_CheckedIn:
		fprintf(f,"IAT_CheckedIn\n");
		break;
	case IAT_Overdue:
		fprintf(f,"IAT_Overdue\n");
		break;
	case IAT_Renew:
		fprintf(f,"IAT_Renew\n");
		break;
	case IAT_RenewAnswer:
		fprintf(f,"IAT_RenewAnswer\n");
		break;
	case IAT_Lost:
		fprintf(f,"IAT_Lost\n");
		break;
	case IAT_Damaged:
		fprintf(f,"IAT_Damaged\n");
		break;
	case IAT_Message:
		fprintf(f,"IAT_Message\n");
		break;
	case IAT_StatusQuery:
		fprintf(f,"IAT_StatusQuery\n");
		break;
	case IAT_StatusOrErrorReport:
		fprintf(f,"IAT_StatusOrErrorReport\n");
		break;
	case IAT_Expired:
		fprintf(f,"IAT_Expired\n");
		break;
	case IAT_Invalid:
		fprintf(f,"IAT_Invalid\n");
		break;
	}
}





int print_aligned_external(FILE *f, DbvASN1External *external_ptr)
{
        fprintf(f,"\tpsOctetAligned:");
        print_octet_string(f, external_ptr->uExternalValue.psOctetAligned);


        /* Call a function to format the (assumed) USMARC data in
           external_ptr->uExternalValue.psOctetAligned */

        /* Normal USMARC format, no header, send to stdout */

        fprintf(f,"\n");
        fprintf(f,"*********************************************\n");
        fprintf(f,"USMARC formatting of data:\n");
        fprintf(f,"\n");

	/* Third parameter = marc formatting style 
	   (0 = Tomas_marc, 1 = Normal_marc). A typedef enum exists in
	   api_usmarc_formatter.h */
        usmarc_format(external_ptr->uExternalValue.psOctetAligned, Normal_marc, DBV_FALSE, f);

        fprintf(f,"\n");
        fprintf(f,"*********************************************\n");

}



int print_intmaptest_external(FILE *f, DbvASN1External *external_ptr)
{

/********************
 No longer used

	DbvIntMapTest *intmaptest_ptr;

	fprintf(f,"psIntMapTest: \n");
	intmaptest_ptr = external_ptr->uExternalValue.psSingleASN1Type->uASN1.psIntMapTest;

	fprintf(f,"eIntMapTestType: ");

	if (intmaptest_ptr != NULL) {
		switch (intmaptest_ptr->eIntMapTestType) {
		case IMT_FirstString:
			fprintf(f,"IMT_FirstString: ");
			if (intmaptest_ptr->uIntMapTest.psFirstString != NULL)
				print_inter_string(f, intmaptest_ptr->uIntMapTest.psFirstString);
			break;
		case IMT_SecondString:
			fprintf(f,"IMT_SecondString: ");
			if (intmaptest_ptr->uIntMapTest.psSecondString != NULL)
				print_inter_string(f, intmaptest_ptr->uIntMapTest.psSecondString);
			break;
		}
	}
	
********************/

}







void print_accessrsp_fields(FILE *f, DbvAccessControlRsp *psAccessControlRsp)
{

	fprintf(f,"AccessControlResponse PDU\n");
	
	/* o, o, o, o */
	print_DbvAccessControlRsp_psReferenceId(f, psAccessControlRsp);
	print_DbvAccessControlRsp_psSecurityChallengeRsp(f, psAccessControlRsp);
	print_DbvAccessControlRsp_psDiagnostic(f, psAccessControlRsp);
	print_DbvAccessControlRsp_ppsOtherInformation(f, psAccessControlRsp);
}



void print_DbvAccessControlRsp_psReferenceId(FILE *f, DbvAccessControlRsp *psAccessControlRsp)
{
	/* o */
       	fprintf(f,"psReferenceId: ");
	print_octet_string(f, psAccessControlRsp->psReferenceId);
}



void print_DbvAccessControlRsp_psSecurityChallengeRsp(FILE *f, DbvAccessControlRsp *psAccessControlRsp)
{
	/* o */
	fprintf(f,"psSecurityChallengeRsp: ");

	if (psAccessControlRsp->psSecurityChallengeRsp == NULL) {
		fprintf(f,"NULL\n");
		return;
	}


	fprintf(f,"\neSecurityChallengeRspType: ");

	switch (psAccessControlRsp->psSecurityChallengeRsp->eSecurityChallengeRspType) {
	case SECT_SimpleForm:
		fprintf(f,"SECT_SimpleForm\n");
		fprintf(f,"psSimpleForm: ");
		print_octet_string(f, psAccessControlRsp->psSecurityChallengeRsp->uSecurityChallengeRsp.psSimpleForm);
		break;
	case SECT_ExternallyDefined:
		fprintf(f,"SECT_ExternallyDefined\n");
		fprintf(f,"psExternallyDefinedInfo:");
		print_external(f, psAccessControlRsp->psSecurityChallengeRsp->uSecurityChallengeRsp.psExternallyDefinedInfo);
		break;
	case SECT_Invalid:
		fprintf(f,"SECT_Invalid\n");
		break;
	}
	
}



void print_DbvAccessControlRsp_psDiagnostic(FILE *f, DbvAccessControlRsp *psAccessControlRsp)
{
	/* o */
	fprintf(f,"psDiagnostic:\n");
	print_diag_rec(f, psAccessControlRsp->psDiagnostic);
}



void print_DbvAccessControlRsp_ppsOtherInformation(FILE *f, DbvAccessControlRsp *psAccessControlRsp)
{
	/* o */
	fprintf(f,"ppsOtherInformation: ");
	print_otherinfo(f, psAccessControlRsp->ppsOtherInformation);
}




void print_rescntrlrsp_fields(FILE *f, DbvResourceControlRsp *psResourceControlRsp)
{
	fprintf(f,"ResourceControlResponse PDU\n");

	/* o, c, o, o */
	print_DbvResourceControlRsp_psReferenceId(f, psResourceControlRsp);
	print_DbvResourceControlRsp_fContinueFlag(f, psResourceControlRsp);
	print_DbvResourceControlRsp_pfResultSetWanted(f, psResourceControlRsp);
	print_DbvResourceControlRsp_ppsOtherInformation(f, psResourceControlRsp);
}


void print_DbvResourceControlRsp_psReferenceId(FILE *f, DbvResourceControlRsp *psResourceControlRsp)
{
	/* o */
       	fprintf(f,"psReferenceId: ");
	print_octet_string(f, psResourceControlRsp->psReferenceId);
}



void print_DbvResourceControlRsp_fContinueFlag(FILE *f, DbvResourceControlRsp *psResourceControlRsp)
{
	/* c */
       	fprintf(f,"fContinueFlag: ");
	print_bool(f, &psResourceControlRsp->fContinueFlag);
}



void print_DbvResourceControlRsp_pfResultSetWanted(FILE *f, DbvResourceControlRsp *psResourceControlRsp)
{
	/* o */
       	fprintf(f,"pfResultSetWanted: ");
	print_bool(f, psResourceControlRsp->pfResultSetWanted);
}



void print_DbvResourceControlRsp_ppsOtherInformation(FILE *f, DbvResourceControlRsp *psResourceControlRsp)
{
	/* o */
	fprintf(f,"ppsOtherInformation: ");
	print_otherinfo(f, psResourceControlRsp->ppsOtherInformation);
}



void print_trigrescntrlreq_fields(FILE *f, DbvTriggerResourceControlReq *psTriggerResourceControlReq)
{
	fprintf(f,"TriggerResourceControlRequest PDU\n");

	/* o, c, o, o, o */
	print_DbvTriggerResourceControlReq_psReferenceId(f, psTriggerResourceControlReq);
	print_DbvTriggerResourceControlReq_eRequestedAction(f, psTriggerResourceControlReq);
	print_DbvTriggerResourceControlReq_pcPreferredResourceReportFormat(f, psTriggerResourceControlReq);
	print_DbvTriggerResourceControlReq_pfResultSetWanted(f, psTriggerResourceControlReq);
	print_DbvTriggerResourceControlReq_ppsOtherInformation(f, psTriggerResourceControlReq);
}


void print_DbvTriggerResourceControlReq_psReferenceId(FILE *f, DbvTriggerResourceControlReq *psTriggerResourceControlReq)
{
	/* o */
       	fprintf(f,"psReferenceId: ");
	print_octet_string(f, psTriggerResourceControlReq->psReferenceId);
}



void print_DbvTriggerResourceControlReq_eRequestedAction(FILE *f, DbvTriggerResourceControlReq *psTriggerResourceControlReq)
{
	/* c */

	fprintf(f,"eRequestedAction: ");

	switch (psTriggerResourceControlReq->eRequestedAction) {
	case RA_ResourceReport1:
		fprintf(f,"RA_ResourceReport1\n");
		break;
		
	case RA_ResourceControl:
		fprintf(f,"RA_ResourceControl\n");
		break;

	case RA_Cancel:
		fprintf(f,"RA_Cancel\n");
		break;

	case RA_Invalid:
		fprintf(f,"RA_Invalid\n");
		break;
	}
}



void print_DbvTriggerResourceControlReq_pcPreferredResourceReportFormat(FILE *f, DbvTriggerResourceControlReq *psTriggerResourceControlReq)
{
	/* o */
	fprintf(f,"pcPreferredResourceReportFormat: ");
	print_DbvObjectIdentifierA(f, psTriggerResourceControlReq->pcPreferredResourceReportFormat);
}



void print_DbvObjectIdentifierA(FILE *f, DbvObjectIdentifier pcPreferredResourceReportFormat)
{	
	if (pcPreferredResourceReportFormat == NULL) {
		fprintf(f,"NULL\n");
		return;
	}


	fprintf(f,pcPreferredResourceReportFormat);
	fprintf(f,"\n");
}



void print_DbvTriggerResourceControlReq_pfResultSetWanted(FILE *f, DbvTriggerResourceControlReq *psTriggerResourceControlReq)
{
	/* o */
       	fprintf(f,"pfResultSetWanted: ");
	print_bool(f, psTriggerResourceControlReq->pfResultSetWanted);
}



void print_DbvTriggerResourceControlReq_ppsOtherInformation(FILE *f, DbvTriggerResourceControlReq *psTriggerResourceControlReq)
{
	/* o */
	fprintf(f,"ppsOtherInformation: ");
	print_otherinfo(f, psTriggerResourceControlReq->ppsOtherInformation);
}



void print_accessreq_fields(FILE *f, DbvAccessControlReq *psAccessControlReq)
{
	fprintf(f,"AccessControlRequest PDU\n");
	
	/* o, c, o */
	print_DbvAccessControlReq_psReferenceId(f, psAccessControlReq);
	print_DbvAccessControlReq_psSecurityChallengeReq(f, psAccessControlReq);
	print_DbvAccessControlReq_ppsOtherInformation(f, psAccessControlReq);
}



void print_DbvAccessControlReq_psReferenceId(FILE *f, DbvAccessControlReq *psAccessControlReq)
{
	/* o */
       	fprintf(f,"psReferenceId: ");
	print_octet_string(f, psAccessControlReq->psReferenceId);
}



void print_DbvAccessControlReq_psSecurityChallengeReq(FILE *f, DbvAccessControlReq *psAccessControlReq)
{
	/* c */
	fprintf(f,"sSecurityChallengeReq:\n");

	fprintf(f,"eSecurityChallengeReqType: ");

	switch (psAccessControlReq->sSecurityChallengeReq.eSecurityChallengeReqType) {
	case SECT_SimpleForm:
		fprintf(f,"SECT_SimpleForm\n");
		fprintf(f,"psSimpleForm: ");
		print_octet_string(f, psAccessControlReq->sSecurityChallengeReq.uSecurityChallengeReq.psSimpleForm);
		break;
	case SECT_ExternallyDefined:
		fprintf(f,"SECT_ExternallyDefined\n");
		fprintf(f,"psExternallyDefinedInfo:");
		print_external(f, psAccessControlReq->sSecurityChallengeReq.uSecurityChallengeReq.psExternallyDefinedInfo);
		break;
	case SECT_Invalid:
		fprintf(f,"SECT_Invalid\n");
		break;
	}
}



void print_DbvAccessControlReq_ppsOtherInformation(FILE *f, DbvAccessControlReq *psAccessControlReq)
{
	/* o */
	fprintf(f,"ppsOtherInformation: ");
	print_otherinfo(f, psAccessControlReq->ppsOtherInformation);
}


void print_rescntrlreq_fields(FILE *f, DbvResourceControlReq *psResourceControlReq)
{
	fprintf(f,"ResourceControlRequest PDU\n");
	
	/* o, o, o, o, c, o, o */
	print_DbvResourceControlReq_psReferenceId(f, psResourceControlReq);
	print_DbvResourceControlReq_pfSuspendedFlag(f, psResourceControlReq);
	print_DbvResourceControlReq_psResourceReport(f, psResourceControlReq);
	print_DbvResourceControlReq_pePartialResultsAvailable(f, psResourceControlReq);
	print_DbvResourceControlReq_fResponseRequired(f, psResourceControlReq);
	print_DbvResourceControlReq_pfTriggeredRequestFlag(f, psResourceControlReq);
	print_DbvResourceControlReq_ppsOtherInformation(f, psResourceControlReq);
}



void print_DbvResourceControlReq_psReferenceId(FILE *f, DbvResourceControlReq *psResourceControlReq)
{
	/* o */
	/* o */
       	fprintf(f,"psReferenceId: ");
	print_octet_string(f, psResourceControlReq->psReferenceId);
}


void print_DbvResourceControlReq_pfSuspendedFlag(FILE *f, DbvResourceControlReq *psResourceControlReq)
{
	/* o */
       	fprintf(f,"pfSuspendedFlag: ");
	print_bool(f, psResourceControlReq->pfSuspendedFlag);
}


void print_DbvResourceControlReq_psResourceReport(FILE *f, DbvResourceControlReq *psResourceControlReq)
{
	/* o */
	fprintf(f,"psResourceReport: ");
	print_external(f, psResourceControlReq->psResourceReport);
}


void print_DbvResourceControlReq_pePartialResultsAvailable(FILE *f, DbvResourceControlReq *psResourceControlReq)
{
	/* o */
	fprintf(f,"pePartialResultsAvailable: ");

	if (psResourceControlReq->pePartialResultsAvailable == NULL) {
		fprintf(f,"NULL\n");
		return;
	}


	switch (*psResourceControlReq->pePartialResultsAvailable) {
	case PRA_Subset:
		fprintf(f,"PRA_Subset\n");
		break;
	case PRA_Interim2:
		fprintf(f,"PRA_Interim2\n");
		break;
	case PRA_None2:
		fprintf(f,"PRA_None2\n");
		break;
	case PRA_Invalid:
		fprintf(f,"PRA_Invalid\n");
		break;
	}
}



void print_DbvResourceControlReq_fResponseRequired(FILE *f, DbvResourceControlReq *psResourceControlReq)
{
	/* c */
       	fprintf(f,"fResponseRequired: ");
	print_bool(f, &psResourceControlReq->fResponseRequired);
}



void print_DbvResourceControlReq_pfTriggeredRequestFlag(FILE *f, DbvResourceControlReq *psResourceControlReq)
{
	/* o */
       	fprintf(f,"pfTriggeredRequestFlag: ");
	print_bool(f, psResourceControlReq->pfTriggeredRequestFlag);
}



void print_DbvResourceControlReq_ppsOtherInformation(FILE *f, DbvResourceControlReq *psResourceControlReq)
{
	/* o */
	/* o */
	fprintf(f,"ppsOtherInformation: ");
	print_otherinfo(f, psResourceControlReq->ppsOtherInformation);
}



void print_DbvPromptObject_external(FILE *f, DbvASN1External *external_ptr)
{
	struct DbvPromptObject *psPromptObject = NULL;

	psPromptObject = external_ptr->uExternalValue.psSingleASN1Type->uASN1.psPromptObject;
	
	/* Will always be non NULL after decoding but check just in
	   case function has been called before PDU sending */
	if (psPromptObject != NULL) {
        	fprintf(f,"\tpsPromptObject: ");
		print_DbvPromptObject(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psPromptObject);
	}
}



void print_DbvPromptObject(FILE *f, struct DbvPromptObject *psPromptObject)
{
	if (psPromptObject == NULL) {
		fprintf(f,"NULL\n");
		return;
	}
	
	fprintf(f,"\n");

	fprintf(f,"ePromptObjectType: ");
	switch (psPromptObject->ePromptObjectType) {
	case POT_Challenge:
		fprintf(f,"POT_Challenge\n");
		fprintf(f,"ppsChallenge:\n");
		print_DbvChallenge_list(f, psPromptObject->uPromptObject.ppsChallenge);
		break;
	case POT_Response:
		fprintf(f,"POT_Response\n");
		fprintf(f,"ppsResponse:\n");
		print_DbvResponse_list(f, psPromptObject->uPromptObject.ppsResponse);
		break;
	case POT_Invalid:
		fprintf(f,"POT_Invalid\n");
		break;
	}
}



void print_DbvChallenge_list(FILE *f, DbvChallenge **ppsChallenge)
{
	if (ppsChallenge == NULL) {
		fprintf(f, "NULL\n");
		return;
	}

	while (*ppsChallenge) {
		print_DbvChallenge(f, *ppsChallenge);
		ppsChallenge++;
		fprintf(f,"\n");
	}
}



void print_DbvChallenge(FILE *f, DbvChallenge *psChallenge)
{
	/* c */
	fprintf(f,"sPromptId: ");
	print_DbvPromptId(f, &psChallenge->sPromptId);
	
	/* o */
	fprintf(f,"psDefaultResponse: ");
	print_inter_string(f, psChallenge->psDefaultResponse);
	
	/* o */
	fprintf(f,"psPromptInfo: ");
	print_DbvPromptInfo(f, psChallenge->psPromptInfo);
	
	/* o */
	fprintf(f,"psRegExpr: ");
	print_inter_string(f, psChallenge->psRegExpr);
	
	/* o */
	print_DbvNull(f, "pvResponseRequired", psChallenge->pvResponseRequired);
	
	/* o */
	printN_DbvInternationalString(f, "ppsAllowedValues", psChallenge->ppsAllowedValues);
	
	/* o */
	print_DbvNull(f, "pvShouldSave", psChallenge->pvShouldSave);
	
	/* o */
	fprintf(f,"peDataType: ");
	print_DbvDataType(f, psChallenge->peDataType);
	
	/* o */
	fprintf(f,"psDiagnostic: ");
	print_external(f, psChallenge->psDiagnostic);
	
	
}


void print_DbvPromptId(FILE *f, DbvPromptId *psPromptId)
{
	if (psPromptId == NULL) {
		fprintf(f,"NULL\n");
		return;
	}
	
	fprintf(f,"\n");

	fprintf(f,"ePromptIdType: ");
	switch (psPromptId->ePromptIdType) {
	case PIT_EnumeratedPrompt:
		fprintf(f,"PIT_EnumeratedPrompt\n");
		fprintf(f,"psEnumeratedPrompt:\n");
		print_DbvEnumeratedPrompt(f, psPromptId->uPromptId.psEnumeratedPrompt);
		break;
	case PIT_NoneEnumeratedPrompt:
		fprintf(f,"PIT_NoneEnumeratedPrompt\n");
		fprintf(f,"psNonEnumeratedPrompt:\n");
		print_inter_string(f, psPromptId->uPromptId.psNonEnumeratedPrompt);
		break;
	case PIT_Invalid:
		fprintf(f,"PIT_Invalid\n");
		break;
	}
}



void print_DbvEnumeratedPrompt(FILE *f, DbvEnumeratedPrompt *psEnumeratedPrompt)
{
	if (psEnumeratedPrompt == NULL) {
		fprintf(f, "NULL\n");
		return;
	}

	/* c */
	fprintf(f,"eType: ");
	print_DbvEPromptIdType(f, &psEnumeratedPrompt->eType);

	/* o */
	fprintf(f,"psSuggestedString: ");
	print_inter_string(f, psEnumeratedPrompt->psSuggestedString);
}



void print_DbvEPromptIdType(FILE *f, DbvEPromptIdType *peType)
{
	switch (*peType) {
	case EPIT_GroupId:
		fprintf(f,"EPIT_GroupId\n");
		break;
	case EPIT_UserId:
		fprintf(f,"EPIT_UserId\n");
		break;
	case EPIT_Password:
		fprintf(f,"EPIT_Password\n");
		break;
	case EPIT_NewPassword:
		fprintf(f,"EPIT_NewPassword\n");
		break;
	case EPIT_Copyright:
		fprintf(f,"EPIT_Copyright\n");
		break;
	case EPIT_SessionId:
		fprintf(f,"EPIT_SessionId\n");
		break;
	case EPIT_Invalid:
		fprintf(f,"EPIT_Invalid\n");
		break;	
	}
}



void print_DbvPromptInfo(FILE *f, DbvPromptInfo *psPromptInfo)
{
	if (psPromptInfo == NULL) {
		fprintf(f,"NULL\n");
		return;
	}
	
	fprintf(f,"\n");

	fprintf(f,"ePromptInfoType: ");
	switch (psPromptInfo->ePromptInfoType) {
	case PIIT_Character:
		fprintf(f,"PIIT_Character\n");
		fprintf(f,"psCharacter: ");
		print_inter_string(f, psPromptInfo->uPromptInfo.psCharacter);
		break;

	case PIIT_Encrypted:
		fprintf(f,"PIT_NoneEnumeratedPrompt\n");
		fprintf(f,"psEncrypted: ");
		print_DbvEncryption(f, psPromptInfo->uPromptInfo.psEncrypted);
		break;

	case PIIT_Invalid:
		fprintf(f,"PIIT_Invalid\n");
		break;
	}
}



void print_DbvEncryption(FILE *f, DbvEncryption *psEncrypted)
{
	if (psEncrypted == NULL) {
		fprintf(f,"NULL\n");
		return;
	}

	fprintf(f,"\n");

	/* o */
	fprintf(f,"psCryptType: ");
	print_octet_string(f, psEncrypted->psCryptType);

	/* o */
	fprintf(f,"psCredential: ");
	print_octet_string(f, psEncrypted->psCredential);

	/* o */
	fprintf(f,"sData: ");
	print_octet_string(f, &psEncrypted->sData);
}



void print_DbvDataType(FILE *f, DbvDataType *peDataType)
{
	if (peDataType == NULL) {
		fprintf(f,"NULL\n");
		return;
	}
	
	fprintf(f,"\n");

	fprintf(f,"peDataType: ");

	switch (*peDataType) {
	case DTTT_Integer:
		fprintf(f,"DTTT_Integer\n");
		break;
	case DTTT_Date1:
		fprintf(f,"DTTT_Date1\n");
		break;
	case DTTT_Float:
		fprintf(f,"DTTT_Float\n");
		break;
	case DTTT_AlphaNumeric:
		fprintf(f,"DTTT_AlphaNumeric\n");
		break;
	case DTTT_UrlUrn:
		fprintf(f,"DTTT_UrlUrn\n");
		break;
	case DTTT_Boolean:
		fprintf(f,"DTTT_Boolean\n");
		break;
	case DTTT_Invalid:
		fprintf(f,"DTTT_Invalid\n");
		break;
	}
}



void print_DbvResponse_list(FILE *f, DbvResponse **ppsResponse)
{
	if (ppsResponse == NULL) {
		fprintf(f, "NULL\n");
		return;
	}


	while (*ppsResponse) {
		print_DbvResponse(f, *ppsResponse);
		ppsResponse++;
		fprintf(f,"\n");
	}
}


void print_DbvResponse(FILE *f, DbvResponse *psResponse)
{
	/* c */
	fprintf(f,"sPromptId: ");
	print_DbvPromptId(f, &psResponse->sPromptId);

	/* c */
	fprintf(f,"sPromptResponse: ");
	print_DbvPromptResponse(f, &psResponse->sPromptResponse);
}



void print_DbvPromptResponse(FILE *f, DbvPromptResponse *psPromptResponse)
{
	if (psPromptResponse == NULL) {
		fprintf(f,"NULL\n");
		return;
	}
	
	fprintf(f,"\n");

	fprintf(f,"eResponseType: ");
	switch (psPromptResponse->eResponseType) {
	case RT_String:
		fprintf(f,"RT_String\n");
		fprintf(f,"psString: ");
		print_inter_string(f, psPromptResponse->uResponse.psString);
		break;

	case RT_Accept:
		fprintf(f,"RT_Accept\n");
		fprintf(f,"fAccept: ");
		print_bool(f, &psPromptResponse->uResponse.fAccept);
		break;

	case RT_Acknowledge:
		fprintf(f,"RT_Acknowledge\n");
		break;

	case RT_Diagnostic:
		fprintf(f,"RT_Diagnostic\n");
		fprintf(f,"psDiagnostic: ");
		print_diag_rec(f, psPromptResponse->uResponse.psDiagnostic);
		break;

	case RT_Encrypted:
		fprintf(f,"RT_Encrypted\n");
		fprintf(f,"psEncryption: ");
		print_DbvEncryption(f, psPromptResponse->uResponse.psEncryption);
		break;
	}
}





/*******************************************************************/






/* A char is 8 bits (0 - 7) and can hold BOTH possitive and negative values,
   depending upon how the char is interpreted and used.
   Note that the C language does not specify whether variables of
   type char without pre specification are signed or unsigned 
   (K & R p. 43).

   Z39.50 has a variety of types including integers which are always in twos 
   complement form.
   snacc takes a char* array and decodes/encodes the array, casting/
   converting the array elements as necessary, it doesnt care if the
   array is signed or unsigned. Note that function DBVencode_pdu_to_bytes()
   in z3950_enc_dec.c returns a char** and function DBVdecode_bytes_to_pdu
   in the same file accepts a char* .

   If an unknown PDU/external is received, the data bytes making up the 
   unknown, a sequence of chars (remember that when received over a socket data
   is just received into a char* 'array'), which may represent possitive or 
   negative values of various structures/types are entered into the
   pcValue field of a DbvOctetString structure rather then being decoded


   The DbvOctetString structure in sitypes.h:

   typedef struct DbvOctetString {
   Ulong      ulLength;
   char      *pcValue;
   } DbvOctetString;


  Function print_as_hex() is used by the API test programs only to 
  print received but undecoded data. This function takes  
  takes a pcValue string and prints it as meaningless hex, the
  hex printed may represented multiple different structures/types which
  have not been decoded.

  print_as_hex() prints each 8 bit char as two ascii digits.

  Assuming ber_data[i] (a character without any signed or unsigned 
  specification) held the following
  10001111

  First charater print:
  ber_data[i] >> 4 = 00001000 on some machines (unsigned quantitity 
  or signed quantitiy logical ) 11111000 on others (signed quantity
  arithmetic ). Note that we dont know precisely which  will
  be done because the C language does not specify whether variables of
  type char are signed or unsigned quantities (K & R p. 43) and when
  they are signed if an arithmatic or logical  is done (K & R p.49).

  The exact  chosen doesnt matter however as the &0x0f in sub function 
  to_hex() rips away the top 4 bits ( & 15) to leave 1000 = 8


  Second character print:
  ber_data[i] = 10001111
  The &0x0f in to_hex() rips away the top 4 bits ( & 15) to leave 1111 = F 

  so the char holding the 8 bit value 10001111, which may represent
  143 or -112 is always printed as 8F
  
  Note that the (ber_data[i] >> 4) does not permanently modify ber_data[i].

  Although theoretically possible, negative data will be rare for strings
  as all ASCII set characters are possitive. 

*/


int print_as_hex(FILE *f, char *ber_data, unsigned long length)
{
	unsigned long i = 0;

	fprintf(f, "Hex: ");
	for(i = 0; i < length; i++)
		fprintf(f,"%c%c", to_hex(ber_data[i] >> 4), to_hex(ber_data[i]));

	/* Print a newline */
	fprintf(f, "\n");
}



/* ascii char set goes from 0 to 127 inclusive */
char to_hex(char eightBits) 
{
 	char numToHexCharTblG[16] =
	{ '0', '1', '2', '3', '4', '5', '6', '7',
	  '8', '9', 'a', 'b', 'c', 'd' ,'e', 'f'};

	return numToHexCharTblG[(eightBits) & 0x0f];
}




void print_DbvPrintExtendedService_external(FILE *f, DbvASN1External *external_ptr)
{
	print_DbvPrintExtendedService(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psPrintExtendedService);
}



void print_DbvPrintExtendedService(FILE *f, DbvPrintExtendedService *psPrintExtendedService)
{

   /* Write the title out */ 
   if (psPrintExtendedService == NULL)
      {
      fprintf(f, "psPrintExtendedService: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psPrintExtendedService:\n");
   

   /* ePrintReqRsp */
   fprintf(f, "ePrintReqRsp: ");
   print_DbvPrintReqOrRsp(f, &psPrintExtendedService->ePrintReqRsp);


   /* uPrintReqOrRsp */
   switch( psPrintExtendedService->ePrintReqRsp )
      {
      case PROR_Request:
	 print_DbvPrintRequestPackage(f, psPrintExtendedService->uPrintReqOrRsp.psPrintRequest);
	 break;

      case PROR_Response:
	print_DbvPrintTaskPackage(f, psPrintExtendedService->uPrintReqOrRsp.psPrintResponse);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvPrintExtendedService() */



void print_DbvPrintReqOrRsp(FILE *f, DbvPrintReqOrRsp *pePrintReqRsp)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *pePrintReqRsp == PROR_Request)
         strcpy(temp, "PROR_Request");

      if( *pePrintReqRsp == PROR_Response)
         strcpy(temp, "PROR_Response");

         fprintf(f, "%s\n", temp);

   } /* End print_DbvPrintReqOrRsp() */




void print_DbvPrintRequestPackage(FILE *f, DbvPrintRequestPackage *psPrintRequest)
{
	if (psPrintRequest == NULL) {
		fprintf(f,"psPrintRequest: NULL\n");
		return;
	}

	fprintf(f,"psPrintRequest:\n");

	/* o */
	print_DbvPrintOriginPartToKeep(f, psPrintRequest->psOriginPartToKeep);
}



void print_DbvPrintOriginPartToKeep(FILE *f, DbvPrintOriginPartToKeep *psOriginPartToKeep)
{

   /* Write the title out */ 
   if (psOriginPartToKeep == NULL)
      {
      fprintf(f, "psOriginPartToKeep: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psOriginPartToKeep:\n");
   

   /* ePrintOriginPartToKeepType */
   fprintf(f, "ePrintOriginPartToKeepType: ");
   print_DbvPrintOriginPartToKeepType(f, &psOriginPartToKeep->ePrintOriginPartToKeepType);


   /* uPrintOriginPartToKeep */
   switch( psOriginPartToKeep->ePrintOriginPartToKeepType )
      {
      case POPKT_Create:
	 print_DbvCreateOption(f, psOriginPartToKeep->uPrintOriginPartToKeep.psCreateOption);
				 
	 break;

      case POPKT_Delete:
	 print_DbvDeleteOption(f, psOriginPartToKeep->uPrintOriginPartToKeep.psDeleteOption);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvPrintOriginPartToKeep() */



void print_DbvPrintOriginPartToKeepType(FILE *f, DbvPrintOriginPartToKeepType *pePrintOriginPartToKeepType)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *pePrintOriginPartToKeepType == POPKT_Create)
         strcpy(temp, "POPKT_Create");

      if( *pePrintOriginPartToKeepType == POPKT_Delete)
         strcpy(temp, "POPKT_Delete");

         fprintf(f, "%s\n", temp);

   } /* End print_DbvPrintOriginPartToKeepType() */



void print_DbvCreateOption(FILE *f, DbvCreateOption *psCreateOption)
{
	if (psCreateOption == NULL) {
		fprintf(f, "psCreateOption: NULL\n");
		return;
	}

	fprintf(f, "psCreateOption:\n");


   /* eCreateOptionType */
   fprintf(f, "eCreateOptionType: ");
   print_DbvCreateOptionType(f, &psCreateOption->eCreateOptionType);


   /* uCreateOption */
   switch( psCreateOption->eCreateOptionType )
      {
      case COPT_ResultSetReference:
	 print_DbvResultSetReference(f, psCreateOption->uCreateOption.psResultSetReference);
				 
	 break;

      case COPT_AccessionReference:
	 print_DbvAccessionReference(f, psCreateOption->uCreateOption.psAccessionReference);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvCreateOption() */



void print_DbvCreateOptionType(FILE *f, DbvCreateOptionType *peCreateOptionType)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *peCreateOptionType == COPT_ResultSetReference)
         strcpy(temp, "COPT_ResultSetReference");

      if( *peCreateOptionType == COPT_AccessionReference)
         strcpy(temp, "COPT_AccessionReference");

         fprintf(f, "%s\n", temp);

   } /* End print_DbvCreateOptionType() */



void print_DbvResultSetReference(FILE *f, DbvResultSetReference *psResultSetReference)
{
	if (psResultSetReference == NULL) {
		fprintf(f, "psResultSetReference: NULL\n");
		return;
	}

	fprintf(f, "psResultSetReference:\n");


	/* c */
   	fprintf(f, "sResultSetId: ");
   	print_inter_string(f, &psResultSetReference->sResultSetId);
	
	/* c */
	fprintf(f,"ulResultSetStartPoint: ");
	fprintf(f,"%lu\n", psResultSetReference->ulResultSetStartPoint);

	/* c */
	fprintf(f,"ulNumberOfRecordsRequested: ");
	fprintf(f,"%lu\n", psResultSetReference->ulNumberOfRecordsRequested);

	/* o */
	printN_DbvRange(f, "ppsAdditionalRanges", psResultSetReference->ppsAdditionalRanges);

	/* o */
	print_DbvRecordComposition(f, psResultSetReference->psRecordComposition);

	/* c */
	print_DbvAddress(f, "sAddress", &psResultSetReference->sAddress);
	
}



void print_DbvAddress(FILE *f, char *name, DbvAddress *psAddress)
{
	if (psAddress == NULL) {
		fprintf(f, "%s: NULL\n", name);
		return;
	}

	fprintf(f, "%s:\n", name);


	/* c */
   	fprintf(f, "sPostalAddress: ");
   	print_inter_string(f, &psAddress->sPostalAddress);
	

	/* o */
   	fprintf(f, "psEmailAddress: ");
   	print_inter_string(f, psAddress->psEmailAddress);

}




void print_DbvAccessionReference(FILE *f, DbvAccessionReference *psAccessionReference)
{
	if (psAccessionReference == NULL) {
		fprintf(f, "psAccessionReference: NULL\n");
		return;
	}

	fprintf(f, "psAccessionReference:\n");


	/* c */
   	fprintf(f, "sReferenceId: ");
   	print_inter_string(f, &psAccessionReference->sReferenceId);
	
	/* o */
	print_DbvRecordComposition(f, psAccessionReference->psRecordComposition);
	/* c */
   	print_DbvAddress(f, "sAddress", &psAccessionReference->sAddress);
}





void printN_DbvRange(FILE *f, char *name, DbvRange **ppsAdditionalRanges)
   {

   if( ppsAdditionalRanges != NULL)
      {
      fprintf(f, "%s:\n", name);
      while( ppsAdditionalRanges && *ppsAdditionalRanges )
         {
         print_DbvRange(f, "psDbvRange", *ppsAdditionalRanges);
         ppsAdditionalRanges++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "%s: NULL\n", name);
      
      } /* End else */

     
   } /* End printN_DbvRange() */




void print_DbvRange(FILE *f, char *name, DbvRange *psAdditionalRanges)
{

   /* Write the title out */ 
   if (psAdditionalRanges == NULL)
      {
      fprintf(f, "%s: NULL\n", name);
      return;
      } /* End if */

   fprintf(f, "%s:\n", name);
   

	/* c */
	fprintf(f,"ulStartingPosition: ");
	fprintf(f,"%lu\n", psAdditionalRanges->ulStartingPosition);

	/* c */
	fprintf(f,"ulNumberOfRecords: ");
	fprintf(f,"%lu\n", psAdditionalRanges->ulNumberOfRecords);
}




void print_DbvRecordComposition(FILE *f, DbvRecordComposition *psRecordComposition)
{

   /* Write the title out */ 
   if (psRecordComposition == NULL)
      {
      fprintf(f, "psRecordComposition: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psRecordComposition:\n");
   
	switch( psRecordComposition->eRecordCompositionType) {
		case RCT_ElementSetNames:
			print_el_set_names(f, psRecordComposition->uRecordComposition.psElementSetNames);
			break;
		case RCT_CompSpec:
			print_pres_comp_spec(f, psRecordComposition->uRecordComposition.psCompSpec);
			break;
	}
	
}



int print_pres_comp_spec(FILE *f, DbvCompSpec *psCompSpec)
{
      	fprintf(f,"psCompSpec:\n");

      	fprintf(f,"fSelectAlternativeSyntax: ");
	print_bool(f, &psCompSpec->fSelectAlternativeSyntax);

	print_DbvSpecification(f, "psGeneric", psCompSpec->psGeneric);

      	fprintf(f,"ppsDbSpecific:\n");
	if (psCompSpec->ppsDbSpecific != NULL)
		print_pres_dbspecific(f, psCompSpec->ppsDbSpecific);
	else
		fprintf(f,"NULL\n");


      	fprintf(f,"ppcRecordSyntax:\n");
	if (psCompSpec->ppcRecordSyntax != NULL)
		print_pres_recsyntax(f, psCompSpec->ppcRecordSyntax);
	else
		fprintf(f,"NULL\n");
}




int print_pres_dbspecific(FILE *f, DbvDbSpecificComp **ppsDbSpecific)
{
	int index = 0;

	if (ppsDbSpecific != NULL){
		while(ppsDbSpecific[index] != NULL) {
       			fprintf(f,"sDatabaseName: ");
			print_inter_string(f, &ppsDbSpecific[index]->sDatabaseName);
			print_DbvSpecification(f, "sSpecification", &ppsDbSpecific[index]->sSpecification);
			index++;
			fprintf(f,"\n");
		}
		fprintf(f,"\n");
	} else
		fprintf(f,"NULL\n");
}



int print_pres_recsyntax(FILE *f, DbvObjectIdentifier *ppcRecordSyntax)
{
	int index = 0;

	if (ppcRecordSyntax != NULL) {
		while(ppcRecordSyntax[index] != NULL) {
       			fprintf(f,"\tpcRecordSyntax: ");
			fprintf(f,"%s\n", ppcRecordSyntax[index]);
			index++;
		}
		fprintf(f,"\n");
	} else
		fprintf(f,"NULL\n");
}





void print_DbvDeleteOption(FILE *f, DbvDeleteOption *psDeleteOption)
{
	if (psDeleteOption == NULL) {
		fprintf(f, "psDeleteOption: NULL\n");
		return;
	}

	fprintf(f, "psDeleteOption:\n");

	/* c */
   	fprintf(f, "sJobReference: ");
   	print_inter_string(f, &psDeleteOption->sJobReference);
	
}



void print_DbvPrintTaskPackage(FILE *f, DbvPrintTaskPackage *psPrintResponse)
{
	if (psPrintResponse == NULL) {
		fprintf(f,"psPrintResponse: NULL\n");
		return;
	}

	fprintf(f,"psPrintResponse:\n");

	/* o */
	print_DbvPrintOriginPartToKeep(f, psPrintResponse->psOriginPartToKeep);

	/* c */
	print_DbvPrintTargetPartToKeep(f, "sTargetPart", &psPrintResponse->sTargetPart);
}



void print_DbvPrintTargetPartToKeep(FILE *f, char *name, DbvPrintTargetPartToKeep *psTargetPart)
{
	if (psTargetPart == NULL) {
		fprintf(f, "%s: NULL\n", name);
		return;
	}

	fprintf(f, "%s:\n", name);

	/* c */
   	fprintf(f, "sJobReference: ");
   	print_inter_string(f, &psTargetPart->sJobReference);
	
	
}


void print_DbvAlertExtendedService_external(FILE *f, DbvASN1External *external_ptr)
{
	print_DbvAlertExtendedService(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psAlertExtendedService);
}



void print_DbvAlertExtendedService(FILE *f, DbvAlertExtendedService *psAlertExtendedService)
{

   /* Write the title out */ 
   if (psAlertExtendedService == NULL)
      {
      fprintf(f, "psAlertExtendedService: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psAlertExtendedService:\n");
   

   /* eAlertReqRsp */
   fprintf(f, "eAlertReqRsp: ");
   print_DbvAlertReqOrRsp(f, &psAlertExtendedService->eAlertReqRsp);


   /* uAlertReqOrRsp */
   switch( psAlertExtendedService->eAlertReqRsp )
      {
      case AROR_Request:
	 print_DbvAlertRequestPackage(f, psAlertExtendedService->uAlertReqOrRsp.psAlertRequest);
	 break;

      case AROR_Response:
	print_DbvAlertTaskPackage(f, psAlertExtendedService->uAlertReqOrRsp.psAlertResponse);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvAlertExtendedService() */



void print_DbvAlertReqOrRsp(FILE *f, DbvAlertReqOrRsp *peAlertReqRsp)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *peAlertReqRsp == AROR_Request)
         strcpy(temp, "AROR_Request");

      if( *peAlertReqRsp == AROR_Response)
         strcpy(temp, "AROR_Response");

         fprintf(f, "%s\n", temp);

   } /* End print_DbvAlertReqOrRsp() */



void print_DbvAlertRequestPackage(FILE *f, DbvAlertRequestPackage *psAlertRequest)
{
	if (psAlertRequest == NULL) {
		fprintf(f, "psAlertRequest: NULL\n");
		return;
	}

	fprintf(f, "psAlertRequest:\n");

	/* o */
	print_DbvAlertOriginPartToKeep(f, psAlertRequest->psOriginPartToKeep);

}



void print_DbvAlertOriginPartToKeep(FILE *f, DbvAlertOriginPartToKeep *psOriginPartToKeep)
{
	if (psOriginPartToKeep == NULL) {
		fprintf(f, "psOriginPartToKeep: NULL\n");
		return;
	}

	fprintf(f, "psOriginPartToKeep:\n");

	/* c */
	print_DbvInternationalString(f, "sAlertName", &psOriginPartToKeep->sAlertName);

	/* o */
	print_DbvAddress(f, "psAddress", psOriginPartToKeep->psAddress);
}



void print_DbvAlertTaskPackage(FILE *f, DbvAlertTaskPackage *psAlertResponse)
{
	if (psAlertResponse == NULL) {
		fprintf(f, "psAlertResponse: NULL\n");
		return;
	}

	fprintf(f, "psAlertResponse:\n");

	 /* o */
	print_DbvAlertOriginPartToKeep(f, psAlertResponse->psOriginPartToKeep);
	
}


void print_DbvCOrder_external(FILE *f, DbvASN1External *external_ptr)
{
	print_DbvCOrder(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psCOrder);
}



void print_DbvCOrder(FILE *f, DbvCOrder *psCOrder)
{

   /* Write the title out */ 
   if (psCOrder == NULL)
      {
      fprintf(f, "psCOrder: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psCOrder:\n");
   

   /* eCOrderType */
   fprintf(f, "eCOrderType: ");
   print_DbvCOrderType(f, &psCOrder->eCOrderType);


   /* uCOrder */
   switch( psCOrder->eCOrderType )
      {
      case COT_OrderRequest:
	 print_DbvOrderRequest(f, psCOrder->uCOrder.psOrderRequest);
	 break;

      case COT_OrderResponse:
	printN_DbvInternationalString(f, "ppsOrderResponse", psCOrder->uCOrder.ppsOrderResponse);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvCOrder() */



void print_DbvCOrderType(FILE *f, DbvCOrderType *peCOrderType)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *peCOrderType == COT_OrderRequest)
         strcpy(temp, "COT_OrderRequest");

      if( *peCOrderType == COT_OrderResponse)
         strcpy(temp, "COT_OrderResponse");

         fprintf(f, "%s\n", temp);

   } /* End print_DbvCOrderType() */



void print_DbvOrderRequest(FILE *f, DbvOrderRequest *psOrderRequest)
{

   /* Write the title out */ 
   if (psOrderRequest == NULL)
      {
      fprintf(f, "psOrderRequest: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psOrderRequest:\n");
   

   /* eOrderRequestType */
   fprintf(f, "eOrderRequestType: ");
   print_DbvOrderRequestType(f, &psOrderRequest->eOrderRequestType);


   /* uOrderRequest */
   switch( psOrderRequest->eOrderRequestType )
      {
      case ORT_NormalOrder:
	 print_DbvNormalOrder(f, psOrderRequest->uOrderRequest.psNormalOrder);
	 break;

      case ORT_OrderRefs:
	printN_DbvInternationalString(f, "ppsOrderRefs", psOrderRequest->uOrderRequest.ppsOrderRefs);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvOrderRequest() */



void print_DbvOrderRequestType(FILE *f, DbvOrderRequestType *peOrderRequestType)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *peOrderRequestType == ORT_NormalOrder)
         strcpy(temp, "ORT_NormalOrder");

      if( *peOrderRequestType == ORT_OrderRefs)
         strcpy(temp, "ORT_OrderRefs");

         fprintf(f, "%s\n", temp);

   } /* End print_DbvOrderRequestType() */



void print_DbvNormalOrder(FILE *f, DbvNormalOrder *psNormalOrder)
{

   /* Write the title out */ 
   if (psNormalOrder == NULL)
      {
      fprintf(f, "psNormalOrder: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psNormalOrder:\n");
   


	/* c */
	printN_DbvRange(f, "ppsOrderRanges", psNormalOrder->ppsOrderRanges);


	/* c */
	fprintf(f,"ulQuantity: ");
	fprintf(f,"%lu\n", psNormalOrder->ulQuantity);

}




void print_DbvCharSetAndLanguage_external(FILE *f, DbvASN1External *external_ptr)
{
        fprintf(f,"\tpsCharSetAndLanguage:\n");

	/* If not NULL */
	if (external_ptr->uExternalValue.psSingleASN1Type->uASN1.psExplainRecord) 
		print_DbvCharSetAndLanguage(f, external_ptr->uExternalValue.psSingleASN1Type->uASN1.psCharSetAndLanguage);
	
}



void print_DbvCharSetAndLanguage(FILE *f, DbvCharSetAndLanguage *psCharSetAndLanguage)
{

   /* Write the title out */ 
   if (psCharSetAndLanguage == NULL)
      {
      fprintf(f, "psCharSetAndLanguage: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psCharSetAndLanguage:\n");
   

   /* eCharSetAndLanguageType */
   fprintf(f, "eCharSetAndLanguageType: ");
   print_DbvCharSetAndLanguageType(f, &psCharSetAndLanguage->eCharSetAndLanguageType);


   /* uCharSetAndLanguage */
   switch( psCharSetAndLanguage->eCharSetAndLanguageType )
      {
      case CSALT_Proposal:
	 print_DbvOriginProposal(f, psCharSetAndLanguage->uCharSetAndLanguage.psProposal);
	 break;

      case CSALT_Response:
	print_DbvTargetResponse(f, psCharSetAndLanguage->uCharSetAndLanguage.psResponse);
	 break;

      default:
	 break;
      } /* End switch */

   } /* End print_DbvCharSetAndLanguage() */



void print_DbvCharSetAndLanguageType(FILE *f, DbvCharSetAndLanguageType *peCharSetAndLanguageType)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *peCharSetAndLanguageType == CSALT_Proposal)
         strcpy(temp, "CSALT_Proposal");

      if( *peCharSetAndLanguageType == CSALT_Response)
         strcpy(temp, "CSALT_Response");

         fprintf(f, "%s\n", temp);

   } /* End print_DbvCharSetAndLanguageType() */



void print_DbvOriginProposal(FILE *f, DbvOriginProposal *psProposal)
{
   /* Write the title out */ 
   if (psProposal == NULL)
      {
      fprintf(f, "psProposal: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psProposal:\n");
   

	/* o */
	printN_DbvProposedCharSet(f, psProposal->ppsProposedCharSets);

	/* o */
	printN_DbvLanguageCode(f, psProposal->ppsProposedLanguages);
}



void printN_DbvProposedCharSet(FILE *f, DbvProposedCharSet **ppsProposedCharSets)
   {

   if( ppsProposedCharSets != NULL)
      {
      fprintf(f, "ppsProposedCharSets:\n");
      while( ppsProposedCharSets && *ppsProposedCharSets )
         {
         print_DbvProposedCharSet(f, *ppsProposedCharSets);
         ppsProposedCharSets++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "ppsProposedCharSets: NULL\n");
      
      } /* End else */
   } /* End printN_DbvProposedCharSet() */



void print_DbvProposedCharSet(FILE *f, DbvProposedCharSet *psProposedCharSet)
{
   /* Write the title out */ 
   if (psProposedCharSet == NULL)
      {
      fprintf(f, "psProposedCharSet: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psProposedCharSet:\n");
   
   /* eProposedCharSetType */
   fprintf(f, "eProposedCharSetType: ");
   print_DbvProposedCharSetType(f, &psProposedCharSet->eProposedCharSetType);

   /* uProposedCharSet */
   switch( psProposedCharSet->eProposedCharSetType )
      {
      case PRCST_Iso2022:
	 print_DbvIso2022(f, psProposedCharSet->uProposedCharSet.psIso2022);
	 break;

      case PRCST_Iso10646:
	print_DbvIso10646(f, psProposedCharSet->uProposedCharSet.psIso10646);
	 break;

      case PRCST_Private:
	print_DbvPrivateCharacterSet(f, psProposedCharSet->uProposedCharSet.psPrivate);
	 break;
      default:
	 break;
      } /* End switch */
   } /* End print_DbvProposedCharSet() */



void print_DbvProposedCharSetType(FILE *f, DbvProposedCharSetType *peProposedCharSetType)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *peProposedCharSetType == PRCST_Iso2022)
         strcpy(temp, "PRCST_Iso2022");

      if( *peProposedCharSetType == PRCST_Iso10646)
         strcpy(temp, "PRCST_Iso10646");

      if( *peProposedCharSetType == PRCST_Private)
         strcpy(temp, "PRCST_Private");

         fprintf(f, "%s\n", temp);

   } /* End print_DbvProposedCharSetType() */



void print_DbvIso2022(FILE *f, DbvIso2022 *psIso2022)
{
   /* Write the title out */ 
   if (psIso2022 == NULL)
      {
      fprintf(f, "psIso2022: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psIso2022:\n");
   
   /* eIso2022Type */
   fprintf(f, "eIso2022Type: ");
   print_DbvIso2022Type(f, &psIso2022->eIso2022Type);

   /* uIso2022Type */
   switch( psIso2022->eIso2022Type )
      {
      case I2022T_OriginProposal:
	 print_DbvIso2022Proposal(f, psIso2022->uIso2022Type.psOriginProposal);
	 break;

      case I2022T_TargetResponse:
	print_DbvIso2022Response(f, psIso2022->uIso2022Type.psTargetResponse);
	 break;
      default:
	 break;
      } /* End switch */
   } /* End print_DbvIso2022() */



void print_DbvIso2022Type(FILE *f, DbvIso2022Type *peIso2022Type)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *peIso2022Type == I2022T_OriginProposal)
         strcpy(temp, "I2022T_OriginProposal");

      if( *peIso2022Type == I2022T_TargetResponse)
         strcpy(temp, "I2022T_TargetResponse");

         fprintf(f, "%s\n", temp);

   } /* End print_DbvIso2022Type() */



void print_DbvIso2022Proposal(FILE *f, DbvIso2022Proposal *psOriginProposal)
{
   /* Write the title out */ 
   if (psOriginProposal == NULL)
      {
      fprintf(f, "psOriginProposal: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psOriginProposal:\n");
   
	/* o */
	print_DbvEnvironment(f, "psProposedEnvironment", psOriginProposal->psProposedEnvironment);

	/* c */
	printN_Ulong(f, "ppulProposedSets", psOriginProposal->ppulProposedSets);

	/* c */
	printN_DbvInitialSet(f, psOriginProposal->ppsProposedInitialSets);

	/* c */
	print_DbvLeftAndRight(f, "psProposedLeftAndRight", psOriginProposal->psProposedLeftAndRight);
}



void print_DbvEnvironment(FILE *f, char *name, DbvEnvironment *psProposedEnvironment)
{
   if (psProposedEnvironment == NULL)
      {
      fprintf(f, "%s: NULL\n", name);
      return;
      } /* End if */

   fprintf(f, "%s:\n", name);

   /* eEnvironmentType */
   fprintf(f, "eEnvironmentType: ");
   print_DbvEnvironmentType(f, &psProposedEnvironment->eEnvironmentType);

}
   


void print_DbvEnvironmentType(FILE *f, DbvEnvironmentType *peEnvironmentType)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *peEnvironmentType == ENT_SevenBit)
         strcpy(temp, "ENT_SevenBit");

      if( *peEnvironmentType == ENT_EightBit)
         strcpy(temp, "ENT_EightBit");

         fprintf(f, "%s\n", temp);

   } /* End print_DbvEnvironmentType() */



void print_DbvLeftAndRight(FILE *f, char *name, DbvLeftAndRight *psProposedLeftAndRight)
{

   if (psProposedLeftAndRight == NULL)
      {
      fprintf(f, "%s: NULL\n", name);
      return;
      } /* End if */

   fprintf(f, "%s:\n", name);

   /* eEnvironmentType */
	/* c */
	fprintf(f, "ulGLeft: ");
	print_Ulong(f, &psProposedLeftAndRight->ulGLeft);

	/* c */
	fprintf(f, "ulGRight: ");
	print_Ulong(f, &psProposedLeftAndRight->ulGRight);
}



void printN_DbvInitialSet(FILE *f, DbvInitialSet **ppsProposedInitialSets)
{

   if( ppsProposedInitialSets != NULL)
      {
      fprintf(f, "ppsProposedInitialSets:\n");

      while( ppsProposedInitialSets && *ppsProposedInitialSets )
         {
         print_DbvInitialSet(f, "psProposedInitialSets", *ppsProposedInitialSets);
         ppsProposedInitialSets++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "ppsProposedInitialSets: NULL\n");
      
      } /* End else */
   } /* End printN_DbvInitialSet() */



void print_DbvInitialSet(FILE *f, char *name, DbvInitialSet *psProposedInitialSets)
{

   if (psProposedInitialSets == NULL)
      {
      fprintf(f, "%s: NULL\n", name);
      return;
      } /* End if */

   fprintf(f, "%s:\n", name);

	/* c */
	fprintf(f, "ulG0: ");
	print_Ulong(f, &psProposedInitialSets->ulG0);
	
	/* c */
	fprintf(f, "ulG1: ");
	print_Ulong(f, &psProposedInitialSets->ulG1);

	/* c */
	fprintf(f, "ulG2: ");
	print_Ulong(f, &psProposedInitialSets->ulG2);

	/* c */
	fprintf(f, "ulG3: ");
	print_Ulong(f, &psProposedInitialSets->ulG3);

	/* c */
	fprintf(f, "ulC0: ");
	print_Ulong(f, &psProposedInitialSets->ulC0);

	/* c */	
	fprintf(f, "ulC1: ");
	print_Ulong(f, &psProposedInitialSets->ulC1);
}



void print_DbvIso2022Response(FILE *f, DbvIso2022Response *psTargetResponse)
{
   /* Write the title out */ 
   if (psTargetResponse == NULL)
      {
      fprintf(f, "psTargetResponse: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psTargetResponse:\n");
   
	/* o */
	print_DbvEnvironment(f, "psSelectedEnvironment", psTargetResponse->psSelectedEnvironment);

	/* c */
	printN_Ulong(f, "ppulSelectedSets", psTargetResponse->ppulSelectedSets);

	/* c */
	print_DbvInitialSet(f, "psSelectedInitialSet", psTargetResponse->psSelectedInitialSet);

	/* c */
	print_DbvLeftAndRight(f, "psSelectedLeftAndRight", psTargetResponse->psSelectedLeftAndRight);
}



void print_DbvIso10646(FILE *f, DbvIso10646 *psIso10646)
{

   /* Write the title out */ 
   if (psIso10646 == NULL)
      {
      fprintf(f, "psIso10646: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psIso10646:\n");
   
	/* c */
	print_DbvObjectIdentifier(f, "pcCollections", psIso10646->pcCollections);
	
	/* c */
	print_DbvObjectIdentifier(f, "pcEncodingLevel", psIso10646->pcEncodingLevel);
}



void print_DbvPrivateCharacterSet(FILE *f, DbvPrivateCharacterSet *psPrivate)
{
   /* Write the title out */ 
   if (psPrivate == NULL)
      {
      fprintf(f, "psPrivate: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psPrivate:\n");
   
   /* ePrivateCharacterSetType */
   fprintf(f, "ePrivateCharacterSetType: ");
   print_DbvPrivateCharacterSetType(f, &psPrivate->ePrivateCharacterSetType);

   /* uPrivateCharacterSet */
   switch( psPrivate->ePrivateCharacterSetType )
      {
      case PCST_ViaOid:
	 printN_DbvObjectIdentifier(f, "ppcViaOid", psPrivate->uPrivateCharacterSet.ppcViaOid);
	 break;

      case PCST_ExternallySpecified:
	print_DbvASN1External(f, psPrivate->uPrivateCharacterSet.psExternallySpecified);
	 break;
      default:
	 break;
      } /* End switch */
   } /* End print_DbvPrivateCharacterSet() */



void print_DbvPrivateCharacterSetType(FILE *f, DbvPrivateCharacterSetType *pePrivateCharacterSetType)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *pePrivateCharacterSetType == PCST_ViaOid)
         strcpy(temp, "PCST_ViaOid");

      if( *pePrivateCharacterSetType == PCST_ExternallySpecified)
         strcpy(temp, "PCST_ExternallySpecified");

      if( *pePrivateCharacterSetType == PCST_PreviouslyAgreedUpon)
         strcpy(temp, "PCST_PreviouslyAgreedUpon");


         fprintf(f, "%s\n", temp);

   } /* End print_DbvPrivateCharacterSetType() */




void printN_DbvLanguageCode(FILE *f, DbvLanguageCode **ppsProposedLangauages)
   {

   if( ppsProposedLangauages != NULL)
      {
      fprintf(f, "ppsProposedLanguages:\n");
      while( ppsProposedLangauages && *ppsProposedLangauages )
         {
         print_DbvLanguageCode(f, "psProposedLanguages", *ppsProposedLangauages);
         ppsProposedLangauages++;
         } /* End while */
      } /* End if */
   else
      {
      fprintf(f, "ppsProposedLanguages: NULL\n");
      
      } /* End else */
   } /* End printN_DbvLanguageCode() */



void print_DbvTargetResponse(FILE *f, DbvTargetResponse *psResponse)
{
   if (psResponse == NULL)
      {
      fprintf(f, "psResponse: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psResponse:\n");

	/* o */
	print_DbvSelectedCharSet(f, psResponse->psSelectedCharSets);

	/* o */
	fprintf(f, "psSelectedLanguage: ");
	print_DbvGeneralString(f, psResponse->psSelectedLanguage);
}



void print_DbvSelectedCharSet(FILE *f, DbvSelectedCharSet *psSelectedCharSets)
{

   /* Write the title out */ 
   if (psSelectedCharSets == NULL)
      {
      fprintf(f, "psSelectedCharSets: NULL\n");
      return;
      } /* End if */

   fprintf(f, "psSelectedCharSets:\n");
   
   /* eSelectedCharSetType */
   fprintf(f, "eSelectedCharSetType: ");
   print_DbvSelectedCharSetType(f, &psSelectedCharSets->eSelectedCharSetType);

   /* uSelectedCharSet */
   switch( psSelectedCharSets->eSelectedCharSetType )
      {
      case SCST_Iso2022:
	 print_DbvIso2022(f, psSelectedCharSets->uSelectedCharSet.psIso2022);
	 break;

      case SCST_Iso10646:
	print_DbvIso10646(f, psSelectedCharSets->uSelectedCharSet.psIso10646);
	 break;

      case SCST_Private:
	print_DbvPrivateCharacterSet(f, psSelectedCharSets->uSelectedCharSet.psPrivate);
	 break;

      default:
	 break;
      } /* End switch */
   } /* End print_DbvPrivateCharacterSet() */



void print_DbvSelectedCharSetType(FILE *f, DbvSelectedCharSetType *peSelectedCharSetType)
   {

   char temp[ STRING_LEN ];
      temp[ 0 ] = '\0';

      if( *peSelectedCharSetType == SCST_Iso2022)
         strcpy(temp, "SCST_Iso2022");

      if( *peSelectedCharSetType == SCST_Iso10646)
         strcpy(temp, "SCST_Iso10646");

      if( *peSelectedCharSetType == SCST_Private)
         strcpy(temp, "SCST_Private");

      if( *peSelectedCharSetType == SCST_None)
         strcpy(temp, "SCST_None");


         fprintf(f, "%s\n", temp);

   } /* End print_DbvSelectedCharSetType() */



